"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/extpath","vs/base/common/uri","vs/base/common/errors","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/process","vs/base/common/event","vs/base/common/cancellation","vs/base/common/strings","vs/base/common/resources","vs/base/common/async","fs","os","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/map","vs/base/common/normalization","vs/base/common/types","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/server/node/server.cli","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/network","vs/base/node/pfs","vs/base/node/terminalEncoding","child_process","vs/nls!vs/platform/environment/node/argv","vs/platform/environment/node/argv","vs/platform/environment/node/stdin","vs/platform/environment/node/wait","util","minimist","vs/server/node/server.cli","url","http"],ce=function(ie){for(var e=[],v=0,R=ie.length;v<R;v++)e[v]=ae[ie[v]];return e};define(ae[6],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(d){setTimeout(()=>{throw d.stack?a.isErrorNoTelemetry(d)?new a(d.message+`

`+d.stack):new Error(d.message+`

`+d.stack):d},0)}}addListener(d){return this.listeners.push(d),()=>{this._removeListener(d)}}emit(d){this.listeners.forEach(u=>{u(d)})}_removeListener(d){this.listeners.splice(this.listeners.indexOf(d),1)}setUnexpectedErrorHandler(d){this.unexpectedErrorHandler=d}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(d){this.unexpectedErrorHandler(d),this.emit(d)}onUnexpectedExternalError(d){this.unexpectedErrorHandler(d)}}e.ErrorHandler=v,e.errorHandler=new v;function R(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=R;function w(f){E(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=w;function N(f){E(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=N;function j(f){if(f instanceof Error){const{name:d,message:u}=f,l=f.stacktrace||f.stack;return{$isError:!0,name:d,message:u,stack:l,noTelemetry:a.isErrorNoTelemetry(f)}}return f}e.transformErrorForSerialization=j;const k="Canceled";function E(f){return f instanceof P?!0:f instanceof Error&&f.name===k&&f.message===k}e.isCancellationError=E;class P extends Error{constructor(){super(k),this.name=this.message}}e.CancellationError=P;function F(){const f=new Error(k);return f.name=f.message,f}e.canceled=F;function z(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=z;function Y(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=Y;function S(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function h(f){const d=new Error(`${f} has been disposed`);return d.name="DISPOSED",d}e.disposed=h;function s(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=s;class g extends Error{constructor(d){super("NotImplemented"),d&&(this.message=d)}}e.NotImplementedError=g;class b extends Error{constructor(d){super("NotSupported"),d&&(this.message=d)}}e.NotSupportedError=b;class O extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=O;class a extends Error{constructor(d){super(d),this.name="CodeExpectedError"}static fromError(d){if(d instanceof a)return d;const u=new a;return u.message=d.message,u.stack=d.stack,u}static isErrorNoTelemetry(d){return d.name==="CodeExpectedError"}}e.ErrorNoTelemetry=a;class o extends Error{constructor(d){super(d||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype);debugger}}e.BugIndicatingError=o}),define(ae[7],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const w=this;let N=!1,j;return function(){return N||(N=!0,j=R.apply(w,arguments)),j}}e.once=v}),define(ae[17],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function w(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}R.is=w;const N=Object.freeze([]);function j(){return N}R.empty=j;function*k(o){yield o}R.single=k;function E(o){return w(o)?o:k(o)}R.wrap=E;function P(o){return o||N}R.from=P;function F(o){return!o||o[Symbol.iterator]().next().done===!0}R.isEmpty=F;function z(o){return o[Symbol.iterator]().next().value}R.first=z;function Y(o,f){for(const d of o)if(f(d))return!0;return!1}R.some=Y;function S(o,f){for(const d of o)if(f(d))return d}R.find=S;function*h(o,f){for(const d of o)f(d)&&(yield d)}R.filter=h;function*s(o,f){let d=0;for(const u of o)yield f(u,d++)}R.map=s;function*g(...o){for(const f of o)for(const d of f)yield d}R.concat=g;function b(o,f,d){let u=d;for(const l of o)u=f(u,l);return u}R.reduce=b;function*O(o,f,d=o.length){for(f<0&&(f+=o.length),d<0?d+=o.length:d>o.length&&(d=o.length);f<d;f++)yield o[f]}R.slice=O;function a(o,f=Number.POSITIVE_INFINITY){const d=[];if(f===0)return[d,o];const u=o[Symbol.iterator]();for(let l=0;l<f;l++){const c=u.next();if(c.done)return[d,R.empty()];d.push(c.value)}return[d,{[Symbol.iterator](){return u}}]}R.consume=a})(v=e.Iterable||(e.Iterable={}))}),define(ae[18],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new v(()=>w(this.getValue()))}}e.Lazy=v}),define(ae[8],ce([0,1,7,17]),function(ie,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const w=!1;let N=null;function j(i){N=i}if(e.setDisposableTracker=j,w){const i="__is_disposable_tracked__";j(new class{trackDisposable(t){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{t[i]||console.log(y)},3e3)}setParent(t,y){if(t&&t!==O.None)try{t[i]=!0}catch{}}markAsDisposed(t){if(t&&t!==O.None)try{t[i]=!0}catch{}}markAsSingleton(t){}})}function k(i){return N?.trackDisposable(i),i}function E(i){N?.markAsDisposed(i)}function P(i,t){N?.setParent(i,t)}function F(i,t){if(!!N)for(const y of i)N.setParent(y,t)}function z(i){return N?.markAsSingleton(i),i}e.markAsSingleton=z;function Y(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=Y;function S(i){if(R.Iterable.is(i)){const t=[];for(const y of i)if(y)try{y.dispose()}catch(p){t.push(p)}if(t.length===1)throw t[0];if(t.length>1)throw new AggregateError(t,"Encountered errors while disposing of store");return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=S;function h(i){for(const t of i)Y(t)&&t.dispose();return[]}e.disposeIfDisposable=h;function s(...i){const t=g(()=>S(i));return F(i,t),t}e.combinedDisposable=s;function g(i){const t=k({dispose:(0,v.once)(()=>{E(t),i()})});return t}e.toDisposable=g;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{S(this._toDispose)}finally{this._toDispose.clear()}}add(t){if(!t)return t;if(t===this)throw new Error("Cannot register a disposable on itself!");return P(t,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(t),t}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class O{constructor(){this._store=new b,k(this),P(this._store,this)}dispose(){E(this),this._store.dispose()}_register(t){if(t===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(t)}}e.Disposable=O,O.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(t){this._isDisposed||t===this._value||(this._value?.dispose(),t&&P(t,this),this._value=t)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const t=this._value;return this._value=void 0,t&&P(t,null),t}}e.MutableDisposable=a;class o{constructor(t){this._disposable=t,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(t){let y=t;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,E(this))},this}}e.SafeDisposable=f;class d{constructor(){this.references=new Map}acquire(t,...y){let p=this.references.get(t);p||(p={counter:0,object:this.createReferencedObject(t,...y)},this.references.set(t,p));const{object:I}=p,x=(0,v.once)(()=>{--p.counter===0&&(this.destroyReferencedObject(t,p.object),this.references.delete(t))});return p.counter++,{object:I,dispose:x}}}e.ReferenceCollection=d;class u{constructor(t){this.referenceCollection=t}async acquire(t,...y){const p=this.referenceCollection.acquire(t,...y);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(I){throw p.dispose(),I}}}e.AsyncReferenceCollection=u;class l{constructor(t){this.object=t}dispose(){}}e.ImmortalReference=l;function c(i){const t=new b;try{i(t)}finally{t.dispose()}}e.disposeOnReturn=c;class n{constructor(){this._store=new Map,this._isDisposed=!1,k(this)}dispose(){E(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{S(this._store.values())}finally{this._store.clear()}}has(t){return this._store.has(t)}get(t){return this._store.get(t)}set(t,y,p=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||this._store.get(t)?.dispose(),this._store.set(t,y)}deleteAndDispose(t){this._store.get(t)?.dispose(),this._store.delete(t)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=n}),define(ae[19],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(N){this.element=N,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let N=this._first;for(;N!==v.Undefined;){const j=N.next;N.prev=v.Undefined,N.next=v.Undefined,N=j}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(N){return this._insert(N,!1)}push(N){return this._insert(N,!0)}_insert(N,j){const k=new v(N);if(this._first===v.Undefined)this._first=k,this._last=k;else if(j){const P=this._last;this._last=k,k.prev=P,P.next=k}else{const P=this._first;this._first=k,k.next=P,P.prev=k}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(k))}}shift(){if(this._first!==v.Undefined){const N=this._first.element;return this._remove(this._first),N}}pop(){if(this._last!==v.Undefined){const N=this._last.element;return this._remove(this._last),N}}_remove(N){if(N.prev!==v.Undefined&&N.next!==v.Undefined){const j=N.prev;j.next=N.next,N.next.prev=j}else N.prev===v.Undefined&&N.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):N.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):N.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let N=this._first;for(;N!==v.Undefined;)yield N.element,N=N.next}}e.LinkedList=R}),define(ae[20],ce([0,1]),function(ie,e){"use strict";var v,R,w;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function N(h,s,g){let b=h.get(s);return b===void 0&&(b=g,h.set(s,b)),b}e.getOrSet=N;function j(h){const s=[];return h.forEach((g,b)=>{s.push(`${b} => ${g}`)}),`Map(${h.size}) {${s.join(", ")}}`}e.mapToString=j;function k(h){const s=[];return h.forEach(g=>{s.push(g)}),`Set(${h.size}) {${s.join(", ")}}`}e.setToString=k;class E{constructor(s,g){this.uri=s,this.value=g}}class P{constructor(s,g){this[v]="ResourceMap",s instanceof P?(this.map=new Map(s.map),this.toKey=g??P.defaultToKey):(this.map=new Map,this.toKey=s??P.defaultToKey)}set(s,g){return this.map.set(this.toKey(s),new E(s,g)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,g){typeof g<"u"&&(s=s.bind(g));for(const[b,O]of this.map)s(O.value,O.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}e.ResourceMap=P,P.defaultToKey=h=>h.toString();class F{constructor(s,g){this[R]="ResourceSet",!s||typeof s=="function"?this._map=new P(s):(this._map=new P(g),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,g){this._map.forEach((b,O)=>s.call(g,O,O,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=F;var z;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(z=e.Touch||(e.Touch={}));class Y{constructor(){this[w]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,g=0){const b=this._map.get(s);if(!!b)return g!==0&&this.touch(b,g),b.value}set(s,g,b=0){let O=this._map.get(s);if(O)O.value=g,b!==0&&this.touch(O,b);else{switch(O={key:s,value:g,next:void 0,previous:void 0},b){case 0:this.addItemLast(O);break;case 1:this.addItemFirst(O);break;case 2:this.addItemLast(O);break;default:this.addItemLast(O);break}this._map.set(s,O),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const g=this._map.get(s);if(!!g)return this._map.delete(s),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,g){const b=this._state;let O=this._head;for(;O;){if(g?s.bind(g)(O.value,O.key,this):s(O.value,O.key,this),this._state!==b)throw new Error("LinkedMap got modified during iteration.");O=O.next}}keys(){const s=this,g=this._state;let b=this._head;const O={[Symbol.iterator](){return O},next(){if(s._state!==g)throw new Error("LinkedMap got modified during iteration.");if(b){const a={value:b.key,done:!1};return b=b.next,a}else return{value:void 0,done:!0}}};return O}values(){const s=this,g=this._state;let b=this._head;const O={[Symbol.iterator](){return O},next(){if(s._state!==g)throw new Error("LinkedMap got modified during iteration.");if(b){const a={value:b.value,done:!1};return b=b.next,a}else return{value:void 0,done:!0}}};return O}entries(){const s=this,g=this._state;let b=this._head;const O={[Symbol.iterator](){return O},next(){if(s._state!==g)throw new Error("LinkedMap got modified during iteration.");if(b){const a={value:[b.key,b.value],done:!1};return b=b.next,a}else return{value:void 0,done:!0}}};return O}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let g=this._head,b=this.size;for(;g&&b>s;)this._map.delete(g.key),g=g.next,b--;this._head=g,this._size=b,g&&(g.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const g=s.next,b=s.previous;if(!g||!b)throw new Error("Invalid list");g.previous=b,b.next=g}s.next=void 0,s.previous=void 0,this._state++}touch(s,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(s===this._head)return;const b=s.next,O=s.previous;s===this._tail?(O.next=void 0,this._tail=O):(b.previous=O,O.next=b),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(g===2){if(s===this._tail)return;const b=s.next,O=s.previous;s===this._head?(b.previous=void 0,this._head=b):(b.previous=O,O.next=b),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((g,b)=>{s.push([b,g])}),s}fromJSON(s){this.clear();for(const[g,b]of s)this.set(g,b)}}e.LinkedMap=Y;class S extends Y{constructor(s,g=1){super(),this._limit=s,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,g=2){return super.get(s,g)}peek(s){return super.get(s,0)}set(s,g){return super.set(s,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=S}),define(ae[21],ce([0,1,20]),function(ie,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new v.LRUCache(1e4);function w(P){return E(P,"NFC",R)}e.normalizeNFC=w;const N=new v.LRUCache(1e4);function j(P){return E(P,"NFD",N)}e.normalizeNFD=j;const k=/[^\u0000-\u0080]/;function E(P,F,z){if(!P)return P;const Y=z.get(P);if(Y)return Y;let S;return k.test(P)?S=P.normalize(F):S=P,z.set(P,S),S}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(F){return j(F).replace(P,"")}}()}),define(ae[22],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function v(u){return typeof u=="string"}e.isString=v;function R(u){return Array.isArray(u)&&u.every(l=>v(l))}e.isStringArray=R;function w(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=w;function N(u){const l=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof l}e.isTypedArray=N;function j(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=j;function k(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=k;function E(u){return u===!0||u===!1}e.isBoolean=E;function P(u){return typeof u>"u"}e.isUndefined=P;function F(u){return!z(u)}e.isDefined=F;function z(u){return P(u)||u===null}e.isUndefinedOrNull=z;function Y(u,l){if(!u)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=Y;function S(u){if(z(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=S;function h(...u){const l=[];for(let c=0;c<u.length;c++){const n=u[c];if(z(n))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);l.push(n)}return l}e.assertAllDefined=h;const s=Object.prototype.hasOwnProperty;function g(u){if(!w(u))return!1;for(const l in u)if(s.call(u,l))return!1;return!0}e.isEmptyObject=g;function b(u){return typeof u=="function"}e.isFunction=b;function O(...u){return u.length>0&&u.every(b)}e.areFunctions=O;function a(u,l){const c=Math.min(u.length,l.length);for(let n=0;n<c;n++)o(u[n],l[n])}e.validateConstraints=a;function o(u,l){if(v(l)){if(typeof u!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(b(l)){try{if(u instanceof l)return}catch{}if(!z(u)&&u.constructor===l||l.length===1&&l.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function f(u){return u===null?void 0:u}e.withNullAsUndefined=f;function d(u){return typeof u>"u"?null:u}e.withUndefinedAsNull=d}),define(ae[23],ce([24,25]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(ae[2],ce([0,1,23]),function(ie,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let R=!1,w=!1,N=!1,j=!1,k=!1,E=!1,P=!1,F=!1,z=!1,Y=!1,S,h=e.LANGUAGE_DEFAULT,s,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?b=e.globals.vscode.process:typeof process<"u"&&(b=process);const O=typeof b?.versions?.electron=="string",a=O&&b?.type==="renderer";if(typeof navigator=="object"&&!a)g=navigator.userAgent,R=g.indexOf("Windows")>=0,w=g.indexOf("Macintosh")>=0,F=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,N=g.indexOf("Linux")>=0,Y=g?.indexOf("Mobi")>=0,E=!0,S=v.getConfiguredDefaultLocale(v.localize(0,null))||e.LANGUAGE_DEFAULT,h=S;else if(typeof b=="object"){R=b.platform==="win32",w=b.platform==="darwin",N=b.platform==="linux",j=N&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,P=O,z=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT;const t=b.env.VSCODE_NLS_CONFIG;if(t)try{const y=JSON.parse(t),p=y.availableLanguages["*"];S=y.locale,h=p||e.LANGUAGE_DEFAULT,s=y._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var o;(function(t){t[t.Web=0]="Web",t[t.Mac=1]="Mac",t[t.Linux=2]="Linux",t[t.Windows=3]="Windows"})(o=e.Platform||(e.Platform={}));function f(t){switch(t){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let d=0;w?d=1:R?d=3:N&&(d=2),e.isWindows=R,e.isMacintosh=w,e.isLinux=N,e.isLinuxSnap=j,e.isNative=k,e.isElectron=P,e.isWeb=E,e.isWebWorker=E&&typeof e.globals.importScripts=="function",e.isIOS=F,e.isMobile=Y,e.isCI=z,e.platform=d,e.userAgent=g,e.language=h;var u;(function(t){function y(){return e.language}t.value=y;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}t.isDefaultVariant=p;function I(){return e.language==="en"}t.isDefault=I})(u=e.Language||(e.Language={})),e.locale=S,e.translationsConfigFile=s,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const t=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let I=0,x=t.length;I<x;I++){const q=t[I];if(q.id===p.data.vscodeScheduleAsyncWork){t.splice(I,1),q.callback();return}}});let y=0;return p=>{const I=++y;t.push({id:I,callback:p}),e.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return t=>setTimeout(t)})();var l;(function(t){t[t.Windows=1]="Windows",t[t.Macintosh=2]="Macintosh",t[t.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=w||F?2:R?1:3;let c=!0,n=!1;function i(){if(!n){n=!0;const t=new Uint8Array(2);t[0]=1,t[1]=2,c=new Uint16Array(t.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=i,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ae[9],ce([0,1,2]),function(ie,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const w=v.globals.vscode.process;R={get platform(){return w.platform},get arch(){return w.arch},get env(){return w.env},cwd(){return w.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(ae[3],ce([0,1,9]),function(ie,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,w=97,N=90,j=122,k=46,E=47,P=92,F=58,z=63;class Y extends Error{constructor(o,f,d){let u;typeof f=="string"&&f.indexOf("not ")===0?(u="must not be",f=f.replace(/^not /,"")):u="must be";const l=o.indexOf(".")!==-1?"property":"argument";let c=`The "${o}" ${l} ${u} of type ${f}`;c+=`. Received type ${typeof d}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function S(a,o){if(typeof a!="string")throw new Y(o,"string",a)}function h(a){return a===E||a===P}function s(a){return a===E}function g(a){return a>=R&&a<=N||a>=w&&a<=j}function b(a,o,f,d){let u="",l=0,c=-1,n=0,i=0;for(let t=0;t<=a.length;++t){if(t<a.length)i=a.charCodeAt(t);else{if(d(i))break;i=E}if(d(i)){if(!(c===t-1||n===1))if(n===2){if(u.length<2||l!==2||u.charCodeAt(u.length-1)!==k||u.charCodeAt(u.length-2)!==k){if(u.length>2){const y=u.lastIndexOf(f);y===-1?(u="",l=0):(u=u.slice(0,y),l=u.length-1-u.lastIndexOf(f)),c=t,n=0;continue}else if(u.length!==0){u="",l=0,c=t,n=0;continue}}o&&(u+=u.length>0?`${f}..`:"..",l=2)}else u.length>0?u+=`${f}${a.slice(c+1,t)}`:u=a.slice(c+1,t),l=t-c-1;c=t,n=0}else i===k&&n!==-1?++n:n=-1}return u}function O(a,o){if(o===null||typeof o!="object")throw new Y("pathObject","Object",o);const f=o.dir||o.root,d=o.base||`${o.name||""}${o.ext||""}`;return f?f===o.root?`${f}${d}`:`${f}${a}${d}`:d}e.win32={resolve(...a){let o="",f="",d=!1;for(let u=a.length-1;u>=-1;u--){let l;if(u>=0){if(l=a[u],S(l,"path"),l.length===0)continue}else o.length===0?l=v.cwd():(l=v.env[`=${o}`]||v.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===P)&&(l=`${o}\\`));const c=l.length;let n=0,i="",t=!1;const y=l.charCodeAt(0);if(c===1)h(y)&&(n=1,t=!0);else if(h(y))if(t=!0,h(l.charCodeAt(1))){let p=2,I=p;for(;p<c&&!h(l.charCodeAt(p));)p++;if(p<c&&p!==I){const x=l.slice(I,p);for(I=p;p<c&&h(l.charCodeAt(p));)p++;if(p<c&&p!==I){for(I=p;p<c&&!h(l.charCodeAt(p));)p++;(p===c||p!==I)&&(i=`\\\\${x}\\${l.slice(I,p)}`,n=p)}}}else n=1;else g(y)&&l.charCodeAt(1)===F&&(i=l.slice(0,2),n=2,c>2&&h(l.charCodeAt(2))&&(t=!0,n=3));if(i.length>0)if(o.length>0){if(i.toLowerCase()!==o.toLowerCase())continue}else o=i;if(d){if(o.length>0)break}else if(f=`${l.slice(n)}\\${f}`,d=t,t&&o.length>0)break}return f=b(f,!d,"\\",h),d?`${o}\\${f}`:`${o}${f}`||"."},normalize(a){S(a,"path");const o=a.length;if(o===0)return".";let f=0,d,u=!1;const l=a.charCodeAt(0);if(o===1)return s(l)?"\\":a;if(h(l))if(u=!0,h(a.charCodeAt(1))){let n=2,i=n;for(;n<o&&!h(a.charCodeAt(n));)n++;if(n<o&&n!==i){const t=a.slice(i,n);for(i=n;n<o&&h(a.charCodeAt(n));)n++;if(n<o&&n!==i){for(i=n;n<o&&!h(a.charCodeAt(n));)n++;if(n===o)return`\\\\${t}\\${a.slice(i)}\\`;n!==i&&(d=`\\\\${t}\\${a.slice(i,n)}`,f=n)}}}else f=1;else g(l)&&a.charCodeAt(1)===F&&(d=a.slice(0,2),f=2,o>2&&h(a.charCodeAt(2))&&(u=!0,f=3));let c=f<o?b(a.slice(f),!u,"\\",h):"";return c.length===0&&!u&&(c="."),c.length>0&&h(a.charCodeAt(o-1))&&(c+="\\"),d===void 0?u?`\\${c}`:c:u?`${d}\\${c}`:`${d}${c}`},isAbsolute(a){S(a,"path");const o=a.length;if(o===0)return!1;const f=a.charCodeAt(0);return h(f)||o>2&&g(f)&&a.charCodeAt(1)===F&&h(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let o,f;for(let l=0;l<a.length;++l){const c=a[l];S(c,"path"),c.length>0&&(o===void 0?o=f=c:o+=`\\${c}`)}if(o===void 0)return".";let d=!0,u=0;if(typeof f=="string"&&h(f.charCodeAt(0))){++u;const l=f.length;l>1&&h(f.charCodeAt(1))&&(++u,l>2&&(h(f.charCodeAt(2))?++u:d=!1))}if(d){for(;u<o.length&&h(o.charCodeAt(u));)u++;u>=2&&(o=`\\${o.slice(u)}`)}return e.win32.normalize(o)},relative(a,o){if(S(a,"from"),S(o,"to"),a===o)return"";const f=e.win32.resolve(a),d=e.win32.resolve(o);if(f===d||(a=f.toLowerCase(),o=d.toLowerCase(),a===o))return"";let u=0;for(;u<a.length&&a.charCodeAt(u)===P;)u++;let l=a.length;for(;l-1>u&&a.charCodeAt(l-1)===P;)l--;const c=l-u;let n=0;for(;n<o.length&&o.charCodeAt(n)===P;)n++;let i=o.length;for(;i-1>n&&o.charCodeAt(i-1)===P;)i--;const t=i-n,y=c<t?c:t;let p=-1,I=0;for(;I<y;I++){const q=a.charCodeAt(u+I);if(q!==o.charCodeAt(n+I))break;q===P&&(p=I)}if(I!==y){if(p===-1)return d}else{if(t>y){if(o.charCodeAt(n+I)===P)return d.slice(n+I+1);if(I===2)return d.slice(n+I)}c>y&&(a.charCodeAt(u+I)===P?p=I:I===2&&(p=3)),p===-1&&(p=0)}let x="";for(I=u+p+1;I<=l;++I)(I===l||a.charCodeAt(I)===P)&&(x+=x.length===0?"..":"\\..");return n+=p,x.length>0?`${x}${d.slice(n,i)}`:(d.charCodeAt(n)===P&&++n,d.slice(n,i))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const o=e.win32.resolve(a);if(o.length<=2)return a;if(o.charCodeAt(0)===P){if(o.charCodeAt(1)===P){const f=o.charCodeAt(2);if(f!==z&&f!==k)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===F&&o.charCodeAt(2)===P)return`\\\\?\\${o}`;return a},dirname(a){S(a,"path");const o=a.length;if(o===0)return".";let f=-1,d=0;const u=a.charCodeAt(0);if(o===1)return h(u)?a:".";if(h(u)){if(f=d=1,h(a.charCodeAt(1))){let n=2,i=n;for(;n<o&&!h(a.charCodeAt(n));)n++;if(n<o&&n!==i){for(i=n;n<o&&h(a.charCodeAt(n));)n++;if(n<o&&n!==i){for(i=n;n<o&&!h(a.charCodeAt(n));)n++;if(n===o)return a;n!==i&&(f=d=n+1)}}}}else g(u)&&a.charCodeAt(1)===F&&(f=o>2&&h(a.charCodeAt(2))?3:2,d=f);let l=-1,c=!0;for(let n=o-1;n>=d;--n)if(h(a.charCodeAt(n))){if(!c){l=n;break}}else c=!1;if(l===-1){if(f===-1)return".";l=f}return a.slice(0,l)},basename(a,o){o!==void 0&&S(o,"ext"),S(a,"path");let f=0,d=-1,u=!0,l;if(a.length>=2&&g(a.charCodeAt(0))&&a.charCodeAt(1)===F&&(f=2),o!==void 0&&o.length>0&&o.length<=a.length){if(o===a)return"";let c=o.length-1,n=-1;for(l=a.length-1;l>=f;--l){const i=a.charCodeAt(l);if(h(i)){if(!u){f=l+1;break}}else n===-1&&(u=!1,n=l+1),c>=0&&(i===o.charCodeAt(c)?--c===-1&&(d=l):(c=-1,d=n))}return f===d?d=n:d===-1&&(d=a.length),a.slice(f,d)}for(l=a.length-1;l>=f;--l)if(h(a.charCodeAt(l))){if(!u){f=l+1;break}}else d===-1&&(u=!1,d=l+1);return d===-1?"":a.slice(f,d)},extname(a){S(a,"path");let o=0,f=-1,d=0,u=-1,l=!0,c=0;a.length>=2&&a.charCodeAt(1)===F&&g(a.charCodeAt(0))&&(o=d=2);for(let n=a.length-1;n>=o;--n){const i=a.charCodeAt(n);if(h(i)){if(!l){d=n+1;break}continue}u===-1&&(l=!1,u=n+1),i===k?f===-1?f=n:c!==1&&(c=1):f!==-1&&(c=-1)}return f===-1||u===-1||c===0||c===1&&f===u-1&&f===d+1?"":a.slice(f,u)},format:O.bind(null,"\\"),parse(a){S(a,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return o;const f=a.length;let d=0,u=a.charCodeAt(0);if(f===1)return h(u)?(o.root=o.dir=a,o):(o.base=o.name=a,o);if(h(u)){if(d=1,h(a.charCodeAt(1))){let p=2,I=p;for(;p<f&&!h(a.charCodeAt(p));)p++;if(p<f&&p!==I){for(I=p;p<f&&h(a.charCodeAt(p));)p++;if(p<f&&p!==I){for(I=p;p<f&&!h(a.charCodeAt(p));)p++;p===f?d=p:p!==I&&(d=p+1)}}}}else if(g(u)&&a.charCodeAt(1)===F){if(f<=2)return o.root=o.dir=a,o;if(d=2,h(a.charCodeAt(2))){if(f===3)return o.root=o.dir=a,o;d=3}}d>0&&(o.root=a.slice(0,d));let l=-1,c=d,n=-1,i=!0,t=a.length-1,y=0;for(;t>=d;--t){if(u=a.charCodeAt(t),h(u)){if(!i){c=t+1;break}continue}n===-1&&(i=!1,n=t+1),u===k?l===-1?l=t:y!==1&&(y=1):l!==-1&&(y=-1)}return n!==-1&&(l===-1||y===0||y===1&&l===n-1&&l===c+1?o.base=o.name=a.slice(c,n):(o.name=a.slice(c,l),o.base=a.slice(c,n),o.ext=a.slice(l,n))),c>0&&c!==d?o.dir=a.slice(0,c-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let o="",f=!1;for(let d=a.length-1;d>=-1&&!f;d--){const u=d>=0?a[d]:v.cwd();S(u,"path"),u.length!==0&&(o=`${u}/${o}`,f=u.charCodeAt(0)===E)}return o=b(o,!f,"/",s),f?`/${o}`:o.length>0?o:"."},normalize(a){if(S(a,"path"),a.length===0)return".";const o=a.charCodeAt(0)===E,f=a.charCodeAt(a.length-1)===E;return a=b(a,!o,"/",s),a.length===0?o?"/":f?"./":".":(f&&(a+="/"),o?`/${a}`:a)},isAbsolute(a){return S(a,"path"),a.length>0&&a.charCodeAt(0)===E},join(...a){if(a.length===0)return".";let o;for(let f=0;f<a.length;++f){const d=a[f];S(d,"path"),d.length>0&&(o===void 0?o=d:o+=`/${d}`)}return o===void 0?".":e.posix.normalize(o)},relative(a,o){if(S(a,"from"),S(o,"to"),a===o||(a=e.posix.resolve(a),o=e.posix.resolve(o),a===o))return"";const f=1,d=a.length,u=d-f,l=1,c=o.length-l,n=u<c?u:c;let i=-1,t=0;for(;t<n;t++){const p=a.charCodeAt(f+t);if(p!==o.charCodeAt(l+t))break;p===E&&(i=t)}if(t===n)if(c>n){if(o.charCodeAt(l+t)===E)return o.slice(l+t+1);if(t===0)return o.slice(l+t)}else u>n&&(a.charCodeAt(f+t)===E?i=t:t===0&&(i=0));let y="";for(t=f+i+1;t<=d;++t)(t===d||a.charCodeAt(t)===E)&&(y+=y.length===0?"..":"/..");return`${y}${o.slice(l+i)}`},toNamespacedPath(a){return a},dirname(a){if(S(a,"path"),a.length===0)return".";const o=a.charCodeAt(0)===E;let f=-1,d=!0;for(let u=a.length-1;u>=1;--u)if(a.charCodeAt(u)===E){if(!d){f=u;break}}else d=!1;return f===-1?o?"/":".":o&&f===1?"//":a.slice(0,f)},basename(a,o){o!==void 0&&S(o,"ext"),S(a,"path");let f=0,d=-1,u=!0,l;if(o!==void 0&&o.length>0&&o.length<=a.length){if(o===a)return"";let c=o.length-1,n=-1;for(l=a.length-1;l>=0;--l){const i=a.charCodeAt(l);if(i===E){if(!u){f=l+1;break}}else n===-1&&(u=!1,n=l+1),c>=0&&(i===o.charCodeAt(c)?--c===-1&&(d=l):(c=-1,d=n))}return f===d?d=n:d===-1&&(d=a.length),a.slice(f,d)}for(l=a.length-1;l>=0;--l)if(a.charCodeAt(l)===E){if(!u){f=l+1;break}}else d===-1&&(u=!1,d=l+1);return d===-1?"":a.slice(f,d)},extname(a){S(a,"path");let o=-1,f=0,d=-1,u=!0,l=0;for(let c=a.length-1;c>=0;--c){const n=a.charCodeAt(c);if(n===E){if(!u){f=c+1;break}continue}d===-1&&(u=!1,d=c+1),n===k?o===-1?o=c:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||d===-1||l===0||l===1&&o===d-1&&o===f+1?"":a.slice(o,d)},format:O.bind(null,"/"),parse(a){S(a,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return o;const f=a.charCodeAt(0)===E;let d;f?(o.root="/",d=1):d=0;let u=-1,l=0,c=-1,n=!0,i=a.length-1,t=0;for(;i>=d;--i){const y=a.charCodeAt(i);if(y===E){if(!n){l=i+1;break}continue}c===-1&&(n=!1,c=i+1),y===k?u===-1?u=i:t!==1&&(t=1):u!==-1&&(t=-1)}if(c!==-1){const y=l===0&&f?1:l;u===-1||t===0||t===1&&u===c-1&&u===l+1?o.base=o.name=a.slice(y,c):(o.name=a.slice(y,u),o.base=a.slice(y,c),o.ext=a.slice(u,c))}return l>0?o.dir=a.slice(0,l-1):f&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ae[26],ce([0,1,2]),function(ie,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class w{static create(j=!0){return new w(j)}constructor(j){this._highResolution=R&&j,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=w}),define(ae[10],ce([0,1,6,7,8,19,26]),function(ie,e,v,R,w,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,E=!1;var P;(function(i){i.None=()=>w.Disposable.None;function t(L){if(E){const{onListenerDidAdd:T}=L,V=h.create();let H=0;L.onListenerDidAdd=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),T?.()}}}function y(L,T){return W(L,()=>{},0,void 0,void 0,T)}i.defer=y;function p(L,T=0,V){return i.debounce(L,(H,Z)=>H?(H.push(Z),H):[Z],T,void 0,void 0,V)}i.accumulate=p;function I(L){return(T,V=null,H)=>{let Z=!1,se;return se=L(ue=>{if(!Z)return se?se.dispose():Z=!0,T.call(V,ue)},null,H),Z&&se.dispose(),se}}i.once=I;function x(L,T,V){return C((H,Z=null,se)=>L(ue=>H.call(Z,T(ue)),null,se),V)}i.map=x;function q(L,T,V){return C((H,Z=null,se)=>L(ue=>{T(ue),H.call(Z,ue)},null,se),V)}i.forEach=q;function te(L,T,V){return C((H,Z=null,se)=>L(ue=>T(ue)&&H.call(Z,ue),null,se),V)}i.filter=te;function re(L){return L}i.signal=re;function le(...L){return(T,V=null,H)=>(0,w.combinedDisposable)(...L.map(Z=>Z(se=>T.call(V,se),null,H)))}i.any=le;function me(L,T,V,H){let Z=V;return x(L,se=>(Z=T(Z,se),Z),H)}i.reduce=me;function C(L,T){let V;const H={onFirstListenerAdd(){V=L(Z.fire,Z)},onLastListenerRemove(){V?.dispose()}};T||t(H);const Z=new g(H);return T?.add(Z),Z.event}function W(L,T,V=100,H=!1,Z,se){let ue,de,Ee,Pe=0;const Le={leakWarningThreshold:Z,onFirstListenerAdd(){ue=L(Se=>{Pe++,de=T(de,Se),H&&!Ee&&(be.fire(de),de=void 0),clearTimeout(Ee),Ee=setTimeout(()=>{const Oe=de;de=void 0,Ee=void 0,(!H||Pe>1)&&be.fire(Oe),Pe=0},V)})},onLastListenerRemove(){ue.dispose()}};se||t(Le);const be=new g(Le);return se?.add(be),be.event}i.debounce=W;function B(L,T=(H,Z)=>H===Z,V){let H=!0,Z;return te(L,se=>{const ue=H||!T(se,Z);return H=!1,Z=se,ue},V)}i.latch=B;function G(L,T,V){return[i.filter(L,T,V),i.filter(L,H=>!T(H),V)]}i.split=G;function X(L,T=!1,V=[]){let H=V.slice(),Z=L(de=>{H?H.push(de):ue.fire(de)});const se=()=>{H?.forEach(de=>ue.fire(de)),H=null},ue=new g({onFirstListenerAdd(){Z||(Z=L(de=>ue.fire(de)))},onFirstListenerDidAdd(){H&&(T?setTimeout(se):se())},onLastListenerRemove(){Z&&Z.dispose(),Z=null}});return ue.event}i.buffer=X;class K{constructor(T){this.event=T,this.disposables=new w.DisposableStore}map(T){return new K(x(this.event,T,this.disposables))}forEach(T){return new K(q(this.event,T,this.disposables))}filter(T){return new K(te(this.event,T,this.disposables))}reduce(T,V){return new K(me(this.event,T,V,this.disposables))}latch(){return new K(B(this.event,void 0,this.disposables))}debounce(T,V=100,H=!1,Z){return new K(W(this.event,T,V,H,Z,this.disposables))}on(T,V,H){return this.event(T,V,H)}once(T,V,H){return I(this.event)(T,V,H)}dispose(){this.disposables.dispose()}}function oe(L){return new K(L)}i.chain=oe;function ee(L,T,V=H=>H){const H=(...de)=>ue.fire(V(...de)),Z=()=>L.on(T,H),se=()=>L.removeListener(T,H),ue=new g({onFirstListenerAdd:Z,onLastListenerRemove:se});return ue.event}i.fromNodeEventEmitter=ee;function ge(L,T,V=H=>H){const H=(...de)=>ue.fire(V(...de)),Z=()=>L.addEventListener(T,H),se=()=>L.removeEventListener(T,H),ue=new g({onFirstListenerAdd:Z,onLastListenerRemove:se});return ue.event}i.fromDOMEventEmitter=ge;function J(L){return new Promise(T=>I(L)(T))}i.toPromise=J;function M(L,T){return T(void 0),L(V=>T(V))}i.runAndSubscribe=M;function m(L,T){let V=null;function H(se){V?.dispose(),V=new w.DisposableStore,T(se,V)}H(void 0);const Z=L(se=>H(se));return(0,w.toDisposable)(()=>{Z.dispose(),V?.dispose()})}i.runAndSubscribeWithStore=m;class A{constructor(T,V){this.obs=T,this._counter=0,this._hasChanged=!1;const H={onFirstListenerAdd:()=>{T.addObserver(this)},onLastListenerRemove:()=>{T.removeObserver(this)}};V||t(H),this.emitter=new g(H),V&&V.add(this.emitter)}beginUpdate(T){this._counter++}handleChange(T,V){this._hasChanged=!0}endUpdate(T){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function U(L,T){return new A(L,T).emitter.event}i.fromObservable=U})(P=e.Event||(e.Event={}));class F{constructor(t){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${t}_${F._idPool++}`,F.all.add(this)}start(t){this._stopWatch=new j.StopWatch(!0),this.listenerCount=t}stop(){if(this._stopWatch){const t=this._stopWatch.elapsed();this.durations.push(t),this.elapsedOverall+=t,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=F,F.all=new Set,F._idPool=0;let z=-1;function Y(i){const t=z;return z=i,{dispose(){z=t}}}e.setGlobalLeakWarningThreshold=Y;class S{constructor(t,y=Math.random().toString(18).slice(2,5)){this.customThreshold=t,this.name=y,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(t,y){let p=z;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||y<p)return;this._stacks||(this._stacks=new Map);const I=this._stacks.get(t.value)||0;if(this._stacks.set(t.value,I+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let x,q=0;for(const[te,re]of this._stacks)(!x||q<re)&&(x=te,q=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${q}):`),console.warn(x)}return()=>{const x=this._stacks.get(t.value)||0;this._stacks.set(t.value,x-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(t){this.value=t}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class s{constructor(t,y,p){this.callback=t,this.callbackThis=y,this.stack=p,this.subscription=new w.SafeDisposable}invoke(t){this.callback.call(this.callbackThis,t)}}class g{constructor(t){this._disposed=!1,this._options=t,this._leakageMon=z>0?new S(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new F(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(k){const t=Array.from(this._listeners);queueMicrotask(()=>{for(const y of t)y.subscription.isset()&&(y.subscription.unset(),y.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(t,y,p)=>{this._listeners||(this._listeners=new N.LinkedList);const I=this._listeners.isEmpty();I&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let x,q;this._leakageMon&&this._listeners.size>=30&&(q=h.create(),x=this._leakageMon.check(q,this._listeners.size+1)),k&&(q=q??h.create());const te=new s(t,y,q),re=this._listeners.push(te);I&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,t,y);const le=te.subscription.set(()=>{x?.(),this._disposed||(re(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return p instanceof w.DisposableStore?p.add(le):Array.isArray(p)&&p.push(le),le}),this._event}fire(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new O);for(const y of this._listeners)this._deliveryQueue.push(this,y,t);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=g;class b{constructor(){this._queue=new N.LinkedList}get size(){return this._queue.size}push(t,y,p){this._queue.push(new a(t,y,p))}clear(t){const y=new N.LinkedList;for(const p of this._queue)p.emitter!==t&&y.push(p);this._queue=y}deliver(){for(;this._queue.size>0;){const t=this._queue.shift();try{t.listener.invoke(t.event)}catch(y){(0,v.onUnexpectedError)(y)}}}}e.EventDeliveryQueue=b;class O extends b{clear(t){this._queue.clear()}}class a{constructor(t,y,p){this.emitter=t,this.listener=y,this.event=p}}class o extends g{async fireAsync(t,y,p){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new N.LinkedList);for(const I of this._listeners)this._asyncDeliveryQueue.push([I,t]);for(;this._asyncDeliveryQueue.size>0&&!y.isCancellationRequested;){const[I,x]=this._asyncDeliveryQueue.shift(),q=[],te={...x,token:y,waitUntil:re=>{if(Object.isFrozen(q))throw new Error("waitUntil can NOT be called asynchronous");p&&(re=p(re,I.callback)),q.push(re)}};try{I.invoke(te)}catch(re){(0,v.onUnexpectedError)(re);continue}Object.freeze(q),await Promise.allSettled(q).then(re=>{for(const le of re)le.status==="rejected"&&(0,v.onUnexpectedError)(le.reason)})}}}}e.AsyncEmitter=o;class f extends g{constructor(t){super(t),this._isPaused=0,this._eventQueue=new N.LinkedList,this._mergeFn=t?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const t=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(t))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(t){this._listeners&&(this._isPaused!==0?this._eventQueue.push(t):super.fire(t))}}e.PauseableEmitter=f;class d extends f{constructor(t){super(t),this._delay=t.delay??100}fire(t){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(t)}}e.DebounceEmitter=d;class u extends g{constructor(t){super(t),this._queuedEvents=[],this._mergeFn=t?.merge}fire(t){!this.hasListeners()||(this._queuedEvents.push(t),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(y=>super.fire(y)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=u;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(t){const y={event:t,listener:null};this.events.push(y),this.hasListeners&&this.hook(y);const p=()=>{this.hasListeners&&this.unhook(y);const I=this.events.indexOf(y);this.events.splice(I,1)};return(0,w.toDisposable)((0,R.once)(p))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(t=>this.hook(t))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(t=>this.unhook(t))}hook(t){t.listener=t.event(y=>this.emitter.fire(y))}unhook(t){t.listener&&t.listener.dispose(),t.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=l;class c{constructor(){this.buffers=[]}wrapEvent(t){return(y,p,I)=>t(x=>{const q=this.buffers[this.buffers.length-1];q?q.push(()=>y.call(p,x)):y.call(p,x)},void 0,I)}bufferEvents(t){const y=[];this.buffers.push(y);const p=t();return this.buffers.pop(),y.forEach(I=>I()),p}}e.EventBufferer=c;class n{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=w.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=n}),define(ae[11],ce([0,1,10]),function(ie,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(k,E){const P=setTimeout(k.bind(E),0);return{dispose(){clearTimeout(P)}}});var w;(function(k){function E(P){return P===k.None||P===k.Cancelled||P instanceof N?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}k.isCancellationToken=E,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(w=e.CancellationToken||(e.CancellationToken={}));class N{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class j{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new N),this._token}cancel(){this._token?this._token instanceof N&&this._token.cancel():this._token=w.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof N&&this._token.dispose():this._token=w.None}}e.CancellationTokenSource=j}),define(ae[27],ce([0,1,11]),function(ie,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class R{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new v.CancellationTokenSource,E=this.task(k.token);return this.result={promise:E,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=R;class w{constructor(k){this.fn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const E=JSON.stringify(k);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(k)),this.lastCache}}e.LRUCachedFunction=w;class N{get cachedValues(){return this._map}constructor(k){this.fn=k,this._map=new Map}get(k){if(this._map.has(k))return this._map.get(k);const E=this.fn(k);return this._map.set(k,E),E}}e.CachedFunction=N}),define(ae[12],ce([0,1,27,18]),function(ie,e,v,R){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function N(r){return!r||typeof r!="string"?!0:r.trim().length===0}e.isFalsyOrWhitespace=N;const j=/{(\d+)}/g;function k(r,..._){return _.length===0?r:r.replace(j,function(D,$){const Q=parseInt($,10);return isNaN(Q)||Q<0||Q>=_.length?D:_[Q]})}e.format=k;const E=/{([^}]+)}/g;function P(r,_){return r.replace(E,(D,$)=>_[$]??D)}e.format2=P;function F(r){return r.replace(/[<>&]/g,function(_){switch(_){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return _}})}e.escape=F;function z(r){return r.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=z;function Y(r,_){let D=0;const $=_.charCodeAt(0);for(let Q=r.length-1;Q>=0;Q--)r.charCodeAt(Q)===$&&D++;return D}e.count=Y;function S(r,_,D="\u2026"){return r.length<=_?r:`${r.substr(0,_)}${D}`}e.truncate=S;function h(r,_=" "){const D=s(r,_);return g(D,_)}e.trim=h;function s(r,_){if(!r||!_)return r;const D=_.length;if(D===0||r.length===0)return r;let $=0;for(;r.indexOf(_,$)===$;)$=$+D;return r.substring($)}e.ltrim=s;function g(r,_){if(!r||!_)return r;const D=_.length,$=r.length;if(D===0||$===0)return r;let Q=$,ne=-1;for(;ne=r.lastIndexOf(_,Q-1),!(ne===-1||ne+D!==Q);){if(ne===0)return"";Q=ne}return r.substring(0,Q)}e.rtrim=g;function b(r){return r.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=b;function O(r){return r.replace(/\*/g,"")}e.stripWildcards=O;function a(r,_,D={}){if(!r)throw new Error("Cannot create regex from empty string");_||(r=z(r)),D.wholeWord&&(/\B/.test(r.charAt(0))||(r="\\b"+r),/\B/.test(r.charAt(r.length-1))||(r=r+"\\b"));let $="";return D.global&&($+="g"),D.matchCase||($+="i"),D.multiline&&($+="m"),D.unicode&&($+="u"),new RegExp(r,$)}e.createRegExp=a;function o(r){return r.source==="^"||r.source==="^$"||r.source==="$"||r.source==="^\\s*$"?!1:!!(r.exec("")&&r.lastIndex===0)}e.regExpLeadsToEndlessLoop=o;function f(r){return!!r.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function d(r){return(r.global?"g":"")+(r.ignoreCase?"i":"")+(r.multiline?"m":"")+(r.unicode?"u":"")}e.regExpFlags=d;function u(r){return r.split(/\r\n|\r|\n/)}e.splitLines=u;function l(r){for(let _=0,D=r.length;_<D;_++){const $=r.charCodeAt(_);if($!==32&&$!==9)return _}return-1}e.firstNonWhitespaceIndex=l;function c(r,_=0,D=r.length){for(let $=_;$<D;$++){const Q=r.charCodeAt($);if(Q!==32&&Q!==9)return r.substring(_,$)}return r.substring(_,D)}e.getLeadingWhitespace=c;function n(r,_=r.length-1){for(let D=_;D>=0;D--){const $=r.charCodeAt(D);if($!==32&&$!==9)return D}return-1}e.lastNonWhitespaceIndex=n;function i(r,_,D){const $=[];let Q=0;for(const ne of r.matchAll(_)){if($.push(r.slice(Q,ne.index)),ne.index===void 0)throw new Error("match.index should be defined");Q=ne.index+ne[0].length,$.push(D(ne[0],...ne.slice(1),ne.index,r,ne.groups))}return $.push(r.slice(Q)),Promise.all($).then(ne=>ne.join(""))}e.replaceAsync=i;function t(r,_){return r<_?-1:r>_?1:0}e.compare=t;function y(r,_,D=0,$=r.length,Q=0,ne=_.length){for(;D<$&&Q<ne;D++,Q++){const we=r.charCodeAt(D),fe=_.charCodeAt(Q);if(we<fe)return-1;if(we>fe)return 1}const he=$-D,Ce=ne-Q;return he<Ce?-1:he>Ce?1:0}e.compareSubstring=y;function p(r,_){return I(r,_,0,r.length,0,_.length)}e.compareIgnoreCase=p;function I(r,_,D=0,$=r.length,Q=0,ne=_.length){for(;D<$&&Q<ne;D++,Q++){let we=r.charCodeAt(D),fe=_.charCodeAt(Q);if(we===fe)continue;if(we>=128||fe>=128)return y(r.toLowerCase(),_.toLowerCase(),D,$,Q,ne);q(we)&&(we-=32),q(fe)&&(fe-=32);const ye=we-fe;if(ye!==0)return ye}const he=$-D,Ce=ne-Q;return he<Ce?-1:he>Ce?1:0}e.compareSubstringIgnoreCase=I;function x(r){return r>=48&&r<=57}e.isAsciiDigit=x;function q(r){return r>=97&&r<=122}e.isLowerAsciiLetter=q;function te(r){return r>=65&&r<=90}e.isUpperAsciiLetter=te;function re(r,_){return r.length===_.length&&I(r,_)===0}e.equalsIgnoreCase=re;function le(r,_){const D=_.length;return _.length>r.length?!1:I(r,_,0,D)===0}e.startsWithIgnoreCase=le;function me(r,_){const D=Math.min(r.length,_.length);let $;for($=0;$<D;$++)if(r.charCodeAt($)!==_.charCodeAt($))return $;return D}e.commonPrefixLength=me;function C(r,_){const D=Math.min(r.length,_.length);let $;const Q=r.length-1,ne=_.length-1;for($=0;$<D;$++)if(r.charCodeAt(Q-$)!==_.charCodeAt(ne-$))return $;return D}e.commonSuffixLength=C;function W(r){return 55296<=r&&r<=56319}e.isHighSurrogate=W;function B(r){return 56320<=r&&r<=57343}e.isLowSurrogate=B;function G(r,_){return(r-55296<<10)+(_-56320)+65536}e.computeCodePoint=G;function X(r,_,D){const $=r.charCodeAt(D);if(W($)&&D+1<_){const Q=r.charCodeAt(D+1);if(B(Q))return G($,Q)}return $}e.getNextCodePoint=X;function K(r,_){const D=r.charCodeAt(_-1);if(B(D)&&_>1){const $=r.charCodeAt(_-2);if(W($))return G($,D)}return D}class oe{get offset(){return this._offset}constructor(_,D=0){this._str=_,this._len=_.length,this._offset=D}setOffset(_){this._offset=_}prevCodePoint(){const _=K(this._str,this._offset);return this._offset-=_>=65536?2:1,_}nextCodePoint(){const _=X(this._str,this._len,this._offset);return this._offset+=_>=65536?2:1,_}eol(){return this._offset>=this._len}}e.CodePointIterator=oe;class ee{get offset(){return this._iterator.offset}constructor(_,D=0){this._iterator=new oe(_,D)}nextGraphemeLength(){const _=_e.getInstance(),D=this._iterator,$=D.offset;let Q=_.getGraphemeBreakType(D.nextCodePoint());for(;!D.eol();){const ne=D.offset,he=_.getGraphemeBreakType(D.nextCodePoint());if(Te(Q,he)){D.setOffset(ne);break}Q=he}return D.offset-$}prevGraphemeLength(){const _=_e.getInstance(),D=this._iterator,$=D.offset;let Q=_.getGraphemeBreakType(D.prevCodePoint());for(;D.offset>0;){const ne=D.offset,he=_.getGraphemeBreakType(D.prevCodePoint());if(Te(he,Q)){D.setOffset(ne);break}Q=he}return $-D.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ee;function ge(r,_){return new ee(r,_).nextGraphemeLength()}e.nextCharLength=ge;function J(r,_){return new ee(r,_).prevGraphemeLength()}e.prevCharLength=J;function M(r,_){_>0&&B(r.charCodeAt(_))&&_--;const D=_+ge(r,_);return[D-J(r,D),D]}e.getCharContainingOffset=M;function m(r){const _=new ee(r);let D=0;for(;!_.eol();)D++,_.nextGraphemeLength();return D}e.charCount=m;let A;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function L(r){return A||(A=U()),A.test(r)}e.containsRTL=L;const T=/^[\t\n\r\x20-\x7E]*$/;function V(r){return T.test(r)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(r){return e.UNUSUAL_LINE_TERMINATORS.test(r)}e.containsUnusualLineTerminators=H;function Z(r){return r>=11904&&r<=55215||r>=63744&&r<=64255||r>=65281&&r<=65374}e.isFullWidthCharacter=Z;function se(r){return r>=127462&&r<=127487||r===8986||r===8987||r===9200||r===9203||r>=9728&&r<=10175||r===11088||r===11093||r>=127744&&r<=128591||r>=128640&&r<=128764||r>=128992&&r<=129008||r>=129280&&r<=129535||r>=129648&&r<=129782}e.isEmojiImprecise=se;function ue(r,_){if(r.length<_)return r;const D=/\b/g;let $=0;for(;D.test(r)&&!(r.length-D.lastIndex<_);)$=D.lastIndex,D.lastIndex+=1;return r.substring($).replace(/^\s/,"")}e.lcut=ue;const de=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,Pe=/\x1b\[0?m/g;function Le(r){return r&&(r=r.replace(de,""),r=r.replace(Ee,""),r=r.replace(Pe,"")),r}e.removeAnsiEscapeCodes=Le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(r){return!!(r&&r.length>0&&r.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Se(r){return be(r)?r.substr(1):r}e.stripUTF8BOM=Se;function Oe(r,_){if(!r||!_||r.length<_.length)return!1;const D=_.length,$=r.toLowerCase();let Q=0,ne=-1;for(;Q<D;){const he=$.indexOf(_[Q],ne+1);if(he<0)return!1;ne=he,Q++}return!0}e.fuzzyContains=Oe;function Re(r,_=!1){return r?(_&&(r=r.replace(/\\./g,"")),r.toLowerCase()!==r):!1}e.containsUppercaseCharacter=Re;function Fe(r){return r.charAt(0).toUpperCase()+r.slice(1)}e.uppercaseFirstLetter=Fe;function Ue(r,_=1){if(_===0)return"";let D=-1;do D=r.indexOf(`
`,D+1),_--;while(_>0&&D>=0);return D===-1?r:(r[D-1]==="\r"&&D--,r.substr(0,D))}e.getNLines=Ue;function Ne(r){return r=r%(2*26),r<26?String.fromCharCode(97+r):String.fromCharCode(65+r-26)}e.singleLetterHash=Ne;function Me(r){return _e.getInstance().getGraphemeBreakType(r)}e.getGraphemeBreakType=Me;function Te(r,_){return r===0?_!==5&&_!==7:r===2&&_===3?!1:r===4||r===2||r===3||_===4||_===2||_===3?!0:!(r===8&&(_===8||_===9||_===11||_===12)||(r===11||r===9)&&(_===9||_===10)||(r===12||r===10)&&_===10||_===5||_===13||_===7||r===1||r===13&&_===14||r===6&&_===6)}var qe;(function(r){r[r.Other=0]="Other",r[r.Prepend=1]="Prepend",r[r.CR=2]="CR",r[r.LF=3]="LF",r[r.Control=4]="Control",r[r.Extend=5]="Extend",r[r.Regional_Indicator=6]="Regional_Indicator",r[r.SpacingMark=7]="SpacingMark",r[r.L=8]="L",r[r.V=9]="V",r[r.T=10]="T",r[r.LV=11]="LV",r[r.LVT=12]="LVT",r[r.ZWJ=13]="ZWJ",r[r.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class _e{static getInstance(){return _e._INSTANCE||(_e._INSTANCE=new _e),_e._INSTANCE}constructor(){this._data=ze()}getGraphemeBreakType(_){if(_<32)return _===10?3:_===13?2:4;if(_<127)return 0;const D=this._data,$=D.length/3;let Q=1;for(;Q<=$;)if(_<D[3*Q])Q=2*Q;else if(_>D[3*Q+1])Q=2*Q+1;else return D[3*Q+2];return 0}}_e._INSTANCE=null;function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function $e(r,_){if(r===0)return 0;const D=We(r,_);if(D!==void 0)return D;const $=new oe(_,r);return $.prevCodePoint(),$.offset}e.getLeftDeleteOffset=$e;function We(r,_){const D=new oe(_,r);let $=D.prevCodePoint();for(;je($)||$===65039||$===8419;){if(D.offset===0)return;$=D.prevCodePoint()}if(!se($))return;let Q=D.offset;return Q>0&&D.prevCodePoint()===8205&&(Q=D.offset),Q}function je(r){return 127995<=r&&r<=127999}var Ie;(function(r){r[r.zwj=8205]="zwj",r[r.emojiVariantSelector=65039]="emojiVariantSelector",r[r.enclosingKeyCap=8419]="enclosingKeyCap"})(Ie||(Ie={})),e.noBreakWhitespace="\xA0";class ve{static getInstance(_){return ve.cache.get(Array.from(_))}static getLocales(){return ve._locales.getValue()}constructor(_){this.confusableDictionary=_}isAmbiguous(_){return this.confusableDictionary.has(_)}getPrimaryConfusable(_){return this.confusableDictionary.get(_)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ve,w=ve,ve.ambiguousCharacterData=new R.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ve.cache=new v.LRUCachedFunction(r=>{function _(fe){const ye=new Map;for(let pe=0;pe<fe.length;pe+=2)ye.set(fe[pe],fe[pe+1]);return ye}function D(fe,ye){const pe=new Map(fe);for(const[De,ke]of ye)pe.set(De,ke);return pe}function $(fe,ye){if(!fe)return ye;const pe=new Map;for(const[De,ke]of fe)ye.has(De)&&pe.set(De,ke);return pe}const Q=w.ambiguousCharacterData.getValue();let ne=r.filter(fe=>!fe.startsWith("_")&&fe in Q);ne.length===0&&(ne=["_default"]);let he;for(const fe of ne){const ye=_(Q[fe]);he=$(he,ye)}const Ce=_(Q._common),we=D(Ce,he);return new ve(we)}),ve._locales=new R.Lazy(()=>Object.keys(ve.ambiguousCharacterData.getValue()).filter(r=>!r.startsWith("_")));class Ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ae.getRawData())),this._data}static isInvisibleCharacter(_){return Ae.getData().has(_)}static get codePoints(){return Ae.getData()}}e.InvisibleCharacters=Ae,Ae._data=void 0}),define(ae[4],ce([0,1,3,2,12,22]),function(ie,e,v,R,w,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function j(n){return n===47||n===92}e.isPathSeparator=j;function k(n){return n.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=k;function E(n){return n.indexOf("/")===-1&&(n=k(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=E;function P(n,i=v.posix.sep){if(!n)return"";const t=n.length,y=n.charCodeAt(0);if(j(y)){if(j(n.charCodeAt(1))&&!j(n.charCodeAt(2))){let I=3;const x=I;for(;I<t&&!j(n.charCodeAt(I));I++);if(x!==I&&!j(n.charCodeAt(I+1))){for(I+=1;I<t;I++)if(j(n.charCodeAt(I)))return n.slice(0,I+1).replace(/[\\/]/g,i)}}return i}else if(b(y)&&n.charCodeAt(1)===58)return j(n.charCodeAt(2))?n.slice(0,2)+i:n.slice(0,2);let p=n.indexOf("://");if(p!==-1){for(p+=3;p<t;p++)if(j(n.charCodeAt(p)))return n.slice(0,p+1)}return""}e.getRoot=P;function F(n){if(!R.isWindows||!n||n.length<5)return!1;let i=n.charCodeAt(0);if(i!==92||(i=n.charCodeAt(1),i!==92))return!1;let t=2;const y=t;for(;t<n.length&&(i=n.charCodeAt(t),i!==92);t++);return!(y===t||(i=n.charCodeAt(t+1),isNaN(i)||i===92))}e.isUNC=F;const z=/[\\/:\*\?"<>\|]/g,Y=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,i=R.isWindows){const t=i?z:Y;return!(!n||n.length===0||/^\s+$/.test(n)||(t.lastIndex=0,t.test(n))||i&&S.test(n)||n==="."||n===".."||i&&n[n.length-1]==="."||i&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function s(n,i,t){const y=n===i;return!t||y?y:!n||!i?!1:(0,w.equalsIgnoreCase)(n,i)}e.isEqual=s;function g(n,i,t,y=v.sep){if(n===i)return!0;if(!n||!i||i.length>n.length)return!1;if(t){if(!(0,w.startsWithIgnoreCase)(n,i))return!1;if(i.length===n.length)return!0;let I=i.length;return i.charAt(i.length-1)===y&&I--,n.charAt(I)===y}return i.charAt(i.length-1)!==y&&(i+=y),n.indexOf(i)===0}e.isEqualOrParent=g;function b(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=b;function O(n,i){return R.isWindows&&n.endsWith(":")&&(n+=v.sep),(0,v.isAbsolute)(n)||(n=(0,v.join)(i,n)),n=(0,v.normalize)(n),R.isWindows?(n=(0,w.rtrim)(n,v.sep),n.endsWith(":")&&(n+=v.sep)):(n=(0,w.rtrim)(n,v.sep),n||(n=v.sep)),n}e.sanitizeFilePath=O;function a(n){const i=(0,v.normalize)(n);return R.isWindows?n.length>3?!1:o(i)&&(n.length===2||i.charCodeAt(2)===92):i===v.posix.sep}e.isRootOrDriveLetter=a;function o(n,i=R.isWindows){return i?b(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function f(n){return o(n)?n[0]:void 0}e.getDriveLetter=f;function d(n,i,t){return i.length>n.length?-1:n===i?0:(t&&(n=n.toLowerCase(),i=i.toLowerCase()),n.indexOf(i))}e.indexOfPath=d;function u(n){const i=n.split(":");let t,y,p;for(const I of i){const x=Number(I);(0,N.isNumber)(x)?y===void 0?y=x:p===void 0&&(p=x):t=t?[t,I].join(":"):I}if(!t)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:t,line:y!==void 0?y:void 0,column:p!==void 0?p:y!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function c(n,i,t=8){let y="";for(let I=0;I<t;I++)y+=l.charAt(Math.floor(Math.random()*l.length));let p;return i?p=`${i}-${y}`:p=y,n?(0,v.join)(n,p):p}e.randomPath=c}),define(ae[5],ce([0,1,3,2]),function(ie,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const w=/^\w[\w\d+.-]*$/,N=/^\//,j=/^\/\//;function k(l,c){if(!l.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!w.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!N.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(l,c){return!l&&!c?"file":l}function P(l,c){switch(l){case"https":case"http":case"file":c?c[0]!==z&&(c=z+c):c=z;break}return c}const F="",z="/",Y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(c){return c instanceof S?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,n,i,t,y,p=!1){typeof c=="object"?(this.scheme=c.scheme||F,this.authority=c.authority||F,this.path=c.path||F,this.query=c.query||F,this.fragment=c.fragment||F):(this.scheme=E(c,p),this.authority=n||F,this.path=P(this.scheme,i||F),this.query=t||F,this.fragment=y||F,k(this,p))}get fsPath(){return a(this,!1)}with(c){if(!c)return this;let{scheme:n,authority:i,path:t,query:y,fragment:p}=c;return n===void 0?n=this.scheme:n===null&&(n=F),i===void 0?i=this.authority:i===null&&(i=F),t===void 0?t=this.path:t===null&&(t=F),y===void 0?y=this.query:y===null&&(y=F),p===void 0?p=this.fragment:p===null&&(p=F),n===this.scheme&&i===this.authority&&t===this.path&&y===this.query&&p===this.fragment?this:new s(n,i,t,y,p)}static parse(c,n=!1){const i=Y.exec(c);return i?new s(i[2]||F,u(i[4]||F),u(i[5]||F),u(i[7]||F),u(i[9]||F),n):new s(F,F,F,F,F)}static file(c){let n=F;if(R.isWindows&&(c=c.replace(/\\/g,z)),c[0]===z&&c[1]===z){const i=c.indexOf(z,2);i===-1?(n=c.substring(2),c=z):(n=c.substring(2,i),c=c.substring(i)||z)}return new s("file",n,c,F,F)}static from(c){const n=new s(c.scheme,c.authority,c.path,c.query,c.fragment);return k(n,!0),n}static joinPath(c,...n){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let i;return R.isWindows&&c.scheme==="file"?i=S.file(v.win32.join(a(c,!0),...n)).path:i=v.posix.join(c.path,...n),c.with({path:i})}toString(c=!1){return o(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof S)return c;{const n=new s(c);return n._formatted=c.external,n._fsPath=c._sep===h?c.fsPath:null,n}}else return c}}e.URI=S;const h=R.isWindows?1:void 0;class s extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(c=!1){return c?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=h),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(l,c){let n,i=-1;for(let t=0;t<l.length;t++){const y=l.charCodeAt(t);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||c&&y===47)i!==-1&&(n+=encodeURIComponent(l.substring(i,t)),i=-1),n!==void 0&&(n+=l.charAt(t));else{n===void 0&&(n=l.substr(0,t));const p=g[y];p!==void 0?(i!==-1&&(n+=encodeURIComponent(l.substring(i,t)),i=-1),n+=p):i===-1&&(i=t)}}return i!==-1&&(n+=encodeURIComponent(l.substring(i))),n!==void 0?n:l}function O(l){let c;for(let n=0;n<l.length;n++){const i=l.charCodeAt(n);i===35||i===63?(c===void 0&&(c=l.substr(0,n)),c+=g[i]):c!==void 0&&(c+=l[n])}return c!==void 0?c:l}function a(l,c){let n;return l.authority&&l.path.length>1&&l.scheme==="file"?n=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?c?n=l.path.substr(1):n=l.path[1].toLowerCase()+l.path.substr(2):n=l.path,R.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=a;function o(l,c){const n=c?O:b;let i="",{scheme:t,authority:y,path:p,query:I,fragment:x}=l;if(t&&(i+=t,i+=":"),(y||t==="file")&&(i+=z,i+=z),y){let q=y.indexOf("@");if(q!==-1){const te=y.substr(0,q);y=y.substr(q+1),q=te.indexOf(":"),q===-1?i+=n(te,!1):(i+=n(te.substr(0,q),!1),i+=":",i+=n(te.substr(q+1),!1)),i+="@"}y=y.toLowerCase(),q=y.indexOf(":"),q===-1?i+=n(y,!1):(i+=n(y.substr(0,q),!1),i+=y.substr(q))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const q=p.charCodeAt(1);q>=65&&q<=90&&(p=`/${String.fromCharCode(q+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const q=p.charCodeAt(0);q>=65&&q<=90&&(p=`${String.fromCharCode(q+32)}:${p.substr(2)}`)}i+=n(p,!0)}return I&&(i+="?",i+=n(I,!1)),x&&(i+="#",i+=c?x:b(x,!1)),i}function f(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+f(l.substr(3)):l}}const d=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(l){return l.match(d)?l.replace(d,c=>f(c)):l}}),define(ae[28],ce([0,1,2,5]),function(ie,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class N{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${w.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${w.vscodeRemoteResource}`}set(P,F,z){this._hosts[P]=F,this._ports[P]=z}setConnectionToken(P,F){this._connectionTokens[P]=F}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)return this._delegate(P);const F=P.authority;let z=this._hosts[F];z&&z.indexOf(":")!==-1&&z.indexOf("[")===-1&&(z=`[${z}]`);const Y=this._ports[F],S=this._connectionTokens[F];let h=`path=${encodeURIComponent(P.path)}`;return typeof S=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),R.URI.from({scheme:v.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${z}:${Y}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new N;class j{asBrowserUri(P,F){const z=this.toUri(P,F);return z.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(z):z.scheme===w.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${w.vscodeFileResource}://${j.FALLBACK_AUTHORITY}`)?z.with({scheme:w.vscodeFileResource,authority:z.authority||j.FALLBACK_AUTHORITY,query:null,fragment:null}):z}asFileUri(P,F){const z=this.toUri(P,F);return z.scheme===w.vscodeFileResource?z.with({scheme:w.file,authority:z.authority!==j.FALLBACK_AUTHORITY?z.authority:null,query:null,fragment:null}):z}toUri(P,F){return R.URI.isUri(P)?P:R.URI.parse(F.toUrl(P))}}j.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new j;var k;(function(E){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(P.get("3"));const F="vscode-coi";function z(S){let h;typeof S=="string"?h=new URL(S).searchParams:S instanceof URL?h=S.searchParams:R.URI.isUri(S)&&(h=new URL(S.toString(!0)).searchParams);const s=h?.get(F);if(!!s)return P.get(s)}E.getHeadersFromQuery=z;function Y(S,h,s){if(!globalThis.crossOriginIsolated)return;const g=h&&s?"3":s?"2":"1";S instanceof URLSearchParams?S.set(F,g):S[F]=g}E.addSearchParam=Y})(k=e.COI||(e.COI={}))}),define(ae[13],ce([0,1,4,28,3,2,12,5]),function(ie,e,v,R,w,N,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(S){return(0,k.uriToFsPath)(S,!0)}e.originalFSPath=E;class P{constructor(h){this._ignorePathCasing=h}compare(h,s,g=!1){return h===s?0:(0,j.compare)(this.getComparisonKey(h,g),this.getComparisonKey(s,g))}isEqual(h,s,g=!1){return h===s?!0:!h||!s?!1:this.getComparisonKey(h,g)===this.getComparisonKey(s,g)}getComparisonKey(h,s=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,s,g=!1){if(h.scheme===s.scheme){if(h.scheme===R.Schemas.file)return v.isEqualOrParent(E(h),E(s),this._ignorePathCasing(h))&&h.query===s.query&&(g||h.fragment===s.fragment);if((0,e.isEqualAuthority)(h.authority,s.authority))return v.isEqualOrParent(h.path,s.path,this._ignorePathCasing(h),"/")&&h.query===s.query&&(g||h.fragment===s.fragment)}return!1}joinPath(h,...s){return k.URI.joinPath(h,...s)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return w.posix.basename(h.path)}extname(h){return w.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let s;return h.scheme===R.Schemas.file?s=k.URI.file(w.dirname(E(h))).path:(s=w.posix.dirname(h.path),h.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),s="/")),h.with({path:s})}normalizePath(h){if(!h.path.length)return h;let s;return h.scheme===R.Schemas.file?s=k.URI.file(w.normalize(E(h))).path:s=w.posix.normalize(h.path),h.with({path:s})}relativePath(h,s){if(h.scheme!==s.scheme||!(0,e.isEqualAuthority)(h.authority,s.authority))return;if(h.scheme===R.Schemas.file){const O=w.relative(E(h),E(s));return N.isWindows?v.toSlashes(O):O}let g=h.path||"/";const b=s.path||"/";if(this._ignorePathCasing(h)){let O=0;for(const a=Math.min(g.length,b.length);O<a&&!(g.charCodeAt(O)!==b.charCodeAt(O)&&g.charAt(O).toLowerCase()!==b.charAt(O).toLowerCase());O++);g=b.substr(0,O)+g.substr(O)}return w.posix.relative(g,b)}resolvePath(h,s){if(h.scheme===R.Schemas.file){const g=k.URI.file(w.resolve(E(h),s));return h.with({authority:g.authority,path:g.path})}return s=v.toPosixPath(s),h.with({path:w.posix.resolve(h.path,s)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,s){return h===s||h!==void 0&&s!==void 0&&(0,j.equalsIgnoreCase)(h,s)}hasTrailingPathSeparator(h,s=w.sep){if(h.scheme===R.Schemas.file){const g=E(h);return g.length>v.getRoot(g).length&&g[g.length-1]===s}else{const g=h.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,s=w.sep){return(0,e.hasTrailingPathSeparator)(h,s)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,s=w.sep){let g=!1;if(h.scheme===R.Schemas.file){const b=E(h);g=b!==void 0&&b.length===v.getRoot(b).length&&b[b.length-1]===s}else{s="/";const b=h.path;g=b.length===1&&b.charCodeAt(b.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(h,s)?h.with({path:h.path+"/"}):h}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(S=>S.scheme===R.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new P(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(S,h){const s=[];for(let g=0;g<S.length;g++){const b=h(S[g]);S.some((O,a)=>a===g?!1:(0,e.isEqualOrParent)(b,h(O)))||s.push(S[g])}return s}e.distinctParents=F;var z;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function h(s){const g=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(a=>{const[o,f]=a.split(":");o&&f&&g.set(o,f)});const O=s.path.substring(0,s.path.indexOf(";"));return O&&g.set(S.META_DATA_MIME,O),g}S.parseMetaData=h})(z=e.DataUri||(e.DataUri={}));function Y(S,h,s){if(h){let g=S.path;return g&&g[0]!==w.posix.sep&&(g=w.posix.sep+g),S.with({scheme:s,authority:h,path:g})}return S.with({scheme:s})}e.toLocalResource=Y}),define(ae[14],ce([0,1,11,6,10,8,13,2]),function(ie,e,v,R,w,N,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(M){return!!M&&typeof M.then=="function"}e.isThenable=E;function P(M){const m=new v.CancellationTokenSource,A=M(m.token),U=new Promise((L,T)=>{const V=m.token.onCancellationRequested(()=>{V.dispose(),m.dispose(),T(new R.CancellationError)});Promise.resolve(A).then(H=>{V.dispose(),m.dispose(),L(H)},H=>{V.dispose(),m.dispose(),T(H)})});return new class{cancel(){m.cancel()}then(L,T){return U.then(L,T)}catch(L){return this.then(void 0,L)}finally(L){return U.finally(L)}}}e.createCancelablePromise=P;function F(M,m,A){return new Promise((U,L)=>{const T=m.onCancellationRequested(()=>{T.dispose(),U(A)});M.then(U,L).finally(()=>T.dispose())})}e.raceCancellation=F;function z(M,m){return new Promise((A,U)=>{const L=m.onCancellationRequested(()=>{L.dispose(),U(new R.CancellationError)});M.then(A,U).finally(()=>L.dispose())})}e.raceCancellationError=z;async function Y(M){let m=-1;const A=M.map((L,T)=>L.then(V=>(m=T,V))),U=await Promise.race(A);return M.forEach((L,T)=>{T!==m&&L.cancel()}),U}e.raceCancellablePromises=Y;function S(M,m,A){let U;const L=setTimeout(()=>{U?.(void 0),A?.()},m);return Promise.race([M.finally(()=>clearTimeout(L)),new Promise(T=>U=T)])}e.raceTimeout=S;function h(M){return new Promise((m,A)=>{const U=M();E(U)?U.then(m,A):m(U)})}e.asPromise=h;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(m){if(this.activePromise){if(this.queuedPromiseFactory=m,!this.queuedPromise){const A=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(A,A).then(U)})}return new Promise((A,U)=>{this.queuedPromise.then(A,U)})}return this.activePromise=m(),new Promise((A,U)=>{this.activePromise.then(L=>{this.activePromise=null,A(L)},L=>{this.activePromise=null,U(L)})})}}e.Throttler=s;class g{constructor(){this.current=Promise.resolve(null)}queue(m){return this.current=this.current.then(()=>m(),()=>m())}}e.Sequencer=g;class b{constructor(){this.promiseMap=new Map}queue(m,A){const L=(this.promiseMap.get(m)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.promiseMap.get(m)===L&&this.promiseMap.delete(m)});return this.promiseMap.set(m,L),L}}e.SequencerByKey=b;const O=(M,m)=>{let A=!0;const U=setTimeout(()=>{A=!1,m()},M);return{isTriggered:()=>A,dispose:()=>{clearTimeout(U),A=!1}}},a=M=>{let m=!0;return queueMicrotask(()=>{m&&(m=!1,M())}),{isTriggered:()=>m,dispose:()=>{m=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class o{constructor(m){this.defaultDelay=m,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(m,A=this.defaultDelay){this.task=m,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((L,T)=>{this.doResolve=L,this.doReject=T}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const L=this.task;return this.task=null,L()}}));const U=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=A===e.MicrotaskDelay?a(U):O(A,U),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new R.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=o;class f{constructor(m){this.delayer=new o(m),this.throttler=new s}trigger(m,A){return this.delayer.trigger(()=>this.throttler.queue(m),A)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class d{constructor(){this._isOpen=!1,this._promise=new Promise((m,A)=>{this._completePromise=m})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class u extends d{constructor(m){super(),this._timeout=setTimeout(()=>this.open(),m)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function l(M,m){return m?new Promise((A,U)=>{const L=setTimeout(()=>{T.dispose(),A()},M),T=m.onCancellationRequested(()=>{clearTimeout(L),T.dispose(),U(new R.CancellationError)})}):P(A=>l(M,A))}e.timeout=l;function c(M,m=0){const A=setTimeout(M,m);return(0,N.toDisposable)(()=>clearTimeout(A))}e.disposableTimeout=c;function n(M){const m=[];let A=0;const U=M.length;function L(){return A<U?M[A++]():null}function T(V){V!=null&&m.push(V);const H=L();return H?H.then(T):Promise.resolve(m)}return Promise.resolve(null).then(T)}e.sequence=n;function i(M,m=U=>!!U,A=null){let U=0;const L=M.length,T=()=>{if(U>=L)return Promise.resolve(A);const V=M[U++];return Promise.resolve(V()).then(Z=>m(Z)?Promise.resolve(Z):T())};return T()}e.first=i;function t(M,m=U=>!!U,A=null){if(M.length===0)return Promise.resolve(A);let U=M.length;const L=()=>{U=-1;for(const T of M)T.cancel?.()};return new Promise((T,V)=>{for(const H of M)H.then(Z=>{--U>=0&&m(Z)?(L(),T(Z)):U===0&&T(A)}).catch(Z=>{--U>=0&&(L(),V(Z))})})}e.firstParallel=t;class y{constructor(m){this._size=0,this.maxDegreeOfParalellism=m,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new w.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(m){return this._size++,new Promise((A,U)=>{this.outstandingPromises.push({factory:m,c:A,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const m=this.outstandingPromises.shift();this.runningPromises++;const A=m.factory();A.then(m.c,m.e),A.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=y;class p extends y{constructor(){super(1)}}e.Queue=p;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const m=new X;return this.drainers.add(m),m.p}isDrained(){for(const[,m]of this.queues)if(m.size>0)return!1;return!0}queueFor(m,A=j.extUri){const U=A.getComparisonKey(m);let L=this.queues.get(U);return L||(L=new p,w.Event.once(L.onDrained)(()=>{L?.dispose(),this.queues.delete(U),this.onDidQueueDrain()}),this.queues.set(U,L)),L}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const m of this.drainers)m.complete();this.drainers.clear()}dispose(){for(const[,m]of this.queues)m.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class x{constructor(m,A){this._token=-1,typeof m=="function"&&typeof A=="number"&&this.setIfNotSet(m,A)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(m,A){this.cancel(),this._token=setTimeout(()=>{this._token=-1,m()},A)}setIfNotSet(m,A){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,m()},A))}}e.TimeoutTimer=x;class q{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(m,A){this.cancel(),this._token=setInterval(()=>{m()},A)}}e.IntervalTimer=q;class te{constructor(m,A){this.timeoutToken=-1,this.runner=m,this.timeout=A,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(m=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,m)}get delay(){return this.timeout}set delay(m){this.timeout=m}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=te;class re{constructor(m,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.runner=m,this.timeout=A,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(m=this.timeout){m%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${m}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(m/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=re;class le extends te{constructor(m,A){super(m,A),this.units=[]}work(m){this.units.push(m),this.isScheduled()||this.schedule()}doRun(){const m=this.units;this.units=[],this.runner?.(m)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=le;class me extends N.Disposable{constructor(m,A){super(),this.options=m,this.handler=A,this.pendingWork=[],this.throttler=this._register(new N.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(m){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+m.length>this.options.maxBufferedWork)return!1}else if(this.pending+m.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...m),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new te(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=me,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=M=>{(0,k.setTimeout0)(()=>{if(m)return;const A=Date.now()+15;M(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let m=!1;return{dispose(){m||(m=!0)}}}:e.runWhenIdle=(M,m)=>{const A=requestIdleCallback(M,typeof m=="number"?{timeout:m}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(A))}}}}();class C{constructor(m){this._didRun=!1,this._executor=()=>{try{this._value=m()}catch(A){this._error=A}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=C;async function W(M,m,A){let U;for(let L=0;L<A;L++)try{return await M()}catch(T){U=T,await l(m)}throw U}e.retry=W;class B{hasPending(m){return this._pending?typeof m=="number"?this._pending.taskId===m:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(m,A,U){return this._pending={taskId:m,cancel:()=>U?.(),promise:A},A.then(()=>this.donePending(m),()=>this.donePending(m)),A}donePending(m){this._pending&&m===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const m=this._next;this._next=void 0,m.run().then(m.promiseResolve,m.promiseReject)}}setNext(m){if(this._next)this._next.run=m;else{let A,U;const L=new Promise((T,V)=>{A=T,U=V});this._next={run:m,promise:L,promiseResolve:A,promiseReject:U}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=B;class G{constructor(m,A=()=>Date.now()){this.interval=m,this.nowFn=A,this.lastIncrementTime=0,this.value=0}increment(){const m=this.nowFn();return m-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=m,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class X{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((m,A)=>{this.completeCallback=m,this.errorCallback=A})}complete(m){return new Promise(A=>{this.completeCallback(m),this.resolved=!0,A()})}error(m){return new Promise(A=>{this.errorCallback(m),this.rejected=!0,A()})}cancel(){new Promise(m=>{this.errorCallback(new R.CancellationError),this.rejected=!0,m()})}}e.DeferredPromise=X;var K;(function(M){async function m(U){let L;const T=await Promise.all(U.map(V=>V.then(H=>H,H=>{L||(L=H)})));if(typeof L<"u")throw L;return T}M.settled=m;function A(U){return new Promise(async(L,T)=>{try{await U(L,T)}catch(V){T(V)}})}M.withAsyncBody=A})(K=e.Promises||(e.Promises={}));var oe;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(oe||(oe={}));class ee{static fromArray(m){return new ee(A=>{A.emitMany(m)})}static fromPromise(m){return new ee(async A=>{A.emitMany(await m)})}static fromPromises(m){return new ee(async A=>{await Promise.all(m.map(async U=>A.emitOne(await U)))})}static merge(m){return new ee(async A=>{await Promise.all(m.map(async U=>{for await(const L of U)A.emitOne(L)}))})}constructor(m){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const A={emitOne:U=>this.emitOne(U),emitMany:U=>this.emitMany(U),reject:U=>this.reject(U)};try{await Promise.resolve(m(A)),this.resolve()}catch(U){this.reject(U)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}[Symbol.asyncIterator](){let m=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(m<this._results.length)return{done:!1,value:this._results[m++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(m,A){return new ee(async U=>{for await(const L of m)U.emitOne(A(L))})}map(m){return ee.map(this,m)}static filter(m,A){return new ee(async U=>{for await(const L of m)A(L)&&U.emitOne(L)})}filter(m){return ee.filter(this,m)}static coalesce(m){return ee.filter(m,A=>!!A)}coalesce(){return ee.coalesce(this)}static async toPromise(m){const A=[];for await(const U of m)A.push(U);return A}toPromise(){return ee.toPromise(this)}emitOne(m){this._state===0&&(this._results.push(m),this._onStateChanged.fire())}emitMany(m){this._state===0&&(this._results=this._results.concat(m),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(m){this._state===0&&(this._state=2,this._error=m,this._onStateChanged.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class ge extends ee{constructor(m,A){super(A),this._source=m}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ge;function J(M){const m=new v.CancellationTokenSource,A=M(m.token);return new ge(m,async U=>{const L=m.token.onCancellationRequested(()=>{L.dispose(),m.dispose(),U.reject(new R.CancellationError)});try{for await(const T of A){if(m.token.isCancellationRequested)return;U.emitOne(T)}L.dispose(),m.dispose()}catch(T){L.dispose(),m.dispose(),U.reject(T)}})}e.createCancelableAsyncIterable=J}),define(ae[29],ce([0,1,15,16,36,14,4,21,3,2,13,5]),function(ie,e,v,R,w,N,j,k,E,P,F,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var Y;(function(C){C[C.UNLINK=0]="UNLINK",C[C.MOVE=1]="MOVE"})(Y=e.RimRafMode||(e.RimRafMode={}));async function S(C,W=Y.UNLINK){if((0,j.isRootOrDriveLetter)(C))throw new Error("rimraf - will refuse to recursively delete root");return W===Y.UNLINK?s(C):h(C)}async function h(C){try{const W=(0,j.randomPath)((0,R.tmpdir)());try{await v.promises.rename(C,W)}catch(B){return B.code==="ENOENT"?void 0:s(C)}s(W).catch(B=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function s(C){return(0,w.promisify)(v.rm)(C,{recursive:!0,force:!0,maxRetries:3})}function g(C){if((0,j.isRootOrDriveLetter)(C))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(C,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function b(C,W){return o(await(W?O(C):(0,w.promisify)(v.readdir)(C)))}async function O(C){try{return await(0,w.promisify)(v.readdir)(C,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const W=[],B=await b(C);for(const G of B){let X=!1,K=!1,oe=!1;try{const ee=await e.Promises.lstat((0,E.join)(C,G));X=ee.isFile(),K=ee.isDirectory(),oe=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}W.push({name:G,isFile:()=>X,isDirectory:()=>K,isSymbolicLink:()=>oe})}return W}function a(C){return o(v.readdirSync(C))}e.readdirSync=a;function o(C){return C.map(W=>typeof W=="string"?P.isMacintosh?(0,k.normalizeNFC)(W):W:(W.name=P.isMacintosh?(0,k.normalizeNFC)(W.name):W.name,W))}async function f(C){const W=await b(C),B=[];for(const G of W)await u.existsDirectory((0,E.join)(C,G))&&B.push(G);return B}function d(C,W=1e3){return new Promise(B=>{let G=!1;const X=setInterval(()=>{G||(G=!0,v.access(C,K=>{G=!1,K&&(clearInterval(X),B(void 0))}))},W)})}e.whenDeleted=d;var u;(function(C){async function W(X){let K;try{if(K=await e.Promises.lstat(X),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(oe){if(oe.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(P.isWindows&&oe.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw ee}throw oe}}C.stat=W;async function B(X){try{const{stat:K,symbolicLink:oe}=await C.stat(X);return K.isFile()&&oe?.dangling!==!0}catch{}return!1}C.existsFile=B;async function G(X){try{const{stat:K,symbolicLink:oe}=await C.stat(X);return K.isDirectory()&&oe?.dangling!==!0}catch{}return!1}C.existsDirectory=G})(u=e.SymlinkSupport||(e.SymlinkSupport={}));const l=new N.ResourceQueue;function c(C,W,B){return l.queueFor(z.URI.file(C),F.extUriBiasedIgnorePathCase).queue(()=>{const G=p(B);return new Promise((X,K)=>t(C,W,G,oe=>oe?K(oe):X()))})}let n=!0;function i(C){n=C}e.configureFlushOnWrite=i;function t(C,W,B,G){if(!n)return v.writeFile(C,W,{mode:B.mode,flag:B.flag},G);v.open(C,B.flag,B.mode,(X,K)=>{if(X)return G(X);v.writeFile(K,W,oe=>{if(oe)return v.close(K,()=>G(oe));v.fdatasync(K,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),i(!1)),v.close(K,ge=>G(ge))))})})}function y(C,W,B){const G=p(B);if(!n)return v.writeFileSync(C,W,{mode:G.mode,flag:G.flag});const X=v.openSync(C,G.flag,G.mode);try{v.writeFileSync(X,W);try{v.fdatasyncSync(X)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),i(!1)}}finally{v.closeSync(X)}}e.writeFileSync=y;function p(C){return C?{mode:typeof C.mode=="number"?C.mode:438,flag:typeof C.flag=="string"?C.flag:"w"}:{mode:438,flag:"w"}}async function I(C,W){if(C!==W)try{await e.Promises.rename(C,W)}catch(B){if(C.toLowerCase()!==W.toLowerCase()&&B.code==="EXDEV"||C.endsWith("."))await x(C,W,{preserveSymlinks:!1}),await S(C,Y.MOVE);else throw B}}async function x(C,W,B){return te(C,W,{root:{source:C,target:W},options:B,handledSourcePaths:new Set})}const q=511;async function te(C,W,B){if(B.handledSourcePaths.has(C))return;B.handledSourcePaths.add(C);const{stat:G,symbolicLink:X}=await u.stat(C);if(X){if(B.options.preserveSymlinks)try{return await me(C,W,B)}catch(K){console.warn("[node.js fs] copy of symlink failed: ",K)}if(X.dangling)return}return G.isDirectory()?re(C,W,G.mode&q,B):le(C,W,G.mode&q)}async function re(C,W,B,G){await e.Promises.mkdir(W,{recursive:!0,mode:B});const X=await b(C);for(const K of X)await te((0,E.join)(C,K),(0,E.join)(W,K),G)}async function le(C,W,B){await e.Promises.copyFile(C,W),await e.Promises.chmod(W,B)}async function me(C,W,B){let G=await e.Promises.readlink(C);(0,j.isEqualOrParent)(G,B.root.source,!P.isLinux)&&(G=(0,E.join)(B.root.target,G.substr(B.root.source.length+1))),await e.Promises.symlink(G,W)}e.Promises=new class{get access(){return(0,w.promisify)(v.access)}get stat(){return(0,w.promisify)(v.stat)}get lstat(){return(0,w.promisify)(v.lstat)}get utimes(){return(0,w.promisify)(v.utimes)}get read(){return(C,W,B,G,X)=>new Promise((K,oe)=>{v.read(C,W,B,G,X,(ee,ge,J)=>ee?oe(ee):K({bytesRead:ge,buffer:J}))})}get readFile(){return(0,w.promisify)(v.readFile)}get write(){return(C,W,B,G,X)=>new Promise((K,oe)=>{v.write(C,W,B,G,X,(ee,ge,J)=>ee?oe(ee):K({bytesWritten:ge,buffer:J}))})}get appendFile(){return(0,w.promisify)(v.appendFile)}get fdatasync(){return(0,w.promisify)(v.fdatasync)}get truncate(){return(0,w.promisify)(v.truncate)}get rename(){return(0,w.promisify)(v.rename)}get copyFile(){return(0,w.promisify)(v.copyFile)}get open(){return(0,w.promisify)(v.open)}get close(){return(0,w.promisify)(v.close)}get symlink(){return(0,w.promisify)(v.symlink)}get readlink(){return(0,w.promisify)(v.readlink)}get chmod(){return(0,w.promisify)(v.chmod)}get mkdir(){return(0,w.promisify)(v.mkdir)}get unlink(){return(0,w.promisify)(v.unlink)}get rmdir(){return(0,w.promisify)(v.rmdir)}get realpath(){return(0,w.promisify)(v.realpath)}async exists(C){try{return await e.Promises.access(C),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return f}get writeFile(){return c}get rm(){return S}get move(){return I}get copy(){return x}}}),define(ae[30],ce([0,1,31,2]),function(ie,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveTerminalEncoding=void 0;const w={437:"cp437",850:"cp850",852:"cp852",855:"cp855",857:"cp857",860:"cp860",861:"cp861",863:"cp863",865:"cp865",866:"cp866",869:"cp869",936:"cp936",1252:"cp1252"};function N(P){const F=P.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return j[F]||F}const j={ibm866:"cp866",big5:"cp950"},k="utf8";async function E(P){let F;const z=process.env.VSCODE_CLI_ENCODING;z?(P&&console.log(`Found VSCODE_CLI_ENCODING variable: ${z}`),F=Promise.resolve(z)):R.isWindows?F=new Promise(S=>{P&&console.log('Running "chcp" to detect terminal encoding...'),(0,v.exec)("chcp",(h,s,g)=>{if(s){P&&console.log(`Output from "chcp" command is: ${s}`);const b=Object.keys(w);for(const O of b)if(s.indexOf(O)>=0)return S(w[O])}return S(void 0)})}):F=new Promise(S=>{P&&console.log('Running "locale charmap" to detect terminal encoding...'),(0,v.exec)("locale charmap",(h,s,g)=>S(s))});const Y=await F;return P&&console.log(`Detected raw terminal encoding: ${Y}`),!Y||Y.toLowerCase()==="utf-8"||Y.toLowerCase()===k?k:N(Y)}e.resolveTerminalEncoding=E}),define(ae[32],ce([24,25]),function(ie,e){return ie.create("vs/platform/environment/node/argv",e)}),define(ae[33],ce([0,1,37,2,32]),function(ie,e,v,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const N={o:(0,w.localize)(0,null),e:(0,w.localize)(1,null),t:(0,w.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,w.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,w.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,w.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,w.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,w.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,w.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,w.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,w.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,w.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,w.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,w.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,w.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,w.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,w.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,w.localize)(17,null)},category:{type:"string",cat:"e",description:(0,w.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,w.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,w.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,w.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,w.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,w.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,w.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,w.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,w.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,w.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,w.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,w.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,w.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,w.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,w.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,w.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,w.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,w.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(s,g,b=j){const O=s.find(i=>i.length>0&&i[0]!=="-"),a={},o=["_"],f=[],d={};let u;for(const i in g){const t=g[i];t.type==="subcommand"?i===O&&(u=t):(t.alias&&(a[i]=t.alias),t.type==="string"||t.type==="string[]"?(o.push(i),t.deprecates&&o.push(...t.deprecates)):t.type==="boolean"&&(f.push(i),t.deprecates&&f.push(...t.deprecates)),t.global&&(d[i]=t))}if(u&&O){const i=d;for(const I in u.options)i[I]=u.options[I];const t=s.filter(I=>I!==O),y=b.getSubcommandReporter?b.getSubcommandReporter(O):void 0,p=k(t,i,y);return{[O]:p,_:[]}}const l=v(s,{string:o,boolean:f,alias:a}),c={},n=l;c._=l._.map(i=>String(i)).filter(i=>i.length>0),delete n._;for(const i in g){const t=g[i];if(t.type==="subcommand")continue;t.alias&&delete n[t.alias];let y=n[i];if(t.deprecates)for(const p of t.deprecates)n.hasOwnProperty(p)&&(y||(y=n[p],y&&b.onDeprecatedOption(p,t.deprecationMessage||(0,w.localize)(36,null,i))),delete n[p]);if(typeof y<"u"){if(t.type==="string[]"){if(Array.isArray(y)||(y=[y]),!t.allowEmptyValue){const p=y.filter(I=>I.length>0);p.length!==y.length&&(b.onEmptyValue(i),y=p.length>0?p:void 0)}}else t.type==="string"&&(Array.isArray(y)?(y=y.pop(),b.onMultipleValues(i,y)):!y&&!t.allowEmptyValue&&(b.onEmptyValue(i),y=void 0));c[i]=y,t.deprecationMessage&&b.onDeprecatedOption(i,t.deprecationMessage)}delete n[i]}for(const i in n)b.onUnknownOption(i);return c}e.parseArgs=k;function E(s,g){let b="";return g.args&&(Array.isArray(g.args)?b=` <${g.args.join("> <")}>`:b=` <${g.args}>`),g.alias?`-${g.alias} --${s}${b}`:`--${s}${b}`}function P(s,g){const b=[];for(const O in s){const a=s[O],o=E(O,a);b.push([o,a.description])}return F(b,g)}e.formatOptions=P;function F(s,g){const O=s.reduce((f,d)=>Math.max(f,d[0].length),12)+2+1;if(g-O<25)return s.reduce((f,d)=>f.concat([`  ${d[0]}`,`      ${d[1]}`]),[]);const a=g-O-1,o=[];for(const f of s){const d=f[0],u=Y(f[1],a),l=z(O-d.length-2);o.push("  "+d+l+u[0]);for(let c=1;c<u.length;c++)o.push(z(O)+u[c])}return o}function z(s){return" ".repeat(s)}function Y(s,g){const b=[];for(;s.length;){const O=s.length<g?s.length:s.lastIndexOf(" ",g),a=s.slice(0,O).trim();s=s.slice(O),b.push(a)}return b}function S(s,g,b,O,a){const o=process.stdout.isTTY&&process.stdout.columns||80,f=a?.noInputFiles!==!0?`[${(0,w.localize)(37,null)}...]`:"",d=[`${s} ${b}`];d.push(""),d.push(`${(0,w.localize)(38,null)}: ${g} [${(0,w.localize)(39,null)}]${f}`),d.push(""),a?.noPipe!==!0&&(R.isWindows?d.push((0,w.localize)(40,null,g)):d.push((0,w.localize)(41,null,g)),d.push(""));const u={},l=[];for(const c in O){const n=O[c];if(n.type==="subcommand")n.description&&l.push({command:c,description:n.description});else if(n.description&&n.cat){let i=u[n.cat];i||(u[n.cat]=i={}),i[c]=n}}for(const c in u){const n=c,i=u[n];i&&(d.push(N[n]),d.push(...P(i,o)),d.push(""))}return l.length&&(d.push((0,w.localize)(42,null)),d.push(...F(l.map(c=>[c.command,c.description]),o)),d.push("")),d.join(`
`)}e.buildHelpMessage=S;function h(s,g){return`${s||(0,w.localize)(43,null)}
${g||(0,w.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=h}),define(ae[34],ce([0,1,16,14,4,29,30]),function(ie,e,v,R,w,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFromStdin=e.getStdinFilePath=e.stdinDataListener=e.hasStdinWithoutTty=void 0;function k(){try{return!process.stdin.isTTY}catch{}return!1}e.hasStdinWithoutTty=k;function E(z){return new Promise(Y=>{const S=()=>Y(!0);setTimeout(()=>{process.stdin.removeListener("data",S),Y(!1)},z),process.stdin.once("data",S)})}e.stdinDataListener=E;function P(){return(0,w.randomPath)((0,v.tmpdir)(),"code-stdin",3)}e.getStdinFilePath=P;async function F(z,Y){let[S,h]=await Promise.all([(0,j.resolveTerminalEncoding)(Y),new Promise((b,O)=>{ie(["@vscode/iconv-lite-umd"],b,O)}),N.Promises.appendFile(z,"")]);h.encodingExists(S)||(console.log(`Unsupported terminal encoding: ${S}, falling back to UTF-8.`),S="utf8");const s=new R.Queue,g=h.getDecoder(S);process.stdin.on("data",b=>{const O=g.write(b);s.queue(()=>N.Promises.appendFile(z,O))}),process.stdin.on("end",()=>{const b=g.end();typeof b=="string"&&s.queue(()=>N.Promises.appendFile(z,b))})}e.readFromStdin=F}),define(ae[35],ce([0,1,15,16,4]),function(ie,e,v,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function N(j){const k=(0,w.randomPath)((0,R.tmpdir)());try{return(0,v.writeFileSync)(k,""),j&&console.log(`Marker file for --wait created: ${k}`),k}catch(E){j&&console.error(`Failed to create marker file for --wait: ${E}`);return}}e.createWaitMarkerFileSync=N}),define(ae[38],ce([0,1,15,39,31,40,9,3,33,35,34]),function(ie,e,v,R,w,N,j,k,E,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;const z=q=>{switch(q){case"user-data-dir":case"extensions-dir":case"export-default-configuration":case"install-source":case"enable-smoke-test-driver":case"extensions-download-dir":case"builtin-extensions-dir":case"telemetry":return!1;default:return!0}},Y=q=>{switch(q){case"version":case"help":case"folder-uri":case"file-uri":case"add":case"diff":case"merge":case"wait":case"goto":case"reuse-window":case"new-window":case"status":case"install-extension":case"uninstall-extension":case"list-extensions":case"force":case"show-versions":case"category":case"verbose":case"remote":case"locate-shell-integration-path":return!0;default:return!1}},S=process.env.VSCODE_IPC_HOOK_CLI,h=process.env.VSCODE_CLIENT_COMMAND,s=process.env.VSCODE_CLIENT_COMMAND_CWD,g=process.env.VSCODE_CLI_AUTHORITY,b=process.env.VSCODE_STDIN_FILE_PATH;async function O(q,te){if(!S&&!h){console.log("Command is only available in WSL or inside a Visual Studio Code terminal.");return}const re={...E.OPTIONS,gitCredential:{type:"string"},openExternal:{type:"boolean"}},le=h?z:Y;for(const J in E.OPTIONS){const M=J;le(M)||delete re[M]}S&&(re.openExternal={type:"boolean"});const me={onMultipleValues:(J,M)=>{console.error(`Option '${J}' can only be defined once. Using value ${M}.`)},onEmptyValue:J=>{console.error(`Ignoring option '${J}': Value must not be empty.`)},onUnknownOption:J=>{console.error(`Ignoring option '${J}': not supported for ${q.executableName}.`)},onDeprecatedOption:(J,M)=>{console.warn(`Option '${J}' is deprecated: ${M}`)}},C=(0,E.parseArgs)(te,re,me),W=g?i:J=>J,B=!!C.verbose;if(C.help){console.log((0,E.buildHelpMessage)(q.productName,q.executableName,q.version,re));return}if(C.version){console.log((0,E.buildVersionMessage)(q.version,q.commit));return}if(C["locate-shell-integration-path"]){let J;switch(C["locate-shell-integration-path"]){case"bash":J="shellIntegration-bash.sh";break;case"pwsh":J="shellIntegration.ps1";break;case"zsh":J="shellIntegration-rc.zsh";break;case"fish":J="shellIntegration.fish";break;default:throw new Error("Error using --locate-shell-integration-path: Invalid shell type")}console.log((0,k.resolve)(__dirname,"../..","workbench","contrib","terminal","browser","media",J));return}if(S&&C.openExternal){o(C._,B);return}let G=C.remote;(G==="local"||G==="false"||G==="")&&(G=null);const X=(C["folder-uri"]||[]).map(W);C["folder-uri"]=X;const K=(C["file-uri"]||[]).map(W);C["file-uri"]=K;const oe=C._;let ee=!1;for(const J of oe)J==="-"?ee=!0:n(J,W,X,K);if(C._=[],ee&&K.length===0&&X.length===0&&(0,F.hasStdinWithoutTty)())try{let J=b;J||(J=(0,F.getStdinFilePath)(),await(0,F.readFromStdin)(J,B)),n(J,W,X,K),C.wait=!0,C["skip-add-to-recently-opened"]=!0,console.log(`Reading from stdin via: ${J}`)}catch(J){console.log(`Failed to create file to read via stdin: ${J.toString()}`)}C.extensionDevelopmentPath&&(C.extensionDevelopmentPath=C.extensionDevelopmentPath.map(J=>W(c(J).href))),C.extensionTestsPath&&(C.extensionTestsPath=W(c(C.extensionTestsPath).href));const ge=C["crash-reporter-directory"];if(ge!==void 0&&!ge.match(/^([a-zA-Z]:[\\\/])/)){console.log(`The crash reporter directory '${ge}' must be an absolute Windows path (e.g. c:/crashes)`);return}if(h){if(C["install-extension"]!==void 0||C["uninstall-extension"]!==void 0||C["list-extensions"]){const m=[];C["install-extension"]?.forEach(U=>m.push("--install-extension",U)),C["uninstall-extension"]?.forEach(U=>m.push("--uninstall-extension",U)),["list-extensions","force","show-versions","category"].forEach(U=>{const L=C[U];L!==void 0&&m.push(`--${U}=${L}`)}),w.fork((0,k.join)(__dirname,"../../../server-main.js"),m,{stdio:"inherit"}).on("error",U=>console.log(U));return}const J=[];for(const m in C){const A=C[m];if(typeof A=="boolean")A&&J.push("--"+m);else if(Array.isArray(A))for(const U of A)J.push(`--${m}=${U.toString()}`);else A&&J.push(`--${m}=${A.toString()}`)}G!==null&&J.push(`--remote=${G||g}`);const M=(0,k.extname)(h);if(M===".bat"||M===".cmd"){const m=s||(0,j.cwd)();B&&console.log(`Invoking: cmd.exe /C ${h} ${J.join(" ")} in ${m}`),w.spawn("cmd.exe",["/C",h,...J],{stdio:"inherit",cwd:m})}else{const m=(0,k.dirname)(h),A={...process.env,ELECTRON_RUN_AS_NODE:"1"};J.unshift("--ms-enable-electron-run-as-node"),J.unshift("resources/app/out/cli.js"),B&&console.log(`Invoking: cd "${m}" && ELECTRON_RUN_AS_NODE=1 "${h}" "${J.join('" "')}"`),w.spawn(h,J,{cwd:m,env:A,stdio:["inherit"]})}}else{if(C.status){f({type:"status"},B).then(M=>{console.log(M)}).catch(M=>{console.error("Error when requesting status:",M)});return}if(C["install-extension"]!==void 0||C["uninstall-extension"]!==void 0||C["list-extensions"]){f({type:"extensionManagement",list:C["list-extensions"]?{showVersions:C["show-versions"],category:C.category}:void 0,install:d(C["install-extension"]),uninstall:d(C["uninstall-extension"]),force:C.force},B).then(M=>{console.log(M)}).catch(M=>{console.error("Error when invoking the extension management command:",M)});return}let J;if(C.wait){if(!K.length){console.log("At least one file must be provided to wait for.");return}J=(0,P.createWaitMarkerFileSync)(B)}f({type:"open",fileURIs:K,folderURIs:X,diffMode:C.diff,mergeMode:C.merge,addMode:C.add,gotoLineMode:C.goto,forceReuseWindow:C["reuse-window"],forceNewWindow:C["new-window"],waitMarkerFilePath:J,remoteAuthority:G},B).catch(M=>{console.error("Error when invoking the open command:",M)}),J&&a(J)}}e.main=O;async function a(q){for(;v.existsSync(q);)await new Promise(te=>setTimeout(te,1e3))}function o(q,te){const re=[];for(const le of q)try{/^(http|https|file):\/\//.test(le)?re.push(R.parse(le).href):re.push(c(le).href)}catch{console.log(`Invalid url: ${le}`)}re.length&&f({type:"openExternal",uris:re},te).catch(le=>{console.error("Error when invoking the open external command:",le)})}function f(q,te){return te&&console.log(JSON.stringify(q,null,"  ")),new Promise((re,le)=>{const me=JSON.stringify(q);if(!S){console.log("Message "+me),re("");return}const C={socketPath:S,path:"/",method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},W=N.request(C,B=>{if(B.headers["content-type"]!=="application/json"){le("Error in response: Invalid content type: Expected 'application/json', is: "+B.headers["content-type"]);return}const G=[];B.setEncoding("utf8"),B.on("data",X=>{G.push(X)}),B.on("error",X=>u("Error in response.",X)),B.on("end",()=>{const X=G.join("");try{const K=JSON.parse(X);B.statusCode===200?re(K):le(K)}catch{le("Error in response: Unable to parse response as JSON: "+X)}})});W.on("error",B=>u("Error in request.",B)),W.write(me),W.end()})}function d(q){return q?.map(te=>/\.vsix$/i.test(te)?c(te).href:te)}function u(q,te){console.error("Unable to connect to VS Code server: "+q),console.error(te),process.exit(1)}const l=process.env.PWD||(0,j.cwd)();function c(q){return q=q.trim(),q=(0,k.resolve)(l,q),R.pathToFileURL(q)}function n(q,te,re,le){const me=c(q),C=te(me.href);try{const W=v.lstatSync(v.realpathSync(q));W.isFile()?le.push(C):W.isDirectory()?re.push(C):q==="/dev/null"&&le.push(C)}catch(W){W.code==="ENOENT"?le.push(C):console.log(`Problem accessing file ${q}. Ignoring file`,W)}}function i(q){return q.replace(/^file:\/\//,"vscode-remote://"+g)}const[,,t,y,p,I,...x]=process.argv;O({productName:t,version:y,commit:p,executableName:I},x).then(null,q=>{console.error(q.message||q.stack||q)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6261075646f055b99068d3688932416f2346dd3b/core/vs/server/node/server.cli.js.map
