"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/event","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/process","fs","os","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetry","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/errorMessage","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/codicons","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/performance","vs/editor/common/core/range","vs/base/common/marshalling","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/iterator","vs/base/common/processes","vs/base/common/ternarySearchTree","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/common/functional","vs/base/common/json","vs/base/common/mime","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","url","vs/platform/shell/node/shellEnv","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/decorators","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","path","net","vs/editor/common/core/position","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/telemetry/common/commonProperties","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/common/extensionGalleryService","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/server/node/extensionHostConnection","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/node/extpath","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/node/loggerService","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","https","http","yauzl","yazl","zlib","vs/server/node/server.main"],ye=function(se){for(var e=[],y=0,t=se.length;y<t;y++)e[y]=we[se[y]];return e};define(we[136],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class y{static get(){const P=new Map,I=new Map,k=new Map,b=new Map;function E(w,d){w.has(d.detail)||w.set(d.detail,-d.timestamp)}function C(w,d){const g=w.get(d.detail);!g||g>=0||w.set(d.detail,g+d.timestamp)}const T=se.getStats().slice(0).sort((w,d)=>w.timestamp-d.timestamp);for(const w of T)switch(w.type){case 10:E(P,w);break;case 11:case 12:C(P,w);break;case 21:E(I,w);break;case 22:C(I,w);break;case 33:E(k,w);break;case 34:C(k,w);break;case 31:E(b,w);break;case 32:C(b,w);break}let R=0;k.forEach(w=>R+=w);function S(w){const d=[];return w.forEach((g,p)=>d.push([p,g])),d}return{amdLoad:S(P),amdInvoke:S(I),nodeRequire:S(k),nodeEval:S(b),nodeRequireTotal:R}}static toMarkdownTable(P,I){let k="";const b=[];return P.forEach((E,C)=>{b[C]=E.length}),I.forEach(E=>{E.forEach((C,T)=>{typeof C>"u"&&(C=E[T]="-");const R=C.toString().length;b[T]=Math.max(R,b[T])})}),P.forEach((E,C)=>{k+=`| ${E+" ".repeat(b[C]-E.toString().length)} `}),k+=`|
`,P.forEach((E,C)=>{k+=`| ${"-".repeat(b[C])} `}),k+=`|
`,I.forEach(E=>{E.forEach((C,T)=>{typeof C<"u"&&(k+=`| ${C+" ".repeat(b[T]-C.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=y}),define(we[40],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function y(k){return k?k.replace(/\$\((.*?)\)/g,(b,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=y;class t{constructor(b,E,C){this.id=b,this.definition=E,this.description=C,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function P(k,b){const E=["codicon","codicon-"+k];return b&&E.push("codicon-modifier-"+b),E}e.getClassNamesArray=P;var I;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function E(R){if(R instanceof t)return["codicon","codicon-"+R.id];const S=b.exec(R.id);if(!S)return E(t.error);const[,w,d]=S,g=["codicon","codicon-"+w];return d&&g.push("codicon-modifier-"+d.substr(1)),g}k.asClassNameArray=E;function C(R){return E(R).join(" ")}k.asClassName=C;function T(R){return"."+E(R).join(".")}k.asCSSSelector=T})(I=e.CSSIcon||(e.CSSIcon={}))}),define(we[84],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function y(k){return(b,E,C)=>{let T=null,R=null;if(typeof C.value=="function"?(T="value",R=C.value):typeof C.get=="function"&&(T="get",R=C.get),!R)throw new Error("not supported");C[T]=k(R,E)}}e.createDecorator=y;function t(k,b,E){let C=null,T=null;if(typeof E.value=="function"?(C="value",T=E.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(C="get",T=E.get),!T)throw new Error("not supported");const R=`$memoize$${b}`;E[C]=function(...S){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,S)}),this[R]}}e.memoize=t;function P(k,b,E){return y((C,T)=>{const R=`$debounce$${T}`,S=`$debounce$result$${T}`;return function(...w){this[S]||(this[S]=E?E():void 0),clearTimeout(this[R]),b&&(this[S]=b(this[S],...w),w=[this[S]]),this[R]=setTimeout(()=>{C.apply(this,w),this[S]=E?E():void 0},k)}})}e.debounce=P;function I(k,b,E){return y((C,T)=>{const R=`$throttle$timer$${T}`,S=`$throttle$result$${T}`,w=`$throttle$lastRun$${T}`,d=`$throttle$pending$${T}`;return function(...g){if(this[S]||(this[S]=E?E():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),b&&(this[S]=b(this[S],...g)),this[d])return;const p=this[w]+k;p<=Date.now()?(this[w]=Date.now(),C.apply(this,[this[S]]),this[S]=E?E():void 0):(this[d]=!0,this[R]=setTimeout(()=>{this[d]=!1,this[w]=Date.now(),C.apply(this,[this[S]]),this[S]=E?E():void 0},p-Date.now()))}})}e.throttle=I}),define(we[10],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?u.isErrorNoTelemetry(i)?new u(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(r=>{r(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=y,e.errorHandler=new y;function t(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=t;function P(h){E(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=P;function I(h){E(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=I;function k(h){if(h instanceof Error){const{name:i,message:r}=h,n=h.stacktrace||h.stack;return{$isError:!0,name:i,message:r,stack:n,noTelemetry:u.isErrorNoTelemetry(h)}}return h}e.transformErrorForSerialization=k;const b="Canceled";function E(h){return h instanceof C?!0:h instanceof Error&&h.name===b&&h.message===b}e.isCancellationError=E;class C extends Error{constructor(){super(b),this.name=this.message}}e.CancellationError=C;function T(){const h=new Error(b);return h.name=h.message,h}e.canceled=T;function R(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=R;function S(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=S;function w(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function d(h){const i=new Error(`${h} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function g(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=g;class p extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=p;class m extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=m;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class u extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof u)return i;const r=new u;return r.message=i.message,r.stack=i.stack,r}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=u;class l extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype);debugger}}e.BugIndicatingError=l}),define(we[18],ye([1,0,10]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t($,Q=0){return $[$.length-(1+Q)]}e.tail=t;function P($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=P;function I($,Q,Y=(W,V)=>W===V){if($===Q)return!0;if(!$||!Q||$.length!==Q.length)return!1;for(let W=0,V=$.length;W<V;W++)if(!Y($[W],Q[W]))return!1;return!0}e.equals=I;function k($,Q){const Y=$.length-1;Q<Y&&($[Q]=$[Y]),$.pop()}e.removeFastWithoutKeepingOrder=k;function b($,Q,Y){return E($.length,W=>Y($[W],Q))}e.binarySearch=b;function E($,Q){let Y=0,W=$-1;for(;Y<=W;){const V=(Y+W)/2|0,q=Q(V);if(q<0)Y=V+1;else if(q>0)W=V-1;else return V}return-(Y+1)}e.binarySearch2=E;function C($,Q){let Y=0,W=$.length;if(W===0)return 0;for(;Y<W;){const V=Math.floor((Y+W)/2);Q($[V])?W=V:Y=V+1}return Y}e.findFirstInSorted=C;function T($,Q,Y){if($=$|0,$>=Q.length)throw new TypeError("invalid index");const W=Q[Math.floor(Q.length*Math.random())],V=[],q=[],X=[];for(const le of Q){const pe=Y(le,W);pe<0?V.push(le):pe>0?q.push(le):X.push(le)}return $<V.length?T($,V,Y):$<V.length+X.length?X[0]:T($-(V.length+X.length),q,Y)}e.quickSelect=T;function R($,Q){const Y=[];let W;for(const V of $.slice(0).sort(Q))!W||Q(W[0],V)!==0?(W=[V],Y.push(W)):W.push(V);return Y}e.groupBy=R;function S($,Q,Y){const W=[];function V(le,pe,ke){if(pe===0&&ke.length===0)return;const Te=W[W.length-1];Te&&Te.start+Te.deleteCount===le?(Te.deleteCount+=pe,Te.toInsert.push(...ke)):W.push({start:le,deleteCount:pe,toInsert:ke})}let q=0,X=0;for(;;){if(q===$.length){V(q,0,Q.slice(X));break}if(X===Q.length){V(q,$.length-q,[]);break}const le=$[q],pe=Q[X],ke=Y(le,pe);ke===0?(q+=1,X+=1):ke<0?(V(q,1,[]),q+=1):ke>0&&(V(q,0,[pe]),X+=1)}return W}e.sortedDiff=S;function w($,Q,Y){const W=S($,Q,Y),V=[],q=[];for(const X of W)V.push(...$.slice(X.start,X.start+X.deleteCount)),q.push(...X.toInsert);return{removed:V,added:q}}e.delta=w;function d($,Q,Y){if(Y===0)return[];const W=$.slice(0,Y).sort(Q);return p($,Q,W,Y,$.length),W}e.top=d;function g($,Q,Y,W,V){return Y===0?Promise.resolve([]):new Promise((q,X)=>{(async()=>{const le=$.length,pe=$.slice(0,Y).sort(Q);for(let ke=Y,Te=Math.min(Y+W,le);ke<le;ke=Te,Te=Math.min(Te+W,le)){if(ke>Y&&await new Promise(Me=>setTimeout(Me)),V&&V.isCancellationRequested)throw new y.CancellationError;p($,Q,pe,ke,Te)}return pe})().then(q,X)})}e.topAsync=g;function p($,Q,Y,W,V){for(const q=Y.length;W<V;W++){const X=$[W];if(Q(X,Y[q-1])<0){Y.pop();const le=C(Y,pe=>Q(X,pe)<0);Y.splice(le,0,X)}}}function m($){return $.filter(Q=>!!Q)}e.coalesce=m;function v($){let Q=0;for(let Y=0;Y<$.length;Y++)$[Y]&&($[Q]=$[Y],Q+=1);$.length=Q}e.coalesceInPlace=v;function u($,Q,Y){$.splice(Y,0,$.splice(Q,1)[0])}e.move=u;function l($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=l;function h($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=h;function i($,Q=Y=>Y){const Y=new Set;return $.filter(W=>{const V=Q(W);return Y.has(V)?!1:(Y.add(V),!0)})}e.distinct=i;function r($){const Q=new Set;return Y=>{const W=$(Y);return Q.has(W)?!1:(Q.add(W),!0)}}e.uniqueFilter=r;function n($,Q){const Y=s($,Q);if(Y!==-1)return $[Y]}e.findLast=n;function s($,Q){for(let Y=$.length-1;Y>=0;Y--){const W=$[Y];if(Q(W))return Y}return-1}e.lastIndex=s;function a($,Q){return $.length>0?$[0]:Q}e.firstOrDefault=a;function f($,Q){return $.length>0?$[$.length-1]:Q}e.lastOrDefault=f;function o($,Q,Y=(W,V)=>W===V){let W=0;for(let V=0,q=Math.min($.length,Q.length);V<q&&Y($[V],Q[V]);V++)W++;return W}e.commonPrefixLength=o;function c($){return[].concat(...$)}e.flatten=c;function D($,Q){let Y=typeof Q=="number"?$:0;typeof Q=="number"?Y=$:(Y=0,Q=$);const W=[];if(Y<=Q)for(let V=Y;V<Q;V++)W.push(V);else for(let V=Y;V>Q;V--)W.push(V);return W}e.range=D;function O($,Q,Y){return $.reduce((W,V)=>(W[Q(V)]=Y?Y(V):V,W),Object.create(null))}e.index=O;function H($,Q){return $.push(Q),()=>re($,Q)}e.insert=H;function re($,Q){const Y=$.indexOf(Q);if(Y>-1)return $.splice(Y,1),Q}e.remove=re;function ce($,Q,Y){const W=$.slice(0,Q),V=$.slice(Q);return W.concat(Y,V)}e.arrayInsert=ce;function ae($,Q){let Y;if(typeof Q=="number"){let W=Q;Y=()=>{const V=Math.sin(W++)*179426549;return V-Math.floor(V)}}else Y=Math.random;for(let W=$.length-1;W>0;W-=1){const V=Math.floor(Y()*(W+1)),q=$[W];$[W]=$[V],$[V]=q}}e.shuffle=ae;function N($,Q){const Y=$.indexOf(Q);Y>-1&&($.splice(Y,1),$.unshift(Q))}e.pushToStart=N;function J($,Q){const Y=$.indexOf(Q);Y>-1&&($.splice(Y,1),$.push(Q))}e.pushToEnd=J;function B($,Q){for(const Y of Q)$.push(Y)}e.pushMany=B;function x($,Q){return Array.isArray($)?$.map(Q):Q($)}e.mapArrayOrNot=x;function z($){return Array.isArray($)?$:[$]}e.asArray=z;function j($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=j;function L($,Q){for(const Y of $){const W=Q(Y);if(W!==void 0)return W}}e.mapFind=L;function F($,Q,Y){const W=oe($,Q),V=$.length,q=Y.length;$.length=V+q;for(let X=V-1;X>=W;X--)$[X+q]=$[X];for(let X=0;X<q;X++)$[X+W]=Y[X]}e.insertInto=F;function G($,Q,Y,W){const V=oe($,Q),q=$.splice(V,Y);return F($,V,W),q}e.splice=G;function oe($,Q){return Q<0?Math.max(Q+$.length,0):Math.min(Q,$.length)}var fe;(function($){function Q(V){return V<0}$.isLessThan=Q;function Y(V){return V>0}$.isGreaterThan=Y;function W(V){return V===0}$.isNeitherLessOrGreaterThan=W,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(fe=e.CompareResult||(e.CompareResult={}));function ee($,Q){return(Y,W)=>Q($(Y),$(W))}e.compareBy=ee;function te(...$){return(Q,Y)=>{for(const W of $){const V=W(Q,Y);if(!fe.isNeitherLessOrGreaterThan(V))return V}return fe.neitherLessOrGreaterThan}}e.tieBreakComparators=te;const _=($,Q)=>$-Q;e.numberComparator=_;function U($,Q){if($.length===0)return;let Y=$[0];for(let W=1;W<$.length;W++){const V=$[W];Q(V,Y)>0&&(Y=V)}return Y}e.findMaxBy=U;function Z($,Q){if($.length===0)return;let Y=$[0];for(let W=1;W<$.length;W++){const V=$[W];Q(V,Y)>=0&&(Y=V)}return Y}e.findLastMaxBy=Z;function ie($,Q){return U($,(Y,W)=>-Q(Y,W))}e.findMinBy=ie;class ue{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let Y=this.firstIdx;for(;Y<this.items.length&&Q(this.items[Y]);)Y++;const W=Y===this.firstIdx?null:this.items.slice(this.firstIdx,Y);return this.firstIdx=Y,W}takeFromEndWhile(Q){let Y=this.lastIdx;for(;Y>=0&&Q(this.items[Y]);)Y--;const W=Y===this.lastIdx?null:this.items.slice(Y+1,this.lastIdx+1);return this.lastIdx=Y,W}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Q=this.items[this.firstIdx];return this.firstIdx++,Q}removeLast(){const Q=this.items[this.lastIdx];return this.lastIdx--,Q}takeCount(Q){const Y=this.items.slice(this.firstIdx,this.firstIdx+Q);return this.firstIdx+=Q,Y}}e.ArrayQueue=ue;class ve{constructor(Q){this.iterate=Q}forEach(Q){this.iterate(Y=>(Q(Y),!0))}toArray(){const Q=[];return this.iterate(Y=>(Q.push(Y),!0)),Q}filter(Q){return new ve(Y=>this.iterate(W=>Q(W)?Y(W):!0))}map(Q){return new ve(Y=>this.iterate(W=>Y(Q(W))))}some(Q){let Y=!1;return this.iterate(W=>(Y=Q(W),!Y)),Y}findFirst(Q){let Y;return this.iterate(W=>Q(W)?(Y=W,!1):!0),Y}findLast(Q){let Y;return this.iterate(W=>(Q(W)&&(Y=W),!0)),Y}findLastMaxBy(Q){let Y,W=!0;return this.iterate(V=>((W||fe.isGreaterThan(Q(V,Y)))&&(W=!1,Y=V),!0)),Y}}e.CallbackIterable=ve,ve.empty=new ve($=>{})}),define(we[85],ye([1,0,10]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(E,C){if(!E)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=t;function P(E,C="Unreachable"){throw new Error(C)}e.assertNever=P;function I(E){if(!E)throw new y.BugIndicatingError("Assertion Failed")}e.assert=I;function k(E){if(!E()){debugger;E(),(0,y.onUnexpectedError)(new y.BugIndicatingError("Assertion Failed"))}}e.assertFn=k;function b(E,C){let T=0;for(;T<E.length-1;){const R=E[T],S=E[T+1];if(!C(R,S))return!1;T++}return!0}e.checkAdjacentItems=b}),define(we[66],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(t){const P=this;let I=!1,k;return function(){return I||(I=!0,k=t.apply(P,arguments)),k}}e.once=y}),define(we[55],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(t){function P(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}t.is=P;const I=Object.freeze([]);function k(){return I}t.empty=k;function*b(l){yield l}t.single=b;function E(l){return P(l)?l:b(l)}t.wrap=E;function C(l){return l||I}t.from=C;function T(l){return!l||l[Symbol.iterator]().next().done===!0}t.isEmpty=T;function R(l){return l[Symbol.iterator]().next().value}t.first=R;function S(l,h){for(const i of l)if(h(i))return!0;return!1}t.some=S;function w(l,h){for(const i of l)if(h(i))return i}t.find=w;function*d(l,h){for(const i of l)h(i)&&(yield i)}t.filter=d;function*g(l,h){let i=0;for(const r of l)yield h(r,i++)}t.map=g;function*p(...l){for(const h of l)for(const i of h)yield i}t.concat=p;function m(l,h,i){let r=i;for(const n of l)r=h(r,n);return r}t.reduce=m;function*v(l,h,i=l.length){for(h<0&&(h+=l.length),i<0?i+=l.length:i>l.length&&(i=l.length);h<i;h++)yield l[h]}t.slice=v;function u(l,h=Number.POSITIVE_INFINITY){const i=[];if(h===0)return[i,l];const r=l[Symbol.iterator]();for(let n=0;n<h;n++){const s=r.next();if(s.done)return[i,t.empty()];i.push(s.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=u})(y=e.Iterable||(e.Iterable={}))}),define(we[67],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(y=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(i){i.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function k(i,r=!1){let n=0;const s=i.length;let a="",f=0,o=16,c=0;function D(J){let B=0,x=0;for(;B<J;){const z=i.charCodeAt(n);if(z>=48&&z<=57)x=x*16+z-48;else if(z>=65&&z<=70)x=x*16+z-65+10;else if(z>=97&&z<=102)x=x*16+z-97+10;else break;n++,B++}return B<J&&(x=-1),x}function O(J){n=J,a="",f=0,o=16,c=0}function H(){const J=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&C(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&C(i.charCodeAt(n)))for(n++;n<i.length&&C(i.charCodeAt(n));)n++;else return c=3,i.substring(J,n);let B=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&C(i.charCodeAt(n))){for(n++;n<i.length&&C(i.charCodeAt(n));)n++;B=n}else c=3;return i.substring(J,B)}function re(){let J="",B=n;for(;;){if(n>=s){J+=i.substring(B,n),c=2;break}const x=i.charCodeAt(n);if(x===34){J+=i.substring(B,n),n++;break}if(x===92){if(J+=i.substring(B,n),n++,n>=s){c=2;break}switch(i.charCodeAt(n++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const j=D(4);j>=0?J+=String.fromCharCode(j):c=4;break}default:c=5}B=n;continue}if(x>=0&&x<=31)if(E(x)){J+=i.substring(B,n),c=2;break}else c=6;n++}return J}function ce(){if(a="",c=0,f=n,n>=s)return f=s,o=17;let J=i.charCodeAt(n);if(b(J)){do n++,a+=String.fromCharCode(J),J=i.charCodeAt(n);while(b(J));return o=15}if(E(J))return n++,a+=String.fromCharCode(J),J===13&&i.charCodeAt(n)===10&&(n++,a+=`
`),o=14;switch(J){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,a=re(),o=10;case 47:{const B=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!E(i.charCodeAt(n));)n++;return a=i.substring(B,n),o=12}if(i.charCodeAt(n+1)===42){n+=2;const x=s-1;let z=!1;for(;n<x;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,z=!0;break}n++}return z||(n++,c=1),a=i.substring(B,n),o=13}return a+=String.fromCharCode(J),n++,o=16}case 45:if(a+=String.fromCharCode(J),n++,n===s||!C(i.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=H(),o=11;default:for(;n<s&&ae(J);)n++,J=i.charCodeAt(n);if(f!==n){switch(a=i.substring(f,n),a){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return a+=String.fromCharCode(J),n++,o=16}}function ae(J){if(b(J)||E(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let J;do J=ce();while(J>=12&&J<=15);return J}return{setPosition:O,getPosition:()=>n,scan:r?N:ce,getToken:()=>o,getTokenValue:()=>a,getTokenOffset:()=>f,getTokenLength:()=>n-f,getTokenError:()=>c}}e.createScanner=k;function b(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function C(i){return i>=48&&i<=57}var T;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(T||(T={}));function R(i,r){const n=[],s=new Object;let a;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function c(D,O,H,re){f.value=D,f.offset=O,f.length=H,f.type=re,f.colonOffset=void 0,a=f}try{u(i,{onObjectBegin:(D,O)=>{if(r<=D)throw s;a=void 0,o=r>D,n.push("")},onObjectProperty:(D,O,H)=>{if(r<O||(c(D,O,H,"property"),n[n.length-1]=D,r<=O+H))throw s},onObjectEnd:(D,O)=>{if(r<=D)throw s;a=void 0,n.pop()},onArrayBegin:(D,O)=>{if(r<=D)throw s;a=void 0,n.push(0)},onArrayEnd:(D,O)=>{if(r<=D)throw s;a=void 0,n.pop()},onLiteralValue:(D,O,H)=>{if(r<O||(c(D,O,H,h(D)),r<=O+H))throw s},onSeparator:(D,O,H)=>{if(r<=O)throw s;if(D===":"&&a&&a.type==="property")a.colonOffset=O,o=!1,a=void 0;else if(D===","){const re=n[n.length-1];typeof re=="number"?n[n.length-1]=re+1:(o=!0,n[n.length-1]=""),a=void 0}}})}catch(D){if(D!==s)throw D}return{path:n,previousNode:a,isAtPropertyKey:o,matches:D=>{let O=0;for(let H=0;O<D.length&&H<n.length;H++)if(D[O]===n[H]||D[O]==="*")O++;else if(D[O]!=="**")return!1;return O===D.length}}}e.getLocation=R;function S(i,r=[],n=I.DEFAULT){let s=null,a=[];const f=[];function o(D){Array.isArray(a)?a.push(D):s!==null&&(a[s]=D)}return u(i,{onObjectBegin:()=>{const D={};o(D),f.push(a),a=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const D=[];o(D),f.push(a),a=D,s=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:o,onError:(D,O,H)=>{r.push({error:D,offset:O,length:H})}},n),a[0]}e.parse=S;function w(i,r=[],n=I.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(D){s.type==="property"&&(s.length=D-s.offset,s=s.parent)}function f(D){return s.children.push(D),D}u(i,{onObjectBegin:D=>{s=f({type:"object",offset:D,length:-1,parent:s,children:[]})},onObjectProperty:(D,O,H)=>{s=f({type:"property",offset:O,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:D,offset:O,length:H,parent:s})},onObjectEnd:(D,O)=>{s.length=D+O-s.offset,s=s.parent,a(D+O)},onArrayBegin:(D,O)=>{s=f({type:"array",offset:D,length:-1,parent:s,children:[]})},onArrayEnd:(D,O)=>{s.length=D+O-s.offset,s=s.parent,a(D+O)},onLiteralValue:(D,O,H)=>{f({type:h(D),offset:O,length:H,parent:s,value:D}),a(O+H)},onSeparator:(D,O,H)=>{s.type==="property"&&(D===":"?s.colonOffset=O:D===","&&a(O))},onError:(D,O,H)=>{r.push({error:D,offset:O,length:H})}},n);const c=s.children[0];return c&&delete c.parent,c}e.parseTree=w;function d(i,r){if(!i)return;let n=i;for(const s of r)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const f of n.children)if(Array.isArray(f.children)&&f.children[0].value===s){n=f.children[1],a=!0;break}if(!a)return}else{const a=s;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}e.findNodeAtLocation=d;function g(i){if(!i.parent||!i.parent.children)return[];const r=g(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;r.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&r.push(n)}return r}e.getNodePath=g;function p(i){switch(i.type){case"array":return i.children.map(p);case"object":{const r=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(r[n.children[0].value]=p(s))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=p;function m(i,r,n=!1){return r>=i.offset&&r<i.offset+i.length||n&&r===i.offset+i.length}e.contains=m;function v(i,r,n=!1){if(m(i,r,n)){const s=i.children;if(Array.isArray(s))for(let a=0;a<s.length&&s[a].offset<=r;a++){const f=v(s[a],r,n);if(f)return f}return i}}e.findNodeAtOffset=v;function u(i,r,n=I.DEFAULT){const s=k(i,!1);function a(ee){return ee?()=>ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function f(ee){return ee?te=>ee(te,s.getTokenOffset(),s.getTokenLength()):()=>!0}const o=a(r.onObjectBegin),c=f(r.onObjectProperty),D=a(r.onObjectEnd),O=a(r.onArrayBegin),H=a(r.onArrayEnd),re=f(r.onLiteralValue),ce=f(r.onSeparator),ae=a(r.onComment),N=f(r.onError),J=n&&n.disallowComments,B=n&&n.allowTrailingComma;function x(){for(;;){const ee=s.scan();switch(s.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:J||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ee){case 12:case 13:J?z(10):ae();break;case 16:z(1);break;case 15:case 14:break;default:return ee}}}function z(ee,te=[],_=[]){if(N(ee),te.length+_.length>0){let U=s.getToken();for(;U!==17;){if(te.indexOf(U)!==-1){x();break}else if(_.indexOf(U)!==-1)break;U=x()}}}function j(ee){const te=s.getTokenValue();return ee?re(te):c(te),x(),!0}function L(){switch(s.getToken()){case 11:{let ee=0;try{ee=JSON.parse(s.getTokenValue()),typeof ee!="number"&&(z(2),ee=0)}catch{z(2)}re(ee);break}case 7:re(null);break;case 8:re(!0);break;case 9:re(!1);break;default:return!1}return x(),!0}function F(){return s.getToken()!==10?(z(3,[],[2,5]),!1):(j(!1),s.getToken()===6?(ce(":"),x(),fe()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function G(){o(),x();let ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ee||z(4,[],[]),ce(","),x(),s.getToken()===2&&B)break}else ee&&z(6,[],[]);F()||z(4,[],[2,5]),ee=!0}return D(),s.getToken()!==2?z(7,[2],[]):x(),!0}function oe(){O(),x();let ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ee||z(4,[],[]),ce(","),x(),s.getToken()===4&&B)break}else ee&&z(6,[],[]);fe()||z(4,[],[4,5]),ee=!0}return H(),s.getToken()!==4?z(8,[4],[]):x(),!0}function fe(){switch(s.getToken()){case 3:return oe();case 1:return G();case 10:return j(!0);default:return L()}}return x(),s.getToken()===17?n.allowEmptyContent?!0:(z(4,[],[]),!1):fe()?(s.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=u;function l(i,r){const n=k(i),s=[];let a,f=0,o;do switch(o=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:f!==o&&s.push(i.substring(f,o)),r!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,r)),f=n.getPosition();break}while(a!==17);return s.join("")}e.stripComments=l;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(we[137],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class y{constructor(P){this.executor=P,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(P){return new y(()=>P(this.getValue()))}}e.Lazy=y}),define(we[2],ye([1,0,66,55]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const P=!1;let I=null;function k(f){I=f}if(e.setDisposableTracker=k,P){const f="__is_disposable_tracked__";k(new class{trackDisposable(o){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[f]||console.log(c)},3e3)}setParent(o,c){if(o&&o!==v.None)try{o[f]=!0}catch{}}markAsDisposed(o){if(o&&o!==v.None)try{o[f]=!0}catch{}}markAsSingleton(o){}})}function b(f){return I?.trackDisposable(f),f}function E(f){I?.markAsDisposed(f)}function C(f,o){I?.setParent(f,o)}function T(f,o){if(!!I)for(const c of f)I.setParent(c,o)}function R(f){return I?.markAsSingleton(f),f}e.markAsSingleton=R;function S(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=S;function w(f){if(t.Iterable.is(f)){const o=[];for(const c of f)if(c)try{c.dispose()}catch(D){o.push(D)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}e.dispose=w;function d(f){for(const o of f)S(o)&&o.dispose();return[]}e.disposeIfDisposable=d;function g(...f){const o=p(()=>w(f));return T(f,o),o}e.combinedDisposable=g;function p(f){const o=b({dispose:(0,y.once)(()=>{E(o),f()})});return o}e.toDisposable=p;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{w(this._toDispose)}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return C(o,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new m,b(this),C(this._store,this)}dispose(){E(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&C(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&C(o,null),o}}e.MutableDisposable=u;class l{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class h{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(o){let c=o;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,E(this))},this}}e.SafeDisposable=h;class i{constructor(){this.references=new Map}acquire(o,...c){let D=this.references.get(o);D||(D={counter:0,object:this.createReferencedObject(o,...c)},this.references.set(o,D));const{object:O}=D,H=(0,y.once)(()=>{--D.counter===0&&(this.destroyReferencedObject(o,D.object),this.references.delete(o))});return D.counter++,{object:O,dispose:H}}}e.ReferenceCollection=i;class r{constructor(o){this.referenceCollection=o}async acquire(o,...c){const D=this.referenceCollection.acquire(o,...c);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(O){throw D.dispose(),O}}}e.AsyncReferenceCollection=r;class n{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=n;function s(f){const o=new m;try{f(o)}finally{o.dispose()}}e.disposeOnReturn=s;class a{constructor(){this._store=new Map,this._isDisposed=!1,b(this)}dispose(){E(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{w(this._store.values())}finally{this._store.clear()}}has(o){return this._store.has(o)}get(o){return this._store.get(o)}set(o,c,D=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this._store.get(o)?.dispose(),this._store.set(o,c)}deleteAndDispose(o){this._store.get(o)?.dispose(),this._store.delete(o)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=a}),define(we[86],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(I){this.element=I,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class t{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let I=this._first;for(;I!==y.Undefined;){const k=I.next;I.prev=y.Undefined,I.next=y.Undefined,I=k}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,k){const b=new y(I);if(this._first===y.Undefined)this._first=b,this._last=b;else if(k){const C=this._last;this._last=b,b.prev=C,C.next=b}else{const C=this._first;this._first=b,b.next=C,C.prev=b}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(b))}}shift(){if(this._first!==y.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==y.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==y.Undefined&&I.next!==y.Undefined){const k=I.prev;k.next=I.next,I.next.prev=k}else I.prev===y.Undefined&&I.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):I.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):I.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==y.Undefined;)yield I.element,I=I.next}}e.LinkedList=t}),define(we[31],ye([1,0]),function(se,e){"use strict";var y,t,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function I(d,g,p){let m=d.get(g);return m===void 0&&(m=p,d.set(g,m)),m}e.getOrSet=I;function k(d){const g=[];return d.forEach((p,m)=>{g.push(`${m} => ${p}`)}),`Map(${d.size}) {${g.join(", ")}}`}e.mapToString=k;function b(d){const g=[];return d.forEach(p=>{g.push(p)}),`Set(${d.size}) {${g.join(", ")}}`}e.setToString=b;class E{constructor(g,p){this.uri=g,this.value=p}}class C{constructor(g,p){this[y]="ResourceMap",g instanceof C?(this.map=new Map(g.map),this.toKey=p??C.defaultToKey):(this.map=new Map,this.toKey=g??C.defaultToKey)}set(g,p){return this.map.set(this.toKey(g),new E(g,p)),this}get(g){return this.map.get(this.toKey(g))?.value}has(g){return this.map.has(this.toKey(g))}get size(){return this.map.size}clear(){this.map.clear()}delete(g){return this.map.delete(this.toKey(g))}forEach(g,p){typeof p<"u"&&(g=g.bind(p));for(const[m,v]of this.map)g(v.value,v.uri,this)}*values(){for(const g of this.map.values())yield g.value}*keys(){for(const g of this.map.values())yield g.uri}*entries(){for(const g of this.map.values())yield[g.uri,g.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,g]of this.map)yield[g.uri,g.value]}}e.ResourceMap=C,C.defaultToKey=d=>d.toString();class T{constructor(g,p){this[t]="ResourceSet",!g||typeof g=="function"?this._map=new C(g):(this._map=new C(p),g.forEach(this.add,this))}get size(){return this._map.size}add(g){return this._map.set(g,g),this}clear(){this._map.clear()}delete(g){return this._map.delete(g)}forEach(g,p){this._map.forEach((m,v)=>g.call(p,v,v,this))}has(g){return this._map.has(g)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=T;var R;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(R=e.Touch||(e.Touch={}));class S{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(g){return this._map.has(g)}get(g,p=0){const m=this._map.get(g);if(!!m)return p!==0&&this.touch(m,p),m.value}set(g,p,m=0){let v=this._map.get(g);if(v)v.value=p,m!==0&&this.touch(v,m);else{switch(v={key:g,value:p,next:void 0,previous:void 0},m){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(g,v),this._size++}return this}delete(g){return!!this.remove(g)}remove(g){const p=this._map.get(g);if(!!p)return this._map.delete(g),this.removeItem(p),this._size--,p.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const g=this._head;return this._map.delete(g.key),this.removeItem(g),this._size--,g.value}forEach(g,p){const m=this._state;let v=this._head;for(;v;){if(p?g.bind(p)(v.value,v.key,this):g(v.value,v.key,this),this._state!==m)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const g=this,p=this._state;let m=this._head;const v={[Symbol.iterator](){return v},next(){if(g._state!==p)throw new Error("LinkedMap got modified during iteration.");if(m){const u={value:m.key,done:!1};return m=m.next,u}else return{value:void 0,done:!0}}};return v}values(){const g=this,p=this._state;let m=this._head;const v={[Symbol.iterator](){return v},next(){if(g._state!==p)throw new Error("LinkedMap got modified during iteration.");if(m){const u={value:m.value,done:!1};return m=m.next,u}else return{value:void 0,done:!0}}};return v}entries(){const g=this,p=this._state;let m=this._head;const v={[Symbol.iterator](){return v},next(){if(g._state!==p)throw new Error("LinkedMap got modified during iteration.");if(m){const u={value:[m.key,m.value],done:!1};return m=m.next,u}else return{value:void 0,done:!0}}};return v}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(g){if(g>=this.size)return;if(g===0){this.clear();return}let p=this._head,m=this.size;for(;p&&m>g;)this._map.delete(p.key),p=p.next,m--;this._head=p,this._size=m,p&&(p.previous=void 0),this._state++}addItemFirst(g){if(!this._head&&!this._tail)this._tail=g;else if(this._head)g.next=this._head,this._head.previous=g;else throw new Error("Invalid list");this._head=g,this._state++}addItemLast(g){if(!this._head&&!this._tail)this._head=g;else if(this._tail)g.previous=this._tail,this._tail.next=g;else throw new Error("Invalid list");this._tail=g,this._state++}removeItem(g){if(g===this._head&&g===this._tail)this._head=void 0,this._tail=void 0;else if(g===this._head){if(!g.next)throw new Error("Invalid list");g.next.previous=void 0,this._head=g.next}else if(g===this._tail){if(!g.previous)throw new Error("Invalid list");g.previous.next=void 0,this._tail=g.previous}else{const p=g.next,m=g.previous;if(!p||!m)throw new Error("Invalid list");p.previous=m,m.next=p}g.next=void 0,g.previous=void 0,this._state++}touch(g,p){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(g===this._head)return;const m=g.next,v=g.previous;g===this._tail?(v.next=void 0,this._tail=v):(m.previous=v,v.next=m),g.previous=void 0,g.next=this._head,this._head.previous=g,this._head=g,this._state++}else if(p===2){if(g===this._tail)return;const m=g.next,v=g.previous;g===this._head?(m.previous=void 0,this._head=m):(m.previous=v,v.next=m),g.next=void 0,g.previous=this._tail,this._tail.next=g,this._tail=g,this._state++}}}toJSON(){const g=[];return this.forEach((p,m)=>{g.push([m,p])}),g}fromJSON(g){this.clear();for(const[p,m]of g)this.set(p,m)}}e.LinkedMap=S;class w extends S{constructor(g,p=1){super(),this._limit=g,this._ratio=Math.min(Math.max(0,p),1)}get limit(){return this._limit}set limit(g){this._limit=g,this.checkTrim()}get ratio(){return this._ratio}set ratio(g){this._ratio=Math.min(Math.max(0,g),1),this.checkTrim()}get(g,p=2){return super.get(g,p)}peek(g){return super.get(g,0)}set(g,p){return super.set(g,p,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=w}),function(se,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(we[138],ye([0]),e):(se=typeof globalThis<"u"?globalThis:se||self,e(se.marked={}))}(this,function(se){"use strict";function e($,Q){for(var Y=0;Y<Q.length;Y++){var W=Q[Y];W.enumerable=W.enumerable||!1,W.configurable=!0,"value"in W&&(W.writable=!0),Object.defineProperty($,W.key,W)}}function y($,Q,Y){return Q&&e($.prototype,Q),Y&&e($,Y),Object.defineProperty($,"prototype",{writable:!1}),$}function t($,Q){if(!!$){if(typeof $=="string")return P($,Q);var Y=Object.prototype.toString.call($).slice(8,-1);if(Y==="Object"&&$.constructor&&(Y=$.constructor.name),Y==="Map"||Y==="Set")return Array.from($);if(Y==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Y))return P($,Q)}}function P($,Q){(Q==null||Q>$.length)&&(Q=$.length);for(var Y=0,W=new Array(Q);Y<Q;Y++)W[Y]=$[Y];return W}function I($,Q){var Y=typeof Symbol<"u"&&$[Symbol.iterator]||$["@@iterator"];if(Y)return(Y=Y.call($)).next.bind(Y);if(Array.isArray($)||(Y=t($))||Q&&$&&typeof $.length=="number"){Y&&($=Y);var W=0;return function(){return W>=$.length?{done:!0}:{done:!1,value:$[W++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=k();function b($){se.defaults=$}var E=/[&<>"']/,C=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(Q){return S[Q]};function d($,Q){if(Q){if(E.test($))return $.replace(C,w)}else if(T.test($))return $.replace(R,w);return $}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p($){return $.replace(g,function(Q,Y){return Y=Y.toLowerCase(),Y==="colon"?":":Y.charAt(0)==="#"?Y.charAt(1)==="x"?String.fromCharCode(parseInt(Y.substring(2),16)):String.fromCharCode(+Y.substring(1)):""})}var m=/(^|[^\[])\^/g;function v($,Q){$=typeof $=="string"?$:$.source,Q=Q||"";var Y={replace:function(V,q){return q=q.source||q,q=q.replace(m,"$1"),$=$.replace(V,q),Y},getRegex:function(){return new RegExp($,Q)}};return Y}var u=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h($,Q,Y){if($){var W;try{W=decodeURIComponent(p(Y)).replace(u,"").toLowerCase()}catch{return null}if(W.indexOf("javascript:")===0||W.indexOf("vbscript:")===0||W.indexOf("data:")===0)return null}Q&&!l.test(Y)&&(Y=a(Q,Y));try{Y=encodeURI(Y).replace(/%25/g,"%")}catch{return null}return Y}var i={},r=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a($,Q){i[" "+$]||(r.test($)?i[" "+$]=$+"/":i[" "+$]=D($,"/",!0)),$=i[" "+$];var Y=$.indexOf(":")===-1;return Q.substring(0,2)==="//"?Y?Q:$.replace(n,"$1")+Q:Q.charAt(0)==="/"?Y?Q:$.replace(s,"$1")+Q:$+Q}var f={exec:function(){}};function o($){for(var Q=1,Y,W;Q<arguments.length;Q++){Y=arguments[Q];for(W in Y)Object.prototype.hasOwnProperty.call(Y,W)&&($[W]=Y[W])}return $}function c($,Q){var Y=$.replace(/\|/g,function(q,X,le){for(var pe=!1,ke=X;--ke>=0&&le[ke]==="\\";)pe=!pe;return pe?"|":" |"}),W=Y.split(/ \|/),V=0;if(W[0].trim()||W.shift(),W.length>0&&!W[W.length-1].trim()&&W.pop(),W.length>Q)W.splice(Q);else for(;W.length<Q;)W.push("");for(;V<W.length;V++)W[V]=W[V].trim().replace(/\\\|/g,"|");return W}function D($,Q,Y){var W=$.length;if(W===0)return"";for(var V=0;V<W;){var q=$.charAt(W-V-1);if(q===Q&&!Y)V++;else if(q!==Q&&Y)V++;else break}return $.slice(0,W-V)}function O($,Q){if($.indexOf(Q[1])===-1)return-1;for(var Y=$.length,W=0,V=0;V<Y;V++)if($[V]==="\\")V++;else if($[V]===Q[0])W++;else if($[V]===Q[1]&&(W--,W<0))return V;return-1}function H($){$&&$.sanitize&&!$.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function re($,Q){if(Q<1)return"";for(var Y="";Q>1;)Q&1&&(Y+=$),Q>>=1,$+=$;return Y+$}function ce($,Q,Y,W){var V=Q.href,q=Q.title?d(Q.title):null,X=$[1].replace(/\\([\[\]])/g,"$1");if($[0].charAt(0)!=="!"){W.state.inLink=!0;var le={type:"link",raw:Y,href:V,title:q,text:X,tokens:W.inlineTokens(X)};return W.state.inLink=!1,le}return{type:"image",raw:Y,href:V,title:q,text:d(X)}}function ae($,Q){var Y=$.match(/^(\s+)(?:```)/);if(Y===null)return Q;var W=Y[1];return Q.split(`
`).map(function(V){var q=V.match(/^\s+/);if(q===null)return V;var X=q[0];return X.length>=W.length?V.slice(W.length):V}).join(`
`)}var N=function(){function $(Y){this.options=Y||se.defaults}var Q=$.prototype;return Q.space=function(W){var V=this.rules.block.newline.exec(W);if(V&&V[0].length>0)return{type:"space",raw:V[0]}},Q.code=function(W){var V=this.rules.block.code.exec(W);if(V){var q=V[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:V[0],codeBlockStyle:"indented",text:this.options.pedantic?q:D(q,`
`)}}},Q.fences=function(W){var V=this.rules.block.fences.exec(W);if(V){var q=V[0],X=ae(q,V[3]||"");return{type:"code",raw:q,lang:V[2]?V[2].trim():V[2],text:X}}},Q.heading=function(W){var V=this.rules.block.heading.exec(W);if(V){var q=V[2].trim();if(/#$/.test(q)){var X=D(q,"#");(this.options.pedantic||!X||/ $/.test(X))&&(q=X.trim())}return{type:"heading",raw:V[0],depth:V[1].length,text:q,tokens:this.lexer.inline(q)}}},Q.hr=function(W){var V=this.rules.block.hr.exec(W);if(V)return{type:"hr",raw:V[0]}},Q.blockquote=function(W){var V=this.rules.block.blockquote.exec(W);if(V){var q=V[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:V[0],tokens:this.lexer.blockTokens(q,[]),text:q}}},Q.list=function(W){var V=this.rules.block.list.exec(W);if(V){var q,X,le,pe,ke,Te,Me,Oe,me,be,Ee,Ne,Be=V[1].trim(),Ke=Be.length>1,He={type:"list",raw:"",ordered:Ke,start:Ke?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ke?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ke?Be:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");W&&(Ne=!1,!(!(V=Ge.exec(W))||this.rules.block.hr.test(W)));){if(q=V[0],W=W.substring(q.length),Oe=V[2].split(`
`,1)[0],me=W.split(`
`,1)[0],this.options.pedantic?(pe=2,Ee=Oe.trimLeft()):(pe=V[2].search(/[^ ]/),pe=pe>4?1:pe,Ee=Oe.slice(pe),pe+=V[1].length),Te=!1,!Oe&&/^ *$/.test(me)&&(q+=me+`
`,W=W.substring(me.length+1),Ne=!0),!Ne)for(var Xe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),qe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),$e=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");W&&(be=W.split(`
`,1)[0],Oe=be,this.options.pedantic&&(Oe=Oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(qe.test(Oe)||$e.test(Oe)||Xe.test(Oe)||et.test(W)));){if(Oe.search(/[^ ]/)>=pe||!Oe.trim())Ee+=`
`+Oe.slice(pe);else if(!Te)Ee+=`
`+Oe;else break;!Te&&!Oe.trim()&&(Te=!0),q+=be+`
`,W=W.substring(be.length+1)}He.loose||(Me?He.loose=!0:/\n *\n *$/.test(q)&&(Me=!0)),this.options.gfm&&(X=/^\[[ xX]\] /.exec(Ee),X&&(le=X[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:q,task:!!X,checked:le,loose:!1,text:Ee}),He.raw+=q}He.items[He.items.length-1].raw=q.trimRight(),He.items[He.items.length-1].text=Ee.trimRight(),He.raw=He.raw.trimRight();var xe=He.items.length;for(ke=0;ke<xe;ke++){this.lexer.state.top=!1,He.items[ke].tokens=this.lexer.blockTokens(He.items[ke].text,[]);var he=He.items[ke].tokens.filter(function(De){return De.type==="space"}),Ce=he.every(function(De){for(var Re=De.raw.split(""),Fe=0,ze=I(Re),je;!(je=ze()).done;){var rt=je.value;if(rt===`
`&&(Fe+=1),Fe>1)return!0}return!1});!He.loose&&he.length&&Ce&&(He.loose=!0,He.items[ke].loose=!0)}return He}},Q.html=function(W){var V=this.rules.block.html.exec(W);if(V){var q={type:"html",raw:V[0],pre:!this.options.sanitizer&&(V[1]==="pre"||V[1]==="script"||V[1]==="style"),text:V[0]};if(this.options.sanitize){var X=this.options.sanitizer?this.options.sanitizer(V[0]):d(V[0]);q.type="paragraph",q.text=X,q.tokens=this.lexer.inline(X)}return q}},Q.def=function(W){var V=this.rules.block.def.exec(W);if(V){V[3]&&(V[3]=V[3].substring(1,V[3].length-1));var q=V[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:q,raw:V[0],href:V[2],title:V[3]}}},Q.table=function(W){var V=this.rules.block.table.exec(W);if(V){var q={type:"table",header:c(V[1]).map(function(Me){return{text:Me}}),align:V[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:V[3]&&V[3].trim()?V[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(q.header.length===q.align.length){q.raw=V[0];var X=q.align.length,le,pe,ke,Te;for(le=0;le<X;le++)/^ *-+: *$/.test(q.align[le])?q.align[le]="right":/^ *:-+: *$/.test(q.align[le])?q.align[le]="center":/^ *:-+ *$/.test(q.align[le])?q.align[le]="left":q.align[le]=null;for(X=q.rows.length,le=0;le<X;le++)q.rows[le]=c(q.rows[le],q.header.length).map(function(Me){return{text:Me}});for(X=q.header.length,pe=0;pe<X;pe++)q.header[pe].tokens=this.lexer.inline(q.header[pe].text);for(X=q.rows.length,pe=0;pe<X;pe++)for(Te=q.rows[pe],ke=0;ke<Te.length;ke++)Te[ke].tokens=this.lexer.inline(Te[ke].text);return q}}},Q.lheading=function(W){var V=this.rules.block.lheading.exec(W);if(V)return{type:"heading",raw:V[0],depth:V[2].charAt(0)==="="?1:2,text:V[1],tokens:this.lexer.inline(V[1])}},Q.paragraph=function(W){var V=this.rules.block.paragraph.exec(W);if(V){var q=V[1].charAt(V[1].length-1)===`
`?V[1].slice(0,-1):V[1];return{type:"paragraph",raw:V[0],text:q,tokens:this.lexer.inline(q)}}},Q.text=function(W){var V=this.rules.block.text.exec(W);if(V)return{type:"text",raw:V[0],text:V[0],tokens:this.lexer.inline(V[0])}},Q.escape=function(W){var V=this.rules.inline.escape.exec(W);if(V)return{type:"escape",raw:V[0],text:d(V[1])}},Q.tag=function(W){var V=this.rules.inline.tag.exec(W);if(V)return!this.lexer.state.inLink&&/^<a /i.test(V[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(V[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(V[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(V[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:V[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(V[0]):d(V[0]):V[0]}},Q.link=function(W){var V=this.rules.inline.link.exec(W);if(V){var q=V[2].trim();if(!this.options.pedantic&&/^</.test(q)){if(!/>$/.test(q))return;var X=D(q.slice(0,-1),"\\");if((q.length-X.length)%2===0)return}else{var le=O(V[2],"()");if(le>-1){var pe=V[0].indexOf("!")===0?5:4,ke=pe+V[1].length+le;V[2]=V[2].substring(0,le),V[0]=V[0].substring(0,ke).trim(),V[3]=""}}var Te=V[2],Me="";if(this.options.pedantic){var Oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);Oe&&(Te=Oe[1],Me=Oe[3])}else Me=V[3]?V[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(q)?Te=Te.slice(1):Te=Te.slice(1,-1)),ce(V,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},V[0],this.lexer)}},Q.reflink=function(W,V){var q;if((q=this.rules.inline.reflink.exec(W))||(q=this.rules.inline.nolink.exec(W))){var X=(q[2]||q[1]).replace(/\s+/g," ");if(X=V[X.toLowerCase()],!X||!X.href){var le=q[0].charAt(0);return{type:"text",raw:le,text:le}}return ce(q,X,q[0],this.lexer)}},Q.emStrong=function(W,V,q){q===void 0&&(q="");var X=this.rules.inline.emStrong.lDelim.exec(W);if(!!X&&!(X[3]&&q.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=X[1]||X[2]||"";if(!le||le&&(q===""||this.rules.inline.punctuation.exec(q))){var pe=X[0].length-1,ke,Te,Me=pe,Oe=0,me=X[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,V=V.slice(-1*W.length+pe);(X=me.exec(V))!=null;)if(ke=X[1]||X[2]||X[3]||X[4]||X[5]||X[6],!!ke){if(Te=ke.length,X[3]||X[4]){Me+=Te;continue}else if((X[5]||X[6])&&pe%3&&!((pe+Te)%3)){Oe+=Te;continue}if(Me-=Te,!(Me>0)){if(Te=Math.min(Te,Te+Me+Oe),Math.min(pe,Te)%2){var be=W.slice(1,pe+X.index+Te);return{type:"em",raw:W.slice(0,pe+X.index+Te+1),text:be,tokens:this.lexer.inlineTokens(be)}}var Ee=W.slice(2,pe+X.index+Te-1);return{type:"strong",raw:W.slice(0,pe+X.index+Te+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Q.codespan=function(W){var V=this.rules.inline.code.exec(W);if(V){var q=V[2].replace(/\n/g," "),X=/[^ ]/.test(q),le=/^ /.test(q)&&/ $/.test(q);return X&&le&&(q=q.substring(1,q.length-1)),q=d(q,!0),{type:"codespan",raw:V[0],text:q}}},Q.br=function(W){var V=this.rules.inline.br.exec(W);if(V)return{type:"br",raw:V[0]}},Q.del=function(W){var V=this.rules.inline.del.exec(W);if(V)return{type:"del",raw:V[0],text:V[2],tokens:this.lexer.inlineTokens(V[2])}},Q.autolink=function(W,V){var q=this.rules.inline.autolink.exec(W);if(q){var X,le;return q[2]==="@"?(X=d(this.options.mangle?V(q[1]):q[1]),le="mailto:"+X):(X=d(q[1]),le=X),{type:"link",raw:q[0],text:X,href:le,tokens:[{type:"text",raw:X,text:X}]}}},Q.url=function(W,V){var q;if(q=this.rules.inline.url.exec(W)){var X,le;if(q[2]==="@")X=d(this.options.mangle?V(q[0]):q[0]),le="mailto:"+X;else{var pe;do pe=q[0],q[0]=this.rules.inline._backpedal.exec(q[0])[0];while(pe!==q[0]);X=d(q[0]),q[1]==="www."?le="http://"+X:le=X}return{type:"link",raw:q[0],text:X,href:le,tokens:[{type:"text",raw:X,text:X}]}}},Q.inlineText=function(W,V){var q=this.rules.inline.text.exec(W);if(q){var X;return this.lexer.state.inRawBlock?X=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(q[0]):d(q[0]):q[0]:X=d(this.options.smartypants?V(q[0]):q[0]),{type:"text",raw:q[0],text:X}}},$}(),J={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};J._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,J._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,J.def=v(J.def).replace("label",J._label).replace("title",J._title).getRegex(),J.bullet=/(?:[*+-]|\d{1,9}[.)])/,J.listItemStart=v(/^( *)(bull) */).replace("bull",J.bullet).getRegex(),J.list=v(J.list).replace(/bull/g,J.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+J.def.source+")").getRegex(),J._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",J._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,J.html=v(J.html,"i").replace("comment",J._comment).replace("tag",J._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),J.paragraph=v(J._paragraph).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",J._tag).getRegex(),J.blockquote=v(J.blockquote).replace("paragraph",J.paragraph).getRegex(),J.normal=o({},J),J.gfm=o({},J.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),J.gfm.table=v(J.gfm.table).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",J._tag).getRegex(),J.gfm.paragraph=v(J._paragraph).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",J.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",J._tag).getRegex(),J.pedantic=o({},J.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",J._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:v(J.normal._paragraph).replace("hr",J.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",J.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=v(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=v(J._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=v(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=v(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=v(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=v(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=v(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=v(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=v(B.reflink).replace("label",B._label).replace("ref",J._label).getRegex(),B.nolink=v(B.nolink).replace("ref",J._label).getRegex(),B.reflinkSearch=v(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=o({},B),B.pedantic=o({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=o({},B.normal,{escape:v(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=v(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=o({},B.gfm,{br:v(B.br).replace("{2,}","*").getRegex(),text:v(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function x($){return $.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z($){var Q="",Y,W,V=$.length;for(Y=0;Y<V;Y++)W=$.charCodeAt(Y),Math.random()>.5&&(W="x"+W.toString(16)),Q+="&#"+W+";";return Q}var j=function(){function $(Y){this.tokens=[],this.tokens.links=Object.create(null),this.options=Y||se.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var W={block:J.normal,inline:B.normal};this.options.pedantic?(W.block=J.pedantic,W.inline=B.pedantic):this.options.gfm&&(W.block=J.gfm,this.options.breaks?W.inline=B.breaks:W.inline=B.gfm),this.tokenizer.rules=W}$.lex=function(W,V){var q=new $(V);return q.lex(W)},$.lexInline=function(W,V){var q=new $(V);return q.inlineTokens(W)};var Q=$.prototype;return Q.lex=function(W){W=W.replace(/\r\n|\r/g,`
`),this.blockTokens(W,this.tokens);for(var V;V=this.inlineQueue.shift();)this.inlineTokens(V.src,V.tokens);return this.tokens},Q.blockTokens=function(W,V){var q=this;V===void 0&&(V=[]),this.options.pedantic?W=W.replace(/\t/g,"    ").replace(/^ +$/gm,""):W=W.replace(/^( *)(\t+)/gm,function(Me,Oe,me){return Oe+"    ".repeat(me.length)});for(var X,le,pe,ke;W;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(X=Me.call({lexer:q},W,V))?(W=W.substring(X.raw.length),V.push(X),!0):!1}))){if(X=this.tokenizer.space(W)){W=W.substring(X.raw.length),X.raw.length===1&&V.length>0?V[V.length-1].raw+=`
`:V.push(X);continue}if(X=this.tokenizer.code(W)){W=W.substring(X.raw.length),le=V[V.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+X.raw,le.text+=`
`+X.text,this.inlineQueue[this.inlineQueue.length-1].src=le.text):V.push(X);continue}if(X=this.tokenizer.fences(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.heading(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.hr(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.blockquote(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.list(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.html(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.def(W)){W=W.substring(X.raw.length),le=V[V.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+X.raw,le.text+=`
`+X.raw,this.inlineQueue[this.inlineQueue.length-1].src=le.text):this.tokens.links[X.tag]||(this.tokens.links[X.tag]={href:X.href,title:X.title});continue}if(X=this.tokenizer.table(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.lheading(W)){W=W.substring(X.raw.length),V.push(X);continue}if(pe=W,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,Oe=W.slice(1),me=void 0;q.options.extensions.startBlock.forEach(function(be){me=be.call({lexer:this},Oe),typeof me=="number"&&me>=0&&(Me=Math.min(Me,me))}),Me<1/0&&Me>=0&&(pe=W.substring(0,Me+1))}(),this.state.top&&(X=this.tokenizer.paragraph(pe))){le=V[V.length-1],ke&&le.type==="paragraph"?(le.raw+=`
`+X.raw,le.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):V.push(X),ke=pe.length!==W.length,W=W.substring(X.raw.length);continue}if(X=this.tokenizer.text(W)){W=W.substring(X.raw.length),le=V[V.length-1],le&&le.type==="text"?(le.raw+=`
`+X.raw,le.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):V.push(X);continue}if(W){var Te="Infinite loop on byte: "+W.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return this.state.top=!0,V},Q.inline=function(W,V){return V===void 0&&(V=[]),this.inlineQueue.push({src:W,tokens:V}),V},Q.inlineTokens=function(W,V){var q=this;V===void 0&&(V=[]);var X,le,pe,ke=W,Te,Me,Oe;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)me.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Te.index)+"["+re("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"["+re("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;W;)if(Me||(Oe=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(X=Ee.call({lexer:q},W,V))?(W=W.substring(X.raw.length),V.push(X),!0):!1}))){if(X=this.tokenizer.escape(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.tag(W)){W=W.substring(X.raw.length),le=V[V.length-1],le&&X.type==="text"&&le.type==="text"?(le.raw+=X.raw,le.text+=X.text):V.push(X);continue}if(X=this.tokenizer.link(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.reflink(W,this.tokens.links)){W=W.substring(X.raw.length),le=V[V.length-1],le&&X.type==="text"&&le.type==="text"?(le.raw+=X.raw,le.text+=X.text):V.push(X);continue}if(X=this.tokenizer.emStrong(W,ke,Oe)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.codespan(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.br(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.del(W)){W=W.substring(X.raw.length),V.push(X);continue}if(X=this.tokenizer.autolink(W,z)){W=W.substring(X.raw.length),V.push(X);continue}if(!this.state.inLink&&(X=this.tokenizer.url(W,z))){W=W.substring(X.raw.length),V.push(X);continue}if(pe=W,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,Ne=W.slice(1),Be=void 0;q.options.extensions.startInline.forEach(function(Ke){Be=Ke.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(Ee=Math.min(Ee,Be))}),Ee<1/0&&Ee>=0&&(pe=W.substring(0,Ee+1))}(),X=this.tokenizer.inlineText(pe,x)){W=W.substring(X.raw.length),X.raw.slice(-1)!=="_"&&(Oe=X.raw.slice(-1)),Me=!0,le=V[V.length-1],le&&le.type==="text"?(le.raw+=X.raw,le.text+=X.text):V.push(X);continue}if(W){var be="Infinite loop on byte: "+W.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return V},y($,null,[{key:"rules",get:function(){return{block:J,inline:B}}}]),$}(),L=function(){function $(Y){this.options=Y||se.defaults}var Q=$.prototype;return Q.code=function(W,V,q){var X=(V||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(W,X);le!=null&&le!==W&&(q=!0,W=le)}return W=W.replace(/\n$/,"")+`
`,X?'<pre><code class="'+this.options.langPrefix+d(X,!0)+'">'+(q?W:d(W,!0))+`</code></pre>
`:"<pre><code>"+(q?W:d(W,!0))+`</code></pre>
`},Q.blockquote=function(W){return`<blockquote>
`+W+`</blockquote>
`},Q.html=function(W){return W},Q.heading=function(W,V,q,X){if(this.options.headerIds){var le=this.options.headerPrefix+X.slug(q);return"<h"+V+' id="'+le+'">'+W+"</h"+V+`>
`}return"<h"+V+">"+W+"</h"+V+`>
`},Q.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Q.list=function(W,V,q){var X=V?"ol":"ul",le=V&&q!==1?' start="'+q+'"':"";return"<"+X+le+`>
`+W+"</"+X+`>
`},Q.listitem=function(W){return"<li>"+W+`</li>
`},Q.checkbox=function(W){return"<input "+(W?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Q.paragraph=function(W){return"<p>"+W+`</p>
`},Q.table=function(W,V){return V&&(V="<tbody>"+V+"</tbody>"),`<table>
<thead>
`+W+`</thead>
`+V+`</table>
`},Q.tablerow=function(W){return`<tr>
`+W+`</tr>
`},Q.tablecell=function(W,V){var q=V.header?"th":"td",X=V.align?"<"+q+' align="'+V.align+'">':"<"+q+">";return X+W+("</"+q+`>
`)},Q.strong=function(W){return"<strong>"+W+"</strong>"},Q.em=function(W){return"<em>"+W+"</em>"},Q.codespan=function(W){return"<code>"+W+"</code>"},Q.br=function(){return this.options.xhtml?"<br/>":"<br>"},Q.del=function(W){return"<del>"+W+"</del>"},Q.link=function(W,V,q){if(W=h(this.options.sanitize,this.options.baseUrl,W),W===null)return q;var X='<a href="'+d(W)+'"';return V&&(X+=' title="'+V+'"'),X+=">"+q+"</a>",X},Q.image=function(W,V,q){if(W=h(this.options.sanitize,this.options.baseUrl,W),W===null)return q;var X='<img src="'+W+'" alt="'+q+'"';return V&&(X+=' title="'+V+'"'),X+=this.options.xhtml?"/>":">",X},Q.text=function(W){return W},$}(),F=function(){function $(){}var Q=$.prototype;return Q.strong=function(W){return W},Q.em=function(W){return W},Q.codespan=function(W){return W},Q.del=function(W){return W},Q.html=function(W){return W},Q.text=function(W){return W},Q.link=function(W,V,q){return""+q},Q.image=function(W,V,q){return""+q},Q.br=function(){return""},$}(),G=function(){function $(){this.seen={}}var Q=$.prototype;return Q.serialize=function(W){return W.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Q.getNextSafeSlug=function(W,V){var q=W,X=0;if(this.seen.hasOwnProperty(q)){X=this.seen[W];do X++,q=W+"-"+X;while(this.seen.hasOwnProperty(q))}return V||(this.seen[W]=X,this.seen[q]=0),q},Q.slug=function(W,V){V===void 0&&(V={});var q=this.serialize(W);return this.getNextSafeSlug(q,V.dryrun)},$}(),oe=function(){function $(Y){this.options=Y||se.defaults,this.options.renderer=this.options.renderer||new L,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new F,this.slugger=new G}$.parse=function(W,V){var q=new $(V);return q.parse(W)},$.parseInline=function(W,V){var q=new $(V);return q.parseInline(W)};var Q=$.prototype;return Q.parse=function(W,V){V===void 0&&(V=!0);var q="",X,le,pe,ke,Te,Me,Oe,me,be,Ee,Ne,Be,Ke,He,Ge,Xe,et,qe,$e,xe=W.length;for(X=0;X<xe;X++){if(Ee=W[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&($e=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),$e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){q+=$e||"";continue}switch(Ee.type){case"space":continue;case"hr":{q+=this.renderer.hr();continue}case"heading":{q+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,p(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{q+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(me="",Oe="",ke=Ee.header.length,le=0;le<ke;le++)Oe+=this.renderer.tablecell(this.parseInline(Ee.header[le].tokens),{header:!0,align:Ee.align[le]});for(me+=this.renderer.tablerow(Oe),be="",ke=Ee.rows.length,le=0;le<ke;le++){for(Me=Ee.rows[le],Oe="",Te=Me.length,pe=0;pe<Te;pe++)Oe+=this.renderer.tablecell(this.parseInline(Me[pe].tokens),{header:!1,align:Ee.align[pe]});be+=this.renderer.tablerow(Oe)}q+=this.renderer.table(me,be);continue}case"blockquote":{be=this.parse(Ee.tokens),q+=this.renderer.blockquote(be);continue}case"list":{for(Ne=Ee.ordered,Be=Ee.start,Ke=Ee.loose,ke=Ee.items.length,be="",le=0;le<ke;le++)Ge=Ee.items[le],Xe=Ge.checked,et=Ge.task,He="",Ge.task&&(qe=this.renderer.checkbox(Xe),Ke?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=qe+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=qe+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:qe}):He+=qe),He+=this.parse(Ge.tokens,Ke),be+=this.renderer.listitem(He,et,Xe);q+=this.renderer.list(be,Ne,Be);continue}case"html":{q+=this.renderer.html(Ee.text);continue}case"paragraph":{q+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(be=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;X+1<xe&&W[X+1].type==="text";)Ee=W[++X],be+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);q+=V?this.renderer.paragraph(be):be;continue}default:{var he='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return q},Q.parseInline=function(W,V){V=V||this.renderer;var q="",X,le,pe,ke=W.length;for(X=0;X<ke;X++){if(le=W[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(pe=this.options.extensions.renderers[le.type].call({parser:this},le),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(le.type))){q+=pe||"";continue}switch(le.type){case"escape":{q+=V.text(le.text);break}case"html":{q+=V.html(le.text);break}case"link":{q+=V.link(le.href,le.title,this.parseInline(le.tokens,V));break}case"image":{q+=V.image(le.href,le.title,le.text);break}case"strong":{q+=V.strong(this.parseInline(le.tokens,V));break}case"em":{q+=V.em(this.parseInline(le.tokens,V));break}case"codespan":{q+=V.codespan(le.text);break}case"br":{q+=V.br();break}case"del":{q+=V.del(this.parseInline(le.tokens,V));break}case"text":{q+=V.text(le.text);break}default:{var Te='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return q},$}();function fe($,Q,Y){if(typeof $>"u"||$===null)throw new Error("marked(): input parameter is undefined or null");if(typeof $!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call($)+", string expected");if(typeof Q=="function"&&(Y=Q,Q=null),Q=o({},fe.defaults,Q||{}),H(Q),Y){var W=Q.highlight,V;try{V=j.lex($,Q)}catch(ke){return Y(ke)}var q=function(Te){var Me;if(!Te)try{Q.walkTokens&&fe.walkTokens(V,Q.walkTokens),Me=oe.parse(V,Q)}catch(Oe){Te=Oe}return Q.highlight=W,Te?Y(Te):Y(null,Me)};if(!W||W.length<3||(delete Q.highlight,!V.length))return q();var X=0;fe.walkTokens(V,function(ke){ke.type==="code"&&(X++,setTimeout(function(){W(ke.text,ke.lang,function(Te,Me){if(Te)return q(Te);Me!=null&&Me!==ke.text&&(ke.text=Me,ke.escaped=!0),X--,X===0&&q()})},0))}),X===0&&q();return}function le(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Q.silent)return"<p>An error occurred:</p><pre>"+d(ke.message+"",!0)+"</pre>";throw ke}try{var pe=j.lex($,Q);if(Q.walkTokens){if(Q.async)return Promise.all(fe.walkTokens(pe,Q.walkTokens)).then(function(){return oe.parse(pe,Q)}).catch(le);fe.walkTokens(pe,Q.walkTokens)}return oe.parse(pe,Q)}catch(ke){le(ke)}}fe.options=fe.setOptions=function($){return o(fe.defaults,$),b(fe.defaults),fe},fe.getDefaults=k,fe.defaults=se.defaults,fe.use=function(){for(var $=arguments.length,Q=new Array($),Y=0;Y<$;Y++)Q[Y]=arguments[Y];var W=o.apply(void 0,[{}].concat(Q)),V=fe.defaults.extensions||{renderers:{},childTokens:{}},q;Q.forEach(function(X){if(X.extensions&&(q=!0,X.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var ke=V.renderers?V.renderers[pe.name]:null;ke?V.renderers[pe.name]=function(){for(var Te=arguments.length,Me=new Array(Te),Oe=0;Oe<Te;Oe++)Me[Oe]=arguments[Oe];var me=pe.renderer.apply(this,Me);return me===!1&&(me=ke.apply(this,Me)),me}:V.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");V[pe.level]?V[pe.level].unshift(pe.tokenizer):V[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?V.startBlock?V.startBlock.push(pe.start):V.startBlock=[pe.start]:pe.level==="inline"&&(V.startInline?V.startInline.push(pe.start):V.startInline=[pe.start]))}pe.childTokens&&(V.childTokens[pe.name]=pe.childTokens)})),X.renderer&&function(){var pe=fe.defaults.renderer||new L,ke=function(Oe){var me=pe[Oe];pe[Oe]=function(){for(var be=arguments.length,Ee=new Array(be),Ne=0;Ne<be;Ne++)Ee[Ne]=arguments[Ne];var Be=X.renderer[Oe].apply(pe,Ee);return Be===!1&&(Be=me.apply(pe,Ee)),Be}};for(var Te in X.renderer)ke(Te);W.renderer=pe}(),X.tokenizer&&function(){var pe=fe.defaults.tokenizer||new N,ke=function(Oe){var me=pe[Oe];pe[Oe]=function(){for(var be=arguments.length,Ee=new Array(be),Ne=0;Ne<be;Ne++)Ee[Ne]=arguments[Ne];var Be=X.tokenizer[Oe].apply(pe,Ee);return Be===!1&&(Be=me.apply(pe,Ee)),Be}};for(var Te in X.tokenizer)ke(Te);W.tokenizer=pe}(),X.walkTokens){var le=fe.defaults.walkTokens;W.walkTokens=function(pe){var ke=[];return ke.push(X.walkTokens.call(this,pe)),le&&(ke=ke.concat(le.call(this,pe))),ke}}q&&(W.extensions=V),fe.setOptions(W)})},fe.walkTokens=function($,Q){for(var Y=[],W=function(){var le=q.value;switch(Y=Y.concat(Q.call(fe,le)),le.type){case"table":{for(var pe=I(le.header),ke;!(ke=pe()).done;){var Te=ke.value;Y=Y.concat(fe.walkTokens(Te.tokens,Q))}for(var Me=I(le.rows),Oe;!(Oe=Me()).done;)for(var me=Oe.value,be=I(me),Ee;!(Ee=be()).done;){var Ne=Ee.value;Y=Y.concat(fe.walkTokens(Ne.tokens,Q))}break}case"list":{Y=Y.concat(fe.walkTokens(le.items,Q));break}default:fe.defaults.extensions&&fe.defaults.extensions.childTokens&&fe.defaults.extensions.childTokens[le.type]?fe.defaults.extensions.childTokens[le.type].forEach(function(Be){Y=Y.concat(fe.walkTokens(le[Be],Q))}):le.tokens&&(Y=Y.concat(fe.walkTokens(le.tokens,Q)))}},V=I($),q;!(q=V()).done;)W();return Y},fe.parseInline=function($,Q){if(typeof $>"u"||$===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof $!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call($)+", string expected");Q=o({},fe.defaults,Q||{}),H(Q);try{var Y=j.lexInline($,Q);return Q.walkTokens&&fe.walkTokens(Y,Q.walkTokens),oe.parseInline(Y,Q)}catch(W){if(W.message+=`
Please report this to https://github.com/markedjs/marked.`,Q.silent)return"<p>An error occurred:</p><pre>"+d(W.message+"",!0)+"</pre>";throw W}},fe.Parser=oe,fe.parser=oe.parse,fe.Renderer=L,fe.TextRenderer=F,fe.Lexer=j,fe.lexer=j.lex,fe.Tokenizer=N,fe.Slugger=G,fe.parse=fe;var ee=fe.options,te=fe.setOptions,_=fe.use,U=fe.walkTokens,Z=fe.parseInline,ie=fe,ue=oe.parse,ve=j.lex;se.Lexer=j,se.Parser=oe,se.Renderer=L,se.Slugger=G,se.TextRenderer=F,se.Tokenizer=N,se.getDefaults=k,se.lexer=ve,se.marked=fe,se.options=ee,se.parse=ie,se.parseInline=Z,se.parser=ue,se.setOptions=te,se.use=_,se.walkTokens=U,Object.defineProperty(se,"__esModule",{value:!0})}),define(we[87],ye([1,0,31]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new y.LRUCache(1e4);function P(C){return E(C,"NFC",t)}e.normalizeNFC=P;const I=new y.LRUCache(1e4);function k(C){return E(C,"NFD",I)}e.normalizeNFD=k;const b=/[^\u0000-\u0080]/;function E(C,T,R){if(!C)return C;const S=R.get(C);if(S)return S;let w;return b.test(C)?w=C.normalize(T):w=C,R.set(C,w),w}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(T){return k(T).replace(C,"")}}()}),function(){function se(P){const I=[];typeof P=="number"&&I.push("code/timeOrigin",P);function k(E){I.push(E,Date.now())}function b(){const E=[];for(let C=0;C<I.length;C+=2)E.push({name:I[C],startTime:I[C+1]});return E}return{mark:k,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const k of performance.getEntriesByType("mark"))I.push({name:k.name,startTime:Math.round(P+k.startTime)});return I}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function y(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=y(t))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var t in y)(typeof exports=="object"?exports:se)[t]=y[t]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function y(t){if(e[t])return e[t].exports;var P=e[t]={i:t,l:!1,exports:{}};return se[t].call(P.exports,P,P.exports,y),P.l=!0,P.exports}return y.m=se,y.c=e,y.d=function(t,P,I){y.o(t,P)||Object.defineProperty(t,P,{enumerable:!0,get:I})},y.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},y.t=function(t,P){if(1&P&&(t=y(t)),8&P||4&P&&typeof t=="object"&&t&&t.__esModule)return t;var I=Object.create(null);if(y.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:t}),2&P&&typeof t!="string")for(var k in t)y.d(I,k,function(b){return t[b]}.bind(null,k));return I},y.n=function(t){var P=t&&t.__esModule?function(){return t.default}:function(){return t};return y.d(P,"a",P),P},y.o=function(t,P){return Object.prototype.hasOwnProperty.call(t,P)},y.p="",y(y.s=0)}([function(se,e,y){(function(t){var P;e=se.exports=_,P=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],E=e.src=[],C=0,T=C++;E[T]="0|[1-9]\\d*";var R=C++;E[R]="[0-9]+";var S=C++;E[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=C++;E[w]="("+E[T]+")\\.("+E[T]+")\\.("+E[T]+")";var d=C++;E[d]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var g=C++;E[g]="(?:"+E[T]+"|"+E[S]+")";var p=C++;E[p]="(?:"+E[R]+"|"+E[S]+")";var m=C++;E[m]="(?:-("+E[g]+"(?:\\."+E[g]+")*))";var v=C++;E[v]="(?:-?("+E[p]+"(?:\\."+E[p]+")*))";var u=C++;E[u]="[0-9A-Za-z-]+";var l=C++;E[l]="(?:\\+("+E[u]+"(?:\\."+E[u]+")*))";var h=C++,i="v?"+E[w]+E[m]+"?"+E[l]+"?";E[h]="^"+i+"$";var r="[v=\\s]*"+E[d]+E[v]+"?"+E[l]+"?",n=C++;E[n]="^"+r+"$";var s=C++;E[s]="((?:<|>)?=?)";var a=C++;E[a]=E[R]+"|x|X|\\*";var f=C++;E[f]=E[T]+"|x|X|\\*";var o=C++;E[o]="[v=\\s]*("+E[f]+")(?:\\.("+E[f]+")(?:\\.("+E[f]+")(?:"+E[m]+")?"+E[l]+"?)?)?";var c=C++;E[c]="[v=\\s]*("+E[a]+")(?:\\.("+E[a]+")(?:\\.("+E[a]+")(?:"+E[v]+")?"+E[l]+"?)?)?";var D=C++;E[D]="^"+E[s]+"\\s*"+E[o]+"$";var O=C++;E[O]="^"+E[s]+"\\s*"+E[c]+"$";var H=C++;E[H]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var re=C++;E[re]="(?:~>?)";var ce=C++;E[ce]="(\\s*)"+E[re]+"\\s+",b[ce]=new RegExp(E[ce],"g");var ae=C++;E[ae]="^"+E[re]+E[o]+"$";var N=C++;E[N]="^"+E[re]+E[c]+"$";var J=C++;E[J]="(?:\\^)";var B=C++;E[B]="(\\s*)"+E[J]+"\\s+",b[B]=new RegExp(E[B],"g");var x=C++;E[x]="^"+E[J]+E[o]+"$";var z=C++;E[z]="^"+E[J]+E[c]+"$";var j=C++;E[j]="^"+E[s]+"\\s*("+r+")$|^$";var L=C++;E[L]="^"+E[s]+"\\s*("+i+")$|^$";var F=C++;E[F]="(\\s*)"+E[s]+"\\s*("+r+"|"+E[o]+")",b[F]=new RegExp(E[F],"g");var G=C++;E[G]="^\\s*("+E[o]+")\\s+-\\s+("+E[o]+")\\s*$";var oe=C++;E[oe]="^\\s*("+E[c]+")\\s+-\\s+("+E[c]+")\\s*$";var fe=C++;E[fe]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)P(ee,E[ee]),b[ee]||(b[ee]=new RegExp(E[ee]));function te(me,be){if(me instanceof _)return me;if(typeof me!="string"||me.length>I||!(be?b[n]:b[h]).test(me))return null;try{return new _(me,be)}catch{return null}}function _(me,be){if(me instanceof _){if(me.loose===be)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof _))return new _(me,be);P("SemVer",me,be),this.loose=be;var Ee=me.trim().match(be?b[n]:b[h]);if(!Ee)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<k)return Be}return Ne}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=te,e.valid=function(me,be){var Ee=te(me,be);return Ee?Ee.version:null},e.clean=function(me,be){var Ee=te(me.trim().replace(/^[=v]+/,""),be);return Ee?Ee.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(me){return P("SemVer.compare",this.version,this.loose,me),me instanceof _||(me=new _(me,this.loose)),this.compareMain(me)||this.comparePre(me)},_.prototype.compareMain=function(me){return me instanceof _||(me=new _(me,this.loose)),Z(this.major,me.major)||Z(this.minor,me.minor)||Z(this.patch,me.patch)},_.prototype.comparePre=function(me){if(me instanceof _||(me=new _(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var be=0;do{var Ee=this.prerelease[be],Ne=me.prerelease[be];if(P("prerelease compare",be,Ee,Ne),Ee===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==Ne)return Z(Ee,Ne)}while(++be)},_.prototype.inc=function(me,be){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,be,Ee,Ne){typeof Ee=="string"&&(Ne=Ee,Ee=void 0);try{return new _(me,Ee).inc(be,Ne).version}catch{return null}},e.diff=function(me,be){if($(me,be))return null;var Ee=te(me),Ne=te(be);if(Ee.prerelease.length||Ne.prerelease.length){for(var Be in Ee)if((Be==="major"||Be==="minor"||Be==="patch")&&Ee[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in Ee)if((Be==="major"||Be==="minor"||Be==="patch")&&Ee[Be]!==Ne[Be])return Be},e.compareIdentifiers=Z;var U=/^[0-9]+$/;function Z(me,be){var Ee=U.test(me),Ne=U.test(be);return Ee&&Ne&&(me=+me,be=+be),Ee&&!Ne?-1:Ne&&!Ee?1:me<be?-1:me>be?1:0}function ie(me,be,Ee){return new _(me,Ee).compare(new _(be,Ee))}function ue(me,be,Ee){return ie(me,be,Ee)>0}function ve(me,be,Ee){return ie(me,be,Ee)<0}function $(me,be,Ee){return ie(me,be,Ee)===0}function Q(me,be,Ee){return ie(me,be,Ee)!==0}function Y(me,be,Ee){return ie(me,be,Ee)>=0}function W(me,be,Ee){return ie(me,be,Ee)<=0}function V(me,be,Ee,Ne){var Be;switch(be){case"===":typeof me=="object"&&(me=me.version),typeof Ee=="object"&&(Ee=Ee.version),Be=me===Ee;break;case"!==":typeof me=="object"&&(me=me.version),typeof Ee=="object"&&(Ee=Ee.version),Be=me!==Ee;break;case"":case"=":case"==":Be=$(me,Ee,Ne);break;case"!=":Be=Q(me,Ee,Ne);break;case">":Be=ue(me,Ee,Ne);break;case">=":Be=Y(me,Ee,Ne);break;case"<":Be=ve(me,Ee,Ne);break;case"<=":Be=W(me,Ee,Ne);break;default:throw new TypeError("Invalid operator: "+be)}return Be}function q(me,be){if(me instanceof q){if(me.loose===be)return me;me=me.value}if(!(this instanceof q))return new q(me,be);P("comparator",me,be),this.loose=be,this.parse(me),this.semver===X?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(me,be){return Z(be,me)},e.major=function(me,be){return new _(me,be).major},e.minor=function(me,be){return new _(me,be).minor},e.patch=function(me,be){return new _(me,be).patch},e.compare=ie,e.compareLoose=function(me,be){return ie(me,be,!0)},e.rcompare=function(me,be,Ee){return ie(be,me,Ee)},e.sort=function(me,be){return me.sort(function(Ee,Ne){return e.compare(Ee,Ne,be)})},e.rsort=function(me,be){return me.sort(function(Ee,Ne){return e.rcompare(Ee,Ne,be)})},e.gt=ue,e.lt=ve,e.eq=$,e.neq=Q,e.gte=Y,e.lte=W,e.cmp=V,e.Comparator=q;var X={};function le(me,be){if(me instanceof le)return me.loose===be?me:new le(me.raw,be);if(me instanceof q)return new le(me.value,be);if(!(this instanceof le))return new le(me,be);if(this.loose=be,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function pe(me){return!me||me.toLowerCase()==="x"||me==="*"}function ke(me,be,Ee,Ne,Be,Ke,He,Ge,Xe,et,qe,$e,xe){return((be=pe(Ee)?"":pe(Ne)?">="+Ee+".0.0":pe(Be)?">="+Ee+"."+Ne+".0":">="+be)+" "+(Ge=pe(Xe)?"":pe(et)?"<"+(+Xe+1)+".0.0":pe(qe)?"<"+Xe+"."+(+et+1)+".0":$e?"<="+Xe+"."+et+"."+qe+"-"+$e:"<="+Ge)).trim()}function Te(me,be){for(var Ee=0;Ee<me.length;Ee++)if(!me[Ee].test(be))return!1;if(be.prerelease.length){for(Ee=0;Ee<me.length;Ee++)if(P(me[Ee].semver),me[Ee].semver!==X&&me[Ee].semver.prerelease.length>0){var Ne=me[Ee].semver;if(Ne.major===be.major&&Ne.minor===be.minor&&Ne.patch===be.patch)return!0}return!1}return!0}function Me(me,be,Ee){try{be=new le(be,Ee)}catch{return!1}return be.test(me)}function Oe(me,be,Ee,Ne){var Be,Ke,He,Ge,Xe;switch(me=new _(me,Ne),be=new le(be,Ne),Ee){case">":Be=ue,Ke=W,He=ve,Ge=">",Xe=">=";break;case"<":Be=ve,Ke=Y,He=ue,Ge="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(me,be,Ne))return!1;for(var et=0;et<be.set.length;++et){var qe=be.set[et],$e=null,xe=null;if(qe.forEach(function(he){he.semver===X&&(he=new q(">=0.0.0")),$e=$e||he,xe=xe||he,Be(he.semver,$e.semver,Ne)?$e=he:He(he.semver,xe.semver,Ne)&&(xe=he)}),$e.operator===Ge||$e.operator===Xe||(!xe.operator||xe.operator===Ge)&&Ke(me,xe.semver)||xe.operator===Xe&&He(me,xe.semver))return!1}return!0}q.prototype.parse=function(me){var be=this.loose?b[j]:b[L],Ee=me.match(be);if(!Ee)throw new TypeError("Invalid comparator: "+me);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new _(Ee[2],this.loose):this.semver=X},q.prototype.toString=function(){return this.value},q.prototype.test=function(me){return P("Comparator.test",me,this.loose),this.semver===X||(typeof me=="string"&&(me=new _(me,this.loose)),V(me,this.operator,this.semver,this.loose))},q.prototype.intersects=function(me,be){if(!(me instanceof q))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new le(me.value,be),Me(this.value,Ee,be);if(me.operator==="")return Ee=new le(this.value,be),Me(me.semver,Ee,be);var Ne=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),Ke=this.semver.version===me.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Ge=V(this.semver,"<",me.semver,be)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),Xe=V(this.semver,">",me.semver,be)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Ne||Be||Ke&&He||Ge||Xe},e.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(me){var be=this.loose;me=me.trim(),P("range",me,be);var Ee=be?b[oe]:b[G];me=me.replace(Ee,ke),P("hyphen replace",me),me=me.replace(b[F],"$1$2$3"),P("comparator trim",me,b[F]),me=(me=(me=me.replace(b[ce],"$1~")).replace(b[B],"$1^")).split(/\s+/).join(" ");var Ne=be?b[j]:b[L],Be=me.split(" ").map(function(Ke){return function(He,Ge){return P("comp",He),He=function(Xe,et){return Xe.trim().split(/\s+/).map(function(qe){return function($e,xe){P("caret",$e,xe);var he=xe?b[z]:b[x];return $e.replace(he,function(Ce,De,Re,Fe,ze){var je;return P("caret",$e,Ce,De,Re,Fe,ze),pe(De)?je="":pe(Re)?je=">="+De+".0.0 <"+(+De+1)+".0.0":pe(Fe)?je=De==="0"?">="+De+"."+Re+".0 <"+De+"."+(+Re+1)+".0":">="+De+"."+Re+".0 <"+(+De+1)+".0.0":ze?(P("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),je=De==="0"?Re==="0"?">="+De+"."+Re+"."+Fe+ze+" <"+De+"."+Re+"."+(+Fe+1):">="+De+"."+Re+"."+Fe+ze+" <"+De+"."+(+Re+1)+".0":">="+De+"."+Re+"."+Fe+ze+" <"+(+De+1)+".0.0"):(P("no pr"),je=De==="0"?Re==="0"?">="+De+"."+Re+"."+Fe+" <"+De+"."+Re+"."+(+Fe+1):">="+De+"."+Re+"."+Fe+" <"+De+"."+(+Re+1)+".0":">="+De+"."+Re+"."+Fe+" <"+(+De+1)+".0.0"),P("caret return",je),je})}(qe,et)}).join(" ")}(He,Ge),P("caret",He),He=function(Xe,et){return Xe.trim().split(/\s+/).map(function(qe){return function($e,xe){var he=xe?b[N]:b[ae];return $e.replace(he,function(Ce,De,Re,Fe,ze){var je;return P("tilde",$e,Ce,De,Re,Fe,ze),pe(De)?je="":pe(Re)?je=">="+De+".0.0 <"+(+De+1)+".0.0":pe(Fe)?je=">="+De+"."+Re+".0 <"+De+"."+(+Re+1)+".0":ze?(P("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),je=">="+De+"."+Re+"."+Fe+ze+" <"+De+"."+(+Re+1)+".0"):je=">="+De+"."+Re+"."+Fe+" <"+De+"."+(+Re+1)+".0",P("tilde return",je),je})}(qe,et)}).join(" ")}(He,Ge),P("tildes",He),He=function(Xe,et){return P("replaceXRanges",Xe,et),Xe.split(/\s+/).map(function(qe){return function($e,xe){$e=$e.trim();var he=xe?b[O]:b[D];return $e.replace(he,function(Ce,De,Re,Fe,ze,je){P("xRange",$e,Ce,De,Re,Fe,ze,je);var rt=pe(Re),it=rt||pe(Fe),Je=it||pe(ze);return De==="="&&Je&&(De=""),rt?Ce=De===">"||De==="<"?"<0.0.0":"*":De&&Je?(it&&(Fe=0),Je&&(ze=0),De===">"?(De=">=",it?(Re=+Re+1,Fe=0,ze=0):Je&&(Fe=+Fe+1,ze=0)):De==="<="&&(De="<",it?Re=+Re+1:Fe=+Fe+1),Ce=De+Re+"."+Fe+"."+ze):it?Ce=">="+Re+".0.0 <"+(+Re+1)+".0.0":Je&&(Ce=">="+Re+"."+Fe+".0 <"+Re+"."+(+Fe+1)+".0"),P("xRange return",Ce),Ce})}(qe,et)}).join(" ")}(He,Ge),P("xrange",He),He=function(Xe,et){return P("replaceStars",Xe,et),Xe.trim().replace(b[fe],"")}(He,Ge),P("stars",He),He}(Ke,be)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ke){return!!Ke.match(Ne)})),Be=Be.map(function(Ke){return new q(Ke,be)})},le.prototype.intersects=function(me,be){if(!(me instanceof le))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(Ne){return me.set.some(function(Be){return Be.every(function(Ke){return Ne.intersects(Ke,be)})})})})},e.toComparators=function(me,be){return new le(me,be).set.map(function(Ee){return Ee.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},le.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new _(me,this.loose));for(var be=0;be<this.set.length;be++)if(Te(this.set[be],me))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(me,be,Ee){var Ne=null,Be=null;try{var Ke=new le(be,Ee)}catch{return null}return me.forEach(function(He){Ke.test(He)&&(Ne&&Be.compare(He)!==-1||(Be=new _(Ne=He,Ee)))}),Ne},e.minSatisfying=function(me,be,Ee){var Ne=null,Be=null;try{var Ke=new le(be,Ee)}catch{return null}return me.forEach(function(He){Ke.test(He)&&(Ne&&Be.compare(He)!==1||(Be=new _(Ne=He,Ee)))}),Ne},e.validRange=function(me,be){try{return new le(me,be).range||"*"}catch{return null}},e.ltr=function(me,be,Ee){return Oe(me,be,"<",Ee)},e.gtr=function(me,be,Ee){return Oe(me,be,">",Ee)},e.outside=Oe,e.prerelease=function(me,be){var Ee=te(me,be);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(me,be,Ee){return me=new le(me,Ee),be=new le(be,Ee),me.intersects(be)},e.coerce=function(me){if(me instanceof _)return me;if(typeof me!="string")return null;var be=me.match(b[H]);return be==null?null:te((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,y(1))},function(se,e){var y,t,P=se.exports={};function I(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function b(p){if(y===setTimeout)return setTimeout(p,0);if((y===I||!y)&&setTimeout)return y=setTimeout,setTimeout(p,0);try{return y(p,0)}catch{try{return y.call(null,p,0)}catch{return y.call(this,p,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:I}catch{y=I}try{t=typeof clearTimeout=="function"?clearTimeout:k}catch{t=k}})();var E,C=[],T=!1,R=-1;function S(){T&&E&&(T=!1,E.length?C=E.concat(C):R=-1,C.length&&w())}function w(){if(!T){var p=b(S);T=!0;for(var m=C.length;m;){for(E=C,C=[];++R<m;)E&&E[R].run();R=-1,m=C.length}E=null,T=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===k||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(p)}}function d(p,m){this.fun=p,this.array=m}function g(){}P.nextTick=function(p){var m=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)m[v-1]=arguments[v];C.push(new d(p,m)),C.length!==1||T||b(w)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=g,P.addListener=g,P.once=g,P.off=g,P.removeListener=g,P.removeAllListeners=g,P.emit=g,P.prependListener=g,P.prependOnceListener=g,P.listeners=function(p){return[]},P.binding=function(p){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(p){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(we[139],ye([1,0]),function(se,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(b,E,C){this.level=b,this.key=E,this.value=C,this.forward=[]}}const P=void 0;class I{constructor(b,E=2**16){this.comparator=b,this[y]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(E)|0),this._header=new t(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,P,P)}has(b){return Boolean(I._search(this,b,this.comparator))}get(b){return I._search(this,b,this.comparator)?.value}set(b,E){return I._insert(this,b,E,this.comparator)&&(this._size+=1),this}delete(b){const E=I._delete(this,b,this.comparator);return E&&(this._size-=1),E}forEach(b,E){let C=this._header.forward[0];for(;C;)b.call(E,C.value,C.key,this),C=C.forward[0]}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",E=this._header.forward[0];for(;E;)b+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return b}static _search(b,E,C){let T=b._header;for(let R=b._level-1;R>=0;R--)for(;T.forward[R]&&C(T.forward[R].key,E)<0;)T=T.forward[R];if(T=T.forward[0],T&&C(T.key,E)===0)return T}static _insert(b,E,C,T){const R=[];let S=b._header;for(let w=b._level-1;w>=0;w--){for(;S.forward[w]&&T(S.forward[w].key,E)<0;)S=S.forward[w];R[w]=S}if(S=S.forward[0],S&&T(S.key,E)===0)return S.value=C,!1;{const w=I._randomLevel(b);if(w>b._level){for(let d=b._level;d<w;d++)R[d]=b._header;b._level=w}S=new t(w,E,C);for(let d=0;d<w;d++)S.forward[d]=R[d].forward[d],R[d].forward[d]=S;return!0}}static _randomLevel(b,E=.5){let C=1;for(;Math.random()<E&&C<b._maxLevel;)C+=1;return C}static _delete(b,E,C){const T=[];let R=b._header;for(let S=b._level-1;S>=0;S--){for(;R.forward[S]&&C(R.forward[S].key,E)<0;)R=R.forward[S];T[S]=R}if(R=R.forward[0],!R||C(R.key,E)!==0)return!1;for(let S=0;S<b._level&&T[S].forward[S]===R;S++)T[S].forward[S]=R.forward[S];for(;b._level>0&&b._header.forward[b._level-1]===P;)b._level-=1;return!0}}e.SkipList=I}),define(we[44],ye([1,0,10,2]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function P(l){const h=l;return h?typeof h.read=="function":!1}e.isReadable=P;function I(l){const h=l;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=I;function k(l){const h=l;return h?I(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=k;function b(l,h){return new E(l,h)}e.newWriteableStream=b;class E{constructor(h,i){this.reducer=h,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h<"u"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(i=>i(h))}emitError(h){this.listeners.error.length===0?(0,y.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(i=>i(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,i){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(h,i){if(this.state.destroyed)return;let r;switch(h){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const n=r.indexOf(i);n>=0&&r.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(l,h){const i=[];let r;for(;(r=l.read())!==null;)i.push(r);return h(i)}e.consumeReadable=C;function T(l,h,i){const r=[];let n;for(;(n=l.read())!==null&&r.length<i;)r.push(n);return n===null&&r.length>0?h(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return l.read()}}}e.peekReadable=T;function R(l,h){return new Promise((i,r)=>{const n=[];S(l,{onData:s=>{h&&n.push(s)},onError:s=>{h?r(s):i(void 0)},onEnd:()=>{i(h?h(n):void 0)}})})}e.consumeStream=R;function S(l,h){let i=!1;return l.on("error",r=>{i||h.onError(r)}),l.on("end",()=>{i||h.onEnd()}),l.on("data",r=>{i||h.onData(r)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=S;function w(l,h){return new Promise((i,r)=>{const n=new t.DisposableStore,s=[],a=c=>{if(s.push(c),s.length>h)return n.dispose(),l.pause(),i({stream:l,buffer:s,ended:!1})},f=c=>r(c),o=()=>i({stream:l,buffer:s,ended:!0});n.add((0,t.toDisposable)(()=>l.removeListener("error",f))),l.on("error",f),n.add((0,t.toDisposable)(()=>l.removeListener("end",o))),l.on("end",o),n.add((0,t.toDisposable)(()=>l.removeListener("data",a))),l.on("data",a)})}e.peekStream=w;function d(l,h){const i=b(h);return i.end(l),i}e.toStream=d;function g(){const l=b(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=g;function p(l){let h=!1;return{read:()=>h?null:(h=!0,l)}}e.toReadable=p;function m(l,h,i){const r=b(i);return S(l,{onData:n=>r.write(h.data(n)),onError:n=>r.error(h.error?h.error(n):n),onEnd:()=>r.end()}),r}e.transform=m;function v(l,h,i){let r=!1;return{read:()=>{const n=h.read();return r?n:(r=!0,n!==null?i([l,n]):l)}}}e.prefixedReadable=v;function u(l,h,i){let r=!1;const n=b(i);return S(h,{onData:s=>r?n.write(s):(r=!0,n.write(i([l,s]))),onError:s=>n.error(s),onEnd:()=>{r||(r=!0,n.write(l)),n.end()}}),n}e.prefixedStream=u}),define(we[16],ye([1,0,44]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let P,I;class k{static alloc(c){return t?new k(Buffer.allocUnsafe(c)):new k(new Uint8Array(c))}static wrap(c){return t&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new k(c)}static fromString(c,D){return!(D?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(c)):(P||(P=new TextEncoder),new k(P.encode(c)))}static fromByteArray(c){const D=k.alloc(c.length);for(let O=0,H=c.length;O<H;O++)D.buffer[O]=c[O];return D}static concat(c,D){if(typeof D>"u"){D=0;for(let re=0,ce=c.length;re<ce;re++)D+=c[re].byteLength}const O=k.alloc(D);let H=0;for(let re=0,ce=c.length;re<ce;re++){const ae=c[re];O.set(ae,H),H+=ae.byteLength}return O}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=k.alloc(this.byteLength);return c.set(this),c}toString(){return t?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(c,D){return new k(this.buffer.subarray(c,D))}set(c,D){if(c instanceof k)this.buffer.set(c.buffer,D);else if(c instanceof Uint8Array)this.buffer.set(c,D);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),D);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return C(this.buffer,c)}writeUInt32BE(c,D){T(this.buffer,c,D)}readUInt32LE(c){return R(this.buffer,c)}writeUInt32LE(c,D){S(this.buffer,c,D)}readUInt8(c){return w(this.buffer,c)}writeUInt8(c,D){d(this.buffer,c,D)}}e.VSBuffer=k;function b(o,c){return o[c+0]<<0>>>0|o[c+1]<<8>>>0}e.readUInt16LE=b;function E(o,c,D){o[D+0]=c&255,c=c>>>8,o[D+1]=c&255}e.writeUInt16LE=E;function C(o,c){return o[c]*2**24+o[c+1]*2**16+o[c+2]*2**8+o[c+3]}e.readUInt32BE=C;function T(o,c,D){o[D+3]=c,c=c>>>8,o[D+2]=c,c=c>>>8,o[D+1]=c,c=c>>>8,o[D]=c}e.writeUInt32BE=T;function R(o,c){return o[c+0]<<0>>>0|o[c+1]<<8>>>0|o[c+2]<<16>>>0|o[c+3]<<24>>>0}e.readUInt32LE=R;function S(o,c,D){o[D+0]=c&255,c=c>>>8,o[D+1]=c&255,c=c>>>8,o[D+2]=c&255,c=c>>>8,o[D+3]=c&255}e.writeUInt32LE=S;function w(o,c){return o[c]}e.readUInt8=w;function d(o,c,D){o[D]=c}e.writeUInt8=d;function g(o){return y.consumeReadable(o,c=>k.concat(c))}e.readableToBuffer=g;function p(o){return y.toReadable(o)}e.bufferToReadable=p;function m(o){return y.consumeStream(o,c=>k.concat(c))}e.streamToBuffer=m;async function v(o){return o.ended?k.concat(o.buffer):k.concat([...o.buffer,await m(o.stream)])}e.bufferedStreamToBuffer=v;function u(o){return y.toStream(o,c=>k.concat(c))}e.bufferToStream=u;function l(o){return y.transform(o,{data:c=>typeof c=="string"?k.fromString(c):k.wrap(c)},c=>k.concat(c))}e.streamToBufferReadableStream=l;function h(o){return y.newWriteableStream(c=>k.concat(c),o)}e.newWriteableBufferStream=h;function i(o,c){return y.prefixedReadable(o,c,D=>k.concat(D))}e.prefixedBufferReadable=i;function r(o,c){return y.prefixedStream(o,c,D=>k.concat(D))}e.prefixedBufferStream=r;function n(o){let c=0,D=0,O=0;const H=new Uint8Array(Math.floor(o.length/4*3)),re=ae=>{switch(D){case 3:H[O++]=c|ae,D=0;break;case 2:H[O++]=c|ae>>>2,c=ae<<6,D=3;break;case 1:H[O++]=c|ae>>>4,c=ae<<4,D=2;break;default:c=ae<<2,D=1}};for(let ae=0;ae<o.length;ae++){const N=o.charCodeAt(ae);if(N>=65&&N<=90)re(N-65);else if(N>=97&&N<=122)re(N-97+26);else if(N>=48&&N<=57)re(N-48+52);else if(N===43||N===45)re(62);else if(N===47||N===95)re(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${o[ae]}`)}}const ce=O;for(;D>0;)re(0);return k.wrap(H).slice(0,ce)}e.decodeBase64=n;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:o},c=!0,D=!1){const O=D?a:s;let H="";const re=o.byteLength%3;let ce=0;for(;ce<o.byteLength-re;ce+=3){const ae=o[ce+0],N=o[ce+1],J=o[ce+2];H+=O[ae>>>2],H+=O[(ae<<4|N>>>4)&63],H+=O[(N<<2|J>>>6)&63],H+=O[J&63]}if(re===1){const ae=o[ce+0];H+=O[ae>>>2],H+=O[ae<<4&63],c&&(H+="==")}else if(re===2){const ae=o[ce+0],N=o[ce+1];H+=O[ae>>>2],H+=O[(ae<<4|N>>>4)&63],H+=O[N<<2&63],c&&(H+="=")}return H}e.encodeBase64=f}),define(we[13],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function y(r){return typeof r=="string"}e.isString=y;function t(r){return Array.isArray(r)&&r.every(n=>y(n))}e.isStringArray=t;function P(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=P;function I(r){const n=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof n}e.isTypedArray=I;function k(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=k;function b(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=b;function E(r){return r===!0||r===!1}e.isBoolean=E;function C(r){return typeof r>"u"}e.isUndefined=C;function T(r){return!R(r)}e.isDefined=T;function R(r){return C(r)||r===null}e.isUndefinedOrNull=R;function S(r,n){if(!r)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=S;function w(r){if(R(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=w;function d(...r){const n=[];for(let s=0;s<r.length;s++){const a=r[s];if(R(a))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(a)}return n}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function p(r){if(!P(r))return!1;for(const n in r)if(g.call(r,n))return!1;return!0}e.isEmptyObject=p;function m(r){return typeof r=="function"}e.isFunction=m;function v(...r){return r.length>0&&r.every(m)}e.areFunctions=v;function u(r,n){const s=Math.min(r.length,n.length);for(let a=0;a<s;a++)l(r[a],n[a])}e.validateConstraints=u;function l(r,n){if(y(n)){if(typeof r!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(m(n)){try{if(r instanceof n)return}catch{}if(!R(r)&&r.constructor===n||n.length===1&&n.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function h(r){return r===null?void 0:r}e.withNullAsUndefined=h;function i(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=i}),define(we[22],ye([1,0,13]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const v=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([u,l])=>{v[u]=l&&typeof l=="object"?t(l):l}),v}e.deepClone=t;function P(m){if(!m||typeof m!="object")return m;const v=[m];for(;v.length>0;){const u=v.shift();Object.freeze(u);for(const l in u)if(I.call(u,l)){const h=u[l];typeof h=="object"&&!Object.isFrozen(h)&&!(0,y.isTypedArray)(h)&&v.push(h)}}return m}e.deepFreeze=P;const I=Object.prototype.hasOwnProperty;function k(m,v){return b(m,v,new Set)}e.cloneAndChange=k;function b(m,v,u){if((0,y.isUndefinedOrNull)(m))return m;const l=v(m);if(typeof l<"u")return l;if(Array.isArray(m)){const h=[];for(const i of m)h.push(b(i,v,u));return h}if((0,y.isObject)(m)){if(u.has(m))throw new Error("Cannot clone recursive data-structure");u.add(m);const h={};for(const i in m)I.call(m,i)&&(h[i]=b(m[i],v,u));return u.delete(m),h}return m}function E(m,v,u=!0){return(0,y.isObject)(m)?((0,y.isObject)(v)&&Object.keys(v).forEach(l=>{l in m?u&&((0,y.isObject)(m[l])&&(0,y.isObject)(v[l])?E(m[l],v[l],u):m[l]=v[l]):m[l]=v[l]}),m):v}e.mixin=E;function C(m,v){if(m===v)return!0;if(m==null||v===null||v===void 0||typeof m!=typeof v||typeof m!="object"||Array.isArray(m)!==Array.isArray(v))return!1;let u,l;if(Array.isArray(m)){if(m.length!==v.length)return!1;for(u=0;u<m.length;u++)if(!C(m[u],v[u]))return!1}else{const h=[];for(l in m)h.push(l);h.sort();const i=[];for(l in v)i.push(l);if(i.sort(),!C(h,i))return!1;for(u=0;u<h.length;u++)if(!C(m[h[u]],v[h[u]]))return!1}return!0}e.equals=C;function T(m){const v=new Set;return JSON.stringify(m,(u,l)=>{if((0,y.isObject)(l)||Array.isArray(l)){if(v.has(l))return"[Circular]";v.add(l)}return l})}e.safeStringify=T;function R(m,v){const u=Object.create(null);return!m||!v||Object.keys(v).forEach(h=>{const i=m[h],r=v[h];C(i,r)||(u[h]=r)}),u}e.distinct=R;function S(m,v){const u=v.toLowerCase(),l=Object.keys(m).find(h=>h.toLowerCase()===u);return l?m[l]:m[v]}e.getCaseInsensitive=S;function w(m,v){const u=Object.create(null);for(const[l,h]of Object.entries(m))v(l,h)&&(u[l]=h);return u}e.filter=w;function d(m){let v=[],u=Object.getPrototypeOf(m);for(;Object.prototype!==u;)v=v.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return v}e.getAllPropertyNames=d;function g(m){const v=[];for(const u of d(m))typeof m[u]=="function"&&v.push(u);return v}e.getAllMethodNames=g;function p(m,v){const u=h=>function(){const i=Array.prototype.slice.call(arguments,0);return v(h,i)},l={};for(const h of m)l[h]=u(h);return l}e.createProxyObject=p}),define(we[23],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(P){return y.test(P)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(b){for(let E=0;E<b.length;E++)b[E]=Math.floor(Math.random()*256);return b};const I=new Uint8Array(16),k=[];for(let b=0;b<256;b++)k.push(b.toString(16).padStart(2,"0"));return function(){P(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let E=0,C="";return C+=k[I[E++]],C+=k[I[E++]],C+=k[I[E++]],C+=k[I[E++]],C+="-",C+=k[I[E++]],C+=k[I[E++]],C+="-",C+=k[I[E++]],C+=k[I[E++]],C+="-",C+=k[I[E++]],C+=k[I[E++]],C+="-",C+=k[I[E++]],C+=k[I[E++]],C+=k[I[E++]],C+=k[I[E++]],C+=k[I[E++]],C+=k[I[E++]],C}}()}),function(){"use strict";function se(e,y,t){function P(w){return new Promise(d=>y.exists(w,d))}function I(w){return new Promise((d,g)=>{const p=new Date;y.utimes(w,p,p,m=>m?g(m):d())})}function k(w){return new Promise((d,g)=>y.mkdir(w,{recursive:!0},p=>p&&p.code!=="EEXIST"?g(p):d(w)))}function b(w){return new Promise((d,g)=>y.rm(w,{recursive:!0,force:!0,maxRetries:3},p=>p?g(p):d()))}function E(w){return new Promise((d,g)=>y.readFile(w,"utf8",(p,m)=>p?g(p):d(m)))}function C(w,d){return new Promise((g,p)=>y.writeFile(w,d,"utf8",m=>m?p(m):g()))}async function T(w){const d=e.join(w,"languagepacks.json");try{return JSON.parse(await E(d))}catch{}}function R(w,d){try{for(;d;){if(w[d])return d;{const g=d.lastIndexOf("-");if(g>0)d=d.substring(0,g);else return}}}catch(g){console.error("Resolving language pack configuration failed.",g)}}function S(w,d,g,p){if(p==="pseudo")return Promise.resolve({locale:p,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:p,availableLanguages:{}});if(p&&(p==="en"||p==="en-us"))return Promise.resolve({locale:p,availableLanguages:{}});const m=p;t.mark("code/willGenerateNls");const v=function(u){return t.mark("code/didGenerateNls"),Promise.resolve({locale:u,availableLanguages:{}})};try{return w?T(d).then(u=>{if(!u||(p=R(u,p),!p))return v(m);const l=u[p];let h;return!l||typeof l.hash!="string"||!l.translations||typeof(h=l.translations.vscode)!="string"?v(m):P(h).then(i=>{if(!i)return v(m);const r=l.hash+"."+p,n=e.join(d,"clp",r),s=e.join(n,w),a=e.join(n,"tcf.json"),f=e.join(n,"corrupted.info"),o={locale:m,availableLanguages:{"*":p},_languagePackId:r,_translationsConfigFile:a,_cacheRoot:n,_resolvedLanguagePackCoreLocation:s,_corruptedFile:f};return P(f).then(c=>{let D;return c?D=b(n):D=Promise.resolve(void 0),D.then(()=>P(s).then(O=>O?(I(s).catch(()=>{}),t.mark("code/didGenerateNls"),o):k(s).then(()=>Promise.all([E(g),E(h)])).then(H=>{const re=JSON.parse(H[0]),ce=JSON.parse(H[1]).contents,ae=Object.keys(re.bundles),N=[];for(const J of ae){const B=re.bundles[J],x=Object.create(null);for(const z of B){const j=re.keys[z],L=re.messages[z],F=ce[z];let G;if(F){G=[];for(let oe=0;oe<j.length;oe++){const fe=j[oe],ee=typeof fe=="string"?fe:fe.key;let te=F[ee];te===void 0&&(te=L[oe]),G.push(te)}}else G=L;x[z]=G}N.push(C(e.join(s,J.replace(/\//g,"!")+".nls.json"),JSON.stringify(x)))}return N.push(C(a,JSON.stringify(l.translations))),Promise.all(N)}).then(()=>(t.mark("code/didGenerateNls"),o)).catch(H=>(console.error("Generating translation files failed.",H),v(p)))))})})}):v(m)}catch(u){return console.error("Generating translation files failed.",u),v(p)}}return{getNLSConfiguration:S}}if(typeof define=="function")define(we[140],ye([88,28,45]),function(e,y,t){return se(e,y,t)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("fs"),t=require("../common/performance");module.exports=se(e,y,t)}else throw new Error("Unknown context")}(),define(we[141],ye([1,0,29]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(k){const b=k.replace(/\-/g,":").toLowerCase();return!t.has(b)}function I(){const k=(0,y.networkInterfaces)();for(const b in k){const E=k[b];if(E){for(const{mac:C}of E)if(P(C))return C}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=I}),define(we[142],ye([1,0,89]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(b,E,C,T=1){let R=!1;return new Promise(S=>{const w=setTimeout(()=>{if(!R)return R=!0,S(0)},C);P(b,E,T,d=>{if(!R)return R=!0,clearTimeout(w),S(d)})})}e.findFreePort=t;function P(b,E,C,T){if(E===0)return T(0);const R=new y.Socket;R.once("connect",()=>(k(R),P(b+C,E-1,C,T))),R.once("data",()=>{}),R.once("error",S=>(k(R),S.code!=="ECONNREFUSED"?P(b+C,E-1,C,T):T(b))),R.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(b,E,C,T="127.0.0.1"){let R=!1,S,w=1;const d=y.createServer({pauseOnConnect:!0});function g(p,m){R||(R=!0,d.removeAllListeners(),d.close(),S&&clearTimeout(S),m(p))}return new Promise(p=>{S=setTimeout(()=>{g(0,p)},C),d.on("listening",()=>{g(b,p)}),d.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&w<E?(b++,w++,d.listen(b,T)):g(0,p)}),d.on("close",()=>{g(0,p)}),d.listen(b,T)})}e.findFreePortFaster=I;function k(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(E){console.error(E)}}}),define(we[90],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class y{constructor(P,I){this.lineNumber=P,this.column=I}with(P=this.lineNumber,I=this.column){return P===this.lineNumber&&I===this.column?this:new y(P,I)}delta(P=0,I=0){return this.with(this.lineNumber+P,this.column+I)}equals(P){return y.equals(this,P)}static equals(P,I){return!P&&!I?!0:!!P&&!!I&&P.lineNumber===I.lineNumber&&P.column===I.column}isBefore(P){return y.isBefore(this,P)}static isBefore(P,I){return P.lineNumber<I.lineNumber?!0:I.lineNumber<P.lineNumber?!1:P.column<I.column}isBeforeOrEqual(P){return y.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,I){return P.lineNumber<I.lineNumber?!0:I.lineNumber<P.lineNumber?!1:P.column<=I.column}static compare(P,I){const k=P.lineNumber|0,b=I.lineNumber|0;if(k===b){const E=P.column|0,C=I.column|0;return E-C}return k-b}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new y(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}e.Position=y}),define(we[46],ye([1,0,90]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(I,k,b,E){I>b||I===b&&k>E?(this.startLineNumber=b,this.startColumn=E,this.endLineNumber=I,this.endColumn=k):(this.startLineNumber=I,this.startColumn=k,this.endLineNumber=b,this.endColumn=E)}isEmpty(){return t.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return t.containsPosition(this,I)}static containsPosition(I,k){return!(k.lineNumber<I.startLineNumber||k.lineNumber>I.endLineNumber||k.lineNumber===I.startLineNumber&&k.column<I.startColumn||k.lineNumber===I.endLineNumber&&k.column>I.endColumn)}static strictContainsPosition(I,k){return!(k.lineNumber<I.startLineNumber||k.lineNumber>I.endLineNumber||k.lineNumber===I.startLineNumber&&k.column<=I.startColumn||k.lineNumber===I.endLineNumber&&k.column>=I.endColumn)}containsRange(I){return t.containsRange(this,I)}static containsRange(I,k){return!(k.startLineNumber<I.startLineNumber||k.endLineNumber<I.startLineNumber||k.startLineNumber>I.endLineNumber||k.endLineNumber>I.endLineNumber||k.startLineNumber===I.startLineNumber&&k.startColumn<I.startColumn||k.endLineNumber===I.endLineNumber&&k.endColumn>I.endColumn)}strictContainsRange(I){return t.strictContainsRange(this,I)}static strictContainsRange(I,k){return!(k.startLineNumber<I.startLineNumber||k.endLineNumber<I.startLineNumber||k.startLineNumber>I.endLineNumber||k.endLineNumber>I.endLineNumber||k.startLineNumber===I.startLineNumber&&k.startColumn<=I.startColumn||k.endLineNumber===I.endLineNumber&&k.endColumn>=I.endColumn)}plusRange(I){return t.plusRange(this,I)}static plusRange(I,k){let b,E,C,T;return k.startLineNumber<I.startLineNumber?(b=k.startLineNumber,E=k.startColumn):k.startLineNumber===I.startLineNumber?(b=k.startLineNumber,E=Math.min(k.startColumn,I.startColumn)):(b=I.startLineNumber,E=I.startColumn),k.endLineNumber>I.endLineNumber?(C=k.endLineNumber,T=k.endColumn):k.endLineNumber===I.endLineNumber?(C=k.endLineNumber,T=Math.max(k.endColumn,I.endColumn)):(C=I.endLineNumber,T=I.endColumn),new t(b,E,C,T)}intersectRanges(I){return t.intersectRanges(this,I)}static intersectRanges(I,k){let b=I.startLineNumber,E=I.startColumn,C=I.endLineNumber,T=I.endColumn;const R=k.startLineNumber,S=k.startColumn,w=k.endLineNumber,d=k.endColumn;return b<R?(b=R,E=S):b===R&&(E=Math.max(E,S)),C>w?(C=w,T=d):C===w&&(T=Math.min(T,d)),b>C||b===C&&E>T?null:new t(b,E,C,T)}equalsRange(I){return t.equalsRange(this,I)}static equalsRange(I,k){return!I&&!k?!0:!!I&&!!k&&I.startLineNumber===k.startLineNumber&&I.startColumn===k.startColumn&&I.endLineNumber===k.endLineNumber&&I.endColumn===k.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(I){return new y.Position(I.endLineNumber,I.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(I){return new y.Position(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,k){return new t(this.startLineNumber,this.startColumn,I,k)}setStartPosition(I,k){return new t(I,k,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(I){return new t(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static collapseToStart(I){return new t(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}static fromPositions(I,k=I){return new t(I.lineNumber,I.column,k.lineNumber,k.column)}static lift(I){return I?new t(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,k){return!(I.endLineNumber<k.startLineNumber||I.endLineNumber===k.startLineNumber&&I.endColumn<k.startColumn||k.endLineNumber<I.startLineNumber||k.endLineNumber===I.startLineNumber&&k.endColumn<I.startColumn)}static areIntersecting(I,k){return!(I.endLineNumber<k.startLineNumber||I.endLineNumber===k.startLineNumber&&I.endColumn<=k.startColumn||k.endLineNumber<I.startLineNumber||k.endLineNumber===I.startLineNumber&&k.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,k){if(I&&k){const C=I.startLineNumber|0,T=k.startLineNumber|0;if(C===T){const R=I.startColumn|0,S=k.startColumn|0;if(R===S){const w=I.endLineNumber|0,d=k.endLineNumber|0;if(w===d){const g=I.endColumn|0,p=k.endColumn|0;return g-p}return w-d}return R-S}return C-T}return(I?1:0)-(k?1:0)}static compareRangesUsingEnds(I,k){return I.endLineNumber===k.endLineNumber?I.endColumn===k.endColumn?I.startLineNumber===k.startLineNumber?I.startColumn-k.startColumn:I.startLineNumber-k.startLineNumber:I.endColumn-k.endColumn:I.endLineNumber-k.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.Range=t}),define(we[143],ye([8,9]),function(se,e){return se.create("vs/base/common/date",e)}),define(we[144],ye([1,0,143]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,P=t*60,I=P*24,k=I*7,b=I*30,E=I*365;function C(R,S,w){typeof R!="number"&&(R=R.getTime());const d=Math.round((new Date().getTime()-R)/1e3);if(d<-30)return(0,y.localize)(0,null,C(new Date().getTime()+d*1e3,!1));if(d<30)return(0,y.localize)(1,null);let g;return d<t?(g=d,S?g===1?w?(0,y.localize)(2,null,g):(0,y.localize)(3,null,g):w?(0,y.localize)(4,null,g):(0,y.localize)(5,null,g):g===1?w?(0,y.localize)(6,null,g):(0,y.localize)(7,null,g):w?(0,y.localize)(8,null,g):(0,y.localize)(9,null,g)):d<P?(g=Math.floor(d/t),S?g===1?w?(0,y.localize)(10,null,g):(0,y.localize)(11,null,g):w?(0,y.localize)(12,null,g):(0,y.localize)(13,null,g):g===1?w?(0,y.localize)(14,null,g):(0,y.localize)(15,null,g):w?(0,y.localize)(16,null,g):(0,y.localize)(17,null,g)):d<I?(g=Math.floor(d/P),S?g===1?w?(0,y.localize)(18,null,g):(0,y.localize)(19,null,g):w?(0,y.localize)(20,null,g):(0,y.localize)(21,null,g):g===1?w?(0,y.localize)(22,null,g):(0,y.localize)(23,null,g):w?(0,y.localize)(24,null,g):(0,y.localize)(25,null,g)):d<k?(g=Math.floor(d/I),S?g===1?(0,y.localize)(26,null,g):(0,y.localize)(27,null,g):g===1?(0,y.localize)(28,null,g):(0,y.localize)(29,null,g)):d<b?(g=Math.floor(d/k),S?g===1?w?(0,y.localize)(30,null,g):(0,y.localize)(31,null,g):w?(0,y.localize)(32,null,g):(0,y.localize)(33,null,g):g===1?w?(0,y.localize)(34,null,g):(0,y.localize)(35,null,g):w?(0,y.localize)(36,null,g):(0,y.localize)(37,null,g)):d<E?(g=Math.floor(d/b),S?g===1?w?(0,y.localize)(38,null,g):(0,y.localize)(39,null,g):w?(0,y.localize)(40,null,g):(0,y.localize)(41,null,g):g===1?w?(0,y.localize)(42,null,g):(0,y.localize)(43,null,g):w?(0,y.localize)(44,null,g):(0,y.localize)(45,null,g)):(g=Math.floor(d/E),S?g===1?w?(0,y.localize)(46,null,g):(0,y.localize)(47,null,g):w?(0,y.localize)(48,null,g):(0,y.localize)(49,null,g):g===1?w?(0,y.localize)(50,null,g):(0,y.localize)(51,null,g):w?(0,y.localize)(52,null,g):(0,y.localize)(53,null,g))}e.fromNow=C;function T(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(we[145],ye([8,9]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(we[38],ye([1,0,18,13,145]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function I(R,S){return S&&(R.stack||R.stacktrace)?P.localize(0,null,b(R),k(R.stack)||k(R.stacktrace)):b(R)}function k(R){return Array.isArray(R)?R.join(`
`):R}function b(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?P.localize(1,null,R.message):R.message||P.localize(2,null)}function E(R=null,S=!1){if(!R)return P.localize(3,null);if(Array.isArray(R)){const w=y.coalesce(R),d=E(w[0],S);return w.length>1?P.localize(4,null,d,w.length):d}if(t.isString(R))return R;if(R.detail){const w=R.detail;if(w.error)return I(w.error,S);if(w.exception)return I(w.exception,S)}return R.stack?I(R,S):R.message?R.message:P.localize(5,null)}e.toErrorMessage=E;function C(R){const S=R;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=C;function T(R,S){let w;return typeof R=="string"?w=new Error(R):w=R,w.actions=S,w}e.createErrorWithActions=T}),define(we[146],ye([8,9]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(we[147],ye([1,0,146]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(P){switch(P){case 1:return(0,y.localize)(0,null);case 2:return(0,y.localize)(1,null);case 3:return(0,y.localize)(2,null);case 4:return(0,y.localize)(3,null);case 5:return(0,y.localize)(4,null);case 6:return(0,y.localize)(5,null);case 7:return(0,y.localize)(6,null);case 8:return(0,y.localize)(7,null);case 9:return(0,y.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(we[148],ye([8,9]),function(se,e){return se.create("vs/base/common/platform",e)}),define(we[3],ye([1,0,148]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,P=!1,I=!1,k=!1,b=!1,E=!1,C=!1,T=!1,R=!1,S=!1,w,d=e.LANGUAGE_DEFAULT,g,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?m=e.globals.vscode.process:typeof process<"u"&&(m=process);const v=typeof m?.versions?.electron=="string",u=v&&m?.type==="renderer";if(typeof navigator=="object"&&!u)p=navigator.userAgent,t=p.indexOf("Windows")>=0,P=p.indexOf("Macintosh")>=0,T=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=p.indexOf("Linux")>=0,S=p?.indexOf("Mobi")>=0,E=!0,w=y.getConfiguredDefaultLocale(y.localize(0,null))||e.LANGUAGE_DEFAULT,d=w;else if(typeof m=="object"){t=m.platform==="win32",P=m.platform==="darwin",I=m.platform==="linux",k=I&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,C=v,R=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const o=m.env.VSCODE_NLS_CONFIG;if(o)try{const c=JSON.parse(o),D=c.availableLanguages["*"];w=c.locale,d=D||e.LANGUAGE_DEFAULT,g=c._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var l;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(l=e.Platform||(e.Platform={}));function h(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=h;let i=0;P?i=1:t?i=3:I&&(i=2),e.isWindows=t,e.isMacintosh=P,e.isLinux=I,e.isLinuxSnap=k,e.isNative=b,e.isElectron=C,e.isWeb=E,e.isWebWorker=E&&typeof e.globals.importScripts=="function",e.isIOS=T,e.isMobile=S,e.isCI=R,e.platform=i,e.userAgent=p,e.language=d;var r;(function(o){function c(){return e.language}o.value=c;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=D;function O(){return e.language==="en"}o.isDefault=O})(r=e.Language||(e.Language={})),e.locale=w,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let O=0,H=o.length;O<H;O++){const re=o[O];if(re.id===D.data.vscodeScheduleAsyncWork){o.splice(O,1),re.callback();return}}});let c=0;return D=>{const O=++c;o.push({id:O,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:O},"*")}}return o=>setTimeout(o)})();var n;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||T?2:t?1:3;let s=!0,a=!1;function f(){if(!a){a=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,s=new Uint16Array(o.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=f,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(we[27],ye([1,0,3]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof y.globals.vscode<"u"&&typeof y.globals.vscode.process<"u"){const P=y.globals.vscode.process;t={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(we[6],ye([1,0,27]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,P=97,I=90,k=122,b=46,E=47,C=92,T=58,R=63;class S extends Error{constructor(l,h,i){let r;typeof h=="string"&&h.indexOf("not ")===0?(r="must not be",h=h.replace(/^not /,"")):r="must be";const n=l.indexOf(".")!==-1?"property":"argument";let s=`The "${l}" ${n} ${r} of type ${h}`;s+=`. Received type ${typeof i}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function w(u,l){if(typeof u!="string")throw new S(l,"string",u)}function d(u){return u===E||u===C}function g(u){return u===E}function p(u){return u>=t&&u<=I||u>=P&&u<=k}function m(u,l,h,i){let r="",n=0,s=-1,a=0,f=0;for(let o=0;o<=u.length;++o){if(o<u.length)f=u.charCodeAt(o);else{if(i(f))break;f=E}if(i(f)){if(!(s===o-1||a===1))if(a===2){if(r.length<2||n!==2||r.charCodeAt(r.length-1)!==b||r.charCodeAt(r.length-2)!==b){if(r.length>2){const c=r.lastIndexOf(h);c===-1?(r="",n=0):(r=r.slice(0,c),n=r.length-1-r.lastIndexOf(h)),s=o,a=0;continue}else if(r.length!==0){r="",n=0,s=o,a=0;continue}}l&&(r+=r.length>0?`${h}..`:"..",n=2)}else r.length>0?r+=`${h}${u.slice(s+1,o)}`:r=u.slice(s+1,o),n=o-s-1;s=o,a=0}else f===b&&a!==-1?++a:a=-1}return r}function v(u,l){if(l===null||typeof l!="object")throw new S("pathObject","Object",l);const h=l.dir||l.root,i=l.base||`${l.name||""}${l.ext||""}`;return h?h===l.root?`${h}${i}`:`${h}${u}${i}`:i}e.win32={resolve(...u){let l="",h="",i=!1;for(let r=u.length-1;r>=-1;r--){let n;if(r>=0){if(n=u[r],w(n,"path"),n.length===0)continue}else l.length===0?n=y.cwd():(n=y.env[`=${l}`]||y.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==l.toLowerCase()&&n.charCodeAt(2)===C)&&(n=`${l}\\`));const s=n.length;let a=0,f="",o=!1;const c=n.charCodeAt(0);if(s===1)d(c)&&(a=1,o=!0);else if(d(c))if(o=!0,d(n.charCodeAt(1))){let D=2,O=D;for(;D<s&&!d(n.charCodeAt(D));)D++;if(D<s&&D!==O){const H=n.slice(O,D);for(O=D;D<s&&d(n.charCodeAt(D));)D++;if(D<s&&D!==O){for(O=D;D<s&&!d(n.charCodeAt(D));)D++;(D===s||D!==O)&&(f=`\\\\${H}\\${n.slice(O,D)}`,a=D)}}}else a=1;else p(c)&&n.charCodeAt(1)===T&&(f=n.slice(0,2),a=2,s>2&&d(n.charCodeAt(2))&&(o=!0,a=3));if(f.length>0)if(l.length>0){if(f.toLowerCase()!==l.toLowerCase())continue}else l=f;if(i){if(l.length>0)break}else if(h=`${n.slice(a)}\\${h}`,i=o,o&&l.length>0)break}return h=m(h,!i,"\\",d),i?`${l}\\${h}`:`${l}${h}`||"."},normalize(u){w(u,"path");const l=u.length;if(l===0)return".";let h=0,i,r=!1;const n=u.charCodeAt(0);if(l===1)return g(n)?"\\":u;if(d(n))if(r=!0,d(u.charCodeAt(1))){let a=2,f=a;for(;a<l&&!d(u.charCodeAt(a));)a++;if(a<l&&a!==f){const o=u.slice(f,a);for(f=a;a<l&&d(u.charCodeAt(a));)a++;if(a<l&&a!==f){for(f=a;a<l&&!d(u.charCodeAt(a));)a++;if(a===l)return`\\\\${o}\\${u.slice(f)}\\`;a!==f&&(i=`\\\\${o}\\${u.slice(f,a)}`,h=a)}}}else h=1;else p(n)&&u.charCodeAt(1)===T&&(i=u.slice(0,2),h=2,l>2&&d(u.charCodeAt(2))&&(r=!0,h=3));let s=h<l?m(u.slice(h),!r,"\\",d):"";return s.length===0&&!r&&(s="."),s.length>0&&d(u.charCodeAt(l-1))&&(s+="\\"),i===void 0?r?`\\${s}`:s:r?`${i}\\${s}`:`${i}${s}`},isAbsolute(u){w(u,"path");const l=u.length;if(l===0)return!1;const h=u.charCodeAt(0);return d(h)||l>2&&p(h)&&u.charCodeAt(1)===T&&d(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let l,h;for(let n=0;n<u.length;++n){const s=u[n];w(s,"path"),s.length>0&&(l===void 0?l=h=s:l+=`\\${s}`)}if(l===void 0)return".";let i=!0,r=0;if(typeof h=="string"&&d(h.charCodeAt(0))){++r;const n=h.length;n>1&&d(h.charCodeAt(1))&&(++r,n>2&&(d(h.charCodeAt(2))?++r:i=!1))}if(i){for(;r<l.length&&d(l.charCodeAt(r));)r++;r>=2&&(l=`\\${l.slice(r)}`)}return e.win32.normalize(l)},relative(u,l){if(w(u,"from"),w(l,"to"),u===l)return"";const h=e.win32.resolve(u),i=e.win32.resolve(l);if(h===i||(u=h.toLowerCase(),l=i.toLowerCase(),u===l))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===C;)r++;let n=u.length;for(;n-1>r&&u.charCodeAt(n-1)===C;)n--;const s=n-r;let a=0;for(;a<l.length&&l.charCodeAt(a)===C;)a++;let f=l.length;for(;f-1>a&&l.charCodeAt(f-1)===C;)f--;const o=f-a,c=s<o?s:o;let D=-1,O=0;for(;O<c;O++){const re=u.charCodeAt(r+O);if(re!==l.charCodeAt(a+O))break;re===C&&(D=O)}if(O!==c){if(D===-1)return i}else{if(o>c){if(l.charCodeAt(a+O)===C)return i.slice(a+O+1);if(O===2)return i.slice(a+O)}s>c&&(u.charCodeAt(r+O)===C?D=O:O===2&&(D=3)),D===-1&&(D=0)}let H="";for(O=r+D+1;O<=n;++O)(O===n||u.charCodeAt(O)===C)&&(H+=H.length===0?"..":"\\..");return a+=D,H.length>0?`${H}${i.slice(a,f)}`:(i.charCodeAt(a)===C&&++a,i.slice(a,f))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const l=e.win32.resolve(u);if(l.length<=2)return u;if(l.charCodeAt(0)===C){if(l.charCodeAt(1)===C){const h=l.charCodeAt(2);if(h!==R&&h!==b)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(p(l.charCodeAt(0))&&l.charCodeAt(1)===T&&l.charCodeAt(2)===C)return`\\\\?\\${l}`;return u},dirname(u){w(u,"path");const l=u.length;if(l===0)return".";let h=-1,i=0;const r=u.charCodeAt(0);if(l===1)return d(r)?u:".";if(d(r)){if(h=i=1,d(u.charCodeAt(1))){let a=2,f=a;for(;a<l&&!d(u.charCodeAt(a));)a++;if(a<l&&a!==f){for(f=a;a<l&&d(u.charCodeAt(a));)a++;if(a<l&&a!==f){for(f=a;a<l&&!d(u.charCodeAt(a));)a++;if(a===l)return u;a!==f&&(h=i=a+1)}}}}else p(r)&&u.charCodeAt(1)===T&&(h=l>2&&d(u.charCodeAt(2))?3:2,i=h);let n=-1,s=!0;for(let a=l-1;a>=i;--a)if(d(u.charCodeAt(a))){if(!s){n=a;break}}else s=!1;if(n===-1){if(h===-1)return".";n=h}return u.slice(0,n)},basename(u,l){l!==void 0&&w(l,"ext"),w(u,"path");let h=0,i=-1,r=!0,n;if(u.length>=2&&p(u.charCodeAt(0))&&u.charCodeAt(1)===T&&(h=2),l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let s=l.length-1,a=-1;for(n=u.length-1;n>=h;--n){const f=u.charCodeAt(n);if(d(f)){if(!r){h=n+1;break}}else a===-1&&(r=!1,a=n+1),s>=0&&(f===l.charCodeAt(s)?--s===-1&&(i=n):(s=-1,i=a))}return h===i?i=a:i===-1&&(i=u.length),u.slice(h,i)}for(n=u.length-1;n>=h;--n)if(d(u.charCodeAt(n))){if(!r){h=n+1;break}}else i===-1&&(r=!1,i=n+1);return i===-1?"":u.slice(h,i)},extname(u){w(u,"path");let l=0,h=-1,i=0,r=-1,n=!0,s=0;u.length>=2&&u.charCodeAt(1)===T&&p(u.charCodeAt(0))&&(l=i=2);for(let a=u.length-1;a>=l;--a){const f=u.charCodeAt(a);if(d(f)){if(!n){i=a+1;break}continue}r===-1&&(n=!1,r=a+1),f===b?h===-1?h=a:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||r===-1||s===0||s===1&&h===r-1&&h===i+1?"":u.slice(h,r)},format:v.bind(null,"\\"),parse(u){w(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const h=u.length;let i=0,r=u.charCodeAt(0);if(h===1)return d(r)?(l.root=l.dir=u,l):(l.base=l.name=u,l);if(d(r)){if(i=1,d(u.charCodeAt(1))){let D=2,O=D;for(;D<h&&!d(u.charCodeAt(D));)D++;if(D<h&&D!==O){for(O=D;D<h&&d(u.charCodeAt(D));)D++;if(D<h&&D!==O){for(O=D;D<h&&!d(u.charCodeAt(D));)D++;D===h?i=D:D!==O&&(i=D+1)}}}}else if(p(r)&&u.charCodeAt(1)===T){if(h<=2)return l.root=l.dir=u,l;if(i=2,d(u.charCodeAt(2))){if(h===3)return l.root=l.dir=u,l;i=3}}i>0&&(l.root=u.slice(0,i));let n=-1,s=i,a=-1,f=!0,o=u.length-1,c=0;for(;o>=i;--o){if(r=u.charCodeAt(o),d(r)){if(!f){s=o+1;break}continue}a===-1&&(f=!1,a=o+1),r===b?n===-1?n=o:c!==1&&(c=1):n!==-1&&(c=-1)}return a!==-1&&(n===-1||c===0||c===1&&n===a-1&&n===s+1?l.base=l.name=u.slice(s,a):(l.name=u.slice(s,n),l.base=u.slice(s,a),l.ext=u.slice(n,a))),s>0&&s!==i?l.dir=u.slice(0,s-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let l="",h=!1;for(let i=u.length-1;i>=-1&&!h;i--){const r=i>=0?u[i]:y.cwd();w(r,"path"),r.length!==0&&(l=`${r}/${l}`,h=r.charCodeAt(0)===E)}return l=m(l,!h,"/",g),h?`/${l}`:l.length>0?l:"."},normalize(u){if(w(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===E,h=u.charCodeAt(u.length-1)===E;return u=m(u,!l,"/",g),u.length===0?l?"/":h?"./":".":(h&&(u+="/"),l?`/${u}`:u)},isAbsolute(u){return w(u,"path"),u.length>0&&u.charCodeAt(0)===E},join(...u){if(u.length===0)return".";let l;for(let h=0;h<u.length;++h){const i=u[h];w(i,"path"),i.length>0&&(l===void 0?l=i:l+=`/${i}`)}return l===void 0?".":e.posix.normalize(l)},relative(u,l){if(w(u,"from"),w(l,"to"),u===l||(u=e.posix.resolve(u),l=e.posix.resolve(l),u===l))return"";const h=1,i=u.length,r=i-h,n=1,s=l.length-n,a=r<s?r:s;let f=-1,o=0;for(;o<a;o++){const D=u.charCodeAt(h+o);if(D!==l.charCodeAt(n+o))break;D===E&&(f=o)}if(o===a)if(s>a){if(l.charCodeAt(n+o)===E)return l.slice(n+o+1);if(o===0)return l.slice(n+o)}else r>a&&(u.charCodeAt(h+o)===E?f=o:o===0&&(f=0));let c="";for(o=h+f+1;o<=i;++o)(o===i||u.charCodeAt(o)===E)&&(c+=c.length===0?"..":"/..");return`${c}${l.slice(n+f)}`},toNamespacedPath(u){return u},dirname(u){if(w(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===E;let h=-1,i=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===E){if(!i){h=r;break}}else i=!1;return h===-1?l?"/":".":l&&h===1?"//":u.slice(0,h)},basename(u,l){l!==void 0&&w(l,"ext"),w(u,"path");let h=0,i=-1,r=!0,n;if(l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let s=l.length-1,a=-1;for(n=u.length-1;n>=0;--n){const f=u.charCodeAt(n);if(f===E){if(!r){h=n+1;break}}else a===-1&&(r=!1,a=n+1),s>=0&&(f===l.charCodeAt(s)?--s===-1&&(i=n):(s=-1,i=a))}return h===i?i=a:i===-1&&(i=u.length),u.slice(h,i)}for(n=u.length-1;n>=0;--n)if(u.charCodeAt(n)===E){if(!r){h=n+1;break}}else i===-1&&(r=!1,i=n+1);return i===-1?"":u.slice(h,i)},extname(u){w(u,"path");let l=-1,h=0,i=-1,r=!0,n=0;for(let s=u.length-1;s>=0;--s){const a=u.charCodeAt(s);if(a===E){if(!r){h=s+1;break}continue}i===-1&&(r=!1,i=s+1),a===b?l===-1?l=s:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||i===-1||n===0||n===1&&l===i-1&&l===h+1?"":u.slice(l,i)},format:v.bind(null,"/"),parse(u){w(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const h=u.charCodeAt(0)===E;let i;h?(l.root="/",i=1):i=0;let r=-1,n=0,s=-1,a=!0,f=u.length-1,o=0;for(;f>=i;--f){const c=u.charCodeAt(f);if(c===E){if(!a){n=f+1;break}continue}s===-1&&(a=!1,s=f+1),c===b?r===-1?r=f:o!==1&&(o=1):r!==-1&&(o=-1)}if(s!==-1){const c=n===0&&h?1:n;r===-1||o===0||o===1&&r===s-1&&r===n+1?l.base=l.name=u.slice(c,s):(l.name=u.slice(c,r),l.base=u.slice(c,s),l.ext=u.slice(r,s))}return n>0?l.dir=u.slice(0,n-1):h&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=y.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y.platform==="win32"?e.win32.join:e.posix.join,e.resolve=y.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=y.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=y.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=y.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=y.platform==="win32"?e.win32.extname:e.posix.extname,e.format=y.platform==="win32"?e.win32.format:e.posix.format,e.parse=y.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=y.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=y.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[68],ye([1,0,6]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(T){const R=(0,y.extname)(T),S=t[R.toLowerCase()];return S!==void 0?S:k(T)}e.getMediaOrTextMime=I;function k(T){const R=(0,y.extname)(T);return P[R.toLowerCase()]}e.getMediaMime=k;function b(T){for(const R in P)if(P[R]===T)return R}e.getExtensionForMimeType=b;const E=/^(.+)\/(.+?)(;.+)?$/;function C(T,R){const S=E.exec(T);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:R?void 0:T}e.normalizeMimeType=C}),define(we[56],ye([1,0,3]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var P;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(b,...E){const C=E.reduce((S,w)=>(S[w]=!0,S),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(S=>!C[S]).forEach(S=>{for(let w=0;w<T.length;w++)if(S.search(T[w])!==-1){delete b[S];break}})}e.sanitizeProcessEnvironment=I;function k(b){!b||(delete b.DEBUG,y.isMacintosh&&delete b.DYLD_LIBRARY_PATH,y.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(we[149],ye([1,0,3]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=y.globals.performance&&typeof y.globals.performance.now=="function";class P{static create(k=!0){return new P(k)}constructor(k){this._highResolution=t&&k,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}e.StopWatch=P}),define(we[7],ye([1,0,10,66,2,86,149]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const b=!1,E=!1;var C;(function(f){f.None=()=>P.Disposable.None;function o(ie){if(E){const{onListenerDidAdd:ue}=ie,ve=d.create();let $=0;ie.onListenerDidAdd=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),ue?.()}}}function c(ie,ue){return x(ie,()=>{},0,void 0,void 0,ue)}f.defer=c;function D(ie,ue=0,ve){return f.debounce(ie,($,Q)=>$?($.push(Q),$):[Q],ue,void 0,void 0,ve)}f.accumulate=D;function O(ie){return(ue,ve=null,$)=>{let Q=!1,Y;return Y=ie(W=>{if(!Q)return Y?Y.dispose():Q=!0,ue.call(ve,W)},null,$),Q&&Y.dispose(),Y}}f.once=O;function H(ie,ue,ve){return B(($,Q=null,Y)=>ie(W=>$.call(Q,ue(W)),null,Y),ve)}f.map=H;function re(ie,ue,ve){return B(($,Q=null,Y)=>ie(W=>{ue(W),$.call(Q,W)},null,Y),ve)}f.forEach=re;function ce(ie,ue,ve){return B(($,Q=null,Y)=>ie(W=>ue(W)&&$.call(Q,W),null,Y),ve)}f.filter=ce;function ae(ie){return ie}f.signal=ae;function N(...ie){return(ue,ve=null,$)=>(0,P.combinedDisposable)(...ie.map(Q=>Q(Y=>ue.call(ve,Y),null,$)))}f.any=N;function J(ie,ue,ve,$){let Q=ve;return H(ie,Y=>(Q=ue(Q,Y),Q),$)}f.reduce=J;function B(ie,ue){let ve;const $={onFirstListenerAdd(){ve=ie(Q.fire,Q)},onLastListenerRemove(){ve?.dispose()}};ue||o($);const Q=new p($);return ue?.add(Q),Q.event}function x(ie,ue,ve=100,$=!1,Q,Y){let W,V,q,X=0;const le={leakWarningThreshold:Q,onFirstListenerAdd(){W=ie(ke=>{X++,V=ue(V,ke),$&&!q&&(pe.fire(V),V=void 0),clearTimeout(q),q=setTimeout(()=>{const Te=V;V=void 0,q=void 0,(!$||X>1)&&pe.fire(Te),X=0},ve)})},onLastListenerRemove(){W.dispose()}};Y||o(le);const pe=new p(le);return Y?.add(pe),pe.event}f.debounce=x;function z(ie,ue=($,Q)=>$===Q,ve){let $=!0,Q;return ce(ie,Y=>{const W=$||!ue(Y,Q);return $=!1,Q=Y,W},ve)}f.latch=z;function j(ie,ue,ve){return[f.filter(ie,ue,ve),f.filter(ie,$=>!ue($),ve)]}f.split=j;function L(ie,ue=!1,ve=[]){let $=ve.slice(),Q=ie(V=>{$?$.push(V):W.fire(V)});const Y=()=>{$?.forEach(V=>W.fire(V)),$=null},W=new p({onFirstListenerAdd(){Q||(Q=ie(V=>W.fire(V)))},onFirstListenerDidAdd(){$&&(ue?setTimeout(Y):Y())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return W.event}f.buffer=L;class F{constructor(ue){this.event=ue,this.disposables=new P.DisposableStore}map(ue){return new F(H(this.event,ue,this.disposables))}forEach(ue){return new F(re(this.event,ue,this.disposables))}filter(ue){return new F(ce(this.event,ue,this.disposables))}reduce(ue,ve){return new F(J(this.event,ue,ve,this.disposables))}latch(){return new F(z(this.event,void 0,this.disposables))}debounce(ue,ve=100,$=!1,Q){return new F(x(this.event,ue,ve,$,Q,this.disposables))}on(ue,ve,$){return this.event(ue,ve,$)}once(ue,ve,$){return O(this.event)(ue,ve,$)}dispose(){this.disposables.dispose()}}function G(ie){return new F(ie)}f.chain=G;function oe(ie,ue,ve=$=>$){const $=(...V)=>W.fire(ve(...V)),Q=()=>ie.on(ue,$),Y=()=>ie.removeListener(ue,$),W=new p({onFirstListenerAdd:Q,onLastListenerRemove:Y});return W.event}f.fromNodeEventEmitter=oe;function fe(ie,ue,ve=$=>$){const $=(...V)=>W.fire(ve(...V)),Q=()=>ie.addEventListener(ue,$),Y=()=>ie.removeEventListener(ue,$),W=new p({onFirstListenerAdd:Q,onLastListenerRemove:Y});return W.event}f.fromDOMEventEmitter=fe;function ee(ie){return new Promise(ue=>O(ie)(ue))}f.toPromise=ee;function te(ie,ue){return ue(void 0),ie(ve=>ue(ve))}f.runAndSubscribe=te;function _(ie,ue){let ve=null;function $(Y){ve?.dispose(),ve=new P.DisposableStore,ue(Y,ve)}$(void 0);const Q=ie(Y=>$(Y));return(0,P.toDisposable)(()=>{Q.dispose(),ve?.dispose()})}f.runAndSubscribeWithStore=_;class U{constructor(ue,ve){this.obs=ue,this._counter=0,this._hasChanged=!1;const $={onFirstListenerAdd:()=>{ue.addObserver(this)},onLastListenerRemove:()=>{ue.removeObserver(this)}};ve||o($),this.emitter=new p($),ve&&ve.add(this.emitter)}beginUpdate(ue){this._counter++}handleChange(ue,ve){this._hasChanged=!0}endUpdate(ue){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Z(ie,ue){return new U(ie,ue).emitter.event}f.fromObservable=Z})(C=e.Event||(e.Event={}));class T{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${T._idPool++}`,T.all.add(this)}start(o){this._stopWatch=new k.StopWatch(!0),this.listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=T,T.all=new Set,T._idPool=0;let R=-1;function S(f){const o=R;return R=f,{dispose(){R=o}}}e.setGlobalLeakWarningThreshold=S;class w{constructor(o,c=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,c){let D=R;if(typeof this.customThreshold=="number"&&(D=this.customThreshold),D<=0||c<D)return;this._stacks||(this._stacks=new Map);const O=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,O+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=D*.5;let H,re=0;for(const[ce,ae]of this._stacks)(!H||re<ae)&&(H=ce,re=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${re}):`),console.warn(H)}return()=>{const H=this._stacks.get(o.value)||0;this._stacks.set(o.value,H-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(o,c,D){this.callback=o,this.callbackThis=c,this.stack=D,this.subscription=new P.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class p{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=R>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new T(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const c of o)c.subscription.isset()&&(c.subscription.unset(),c.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,c,D)=>{this._listeners||(this._listeners=new I.LinkedList);const O=this._listeners.isEmpty();O&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let H,re;this._leakageMon&&this._listeners.size>=30&&(re=d.create(),H=this._leakageMon.check(re,this._listeners.size+1)),b&&(re=re??d.create());const ce=new g(o,c,re),ae=this._listeners.push(ce);O&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,c);const N=ce.subscription.set(()=>{H?.(),this._disposed||(ae(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return D instanceof P.DisposableStore?D.add(N):Array.isArray(D)&&D.push(N),N}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const c of this._listeners)this._deliveryQueue.push(this,c,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=p;class m{constructor(){this._queue=new I.LinkedList}get size(){return this._queue.size}push(o,c,D){this._queue.push(new u(o,c,D))}clear(o){const c=new I.LinkedList;for(const D of this._queue)D.emitter!==o&&c.push(D);this._queue=c}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(c){(0,y.onUnexpectedError)(c)}}}}e.EventDeliveryQueue=m;class v extends m{clear(o){this._queue.clear()}}class u{constructor(o,c,D){this.emitter=o,this.listener=c,this.event=D}}class l extends p{async fireAsync(o,c,D){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new I.LinkedList);for(const O of this._listeners)this._asyncDeliveryQueue.push([O,o]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[O,H]=this._asyncDeliveryQueue.shift(),re=[],ce={...H,token:c,waitUntil:ae=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");D&&(ae=D(ae,O.callback)),re.push(ae)}};try{O.invoke(ce)}catch(ae){(0,y.onUnexpectedError)(ae);continue}Object.freeze(re),await Promise.allSettled(re).then(ae=>{for(const N of ae)N.status==="rejected"&&(0,y.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=l;class h extends p{constructor(o){super(o),this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=h;class i extends h{constructor(o){super(o),this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=i;class r extends p{constructor(o){super(o),this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){!this.hasListeners()||(this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(c=>super.fire(c)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=r;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const c={event:o,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const D=()=>{this.hasListeners&&this.unhook(c);const O=this.events.indexOf(c);this.events.splice(O,1)};return(0,P.toDisposable)((0,t.once)(D))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(c=>this.emitter.fire(c))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class s{constructor(){this.buffers=[]}wrapEvent(o){return(c,D,O)=>o(H=>{const re=this.buffers[this.buffers.length-1];re?re.push(()=>c.call(D,H)):c.call(D,H)},void 0,O)}bufferEvents(o){const c=[];this.buffers.push(c);const D=o();return this.buffers.pop(),c.forEach(O=>O()),D}}e.EventBufferer=s;class a{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=P.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(we[20],ye([1,0,7]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(b,E){const C=setTimeout(b.bind(E),0);return{dispose(){clearTimeout(C)}}});var P;(function(b){function E(C){return C===b.None||C===b.Cancelled||C instanceof I?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}b.isCancellationToken=E,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(P=e.CancellationToken||(e.CancellationToken={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=P.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=k}),define(we[150],ye([1,0,20]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new y.CancellationTokenSource,E=this.task(b.token);return this.result={promise:E,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=t;class P{constructor(b){this.fn=b,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const E=JSON.stringify(b);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(b)),this.lastCache}}e.LRUCachedFunction=P;class I{get cachedValues(){return this._map}constructor(b){this.fn=b,this._map=new Map}get(b){if(this._map.has(b))return this._map.get(b);const E=this.fn(b);return this._map.set(b,E),E}}e.CachedFunction=I}),define(we[91],ye([1,0,7,2]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const P=k=>({onDidChange:y.Event.None,value:k});e.staticObservableValue=P;class I extends t.Disposable{get value(){return this._value}set value(b){b!==this._value&&(this._value=b,this.changeEmitter.fire(b))}constructor(b){super(),this._value=b,this.changeEmitter=this._register(new y.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=I}),define(we[15],ye([1,0,150,137]),function(se,e,y,t){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function I(he){return!he||typeof he!="string"?!0:he.trim().length===0}e.isFalsyOrWhitespace=I;const k=/{(\d+)}/g;function b(he,...Ce){return Ce.length===0?he:he.replace(k,function(De,Re){const Fe=parseInt(Re,10);return isNaN(Fe)||Fe<0||Fe>=Ce.length?De:Ce[Fe]})}e.format=b;const E=/{([^}]+)}/g;function C(he,Ce){return he.replace(E,(De,Re)=>Ce[Re]??De)}e.format2=C;function T(he){return he.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=T;function R(he){return he.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function S(he,Ce){let De=0;const Re=Ce.charCodeAt(0);for(let Fe=he.length-1;Fe>=0;Fe--)he.charCodeAt(Fe)===Re&&De++;return De}e.count=S;function w(he,Ce,De="\u2026"){return he.length<=Ce?he:`${he.substr(0,Ce)}${De}`}e.truncate=w;function d(he,Ce=" "){const De=g(he,Ce);return p(De,Ce)}e.trim=d;function g(he,Ce){if(!he||!Ce)return he;const De=Ce.length;if(De===0||he.length===0)return he;let Re=0;for(;he.indexOf(Ce,Re)===Re;)Re=Re+De;return he.substring(Re)}e.ltrim=g;function p(he,Ce){if(!he||!Ce)return he;const De=Ce.length,Re=he.length;if(De===0||Re===0)return he;let Fe=Re,ze=-1;for(;ze=he.lastIndexOf(Ce,Fe-1),!(ze===-1||ze+De!==Fe);){if(ze===0)return"";Fe=ze}return he.substring(0,Fe)}e.rtrim=p;function m(he){return he.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function v(he){return he.replace(/\*/g,"")}e.stripWildcards=v;function u(he,Ce,De={}){if(!he)throw new Error("Cannot create regex from empty string");Ce||(he=R(he)),De.wholeWord&&(/\B/.test(he.charAt(0))||(he="\\b"+he),/\B/.test(he.charAt(he.length-1))||(he=he+"\\b"));let Re="";return De.global&&(Re+="g"),De.matchCase||(Re+="i"),De.multiline&&(Re+="m"),De.unicode&&(Re+="u"),new RegExp(he,Re)}e.createRegExp=u;function l(he){return he.source==="^"||he.source==="^$"||he.source==="$"||he.source==="^\\s*$"?!1:!!(he.exec("")&&he.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function h(he){return!!he.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=h;function i(he){return(he.global?"g":"")+(he.ignoreCase?"i":"")+(he.multiline?"m":"")+(he.unicode?"u":"")}e.regExpFlags=i;function r(he){return he.split(/\r\n|\r|\n/)}e.splitLines=r;function n(he){for(let Ce=0,De=he.length;Ce<De;Ce++){const Re=he.charCodeAt(Ce);if(Re!==32&&Re!==9)return Ce}return-1}e.firstNonWhitespaceIndex=n;function s(he,Ce=0,De=he.length){for(let Re=Ce;Re<De;Re++){const Fe=he.charCodeAt(Re);if(Fe!==32&&Fe!==9)return he.substring(Ce,Re)}return he.substring(Ce,De)}e.getLeadingWhitespace=s;function a(he,Ce=he.length-1){for(let De=Ce;De>=0;De--){const Re=he.charCodeAt(De);if(Re!==32&&Re!==9)return De}return-1}e.lastNonWhitespaceIndex=a;function f(he,Ce,De){const Re=[];let Fe=0;for(const ze of he.matchAll(Ce)){if(Re.push(he.slice(Fe,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Fe=ze.index+ze[0].length,Re.push(De(ze[0],...ze.slice(1),ze.index,he,ze.groups))}return Re.push(he.slice(Fe)),Promise.all(Re).then(ze=>ze.join(""))}e.replaceAsync=f;function o(he,Ce){return he<Ce?-1:he>Ce?1:0}e.compare=o;function c(he,Ce,De=0,Re=he.length,Fe=0,ze=Ce.length){for(;De<Re&&Fe<ze;De++,Fe++){const it=he.charCodeAt(De),Je=Ce.charCodeAt(Fe);if(it<Je)return-1;if(it>Je)return 1}const je=Re-De,rt=ze-Fe;return je<rt?-1:je>rt?1:0}e.compareSubstring=c;function D(he,Ce){return O(he,Ce,0,he.length,0,Ce.length)}e.compareIgnoreCase=D;function O(he,Ce,De=0,Re=he.length,Fe=0,ze=Ce.length){for(;De<Re&&Fe<ze;De++,Fe++){let it=he.charCodeAt(De),Je=Ce.charCodeAt(Fe);if(it===Je)continue;if(it>=128||Je>=128)return c(he.toLowerCase(),Ce.toLowerCase(),De,Re,Fe,ze);re(it)&&(it-=32),re(Je)&&(Je-=32);const ot=it-Je;if(ot!==0)return ot}const je=Re-De,rt=ze-Fe;return je<rt?-1:je>rt?1:0}e.compareSubstringIgnoreCase=O;function H(he){return he>=48&&he<=57}e.isAsciiDigit=H;function re(he){return he>=97&&he<=122}e.isLowerAsciiLetter=re;function ce(he){return he>=65&&he<=90}e.isUpperAsciiLetter=ce;function ae(he,Ce){return he.length===Ce.length&&O(he,Ce)===0}e.equalsIgnoreCase=ae;function N(he,Ce){const De=Ce.length;return Ce.length>he.length?!1:O(he,Ce,0,De)===0}e.startsWithIgnoreCase=N;function J(he,Ce){const De=Math.min(he.length,Ce.length);let Re;for(Re=0;Re<De;Re++)if(he.charCodeAt(Re)!==Ce.charCodeAt(Re))return Re;return De}e.commonPrefixLength=J;function B(he,Ce){const De=Math.min(he.length,Ce.length);let Re;const Fe=he.length-1,ze=Ce.length-1;for(Re=0;Re<De;Re++)if(he.charCodeAt(Fe-Re)!==Ce.charCodeAt(ze-Re))return Re;return De}e.commonSuffixLength=B;function x(he){return 55296<=he&&he<=56319}e.isHighSurrogate=x;function z(he){return 56320<=he&&he<=57343}e.isLowSurrogate=z;function j(he,Ce){return(he-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=j;function L(he,Ce,De){const Re=he.charCodeAt(De);if(x(Re)&&De+1<Ce){const Fe=he.charCodeAt(De+1);if(z(Fe))return j(Re,Fe)}return Re}e.getNextCodePoint=L;function F(he,Ce){const De=he.charCodeAt(Ce-1);if(z(De)&&Ce>1){const Re=he.charCodeAt(Ce-2);if(x(Re))return j(Re,De)}return De}class G{get offset(){return this._offset}constructor(Ce,De=0){this._str=Ce,this._len=Ce.length,this._offset=De}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=F(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=L(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=G;class oe{get offset(){return this._iterator.offset}constructor(Ce,De=0){this._iterator=new G(Ce,De)}nextGraphemeLength(){const Ce=Ke.getInstance(),De=this._iterator,Re=De.offset;let Fe=Ce.getGraphemeBreakType(De.nextCodePoint());for(;!De.eol();){const ze=De.offset,je=Ce.getGraphemeBreakType(De.nextCodePoint());if(Ne(Fe,je)){De.setOffset(ze);break}Fe=je}return De.offset-Re}prevGraphemeLength(){const Ce=Ke.getInstance(),De=this._iterator,Re=De.offset;let Fe=Ce.getGraphemeBreakType(De.prevCodePoint());for(;De.offset>0;){const ze=De.offset,je=Ce.getGraphemeBreakType(De.prevCodePoint());if(Ne(je,Fe)){De.setOffset(ze);break}Fe=je}return Re-De.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=oe;function fe(he,Ce){return new oe(he,Ce).nextGraphemeLength()}e.nextCharLength=fe;function ee(he,Ce){return new oe(he,Ce).prevGraphemeLength()}e.prevCharLength=ee;function te(he,Ce){Ce>0&&z(he.charCodeAt(Ce))&&Ce--;const De=Ce+fe(he,Ce);return[De-ee(he,De),De]}e.getCharContainingOffset=te;function _(he){const Ce=new oe(he);let De=0;for(;!Ce.eol();)De++,Ce.nextGraphemeLength();return De}e.charCount=_;let U;function Z(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(he){return U||(U=Z()),U.test(he)}e.containsRTL=ie;const ue=/^[\t\n\r\x20-\x7E]*$/;function ve(he){return ue.test(he)}e.isBasicASCII=ve,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function $(he){return e.UNUSUAL_LINE_TERMINATORS.test(he)}e.containsUnusualLineTerminators=$;function Q(he){return he>=11904&&he<=55215||he>=63744&&he<=64255||he>=65281&&he<=65374}e.isFullWidthCharacter=Q;function Y(he){return he>=127462&&he<=127487||he===8986||he===8987||he===9200||he===9203||he>=9728&&he<=10175||he===11088||he===11093||he>=127744&&he<=128591||he>=128640&&he<=128764||he>=128992&&he<=129008||he>=129280&&he<=129535||he>=129648&&he<=129782}e.isEmojiImprecise=Y;function W(he,Ce){if(he.length<Ce)return he;const De=/\b/g;let Re=0;for(;De.test(he)&&!(he.length-De.lastIndex<Ce);)Re=De.lastIndex,De.lastIndex+=1;return he.substring(Re).replace(/^\s/,"")}e.lcut=W;const V=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,X=/\x1b\[0?m/g;function le(he){return he&&(he=he.replace(V,""),he=he.replace(q,""),he=he.replace(X,"")),he}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(he){return!!(he&&he.length>0&&he.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function ke(he){return pe(he)?he.substr(1):he}e.stripUTF8BOM=ke;function Te(he,Ce){if(!he||!Ce||he.length<Ce.length)return!1;const De=Ce.length,Re=he.toLowerCase();let Fe=0,ze=-1;for(;Fe<De;){const je=Re.indexOf(Ce[Fe],ze+1);if(je<0)return!1;ze=je,Fe++}return!0}e.fuzzyContains=Te;function Me(he,Ce=!1){return he?(Ce&&(he=he.replace(/\\./g,"")),he.toLowerCase()!==he):!1}e.containsUppercaseCharacter=Me;function Oe(he){return he.charAt(0).toUpperCase()+he.slice(1)}e.uppercaseFirstLetter=Oe;function me(he,Ce=1){if(Ce===0)return"";let De=-1;do De=he.indexOf(`
`,De+1),Ce--;while(Ce>0&&De>=0);return De===-1?he:(he[De-1]==="\r"&&De--,he.substr(0,De))}e.getNLines=me;function be(he){return he=he%(2*26),he<26?String.fromCharCode(97+he):String.fromCharCode(65+he-26)}e.singleLetterHash=be;function Ee(he){return Ke.getInstance().getGraphemeBreakType(he)}e.getGraphemeBreakType=Ee;function Ne(he,Ce){return he===0?Ce!==5&&Ce!==7:he===2&&Ce===3?!1:he===4||he===2||he===3||Ce===4||Ce===2||Ce===3?!0:!(he===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(he===11||he===9)&&(Ce===9||Ce===10)||(he===12||he===10)&&Ce===10||Ce===5||Ce===13||Ce===7||he===1||he===13&&Ce===14||he===6&&Ce===6)}var Be;(function(he){he[he.Other=0]="Other",he[he.Prepend=1]="Prepend",he[he.CR=2]="CR",he[he.LF=3]="LF",he[he.Control=4]="Control",he[he.Extend=5]="Extend",he[he.Regional_Indicator=6]="Regional_Indicator",he[he.SpacingMark=7]="SpacingMark",he[he.L=8]="L",he[he.V=9]="V",he[he.T=10]="T",he[he.LV=11]="LV",he[he.LVT=12]="LVT",he[he.ZWJ=13]="ZWJ",he[he.Extended_Pictographic=14]="Extended_Pictographic"})(Be=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ke{static getInstance(){return Ke._INSTANCE||(Ke._INSTANCE=new Ke),Ke._INSTANCE}constructor(){this._data=He()}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const De=this._data,Re=De.length/3;let Fe=1;for(;Fe<=Re;)if(Ce<De[3*Fe])Fe=2*Fe;else if(Ce>De[3*Fe+1])Fe=2*Fe+1;else return De[3*Fe+2];return 0}}Ke._INSTANCE=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(he,Ce){if(he===0)return 0;const De=Xe(he,Ce);if(De!==void 0)return De;const Re=new G(Ce,he);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=Ge;function Xe(he,Ce){const De=new G(Ce,he);let Re=De.prevCodePoint();for(;et(Re)||Re===65039||Re===8419;){if(De.offset===0)return;Re=De.prevCodePoint()}if(!Y(Re))return;let Fe=De.offset;return Fe>0&&De.prevCodePoint()===8205&&(Fe=De.offset),Fe}function et(he){return 127995<=he&&he<=127999}var qe;(function(he){he[he.zwj=8205]="zwj",he[he.emojiVariantSelector=65039]="emojiVariantSelector",he[he.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.noBreakWhitespace="\xA0";class $e{static getInstance(Ce){return $e.cache.get(Array.from(Ce))}static getLocales(){return $e._locales.getValue()}constructor(Ce){this.confusableDictionary=Ce}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=$e,P=$e,$e.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.cache=new y.LRUCachedFunction(he=>{function Ce(Je){const ot=new Map;for(let lt=0;lt<Je.length;lt+=2)ot.set(Je[lt],Je[lt+1]);return ot}function De(Je,ot){const lt=new Map(Je);for(const[ut,ht]of ot)lt.set(ut,ht);return lt}function Re(Je,ot){if(!Je)return ot;const lt=new Map;for(const[ut,ht]of Je)ot.has(ut)&&lt.set(ut,ht);return lt}const Fe=P.ambiguousCharacterData.getValue();let ze=he.filter(Je=>!Je.startsWith("_")&&Je in Fe);ze.length===0&&(ze=["_default"]);let je;for(const Je of ze){const ot=Ce(Fe[Je]);je=Re(je,ot)}const rt=Ce(Fe._common),it=De(rt,je);return new $e(it)}),$e._locales=new t.Lazy(()=>Object.keys($e.ambiguousCharacterData.getValue()).filter(he=>!he.startsWith("_")));class xe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(xe.getRawData())),this._data}static isInvisibleCharacter(Ce){return xe.getData().has(Ce)}static get codePoints(){return xe.getData()}}e.InvisibleCharacters=xe,xe._data=void 0}),define(we[36],ye([1,0,6,3,15,13]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(a){return a===47||a===92}e.isPathSeparator=k;function b(a){return a.replace(/[\\/]/g,y.posix.sep)}e.toSlashes=b;function E(a){return a.indexOf("/")===-1&&(a=b(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=E;function C(a,f=y.posix.sep){if(!a)return"";const o=a.length,c=a.charCodeAt(0);if(k(c)){if(k(a.charCodeAt(1))&&!k(a.charCodeAt(2))){let O=3;const H=O;for(;O<o&&!k(a.charCodeAt(O));O++);if(H!==O&&!k(a.charCodeAt(O+1))){for(O+=1;O<o;O++)if(k(a.charCodeAt(O)))return a.slice(0,O+1).replace(/[\\/]/g,f)}}return f}else if(m(c)&&a.charCodeAt(1)===58)return k(a.charCodeAt(2))?a.slice(0,2)+f:a.slice(0,2);let D=a.indexOf("://");if(D!==-1){for(D+=3;D<o;D++)if(k(a.charCodeAt(D)))return a.slice(0,D+1)}return""}e.getRoot=C;function T(a){if(!t.isWindows||!a||a.length<5)return!1;let f=a.charCodeAt(0);if(f!==92||(f=a.charCodeAt(1),f!==92))return!1;let o=2;const c=o;for(;o<a.length&&(f=a.charCodeAt(o),f!==92);o++);return!(c===o||(f=a.charCodeAt(o+1),isNaN(f)||f===92))}e.isUNC=T;const R=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(a,f=t.isWindows){const o=f?R:S;return!(!a||a.length===0||/^\s+$/.test(a)||(o.lastIndex=0,o.test(a))||f&&w.test(a)||a==="."||a===".."||f&&a[a.length-1]==="."||f&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=d;function g(a,f,o){const c=a===f;return!o||c?c:!a||!f?!1:(0,P.equalsIgnoreCase)(a,f)}e.isEqual=g;function p(a,f,o,c=y.sep){if(a===f)return!0;if(!a||!f||f.length>a.length)return!1;if(o){if(!(0,P.startsWithIgnoreCase)(a,f))return!1;if(f.length===a.length)return!0;let O=f.length;return f.charAt(f.length-1)===c&&O--,a.charAt(O)===c}return f.charAt(f.length-1)!==c&&(f+=c),a.indexOf(f)===0}e.isEqualOrParent=p;function m(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=m;function v(a,f){return t.isWindows&&a.endsWith(":")&&(a+=y.sep),(0,y.isAbsolute)(a)||(a=(0,y.join)(f,a)),a=(0,y.normalize)(a),t.isWindows?(a=(0,P.rtrim)(a,y.sep),a.endsWith(":")&&(a+=y.sep)):(a=(0,P.rtrim)(a,y.sep),a||(a=y.sep)),a}e.sanitizeFilePath=v;function u(a){const f=(0,y.normalize)(a);return t.isWindows?a.length>3?!1:l(f)&&(a.length===2||f.charCodeAt(2)===92):f===y.posix.sep}e.isRootOrDriveLetter=u;function l(a,f=t.isWindows){return f?m(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function h(a){return l(a)?a[0]:void 0}e.getDriveLetter=h;function i(a,f,o){return f.length>a.length?-1:a===f?0:(o&&(a=a.toLowerCase(),f=f.toLowerCase()),a.indexOf(f))}e.indexOfPath=i;function r(a){const f=a.split(":");let o,c,D;for(const O of f){const H=Number(O);(0,I.isNumber)(H)?c===void 0?c=H:D===void 0&&(D=H):o=o?[o,O].join(":"):O}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:c!==void 0?c:void 0,column:D!==void 0?D:c!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(a,f,o=8){let c="";for(let O=0;O<o;O++)c+=n.charAt(Math.floor(Math.random()*n.length));let D;return f?D=`${f}-${c}`:D=c,a?(0,y.join)(a,D):D}e.randomPath=s}),define(we[151],ye([1,0,31,15]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function P(...q){return function(X,le){for(let pe=0,ke=q.length;pe<ke;pe++){const Te=q[pe](X,le);if(Te)return Te}return null}}e.or=P,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(q,X,le){if(!le||le.length<X.length)return null;let pe;return q?pe=t.startsWithIgnoreCase(le,X):pe=le.indexOf(X)===0,pe?X.length>0?[{start:0,end:X.length}]:[]:null}function k(q,X){const le=X.toLowerCase().indexOf(q.toLowerCase());return le===-1?null:[{start:le,end:le+q.length}]}e.matchesContiguousSubString=k;function b(q,X){return E(q.toLowerCase(),X.toLowerCase(),0,0)}e.matchesSubString=b;function E(q,X,le,pe){if(le===q.length)return[];if(pe===X.length)return null;if(q[le]===X[pe]){let ke=null;return(ke=E(q,X,le+1,pe+1))?m({start:pe,end:pe+1},ke):null}return E(q,X,le,pe+1)}function C(q){return 97<=q&&q<=122}function T(q){return 65<=q&&q<=90}e.isUpper=T;function R(q){return 48<=q&&q<=57}function S(q){return q===32||q===9||q===10||q===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(q=>w.add(q.charCodeAt(0)));function d(q){return S(q)||w.has(q)}function g(q,X){return q===X||d(q)&&d(X)}function p(q){return C(q)||T(q)||R(q)}function m(q,X){return X.length===0?X=[q]:q.end===X[0].start?X[0].start=q.start:X.unshift(q),X}function v(q,X){for(let le=X;le<q.length;le++){const pe=q.charCodeAt(le);if(T(pe)||R(pe)||le>0&&!p(q.charCodeAt(le-1)))return le}return q.length}function u(q,X,le,pe){if(le===q.length)return[];if(pe===X.length)return null;if(q[le]!==X[pe].toLowerCase())return null;{let ke=null,Te=pe+1;for(ke=u(q,X,le+1,pe+1);!ke&&(Te=v(X,Te))<X.length;)ke=u(q,X,le+1,Te),Te++;return ke===null?null:m({start:pe,end:pe+1},ke)}}function l(q){let X=0,le=0,pe=0,ke=0,Te=0;for(let Ee=0;Ee<q.length;Ee++)Te=q.charCodeAt(Ee),T(Te)&&X++,C(Te)&&le++,p(Te)&&pe++,R(Te)&&ke++;const Me=X/q.length,Oe=le/q.length,me=pe/q.length,be=ke/q.length;return{upperPercent:Me,lowerPercent:Oe,alphaPercent:me,numericPercent:be}}function h(q){const{upperPercent:X,lowerPercent:le}=q;return le===0&&X>.6}function i(q){const{upperPercent:X,lowerPercent:le,alphaPercent:pe,numericPercent:ke}=q;return le>.2&&X<.8&&pe>.6&&ke<.2}function r(q){let X=0,le=0,pe=0,ke=0;for(let Te=0;Te<q.length;Te++)pe=q.charCodeAt(Te),T(pe)&&X++,C(pe)&&le++,S(pe)&&ke++;return(X===0||le===0)&&ke===0?q.length<=30:X<=5}function n(q,X){if(!X||(X=X.trim(),X.length===0)||!r(q)||X.length>60)return null;const le=l(X);if(!i(le)){if(!h(le))return null;X=X.toLowerCase()}let pe=null,ke=0;for(q=q.toLowerCase();ke<X.length&&(pe=u(q,X,0,ke))===null;)ke=v(X,ke+1);return pe}e.matchesCamelCase=n;function s(q,X,le=!1){if(!X||X.length===0)return null;let pe=null,ke=0;for(q=q.toLowerCase(),X=X.toLowerCase();ke<X.length&&(pe=a(q,X,0,ke,le))===null;)ke=f(X,ke+1);return pe}e.matchesWords=s;function a(q,X,le,pe,ke){if(le===q.length)return[];if(pe===X.length)return null;if(g(q.charCodeAt(le),X.charCodeAt(pe))){let Te=null,Me=pe+1;if(Te=a(q,X,le+1,pe+1,ke),!ke)for(;!Te&&(Me=f(X,Me))<X.length;)Te=a(q,X,le+1,Me,ke),Me++;return Te?q.charCodeAt(le)!==X.charCodeAt(pe)?Te:m({start:pe,end:pe+1},Te):null}else return null}function f(q,X){for(let le=X;le<q.length;le++)if(d(q.charCodeAt(le))||le>0&&d(q.charCodeAt(le-1)))return le;return q.length}const o=P(e.matchesPrefix,n,k),c=P(e.matchesPrefix,n,b),D=new y.LRUCache(1e4);function O(q,X,le=!1){if(typeof q!="string"||typeof X!="string")return null;let pe=D.get(q);pe||(pe=new RegExp(t.convertSimple2RegExpPattern(q),"i"),D.set(q,pe));const ke=pe.exec(X);return ke?[{start:ke.index,end:ke.index+ke[0].length}]:le?c(q,X):o(q,X)}e.matchesFuzzy=O;function H(q,X){const le=ue(q,q.toLowerCase(),0,X,X.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return le?ce(le):null}e.matchesFuzzy2=H;function re(q,X,le,pe,ke,Te){const Me=Math.min(13,q.length);for(;le<Me;le++){const Oe=ue(q,X,le,pe,ke,Te,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Oe)return Oe}return[0,Te]}e.anyScore=re;function ce(q){if(typeof q>"u")return[];const X=[],le=q[1];for(let pe=q.length-1;pe>1;pe--){const ke=q[pe]+le,Te=X[X.length-1];Te&&Te.end===ke?Te.end=ke+1:X.push({start:ke,end:ke+1})}return X}e.createMatches=ce;const ae=128;function N(){const q=[],X=[];for(let le=0;le<=ae;le++)X[le]=0;for(let le=0;le<=ae;le++)q.push(X.slice(0));return q}function J(q){const X=[];for(let le=0;le<=q;le++)X[le]=0;return X}const B=J(2*ae),x=J(2*ae),z=N(),j=N(),L=N(),F=!1;function G(q,X,le,pe,ke){function Te(Oe,me,be=" "){for(;Oe.length<me;)Oe=be+Oe;return Oe}let Me=` |   |${pe.split("").map(Oe=>Te(Oe,3)).join("|")}
`;for(let Oe=0;Oe<=le;Oe++)Oe===0?Me+=" |":Me+=`${X[Oe-1]}|`,Me+=q[Oe].slice(0,ke+1).map(me=>Te(me.toString(),3)).join("|")+`
`;return Me}function oe(q,X,le,pe){q=q.substr(X),le=le.substr(pe),console.log(G(j,q,q.length,le,le.length)),console.log(G(L,q,q.length,le,le.length)),console.log(G(z,q,q.length,le,le.length))}function fe(q,X){if(X<0||X>=q.length)return!1;const le=q.codePointAt(X);switch(le){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(le)}}function ee(q,X){if(X<0||X>=q.length)return!1;switch(q.charCodeAt(X)){case 32:case 9:return!0;default:return!1}}function te(q,X,le){return X[q]!==le[q]}function _(q,X,le,pe,ke,Te,Me=!1){for(;X<le&&ke<Te;)q[X]===pe[ke]&&(Me&&(B[X]=ke),X+=1),ke+=1;return X===le}e.isPatternInWord=_;var U;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(U||(U={}));var Z;(function(q){q.Default=[-100,0];function X(le){return!le||le.length===2&&le[0]===-100&&le[1]===0}q.isDefault=X})(Z=e.FuzzyScore||(e.FuzzyScore={}));class ie{constructor(X,le){this.firstMatchCanBeWeak=X,this.boostFullMatch=le}}e.FuzzyScoreOptions=ie,ie.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ue(q,X,le,pe,ke,Te,Me=ie.default){const Oe=q.length>ae?ae:q.length,me=pe.length>ae?ae:pe.length;if(le>=Oe||Te>=me||Oe-le>me-Te||!_(X,le,Oe,ke,Te,me,!0))return;ve(Oe,me,le,Te,X,ke);let be=1,Ee=1,Ne=le,Be=Te;const Ke=[!1];for(be=1,Ne=le;Ne<Oe;be++,Ne++){const qe=B[Ne],$e=x[Ne],xe=Ne+1<Oe?x[Ne+1]:me;for(Ee=qe-Te+1,Be=qe;Be<xe;Ee++,Be++){let he=Number.MIN_SAFE_INTEGER,Ce=!1;Be<=$e&&(he=$(q,X,Ne,le,pe,ke,Be,me,Te,z[be-1][Ee-1]===0,Ke));let De=0;he!==Number.MAX_SAFE_INTEGER&&(Ce=!0,De=he+j[be-1][Ee-1]);const Re=Be>qe,Fe=Re?j[be][Ee-1]+(z[be][Ee-1]>0?-5:0):0,ze=Be>qe+1&&z[be][Ee-1]>0,je=ze?j[be][Ee-2]+(z[be][Ee-2]>0?-5:0):0;if(ze&&(!Re||je>=Fe)&&(!Ce||je>=De))j[be][Ee]=je,L[be][Ee]=3,z[be][Ee]=0;else if(Re&&(!Ce||Fe>=De))j[be][Ee]=Fe,L[be][Ee]=2,z[be][Ee]=0;else if(Ce)j[be][Ee]=De,L[be][Ee]=1,z[be][Ee]=z[be-1][Ee-1]+1;else throw new Error("not possible")}}if(F&&oe(q,le,pe,Te),!Ke[0]&&!Me.firstMatchCanBeWeak)return;be--,Ee--;const He=[j[be][Ee],Te];let Ge=0,Xe=0;for(;be>=1;){let qe=Ee;do{const $e=L[be][qe];if($e===3)qe=qe-2;else if($e===2)qe=qe-1;else break}while(qe>=1);Ge>1&&X[le+be-1]===ke[Te+Ee-1]&&!te(qe+Te-1,pe,ke)&&Ge+1>z[be][qe]&&(qe=Ee),qe===Ee?Ge++:Ge=1,Xe||(Xe=qe),be--,Ee=qe-1,He.push(Ee)}me===Oe&&Me.boostFullMatch&&(He[0]+=2);const et=Xe-Oe;return He[0]-=et,He}e.fuzzyScore=ue;function ve(q,X,le,pe,ke,Te){let Me=q-1,Oe=X-1;for(;Me>=le&&Oe>=pe;)ke[Me]===Te[Oe]&&(x[Me]=Oe,Me--),Oe--}function $(q,X,le,pe,ke,Te,Me,Oe,me,be,Ee){if(X[le]!==Te[Me])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return Me===le-pe?Ne=q[le]===ke[Me]?7:5:te(Me,ke,Te)&&(Me===0||!te(Me-1,ke,Te))?(Ne=q[le]===ke[Me]?7:5,Be=!0):fe(Te,Me)&&(Me===0||!fe(Te,Me-1))?Ne=5:(fe(Te,Me-1)||ee(Te,Me-1))&&(Ne=5,Be=!0),Ne>1&&le===pe&&(Ee[0]=!0),Be||(Be=te(Me,ke,Te)||fe(Te,Me-1)||ee(Te,Me-1)),le===pe?Me>me&&(Ne-=Be?3:5):be?Ne+=Be?2:0:Ne+=Be?0:1,Me+1===Oe&&(Ne-=Be?3:5),Ne}function Q(q,X,le,pe,ke,Te,Me){return W(q,X,le,pe,ke,Te,!0,Me)}e.fuzzyScoreGracefulAggressive=Q;function Y(q,X,le,pe,ke,Te,Me){return W(q,X,le,pe,ke,Te,!1,Me)}e.fuzzyScoreGraceful=Y;function W(q,X,le,pe,ke,Te,Me,Oe){let me=ue(q,X,le,pe,ke,Te,Oe);if(me&&!Me)return me;if(q.length>=3){const be=Math.min(7,q.length-1);for(let Ee=le+1;Ee<be;Ee++){const Ne=V(q,Ee);if(Ne){const Be=ue(Ne,Ne.toLowerCase(),le,pe,ke,Te,Oe);Be&&(Be[0]-=3,(!me||Be[0]>me[0])&&(me=Be))}}}return me}function V(q,X){if(X+1>=q.length)return;const le=q[X],pe=q[X+1];if(le!==pe)return q.slice(0,X)+pe+le+q.slice(X+2)}}),define(we[92],ye([1,0,15]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return P(m,0)}e.hash=t;function P(m,v){switch(typeof m){case"object":return m===null?I(349,v):Array.isArray(m)?E(m,v):C(m,v);case"string":return b(m,v);case"boolean":return k(m,v);case"number":return I(m,v);case"undefined":return I(937,v);default:return I(617,v)}}e.doHash=P;function I(m,v){return(v<<5)-v+m|0}e.numberHash=I;function k(m,v){return I(m?433:863,v)}function b(m,v){v=I(149417,v);for(let u=0,l=m.length;u<l;u++)v=I(m.charCodeAt(u),v);return v}e.stringHash=b;function E(m,v){return v=I(104579,v),m.reduce((u,l)=>P(l,u),v)}function C(m,v){return v=I(181387,v),Object.keys(m).sort().reduce((u,l)=>(u=b(l,u),P(m[l],u)),v)}class T{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=P(v,this._value),this._value}}e.Hasher=T;var R;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function S(m,v,u=32){const l=u-v,h=~((1<<l)-1);return(m<<v|(h&m)>>>l)>>>0}function w(m,v=0,u=m.byteLength,l=0){for(let h=0;h<u;h++)m[v+h]=l}function d(m,v,u="0"){for(;m.length<v;)m=u+m;return m}function g(m,v=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(u=>u.toString(16).padStart(2,"0")).join(""):d((m>>>0).toString(16),v/4)}e.toHexString=g;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const u=v.length;if(u===0)return;const l=this._buff;let h=this._buffLen,i=this._leftoverHighSurrogate,r,n;for(i!==0?(r=i,n=-1,i=0):(r=v.charCodeAt(0),n=0);;){let s=r;if(y.isHighSurrogate(r))if(n+1<u){const a=v.charCodeAt(n+1);y.isLowSurrogate(a)?(n++,s=y.computeCodePoint(r,a)):s=65533}else{i=r;break}else y.isLowSurrogate(r)&&(s=65533);if(h=this._push(l,h,s),n++,n<u)r=v.charCodeAt(n);else break}this._buffLen=h,this._leftoverHighSurrogate=i}_push(v,u,l){return l<128?v[u++]=l:l<2048?(v[u++]=192|(l&1984)>>>6,v[u++]=128|(l&63)>>>0):l<65536?(v[u++]=224|(l&61440)>>>12,v[u++]=128|(l&4032)>>>6,v[u++]=128|(l&63)>>>0):(v[u++]=240|(l&1835008)>>>18,v[u++]=128|(l&258048)>>>12,v[u++]=128|(l&4032)>>>6,v[u++]=128|(l&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=p._bigBlock32,u=this._buffDV;for(let o=0;o<64;o+=4)v.setUint32(o,u.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,S(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let l=this._h0,h=this._h1,i=this._h2,r=this._h3,n=this._h4,s,a,f;for(let o=0;o<80;o++)o<20?(s=h&i|~h&r,a=1518500249):o<40?(s=h^i^r,a=1859775393):o<60?(s=h&i|h&r|i&r,a=2400959708):(s=h^i^r,a=3395469782),f=S(l,5)+s+n+a+v.getUint32(o*4,!1)&4294967295,n=r,r=i,i=S(h,30),h=l,l=f;this._h0=this._h0+l&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[152],ye([1,0,40,151,15]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=new RegExp(`\\$\\(${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(y.CSSIcon.iconNameCharacter),b=new RegExp(`(\\\\)?${I.source}`,"g");function E(p){return p.replace(b,(m,v)=>v?m:`\\${m}`)}e.escapeIcons=E;const C=new RegExp(`\\\\${I.source}`,"g");function T(p){return p.replace(C,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=T;const R=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function S(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(R,(m,v,u,l)=>u?m:v||l||"")}e.stripIcons=S;function w(p){const m=p.indexOf(e.iconStartMarker);return m===-1?{text:p}:d(p,m)}e.parseLabelWithIcons=w;function d(p,m){const v=[];let u="";function l(o){if(o){u+=o;for(const c of o)v.push(r)}}let h=-1,i="",r=0,n,s,a=m;const f=p.length;for(l(p.substr(0,m));a<f;)n=p[a],s=p[a+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(h=a,l(i),i=e.iconStartMarker,a++):n===")"&&h!==-1?(r+=a-h+1,h=-1,i=""):h!==-1?k.test(n)?i+=n:(l(i),h=-1,i=""):l(n),a++;return l(i),{text:u,iconOffsets:v}}function g(p,m,v=!1){const{text:u,iconOffsets:l}=m;if(!l||l.length===0)return(0,t.matchesFuzzy)(p,u,v);const h=(0,P.ltrim)(u," "),i=u.length-h.length,r=(0,t.matchesFuzzy)(p,h,v);if(r)for(const n of r){const s=l[n.start+i]+i;n.start+=s,n.end+=s}return r}e.matchesFuzzyIconAware=g}),define(we[69],ye([1,0,15]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(t||(t={})),function(P){const I="error",k="warning",b="warn",E="info",C="ignore";function T(S){return S?y.equalsIgnoreCase(I,S)?P.Error:y.equalsIgnoreCase(k,S)||y.equalsIgnoreCase(b,S)?P.Warning:y.equalsIgnoreCase(E,S)?P.Info:P.Ignore:P.Ignore}P.fromValue=T;function R(S){switch(S){case P.Error:return I;case P.Warning:return k;case P.Info:return E;default:return C}}P.toString=R}(t||(t={})),e.default=t}),define(we[57],ye([1,0,18,15]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class P{constructor(){this._value="",this._pos=0}reset(w){return this._value=w,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(w){const d=w.charCodeAt(0),g=this._value.charCodeAt(this._pos);return d-g}value(){return this._value[this._pos]}}e.StringIterator=P;class I{constructor(w=!0){this._caseSensitive=w}reset(w){return this._value=w,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let w=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(w)this._from++;else break;else w=!1;return this}cmp(w){return this._caseSensitive?(0,t.compareSubstring)(w,this._value,0,w.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(w,this._value,0,w.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class k{constructor(w=!0,d=!0){this._splitOnBackslash=w,this._caseSensitive=d}reset(w){this._from=0,this._to=0,this._value=w,this._valueLen=w.length;for(let d=w.length-1;d>=0;d--,this._valueLen--){const g=this._value.charCodeAt(d);if(!(g===47||this._splitOnBackslash&&g===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let w=!0;for(;this._to<this._valueLen;this._to++){const d=this._value.charCodeAt(this._to);if(d===47||this._splitOnBackslash&&d===92)if(w)this._from++;else break;else w=!1}return this}cmp(w){return this._caseSensitive?(0,t.compareSubstring)(w,this._value,0,w.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(w,this._value,0,w.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var b;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(b||(b={}));class E{constructor(w,d){this._ignorePathCasing=w,this._ignoreQueryAndFragment=d,this._states=[],this._stateIdx=0}reset(w){return this._value=w,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(w)),this._pathIterator.reset(w.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(w)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(w){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(w,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(w,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(w);if(this._states[this._stateIdx]===4)return(0,t.compare)(w,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(w,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=E;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(T||(T={}));class R{static forUris(w=()=>!1,d=()=>!1){return new R(new E(w,d))}static forPaths(w=!1){return new R(new k(void 0,!w))}static forStrings(){return new R(new P)}static forConfigKeys(){return new R(new I)}constructor(w){this._iter=w}clear(){this._root=void 0}fill(w,d){if(d){const g=d.slice(0);(0,y.shuffle)(g);for(const p of g)this.set(p,w)}else{const g=w.slice(0);(0,y.shuffle)(g);for(const p of g)this.set(p[0],p[1])}}set(w,d){const g=this._iter.reset(w);let p;this._root||(this._root=new C,this._root.segment=g.value());const m=[];for(p=this._root;;){const u=g.cmp(p.segment);if(u>0)p.left||(p.left=new C,p.left.segment=g.value()),m.push([-1,p]),p=p.left;else if(u<0)p.right||(p.right=new C,p.right.segment=g.value()),m.push([1,p]),p=p.right;else if(g.hasNext())g.next(),p.mid||(p.mid=new C,p.mid.segment=g.value()),m.push([0,p]),p=p.mid;else break}const v=p.value;p.value=d,p.key=w;for(let u=m.length-1;u>=0;u--){const l=m[u][1];l.updateHeight();const h=l.balanceFactor();if(h<-1||h>1){const i=m[u][0],r=m[u+1][0];if(i===1&&r===1)m[u][1]=l.rotateLeft();else if(i===-1&&r===-1)m[u][1]=l.rotateRight();else if(i===1&&r===-1)l.right=m[u+1][1]=m[u+1][1].rotateRight(),m[u][1]=l.rotateLeft();else if(i===-1&&r===1)l.left=m[u+1][1]=m[u+1][1].rotateLeft(),m[u][1]=l.rotateRight();else throw new Error;if(u>0)switch(m[u-1][0]){case-1:m[u-1][1].left=m[u][1];break;case 1:m[u-1][1].right=m[u][1];break;case 0:m[u-1][1].mid=m[u][1];break}else this._root=m[0][1]}}return v}get(w){return this._getNode(w)?.value}_getNode(w){const d=this._iter.reset(w);let g=this._root;for(;g;){const p=d.cmp(g.segment);if(p>0)g=g.left;else if(p<0)g=g.right;else if(d.hasNext())d.next(),g=g.mid;else break}return g}has(w){const d=this._getNode(w);return!(d?.value===void 0&&d?.mid===void 0)}delete(w){return this._delete(w,!1)}deleteSuperstr(w){return this._delete(w,!0)}_delete(w,d){const g=this._iter.reset(w),p=[];let m=this._root;for(;m;){const v=g.cmp(m.segment);if(v>0)p.push([-1,m]),m=m.left;else if(v<0)p.push([1,m]),m=m.right;else if(g.hasNext())g.next(),p.push([0,m]),m=m.mid;else break}if(!!m){if(d?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const v=this._min(m.right);if(v.key){const{key:u,value:l,segment:h}=v;this._delete(v.key,!1),m.key=u,m.value=l,m.segment=h}}else{const v=m.left??m.right;if(p.length>0){const[u,l]=p[p.length-1];switch(u){case-1:l.left=v;break;case 0:l.mid=v;break;case 1:l.right=v;break}}else this._root=v}for(let v=p.length-1;v>=0;v--){const u=p[v][1];u.updateHeight();const l=u.balanceFactor();if(l>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),p[v][1]=u.rotateLeft()):l<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),p[v][1]=u.rotateRight()),v>0)switch(p[v-1][0]){case-1:p[v-1][1].left=p[v][1];break;case 1:p[v-1][1].right=p[v][1];break;case 0:p[v-1][1].mid=p[v][1];break}else this._root=p[0][1]}}}_min(w){for(;w.left;)w=w.left;return w}findSubstr(w){const d=this._iter.reset(w);let g=this._root,p;for(;g;){const m=d.cmp(g.segment);if(m>0)g=g.left;else if(m<0)g=g.right;else if(d.hasNext())d.next(),p=g.value||p,g=g.mid;else break}return g&&g.value||p}findSuperstr(w){const d=this._iter.reset(w);let g=this._root;for(;g;){const p=d.cmp(g.segment);if(p>0)g=g.left;else if(p<0)g=g.right;else if(d.hasNext())d.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(w){for(const[d,g]of this)w(g,d)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(w){const d=[];return this._dfsEntries(w,d),d[Symbol.iterator]()}_dfsEntries(w,d){!w||(w.left&&this._dfsEntries(w.left,d),w.value&&d.push([w.key,w.value]),w.mid&&this._dfsEntries(w.mid,d),w.right&&this._dfsEntries(w.right,d))}_isBalanced(){const w=d=>{if(!d)return!0;const g=d.balanceFactor();return g<-1||g>1?!1:w(d.left)&&w(d.right)};return w(this._root)}}e.TernarySearchTree=R}),define(we[4],ye([1,0,6,3]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,I=/^\//,k=/^\/\//;function b(n,s){if(!n.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!P.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!I.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(n,s){return!n&&!s?"file":n}function C(n,s){switch(n){case"https":case"http":case"file":s?s[0]!==R&&(s=R+s):s=R;break}return s}const T="",R="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{static isUri(s){return s instanceof w?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,a,f,o,c,D=!1){typeof s=="object"?(this.scheme=s.scheme||T,this.authority=s.authority||T,this.path=s.path||T,this.query=s.query||T,this.fragment=s.fragment||T):(this.scheme=E(s,D),this.authority=a||T,this.path=C(this.scheme,f||T),this.query=o||T,this.fragment=c||T,b(this,D))}get fsPath(){return u(this,!1)}with(s){if(!s)return this;let{scheme:a,authority:f,path:o,query:c,fragment:D}=s;return a===void 0?a=this.scheme:a===null&&(a=T),f===void 0?f=this.authority:f===null&&(f=T),o===void 0?o=this.path:o===null&&(o=T),c===void 0?c=this.query:c===null&&(c=T),D===void 0?D=this.fragment:D===null&&(D=T),a===this.scheme&&f===this.authority&&o===this.path&&c===this.query&&D===this.fragment?this:new g(a,f,o,c,D)}static parse(s,a=!1){const f=S.exec(s);return f?new g(f[2]||T,r(f[4]||T),r(f[5]||T),r(f[7]||T),r(f[9]||T),a):new g(T,T,T,T,T)}static file(s){let a=T;if(t.isWindows&&(s=s.replace(/\\/g,R)),s[0]===R&&s[1]===R){const f=s.indexOf(R,2);f===-1?(a=s.substring(2),s=R):(a=s.substring(2,f),s=s.substring(f)||R)}return new g("file",a,s,T,T)}static from(s){const a=new g(s.scheme,s.authority,s.path,s.query,s.fragment);return b(a,!0),a}static joinPath(s,...a){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return t.isWindows&&s.scheme==="file"?f=w.file(y.win32.join(u(s,!0),...a)).path:f=y.posix.join(s.path,...a),s.with({path:f})}toString(s=!1){return l(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof w)return s;{const a=new g(s);return a._formatted=s.external,a._fsPath=s._sep===d?s.fsPath:null,a}}else return s}}e.URI=w;const d=t.isWindows?1:void 0;class g extends w{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(s=!1){return s?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(n,s){let a,f=-1;for(let o=0;o<n.length;o++){const c=n.charCodeAt(o);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||s&&c===47)f!==-1&&(a+=encodeURIComponent(n.substring(f,o)),f=-1),a!==void 0&&(a+=n.charAt(o));else{a===void 0&&(a=n.substr(0,o));const D=p[c];D!==void 0?(f!==-1&&(a+=encodeURIComponent(n.substring(f,o)),f=-1),a+=D):f===-1&&(f=o)}}return f!==-1&&(a+=encodeURIComponent(n.substring(f))),a!==void 0?a:n}function v(n){let s;for(let a=0;a<n.length;a++){const f=n.charCodeAt(a);f===35||f===63?(s===void 0&&(s=n.substr(0,a)),s+=p[f]):s!==void 0&&(s+=n[a])}return s!==void 0?s:n}function u(n,s){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?s?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,t.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=u;function l(n,s){const a=s?v:m;let f="",{scheme:o,authority:c,path:D,query:O,fragment:H}=n;if(o&&(f+=o,f+=":"),(c||o==="file")&&(f+=R,f+=R),c){let re=c.indexOf("@");if(re!==-1){const ce=c.substr(0,re);c=c.substr(re+1),re=ce.indexOf(":"),re===-1?f+=a(ce,!1):(f+=a(ce.substr(0,re),!1),f+=":",f+=a(ce.substr(re+1),!1)),f+="@"}c=c.toLowerCase(),re=c.indexOf(":"),re===-1?f+=a(c,!1):(f+=a(c.substr(0,re),!1),f+=c.substr(re))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const re=D.charCodeAt(1);re>=65&&re<=90&&(D=`/${String.fromCharCode(re+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const re=D.charCodeAt(0);re>=65&&re<=90&&(D=`${String.fromCharCode(re+32)}:${D.substr(2)}`)}f+=a(D,!0)}return O&&(f+="?",f+=a(O,!1)),H&&(f+="#",f+=s?H:m(H,!1)),f}function h(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+h(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(i)?n.replace(i,s=>h(s)):n}}),define(we[153],ye([1,0,4]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(C){const T=C;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=t;function P(C){const T=[];let R;try{const S=JSON.parse(C.arguments),w=S[S.length-1];w&&w.__$stack&&(S.pop(),R=w.__$stack),T.push(...S)}catch{T.push("Unable to log remote console arguments",C.arguments)}return{args:T,stack:R}}e.parse=P;function I(C){if(typeof C!="string")return I(P(C).stack);const T=C;if(T){const R=k(T),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(S&&S.length===4)return{uri:y.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=I;function k(C){if(!C)return C;const T=C.indexOf(`
`);return T===-1?C:C.substring(0,T)}function b(C,T){const{args:R,stack:S}=P(C),w=typeof R[0]=="string"&&R.length===1;let d=k(S);d&&(d=`(${d.trim()})`);let g=[];if(typeof R[0]=="string"?d&&w?g=[`%c[${T}] %c${R[0]} %c${d}`,E("blue"),E(""),E("grey")]:g=[`%c[${T}] %c${R[0]}`,E("blue"),E(""),...R.slice(1)]:g=[`%c[${T}]%`,E("blue"),...R],d&&!w&&g.push(d),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,g)}e.log=b;function E(C){return`color: ${C}`}}),define(we[47],ye([1,0,16,15,4]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(C){return JSON.stringify(C,b)}e.stringify=I;function k(C){let T=JSON.parse(C);return T=E(T),T}e.parse=k;function b(C,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,t.regExpFlags)(T)}:T}function E(C,T=0){if(!C||T>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return P.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 15:return new Date(C.source)}if(C instanceof y.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let R=0;R<C.length;++R)C[R]=E(C[R],T+1);else for(const R in C)Object.hasOwnProperty.call(C,R)&&(C[R]=E(C[R],T+1))}return C}e.revive=E}),define(we[11],ye([1,0,3,4]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var P;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(P=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${P.vscodeRemoteResource}`}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}setServerRootPath(C){this._remoteResourcesPath=`${C}/${P.vscodeRemoteResource}`}set(C,T,R){this._hosts[C]=T,this._ports[C]=R}setConnectionToken(C,T){this._connectionTokens[C]=T}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(C){if(this._delegate)return this._delegate(C);const T=C.authority;let R=this._hosts[T];R&&R.indexOf(":")!==-1&&R.indexOf("[")===-1&&(R=`[${R}]`);const S=this._ports[T],w=this._connectionTokens[T];let d=`path=${encodeURIComponent(C.path)}`;return typeof w=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(w)}`),t.URI.from({scheme:y.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${R}:${S}`,path:this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new I;class k{asBrowserUri(C,T){const R=this.toUri(C,T);return R.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===P.file&&(y.isNative||y.isWebWorker&&y.globals.origin===`${P.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?R.with({scheme:P.vscodeFileResource,authority:R.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(C,T){const R=this.toUri(C,T);return R.scheme===P.vscodeFileResource?R.with({scheme:P.file,authority:R.authority!==k.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(C,T){return t.URI.isUri(C)?C:t.URI.parse(T.toUrl(C))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k;var b;(function(E){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(C.get("3"));const T="vscode-coi";function R(w){let d;typeof w=="string"?d=new URL(w).searchParams:w instanceof URL?d=w.searchParams:t.URI.isUri(w)&&(d=new URL(w.toString(!0)).searchParams);const g=d?.get(T);if(!!g)return C.get(g)}E.getHeadersFromQuery=R;function S(w,d,g){if(!globalThis.crossOriginIsolated)return;const p=d&&g?"3":g?"2":"1";w instanceof URLSearchParams?w.set(T,p):w[T]=p}E.addSearchParam=S})(b=e.COI||(e.COI={}))}),define(we[19],ye([1,0,36,11,6,3,15,4]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(w){return(0,b.uriToFsPath)(w,!0)}e.originalFSPath=E;class C{constructor(d){this._ignorePathCasing=d}compare(d,g,p=!1){return d===g?0:(0,k.compare)(this.getComparisonKey(d,p),this.getComparisonKey(g,p))}isEqual(d,g,p=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,p)===this.getComparisonKey(g,p)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,p=!1){if(d.scheme===g.scheme){if(d.scheme===t.Schemas.file)return y.isEqualOrParent(E(d),E(g),this._ignorePathCasing(d))&&d.query===g.query&&(p||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return y.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(p||d.fragment===g.fragment)}return!1}joinPath(d,...g){return b.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return P.posix.basename(d.path)}extname(d){return P.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===t.Schemas.file?g=b.URI.file(P.dirname(E(d))).path:(g=P.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===t.Schemas.file?g=b.URI.file(P.normalize(E(d))).path:g=P.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===t.Schemas.file){const v=P.relative(E(d),E(g));return I.isWindows?y.toSlashes(v):v}let p=d.path||"/";const m=g.path||"/";if(this._ignorePathCasing(d)){let v=0;for(const u=Math.min(p.length,m.length);v<u&&!(p.charCodeAt(v)!==m.charCodeAt(v)&&p.charAt(v).toLowerCase()!==m.charAt(v).toLowerCase());v++);p=m.substr(0,v)+p.substr(v)}return P.posix.relative(p,m)}resolvePath(d,g){if(d.scheme===t.Schemas.file){const p=b.URI.file(P.resolve(E(d),g));return d.with({authority:p.authority,path:p.path})}return g=y.toPosixPath(g),d.with({path:P.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||d!==void 0&&g!==void 0&&(0,k.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=P.sep){if(d.scheme===t.Schemas.file){const p=E(d);return p.length>y.getRoot(p).length&&p[p.length-1]===g}else{const p=d.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=P.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=P.sep){let p=!1;if(d.scheme===t.Schemas.file){const m=E(d);p=m!==void 0&&m.length===y.getRoot(m).length&&m[m.length-1]===g}else{g="/";const m=d.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(w=>w.scheme===t.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new C(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(w,d){const g=[];for(let p=0;p<w.length;p++){const m=d(w[p]);w.some((v,u)=>u===p?!1:(0,e.isEqualOrParent)(m,d(v)))||g.push(w[p])}return g}e.distinctParents=T;var R;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function d(g){const p=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(u=>{const[l,h]=u.split(":");l&&h&&p.set(l,h)});const v=g.path.substring(0,g.path.indexOf(";"));return v&&p.set(w.META_DATA_MIME,v),p}w.parseMetaData=d})(R=e.DataUri||(e.DataUri={}));function S(w,d,g){if(d){let p=w.path;return p&&p[0]!==P.posix.sep&&(p=P.posix.sep+p),w.with({scheme:g,authority:d,path:p})}return w.with({scheme:g})}e.toLocalResource=S}),define(we[14],ye([1,0,20,10,7,2,19,3]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(te){return!!te&&typeof te.then=="function"}e.isThenable=E;function C(te){const _=new y.CancellationTokenSource,U=te(_.token),Z=new Promise((ie,ue)=>{const ve=_.token.onCancellationRequested(()=>{ve.dispose(),_.dispose(),ue(new t.CancellationError)});Promise.resolve(U).then($=>{ve.dispose(),_.dispose(),ie($)},$=>{ve.dispose(),_.dispose(),ue($)})});return new class{cancel(){_.cancel()}then(ie,ue){return Z.then(ie,ue)}catch(ie){return this.then(void 0,ie)}finally(ie){return Z.finally(ie)}}}e.createCancelablePromise=C;function T(te,_,U){return new Promise((Z,ie)=>{const ue=_.onCancellationRequested(()=>{ue.dispose(),Z(U)});te.then(Z,ie).finally(()=>ue.dispose())})}e.raceCancellation=T;function R(te,_){return new Promise((U,Z)=>{const ie=_.onCancellationRequested(()=>{ie.dispose(),Z(new t.CancellationError)});te.then(U,Z).finally(()=>ie.dispose())})}e.raceCancellationError=R;async function S(te){let _=-1;const U=te.map((ie,ue)=>ie.then(ve=>(_=ue,ve))),Z=await Promise.race(U);return te.forEach((ie,ue)=>{ue!==_&&ie.cancel()}),Z}e.raceCancellablePromises=S;function w(te,_,U){let Z;const ie=setTimeout(()=>{Z?.(void 0),U?.()},_);return Promise.race([te.finally(()=>clearTimeout(ie)),new Promise(ue=>Z=ue)])}e.raceTimeout=w;function d(te){return new Promise((_,U)=>{const Z=te();E(Z)?Z.then(_,U):_(Z)})}e.asPromise=d;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const Z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Z};this.queuedPromise=new Promise(Z=>{this.activePromise.then(U,U).then(Z)})}return new Promise((U,Z)=>{this.queuedPromise.then(U,Z)})}return this.activePromise=_(),new Promise((U,Z)=>{this.activePromise.then(ie=>{this.activePromise=null,U(ie)},ie=>{this.activePromise=null,Z(ie)})})}}e.Throttler=g;class p{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=p;class m{constructor(){this.promiseMap=new Map}queue(_,U){const ie=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(_)===ie&&this.promiseMap.delete(_)});return this.promiseMap.set(_,ie),ie}}e.SequencerByKey=m;const v=(te,_)=>{let U=!0;const Z=setTimeout(()=>{U=!1,_()},te);return{isTriggered:()=>U,dispose:()=>{clearTimeout(Z),U=!1}}},u=te=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,te())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(_){this.defaultDelay=_,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,U=this.defaultDelay){this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ie,ue)=>{this.doResolve=ie,this.doReject=ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ie=this.task;return this.task=null,ie()}}));const Z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===e.MicrotaskDelay?u(Z):v(U,Z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class h{constructor(_){this.delayer=new l(_),this.throttler=new g}trigger(_,U){return this.delayer.trigger(()=>this.throttler.queue(_),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=h;class i{constructor(){this._isOpen=!1,this._promise=new Promise((_,U)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class r extends i{constructor(_){super(),this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function n(te,_){return _?new Promise((U,Z)=>{const ie=setTimeout(()=>{ue.dispose(),U()},te),ue=_.onCancellationRequested(()=>{clearTimeout(ie),ue.dispose(),Z(new t.CancellationError)})}):C(U=>n(te,U))}e.timeout=n;function s(te,_=0){const U=setTimeout(te,_);return(0,I.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=s;function a(te){const _=[];let U=0;const Z=te.length;function ie(){return U<Z?te[U++]():null}function ue(ve){ve!=null&&_.push(ve);const $=ie();return $?$.then(ue):Promise.resolve(_)}return Promise.resolve(null).then(ue)}e.sequence=a;function f(te,_=Z=>!!Z,U=null){let Z=0;const ie=te.length,ue=()=>{if(Z>=ie)return Promise.resolve(U);const ve=te[Z++];return Promise.resolve(ve()).then(Q=>_(Q)?Promise.resolve(Q):ue())};return ue()}e.first=f;function o(te,_=Z=>!!Z,U=null){if(te.length===0)return Promise.resolve(U);let Z=te.length;const ie=()=>{Z=-1;for(const ue of te)ue.cancel?.()};return new Promise((ue,ve)=>{for(const $ of te)$.then(Q=>{--Z>=0&&_(Q)?(ie(),ue(Q)):Z===0&&ue(U)}).catch(Q=>{--Z>=0&&(ie(),ve(Q))})})}e.firstParallel=o;class c{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new P.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(_){return this._size++,new Promise((U,Z)=>{this.outstandingPromises.push({factory:_,c:U,e:Z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const U=_.factory();U.then(_.c,_.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=c;class D extends c{constructor(){super(1)}}e.Queue=D;class O{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const _=new L;return this.drainers.add(_),_.p}isDrained(){for(const[,_]of this.queues)if(_.size>0)return!1;return!0}queueFor(_,U=k.extUri){const Z=U.getComparisonKey(_);let ie=this.queues.get(Z);return ie||(ie=new D,P.Event.once(ie.onDrained)(()=>{ie?.dispose(),this.queues.delete(Z),this.onDidQueueDrain()}),this.queues.set(Z,ie)),ie}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const _ of this.drainers)_.complete();this.drainers.clear()}dispose(){for(const[,_]of this.queues)_.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=O;class H{constructor(_,U){this._token=-1,typeof _=="function"&&typeof U=="number"&&this.setIfNotSet(_,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},U)}setIfNotSet(_,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},U))}}e.TimeoutTimer=H;class re{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setInterval(()=>{_()},U)}}e.IntervalTimer=re;class ce{constructor(_,U){this.timeoutToken=-1,this.runner=_,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=ce;class ae{constructor(_,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ae;class N extends ce{constructor(_,U){super(_,U),this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner?.(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class J extends I.Disposable{constructor(_,U){super(),this.options=_,this.handler=U,this.pendingWork=[],this.throttler=this._register(new I.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.options.maxBufferedWork)return!1}else if(this.pending+_.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(..._),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ce(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=te=>{(0,b.setTimeout0)(()=>{if(_)return;const U=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(te,_)=>{const U=requestIdleCallback(te,typeof _=="number"?{timeout:_}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,cancelIdleCallback(U))}}}}();class B{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function x(te,_,U){let Z;for(let ie=0;ie<U;ie++)try{return await te()}catch(ue){Z=ue,await n(_)}throw Z}e.retry=x;class z{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(_,U,Z){return this._pending={taskId:_,cancel:()=>Z?.(),promise:U},U.then(()=>this.donePending(_),()=>this.donePending(_)),U}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let U,Z;const ie=new Promise((ue,ve)=>{U=ue,Z=ve});this._next={run:_,promise:ie,promiseResolve:U,promiseReject:Z}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=z;class j{constructor(_,U=()=>Date.now()){this.interval=_,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const _=this.nowFn();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class L{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,U)=>{this.completeCallback=_,this.errorCallback=U})}complete(_){return new Promise(U=>{this.completeCallback(_),this.resolved=!0,U()})}error(_){return new Promise(U=>{this.errorCallback(_),this.rejected=!0,U()})}cancel(){new Promise(_=>{this.errorCallback(new t.CancellationError),this.rejected=!0,_()})}}e.DeferredPromise=L;var F;(function(te){async function _(Z){let ie;const ue=await Promise.all(Z.map(ve=>ve.then($=>$,$=>{ie||(ie=$)})));if(typeof ie<"u")throw ie;return ue}te.settled=_;function U(Z){return new Promise(async(ie,ue)=>{try{await Z(ie,ue)}catch(ve){ue(ve)}})}te.withAsyncBody=U})(F=e.Promises||(e.Promises={}));var G;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(G||(G={}));class oe{static fromArray(_){return new oe(U=>{U.emitMany(_)})}static fromPromise(_){return new oe(async U=>{U.emitMany(await _)})}static fromPromises(_){return new oe(async U=>{await Promise.all(_.map(async Z=>U.emitOne(await Z)))})}static merge(_){return new oe(async U=>{await Promise.all(_.map(async Z=>{for await(const ie of Z)U.emitOne(ie)}))})}constructor(_){this._state=0,this._results=[],this._error=null,this._onStateChanged=new P.Emitter,queueMicrotask(async()=>{const U={emitOne:Z=>this.emitOne(Z),emitMany:Z=>this.emitMany(Z),reject:Z=>this.reject(Z)};try{await Promise.resolve(_(U)),this.resolve()}catch(Z){this.reject(Z)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(_<this._results.length)return{done:!1,value:this._results[_++]};if(this._state===1)return{done:!0,value:void 0};await P.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(_,U){return new oe(async Z=>{for await(const ie of _)Z.emitOne(U(ie))})}map(_){return oe.map(this,_)}static filter(_,U){return new oe(async Z=>{for await(const ie of _)U(ie)&&Z.emitOne(ie)})}filter(_){return oe.filter(this,_)}static coalesce(_){return oe.filter(_,U=>!!U)}coalesce(){return oe.coalesce(this)}static async toPromise(_){const U=[];for await(const Z of _)U.push(Z);return U}toPromise(){return oe.toPromise(this)}emitOne(_){this._state===0&&(this._results.push(_),this._onStateChanged.fire())}emitMany(_){this._state===0&&(this._results=this._results.concat(_),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(_){this._state===0&&(this._state=2,this._error=_,this._onStateChanged.fire())}}e.AsyncIterableObject=oe,oe.EMPTY=oe.fromArray([]);class fe extends oe{constructor(_,U){super(U),this._source=_}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=fe;function ee(te){const _=new y.CancellationTokenSource,U=te(_.token);return new fe(_,async Z=>{const ie=_.token.onCancellationRequested(()=>{ie.dispose(),_.dispose(),Z.reject(new t.CancellationError)});try{for await(const ue of U){if(_.token.isCancellationRequested)return;Z.emitOne(ue)}ie.dispose(),_.dispose()}catch(ue){ie.dispose(),_.dispose(),Z.reject(ue)}})}e.createCancelableAsyncIterable=ee}),define(we[70],ye([1,0,18,14,36,31,6,3,15]),function(se,e,y,t,P,I,k,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",R="[^/\\\\]",S=/\//g;function w(L,F){switch(L){case 0:return"";case 1:return`${R}*?`;default:return`(?:${T}|${R}+${T}${F?`|${T}${R}+`:""})*?`}}function d(L,F){if(!L)return[];const G=[];let oe=!1,fe=!1,ee="";for(const te of L){switch(te){case F:if(!oe&&!fe){G.push(ee),ee="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}ee+=te}return ee&&G.push(ee),G}e.splitGlobAware=d;function g(L){if(!L)return"";let F="";const G=d(L,e.GLOB_SPLIT);if(G.every(oe=>oe===e.GLOBSTAR))F=".*";else{let oe=!1;G.forEach((fe,ee)=>{if(fe===e.GLOBSTAR){if(oe)return;F+=w(2,ee===G.length-1)}else{let te=!1,_="",U=!1,Z="";for(const ie of fe){if(ie!=="}"&&te){_+=ie;continue}if(U&&(ie!=="]"||!Z)){let ue;ie==="-"?ue=ie:(ie==="^"||ie==="!")&&!Z?ue="^":ie===e.GLOB_SPLIT?ue="":ue=(0,E.escapeRegExpCharacters)(ie),Z+=ue;continue}switch(ie){case"{":te=!0;continue;case"[":U=!0;continue;case"}":{F+=`(?:${d(_,",").map($=>g($)).join("|")})`,te=!1,_="";break}case"]":{F+="["+Z+"]",U=!1,Z="";break}case"?":F+=R;continue;case"*":F+=w(1);continue;default:F+=(0,E.escapeRegExpCharacters)(ie)}}ee<G.length-1&&(G[ee+1]!==e.GLOBSTAR||ee+2<G.length)&&(F+=T)}oe=fe===e.GLOBSTAR})}return F}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new I.LRUCache(1e4),r=function(){return!1},n=function(){return null};function s(L,F){if(!L)return n;let G;typeof L!="string"?G=L.pattern:G=L,G=G.trim();const oe=`${G}_${!!F.trimForExclusions}`;let fe=i.get(oe);if(fe)return a(fe,L);let ee;return p.test(G)?fe=o(G.substr(4),G):(ee=m.exec(f(G,F)))?fe=c(ee[1],G):(F.trimForExclusions?u:v).test(G)?fe=D(G,F):(ee=l.exec(f(G,F)))?fe=O(ee[1].substr(1),G,!0):(ee=h.exec(f(G,F)))?fe=O(ee[1],G,!1):fe=H(G),i.set(oe,fe),a(fe,L)}function a(L,F){if(typeof F=="string")return L;const G=function(oe,fe){return(0,P.isEqualOrParent)(oe,F.base,!b.isLinux)?L(oe.substr(F.base.length+1),fe):null};return G.allBasenames=L.allBasenames,G.allPaths=L.allPaths,G.basenames=L.basenames,G.patterns=L.patterns,G}function f(L,F){return F.trimForExclusions&&L.endsWith("/**")?L.substr(0,L.length-2):L}function o(L,F){return function(G,oe){return typeof G=="string"&&G.endsWith(L)?F:null}}function c(L,F){const G=`/${L}`,oe=`\\${L}`,fe=function(te,_){return typeof te!="string"?null:_?_===L?F:null:te===L||te.endsWith(G)||te.endsWith(oe)?F:null},ee=[L];return fe.basenames=ee,fe.patterns=[F],fe.allBasenames=ee,fe}function D(L,F){const G=z(L.slice(1,-1).split(",").map(_=>s(_,F)).filter(_=>_!==n),L),oe=G.length;if(!oe)return n;if(oe===1)return G[0];const fe=function(_,U){for(let Z=0,ie=G.length;Z<ie;Z++)if(G[Z](_,U))return L;return null},ee=G.find(_=>!!_.allBasenames);ee&&(fe.allBasenames=ee.allBasenames);const te=G.reduce((_,U)=>U.allPaths?_.concat(U.allPaths):_,[]);return te.length&&(fe.allPaths=te),fe}function O(L,F,G){const oe=k.sep===k.posix.sep,fe=oe?L:L.replace(S,k.sep),ee=k.sep+fe,te=k.posix.sep+L;let _;return G?_=function(U,Z){return typeof U=="string"&&(U===fe||U.endsWith(ee)||!oe&&(U===L||U.endsWith(te)))?F:null}:_=function(U,Z){return typeof U=="string"&&(U===fe||!oe&&U===L)?F:null},_.allPaths=[(G?"*/":"./")+L],_}function H(L){try{const F=new RegExp(`^${g(L)}$`);return function(G){return F.lastIndex=0,typeof G=="string"&&F.test(G)?L:null}}catch{return n}}function re(L,F,G){return!L||typeof F!="string"?!1:ce(L)(F,void 0,G)}e.match=re;function ce(L,F={}){if(!L)return r;if(typeof L=="string"||ae(L)){const G=s(L,F);if(G===n)return r;const oe=function(fe,ee){return!!G(fe,ee)};return G.allBasenames&&(oe.allBasenames=G.allBasenames),G.allPaths&&(oe.allPaths=G.allPaths),oe}return B(L,F)}e.parse=ce;function ae(L){const F=L;return F?typeof F.base=="string"&&typeof F.pattern=="string":!1}e.isRelativePattern=ae;function N(L){return L.allBasenames||[]}e.getBasenameTerms=N;function J(L){return L.allPaths||[]}e.getPathTerms=J;function B(L,F){const G=z(Object.getOwnPropertyNames(L).map(_=>x(_,L[_],F)).filter(_=>_!==n)),oe=G.length;if(!oe)return n;if(!G.some(_=>!!_.requiresSiblings)){if(oe===1)return G[0];const _=function(ie,ue){let ve;for(let $=0,Q=G.length;$<Q;$++){const Y=G[$](ie,ue);if(typeof Y=="string")return Y;(0,t.isThenable)(Y)&&(ve||(ve=[]),ve.push(Y))}return ve?(async()=>{for(const $ of ve){const Q=await $;if(typeof Q=="string")return Q}return null})():null},U=G.find(ie=>!!ie.allBasenames);U&&(_.allBasenames=U.allBasenames);const Z=G.reduce((ie,ue)=>ue.allPaths?ie.concat(ue.allPaths):ie,[]);return Z.length&&(_.allPaths=Z),_}const fe=function(_,U,Z){let ie,ue;for(let ve=0,$=G.length;ve<$;ve++){const Q=G[ve];Q.requiresSiblings&&Z&&(U||(U=(0,k.basename)(_)),ie||(ie=U.substr(0,U.length-(0,k.extname)(_).length)));const Y=Q(_,U,ie,Z);if(typeof Y=="string")return Y;(0,t.isThenable)(Y)&&(ue||(ue=[]),ue.push(Y))}return ue?(async()=>{for(const ve of ue){const $=await ve;if(typeof $=="string")return $}return null})():null},ee=G.find(_=>!!_.allBasenames);ee&&(fe.allBasenames=ee.allBasenames);const te=G.reduce((_,U)=>U.allPaths?_.concat(U.allPaths):_,[]);return te.length&&(fe.allPaths=te),fe}function x(L,F,G){if(F===!1)return n;const oe=s(L,G);if(oe===n)return n;if(typeof F=="boolean")return oe;if(F){const fe=F.when;if(typeof fe=="string"){const ee=(te,_,U,Z)=>{if(!Z||!oe(te,_))return null;const ie=fe.replace("$(basename)",U),ue=Z(ie);return(0,t.isThenable)(ue)?ue.then(ve=>ve?L:null):ue?L:null};return ee.requiresSiblings=!0,ee}}return oe}function z(L,F){const G=L.filter(_=>!!_.basenames);if(G.length<2)return L;const oe=G.reduce((_,U)=>{const Z=U.basenames;return Z?_.concat(Z):_},[]);let fe;if(F){fe=[];for(let _=0,U=oe.length;_<U;_++)fe.push(F)}else fe=G.reduce((_,U)=>{const Z=U.patterns;return Z?_.concat(Z):_},[]);const ee=function(_,U){if(typeof _!="string")return null;if(!U){let ie;for(ie=_.length;ie>0;ie--){const ue=_.charCodeAt(ie-1);if(ue===47||ue===92)break}U=_.substr(ie)}const Z=oe.indexOf(U);return Z!==-1?fe[Z]:null};ee.basenames=oe,ee.patterns=fe,ee.allBasenames=oe;const te=L.filter(_=>!_.basenames);return te.push(ee),te}function j(L,F){return(0,y.equals)(L,F,(G,oe)=>typeof G=="string"&&typeof oe=="string"?G===oe:typeof G!="string"&&typeof oe!="string"?G.base===oe.base&&G.pattern===oe.pattern:!1)}e.patternsEquals=j}),define(we[93],ye([1,0,10,152,19,15,4]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(b=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(m="",v=!1){if(this.value=m,typeof this.value!="string")throw(0,y.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(m,v=0){return this.value+=S(this.supportThemeIcons?(0,t.escapeIcons)(m):m).replace(/([ \t]+)/g,(u,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,v){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(m,v,u){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(m),")"),u&&(this.value+=` "${this._escape(this._escape(u,'"'),")")}"`),this.value+=")",this}_escape(m,v){const u=new RegExp((0,I.escapeRegExpCharacters)(v),"g");return m.replace(u,(l,h)=>m.charAt(h-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=E;function C(p){return T(p)?!p.value:Array.isArray(p)?p.every(C):!0}e.isEmptyMarkdownString=C;function T(p){return p instanceof E?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function R(p,m){return p===m?!0:!p||!m?!1:p.value===m.value&&p.isTrusted===m.isTrusted&&p.supportThemeIcons===m.supportThemeIcons&&p.supportHtml===m.supportHtml&&(p.baseUri===m.baseUri||!!p.baseUri&&!!m.baseUri&&(0,P.isEqual)(k.URI.from(p.baseUri),k.URI.from(m.baseUri)))}e.markdownStringEqual=R;function S(p){return p.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function w(p){return p.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=w;function d(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function g(p){const m=[],v=p.split("|").map(l=>l.trim());p=v[0];const u=v[1];if(u){const l=/height=(\d+)/.exec(u),h=/width=(\d+)/.exec(u),i=l?l[1]:"",r=h?h[1]:"",n=isFinite(parseInt(r)),s=isFinite(parseInt(i));n&&m.push(`width="${r}"`),s&&m.push(`height="${i}"`)}return{href:p,dimensions:m}}e.parseHrefAndDimensions=g}),define(we[154],ye([1,0,18,36,6,3,19,15]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(n,s){const{os:a,tildify:f,relative:o}=s;if(o){const O=C(n,o,a);if(typeof O=="string")return O}let c=n.fsPath;if(a===1&&!I.isWindows?c=c.replace(/\//g,"\\"):a!==1&&I.isWindows&&(c=c.replace(/\\/g,"/")),a!==1&&f?.userHome){const O=f.userHome.fsPath;let H;n.scheme!==f.userHome.scheme&&n.path.startsWith(P.posix.sep)?H=f.userHome.with({path:n.path}).fsPath:H=n.fsPath,c=S(H,O,a)}return(a===1?P.win32:P.posix).normalize(T(c,a===1))}e.getPathLabel=E;function C(n,s,a){const f=a===1?P.win32:P.posix,o=a===3?k.extUri:k.extUriIgnorePathCase,c=s.getWorkspace(),D=(0,y.firstOrDefault)(c.folders);if(!D)return;n.scheme!==D.uri.scheme&&n.path.startsWith(P.posix.sep)&&(n=D.uri.with({path:n.path}));const O=s.getWorkspaceFolder(n);if(!O)return;let H;if(o.isEqual(O.uri,n)?H="":H=o.relativePath(O.uri,n)??"",H&&(H=f.normalize(H)),c.folders.length>1&&!s.noPrefix){const re=O.name?O.name:o.basenameOrAuthority(O.uri);H=H?`${re} \u2022 ${H}`:re}return H}function T(n,s=I.isWindows){return(0,t.hasDriveLetter)(n,s)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=T;let R=Object.create(null);function S(n,s,a=I.OS){if(a===1||!n||!s)return n;let f=R.original===s?R.normalized:void 0;f||(f=s,I.isWindows&&(f=(0,t.toSlashes)(f)),f=`${(0,b.rtrim)(f,P.posix.sep)}${P.posix.sep}`,R={original:s,normalized:f});let o=n;return I.isWindows&&(o=(0,t.toSlashes)(o)),(a===3?o.startsWith(f):(0,b.startsWithIgnoreCase)(o,f))?`~/${o.substr(f.length)}`:n}e.tildify=S;function w(n,s){return n.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=w;const d="\u2026",g="\\\\",p="~";function m(n,s=P.sep){const a=new Array(n.length);let f=!1;for(let o=0;o<n.length;o++){const c=n[o];if(c===""){a[o]=`.${s}`;continue}if(!c){a[o]=c;continue}f=!0;let D="",O=c;O.indexOf(g)===0?(D=O.substr(0,O.indexOf(g)+g.length),O=O.substr(O.indexOf(g)+g.length)):O.indexOf(s)===0?(D=O.substr(0,O.indexOf(s)+s.length),O=O.substr(O.indexOf(s)+s.length)):O.indexOf(p)===0&&(D=O.substr(0,O.indexOf(p)+p.length),O=O.substr(O.indexOf(p)+p.length));const H=O.split(s);for(let re=1;f&&re<=H.length;re++)for(let ce=H.length-re;f&&ce>=0;ce--){f=!1;let ae=H.slice(ce,ce+re).join(s);for(let N=0;!f&&N<n.length;N++)if(N!==o&&n[N]&&n[N].indexOf(ae)>-1){const J=ce+re===H.length,B=ce>0&&n[N].indexOf(s)>-1?s+ae:ae,x=n[N].endsWith(B);f=!J||x}if(!f){let N="";(H[0].endsWith(":")||D!=="")&&(ce===1&&(ce=0,re++,ae=H[0]+s+ae),ce>0&&(N=H[0]+s),N=D+N),ce>0&&(N=N+d+s),N=N+ae,ce+re<H.length&&(N=N+s+d),a[o]=N}}f&&(a[o]=c)}return a}e.shorten=m;var v;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function u(n,s=Object.create(null)){const a=[];let f=!1,o="";for(const c of n)if(c==="$"||f&&c==="{")o&&a.push({value:o,type:v.TEXT}),o="",f=!0;else if(c==="}"&&f){const D=s[o];if(typeof D=="string")D.length&&a.push({value:D,type:v.VARIABLE});else if(D){const O=a[a.length-1];(!O||O.type!==v.SEPARATOR)&&a.push({value:D.label,type:v.SEPARATOR})}o="",f=!1}else o+=c;return o&&!f&&a.push({value:o,type:v.TEXT}),a.filter((c,D)=>{if(c.type===v.SEPARATOR){const O=a[D-1],H=a[D+1];return[O,H].every(re=>re&&(re.type===v.VARIABLE||re.type===v.TEXT)&&re.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=u;function l(n,s){return I.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function h(n,s){return I.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,""):I.isWindows?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=h;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function r(n){const s=n.indexOf("/")!==-1?P.posix:P.win32,a=s.basename(n),f=s.dirname(n);return a.length?{name:a,parentPath:f}:{name:f,parentPath:""}}e.splitName=r}),define(we[71],ye([1,0,4]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(T){return T.toJSON()}class P{constructor(R){this._uriTransformer=R}transformIncoming(R){const S=this._uriTransformer.transformIncoming(R);return S===R?R:t(y.URI.from(S))}transformOutgoing(R){const S=this._uriTransformer.transformOutgoing(R);return S===R?R:t(y.URI.from(S))}transformOutgoingURI(R){const S=this._uriTransformer.transformOutgoing(R);return S===R?R:y.URI.from(S)}transformOutgoingScheme(R){return this._uriTransformer.transformOutgoingScheme(R)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function I(T,R,S){if(!T||S>200)return null;if(typeof T=="object"){if(T instanceof y.URI)return R.transformOutgoing(T);for(const w in T)if(Object.hasOwnProperty.call(T,w)){const d=I(T[w],R,S+1);d!==null&&(T[w]=d)}}return null}function k(T,R){const S=I(T,R,0);return S===null?T:S}e.transformOutgoingURIs=k;function b(T,R,S,w){if(!T||w>200)return null;if(typeof T=="object"){if(T.$mid===1)return S?y.URI.revive(R.transformIncoming(T)):R.transformIncoming(T);for(const d in T)if(Object.hasOwnProperty.call(T,d)){const g=b(T[d],R,S,w+1);g!==null&&(T[d]=g)}}return null}function E(T,R){const S=b(T,R,!1,0);return S===null?T:S}e.transformIncomingURIs=E;function C(T,R){const S=b(T,R,!0,0);return S===null?T:S}e.transformAndReviveIncomingURIs=C}),define(we[94],ye([1,0,29,10,57,23,141]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(T){return this._virtualMachineOUIs||(this._virtualMachineOUIs=P.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(T)}value(){if(this._value===void 0){let T=0,R=0;const S=(0,y.networkInterfaces)();for(const w in S){const d=S[w];if(d)for(const{mac:g,internal:p}of d)p||(R+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(T+=1))}this._value=R>0?T/R:0}return this._value}};let b;async function E(){return b||(b=(async()=>await C()||I.generateUuid())()),b}e.getMachineId=E;async function C(){try{const T=await new Promise((S,w)=>{se(["crypto"],S,w)}),R=(0,k.getMac)();return T.createHash("sha256").update(R,"utf8").digest("hex")}catch(T){t.onUnexpectedError(T);return}}}),define(we[21],ye([1,0,28,29,270,14,36,87,6,3,19,4]),function(se,e,y,t,P,I,k,b,E,C,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function w(B,x=S.UNLINK){if((0,k.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return x===S.UNLINK?g(B):d(B)}async function d(B){try{const x=(0,k.randomPath)((0,t.tmpdir)());try{await y.promises.rename(B,x)}catch(z){return z.code==="ENOENT"?void 0:g(B)}g(x).catch(z=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function g(B){return(0,P.promisify)(y.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function p(B){if((0,k.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function m(B,x){return l(await(x?v(B):(0,P.promisify)(y.readdir)(B)))}async function v(B){try{return await(0,P.promisify)(y.readdir)(B,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const x=[],z=await m(B);for(const j of z){let L=!1,F=!1,G=!1;try{const oe=await e.Promises.lstat((0,E.join)(B,j));L=oe.isFile(),F=oe.isDirectory(),G=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}x.push({name:j,isFile:()=>L,isDirectory:()=>F,isSymbolicLink:()=>G})}return x}function u(B){return l(y.readdirSync(B))}e.readdirSync=u;function l(B){return B.map(x=>typeof x=="string"?C.isMacintosh?(0,b.normalizeNFC)(x):x:(x.name=C.isMacintosh?(0,b.normalizeNFC)(x.name):x.name,x))}async function h(B){const x=await m(B),z=[];for(const j of x)await r.existsDirectory((0,E.join)(B,j))&&z.push(j);return z}function i(B,x=1e3){return new Promise(z=>{let j=!1;const L=setInterval(()=>{j||(j=!0,y.access(B,F=>{j=!1,F&&(clearInterval(L),z(void 0))}))},x)})}e.whenDeleted=i;var r;(function(B){async function x(L){let F;try{if(F=await e.Promises.lstat(L),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(L),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(C.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(L)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw oe}throw G}}B.stat=x;async function z(L){try{const{stat:F,symbolicLink:G}=await B.stat(L);return F.isFile()&&G?.dangling!==!0}catch{}return!1}B.existsFile=z;async function j(L){try{const{stat:F,symbolicLink:G}=await B.stat(L);return F.isDirectory()&&G?.dangling!==!0}catch{}return!1}B.existsDirectory=j})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new I.ResourceQueue;function s(B,x,z){return n.queueFor(R.URI.file(B),T.extUriBiasedIgnorePathCase).queue(()=>{const j=D(z);return new Promise((L,F)=>o(B,x,j,G=>G?F(G):L()))})}let a=!0;function f(B){a=B}e.configureFlushOnWrite=f;function o(B,x,z,j){if(!a)return y.writeFile(B,x,{mode:z.mode,flag:z.flag},j);y.open(B,z.flag,z.mode,(L,F)=>{if(L)return j(L);y.writeFile(F,x,G=>{if(G)return y.close(F,()=>j(G));y.fdatasync(F,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),f(!1)),y.close(F,fe=>j(fe))))})})}function c(B,x,z){const j=D(z);if(!a)return y.writeFileSync(B,x,{mode:j.mode,flag:j.flag});const L=y.openSync(B,j.flag,j.mode);try{y.writeFileSync(L,x);try{y.fdatasyncSync(L)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),f(!1)}}finally{y.closeSync(L)}}e.writeFileSync=c;function D(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function O(B,x){if(B!==x)try{await e.Promises.rename(B,x)}catch(z){if(B.toLowerCase()!==x.toLowerCase()&&z.code==="EXDEV"||B.endsWith("."))await H(B,x,{preserveSymlinks:!1}),await w(B,S.MOVE);else throw z}}async function H(B,x,z){return ce(B,x,{root:{source:B,target:x},options:z,handledSourcePaths:new Set})}const re=511;async function ce(B,x,z){if(z.handledSourcePaths.has(B))return;z.handledSourcePaths.add(B);const{stat:j,symbolicLink:L}=await r.stat(B);if(L){if(z.options.preserveSymlinks)try{return await J(B,x,z)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(L.dangling)return}return j.isDirectory()?ae(B,x,j.mode&re,z):N(B,x,j.mode&re)}async function ae(B,x,z,j){await e.Promises.mkdir(x,{recursive:!0,mode:z});const L=await m(B);for(const F of L)await ce((0,E.join)(B,F),(0,E.join)(x,F),j)}async function N(B,x,z){await e.Promises.copyFile(B,x),await e.Promises.chmod(x,z)}async function J(B,x,z){let j=await e.Promises.readlink(B);(0,k.isEqualOrParent)(j,z.root.source,!C.isLinux)&&(j=(0,E.join)(z.root.target,j.substr(z.root.source.length+1))),await e.Promises.symlink(j,x)}e.Promises=new class{get access(){return(0,P.promisify)(y.access)}get stat(){return(0,P.promisify)(y.stat)}get lstat(){return(0,P.promisify)(y.lstat)}get utimes(){return(0,P.promisify)(y.utimes)}get read(){return(B,x,z,j,L)=>new Promise((F,G)=>{y.read(B,x,z,j,L,(oe,fe,ee)=>oe?G(oe):F({bytesRead:fe,buffer:ee}))})}get readFile(){return(0,P.promisify)(y.readFile)}get write(){return(B,x,z,j,L)=>new Promise((F,G)=>{y.write(B,x,z,j,L,(oe,fe,ee)=>oe?G(oe):F({bytesWritten:fe,buffer:ee}))})}get appendFile(){return(0,P.promisify)(y.appendFile)}get fdatasync(){return(0,P.promisify)(y.fdatasync)}get truncate(){return(0,P.promisify)(y.truncate)}get rename(){return(0,P.promisify)(y.rename)}get copyFile(){return(0,P.promisify)(y.copyFile)}get open(){return(0,P.promisify)(y.open)}get close(){return(0,P.promisify)(y.close)}get symlink(){return(0,P.promisify)(y.symlink)}get readlink(){return(0,P.promisify)(y.readlink)}get chmod(){return(0,P.promisify)(y.chmod)}get mkdir(){return(0,P.promisify)(y.mkdir)}get unlink(){return(0,P.promisify)(y.unlink)}get rmdir(){return(0,P.promisify)(y.rmdir)}get realpath(){return(0,P.promisify)(y.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return h}get writeFile(){return s}get rm(){return w}get move(){return O}get copy(){return H}}}),define(we[155],ye([1,0,28,6,3,15,21]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(S){if(P.isLinux)return S;const w=(0,t.dirname)(S);if(S===w)return S;const d=((0,t.basename)(S)||S).toLowerCase();try{const p=(0,k.readdirSync)(w).filter(m=>m.toLowerCase()===d);if(p.length===1){const m=b(w);if(m)return(0,t.join)(m,p[0])}else if(p.length>1){const m=p.indexOf(d);if(m>=0){const v=b(w);if(v)return(0,t.join)(v,p[m])}}}catch{}return null}e.realcaseSync=b;async function E(S){if(P.isLinux)return S;const w=(0,t.dirname)(S);if(S===w)return S;const d=((0,t.basename)(S)||S).toLowerCase();try{const p=(await k.Promises.readdir(w)).filter(m=>m.toLowerCase()===d);if(p.length===1){const m=await E(w);if(m)return(0,t.join)(m,p[0])}else if(p.length>1){const m=p.indexOf(d);if(m>=0){const v=await E(w);if(v)return(0,t.join)(v,p[m])}}}catch{}return null}e.realcase=E;async function C(S){try{return await k.Promises.realpath(S)}catch{const d=R(S);return await k.Promises.access(d,y.constants.R_OK),d}}e.realpath=C;function T(S){try{return y.realpathSync(S)}catch{const d=R(S);return y.accessSync(d,y.constants.R_OK),d}}e.realpathSync=T;function R(S){return(0,I.rtrim)((0,t.normalize)(S),t.sep)}}),define(we[95],ye([1,0,29,6,21]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,k=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var E;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(E||(E={}));let C;switch(process.arch){case"ia32":case"x32":C=1;break;case"arm":case"arm64":C=2;break;default:C=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class R{constructor(h,i,r){this.exePath=h,this.displayName=i,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:l=!1}={}){return l?C===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:l=!1,findPreview:h=!1}={}){const i=S({useAlternateBitness:l});if(!i)return null;const r=t.join(i,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(r))return null;let n=-1,s=null;for(const o of await P.Promises.readdir(r)){let c=-1;if(h){const O=o.indexOf("-");if(O<0)continue;const H=o.substring(0,O);if(!I.test(H)||o.substring(O+1)!=="preview")continue;c=parseInt(H,10)}else{if(!I.test(o))continue;c=parseInt(o,10)}if(c<=n)continue;const D=t.join(r,o,"pwsh.exe");!await P.SymlinkSupport.existsFile(D)||(s=D,n=c)}if(!s)return null;const a=i.includes("x86")?" (x86)":"",f=h?" Preview":"";return new R(s,`PowerShell${f}${a}`,!0)}async function d({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const h=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=l?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await P.Promises.readdir(h))if(i.test(n)){const s=t.join(h,n,"pwsh.exe");return new R(s,r)}return null}function g(){const l=t.join(y.homedir(),".dotnet","tools","pwsh.exe");return new R(l,".NET Core PowerShell Global Tool")}function p(){const l=t.join(process.env.windir,C===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(l,"Windows PowerShell",!0)}async function*m(){let l=await w();l&&(yield l),l=await w({useAlternateBitness:!0}),l&&(yield l),l=await d(),l&&(yield l),l=g(),l&&(yield l),l=await w({findPreview:!0}),l&&(yield l),l=await d({findPreview:!0}),l&&(yield l),l=await w({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=p(),l&&(yield l)}async function*v(){for await(const l of m())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=v;async function u(){for await(const l of v())return l;return null}e.getFirstAvailablePowerShellInstallation=u}),define(we[96],ye([1,0,6,3,27,56,13,21]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function E(R=P.env){return R.comspec||"cmd.exe"}e.getWindowsShell=E;function C(R){let S=[],w=!1;const d=function(g){if(w){S.push(g);return}(!R.send(g,m=>{if(m&&console.error(m),w=!1,S.length>0){const v=S.slice(0);S=[],v.forEach(u=>d(u))}})||t.isWindows)&&(w=!0)};return{send:d}}e.createQueuedSender=C;var T;(function(R){async function S(w,d,g){if(y.isAbsolute(w))return w;if(d===void 0&&(d=P.cwd()),y.dirname(w)!=="."||(g===void 0&&k.isString(P.env.PATH)&&(g=P.env.PATH.split(y.delimiter)),g===void 0||g.length===0))return y.join(d,w);async function m(v){if(await b.Promises.exists(v)){let u;try{u=await b.Promises.stat(v)}catch(l){l.message.startsWith("EACCES")&&(u=await b.Promises.lstat(v))}return u?!u.isDirectory():!1}return!1}for(const v of g){let u;if(y.isAbsolute(v)?u=y.join(v,w):u=y.join(d,v,w),await m(u))return u;let l=u+".com";if(await m(l)||(l=u+".exe",await m(l)))return l}return y.join(d,w)}R.findExecutable=S})(T=e.win32||(e.win32={}))}),define(we[97],ye([1,0,48,11]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function P(k){return new Promise((b,E)=>{let C;const T=new Map;function R(w,d,g,p,m){const v=T.get(d);if(w===k||v){const u={name:S(g),cmd:g,pid:w,ppid:d,load:p,mem:m};T.set(w,u),w===k&&(C=u),v&&(v.children||(v.children=[]),v.children.push(u),v.children.length>1&&(v.children=v.children.sort((l,h)=>l.pid-h.pid)))}}function S(w){const d=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,p=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,u=/--crashes-directory/,l=/\\pipe\\winpty-control/,h=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(u.exec(w))return"electron-crash-reporter";if(l.exec(w))return"winpty-process";if(h.exec(w))return"console-window-host (Windows internal process)";let r=i.exec(w);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(w)?"shared-process":g.exec(w)?"issue-reporter":p.exec(w)?"process-explorer":"window";if(r[1]==="utility"){if(m.exec(w))return"utility-network-service";if(v.exec(w))return"extension-host"}return r[1]}const n=/[a-zA-Z-]+\.js/g;let s="";do r=n.exec(w),r&&(s+=r+" ");while(r);return s&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${s}`:w}if(process.platform==="win32"){const w=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{se(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(k,g=>{if(!g){E(new Error(`Root process ${k} not found`));return}d.getProcessCpuUsage(g,p=>{const m=new Map;p.forEach(v=>{const u=w(v.commandLine||"");m.set(v.pid,{name:S(u),cmd:u,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),C=m.get(k),C?(m.forEach(v=>{const u=m.get(v.ppid);u&&(u.children||(u.children=[]),u.children.push(v))}),m.forEach(v=>{v.children&&(v.children=v.children.sort((u,l)=>u.pid-l.pid))}),b(C)):E(new Error(`Root process ${k} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let w=function(){let d=[C];const g=[];for(;d.length;){const m=d.shift();m&&(g.push(m.pid),m.children&&(d=d.concat(m.children)))}let p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",se).fsPath);p+=" "+g.join(" "),(0,y.exec)(p,{},(m,v,u)=>{if(m||u)E(m||new Error(u.toString()));else{const l=v.toString().split(`
`);for(let h=0;h<g.length;h++){const i=T.get(g[h]);i.load=parseFloat(l[h])}if(!C){E(new Error(`Root process ${k} not found`));return}b(C)}})};(0,y.exec)("which ps",{},(d,g,p)=>{if(d||p)if(process.platform!=="linux")E(d||new Error(p.toString()));else{const m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",se).fsPath);(0,y.exec)(m,{},(v,u,l)=>{v||l?E(v||new Error(l.toString())):(I(u,R),w())})}else{const m=g.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${m} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,l,h)=>{u||h&&!h.includes("screen size is bogus")?E(u||new Error(h.toString())):(I(l,R),process.platform==="linux"?w():C?b(C):E(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=P;function I(k,b){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,C=k.toString().split(`
`);for(const T of C){const R=E.exec(T.trim());R&&R.length===6&&b(parseInt(R[1]),parseInt(R[2]),R[5],parseFloat(R[3]),parseFloat(R[4]))}}}),define(we[156],ye([1,0,29,3,95,96]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(w,d){return w===1?t.isWindows?R():I.getWindowsShell(d):C(w,d)}e.getSystemShell=k;function b(w,d){return w===1?t.isWindows?S(d):I.getWindowsShell(d):C(w,d)}e.getSystemShellSync=b;let E=null;function C(w,d){if(t.isLinux&&w===2||t.isMacintosh&&w===3)return"/bin/bash";if(!E){let g;if(t.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,y.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}E=g}return E}let T=null;async function R(){return T||(T=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),T}function S(w){if(T)return T;const d=t.isWindows&&parseFloat((0,y.release)())>=10,g=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${w.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?p:I.getWindowsShell(w)}});var Ae=this&&this.__decorate||function(se,e,y,t){var P=arguments.length,I=P<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,y):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(se,e,y,t);else for(var b=se.length-1;b>=0;b--)(k=se[b])&&(I=(P<3?k(I):P>3?k(e,y,I):k(e,y))||I);return P>3&&I&&Object.defineProperty(e,y,I),I};define(we[41],ye([1,0,18,14,16,20,84,10,7,2,47,15,13]),function(se,e,y,t,P,I,k,b,E,C,T,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(L){L[L.Promise=100]="Promise",L[L.PromiseCancel=101]="PromiseCancel",L[L.EventListen=102]="EventListen",L[L.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function d(L){switch(L){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(L){L[L.Initialize=200]="Initialize",L[L.PromiseSuccess=201]="PromiseSuccess",L[L.PromiseError=202]="PromiseError",L[L.PromiseErrorObj=203]="PromiseErrorObj",L[L.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function p(L){switch(L){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(L){L[L.Uninitialized=0]="Uninitialized",L[L.Idle=1]="Idle"})(m||(m={}));class v{constructor(F){this.buffer=F,this.pos=0}read(F){const G=this.buffer.slice(this.pos,this.pos+F);return this.pos+=G.byteLength,G}}class u{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var l;(function(L){L[L.Undefined=0]="Undefined",L[L.String=1]="String",L[L.Buffer=2]="Buffer",L[L.VSBuffer=3]="VSBuffer",L[L.Array=4]="Array",L[L.Object=5]="Object"})(l||(l={}));function h(L){const F=P.VSBuffer.alloc(4);return F.writeUInt32BE(L,0),F}function i(L){return L.read(4).readUInt32BE(0)}function r(L){const F=P.VSBuffer.alloc(1);return F.writeUInt8(L,0),F}const n={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object)},s=typeof Buffer<"u";function a(L,F){if(typeof F>"u")L.write(n.Undefined);else if(typeof F=="string"){const G=P.VSBuffer.fromString(F);L.write(n.String),L.write(h(G.byteLength)),L.write(G)}else if(s&&Buffer.isBuffer(F)){const G=P.VSBuffer.wrap(F);L.write(n.Buffer),L.write(h(G.byteLength)),L.write(G)}else if(F instanceof P.VSBuffer)L.write(n.VSBuffer),L.write(h(F.byteLength)),L.write(F);else if(Array.isArray(F)){L.write(n.Array),L.write(h(F.length));for(const G of F)a(L,G)}else{const G=P.VSBuffer.fromString(JSON.stringify(F));L.write(n.Object),L.write(h(G.byteLength)),L.write(G)}}function f(L){switch(L.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return L.read(i(L)).toString();case l.Buffer:return L.read(i(L)).buffer;case l.VSBuffer:return L.read(i(L));case l.Array:{const G=i(L),oe=[];for(let fe=0;fe<G;fe++)oe.push(f(L));return oe}case l.Object:return JSON.parse(L.read(i(L)).toString())}}class o{constructor(F,G,oe=null,fe=1e3){this.protocol=F,this.ctx=G,this.logger=oe,this.timeoutDelay=fe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(F,G){this.channels.set(F,G),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const G=this.send([F.type]);this.logger?.logOutgoing(G,0,1,p(F.type));return}case 201:case 202:case 204:case 203:{const G=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(G,F.id,1,p(F.type),F.data);return}}}send(F,G=void 0){const oe=new u;return a(oe,F),a(oe,G),this.sendBuffer(oe.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const G=new v(F),oe=f(G),fe=f(G),ee=oe[0];switch(ee){case 100:return this.logger?.logIncoming(F.byteLength,oe[1],1,`${d(ee)}: ${oe[2]}.${oe[3]}`,fe),this.onPromise({type:ee,id:oe[1],channelName:oe[2],name:oe[3],arg:fe});case 102:return this.logger?.logIncoming(F.byteLength,oe[1],1,`${d(ee)}: ${oe[2]}.${oe[3]}`,fe),this.onEventListen({type:ee,id:oe[1],channelName:oe[2],name:oe[3],arg:fe});case 101:return this.logger?.logIncoming(F.byteLength,oe[1],1,`${d(ee)}`),this.disposeActiveRequest({type:ee,id:oe[1]});case 103:return this.logger?.logIncoming(F.byteLength,oe[1],1,`${d(ee)}`),this.disposeActiveRequest({type:ee,id:oe[1]})}}onPromise(F){const G=this.channels.get(F.channelName);if(!G){this.collectPendingRequest(F);return}const oe=new I.CancellationTokenSource;let fe;try{fe=G.call(this.ctx,F.name,F.arg,oe.token)}catch(_){fe=Promise.reject(_)}const ee=F.id;fe.then(_=>{this.sendResponse({id:ee,data:_,type:201}),this.activeRequests.delete(F.id)},_=>{_ instanceof Error?this.sendResponse({id:ee,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:ee,data:_,type:203}),this.activeRequests.delete(F.id)});const te=(0,C.toDisposable)(()=>oe.cancel());this.activeRequests.set(F.id,te)}onEventListen(F){const G=this.channels.get(F.channelName);if(!G){this.collectPendingRequest(F);return}const oe=F.id,ee=G.listen(this.ctx,F.name,F.arg)(te=>this.sendResponse({id:oe,data:te,type:204}));this.activeRequests.set(F.id,ee)}disposeActiveRequest(F){const G=this.activeRequests.get(F.id);G&&(G.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let G=this.pendingRequests.get(F.channelName);G||(G=[],this.pendingRequests.set(F.channelName,G));const oe=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:F,timeoutTimer:oe})}flushPendingRequests(F){const G=this.pendingRequests.get(F);if(G){for(const oe of G)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.onPromise(oe.request);break;case 102:this.onEventListen(oe.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var c;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(F,G=null){this.protocol=F,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(oe=>this.onBuffer(oe)),this.logger=G}getChannel(F){const G=this;return{call(oe,fe,ee){return G.isDisposed?Promise.reject(new b.CancellationError):G.requestPromise(F,oe,fe,ee)},listen(oe,fe){return G.isDisposed?E.Event.None:G.requestEvent(F,oe,fe)}}}requestPromise(F,G,oe,fe=I.CancellationToken.None){const ee=this.lastRequestId++,_={id:ee,type:100,channelName:F,name:G,arg:oe};if(fe.isCancellationRequested)return Promise.reject(new b.CancellationError);let U;return new Promise((ie,ue)=>{if(fe.isCancellationRequested)return ue(new b.CancellationError);const ve=()=>{const W=V=>{switch(V.type){case 201:this.handlers.delete(ee),ie(V.data);break;case 202:{this.handlers.delete(ee);const q=new Error(V.data.message);q.stack=Array.isArray(V.data.stack)?V.data.stack.join(`
`):V.data.stack,q.name=V.data.name,ue(q);break}case 203:this.handlers.delete(ee),ue(V.data);break}};this.handlers.set(ee,W),this.sendRequest(_)};let $=null;this.state===m.Idle?ve():($=(0,t.createCancelablePromise)(W=>this.whenInitialized()),$.then(()=>{$=null,ve()}));const Q=()=>{$?($.cancel(),$=null):this.sendRequest({id:ee,type:101}),ue(new b.CancellationError)},Y=fe.onCancellationRequested(Q);U=(0,C.combinedDisposable)((0,C.toDisposable)(Q),Y),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(F,G,oe){const fe=this.lastRequestId++,te={id:fe,type:102,channelName:F,name:G,arg:oe};let _=null;const U=new E.Emitter({onFirstListenerAdd:()=>{_=(0,t.createCancelablePromise)(ie=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(U),this.sendRequest(te)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(U),this.sendRequest({id:fe,type:103}))}}),Z=ie=>U.fire(ie.data);return this.handlers.set(fe,Z),U.event}sendRequest(F){switch(F.type){case 100:case 102:{const G=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(G,F.id,0,`${d(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const G=this.send([F.type,F.id]);this.logger?.logOutgoing(G,F.id,0,d(F.type));return}}}send(F,G=void 0){const oe=new u;return a(oe,F),a(oe,G),this.sendBuffer(oe.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const G=new v(F),oe=f(G),fe=f(G),ee=oe[0];switch(ee){case 200:return this.logger?.logIncoming(F.byteLength,0,0,p(ee)),this.onResponse({type:oe[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,oe[1],0,p(ee),fe),this.onResponse({type:oe[0],id:oe[1],data:fe})}}onResponse(F){if(F.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ae([k.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class O{get connections(){const F=[];return this._connections.forEach(G=>F.push(G)),F}constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:G,onDidClientDisconnect:oe})=>{E.Event.once(G.onMessage)(ee=>{const te=new v(ee),_=f(te),U=new o(G,_),Z=new D(G);this.channels.forEach((ue,ve)=>U.registerChannel(ve,ue));const ie={channelServer:U,channelClient:Z,ctx:_};this._connections.add(ie),this._onDidAddConnection.fire(ie),oe(()=>{U.dispose(),Z.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}getChannel(F,G){const oe=this;return{call(fe,ee,te){let _;if((0,S.isFunction)(G)){const Z=(0,y.getRandomElement)(oe.connections.filter(G));_=Z?Promise.resolve(Z):E.Event.toPromise(E.Event.filter(oe.onDidAddConnection,G))}else _=G.routeCall(oe,fe,ee);const U=_.then(Z=>Z.channelClient.getChannel(F));return re(U).call(fe,ee,te)},listen(fe,ee){if((0,S.isFunction)(G))return oe.getMulticastEvent(F,G,fe,ee);const te=G.routeEvent(oe,fe,ee).then(_=>_.channelClient.getChannel(F));return re(te).listen(fe,ee)}}}getMulticastEvent(F,G,oe,fe){const ee=this;let te=new C.DisposableStore;const _=new E.Emitter({onFirstListenerAdd:()=>{te=new C.DisposableStore;const U=new E.EventMultiplexer,Z=new Map,ie=ve=>{const Q=ve.channelClient.getChannel(F).listen(oe,fe),Y=U.add(Q);Z.set(ve,Y)},ue=ve=>{const $=Z.get(ve);!$||($.dispose(),Z.delete(ve))};ee.connections.filter(G).forEach(ie),E.Event.filter(ee.onDidAddConnection,G)(ie,void 0,te),ee.onDidRemoveConnection(ue,void 0,te),U.event(_.fire,_,te),te.add(U)},onLastListenerRemove:()=>{te.dispose()}});return _.event}registerChannel(F,G){this.channels.set(F,G),this._connections.forEach(oe=>{oe.channelServer.registerChannel(F,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=O;class H{constructor(F,G,oe=null){const fe=new u;a(fe,G),F.send(fe.buffer),this.channelClient=new D(F,oe),this.channelServer=new o(F,G,oe)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,G){this.channelServer.registerChannel(F,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=H;function re(L){return{call(F,G,oe){return L.then(fe=>fe.call(F,G,oe))},listen(F,G){const oe=new E.Relay;return L.then(fe=>oe.input=fe.listen(F,G)),oe.event}}}e.getDelayedChannel=re;function ce(L){let F=!1;return{call(G,oe,fe){return F?L.call(G,oe,fe):(0,t.timeout)(0).then(()=>F=!0).then(()=>L.call(G,oe,fe))},listen(G,oe){if(F)return L.listen(G,oe);const fe=new E.Relay;return(0,t.timeout)(0).then(()=>F=!0).then(()=>fe.input=L.listen(G,oe)),fe.event}}}e.getNextTickChannel=ce;class ae{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const G of F.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await E.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=ae;var N;(function(L){function F(ee,te){const _=ee,U=te&&te.disableMarshalling,Z=new Map;for(const ie in _)oe(ie)&&Z.set(ie,E.Event.buffer(_[ie],!0));return new class{listen(ie,ue,ve){const $=Z.get(ue);if($)return $;if(fe(ue)){const Q=_[ue];if(typeof Q=="function")return Q.call(_,ve)}throw new Error(`Event not found: ${ue}`)}call(ie,ue,ve){const $=_[ue];if(typeof $=="function"){if(!U&&Array.isArray(ve))for(let Q=0;Q<ve.length;Q++)ve[Q]=(0,T.revive)(ve[Q]);return $.apply(_,ve)}throw new Error(`Method not found: ${ue}`)}}}L.fromService=F;function G(ee,te){const _=te&&te.disableMarshalling;return new Proxy({},{get(U,Z){if(typeof Z=="string")return te?.properties?.has(Z)?te.properties.get(Z):fe(Z)?function(ie){return ee.listen(Z,ie)}:oe(Z)?ee.listen(Z):async function(...ie){let ue;te&&!(0,S.isUndefinedOrNull)(te.context)?ue=[te.context,...ie]:ue=ie;const ve=await ee.call(Z,ue);return _?ve:(0,T.revive)(ve)};throw new Error(`Property not found: ${String(Z)}`)}})}L.toService=G;function oe(ee){return ee[0]==="o"&&ee[1]==="n"&&R.isUpperAsciiLetter(ee.charCodeAt(2))}function fe(ee){return/^onDynamic/.test(ee)&&R.isUpperAsciiLetter(ee.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(L){if(Array.isArray(L))return L;if(L&&typeof L=="object"&&typeof L.toString=="function"){const F=L.toString();if(F!=="[object Object]")return F}return L}function x(L){return Array.isArray(L)?L.map(B):B(L)}function z(L,F,G,oe,fe,ee,te){te=x(te);const _=J[fe],U=_[oe%_.length];let Z=[`%c[${L}]%c[${String(F).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ee)?(Z=Z.concat(te),Z.push(")")):Z.push(te),console.log.apply(console,Z)}e.logWithColors=z;class j{constructor(F,G){this._outgoingPrefix=F,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,G,oe,fe,ee){this._totalOutgoing+=F,z(this._outgoingPrefix,this._totalOutgoing,F,G,oe,fe,ee)}logIncoming(F,G,oe,fe,ee){this._totalIncoming+=F,z(this._incomingPrefix,this._totalIncoming,F,G,oe,fe,ee)}}e.IPCLogger=j}),define(we[98],ye([1,0,16,7,2,41]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(s){s.enableDiagnostics=!1,s.records=[];const a=new WeakMap;let f=0;function o(D,O){if(!a.has(D)){const H=String(++f);a.set(D,H)}return a.get(D)}function c(D,O,H,re){if(!s.enableDiagnostics)return;const ce=o(D,O);if(re instanceof y.VSBuffer||re instanceof Uint8Array||re instanceof ArrayBuffer||ArrayBuffer.isView(re)){const ae=y.VSBuffer.alloc(re.byteLength);ae.set(re),s.records.push({timestamp:Date.now(),id:ce,label:O,type:H,buff:ae})}else s.records.push({timestamp:Date.now(),id:ce,label:O,type:H,data:re})}s.traceSocketEvent=c})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function T(){return C||(C=y.VSBuffer.alloc(0)),C}class R{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,f){if(a===0)return T();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const O=this._chunks[0];return f&&(this._chunks.shift(),this._totalLength-=a),O}if(this._chunks[0].byteLength>a){const O=this._chunks[0].slice(0,a);return f&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),O}const o=y.VSBuffer.alloc(a);let c=0,D=0;for(;a>0;){const O=this._chunks[D];if(O.byteLength>a){const H=O.slice(0,a);o.set(H,c),c+=a,f&&(this._chunks[D]=O.slice(a),this._totalLength-=a),a-=a}else o.set(O,c),c+=O.byteLength,f?(this._chunks.shift(),this._totalLength-=O.byteLength):D++,a-=O.byteLength}return o}}e.ChunkStream=R;var S;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(S||(S={}));function w(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(a,f,o,c){this.type=a,this.id=f,this.ack=o,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends P.Disposable{constructor(a){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(f=>this.acceptChunk(f))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const f=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=f.readUInt32BE(9),this._state.messageType=f.readUInt8(0),this._state.id=f.readUInt32BE(1),this._state.ack=f.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:w(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,c=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",f),this._onMessage.fire(new g(o,c,D,f)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(a){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const f=y.VSBuffer.alloc(13);f.writeUInt8(a.type,0),f.writeUInt32BE(a.id,1),f.writeUInt32BE(a.ack,5),f.writeUInt32BE(a.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:w(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",a.data),this._writeSoon(f,a.data)}_bufferAdd(a,f){const o=this._totalLength===0;return this._data.push(a,f),this._totalLength+=a.byteLength+f.byteLength,o}_bufferTake(){const a=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,f){this._bufferAdd(a,f)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const a=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this._socket.write(a)}}class v extends P.Disposable{constructor(a){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(f=>{f.type===1&&this._onMessage.fire(f.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new g(1,0,0,a))}}e.Protocol=v;class u extends I.IPCClient{static fromSocket(a,f){return new u(new v(a),f)}get onDidDispose(){return this.protocol.onDidDispose}constructor(a,f,o=null){super(a,f,o),this.protocol=a}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=u;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class h{constructor(a){this.data=a,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let a=0,f=this._first;for(;f;)f=f.next,a++;return a}peek(){return this._first?this._first.data:null}toArray(){const a=[];let f=0,o=this._first;for(;o;)a[f++]=o.data,o=o.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const f=new h(a);if(!this._first){this._first=f,this._last=f;return}this._last.next=f,this._last=f}}class r{static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const a=Date.now();for(let f=0;f<r._HISTORY_LENGTH;f++)this.lastRuns[f]=a-1e3*f;setInterval(()=>{for(let f=r._HISTORY_LENGTH;f>=1;f--)this.lastRuns[f]=this.lastRuns[f-1];this.lastRuns[0]=Date.now()},1e3)}load(){const a=Date.now(),f=(1+r._HISTORY_LENGTH)*1e3;let o=0;for(let c=0;c<r._HISTORY_LENGTH;c++)a-this.lastRuns[c]<=f&&o++;return 1-o/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(a,f=null,o=r.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=a,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),f&&this._socketReader.acceptChunk(f),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,P.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new g(5,0,0,T());this._socketWriter.write(a),this._socketWriter.flush()}sendPause(){const a=new g(7,0,0,T());this._socketWriter.write(a)}sendResume(){const a=new g(8,0,0,T());this._socketWriter.write(a)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,f){this._isReconnecting=!0,this._socketDisposables=(0,P.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=a,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(f)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const a=new g(3,0,this._incomingAckId,T());this._socketWriter.write(a);const f=this._outgoingUnackMsg.toArray();for(let o=0,c=f.length;o<c;o++)this._socketWriter.write(f[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const f=this._outgoingUnackMsg.peek();if(f&&f.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const f=Date.now();f-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=f,this._socketWriter.write(new g(6,0,0,T())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data);break}case 2:{this._onControlMessage.fire(a.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const f=this._outgoingUnackMsg.toArray();for(let o=0,c=f.length;o<c;o++)this._socketWriter.write(f[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const f=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new g(1,f,this._incomingAckId,a);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(a){const f=new g(2,0,0,a);this._socketWriter.write(f)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const a=this._outgoingUnackMsg.peek(),f=Date.now()-a.writtenTime,o=Date.now()-this._socketReader.lastReadTime,c=Date.now()-this._lastSocketTimeoutTime;if(f>=2e4&&o>=2e4&&c>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:f,timeSinceLastReceivedSomeData:o});return}const D=Math.max(2e4-f,2e4-o,2e4-c,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},D)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new g(3,0,this._incomingAckId,T());this._socketWriter.write(a)}_sendKeepAlive(){const a=new g(9,0,0,T());this._socketWriter.write(a)}}e.PersistentProtocol=n}),define(we[99],ye([1,0,48,14,16,20,153,10,7,2,22,96,56,41]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends w.ChannelServer{constructor(m){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",v=>P.VSBuffer.wrap(Buffer.from(v,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(m,v){this.modulePath=m,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new t.Delayer(u),this.child=null,this._client=null}getChannel(m){const v=this;return{call(u,l,h){return v.requestPromise(m,u,l,h)},listen(u,l){return v.requestEvent(m,u,l)}}}requestPromise(m,v,u,l=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const h=this.getCachedChannel(m),i=(0,t.createCancelablePromise)(s=>h.call(v,u,s)),r=l.onCancellationRequested(()=>i.cancel()),n=(0,C.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{r.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(m,v,u){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let l;const h=new E.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(m).listen(v,u)(h.fire,h),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return h.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),(0,S.removeDangerousEnvVariables)(v.env),this.child=(0,y.fork)(this.modulePath,m,v);const u=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,k.isRemoteConsoleLog)(a)){(0,k.log)(a,`IPC Library: ${this.options.serverName}`);return}u.fire(P.VSBuffer.wrap(Buffer.from(a,"base64")))});const h=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,i=a=>this.child&&this.child.connected&&h.send(a.buffer.toString("base64")),r=u.event,n={send:i,onMessage:r};this._client=new w.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,f)=>{process.removeListener("exit",s),this.activeRequests.forEach(o=>(0,C.dispose)(o)),this.activeRequests.clear(),a!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+f),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:f})})}return this._client}getCachedChannel(m){let v=this.channels.get(m);return v||(v=this.client.getChannel(m),this.channels.set(m,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(we[58],ye([1,0,16,10,7,2,6,3,23,41,98]),function(se,e,y,t,P,I,k,b,E,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function R(){return{crypto:se.__$__nodeRequire("crypto"),zlib:se.__$__nodeRequire("zlib"),net:se.__$__nodeRequire("net"),os:se.__$__nodeRequire("os")}}class S{traceSocketEvent(o,c){T.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,c)}constructor(o,c=""){this._canWrite=!0,this.debugLabel=c,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,t.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener),this._closeListener=D=>{this.traceSocketEvent("close",{hadError:D}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(o){const c=D=>{this.traceSocketEvent("read",D),o(y.VSBuffer.wrap(D))};return this.socket.on("data",c),{dispose:()=>this.socket.off("data",c)}}onClose(o){const c=D=>{o({type:0,hadError:D,error:void 0})};return this.socket.on("close",c),{dispose:()=>this.socket.off("close",c)}}onEnd(o){const c=()=>{o()};return this.socket.on("end",c),{dispose:()=>this.socket.off("end",c)}}write(o){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,c=>{if(c){if(c.code==="EPIPE")return;(0,t.onUnexpectedError)(c)}})}catch(c){if(c.code==="EPIPE")return;(0,t.onUnexpectedError)(c)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,c)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=S;var w;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var d;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(d||(d={}));class g extends I.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(o,c){this.socket.traceSocketEvent(o,c)}constructor(o,c,D,O){super(),this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:c,inflateBytesLength:D?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new p(this,c,D,O,this._onData,(H,re)=>this._write(H,re))),this._register(this._flowManager.onError(H=>{console.error(H),(0,t.onUnexpectedError)(H),this._onClose.fire({type:0,hadError:!0,error:H})})),this._incomingData=new T.ChunkStream,this._register(this.socket.onData(H=>this._acceptChunk(H))),this._register(this.socket.onClose(H=>this._onClose.fire(H)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this._flowManager.writeMessage(o)}_write(o,c){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let D=2;o.byteLength<126?D+=0:o.byteLength<2**16?D+=2:D+=8;const O=y.VSBuffer.alloc(D);if(c?O.writeUInt8(194,0):O.writeUInt8(130,0),o.byteLength<126)O.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){O.writeUInt8(126,1);let H=1;O.writeUInt8(o.byteLength>>>8&255,++H),O.writeUInt8(o.byteLength>>>0&255,++H)}else{O.writeUInt8(127,1);let H=1;O.writeUInt8(0,++H),O.writeUInt8(0,++H),O.writeUInt8(0,++H),O.writeUInt8(0,++H),O.writeUInt8(o.byteLength>>>24&255,++H),O.writeUInt8(o.byteLength>>>16&255,++H),O.writeUInt8(o.byteLength>>>8&255,++H),O.writeUInt8(o.byteLength>>>0&255,++H)}this.socket.write(y.VSBuffer.concat([O,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const c=this._incomingData.peek(this._state.readLen),D=c.readUInt8(0),O=(D&128)>>>7,H=(D&64)>>>6,re=c.readUInt8(1),ce=(re&128)>>>7,ae=re&127;this._state.state=2,this._state.readLen=2+(ce?4:0)+(ae===126?2:0)+(ae===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(H)),this._state.firstFrameOfMessage=Boolean(O),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const c=this._incomingData.read(this._state.readLen),D=c.readUInt8(1),O=(D&128)>>>7;let H=D&127,re=1;H===126?H=c.readUInt8(++re)*2**8+c.readUInt8(++re):H===127&&(H=c.readUInt8(++re)*0+c.readUInt8(++re)*0+c.readUInt8(++re)*0+c.readUInt8(++re)*0+c.readUInt8(++re)*2**24+c.readUInt8(++re)*2**16+c.readUInt8(++re)*2**8+c.readUInt8(++re));let ce=0;O&&(ce=c.readUInt8(++re)*2**24+c.readUInt8(++re)*2**16+c.readUInt8(++re)*2**8+c.readUInt8(++re)),this._state.state=3,this._state.readLen=H,this._state.mask=ce,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const c=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",c),u(c,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",c),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(c,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class p extends I.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:y.VSBuffer.alloc(0)}constructor(o,c,D,O,H,re){super(),this._tracer=o,this._onData=H,this._writeFn=re,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,c?(this._zlibInflateStream=this._register(new m(this._tracer,O,D,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(ce=>this._onError.fire(ce))),this._register(this._zlibDeflateStream.onError(ce=>this._onError.fire(ce)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(o){this._writeQueue.push(o),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const o=this._writeQueue.shift();if(this._zlibDeflateStream){const c=await this._deflateMessage(this._zlibDeflateStream,o);this._writeFn(c,!0)}else this._writeFn(o,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(o,c){return new Promise((D,O)=>{o.write(c),o.flush(H=>D(H))})}acceptFrame(o,c,D){this._readQueue.push({data:o,isCompressed:c,isLastFrameOfMessage:D}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const o=this._readQueue.shift();if(this._zlibInflateStream&&o.isCompressed){const c=await this._inflateFrame(this._zlibInflateStream,o.data,o.isLastFrameOfMessage);this._onData.fire(c)}else this._onData.fire(o.data)}this._isProcessingReadQueue=!1}}_inflateFrame(o,c,D){return new Promise((O,H)=>{o.write(c),D&&o.write(y.VSBuffer.fromByteArray([0,0,255,255])),o.flush(re=>O(re))})}}class m extends I.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?y.VSBuffer.concat(this._recordedInflateBytes):y.VSBuffer.alloc(0)}constructor(o,c,D,O){super(),this._tracer=o,this._recordInflateBytes=c,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=R().zlib.createInflateRaw(O),this._zlibInflate.on("error",H=>{this._tracer.traceSocketEvent("zlibInflateError",{message:H?.message,code:H?.code}),this._onError.fire(H)}),this._zlibInflate.on("data",H=>{this._tracer.traceSocketEvent("zlibInflateData",H),this._pendingInflateData.push(y.VSBuffer.wrap(H))}),D&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(o){this._recordInflateBytes&&this._recordedInflateBytes.push(o.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",o),this._zlibInflate.write(o.buffer)}flush(o){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const c=y.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,o(c)})}}class v extends I.Disposable{constructor(o,c){super(),this._tracer=o,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=R().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",D=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibDeflate.on("data",D=>{this._tracer.traceSocketEvent("zlibDeflateData",D),this._pendingDeflateData.push(y.VSBuffer.wrap(D))})}write(o){this._tracer.traceSocketEvent("zlibDeflateWrite",o.buffer),this._zlibDeflate.write(o.buffer)}flush(o){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let c=y.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,c=c.slice(0,c.byteLength-4),o(c)})}}function u(f,o){if(o===0)return;const c=f.byteLength>>>2;for(let ae=0;ae<c;ae++){const N=f.readUInt32BE(ae*4);f.writeUInt32BE(N^o,ae*4)}const D=c*4,O=f.byteLength-D,H=o>>>24&255,re=o>>>16&255,ce=o>>>8&255;O>=1&&f.writeUInt8(f.readUInt8(D)^H,D),O>=2&&f.writeUInt8(f.readUInt8(D+1)^re,D+1),O>=3&&f.writeUInt8(f.readUInt8(D+2)^ce,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const l={[2]:107,[1]:103};function h(){const f=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):o=(0,k.join)(R().os.tmpdir(),`vscode-ipc-${f}.sock`),r(o),o}e.createRandomIPCHandle=h;function i(f,o,c){const D=R().crypto.createHash("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${c}-${o}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${c}-${o}.sock`):O=(0,k.join)(f,`${c}-${o}.sock`),r(O),O}e.createStaticIPCHandle=i;function r(f){const o=l[b.platform];typeof o=="number"&&f.length>=o&&console.warn(`WARNING: IPC handle "${f}" is longer than ${o} chars, try a shorter --user-data-dir`)}class n extends C.IPCServer{static toClientConnectionEvent(o){const c=P.Event.fromNodeEventEmitter(o,"connection");return P.Event.map(c,D=>({protocol:new T.Protocol(new S(D,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(D,"close"))}))}constructor(o){super(n.toClientConnectionEvent(o)),this.server=o}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function s(f){return new Promise((o,c)=>{const D=R().net.createServer();D.on("error",c),D.listen(f,()=>{D.removeListener("error",c),o(new n(D))})})}e.serve=s;function a(f,o){return new Promise((c,D)=>{const O=R().net.createConnection(f,()=>{O.removeListener("error",D),c(T.Client.fromSocket(new S(O,`ipc-client${o}`),o))});O.once("error",D)})}e.connect=a}),define(we[157],ye([1,0,14,7,2,13]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function b(R){const S=R;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var E;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(E=e.StorageState||(e.StorageState={}));class C extends P.Disposable{constructor(S,w=Object.create(null)){super(),this.database=S,this.options=w,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new y.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((w,d)=>this.accept(d,w)),S.deleted?.forEach(w=>this.accept(w,void 0))}accept(S,w){if(this.state===E.Closed)return;let d=!1;(0,I.isUndefinedOrNull)(w)?d=this.cache.delete(S):this.cache.get(S)!==w&&(this.cache.set(S,w),d=!0),d&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,w){const d=this.cache.get(S);return(0,I.isUndefinedOrNull)(d)?w:d}getBoolean(S,w){const d=this.get(S);return(0,I.isUndefinedOrNull)(d)?w:d==="true"}getNumber(S,w){const d=this.get(S);return(0,I.isUndefinedOrNull)(d)?w:parseInt(d,10)}async set(S,w){if(this.state===E.Closed)return;if((0,I.isUndefinedOrNull)(w))return this.delete(S);const d=String(w);if(this.cache.get(S)!==d)return this.cache.set(S,d),this.pendingInserts.set(S,d),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===E.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=C,C.DEFAULT_FLUSH_DELAY=100;class T{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((w,d)=>this.items.set(d,w)),S.delete?.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=T}),define(we[158],ye([1,0,7,2]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class P{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(b){this._onDidChange.fire({changedLanguages:b,changedColorMap:!1})}register(b,E){return this._map.set(b,E),this.fire([b]),(0,t.toDisposable)(()=>{this._map.get(b)===E&&(this._map.delete(b),this.fire([b]))})}registerFactory(b,E){this._factories.get(b)?.dispose();const C=new I(this,b,E);return this._factories.set(b,C),(0,t.toDisposable)(()=>{const T=this._factories.get(b);!T||T!==C||(this._factories.delete(b),T.dispose())})}async getOrCreate(b){const E=this.get(b);if(E)return E;const C=this._factories.get(b);return!C||C.isResolved?null:(await C.resolve(),this.get(b))}get(b){return this._map.get(b)||null}isResolved(b){if(this.get(b))return!0;const C=this._factories.get(b);return!!(!C||C.isResolved)}setColorMap(b){this._colorMap=b,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=P;class I extends t.Disposable{get isResolved(){return this._isResolved}constructor(b,E,C){super(),this._registry=b,this._languageId=E,this._factory=C,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const b=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,b&&!this._isDisposed&&this._register(this._registry.register(this._languageId,b))}}}),define(we[159],ye([1,0,40,4,46,158]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class k{constructor(D,O,H){this._tokenBrand=void 0,this.offset=D,this.type=O,this.language=H}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=k;class b{constructor(D,O){this._tokenizationResultBrand=void 0,this.tokens=D,this.endState=O}}e.TokenizationResult=b;class E{constructor(D,O){this._encodedTokenizationResultBrand=void 0,this.tokens=D,this.endState=O}}e.EncodedTokenizationResult=E;var C;(function(c){c[c.Method=0]="Method",c[c.Function=1]="Function",c[c.Constructor=2]="Constructor",c[c.Field=3]="Field",c[c.Variable=4]="Variable",c[c.Class=5]="Class",c[c.Struct=6]="Struct",c[c.Interface=7]="Interface",c[c.Module=8]="Module",c[c.Property=9]="Property",c[c.Event=10]="Event",c[c.Operator=11]="Operator",c[c.Unit=12]="Unit",c[c.Value=13]="Value",c[c.Constant=14]="Constant",c[c.Enum=15]="Enum",c[c.EnumMember=16]="EnumMember",c[c.Keyword=17]="Keyword",c[c.Text=18]="Text",c[c.Color=19]="Color",c[c.File=20]="File",c[c.Reference=21]="Reference",c[c.Customcolor=22]="Customcolor",c[c.Folder=23]="Folder",c[c.TypeParameter=24]="TypeParameter",c[c.User=25]="User",c[c.Issue=26]="Issue",c[c.Snippet=27]="Snippet"})(C=e.CompletionItemKind||(e.CompletionItemKind={}));var T;(function(c){const D=new Map;D.set(0,y.Codicon.symbolMethod),D.set(1,y.Codicon.symbolFunction),D.set(2,y.Codicon.symbolConstructor),D.set(3,y.Codicon.symbolField),D.set(4,y.Codicon.symbolVariable),D.set(5,y.Codicon.symbolClass),D.set(6,y.Codicon.symbolStruct),D.set(7,y.Codicon.symbolInterface),D.set(8,y.Codicon.symbolModule),D.set(9,y.Codicon.symbolProperty),D.set(10,y.Codicon.symbolEvent),D.set(11,y.Codicon.symbolOperator),D.set(12,y.Codicon.symbolUnit),D.set(13,y.Codicon.symbolValue),D.set(15,y.Codicon.symbolEnum),D.set(14,y.Codicon.symbolConstant),D.set(15,y.Codicon.symbolEnum),D.set(16,y.Codicon.symbolEnumMember),D.set(17,y.Codicon.symbolKeyword),D.set(27,y.Codicon.symbolSnippet),D.set(18,y.Codicon.symbolText),D.set(19,y.Codicon.symbolColor),D.set(20,y.Codicon.symbolFile),D.set(21,y.Codicon.symbolReference),D.set(22,y.Codicon.symbolCustomColor),D.set(23,y.Codicon.symbolFolder),D.set(24,y.Codicon.symbolTypeParameter),D.set(25,y.Codicon.account),D.set(26,y.Codicon.issues);function O(ce){let ae=D.get(ce);return ae||(console.info("No codicon found for CompletionItemKind "+ce),ae=y.Codicon.symbolProperty),ae}c.toIcon=O;const H=new Map;H.set("method",0),H.set("function",1),H.set("constructor",2),H.set("field",3),H.set("variable",4),H.set("class",5),H.set("struct",6),H.set("interface",7),H.set("module",8),H.set("property",9),H.set("event",10),H.set("operator",11),H.set("unit",12),H.set("value",13),H.set("constant",14),H.set("enum",15),H.set("enum-member",16),H.set("enumMember",16),H.set("keyword",17),H.set("snippet",27),H.set("text",18),H.set("color",19),H.set("file",20),H.set("reference",21),H.set("customcolor",22),H.set("folder",23),H.set("type-parameter",24),H.set("typeParameter",24),H.set("account",25),H.set("issue",26);function re(ce,ae){let N=H.get(ce);return typeof N>"u"&&!ae&&(N=9),N}c.fromString=re})(T=e.CompletionItemKinds||(e.CompletionItemKinds={}));var R;(function(c){c[c.Deprecated=1]="Deprecated"})(R=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(c){c[c.KeepWhitespace=1]="KeepWhitespace",c[c.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(c){c[c.Invoke=0]="Invoke",c[c.TriggerCharacter=1]="TriggerCharacter",c[c.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var d;(function(c){c[c.Automatic=0]="Automatic",c[c.Explicit=1]="Explicit"})(d=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var g;(function(c){c[c.Invoke=1]="Invoke",c[c.Auto=2]="Auto"})(g=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(c){c[c.Invoke=1]="Invoke",c[c.TriggerCharacter=2]="TriggerCharacter",c[c.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(c){c[c.Text=0]="Text",c[c.Read=1]="Read",c[c.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(c){return c&&t.URI.isUri(c.uri)&&P.Range.isIRange(c.range)&&(P.Range.isIRange(c.originSelectionRange)||P.Range.isIRange(c.targetSelectionRange))}e.isLocationLink=v;var u;(function(c){c[c.File=0]="File",c[c.Module=1]="Module",c[c.Namespace=2]="Namespace",c[c.Package=3]="Package",c[c.Class=4]="Class",c[c.Method=5]="Method",c[c.Property=6]="Property",c[c.Field=7]="Field",c[c.Constructor=8]="Constructor",c[c.Enum=9]="Enum",c[c.Interface=10]="Interface",c[c.Function=11]="Function",c[c.Variable=12]="Variable",c[c.Constant=13]="Constant",c[c.String=14]="String",c[c.Number=15]="Number",c[c.Boolean=16]="Boolean",c[c.Array=17]="Array",c[c.Object=18]="Object",c[c.Key=19]="Key",c[c.Null=20]="Null",c[c.EnumMember=21]="EnumMember",c[c.Struct=22]="Struct",c[c.Event=23]="Event",c[c.Operator=24]="Operator",c[c.TypeParameter=25]="TypeParameter"})(u=e.SymbolKind||(e.SymbolKind={}));var l;(function(c){c[c.Deprecated=1]="Deprecated"})(l=e.SymbolTag||(e.SymbolTag={}));var h;(function(c){const D=new Map;D.set(0,y.Codicon.symbolFile),D.set(1,y.Codicon.symbolModule),D.set(2,y.Codicon.symbolNamespace),D.set(3,y.Codicon.symbolPackage),D.set(4,y.Codicon.symbolClass),D.set(5,y.Codicon.symbolMethod),D.set(6,y.Codicon.symbolProperty),D.set(7,y.Codicon.symbolField),D.set(8,y.Codicon.symbolConstructor),D.set(9,y.Codicon.symbolEnum),D.set(10,y.Codicon.symbolInterface),D.set(11,y.Codicon.symbolFunction),D.set(12,y.Codicon.symbolVariable),D.set(13,y.Codicon.symbolConstant),D.set(14,y.Codicon.symbolString),D.set(15,y.Codicon.symbolNumber),D.set(16,y.Codicon.symbolBoolean),D.set(17,y.Codicon.symbolArray),D.set(18,y.Codicon.symbolObject),D.set(19,y.Codicon.symbolKey),D.set(20,y.Codicon.symbolNull),D.set(21,y.Codicon.symbolEnumMember),D.set(22,y.Codicon.symbolStruct),D.set(23,y.Codicon.symbolEvent),D.set(24,y.Codicon.symbolOperator),D.set(25,y.Codicon.symbolTypeParameter);function O(H){let re=D.get(H);return re||(console.info("No codicon found for SymbolKind "+H),re=y.Codicon.symbolProperty),re}c.toIcon=O})(h=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(D){this.value=D}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var r;(function(c){function D(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}c.is=D})(r=e.Command||(e.Command={}));var n;(function(c){c[c.Collapsed=0]="Collapsed",c[c.Expanded=1]="Expanded"})(n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var s;(function(c){c[c.Unresolved=0]="Unresolved",c[c.Resolved=1]="Resolved"})(s=e.CommentThreadState||(e.CommentThreadState={}));var a;(function(c){c[c.Editing=0]="Editing",c[c.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var f;(function(c){c[c.Type=1]="Type",c[c.Parameter=2]="Parameter"})(f=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new I.TokenizationRegistry;var o;(function(c){c[c.None=0]="None",c[c.Option=1]="Option",c[c.Default=2]="Default",c[c.Preferred=3]="Preferred"})(o=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[160],ye([8,9]),function(se,e){return se.create("vs/base/node/zip",e)}),define(we[161],ye([8,9]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[162],ye([8,9]),function(se,e){return se.create("vs/platform/environment/node/argv",e)}),define(we[163],ye([8,9]),function(se,e){return se.create("vs/platform/environment/node/argvHelper",e)}),define(we[164],ye([8,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(we[165],ye([8,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[166],ye([8,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(we[167],ye([8,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(we[168],ye([8,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(we[169],ye([8,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(we[170],ye([8,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(we[171],ye([8,9]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[172],ye([8,9]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(we[173],ye([8,9]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(we[174],ye([8,9]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(we[175],ye([8,9]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(we[176],ye([8,9]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(we[177],ye([8,9]),function(se,e){return se.create("vs/platform/markers/common/markers",e)}),define(we[178],ye([8,9]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(we[179],ye([8,9]),function(se,e){return se.create("vs/platform/shell/node/shellEnv",e)}),define(we[180],ye([8,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(we[181],ye([8,9]),function(se,e){return se.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(we[182],ye([8,9]),function(se,e){return se.create("vs/platform/terminal/common/terminalProfiles",e)}),define(we[183],ye([8,9]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(we[184],ye([8,9]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(we[185],ye([8,9]),function(se,e){return se.create("vs/server/node/serverEnvironmentService",e)}),define(we[186],ye([8,9]),function(se,e){return se.create("vs/workbench/common/editor",e)}),define(we[187],ye([8,9]),function(se,e){return se.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[188],ye([8,9]),function(se,e){return se.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(we[189],ye([1,0,7,2]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class P{constructor(){this._onCloseEmitter=new y.Emitter,this._onReloadEmitter=new y.Emitter,this._onTerminateEmitter=new y.Emitter,this._onAttachEmitter=new y.Emitter}call(b,E,C){switch(E){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:C[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:C[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:C[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:C[0],port:C[1],subId:C[2]}))}throw new Error("Method not implemented.")}listen(b,E,C){switch(E){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=P,P.ChannelName="extensionhostdebugservice";class I extends t.Disposable{constructor(b){super(),this.channel=b}reload(b){this.channel.call("reload",[b])}get onReload(){return this.channel.listen("reload")}close(b){this.channel.call("close",[b])}get onClose(){return this.channel.listen("close")}attachSession(b,E,C){this.channel.call("attach",[b,E,C])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(b,E){this.channel.call("terminate",[b,E])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(b,E){return this.channel.call("openExtensionDevelopmentHostWindow",[b,E])}}e.ExtensionHostDebugChannelClient=I}),define(we[190],ye([1,0,4]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(k){this.service=k}listen(k,b,E){throw new Error("Invalid listen")}call(k,b,E){switch(b){case"download":return this.service.download(y.URI.revive(E[0]),y.URI.revive(E[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class P{constructor(k,b){this.channel=k,this.getUriTransformer=b}async download(k,b){const E=this.getUriTransformer();E&&(k=E.transformOutgoingURI(k),b=E.transformOutgoingURI(b)),await this.channel.call("download",[k,b])}}e.DownloadServiceChannelClient=P}),define(we[191],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class y{constructor(P){this.machineId=P}encryption(){return new Promise((P,I)=>se(["vscode-encrypt"],P,I))}async encrypt(P){try{return(await this.encryption()).encrypt(this.machineId,P)}catch{return P}}async decrypt(P){try{return(await this.encryption()).decrypt(this.machineId,P)}catch{return P}}}e.EncryptionMainService=y}),define(we[100],ye([1,0,144,84,11,6,27,19,4]),function(se,e,y,t,P,I,k,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class C{get appRoot(){return(0,I.dirname)(P.FileAccess.asFileUri("",se).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return E.URI.file((0,I.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return E.URI.file((0,I.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(E.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=k.env.VSCODE_PORTABLE;return g?E.URI.file((0,I.join)(g,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,I.resolve)(g):(0,I.normalize)((0,I.join)(P.FileAccess.asFileUri("",se).fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?E.URI.file((0,I.resolve)(g)):E.URI.file((0,I.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,I.resolve)(g);const p=k.env.VSCODE_EXTENSIONS;if(p)return p;const m=k.env.VSCODE_PORTABLE;return m?(0,I.join)(m,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(p=>/^[^:/?#]+?:\/\//.test(p)?E.URI.parse(p):E.URI.file((0,I.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?E.URI.parse(g):E.URI.file((0,I.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const p of this.args.log||[]){const m=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);m&&m[1]&&m[2]&&g.push([m[1],m[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,b.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return E.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=k.env.VSCODE_PORTABLE;return g?E.URI.file((0,I.join)(g,"policy.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this._args}constructor(g,p,m){this._args=g,this.paths=p,this.productService=m,this.editSessionId=this.args.editSessionId}}Ae([t.memoize],C.prototype,"appRoot",null),Ae([t.memoize],C.prototype,"userHome",null),Ae([t.memoize],C.prototype,"userDataPath",null),Ae([t.memoize],C.prototype,"appSettingsHome",null),Ae([t.memoize],C.prototype,"tmpDir",null),Ae([t.memoize],C.prototype,"cacheHome",null),Ae([t.memoize],C.prototype,"stateResource",null),Ae([t.memoize],C.prototype,"userRoamingDataHome",null),Ae([t.memoize],C.prototype,"userDataSyncHome",null),Ae([t.memoize],C.prototype,"userDataSyncLogResource",null),Ae([t.memoize],C.prototype,"editSessionsLogResource",null),Ae([t.memoize],C.prototype,"remoteTunnelLogResource",null),Ae([t.memoize],C.prototype,"sync",null),Ae([t.memoize],C.prototype,"machineSettingsResource",null),Ae([t.memoize],C.prototype,"workspaceStorageHome",null),Ae([t.memoize],C.prototype,"localHistoryHome",null),Ae([t.memoize],C.prototype,"keyboardLayoutResource",null),Ae([t.memoize],C.prototype,"argvResource",null),Ae([t.memoize],C.prototype,"isExtensionDevelopment",null),Ae([t.memoize],C.prototype,"untitledWorkspacesHome",null),Ae([t.memoize],C.prototype,"installSourcePath",null),Ae([t.memoize],C.prototype,"builtinExtensionsPath",null),Ae([t.memoize],C.prototype,"extensionsPath",null),Ae([t.memoize],C.prototype,"extensionDevelopmentLocationURI",null),Ae([t.memoize],C.prototype,"extensionDevelopmentKind",null),Ae([t.memoize],C.prototype,"extensionTestsLocationURI",null),Ae([t.memoize],C.prototype,"debugExtensionHost",null),Ae([t.memoize],C.prototype,"logLevel",null),Ae([t.memoize],C.prototype,"extensionLogLevel",null),Ae([t.memoize],C.prototype,"serviceMachineIdResource",null),Ae([t.memoize],C.prototype,"telemetryLogResource",null),Ae([t.memoize],C.prototype,"disableWorkspaceTrust",null),Ae([t.memoize],C.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=C;function T(d,g){return w(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=T;function R(d,g){return w(d["inspect-search"],d["inspect-brk-search"],5876,g,d.extensionEnvironment)}e.parseSearchPort=R;function S(d,g){return w(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,g,d.extensionEnvironment)}e.parsePtyHostPort=S;function w(d,g,p,m,v,u){const h=Number(g||d)||(m?null:p),i=h?Boolean(!!g):!1;let r;if(u)try{r=JSON.parse(u)}catch{}return{port:h,break:i,debugId:v,env:r}}}),define(we[59],ye([1,0,271,3,162]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const I={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,P.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},category:{type:"string",cat:"e",description:(0,P.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,P.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function b(g,p,m=k){const v=g.find(f=>f.length>0&&f[0]!=="-"),u={},l=["_"],h=[],i={};let r;for(const f in p){const o=p[f];o.type==="subcommand"?f===v&&(r=o):(o.alias&&(u[f]=o.alias),o.type==="string"||o.type==="string[]"?(l.push(f),o.deprecates&&l.push(...o.deprecates)):o.type==="boolean"&&(h.push(f),o.deprecates&&h.push(...o.deprecates)),o.global&&(i[f]=o))}if(r&&v){const f=i;for(const O in r.options)f[O]=r.options[O];const o=g.filter(O=>O!==v),c=m.getSubcommandReporter?m.getSubcommandReporter(v):void 0,D=b(o,f,c);return{[v]:D,_:[]}}const n=y(g,{string:l,boolean:h,alias:u}),s={},a=n;s._=n._.map(f=>String(f)).filter(f=>f.length>0),delete a._;for(const f in p){const o=p[f];if(o.type==="subcommand")continue;o.alias&&delete a[o.alias];let c=a[f];if(o.deprecates)for(const D of o.deprecates)a.hasOwnProperty(D)&&(c||(c=a[D],c&&m.onDeprecatedOption(D,o.deprecationMessage||(0,P.localize)(36,null,f))),delete a[D]);if(typeof c<"u"){if(o.type==="string[]"){if(Array.isArray(c)||(c=[c]),!o.allowEmptyValue){const D=c.filter(O=>O.length>0);D.length!==c.length&&(m.onEmptyValue(f),c=D.length>0?D:void 0)}}else o.type==="string"&&(Array.isArray(c)?(c=c.pop(),m.onMultipleValues(f,c)):!c&&!o.allowEmptyValue&&(m.onEmptyValue(f),c=void 0));s[f]=c,o.deprecationMessage&&m.onDeprecatedOption(f,o.deprecationMessage)}delete a[f]}for(const f in a)m.onUnknownOption(f);return s}e.parseArgs=b;function E(g,p){let m="";return p.args&&(Array.isArray(p.args)?m=` <${p.args.join("> <")}>`:m=` <${p.args}>`),p.alias?`-${p.alias} --${g}${m}`:`--${g}${m}`}function C(g,p){const m=[];for(const v in g){const u=g[v],l=E(v,u);m.push([l,u.description])}return T(m,p)}e.formatOptions=C;function T(g,p){const v=g.reduce((h,i)=>Math.max(h,i[0].length),12)+2+1;if(p-v<25)return g.reduce((h,i)=>h.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const u=p-v-1,l=[];for(const h of g){const i=h[0],r=S(h[1],u),n=R(v-i.length-2);l.push("  "+i+n+r[0]);for(let s=1;s<r.length;s++)l.push(R(v)+r[s])}return l}function R(g){return" ".repeat(g)}function S(g,p){const m=[];for(;g.length;){const v=g.length<p?g.length:g.lastIndexOf(" ",p),u=g.slice(0,v).trim();g=g.slice(v),m.push(u)}return m}function w(g,p,m,v,u){const l=process.stdout.isTTY&&process.stdout.columns||80,h=u?.noInputFiles!==!0?`[${(0,P.localize)(37,null)}...]`:"",i=[`${g} ${m}`];i.push(""),i.push(`${(0,P.localize)(38,null)}: ${p} [${(0,P.localize)(39,null)}]${h}`),i.push(""),u?.noPipe!==!0&&(t.isWindows?i.push((0,P.localize)(40,null,p)):i.push((0,P.localize)(41,null,p)),i.push(""));const r={},n=[];for(const s in v){const a=v[s];if(a.type==="subcommand")a.description&&n.push({command:s,description:a.description});else if(a.description&&a.cat){let f=r[a.cat];f||(r[a.cat]=f={}),f[s]=a}}for(const s in r){const a=s,f=r[a];f&&(i.push(I[a]),i.push(...C(f,l)),i.push(""))}return n.length&&(i.push((0,P.localize)(42,null)),i.push(...T(n.map(s=>[s.command,s.description]),l)),i.push("")),i.join(`
`)}e.buildHelpMessage=w;function d(g,p){return`${g||(0,P.localize)(43,null)}
${p||(0,P.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(we[192],ye([1,0,272,163,59]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const I=2048;function k(S,w){const d=(l,h)=>{console.warn((0,t.localize)(0,null,l,h))},g=l=>{console.warn((0,t.localize)(1,null,l))},p=(l,h)=>{console.warn((0,t.localize)(2,null,l,h))},m=l=>({onUnknownOption:h=>{l!=="tunnel"&&console.warn((0,t.localize)(3,null,h,l))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:p,getSubcommandReporter:l!=="tunnel"?m:void 0}),v={onUnknownOption:l=>{console.warn((0,t.localize)(4,null,l))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:p,getSubcommandReporter:m},u=(0,P.parseArgs)(S,P.OPTIONS,w?v:void 0);return u.goto&&u._.forEach(l=>y(/^(\w:)?[^:]+(:\d*){0,2}$/.test(l),(0,t.localize)(5,null))),u["max-memory"]&&y(parseInt(u["max-memory"])>=I,`The max-memory argument cannot be specified lower than ${I} MB.`),u}function b(S){const w=S.findIndex(d=>!/^-/.test(d));if(w>-1)return[...S.slice(0,w),...S.slice(w+1)]}function E(S){let[,...w]=S;process.env.VSCODE_DEV&&(w=b(w)||[]);const d=!R(process.env);return k(w,d)}e.parseMainProcessArgv=E;function C(S){let[,,...w]=S;return process.env.VSCODE_DEV&&(w=b(w)||[]),k(w,!0)}e.parseCLIProcessArgv=C;function T(S,...w){const d=S.indexOf("--");return d===-1?S.push(...w):S.splice(d,0,...w),S}e.addArg=T;function R(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),function(){"use strict";function se(e,y,t){function P(k,b){const E=I(k,b),C=[E];return e.isAbsolute(E)||C.unshift(t),e.resolve(...C)}function I(k,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,b);const T=k["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(R,"AppData","Roaming")}break;case"darwin":C=e.join(y.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,b)}return{getUserDataPath:P}}if(typeof define=="function")define(we[193],ye([88,29,27]),function(e,y,t){return se(e,y,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=se(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(we[194],ye([1,0,29,100,193]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class I extends t.AbstractNativeEnvironmentService{constructor(b,E){super(b,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,P.getUserDataPath)(b,E.nameShort)},E)}}e.NativeEnvironmentService=I}),define(we[195],ye([1,0,13,167]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function P(k,b,E){try{I(k,b,E)}catch{}return k}e.localizeManifest=P;function I(k,b,E){const C=(T,R,S)=>{const w=T[R];if((0,y.isString)(w)){const d=w,g=d.length;if(g>1&&d[0]==="%"&&d[g-1]==="%"){const p=d.substr(1,g-2);let m=b[p];m===void 0&&E&&(m=E[p]);const v=typeof m=="string"?m:m.message;if(v!==void 0){const u=E?.[p],l=typeof u=="string"?u:u?.message;if(S&&(R==="title"||R==="category")&&l&&l!==v){const h={value:v,original:l};T[R]=h}else T[R]=v}else console.warn(`[${k.name}]: ${(0,t.localize)(0,null,p)}`)}}else if((0,y.isObject)(w))for(const d in w)w.hasOwnProperty(d)&&(d==="commands"?C(w,d,!0):C(w,d,S));else if(Array.isArray(w))for(let d=0;d<w.length;d++)C(w,d,S)};for(const T in k)k.hasOwnProperty(T)&&C(k,T)}}),define(we[72],ye([1,0,19,69,171,49]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function E(m){return m=m.trim(),m==="*"||k.test(m)}e.isValidVersionStr=E;function C(m){if(!E(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=m.match(k);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=C;function T(m){if(!m)return null;const v=m.majorBase,u=m.majorMustEqual,l=m.minorBase;let h=m.minorMustEqual;const i=m.patchBase;let r=m.patchMustEqual;m.hasCaret&&(v===0||(h=!1),r=!1);let n=0;if(m.preRelease){const s=b.exec(m.preRelease);if(s){const[,a,f,o]=s;n=Date.UTC(Number(a),Number(f)-1,Number(o))}}return{majorBase:v,majorMustEqual:u,minorBase:l,minorMustEqual:h,patchBase:i,patchMustEqual:r,isMinimum:m.hasGreaterEquals,notBefore:n}}e.normalizeVersion=T;function R(m,v,u){let l;typeof m=="string"?l=T(C(m)):l=m;let h;v instanceof Date?h=v.getTime():typeof v=="string"&&(h=new Date(v).getTime());let i;if(typeof u=="string"?i=T(C(u)):i=u,!l||!i)return!1;const r=l.majorBase,n=l.minorBase,s=l.patchBase;let a=i.majorBase,f=i.minorBase,o=i.patchBase;const c=i.notBefore;let D=i.majorMustEqual,O=i.minorMustEqual,H=i.patchMustEqual;return i.isMinimum?r>a?!0:r<a?!1:n>f?!0:n<f||h&&h<c?!1:s>=o:(r===1&&a===0&&(!D||!O||!H)&&(a=1,f=0,o=0,D=!0,O=!1,H=!1),r<a?!1:r>a?!D:n<f?!1:n>f?!O:s<o?!1:s>o?!H:!(h&&h<c))}e.isValidVersion=R;function S(m,v,u,l,h){const i=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return i.push([t.default.Error,P.localize(0,null)]),i;if(typeof l.name!="string")return i.push([t.default.Error,P.localize(1,null,"name")]),i;if(typeof l.version!="string")return i.push([t.default.Error,P.localize(2,null,"version")]),i;if(!l.engines)return i.push([t.default.Error,P.localize(3,null,"engines")]),i;if(typeof l.engines.vscode!="string")return i.push([t.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof l.extensionDependencies<"u"&&!p(l.extensionDependencies))return i.push([t.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof l.activationEvents<"u"){if(!p(l.activationEvents))return i.push([t.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof l.main>"u"&&typeof l.browser>"u")return i.push([t.default.Error,P.localize(7,null,"activationEvents","main")]),i}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&i.push([t.default.Warning,P.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return i.push([t.default.Error,P.localize(9,null,"main")]),i;{const s=(0,y.joinPath)(u,l.main);(0,y.isEqualOrParent)(s,u)||i.push([t.default.Warning,P.localize(10,null,s.path,u.path)])}if(typeof l.activationEvents>"u")return i.push([t.default.Error,P.localize(11,null,"activationEvents","main")]),i}if(typeof l.browser<"u"){if(typeof l.browser!="string")return i.push([t.default.Error,P.localize(12,null,"browser")]),i;{const s=(0,y.joinPath)(u,l.browser);(0,y.isEqualOrParent)(s,u)||i.push([t.default.Warning,P.localize(13,null,s.path,u.path)])}if(typeof l.activationEvents>"u")return i.push([t.default.Error,P.localize(14,null,"activationEvents","browser")]),i}if(!I.valid(l.version))return i.push([t.default.Error,P.localize(15,null)]),i;const r=[];if(!w(m,v,l,h,r))for(const s of r)i.push([t.default.Error,s]);return i}e.validateExtensionManifest=S;function w(m,v,u,l,h){return l||typeof u.main>"u"&&typeof u.browser>"u"?!0:g(m,v,u.engines.vscode,h)}e.isValidExtensionVersion=w;function d(m,v,u){return m==="*"||g(v,u,m)}e.isEngineValid=d;function g(m,v,u,l=[]){const h=T(C(u));if(!h)return l.push(P.localize(16,null,u)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return l.push(P.localize(17,null,u)),!1}else if(!h.majorMustEqual)return l.push(P.localize(18,null,u)),!1;return R(m,v,h)?!0:(l.push(P.localize(19,null,m,u)),!1)}function p(m){if(!Array.isArray(m))return!1;for(let v=0,u=m.length;v<u;v++)if(typeof m[v]!="string")return!1;return!0}}),define(we[196],ye([1,0,16,23]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(I,k,b){let E=b&&b.get("storage.serviceMachineId",-1)||null;if(E)return E;try{const T=(await k.readFile(I.serviceMachineIdResource)).value.toString();E=(0,t.isUUID)(T)?T:null}catch{E=null}if(!E){E=(0,t.generateUuid)();try{await k.writeFile(I.serviceMachineIdResource,y.VSBuffer.fromString(E))}catch{}}return b?.store("storage.serviceMachineId",E,-1,1),E}e.getServiceMachineId=P}),define(we[60],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class y{constructor(P,I=[],k=!1){this.ctor=P,this.staticArguments=I,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=y}),define(we[197],ye([1,0,60]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var P;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(P=e.InstantiationType||(e.InstantiationType={}));function I(b,E,C){E instanceof y.SyncDescriptor||(E=new y.SyncDescriptor(E,[],Boolean(C))),t.push([b,E])}e.registerSingleton=I;function k(){return t}e.getSingletonServiceDescriptors=k}),define(we[198],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(I,k){this.key=I,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=y;class t{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(const k of this._nodes.values())k.outgoing.size===0&&I.push(k);return I}insertEdge(I,k){const b=this.lookupOrInsertNode(I),E=this.lookupOrInsertNode(k);b.outgoing.set(E.key,E),E.incoming.set(b.key,b)}removeNode(I){const k=this._hashFn(I);this._nodes.delete(k);for(const b of this._nodes.values())b.outgoing.delete(k),b.incoming.delete(k)}lookupOrInsertNode(I){const k=this._hashFn(I);let b=this._nodes.get(k);return b||(b=new y(k,I),this._nodes.set(k,b)),b}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){const I=[];for(const[k,b]of this._nodes)I.push(`${k}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,k]of this._nodes){const b=new Set([I]),E=this._findCycle(k,b);if(E)return E}}_findCycle(I,k){for(const[b,E]of I.outgoing){if(k.has(b))return[...k,b].join(" -> ");k.add(b);const C=this._findCycle(E,k);if(C)return C;k.delete(b)}}}e.Graph=t}),define(we[5],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function b(E){return E[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=b})(y=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function t(k,b,E){b[y.DI_TARGET]===b?b[y.DI_DEPENDENCIES].push({id:k,index:E}):(b[y.DI_DEPENDENCIES]=[{id:k,index:E}],b[y.DI_TARGET]=b)}function P(k){if(y.serviceIds.has(k))return y.serviceIds.get(k);const b=function(E,C,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(b,E,T)};return b.toString=()=>k,y.serviceIds.set(k,b),b}e.createDecorator=P;function I(k){return k}e.refineServiceDecorator=I}),define(we[24],ye([1,0,13,4,5]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function I(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=I;function k(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var b;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function C(m,v){const u=Object.create(null);for(const l in m)T(u,l,m[l],v);return u}e.toValuesTree=C;function T(m,v,u,l){const h=v.split("."),i=h.pop();let r=m;for(let n=0;n<h.length;n++){const s=h[n];let a=r[s];switch(typeof a){case"undefined":a=r[s]=Object.create(null);break;case"object":break;default:l(`Ignoring ${v} as ${h.slice(0,n+1).join(".")} is ${JSON.stringify(a)}`);return}r=a}if(typeof r=="object"&&r!==null)try{r[i]=u}catch{l(`Ignoring ${v} as ${h.join(".")} is ${JSON.stringify(r)}`)}else l(`Ignoring ${v} as ${h.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=T;function R(m,v){const u=v.split(".");S(m,u)}e.removeFromValueTree=R;function S(m,v){const u=v.shift();if(v.length===0){delete m[u];return}if(Object.keys(m).indexOf(u)!==-1){const l=m[u];typeof l=="object"&&!Array.isArray(l)&&(S(l,v),Object.keys(l).length===0&&delete m[u])}}function w(m,v,u){function l(r,n){let s=r;for(const a of n){if(typeof s!="object"||s===null)return;s=s[a]}return s}const h=v.split("."),i=l(m,h);return typeof i>"u"?u:i}e.getConfigurationValue=w;function d(m,v,u){Object.keys(v).forEach(l=>{l!=="__proto__"&&(l in m?y.isObject(m[l])&&y.isObject(v[l])?d(m[l],v[l],u):u&&(m[l]=v[l]):m[l]=v[l])})}e.merge=d;function g(m,v,u){const l=m.inspect(v),h=m.inspect(u);return typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:l.defaultValue}e.getMigratedSettingValue=g;function p(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(we[101],ye([1,0,3,15,5]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",y.isMacintosh),I.set("isLinux",y.isLinux),I.set("isWindows",y.isWindows),I.set("isWeb",y.isWeb),I.set("isMacNative",y.isMacintosh&&!y.isWeb),I.set("isEdge",y.isEdge),I.set("isFirefox",y.isFirefox),I.set("isChrome",y.isChrome),I.set("isSafari",y.isSafari);const k=Object.prototype.hasOwnProperty;var b;(function(ae){ae[ae.False=0]="False",ae[ae.True=1]="True",ae[ae.Defined=2]="Defined",ae[ae.Not=3]="Not",ae[ae.Equals=4]="Equals",ae[ae.NotEquals=5]="NotEquals",ae[ae.And=6]="And",ae[ae.Regex=7]="Regex",ae[ae.NotRegex=8]="NotRegex",ae[ae.Or=9]="Or",ae[ae.In=10]="In",ae[ae.NotIn=11]="NotIn",ae[ae.Greater=12]="Greater",ae[ae.GreaterEquals=13]="GreaterEquals",ae[ae.Smaller=14]="Smaller",ae[ae.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return R.INSTANCE}static true(){return S.INSTANCE}static has(N){return w.create(N)}static equals(N,J){return d.create(N,J)}static notEquals(N,J){return m.create(N,J)}static regex(N,J){return n.create(N,J)}static in(N,J){return g.create(N,J)}static notIn(N,J){return p.create(N,J)}static not(N){return v.create(N)}static and(...N){return f.create(N,null,!0)}static or(...N){return o.create(N,null,!0)}static greater(N,J){return l.create(N,J)}static greaterEquals(N,J){return h.create(N,J)}static smaller(N,J){return i.create(N,J)}static smallerEquals(N,J){return r.create(N,J)}static deserialize(N,J=!1){if(!!N)return this._deserializeOrExpression(N,J)}static _deserializeOrExpression(N,J){const B=N.split("||");return o.create(B.map(x=>this._deserializeAndExpression(x,J)),null,!0)}static _deserializeAndExpression(N,J){const B=N.split("&&");return f.create(B.map(x=>this._deserializeOne(x,J)),null,!0)}static _deserializeOne(N,J){if(N=N.trim(),N.indexOf("!=")>=0){const B=N.split("!=");return m.create(B[0].trim(),this._deserializeValue(B[1],J))}if(N.indexOf("==")>=0){const B=N.split("==");return d.create(B[0].trim(),this._deserializeValue(B[1],J))}if(N.indexOf("=~")>=0){const B=N.split("=~");return n.create(B[0].trim(),this._deserializeRegexValue(B[1],J))}if(N.indexOf(" not in ")>=0){const B=N.split(" not in ");return p.create(B[0].trim(),this._deserializeValue(B[1],J))}if(N.indexOf(" in ")>=0){const B=N.split(" in ");return g.create(B[0].trim(),this._deserializeValue(B[1],J))}if(/^[^<=>]+>=[^<=>]+$/.test(N)){const B=N.split(">=");return h.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(N)){const B=N.split(">");return l.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(N)){const B=N.split("<=");return r.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(N)){const B=N.split("<");return i.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(N)?v.create(N.substr(1).trim()):w.create(N)}static _deserializeValue(N,J){if(N=N.trim(),N==="true")return!0;if(N==="false")return!1;const B=/^'([^']*)'$/.exec(N);return B?B[1].trim():N}static _deserializeRegexValue(N,J){if((0,t.isFalsyOrWhitespace)(N)){if(J)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const B=N.indexOf("/"),x=N.lastIndexOf("/");if(B===x||B<0){if(J)throw new Error(`bad regexp-value '${N}', missing /-enclosure`);return console.warn(`bad regexp-value '${N}', missing /-enclosure`),null}const z=N.slice(B+1,x),j=N[x+1]==="i"?"i":"";try{return new RegExp(z,j)}catch(L){if(J)throw new Error(`bad regexp-value '${N}', parse error: ${L}`);return console.warn(`bad regexp-value '${N}', parse error: ${L}`),null}}}e.ContextKeyExpr=E;function C(ae,N){const J=ae?ae.substituteConstants():void 0,B=N?N.substituteConstants():void 0;return!J&&!B?!0:!J||!B?!1:J.equals(B)}e.expressionsAreEqualWithConstantSubstitution=C;function T(ae,N){return ae.cmp(N)}class R{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=R,R.INSTANCE=new R;class S{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return R.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class w{static create(N,J=null){const B=I.get(N);return typeof B=="boolean"?B?S.INSTANCE:R.INSTANCE:new w(N,J)}constructor(N,J){this.key=N,this.negated=J,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:D(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=I.get(this.key);return typeof N=="boolean"?N?S.INSTANCE:R.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class d{static create(N,J,B=null){if(typeof J=="boolean")return J?w.create(N,B):v.create(N,B);const x=I.get(N);return typeof x=="boolean"?J===(x?"true":"false")?S.INSTANCE:R.INSTANCE:new d(N,J,B)}constructor(N,J,B){this.key=N,this.value=J,this.negated=B,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:O(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){const N=I.get(this.key);if(typeof N=="boolean"){const J=N?"true":"false";return this.value===J?S.INSTANCE:R.INSTANCE}return this}evaluate(N){return N.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(N){return N.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class g{static create(N,J){return new g(N,J)}constructor(N,J){this.key=N,this.valueKey=J,this.type=10,this.negated=null}cmp(N){return N.type!==this.type?this.type-N.type:O(this.key,this.valueKey,N.key,N.valueKey)}equals(N){return N.type===this.type?this.key===N.key&&this.valueKey===N.valueKey:!1}substituteConstants(){return this}evaluate(N){const J=N.getValue(this.valueKey),B=N.getValue(this.key);return Array.isArray(J)?J.includes(B):typeof B=="string"&&typeof J=="object"&&J!==null?k.call(J,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(N){return N.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=p.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=g;class p{static create(N,J){return new p(N,J)}constructor(N,J){this.key=N,this.valueKey=J,this.type=11,this._negated=g.create(N,J)}cmp(N){return N.type!==this.type?this.type-N.type:this._negated.cmp(N._negated)}equals(N){return N.type===this.type?this._negated.equals(N._negated):!1}substituteConstants(){return this}evaluate(N){return!this._negated.evaluate(N)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(N){return N.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=p;class m{static create(N,J,B=null){if(typeof J=="boolean")return J?v.create(N,B):w.create(N,B);const x=I.get(N);return typeof x=="boolean"?J===(x?"true":"false")?R.INSTANCE:S.INSTANCE:new m(N,J,B)}constructor(N,J,B){this.key=N,this.value=J,this.negated=B,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:O(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){const N=I.get(this.key);if(typeof N=="boolean"){const J=N?"true":"false";return this.value===J?R.INSTANCE:S.INSTANCE}return this}evaluate(N){return N.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(N){return N.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class v{static create(N,J=null){const B=I.get(N);return typeof B=="boolean"?B?R.INSTANCE:S.INSTANCE:new v(N,J)}constructor(N,J){this.key=N,this.negated=J,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:D(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=I.get(this.key);return typeof N=="boolean"?N?R.INSTANCE:S.INSTANCE:this}evaluate(N){return!N.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(N){return N.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function u(ae,N){if(typeof ae=="string"){const J=parseFloat(ae);isNaN(J)||(ae=J)}return typeof ae=="string"||typeof ae=="number"?N(ae):R.INSTANCE}class l{static create(N,J,B=null){return u(J,x=>new l(N,x,B))}constructor(N,J,B){this.key=N,this.value=J,this.negated=B,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:O(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(N){return N.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class h{static create(N,J,B=null){return u(J,x=>new h(N,x,B))}constructor(N,J,B){this.key=N,this.value=J,this.negated=B,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:O(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(N){return N.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=h;class i{static create(N,J,B=null){return u(J,x=>new i(N,x,B))}constructor(N,J,B){this.key=N,this.value=J,this.negated=B,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:O(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(N){return N.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class r{static create(N,J,B=null){return u(J,x=>new r(N,x,B))}constructor(N,J,B){this.key=N,this.value=J,this.negated=B,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:O(this.key,this.value,N.key,N.value)}equals(N){return N.type===this.type?this.key===N.key&&this.value===N.value:!1}substituteConstants(){return this}evaluate(N){return typeof this.value=="string"?!1:parseFloat(N.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(N){return N.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class n{static create(N,J){return new n(N,J)}constructor(N,J){this.key=N,this.regexp=J,this.type=7,this.negated=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.key<N.key)return-1;if(this.key>N.key)return 1;const J=this.regexp?this.regexp.source:"",B=N.regexp?N.regexp.source:"";return J<B?-1:J>B?1:0}equals(N){if(N.type===this.type){const J=this.regexp?this.regexp.source:"",B=N.regexp?N.regexp.source:"";return this.key===N.key&&J===B}return!1}substituteConstants(){return this}evaluate(N){const J=N.getValue(this.key);return this.regexp?this.regexp.test(J):!1}serialize(){const N=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${N}`}keys(){return[this.key]}map(N){return N.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class s{static create(N){return new s(N)}constructor(N){this._actual=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this._actual.cmp(N._actual)}equals(N){return N.type===this.type?this._actual.equals(N._actual):!1}substituteConstants(){return this}evaluate(N){return!this._actual.evaluate(N)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(N){return new s(this._actual.map(N))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function a(ae){let N=null;for(let J=0,B=ae.length;J<B;J++){const x=ae[J].substituteConstants();if(ae[J]!==x&&N===null){N=[];for(let z=0;z<J;z++)N[z]=ae[z]}N!==null&&(N[J]=x)}return N===null?ae:N}class f{static create(N,J,B){return f._normalizeArr(N,J,B)}constructor(N,J){this.expr=N,this.negated=J,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let J=0,B=this.expr.length;J<B;J++){const x=T(this.expr[J],N.expr[J]);if(x!==0)return x}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let J=0,B=this.expr.length;J<B;J++)if(!this.expr[J].equals(N.expr[J]))return!1;return!0}return!1}substituteConstants(){const N=a(this.expr);return N===this.expr?this:f.create(N,this.negated,!1)}evaluate(N){for(let J=0,B=this.expr.length;J<B;J++)if(!this.expr[J].evaluate(N))return!1;return!0}static _normalizeArr(N,J,B){const x=[];let z=!1;for(const j of N)if(!!j){if(j.type===1){z=!0;continue}if(j.type===0)return R.INSTANCE;if(j.type===6){x.push(...j.expr);continue}x.push(j)}if(x.length===0&&z)return S.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(T);for(let j=1;j<x.length;j++)x[j-1].equals(x[j])&&(x.splice(j,1),j--);if(x.length===1)return x[0];for(;x.length>1;){const j=x[x.length-1];if(j.type!==9)break;x.pop();const L=x.pop(),F=x.length===0,G=o.create(j.expr.map(oe=>f.create([oe,L],null,B)),null,F);G&&(x.push(G),x.sort(T))}if(x.length===1)return x[0];if(B){for(let j=0;j<x.length;j++)for(let L=j+1;L<x.length;L++)if(x[j].negate().equals(x[L]))return R.INSTANCE;if(x.length===1)return x[0]}return new f(x,J)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const J of this.expr)N.push(...J.keys());return N}map(N){return new f(this.expr.map(J=>J.map(N)),null)}negate(){if(!this.negated){const N=[];for(const J of this.expr)N.push(J.negate());this.negated=o.create(N,this,!0)}return this.negated}}class o{static create(N,J,B){return o._normalizeArr(N,J,B)}constructor(N,J){this.expr=N,this.negated=J,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let J=0,B=this.expr.length;J<B;J++){const x=T(this.expr[J],N.expr[J]);if(x!==0)return x}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let J=0,B=this.expr.length;J<B;J++)if(!this.expr[J].equals(N.expr[J]))return!1;return!0}return!1}substituteConstants(){const N=a(this.expr);return N===this.expr?this:o.create(N,this.negated,!1)}evaluate(N){for(let J=0,B=this.expr.length;J<B;J++)if(this.expr[J].evaluate(N))return!0;return!1}static _normalizeArr(N,J,B){let x=[],z=!1;if(N){for(let j=0,L=N.length;j<L;j++){const F=N[j];if(!!F){if(F.type===0){z=!0;continue}if(F.type===1)return S.INSTANCE;if(F.type===9){x=x.concat(F.expr);continue}x.push(F)}}if(x.length===0&&z)return R.INSTANCE;x.sort(T)}if(x.length!==0){if(x.length===1)return x[0];for(let j=1;j<x.length;j++)x[j-1].equals(x[j])&&(x.splice(j,1),j--);if(x.length===1)return x[0];if(B){for(let j=0;j<x.length;j++)for(let L=j+1;L<x.length;L++)if(x[j].negate().equals(x[L]))return S.INSTANCE;if(x.length===1)return x[0]}return new o(x,J)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const J of this.expr)N.push(...J.keys());return N}map(N){return new o(this.expr.map(J=>J.map(N)),null)}negate(){if(!this.negated){const N=[];for(const J of this.expr)N.push(J.negate());for(;N.length>1;){const J=N.shift(),B=N.shift(),x=[];for(const z of ce(J))for(const j of ce(B))x.push(f.create([z,j],null,!1));N.unshift(o.create(x,null,!1))}this.negated=o.create(N,this,!0)}return this.negated}}class c extends w{static all(){return c._info.values()}constructor(N,J,B){super(N,null),this._defaultValue=J,typeof B=="object"?c._info.push({...B,key:N}):B!==!0&&c._info.push({key:N,description:B,type:J!=null?typeof J:void 0})}bindTo(N){return N.createKey(this.key,this._defaultValue)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return d.create(this.key,N)}notEqualsTo(N){return m.create(this.key,N)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function D(ae,N){return ae<N?-1:ae>N?1:0}function O(ae,N,J,B){return ae<J?-1:ae>J?1:N<B?-1:N>B?1:0}function H(ae,N){if(ae.type===0||N.type===1)return!0;if(ae.type===9)return N.type===9?re(ae.expr,N.expr):!1;if(N.type===9){for(const J of N.expr)if(H(ae,J))return!0;return!1}if(ae.type===6){if(N.type===6)return re(N.expr,ae.expr);for(const J of ae.expr)if(H(J,N))return!0;return!1}return ae.equals(N)}e.implies=H;function re(ae,N){let J=0,B=0;for(;J<ae.length&&B<N.length;){const x=ae[J].cmp(N[B]);if(x<0)return!1;x===0&&J++,B++}return J===ae.length}function ce(ae){return ae.type===9?ae.expr:[ae]}}),define(we[73],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,y.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,y.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(I,k){return this.secretVault[I]?.[k]??null}async setPassword(I,k,b){this.secretVault[I]=this.secretVault[I]??{},this.secretVault[I][k]=b}async deletePassword(I,k){return this.secretVault[I]?.[k]?(delete this.secretVault[I][k],Object.keys(this.secretVault[I]).length===0&&delete this.secretVault[I],!0):!1}async findPassword(I){return JSON.stringify(this.secretVault[I])??null}async findCredentials(I){const k=[];for(const b of Object.keys(this.secretVault[I]||{}))k.push({account:b,password:this.secretVault[I][b]});return k}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(we[199],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,y.createDecorator)(e.ID);function t(I){return!!I.hostName&&!!I.errorMessage}e.isRemoteDiagnosticError=t;class P{async getPerformanceInfo(k,b){return{}}async getSystemInfo(k,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,b){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=P}),define(we[74],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,y.createDecorator)("downloadService")}),define(we[200],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,y.createDecorator)("encryptionMainService")}),define(we[25],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,y.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,y.refineServiceDecorator)(e.IEnvironmentService)}),define(we[30],ye([1,0,165,5]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function P(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function I(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function k(m,v){switch(m){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function b(m,v){return v==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function E(m,v,u){return b(v,u)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===u?!0:C(u).includes(m)}e.isTargetPlatformCompatible=E;function C(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function T(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=T;var R;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(R=e.SortBy||(e.SortBy={}));var S;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var w;(function(m){m.Install="install",m.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var d;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var g;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal",m.Signature="Signature"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(v,u){super(v),this.code=u,this.name=u}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,y.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,y.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(we[201],ye([1,0,7,2,47,22,4,71,30]),function(se,e,y,t,P,I,k,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(p,m){return k.URI.revive(m?m.transformIncoming(p):p)}function T(p,m){return m?m.transformOutgoingURI(p):p}function R(p,m){m=m||b.DefaultURITransformer;const v=p.manifest;return{...(0,b.transformAndReviveIncomingURIs)({...p,manifest:void 0},m),manifest:v}}function S(p,m){return m?(0,I.cloneAndChange)(p,v=>v instanceof k.URI?m.transformOutgoingURI(v):void 0):p}class w{constructor(m,v){this.service=m,this.getUriTransformer=v,this.onInstallExtension=y.Event.buffer(m.onInstallExtension,!0),this.onDidInstallExtensions=y.Event.buffer(m.onDidInstallExtensions,!0),this.onUninstallExtension=y.Event.buffer(m.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(m.onDidUninstallExtension,!0)}listen(m,v){const u=this.getUriTransformer(m);switch(v){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return y.Event.map(this.onDidInstallExtensions,l=>l.map(h=>({...h,local:h.local?S(h.local,u):h.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(m,v,u){const l=this.getUriTransformer(m);switch(v){case"zip":return this.service.zip(R(u[0],l)).then(h=>T(h,l));case"unzip":return this.service.unzip(C(u[0],l));case"install":return this.service.install(C(u[0],l),(0,P.revive)(u[1]));case"getManifest":return this.service.getManifest(C(u[0],l));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(u[0]);case"installFromGallery":return this.service.installFromGallery(u[0],(0,P.revive)(u[1]));case"uninstall":return this.service.uninstall(R(u[0],l),(0,P.revive)(u[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(R(u[0],l));case"getInstalled":return this.service.getInstalled(u[0],k.URI.revive(u[1])).then(h=>h.map(i=>S(i,l)));case"getMetadata":return this.service.getMetadata(R(u[0],l));case"updateMetadata":return this.service.updateMetadata(R(u[0],l),u[1]).then(h=>S(h,l));case"updateExtensionScope":return this.service.updateExtensionScope(R(u[0],l),u[1]).then(h=>S(h,l));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(u[0],u[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=w;class d extends t.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(m){super(),this.channel=m,this._onInstallExtension=this._register(new y.Emitter),this._onDidInstallExtensions=this._register(new y.Emitter),this._onUninstallExtension=this._register(new y.Emitter),this._onDidUninstallExtension=this._register(new y.Emitter),this._register(this.channel.listen("onInstallExtension")(v=>this._onInstallExtension.fire({identifier:v.identifier,source:this.isUriComponents(v.source)?k.URI.revive(v.source):v.source,profileLocation:k.URI.revive(v.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(v=>this._onDidInstallExtensions.fire(v.map(u=>({...u,local:u.local?R(u.local,null):u.local,source:this.isUriComponents(u.source)?k.URI.revive(u.source):u.source,profileLocation:k.URI.revive(u.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(v=>this._onUninstallExtension.fire({identifier:v.identifier,profileLocation:k.URI.revive(v.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(v=>this._onDidUninstallExtension.fire({...v,profileLocation:k.URI.revive(v.profileLocation)})))}isUriComponents(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(m){const v=await this.getTargetPlatform();return m.allTargetPlatforms.some(u=>(0,E.isTargetPlatformCompatible)(u,m.allTargetPlatforms,v))}zip(m){return Promise.resolve(this.channel.call("zip",[m]).then(v=>k.URI.revive(v)))}unzip(m){return Promise.resolve(this.channel.call("unzip",[m]))}install(m,v){return Promise.resolve(this.channel.call("install",[m,v])).then(u=>R(u,null))}getManifest(m){return Promise.resolve(this.channel.call("getManifest",[m]))}installFromGallery(m,v){return Promise.resolve(this.channel.call("installFromGallery",[m,v])).then(u=>R(u,null))}uninstall(m,v){return Promise.resolve(this.channel.call("uninstall",[m,v]))}reinstallFromGallery(m){return Promise.resolve(this.channel.call("reinstallFromGallery",[m]))}getInstalled(m=null,v){return Promise.resolve(this.channel.call("getInstalled",[m,v])).then(u=>u.map(l=>R(l,null)))}getMetadata(m){return Promise.resolve(this.channel.call("getMetadata",[m]))}updateMetadata(m,v){return Promise.resolve(this.channel.call("updateMetadata",[m,v])).then(u=>R(u,null))}updateExtensionScope(m,v){return Promise.resolve(this.channel.call("updateExtensionScope",[m,v])).then(u=>R(u,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(m,v){const u=await this.channel.call("download",[m,v]);return k.URI.revive(u)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class g{constructor(m){this.service=m}listen(m,v){throw new Error("Invalid listen")}call(m,v,u){switch(v){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(we[75],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,y.createDecorator)("IExtensionSignatureVerificationService");class t{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((I,k)=>se(["node-vsce-sign"],async b=>I(b),k))),this.moduleLoadingPromise}async verify(I,k){let b;try{b=await this.vsceSign()}catch{return!1}return b.verify(I,k)}}e.ExtensionSignatureVerificationService=t}),define(we[17],ye([1,0,57,6,15,13,4,173,5]),function(se,e,y,t,P,I,k,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function C(z){return z.create===!0}e.isFileOpenForWriteOptions=C;var T;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var R;(function(z){z[z.Readonly=1]="Readonly"})(R=e.FilePermission||(e.FilePermission={}));var S;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=w;function d(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=g;function p(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function m(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=m;function v(z){return w(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var u;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(j,L){super(j),this.code=L}}e.FileSystemProviderError=l;function h(z,j){const L=new l(z.toString(),j);return r(L,j),L}e.createFileSystemProviderError=h;function i(z){return z||h((0,b.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=i;function r(z,j){return z.name=j?`${j} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=r;function n(z){if(!z)return u.Unknown;if(z instanceof l)return z.code;const j=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!j)return u.Unknown;switch(j[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=n;function s(z){if(z instanceof O)return z.fileOperationResult;switch(n(z)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var a;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class f{constructor(j,L,F){this.resource=j,this.operation=L,this.target=F}isOperation(j){return this.operation===j}}e.FileOperationEvent=f;var o;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class c{constructor(j,L){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=j;const F=new Map;for(const G of j){const oe=F.get(G.type);switch(oe?oe.push([G.resource,G]):F.set(G.type,[[G.resource,G]]),G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}}for(const[G,oe]of F)switch(G){case 1:this.added=y.TernarySearchTree.forUris(()=>L),this.added.fill(oe);break;case 0:this.updated=y.TernarySearchTree.forUris(()=>L),this.updated.fill(oe);break;case 2:this.deleted=y.TernarySearchTree.forUris(()=>L),this.deleted.fill(oe);break}}contains(j,...L){return this.doContains(j,{includeChildren:!1},...L)}affects(j,...L){return this.doContains(j,{includeChildren:!0},...L)}doContains(j,L,...F){if(!j)return!1;const G=F.length>0;return!!((!G||F.includes(1))&&(this.added?.get(j)||L.includeChildren&&this.added?.findSuperstr(j))||(!G||F.includes(0))&&(this.updated?.get(j)||L.includeChildren&&this.updated?.findSuperstr(j))||(!G||F.includes(2))&&(this.deleted?.findSubstr(j)||L.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function D(z,j,L){return!z||!j||z===j||j.length>z.length?!1:(j.charAt(j.length-1)!==t.sep&&(j+=t.sep),L?(0,P.startsWithIgnoreCase)(z,j):z.indexOf(j)===0)}e.isParent=D;class O extends Error{constructor(j,L,F){super(j),this.fileOperationResult=L,this.options=F}}e.FileOperationError=O;class H extends O{constructor(j,L,F){super(j,2,F),this.stat=L}}e.NotModifiedSinceFileOperationError=H;var re;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(re=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ce;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ae(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=ae;async function N(z,j){if(!j.hasProvider(k.URI.from({scheme:z.scheme})))return new Promise(L=>{const F=j.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===z.scheme&&G.added&&(F.dispose(),L())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class J{static formatSize(j){return(0,I.isNumber)(j)||(j=0),j<J.KB?(0,b.localize)(1,null,j.toFixed(0)):j<J.MB?(0,b.localize)(2,null,(j/J.KB).toFixed(2)):j<J.GB?(0,b.localize)(3,null,(j/J.MB).toFixed(2)):j<J.TB?(0,b.localize)(4,null,(j/J.GB).toFixed(2)):(0,b.localize)(5,null,(j/J.TB).toFixed(2))}}e.ByteSize=J,J.KB=1024,J.MB=J.KB*J.KB,J.GB=J.MB*J.KB,J.TB=J.GB*J.KB;var B;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function x(z){return{maxFileSize:z===0?300*J.MB:16*J.GB,maxHeapSize:z===0?700*J.MB:2*700*J.MB}}e.getPlatformLimits=x}),define(we[202],ye([1,0,16,38,10,7,2,44,4,23,17]),function(se,e,y,t,P,I,k,b,E,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class R extends k.Disposable{constructor(w,d){super(),this.channel=w,this.extraCapabilities=d,this.onDidChangeCapabilities=I.Event.None,this._onDidChange=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new I.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,C.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(w){return this.channel.call("stat",[w])}readdir(w){return this.channel.call("readdir",[w])}async readFile(w,d){const{buffer:g}=await this.channel.call("readFile",[w,d]);return g}readFileStream(w,d,g){const p=(0,b.newWriteableStream)(v=>y.VSBuffer.concat(v.map(u=>y.VSBuffer.wrap(u))).buffer),m=this.channel.listen("readFileStream",[w,d])(v=>{if(v instanceof y.VSBuffer)p.write(v.buffer);else{if(v==="end")p.end();else{let u=v;u instanceof Error||(u=(0,T.createFileSystemProviderError)((0,t.toErrorMessage)(u),T.FileSystemProviderErrorCode.Unknown)),p.error(u),p.end()}m.dispose()}});return g.onCancellationRequested(()=>{p.error((0,P.canceled)()),p.end(),m.dispose()}),p}writeFile(w,d,g){return this.channel.call("writeFile",[w,y.VSBuffer.wrap(d),g])}open(w,d){return this.channel.call("open",[w,d])}close(w){return this.channel.call("close",[w])}async read(w,d,g,p,m){const[v,u]=await this.channel.call("read",[w,d,m]);return g.set(v.buffer.slice(0,u),p),u}write(w,d,g,p,m){return this.channel.call("write",[w,d,y.VSBuffer.wrap(g),p,m])}mkdir(w){return this.channel.call("mkdir",[w])}delete(w,d){return this.channel.call("delete",[w,d])}rename(w,d,g){return this.channel.call("rename",[w,d,g])}copy(w,d,g){return this.channel.call("copy",[w,d,g])}cloneFile(w,d){return this.channel.call("cloneFile",[w,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(w=>{if(Array.isArray(w)){const d=w;this._onDidChange.fire(d.map(g=>({resource:E.URI.revive(g.resource),type:g.type})))}else{const d=w;this._onDidWatchError.fire(d)}}))}watch(w,d){const g=(0,C.generateUuid)();return this.channel.call("watch",[this.sessionId,g,w,d]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,g]))}}e.DiskFileSystemProviderClient=R}),define(we[102],ye([1,0,16,10,174,17]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(T,R,S,w,d,g){let p;try{await b(T,R,S,w,d,g)}catch(m){p=m}finally{p&&d.errorTransformer&&(p=d.errorTransformer(p)),typeof p<"u"&&S.error(p),S.end()}}e.readFileIntoStream=k;async function b(T,R,S,w,d,g){E(g);const p=await T.open(R,{create:!1});try{E(g);let m=0,v=0,u=d&&typeof d.length=="number"?d.length:void 0,l=y.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),h=d&&typeof d.position=="number"?d.position:0,i=0;do v=await T.read(p,h,l.buffer,i,l.byteLength-i),h+=v,i+=v,m+=v,typeof u=="number"&&(u-=v),i===l.byteLength&&(await S.write(w(l)),l=y.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),i=0);while(v>0&&(typeof u!="number"||u>0)&&E(g)&&C(m,d));if(i>0){let r=i;typeof u=="number"&&(r=Math.min(i,u)),S.write(w(l.slice(0,r)))}}catch(m){throw(0,I.ensureFileSystemProviderError)(m)}finally{await T.close(p)}}function E(T){if(T.isCancellationRequested)throw(0,t.canceled)();return!0}function C(T,R){if(R?.limits){if(typeof R.limits.memory=="number"&&T>R.limits.memory)throw(0,I.createFileSystemProviderError)((0,P.localize)(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof R.limits.size=="number"&&T>R.limits.size)throw(0,I.createFileSystemProviderError)((0,P.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(we[61],ye([1,0,70,2,6,3,4,17]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(m){return m.recursive===!0}e.isRecursiveWatchRequest=E;class C extends t.Disposable{constructor(v,u,l,h){super(),this.onFileChanges=v,this.onLogMessage=u,this.verboseLogging=l,this.options=h,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const v=new t.DisposableStore;this.watcherDisposables.value=v,this.watcher=this.createWatcher(v),this.watcher.setVerboseLogging(this.verboseLogging),v.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),v.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),v.add(this.watcher.onDidError(u=>this.onError(u)))}onError(v){this.options.restartOnError?this.restartCounter<C.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${v}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${v}`):this.error(v)}restart(v){this.restartCounter++,this.init(),this.watch(v)}async watch(v){this.requests=v,await this.watcher?.watch(v)}async setVerboseLogging(v){this.verboseLogging=v,await this.watcher?.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${v}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=C,C.MAX_RESTARTS=5;class T extends C{constructor(v,u,l){super(v,u,l,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class R extends C{constructor(v,u,l){super(v,u,l,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=R;function S(m){return m.map(v=>({type:v.type,resource:k.URI.file(v.path)}))}e.toFileChanges=S;function w(m){const v=new p;for(const u of m)v.processEvent(u);return v.coalesce()}e.coalesceEvents=w;function d(m,v){return typeof v=="string"&&!v.startsWith(y.GLOBSTAR)&&!(0,P.isAbsolute)(v)?{base:m,pattern:v}:v}e.normalizeWatcherPattern=d;function g(m,v){const u=[];for(const l of v)u.push((0,y.parse)(d(m,l)));return u}e.parseWatcherPatterns=g;class p{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(v){return I.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const u=this.mapPathToChange.get(this.toKey(v));let l=!1;if(u){const h=u.type,i=v.type;u.path!==v.path&&(v.type===2||v.type===1)?l=!0:h===1&&i===2?(this.mapPathToChange.delete(this.toKey(v)),this.coalesced.delete(u)):h===2&&i===1?u.type=0:h===1&&i===0||(u.type=i)}else l=!0;l&&(this.coalesced.add(v),this.mapPathToChange.set(this.toKey(v),v))}coalesce(){const v=[],u=[];return Array.from(this.coalesced).filter(l=>l.type!==2?(v.push(l),!1):!0).sort((l,h)=>l.path.length-h.path.length).filter(l=>u.some(h=>(0,b.isParent)(l.path,h,!I.isLinux))?!1:(u.push(l.path),!0)).concat(v)}}}),define(we[203],ye([1,0,28,14,20,36,2,87,6,3,155,21,61]),function(se,e,y,t,P,I,k,b,E,C,T,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class w extends k.Disposable{constructor(p,m,v,u){super(),this.request=p,this.onDidFilesChange=m,this.onLogMessage=v,this.verboseLogging=u,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(w.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new P.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const p=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await R.Promises.stat(p);this._register(await this.doWatch(p,m.isDirectory()))}catch(p){p.code!=="ENOENT"?this.error(p):this.trace(p)}}async normalizePath(p){let m=p.path;try{m=await R.Promises.realpath(p.path),p.path===m&&(m=await(0,T.realcase)(p.path)??p.path),p.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${p.path}, real: ${m})`)}catch{}return m}async doWatch(p,m){if(C.isMacintosh&&(0,I.isEqualOrParent)(p,"/Volumes/",!0))return this.error(`Refusing to watch ${p} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const v=new P.CancellationTokenSource(this.cts.token),u=new k.DisposableStore;try{const l=(0,E.basename)(p),h=(0,y.watch)(p);u.add((0,k.toDisposable)(()=>{h.removeAllListeners(),h.close()})),this.trace(`Started watching: '${p}'`);const i=new Set;if(m)try{for(const n of await R.Promises.readdir(p))i.add(n)}catch(n){this.error(n)}const r=new Map;u.add((0,k.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),h.on("error",(n,s)=>{this.error(`Failed to watch ${p} for changes using fs.watch() (${n}, ${s})`),this.dispose()}),h.on("change",(n,s)=>{if(v.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${s}`);let a="";if(s&&(a=s.toString(),C.isMacintosh&&(a=(0,b.normalizeNFC)(a))),!(!a||n!=="change"&&n!=="rename"))if(m)if(n==="rename"){r.get(a)?.dispose();const f=setTimeout(async()=>{if(r.delete(a),a===l&&!await R.Promises.exists(p)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.existsChildStrictCase((0,E.join)(p,a));if(v.token.isCancellationRequested)return;let c;o?i.has(a)?c=0:(c=1,i.add(a)):(i.delete(a),c=2),this.onFileChange({path:(0,E.join)(this.request.path,a),type:c})},w.FILE_DELETE_HANDLER_DELAY);r.set(a,(0,k.toDisposable)(()=>clearTimeout(f)))}else{let f;i.has(a)?f=0:(f=1,i.add(a)),this.onFileChange({path:(0,E.join)(this.request.path,a),type:f})}else if(n==="rename"||a!==l){const f=setTimeout(async()=>{const o=await R.Promises.exists(p);v.token.isCancellationRequested||(o?(this.onFileChange({path:this.request.path,type:0},!0),u.add(await this.doWatch(p,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},w.FILE_DELETE_HANDLER_DELAY);u.clear(),u.add((0,k.toDisposable)(()=>clearTimeout(f)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await R.Promises.exists(p)&&!v.token.isCancellationRequested&&this.error(`Failed to watch ${p} for changes using fs.watch() (${l.toString()})`)}return(0,k.toDisposable)(()=>{v.dispose(!0),u.dispose()})}async onFileChange(p,m=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`),!m&&this.excludes.some(v=>v(p.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${p.path}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(v=>v(p.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${p.path}`):this.fileChangesBuffer.push(p);try{await this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const u=(0,S.coalesceEvents)(v);if(u.length>0){if(this.verboseLogging)for(const h of u)this.trace(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);this.throttledFileChangesWorker.work(u)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(p){if(C.isLinux)return R.Promises.exists(p);try{const m=(0,E.basename)(p);return(await R.Promises.readdir((0,E.dirname)(p))).some(u=>u===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(p){this.verboseLogging=p}error(p){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${p}`})}warn(p){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${p}`})}trace(p){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=w,w.FILE_DELETE_HANDLER_DELAY=100,w.FILE_CHANGES_HANDLER_DELAY=50;async function d(g,p,m,v,u=512){const l=await R.Promises.open(g,"r"),h=Buffer.allocUnsafe(u),i=new P.CancellationTokenSource(v);let r,n=!1;const s={path:g,excludes:[],recursive:!1},a=new w(s,f=>{(async()=>{for(const{type:o}of f)if(o===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:c}=await R.Promises.read(l,h,0,u,null);if(!c||i.token.isCancellationRequested)break;p(h.slice(0,c))}}catch(c){r=new Error(c),i.dispose(!0)}finally{n=!1}}})()});return await a.ready,m(),new Promise((f,o)=>{i.token.onCancellationRequested(async()=>{a.dispose();try{await R.Promises.close(l)}catch(c){r=new Error(c)}r?o(r):f()})})}e.watchFileContents=d}),define(we[204],ye([1,0,7,70,2,3,203]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends P.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new y.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new y.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=y.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(C){const T=this.normalizeRequests(C),R=T.filter(w=>{const d=this.watchers.get(w.path);return d?!(0,t.patternsEquals)(d.request.excludes,w.excludes)||!(0,t.patternsEquals)(d.request.includes,w.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:w})=>!T.find(d=>d.path===w.path&&(0,t.patternsEquals)(d.excludes,w.excludes)&&(0,t.patternsEquals)(d.includes,w.includes))).map(({request:w})=>w.path);R.length&&this.trace(`Request to start watching: ${R.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const w of S)this.stopWatching(w);for(const w of R)this.startWatching(w)}startWatching(C){const T=new k.NodeJSFileWatcherLibrary(C,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),R={request:C,instance:T};this.watchers.set(C.path,R)}async stop(){for(const[C]of this.watchers)this.stopWatching(C);this.watchers.clear()}stopWatching(C){const T=this.watchers.get(C);T&&(this.watchers.delete(C),T.instance.dispose())}normalizeRequests(C){const T=new Map;for(const R of C){const S=I.isLinux?R.path:R.path.toLowerCase();T.set(S,R)}return Array.from(T.values())}async setVerboseLogging(C){this.verboseLogging=C;for(const[,T]of this.watchers)T.instance.setVerboseLogging(C)}trace(C){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(C)})}toMessage(C,T){return T?`[File Watcher (node.js)] ${C} (path: ${T.request.path})`:`[File Watcher (node.js)] ${C}`}}e.NodeJSWatcher=b}),define(we[205],ye([1,0,61,204]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class P extends y.AbstractNonRecursiveWatcherClient{constructor(k,b,E){super(k,b,E),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=P}),define(we[206],ye([1,0,11,41,99,61]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends I.AbstractUniversalWatcherClient{constructor(E,C,T){super(E,C,T),this.init()}createWatcher(E){const C=E.add(new P.Client(y.FileAccess.asFileUri("bootstrap-fork",se).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(C.onDidProcessExit(({code:T,signal:R})=>this.onError(`terminated by itself with code ${T}, signal: ${R}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(C.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(we[76],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...P){this._entries=new Map;for(const[I,k]of P)this.set(I,k)}set(P,I){const k=this._entries.get(P);return this._entries.set(P,I),k}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=y}),define(we[103],ye([1,0,14,10,2,60,198,5,76,86]),function(se,e,y,t,P,I,k,b,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class R extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class S{constructor(p=new E.ServiceCollection,m=!1,v,u=T){this._services=p,this._strict=m,this._parent=v,this._enableTracing=u,this._activeInstantiations=new Set,this._services.set(b.IInstantiationService,this),this._globalGraph=u?v?._globalGraph??new k.Graph(l=>l):void 0}createChild(p){return new S(p,this._strict,this,this._enableTracing)}invokeFunction(p,...m){const v=d.traceInvocation(this._enableTracing,p);let u=!1;try{return p({get:h=>{if(u)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(h,v);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...m)}finally{u=!0,v.stop()}}createInstance(p,...m){let v,u;return p instanceof I.SyncDescriptor?(v=d.traceCreation(this._enableTracing,p.ctor),u=this._createInstance(p.ctor,p.staticArguments.concat(m),v)):(v=d.traceCreation(this._enableTracing,p),u=this._createInstance(p,m,v)),v.stop(),u}_createInstance(p,m=[],v){const u=b._util.getServiceDependencies(p).sort((i,r)=>i.index-r.index),l=[];for(const i of u){const r=this._getOrCreateServiceInstance(i.id,v);r||this._throwIfStrict(`[createInstance] ${p.name} depends on UNKNOWN service ${i.id}.`,!1),l.push(r)}const h=u.length>0?u[0].index:m.length;if(m.length!==h){console.trace(`[createInstance] First service dependency of ${p.name} at position ${h+1} conflicts with ${m.length} static arguments`);const i=h-m.length;i>0?m=m.concat(new Array(i)):m=m.slice(0,h)}return Reflect.construct(p,m.concat(l))}_setServiceInstance(p,m){if(this._services.get(p)instanceof I.SyncDescriptor)this._services.set(p,m);else if(this._parent)this._parent._setServiceInstance(p,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){const m=this._services.get(p);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):m}_getOrCreateServiceInstance(p,m){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(p));const v=this._getServiceInstanceOrDescriptor(p);return v instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,v,m.branch(p,!0)):(m.branch(p,!1),v)}_safeCreateAndCacheServiceInstance(p,m,v){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,m,v)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,m,v){const u=new k.Graph(i=>i.id.toString());let l=0;const h=[{id:p,desc:m,_trace:v}];for(;h.length;){const i=h.pop();if(u.lookupOrInsertNode(i),l++>1e3)throw new R(u);for(const r of b._util.getServiceDependencies(i.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(r.id);if(n||this._throwIfStrict(`[createInstance] ${p} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),n instanceof I.SyncDescriptor){const s={id:r.id,desc:n,_trace:i._trace.branch(r.id,!0)};u.insertEdge(i,s),h.push(s)}}}for(;;){const i=u.roots();if(i.length===0){if(!u.isEmpty())throw new R(u);break}for(const{data:r}of i){if(this._getServiceInstanceOrDescriptor(r.id)instanceof I.SyncDescriptor){const s=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,s)}u.removeNode(r)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,m,v=[],u,l){if(this._services.get(p)instanceof I.SyncDescriptor)return this._createServiceInstance(p,m,v,u,l);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,m,v,u,l);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(p,m,v=[],u,l){if(u){const h=new S(void 0,this._strict,this,this._enableTracing);h._globalGraphImplicitDependency=String(p);const i=new Map,r=new y.IdleValue(()=>{const n=h._createInstance(m,v,l);for(const[s,a]of i){const f=n[s];if(typeof f=="function")for(const o of a)f.apply(n,o)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let o=i.get(s);return o||(o=new C.LinkedList,i.set(s,o)),(D,O,H)=>{const re=o.push([D,O,H]);return(0,P.toDisposable)(re)}}if(s in n)return n[s];const a=r.value;let f=a[s];return typeof f!="function"||(f=f.bind(a),n[s]=f),f},set(n,s,a){return r.value[s]=a,!0}})}else return this._createInstance(m,v,l)}_throwIfStrict(p,m){if(m&&console.warn(p),this._strict)throw new Error(p)}}e.InstantiationService=S;var w;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(w||(w={}));class d{static traceInvocation(p,m){return p?new d(1,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d._None}static traceCreation(p,m){return p?new d(0,m.name):d._None}constructor(p,m){this.type=p,this.name=m,this._start=Date.now(),this._dep=[]}branch(p,m){const v=new d(2,p.toString());return this._dep.push([p,m,v]),v}stop(){const p=Date.now()-this._start;d._totals+=p;let m=!1;function v(l,h){const i=[],r=new Array(l+1).join("	");for(const[n,s,a]of h._dep)if(s&&a){m=!0,i.push(`${r}CREATES -> ${n}`);const f=v(l+1,a);f&&i.push(f)}else i.push(`${r}uses -> ${n}`);return i.join(`
`)}const u=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(p>2||m)&&d.all.add(u.join(`
`))}}e.Trace=d,d.all=new Set,d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(we[207],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,y.createDecorator)("labelService")});var _e=this&&this.__param||function(se,e){return function(y,t){e(y,t,se)}};define(we[77],ye([1,0,20,2,3,176,30,5]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,b.createDecorator)("languagePackService");let E=class extends t.Disposable{constructor(T){super(),this.extensionGalleryService=T}async getAvailableLanguages(){const T=new y.CancellationTokenSource;setTimeout(()=>T.cancel(),1e3);let R;try{R=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},T.token)}catch{return[]}const w=R.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(g=>g.startsWith("lp-"))).map(d=>{const g=d.properties.localizedLanguages?.[0],p=this.getLocale(d);return{...this.createQuickPickItem(p,g,d),extensionId:d.identifier.id,galleryExtension:d}});return w.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),w}getLocale(T){return T.tags.find(R=>R.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(T,R,S){const w=R??T;let d;if(w!==T&&(d=`(${T})`),T.toLowerCase()===P.language.toLowerCase()&&(d??="",d+=(0,I.localize)(0,null)),S?.installCount){d??="";const g=S.installCount;let p;g>1e6?p=`${Math.floor(g/1e5)/10}M`:g>1e3?p=`${Math.floor(g/1e3)}K`:p=String(g),d+=` $(cloud-download) ${p}`}return{id:T,label:w,description:d}}};E=Ae([_e(0,k.IExtensionGalleryService)],E),e.LanguagePackBaseService=E}),define(we[12],ye([1,0,38,7,2,31,3,4,5]),function(se,e,y,t,P,I,k,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function C(){return new Date().toISOString()}var T;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(T=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=T.Info;function R(f,o,c){switch(o){case T.Trace:f.trace(c);break;case T.Debug:f.debug(c);break;case T.Info:f.info(c);break;case T.Warning:f.warn(c);break;case T.Error:f.error(c);break;case T.Critical:f.critical(c);break;default:throw new Error("Invalid log level")}}e.log=R;function S(f){let o="";for(let c=0;c<f.length;c++){let D=f[c];if(typeof D=="object")try{D=JSON.stringify(D)}catch{}o+=(c>0?" ":"")+D}return o}e.format=S;class w extends P.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class d extends w{constructor(o){super(),this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...c){this.checkLogLevel(T.Trace)&&this.log(T.Trace,S([o,...c]))}debug(o,...c){this.checkLogLevel(T.Debug)&&this.log(T.Debug,S([o,...c]))}info(o,...c){this.checkLogLevel(T.Info)&&this.log(T.Info,S([o,...c]))}warn(o,...c){this.checkLogLevel(T.Warning)&&this.log(T.Warning,S([o,...c]))}error(o,...c){if(this.checkLogLevel(T.Error))if(o instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=o.stack,this.log(T.Error,S(D))}else this.log(T.Error,S([o,...c]))}critical(o,...c){this.checkLogLevel(T.Critical)&&this.log(T.Critical,S([o,...c]))}flush(){}}e.AbstractMessageLogger=d;class g extends w{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.useColors=!k.isWindows}trace(o,...c){this.getLevel()<=T.Trace&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,o,...c):console.log(`[main ${C()}]`,o,...c))}debug(o,...c){this.getLevel()<=T.Debug&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,o,...c):console.log(`[main ${C()}]`,o,...c))}info(o,...c){this.getLevel()<=T.Info&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,o,...c):console.log(`[main ${C()}]`,o,...c))}warn(o,...c){this.getLevel()<=T.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,o,...c):console.warn(`[main ${C()}]`,o,...c))}error(o,...c){this.getLevel()<=T.Error&&(this.useColors?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,o,...c):console.error(`[main ${C()}]`,o,...c))}critical(o,...c){this.getLevel()<=T.Critical&&(this.useColors?console.error(`\x1B[90m[main ${C()}]\x1B[0m`,o,...c):console.error(`[main ${C()}]`,o,...c))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class p extends w{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...c){this.getLevel()<=T.Trace&&console.log("%cTRACE","color: #888",o,...c)}debug(o,...c){this.getLevel()<=T.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...c)}info(o,...c){this.getLevel()<=T.Info&&console.log("%c INFO","color: #33f",o,...c)}warn(o,...c){this.getLevel()<=T.Warning&&console.log("%c WARN","color: #993",o,...c)}error(o,...c){this.getLevel()<=T.Error&&console.log("%c  ERR","color: #f33",o,...c)}critical(o,...c){this.getLevel()<=T.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...c)}dispose(){}flush(){}}e.ConsoleLogger=p;class m extends w{constructor(o,c=e.DEFAULT_LOG_LEVEL){super(),this.adapter=o,this.setLevel(c)}trace(o,...c){this.getLevel()<=T.Trace&&this.adapter.log(T.Trace,[this.extractMessage(o),...c])}debug(o,...c){this.getLevel()<=T.Debug&&this.adapter.log(T.Debug,[this.extractMessage(o),...c])}info(o,...c){this.getLevel()<=T.Info&&this.adapter.log(T.Info,[this.extractMessage(o),...c])}warn(o,...c){this.getLevel()<=T.Warning&&this.adapter.log(T.Warning,[this.extractMessage(o),...c])}error(o,...c){this.getLevel()<=T.Error&&this.adapter.log(T.Error,[this.extractMessage(o),...c])}critical(o,...c){this.getLevel()<=T.Critical&&this.adapter.log(T.Critical,[this.extractMessage(o),...c])}extractMessage(o){return typeof o=="string"?o:(0,y.toErrorMessage)(o,this.getLevel()<=T.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class v extends w{constructor(o){super(),this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const c of this.logServices)c.setLevel(o);super.setLevel(o)}trace(o,...c){for(const D of this.logServices)D.trace(o,...c)}debug(o,...c){for(const D of this.logServices)D.debug(o,...c)}info(o,...c){for(const D of this.logServices)D.info(o,...c)}warn(o,...c){for(const D of this.logServices)D.warn(o,...c)}error(o,...c){for(const D of this.logServices)D.error(o,...c)}critical(o,...c){for(const D of this.logServices)D.critical(o,...c)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=v;class u extends P.Disposable{constructor(o){super(),this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...c){this.logger.trace(o,...c)}debug(o,...c){this.logger.debug(o,...c)}info(o,...c){this.logger.info(o,...c)}warn(o,...c){this.logger.warn(o,...c)}error(o,...c){this.logger.error(o,...c)}critical(o,...c){this.logger.critical(o,...c)}flush(){this.logger.flush()}}e.LogService=u;class l extends P.Disposable{constructor(o,c){super(),this.logLevel=o,this.loggerItems=new I.ResourceMap,this._register(c(D=>this.setLevel(D)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:o})=>o)}getLogger(o){return this.loggerItems.get(o)?.logger}createLogger(o,c,D){let O=this.loggerItems.get(o)?.logger;return O||(D=c?.always?T.Trace:D,O=this.doCreateLogger(o,D??this.logLevel,c),this.loggerItems.set(o,{logger:O,logLevel:D})),O}setLevel(o,c){const D=b.URI.isUri(o)?o:void 0,O=D?c:o;if(D){const H=this.loggerItems.get(D);H&&H.logLevel!==O&&(H.logLevel=O,H.logger.setLevel(O))}else this.logLevel=O,this.loggerItems.forEach(({logLevel:H,logger:re})=>{H===void 0&&re.setLevel(this.logLevel)})}getLogLevel(o){return this.loggerItems.get(o)?.logLevel}dispose(){this.loggerItems.forEach(({logger:o})=>o.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=l;class h{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return T.Info}trace(o,...c){}debug(o,...c){}info(o,...c){}warn(o,...c){}error(o,...c){}critical(o,...c){}dispose(){}flush(){}}e.NullLogger=h;class i extends h{}e.NullLogService=i;class r extends l{constructor(){super(T.Info,t.Event.None)}doCreateLogger(o,c,D){return new h}}e.NullLoggerService=r;function n(f){if(f.verbose)return T.Trace;if(typeof f.logLevel=="string"){const o=s(f.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function s(f){switch(f){case"trace":return T.Trace;case"debug":return T.Debug;case"info":return T.Info;case"warn":return T.Warning;case"error":return T.Error;case"critical":return T.Critical;case"off":return T.Off}}e.parseLogLevel=s;function a(f){switch(f){case T.Trace:return"trace";case T.Debug:return"debug";case T.Info:return"info";case T.Warning:return"warn";case T.Error:return"error";case T.Critical:return"critical";case T.Off:return"off"}}e.LogLevelToString=a}),define(we[208],ye([1,0,73,7,2,12,3,14]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let E=class $t extends P.Disposable{constructor(T){super(),this.logService=T,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(T,R){this.logService.trace("Getting password from keytar:",T,R);let S;try{S=await this.withKeytar()}catch{return null}const w=await(0,b.retry)(()=>S.getPassword(T,R),50,3);if(!w)return this.logService.trace("Did not get a password from keytar for account:",R),w;let d,g;try{const p=JSON.parse(w);d=p.content,g=p.hasNextChunk}catch{}if(!d||!g)return this.logService.trace("Got password from keytar for account:",R),w;try{let p=1;for(;g;){const m=await(0,b.retry)(()=>S.getPassword(T,`${R}-${p}`),50,3),v=JSON.parse(m);d+=v.content,g=v.hasNextChunk,p++}return this.logService.trace(`Got ${p}-chunked password from keytar for account:`,R),d}catch(p){return this.logService.error(p),w}}async setPassword(T,R,S){this.logService.trace("Setting password using keytar:",T,R);let w;try{w=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}if(k.isWindows&&S.length>$t.MAX_PASSWORD_LENGTH){let d=0,g=0,p=!0;for(;p;){const m=S.substring(d,d+$t.PASSWORD_CHUNK_SIZE);d+=$t.PASSWORD_CHUNK_SIZE,p=S.length-d>0;const v={content:m,hasNextChunk:p};await(0,b.retry)(()=>w.setPassword(T,g?`${R}-${g}`:R,JSON.stringify(v)),50,3),g++}this.logService.trace(`Got${g?` ${g}-chunked`:""} password from keytar for account:`,R)}else await(0,b.retry)(()=>w.setPassword(T,R,S),50,3),this.logService.trace("Got password from keytar for account:",R);this._onDidChangePassword.fire({service:T,account:R})}async deletePassword(T,R){this.logService.trace("Deleting password using keytar:",T,R);let S;try{S=await this.withKeytar()}catch(m){throw this.surfaceKeytarLoadError?.(m),m}const w=await S.getPassword(T,R);if(!w)return this.logService.trace("Did not get a password to delete from keytar for account:",R),!1;let d,g;try{const m=JSON.parse(w);d=m.content,g=m.hasNextChunk}catch{}let p=0;if(d&&g)try{for(p++;g;){const m=`${R}-${p}`,v=await S.getPassword(T,m);await S.deletePassword(T,m),g=JSON.parse(v).hasNextChunk,p++}}catch(m){this.logService.error(m)}return await S.deletePassword(T,R)?(this._onDidChangePassword.fire({service:T,account:R}),this.logService.trace(`Deleted${p?` ${p}-chunked`:""} password from keytar for account:`,R),!0):(this.logService.trace(`Keytar failed to delete${p?` ${p}-chunked`:""} password for account:`,R),!1)}async findPassword(T){let R;try{R=await this.withKeytar()}catch{return null}return await R.findPassword(T)}async findCredentials(T){let R;try{R=await this.withKeytar()}catch{return[]}return await R.findCredentials(T)}clear(){return this._keytarCache instanceof y.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};E.MAX_PASSWORD_LENGTH=2500,E.PASSWORD_CHUNK_SIZE=E.MAX_PASSWORD_LENGTH-100,E=Ae([_e(0,I.ILogService)],E),e.BaseCredentialsMainService=E}),define(we[209],ye([1,0,18,14,10,7,2,6,61,12]),function(se,e,y,t,P,I,k,b,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends k.Disposable{constructor(S,w){super(),this.logService=S,this.options=w,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new I.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(S,w){return w.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,w):this.watchNonRecursive(S,w)}watchUniversal(S,w){const d={path:this.toFilePath(S),excludes:w.excludes,includes:w.includes,recursive:w.recursive},g=(0,y.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,P.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(w=>this._onDidChangeFile.fire((0,E.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const w of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const w of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(w)&&S.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,w){const d={path:this.toFilePath(S),excludes:w.excludes,includes:w.includes,recursive:!1},g=(0,y.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,P.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,E.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,b.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(we[104],ye([1,0,18,14,16,20,7,92,55,2,57,11,45,19,44,172,17,102,12]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class extends C.Disposable{constructor(h){super(),this.logService=h,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(h,i){if(this.provider.has(h))throw new Error(`A filesystem provider for the scheme '${h}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${h}`);const r=new C.DisposableStore;return this.provider.set(h,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:h,provider:i}),r.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new p.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&r.add(i.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),r.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:h}))),(0,C.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:h,provider:i}),this.provider.delete(h),(0,C.dispose)(r)})}getProvider(h){return this.provider.get(h)}async activateProvider(h){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:h,join(r){i.push(r)}}),!this.provider.has(h)&&await t.Promises.settled(i)}async canHandleResource(h){return await this.activateProvider(h.scheme),this.hasProvider(h)}hasProvider(h){return this.provider.has(h.scheme)}hasCapability(h,i){const r=this.provider.get(h.scheme);return!!(r&&r.capabilities&i)}listCapabilities(){return E.Iterable.map(this.provider,([h,i])=>({scheme:h,capabilities:i.capabilities}))}async withProvider(h){if(!(0,w.isAbsolutePath)(h))throw new p.FileOperationError((0,g.localize)(0,null,this.resourceForError(h)),8);await this.activateProvider(h.scheme);const i=this.provider.get(h.scheme);if(!i){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,h.toString()),r}return i}async withReadProvider(h){const i=await this.withProvider(h);if((0,p.hasOpenReadWriteCloseCapability)(i)||(0,p.hasReadWriteCapability)(i)||(0,p.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${h.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(h){const i=await this.withProvider(h);if((0,p.hasOpenReadWriteCloseCapability)(i)||(0,p.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${h.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(h,i){try{return await this.doResolveFile(h,i)}catch(r){throw(0,p.toFileSystemProviderErrorCode)(r)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,g.localize)(2,null,this.resourceForError(h)),1):(0,p.ensureFileSystemProviderError)(r)}}async doResolveFile(h,i){const r=await this.withProvider(h),n=this.isPathCaseSensitive(r),s=i?.resolveTo,a=i?.resolveSingleChildDescendants,f=i?.resolveMetadata,o=await r.stat(h);let c;return this.toFileStat(r,h,o,void 0,!!f,(D,O)=>(c||(c=T.TernarySearchTree.forUris(()=>!n),c.set(h,!0),s&&c.fill(!0,s)),c.get(D.resource)||c.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&a?O===1:!1))}async toFileStat(h,i,r,n,s,a){const{providerExtUri:f}=this.getExtUri(h),o={resource:i,name:f.basename(i),isFile:(r.type&p.FileType.File)!==0,isDirectory:(r.type&p.FileType.Directory)!==0,isSymbolicLink:(r.type&p.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&p.FilePermission.Readonly)||Boolean(h.capabilities&2048),etag:(0,p.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(o.isDirectory&&a(o,n)){try{const c=await h.readdir(i),D=await t.Promises.settled(c.map(async([O,H])=>{try{const re=f.joinPath(i,O),ce=s?await h.stat(re):{type:H};return await this.toFileStat(h,re,ce,c.length,s,a)}catch(re){return this.logService.trace(re),null}}));o.children=(0,y.coalesce)(D)}catch(c){this.logService.trace(c),o.children=[]}return o}return o}async resolveAll(h){return t.Promises.settled(h.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(h){const i=await this.withProvider(h),r=await i.stat(h);return this.toFileStat(i,h,r,void 0,!0,()=>!1)}async exists(h){const i=await this.withProvider(h);try{return!!await i.stat(h)}catch{return!1}}async canCreateFile(h,i){try{await this.doValidateCreateFile(h,i)}catch(r){return r}return!0}async doValidateCreateFile(h,i){if(!i?.overwrite&&await this.exists(h))throw new p.FileOperationError((0,g.localize)(3,null,this.resourceForError(h)),3,i)}async createFile(h,i=P.VSBuffer.fromString(""),r){await this.doValidateCreateFile(h,r);const n=await this.writeFile(h,i);return this._onDidRunOperation.fire(new p.FileOperationEvent(h,0,n)),n}async writeFile(h,i,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h),{providerExtUri:s}=this.getExtUri(n);try{await this.validateWriteFile(n,h,r)||await this.mkdirp(n,s.dirname(h));let f;if((0,p.hasReadWriteCapability)(n)&&!(i instanceof P.VSBuffer))if((0,d.isReadableStream)(i)){const o=await(0,d.peekStream)(i,3);o.ended?f=P.VSBuffer.concat(o.buffer):f=o}else f=(0,d.peekReadable)(i,o=>P.VSBuffer.concat(o),3);else f=i;!(0,p.hasOpenReadWriteCloseCapability)(n)||(0,p.hasReadWriteCapability)(n)&&f instanceof P.VSBuffer?await this.doWriteUnbuffered(n,h,r,f):await this.doWriteBuffered(n,h,r,f instanceof P.VSBuffer?(0,P.bufferToReadable)(f):f),this._onDidRunOperation.fire(new p.FileOperationEvent(h,4))}catch(a){throw new p.FileOperationError((0,g.localize)(4,null,this.resourceForError(h),(0,p.ensureFileSystemProviderError)(a).toString()),(0,p.toFileOperationResult)(a),r)}return this.resolve(h,{resolveMetadata:!0})}async validateWriteFile(h,i,r){if(!!r?.unlock&&!(h.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(i)));let s;try{s=await h.stat(i)}catch{return}if((s.type&p.FileType.Directory)!==0)throw new p.FileOperationError((0,g.localize)(6,null,this.resourceForError(i)),0,r);if(this.throwIfFileIsReadonly(i,s),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==p.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&r.mtime<s.mtime&&r.etag!==(0,p.etag)({mtime:r.mtime,size:s.size}))throw new p.FileOperationError((0,g.localize)(7,null),3,r);return s}async readFile(h,i,r){const n=await this.withReadProvider(h);return i?.atomic?this.doReadFileAtomic(n,h,i,r):this.doReadFile(n,h,i,r)}async doReadFileAtomic(h,i,r,n){return new Promise((s,a)=>{this.writeQueue.queueFor(i,this.getExtUri(h).providerExtUri).queue(async()=>{try{const f=await this.doReadFile(h,i,r,n);s(f)}catch(f){a(f)}})})}async doReadFile(h,i,r,n){const s=await this.doReadFileStream(h,i,{...r,preferUnbuffered:!0},n);return{...s,value:await(0,P.streamToBuffer)(s.value)}}async readFileStream(h,i,r){const n=await this.withReadProvider(h);return this.doReadFileStream(n,h,i,r)}async doReadFileStream(h,i,r,n){const s=new I.CancellationTokenSource(n),a=this.validateReadFile(i,r).then(o=>o,o=>{throw s.cancel(),o});let f;try{return typeof r?.etag=="string"&&r.etag!==p.ETAG_DISABLED&&await a,r?.atomic&&(0,p.hasFileAtomicReadCapability)(h)||!((0,p.hasOpenReadWriteCloseCapability)(h)||(0,p.hasFileReadStreamCapability)(h))||(0,p.hasReadWriteCapability)(h)&&r?.preferUnbuffered?f=this.readFileUnbuffered(h,i,r):(0,p.hasFileReadStreamCapability)(h)?f=this.readFileStreamed(h,i,s.token,r):f=this.readFileBuffered(h,i,s.token,r),{...await a,value:f}}catch(o){f&&await(0,d.consumeStream)(f);const c=(0,g.localize)(8,null,this.resourceForError(i),(0,p.ensureFileSystemProviderError)(o).toString());throw o instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(c,o.stat,r):new p.FileOperationError(c,(0,p.toFileOperationResult)(o),r)}}readFileStreamed(h,i,r,n=Object.create(null)){const s=h.readFileStream(i,n,r);return(0,d.transform)(s,{data:a=>a instanceof P.VSBuffer?a:P.VSBuffer.wrap(a),error:a=>new p.FileOperationError((0,g.localize)(9,null,this.resourceForError(i),(0,p.ensureFileSystemProviderError)(a).toString()),(0,p.toFileOperationResult)(a),n)},a=>P.VSBuffer.concat(a))}readFileBuffered(h,i,r,n=Object.create(null)){const s=(0,P.newWriteableBufferStream)();return(0,m.readFileIntoStream)(h,i,s,a=>a,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new p.FileOperationError((0,g.localize)(10,null,this.resourceForError(i),(0,p.ensureFileSystemProviderError)(a).toString()),(0,p.toFileOperationResult)(a),n)},r),s}readFileUnbuffered(h,i,r){const n=(0,d.newWriteableStream)(s=>P.VSBuffer.concat(s));return(async()=>{try{let s;r?.atomic&&(0,p.hasFileAtomicReadCapability)(h)?s=await h.readFile(i,{atomic:!0}):s=await h.readFile(i),typeof r?.position=="number"&&(s=s.slice(r.position)),typeof r?.length=="number"&&(s=s.slice(0,r.length)),this.validateReadFileLimits(i,s.byteLength,r),n.end(P.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async validateReadFile(h,i){const r=await this.resolve(h,{resolveMetadata:!0});if(r.isDirectory)throw new p.FileOperationError((0,g.localize)(11,null,this.resourceForError(h)),0,i);if(typeof i?.etag=="string"&&i.etag!==p.ETAG_DISABLED&&i.etag===r.etag)throw new p.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,i);return this.validateReadFileLimits(h,r.size,i),r}validateReadFileLimits(h,i,r){if(r?.limits){let n;if(typeof r.limits.memory=="number"&&i>r.limits.memory&&(n=9),typeof r.limits.size=="number"&&i>r.limits.size&&(n=7),typeof n=="number")throw new p.FileOperationError((0,g.localize)(13,null,this.resourceForError(h)),n)}}async canMove(h,i,r){return this.doCanMoveCopy(h,i,"move",r)}async canCopy(h,i,r){return this.doCanMoveCopy(h,i,"copy",r)}async doCanMoveCopy(h,i,r,n){if(h.toString()!==i.toString())try{const s=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h):await this.withReadProvider(h),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(s,h,a,i,r,n)}catch(s){return s}return!0}async move(h,i,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(n,h,s,i,"move",!!r),f=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(h,a==="move"?2:3,f)),f}async copy(h,i,r){const n=await this.withReadProvider(h),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(n,h,s,i,"copy",!!r),f=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(h,a==="copy"?3:2,f)),f}async doMoveCopy(h,i,r,n,s,a){if(i.toString()===n.toString())return s;const{exists:f,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(h,i,r,n,s,a);if(f&&!o&&a&&await this.del(n,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(n)),s==="copy"){if(h===r&&(0,p.hasFileFolderCopyCapability)(h))await h.copy(i,n,{overwrite:a});else{const c=await this.resolve(i);c.isDirectory?await this.doCopyFolder(h,c,r,n):await this.doCopyFile(h,i,r,n)}return s}else return h===r?(await h.rename(i,n,{overwrite:a}),s):(await this.doMoveCopy(h,i,r,n,"copy",a),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(h,i,r,n){if((0,p.hasOpenReadWriteCloseCapability)(h)&&(0,p.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(h,i,r,n);if((0,p.hasOpenReadWriteCloseCapability)(h)&&(0,p.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(h,i,r,n);if((0,p.hasReadWriteCapability)(h)&&(0,p.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(h,i,r,n);if((0,p.hasReadWriteCapability)(h)&&(0,p.hasReadWriteCapability)(r))return this.doPipeUnbuffered(h,i,r,n)}async doCopyFolder(h,i,r,n){await r.mkdir(n),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async s=>{const a=this.getExtUri(r).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.doCopyFolder(h,await this.resolve(s.resource),r,a):this.doCopyFile(h,s.resource,r,a)}))}async doValidateMoveCopy(h,i,r,n,s,a){let f=!1;if(h===r){const{providerExtUri:c,isPathCaseSensitive:D}=this.getExtUri(h);if(D||(f=c.isEqual(i,n)),f&&s==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!f&&c.isEqualOrParent(n,i))throw new Error((0,g.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const o=await this.exists(n);if(o&&!f){if(!a)throw new p.FileOperationError((0,g.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(h===r){const{providerExtUri:c}=this.getExtUri(h);if(c.isEqualOrParent(i,n))throw new Error((0,g.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:o,isSameResourceWithDifferentPathCase:f}}getExtUri(h){const i=this.isPathCaseSensitive(h);return{providerExtUri:i?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(h){return!!(h.capabilities&1024)}async createFolder(h){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(h),h);await this.mkdirp(i,h);const r=await this.resolve(h,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(h,0,r)),r}async mkdirp(h,i){const r=[],{providerExtUri:n}=this.getExtUri(h);for(;!n.isEqual(i,n.dirname(i));)try{if(((await h.stat(i)).type&p.FileType.Directory)===0)throw new Error((0,g.localize)(18,null,this.resourceForError(i)));break}catch(s){if((0,p.toFileSystemProviderErrorCode)(s)!==p.FileSystemProviderErrorCode.FileNotFound)throw s;r.push(n.basename(i)),i=n.dirname(i)}for(let s=r.length-1;s>=0;s--){i=n.joinPath(i,r[s]);try{await h.mkdir(i)}catch(a){if((0,p.toFileSystemProviderErrorCode)(a)!==p.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(h,i){try{await this.doValidateDelete(h,i)}catch(r){return r}return!0}async doValidateDelete(h,i){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(h),h);if(!!i?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(h)));let s;try{s=await r.stat(h)}catch{}if(s)this.throwIfFileIsReadonly(h,s);else throw new p.FileOperationError((0,g.localize)(20,null,this.resourceForError(h)),1);if(!!!i?.recursive){const f=await this.resolve(h);if(f.isDirectory&&Array.isArray(f.children)&&f.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(h)))}return r}async del(h,i){const r=await this.doValidateDelete(h,i),n=!!i?.useTrash,s=!!i?.recursive;await r.delete(h,{recursive:s,useTrash:n}),this._onDidRunOperation.fire(new p.FileOperationEvent(h,1))}async cloneFile(h,i){const r=await this.withProvider(h),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(r===n&&this.getExtUri(r).providerExtUri.isEqual(h,i))return;if(r===n&&(0,p.hasFileCloneCapability)(r))return r.cloneFile(h,i);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i));const s=this.writeQueue.queueFor(h,this.getExtUri(r).providerExtUri);return r===n&&(0,p.hasFileFolderCopyCapability)(r)?s.queue(()=>r.copy(h,i,{overwrite:!0})):s.queue(()=>this.doCopyFile(r,h,n,i))}watch(h,i={recursive:!1,excludes:[]}){const r=new C.DisposableStore;let n=!1,s=()=>{n=!0};return r.add((0,C.toDisposable)(()=>s())),(async()=>{try{const a=await this.doWatch(h,i);n?(0,C.dispose)(a):s=()=>(0,C.dispose)(a)}catch(a){this.logService.error(a)}})(),r}async doWatch(h,i){const r=await this.withProvider(h),n=(0,b.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(h),i]);let s=this.activeWatchers.get(n);return s||(s={count:0,disposable:r.watch(h,i)},this.activeWatchers.set(n,s)),s.count+=1,(0,C.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,C.dispose)(s.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,h]of this.activeWatchers)(0,C.dispose)(h.disposable);this.activeWatchers.clear()}async doWriteBuffered(h,i,r,n){return this.writeQueue.queueFor(i,this.getExtUri(h).providerExtUri).queue(async()=>{const s=await h.open(i,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(n)||(0,d.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(h,s,n):await this.doWriteReadableBufferedQueued(h,s,n)}catch(a){throw(0,p.ensureFileSystemProviderError)(a)}finally{await h.close(s)}})}async doWriteStreamBufferedQueued(h,i,r){let n=0,s;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const a=P.VSBuffer.concat(r.buffer);await this.doWriteBuffer(h,i,a,a.byteLength,n,0),n+=a.byteLength}if(r.ended)return;s=r.stream}else s=r;return new Promise((a,f)=>{(0,d.listenStream)(s,{onData:async o=>{s.pause();try{await this.doWriteBuffer(h,i,o,o.byteLength,n,0)}catch(c){return f(c)}n+=o.byteLength,setTimeout(()=>s.resume())},onError:o=>f(o),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(h,i,r){let n=0,s;for(;(s=r.read())!==null;)await this.doWriteBuffer(h,i,s,s.byteLength,n,0),n+=s.byteLength}async doWriteBuffer(h,i,r,n,s,a){let f=0;for(;f<n;)f+=await h.write(i,s+f,r.buffer,a+f,n-f)}async doWriteUnbuffered(h,i,r,n){return this.writeQueue.queueFor(i,this.getExtUri(h).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(h,i,r,n))}async doWriteUnbufferedQueued(h,i,r,n){let s;n instanceof P.VSBuffer?s=n:(0,d.isReadableStream)(n)?s=await(0,P.streamToBuffer)(n):(0,d.isReadableBufferedStream)(n)?s=await(0,P.bufferedStreamToBuffer)(n):s=(0,P.readableToBuffer)(n),await h.writeFile(i,s.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(h,i,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(h,i,r,n))}async doPipeBufferedQueued(h,i,r,n){let s,a;try{s=await h.open(i,{create:!1}),a=await r.open(n,{create:!0,unlock:!1});const f=P.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,c=0,D=0;do D=await h.read(s,o,f.buffer,c,f.byteLength-c),await this.doWriteBuffer(r,a,f,D,o,c),o+=D,c+=D,c===f.byteLength&&(c=0);while(D>0)}catch(f){throw(0,p.ensureFileSystemProviderError)(f)}finally{await t.Promises.settled([typeof s=="number"?h.close(s):Promise.resolve(),typeof a=="number"?r.close(a):Promise.resolve()])}}async doPipeUnbuffered(h,i,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(h,i,r,n))}async doPipeUnbufferedQueued(h,i,r,n){return r.writeFile(n,await h.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(h,i,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(h,i,r,n))}async doPipeUnbufferedToBufferedQueued(h,i,r,n){const s=await r.open(n,{create:!0,unlock:!1});try{const a=await h.readFile(i);await this.doWriteBuffer(r,s,P.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,p.ensureFileSystemProviderError)(a)}finally{await r.close(s)}}async doPipeBufferedToUnbuffered(h,i,r,n){const s=await(0,P.streamToBuffer)(this.readFileBuffered(h,i,I.CancellationToken.None));await this.doWriteUnbuffered(r,n,void 0,s)}throwIfFileSystemIsReadonly(h,i){if(h.capabilities&2048)throw new p.FileOperationError((0,g.localize)(22,null,this.resourceForError(i)),6);return h}throwIfFileIsReadonly(h,i){if((i.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,g.localize)(23,null,this.resourceForError(h)),6)}resourceForError(h){return h.scheme===R.Schemas.file?h.fsPath:h.toString(!0)}};u=Ae([_e(0,v.ILogService)],u),e.FileService=u}),define(we[62],ye([1,0,28,273,14,31,16,7,36,2,6,3,19,44,21,175,17,102,209,38,206,205]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m,v,u,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(y)}catch(r){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(r)}`)}})();class i extends v.AbstractDiskFileSystemProvider{constructor(n,s){super(n,s),this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new I.ResourceMap(a=>S.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:a}=await d.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,a),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await d.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),a=[];return await Promise.all(s.map(async f=>{try{let o;f.isSymbolicLink()?o=(await this.stat((0,S.joinPath)(n,f.name))).type:o=this.toType(f),a.push([f.name,o])}catch(o){this.logService.trace(o)}})),a}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let a;return s?.dangling?a=p.FileType.Unknown:n.isFile()?a=p.FileType.File:n.isDirectory()?a=p.FileType.Directory:a=p.FileType.Unknown,s&&(a|=p.FileType.SymbolicLink),a}async createResourceLock(n){const s=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let a;for(;a=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await a.wait();const f=new P.Barrier;return this.resourceLocks.set(n,f),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,C.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(n)===f&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),f.open()})}async readFile(n,s){let a;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),a=await this.createResourceLock(n));const f=this.toFilePath(n);return await d.Promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}finally{a?.dispose()}}traceLock(n){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,s,a){const f=(0,w.newWriteableStream)(o=>k.VSBuffer.concat(o.map(c=>k.VSBuffer.wrap(c))).buffer);return(0,m.readFileIntoStream)(this,n,f,o=>o.buffer,{...s,bufferSize:256*1024},a),f}async writeFile(n,s,a){let f;try{const o=this.toFilePath(n);if(!a.create||!a.overwrite){if(await d.Promises.exists(o)){if(!a.overwrite)throw(0,p.createFileSystemProviderError)((0,g.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,p.createFileSystemProviderError)((0,g.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(n,{create:!0,unlock:a.unlock}),await this.write(f,0,s,0,s.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(n,o)}finally{typeof f=="number"&&await this.close(f)}}static configureFlushOnWrite(n){i.canFlush=n}async open(n,s){const a=this.toFilePath(n);let f;(0,p.isFileOpenForWriteOptions)(s)&&(f=await this.createResourceLock(n));let o;try{if((0,p.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:D}=await d.SymlinkSupport.stat(a);D.mode&128||await d.Promises.chmod(a,D.mode|128)}catch(D){this.logService.trace(D)}let c;if((0,p.isFileOpenForWriteOptions)(s)){if(R.isWindows)try{await d.Promises.truncate(a,0),c="r+"}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}c||(c="w")}else c="r";o=await d.Promises.open(a,c)}catch(c){throw f?.dispose(),(0,p.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,c):this.toFileSystemProviderError(c)}if(this.mapHandleToPos.set(o,0),(0,p.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(o,n),f){const c=this.mapHandleToLock.get(o);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${a})`),this.mapHandleToLock.set(o,f),c&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${a})`),c.dispose())}return o}async close(n){const s=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&i.canFlush)try{await d.Promises.fdatasync(n)}catch(a){i.configureFlushOnWrite(!1),this.logService.error(a)}return await d.Promises.close(n)}catch(a){throw this.toFileSystemProviderError(a)}finally{s&&(this.mapHandleToLock.get(n)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,a,f,o){const c=this.normalizePos(n,s);let D=null;try{D=(await d.Promises.read(n,a,f,o,c)).bytesRead}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(n,c,D)}return D}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,a){const f=this.mapHandleToPos.get(n);typeof f=="number"&&(typeof s=="number"||(typeof a=="number"?this.mapHandleToPos.set(n,f+a):this.mapHandleToPos.delete(n)))}async write(n,s,a,f,o){return(0,P.retry)(()=>this.doWrite(n,s,a,f,o),100,3)}async doWrite(n,s,a,f,o){const c=this.normalizePos(n,s);let D=null;try{D=(await d.Promises.write(n,a,f,o,c)).bytesWritten}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),O)}finally{this.updatePos(n,c,D)}return D}async mkdir(n){try{await d.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const a=this.toFilePath(n);s.recursive?await d.Promises.rm(a,d.RimRafMode.MOVE):await d.Promises.unlink(a)}catch(a){throw this.toFileSystemProviderError(a)}}async rename(n,s,a){const f=this.toFilePath(n),o=this.toFilePath(s);if(f!==o)try{await this.validateTargetDeleted(n,s,"move",a.overwrite),await d.Promises.move(f,o)}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,g.localize)(2,null,(0,T.basename)(f),(0,T.basename)((0,T.dirname)(o)),c.toString()))),this.toFileSystemProviderError(c)}}async copy(n,s,a){const f=this.toFilePath(n),o=this.toFilePath(s);if(f!==o)try{await this.validateTargetDeleted(n,s,"copy",a.overwrite),await d.Promises.copy(f,o,{preserveSymlinks:!0})}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,g.localize)(3,null,(0,T.basename)(f),(0,T.basename)((0,T.dirname)(o)),c.toString()))),this.toFileSystemProviderError(c)}}async validateTargetDeleted(n,s,a,f){const o=this.toFilePath(n),c=this.toFilePath(s);let D=!1;if(!!(this.capabilities&1024)||(D=(0,E.isEqual)(o,c,!0)),D&&a==="copy")throw(0,p.createFileSystemProviderError)((0,g.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(!D&&await d.Promises.exists(c)){if(!f)throw(0,p.createFileSystemProviderError)((0,g.localize)(5,null),p.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(n,s){return this.doCloneFile(n,s,!1)}async doCloneFile(n,s,a){const f=this.toFilePath(n),o=this.toFilePath(s),c=!!(this.capabilities&1024);if((0,E.isEqual)(f,o,!c))return;const D=new C.DisposableStore;try{const[O,H]=await Promise.all([this.createResourceLock(n),this.createResourceLock(s)]);D.add(O),D.add(H),a&&await d.Promises.mkdir((0,T.dirname)(o),{recursive:!0}),await d.Promises.copyFile(f,o)}catch(O){if(O.code==="ENOENT"&&!a)return this.doCloneFile(n,s,!0);throw this.toFileSystemProviderError(O)}finally{D.dispose()}}createUniversalWatcher(n,s,a){return new l.UniversalWatcherClient(f=>n(f),f=>s(f),a)}createNonRecursiveWatcher(n,s,a){return new h.NodeJSWatcherClient(f=>n(f),f=>s(f),a)}toFileSystemProviderError(n){if(n instanceof p.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=p.FileSystemProviderErrorCode.NoPermissions;break;default:s=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(n,s)}async toFileSystemProviderWriteError(n,s){let a=this.toFileSystemProviderError(s);if(n&&a.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await d.SymlinkSupport.stat(this.toFilePath(n));f.mode&128||(a=(0,p.createFileSystemProviderError)(s,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.logService.trace(f)}return a}}e.DiskFileSystemProvider=i,i.TRACE_LOG_RESOURCE_LOCKS=!1,i.canFlush=!0}),define(we[210],ye([1,0,7,62,2,16,44,20]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class E extends P.Disposable{constructor(R,S){super(),this.provider=R,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(R,S,w){const d=this.getUriTransformer(R);switch(S){case"stat":return this.stat(d,w[0]);case"readdir":return this.readdir(d,w[0]);case"open":return this.open(d,w[0],w[1]);case"close":return this.close(w[0]);case"read":return this.read(w[0],w[1],w[2]);case"readFile":return this.readFile(d,w[0],w[1]);case"write":return this.write(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.writeFile(d,w[0],w[1],w[2]);case"rename":return this.rename(d,w[0],w[1],w[2]);case"copy":return this.copy(d,w[0],w[1],w[2]);case"cloneFile":return this.cloneFile(d,w[0],w[1]);case"mkdir":return this.mkdir(d,w[0]);case"delete":return this.delete(d,w[0],w[1]);case"watch":return this.watch(d,w[0],w[1],w[2],w[3]);case"unwatch":return this.unwatch(w[0],w[1])}throw new Error(`IPC Command ${S} not found`)}listen(R,S,w){const d=this.getUriTransformer(R);switch(S){case"fileChange":return this.onFileChange(d,w[0]);case"readFileStream":return this.onReadFileStream(d,w[0],w[1])}throw new Error(`Unknown event ${S}`)}stat(R,S){const w=this.transformIncoming(R,S,!0);return this.provider.stat(w)}readdir(R,S){const w=this.transformIncoming(R,S);return this.provider.readdir(w)}async readFile(R,S,w){const d=this.transformIncoming(R,S,!0),g=await this.provider.readFile(d,w);return I.VSBuffer.wrap(g)}onReadFileStream(R,S,w){const d=this.transformIncoming(R,S,!0),g=new b.CancellationTokenSource,p=new y.Emitter({onLastListenerRemove:()=>{g.cancel()}}),m=this.provider.readFileStream(d,w,g.token);return(0,k.listenStream)(m,{onData:v=>p.fire(I.VSBuffer.wrap(v)),onError:v=>p.fire(v),onEnd:()=>{p.fire("end"),p.dispose(),g.dispose()}}),p.event}writeFile(R,S,w,d){const g=this.transformIncoming(R,S);return this.provider.writeFile(g,w.buffer,d)}open(R,S,w){const d=this.transformIncoming(R,S,!0);return this.provider.open(d,w)}close(R){return this.provider.close(R)}async read(R,S,w){const d=I.VSBuffer.alloc(w),g=0,p=await this.provider.read(R,S,d.buffer,g,w);return[d,p]}write(R,S,w,d,g){return this.provider.write(R,S,w.buffer,d,g)}mkdir(R,S){const w=this.transformIncoming(R,S);return this.provider.mkdir(w)}delete(R,S,w){const d=this.transformIncoming(R,S);return this.provider.delete(d,w)}rename(R,S,w,d){const g=this.transformIncoming(R,S),p=this.transformIncoming(R,w);return this.provider.rename(g,p,d)}copy(R,S,w,d){const g=this.transformIncoming(R,S),p=this.transformIncoming(R,w);return this.provider.copy(g,p,d)}cloneFile(R,S,w){const d=this.transformIncoming(R,S),g=this.transformIncoming(R,w);return this.provider.cloneFile(d,g)}onFileChange(R,S){const w=new y.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(R,w))},onLastListenerRemove:()=>{(0,P.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return w.event}async watch(R,S,w,d,g){const p=this.sessionToWatcher.get(S);if(p){const m=this.transformIncoming(R,d),v=p.watch(w,m,g);this.watchRequests.set(S+w,v)}}async unwatch(R,S){const w=R+S,d=this.watchRequests.get(w);d&&((0,P.dispose)(d),this.watchRequests.delete(w))}dispose(){super.dispose();for(const[,R]of this.watchRequests)R.dispose();this.watchRequests.clear();for(const[,R]of this.sessionToWatcher)R.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=E;class C extends P.Disposable{constructor(R,S,w,d){super(),this.uriTransformer=R,this.logService=w,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(R){const S=this._register(new y.Emitter);this._register(S.event(w=>{R.fire(w.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(w=>S.fire(w))),this._register(this.fileWatcher.onDidWatchError(w=>R.fire(w)))}getRecursiveWatcherOptions(R){}getExtraExcludes(R){}watch(R,S,w){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(w.excludes=[...w.excludes,...d]),this.watcherRequests.set(R,this.fileWatcher.watch(S,w)),(0,P.toDisposable)(()=>{(0,P.dispose)(this.watcherRequests.get(R)),this.watcherRequests.delete(R)})}dispose(){super.dispose();for(const[,R]of this.watcherRequests)R.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=C}),define(we[211],ye([1,0,12]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(I,k){switch(k){case y.LogLevel.Trace:return I.trace;case y.LogLevel.Debug:return I.debug;case y.LogLevel.Info:return I.info;case y.LogLevel.Warning:return I.warn;case y.LogLevel.Error:return I.error;case y.LogLevel.Critical:return I.critical;default:throw new Error("Invalid log level")}}class P extends y.AbstractLogger{constructor(k=y.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(b=>{this._logger?.setLevel(b)}))}set logger(k){this._logger=k;for(const{level:b,args:E}of this.buffer)t(k,b).apply(k,E);this.buffer=[]}_log(k,...b){this._logger?t(this._logger,k).apply(this._logger,b):this.getLevel()<=k&&this.buffer.push({level:k,args:b})}trace(k,...b){this._log(y.LogLevel.Trace,k,...b)}debug(k,...b){this._log(y.LogLevel.Debug,k,...b)}info(k,...b){this._log(y.LogLevel.Info,k,...b)}warn(k,...b){this._log(y.LogLevel.Warning,k,...b)}error(k,...b){this._log(y.LogLevel.Error,k,...b)}critical(k,...b){this._log(y.LogLevel.Critical,k,...b)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=P}),define(we[105],ye([1,0,7,4,12]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class I{constructor(S,w){this.logService=S,this.loggerService=w,this.onDidChangeLogLevel=y.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(S,w,d){switch(w){case"setLevel":return d[1]?this.loggerService.setLevel(t.URI.revive(d[1]),d[0]):this.logService.setLevel(d[0])}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=I;class k{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S,w){k.setLevel(this.channel,S,w)}static setLevel(S,w,d){return S.call("setLevel",[w,d])}}e.LogLevelChannelClient=k;class b{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,w){throw new Error(`Event not found: ${w}`)}async call(S,w,d){switch(w){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${w}`)}createLogger(S,w){this.loggers.set(S.toString(),this.loggerService.createLogger(S,w))}consoleLog(S,w){let d=console.log;switch(S){case P.LogLevel.Error:d=console.error;break;case P.LogLevel.Warning:d=console.warn;break;case P.LogLevel.Info:d=console.info;break}d.call(console,...w)}log(S,w){const d=this.loggers.get(S.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,p]of w)(0,P.log)(d,g,p)}}e.LoggerChannel=b;class E extends P.AbstractLoggerService{constructor(S,w,d){super(S,w),this.channel=d}createConsoleMainLogger(){return new P.AdapterLogger({log:(S,w)=>{this.channel.call("consoleLog",[S,w])}})}doCreateLogger(S,w,d){return new C(this.channel,S,w,d)}}e.LoggerChannelClient=E;class C extends P.AbstractMessageLogger{constructor(S,w,d,g){super(g?.always),this.channel=S,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[w,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,w){const d=[[S,w]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(S){this.channel.call("log",[this.file,S])}}class T extends P.LogService{constructor(S,w){super(w),this.parent=S,this._register(S.onDidChangeLogLevel(d=>w.setLevel(d)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=T}),define(we[106],ye([1,0,17,12]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function P(b,E,C,T,R){try{const S=await new Promise((d,g)=>{se(["spdlog"],d,g)});S.setFlushOn(t.LogLevel.Trace);const w=await S.createAsyncRotatingLogger(b,E,C,T);return R?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(S){console.error(S)}return null}function I(b,E,C){switch(E){case t.LogLevel.Trace:b.trace(C);break;case t.LogLevel.Debug:b.debug(C);break;case t.LogLevel.Info:b.info(C);break;case t.LogLevel.Warning:b.warn(C);break;case t.LogLevel.Error:b.error(C);break;case t.LogLevel.Critical:b.critical(C);break;default:throw new Error("Invalid log level")}}class k extends t.AbstractMessageLogger{constructor(E,C,T,R,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(E,C,T,R),this._register(this.onDidChangeLogLevel(w=>{this._logger?.setLevel(w)}))}async _createSpdLogLogger(E,C,T,R){const S=T?6:1,w=30/S*y.ByteSize.MB,d=await P(E,C,w,S,R);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:g,message:p}of this.buffer)I(this._logger,g,p);this.buffer=[]}}log(E,C){this._logger?I(this._logger,E,C):this.getLevel()<=E&&this.buffer.push({level:E,message:C})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(we[212],ye([1,0,23,12,106]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let I=class extends t.AbstractLoggerService{constructor(b){super(b.getLevel(),b.onDidChangeLogLevel)}doCreateLogger(b,E,C){return new P.SpdLogLogger(C?.name||(0,y.generateUuid)(),b.fsPath,!C?.donotRotate,!!C?.donotUseFormatters,E)}};I=Ae([_e(0,t.ILogService)],I),e.LoggerService=I}),define(we[213],ye([1,0,69,177,5]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var k;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function C(d,g){return g-d}E.compare=C;const T=Object.create(null);T[E.Error]=(0,t.localize)(0,null),T[E.Warning]=(0,t.localize)(1,null),T[E.Info]=(0,t.localize)(2,null);function R(d){return T[d]||""}E.toString=R;function S(d){switch(d){case y.default.Error:return E.Error;case y.default.Warning:return E.Warning;case y.default.Info:return E.Info;case y.default.Ignore:return E.Hint}}E.fromSeverity=S;function w(d){switch(d){case E.Error:return y.default.Error;case E.Warning:return y.default.Warning;case E.Info:return y.default.Info;case E.Hint:return y.default.Ignore}}E.toSeverity=w}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var b;(function(E){const C="";function T(S){return R(S,!0)}E.makeKey=T;function R(S,w){const d=[C];return S.source?d.push(S.source.replace("\xA6","\\\xA6")):d.push(C),S.code?typeof S.code=="string"?d.push(S.code.replace("\xA6","\\\xA6")):d.push(S.code.value.replace("\xA6","\\\xA6")):d.push(C),S.severity!==void 0&&S.severity!==null?d.push(k.toString(S.severity)):d.push(C),S.message&&w?d.push(S.message.replace("\xA6","\\\xA6")):d.push(C),S.startLineNumber!==void 0&&S.startLineNumber!==null?d.push(S.startLineNumber.toString()):d.push(C),S.startColumn!==void 0&&S.startColumn!==null?d.push(S.startColumn.toString()):d.push(C),S.endLineNumber!==void 0&&S.endLineNumber!==null?d.push(S.endLineNumber.toString()):d.push(C),S.endColumn!==void 0&&S.endColumn!==null?d.push(S.endColumn.toString()):d.push(C),d.push(C),d.join("\xA6")}E.makeKeyOptionalMessage=R})(b=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,P.createDecorator)("markerService")}),define(we[63],ye([1,0,7,55,2,5]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,I.createDecorator)("policy");class k extends P.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(C){const T=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...C,...this.policyDefinitions},T!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(C),t.Iterable.reduce(this.policies.entries(),(R,[S,w])=>({...R,[S]:w}),{})}getPolicyValue(C){return this.policies.get(C)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(C,[T,R])=>({...C,[T]:{definition:R,value:this.policies.get(T)}}),{})}}e.AbstractPolicyService=k;class b{constructor(){this.onDidChange=y.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(we[50],ye([1,0,11,3,27,19]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const b=t.globals.vscode.context.configuration();if(b)k=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof se?.__$__nodeRequire=="function"){const b=(0,I.dirname)(y.FileAccess.asFileUri("",se));if(k=se.__$__nodeRequire((0,I.joinPath)(b,"product.json").fsPath),P.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const E=se.__$__nodeRequire((0,I.joinPath)(b,"package.json").fsPath);Object.assign(k,{version:E.version})}}else k={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.72.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"3",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.73.1",commit:"6261075646f055b99068d3688932416f2346dd3b",date:"2022-12-20T05:04:09.409Z"},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(we[26],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,y.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(we[214],ye([1,0,73,12,25,26,208]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let b=class extends k.BaseCredentialsMainService{constructor(C,T,R){super(C),this.environmentMainService=T,this.productService=R}async getSecretStoragePrefix(){return Promise.resolve(`${this.productService.urlProtocol}-server`)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new y.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((C,T)=>{se(["keytar"],C,T)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(C){this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${C.message??C}`),this._keytarCache=new y.InMemoryCredentialsProvider}return this._keytarCache}};b=Ae([_e(0,t.ILogService),_e(1,P.INativeEnvironmentService),_e(2,I.IProductService)],b),e.CredentialsWebMainService=b}),define(we[34],ye([1,0,85,13]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(k,b){y.ok(t.isString(k)),y.ok(t.isObject(b)),y.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,b)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new P}),define(we[215],ye([1,0,7,34]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class I{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,C){this.schemasById[P(E)]=C,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new I;t.Registry.add(e.Extensions.JSONContribution,k)}),define(we[51],ye([1,0,18,7,13,161,24,215,34]),function(se,e,y,t,P,I,k,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=E.Registry.as(b.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const n=this.doRegisterConfigurations(i,r);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const r=this.doDeregisterConfigurations(i);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:i,remove:r}){const n=[];n.push(...this.doDeregisterConfigurations(r)),n.push(...this.doRegisterConfigurations(i,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,y.distinct)(n)})}registerDefaultConfigurations(i){const r=[],n=[];for(const{overrides:s,source:a}of i)for(const f in s)if(r.push(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const o=this.configurationDefaultsOverrides.get(f),c=o?.valuesSources??new Map;if(a)for(const re of Object.keys(s[f]))c.set(re,a);const D={...o?.value||{},...s[f]};this.configurationDefaultsOverrides.set(f,{source:a,value:D,valuesSources:c});const O=(0,k.getLanguageTagSettingPlainKey)(f),H={type:"object",default:D,description:I.localize(1,null,O),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:P.isString(a)?void 0:a,defaultValueSource:a};n.push(...g(f)),this.configurationProperties[f]=H,this.defaultLanguageConfigurationOverridesNode.properties[f]=H}else{this.configurationDefaultsOverrides.set(f,{value:s[f],source:a});const o=this.configurationProperties[f];o&&(this.updatePropertyDefaultValue(f,o),this.updateSchema(f,o))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const r=[];for(const{overrides:n,source:s}of i)for(const a in n){const f=this.configurationDefaultsOverrides.get(a),o=P.isString(s)?s:s?.id,c=P.isString(f?.source)?f?.source:f?.source?.id;if(o===c)if(r.push(a),this.configurationDefaultsOverrides.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const D=this.configurationProperties[a];D&&(this.updatePropertyDefaultValue(a,D),this.updateSchema(a,D))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const r of i)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,r){const n=[];return i.forEach(s=>{n.push(...this.validateAndRegisterProperties(s,r,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),n}doDeregisterConfigurations(i){const r=[],n=s=>{if(s.properties)for(const a in s.properties){r.push(a);const f=this.configurationProperties[a];f?.policy?.name&&this.policyConfigurations.delete(f.policy.name),delete this.configurationProperties[a],this.removeFromSchema(a,s.properties[a])}s.allOf?.forEach(a=>n(a))};for(const s of i){n(s);const a=this.configurationContributors.indexOf(s);a!==-1&&this.configurationContributors.splice(a,1)}return r}validateAndRegisterProperties(i,r=!0,n,s,a=3){a=P.isUndefinedOrNull(i.scope)?a:i.scope;const f=[],o=i.properties;if(o)for(const D in o){const O=o[D];if(r&&u(D,O)){delete o[D];continue}if(O.source=n,O.defaultDefaultValue=o[D].default,this.updatePropertyDefaultValue(D,O),e.OVERRIDE_PROPERTY_REGEX.test(D)?O.scope=void 0:(O.scope=P.isUndefinedOrNull(O.scope)?a:O.scope,O.restricted=P.isUndefinedOrNull(O.restricted)?!!s?.includes(D):O.restricted),o[D].hasOwnProperty("included")&&!o[D].included){this.excludedConfigurationProperties[D]=o[D],delete o[D];continue}else this.configurationProperties[D]=o[D],o[D].policy?.name&&this.policyConfigurations.set(o[D].policy.name,D);!o[D].deprecationMessage&&o[D].markdownDeprecationMessage&&(o[D].deprecationMessage=o[D].markdownDeprecationMessage),f.push(D)}const c=i.allOf;if(c)for(const D of c)f.push(...this.validateAndRegisterProperties(D,r,n,s,a));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const r=n=>{const s=n.properties;if(s)for(const f in s)this.updateSchema(f,s[f]);n.allOf?.forEach(r)};r(i)}updateSchema(i,r){switch(e.allSettings.properties[i]=r,r.scope){case 1:e.applicationSettings.properties[i]=r;break;case 2:e.machineSettings.properties[i]=r;break;case 6:e.machineOverridableSettings.properties[i]=r;break;case 3:e.windowSettings.properties[i]=r;break;case 4:e.resourceSettings.properties[i]=r;break;case 5:e.resourceSettings.properties[i]=r,this.resourceLanguageSettingsSchema.properties[i]=r;break}}removeFromSchema(i,r){switch(delete e.allSettings.properties[i],r.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const r=`[${i}]`,n={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,n),e.allSettings.properties[r]=n,e.applicationSettings.properties[r]=n,e.machineSettings.properties[r]=n,e.machineOverridableSettings.properties[r]=n,e.windowSettings.properties[r]=n,e.resourceSettings.properties[r]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,r){const n=this.configurationDefaultsOverrides.get(i);let s=n?.value,a=n?.source;P.isUndefined(s)&&(s=r.defaultDefaultValue,a=void 0),P.isUndefined(s)&&(s=m(r.type)),r.default=s,r.defaultValueSource=a}}const w="\\[([^\\]]+)\\]",d=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(h){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(h)){let r=d.exec(h);for(;r?.length;){const n=r[1].trim();n&&i.push(n),r=d.exec(h)}}return(0,y.distinct)(i)}e.overrideIdentifiersFromKey=g;function p(h){return h.reduce((i,r)=>`${i}[${r}]`,"")}e.keyFromOverrideIdentifiers=p;function m(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const v=new S;E.Registry.add(e.Extensions.Configuration,v);function u(h,i){return h.trim()?e.OVERRIDE_PROPERTY_REGEX.test(h)?I.localize(7,null,h):v.getConfigurationProperties()[h]!==void 0?I.localize(8,null,h):i.policy?.name&&v.getPolicyConfigurations().get(i.policy?.name)!==void 0?I.localize(9,null,h,i.policy?.name,v.getPolicyConfigurations().get(i.policy?.name)):null:I.localize(6,null)}e.validateProperty=u;function l(){const h=[],i=v.getConfigurationProperties();for(const r of Object.keys(i))h.push([r,i[r].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.getScopes=l}),define(we[107],ye([1,0,18,7,67,2,31,22,13,4,24,51,34]),function(se,e,y,t,P,I,k,b,E,C,T,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class w{constructor(r={},n=[],s=[],a){this._contents=r,this._keys=n,this._overrides=s,this.raw=a,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(n=>{if(n instanceof w)return n;const s=new d("");return s.parseRaw(n),s.configurationModel});this._rawConfiguration=r.reduce((n,s)=>s===n?s:n.merge(s),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,T.getConfigurationValue)(this.contents,r):this.contents}inspect(r,n){const s=this.rawConfiguration.getValue(r),a=n?this.rawConfiguration.getOverrideValue(r,n):void 0,f=n?this.rawConfiguration.override(n).getValue(r):s;return{value:s,override:a,merged:f}}getOverrideValue(r,n){const s=this.getContentsForOverrideIdentifer(n);return s?r?(0,T.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const s of this.overrides)s.identifiers.includes(r)&&n.push(...s.keys);return y.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return y.distinct(r)}override(r){let n=this.overrideConfigurations.get(r);return n||(n=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,n)),n}merge(...r){const n=b.deepClone(this.contents),s=b.deepClone(this.overrides),a=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const o of r)if(f.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.mergeContents(n,o.contents);for(const c of o.overrides){const[D]=s.filter(O=>y.equals(O.identifiers,c.identifiers));D?(this.mergeContents(D.contents,c.contents),D.keys.push(...c.keys),D.keys=y.distinct(D.keys)):s.push(b.deepClone(c))}for(const c of o.keys)a.indexOf(c)===-1&&a.push(c)}return new w(n,a,s,f.every(o=>o instanceof w)?void 0:f)}freeze(){return this.frozen=!0,this}clone(){return new w(b.deepClone(this.contents),[...this.keys],b.deepClone(this.overrides))}createOverrideConfigurationModel(r){const n=this.getContentsForOverrideIdentifer(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const a of y.distinct([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[a];const o=n[a];o&&(typeof f=="object"&&typeof o=="object"?(f=b.deepClone(f),this.mergeContents(f,o)):f=o),s[a]=f}return new w(s,this.keys,this.overrides)}mergeContents(r,n){for(const s of Object.keys(n)){if(s in r&&E.isObject(r[s])&&E.isObject(n[s])){this.mergeContents(r[s],n[s]);continue}r[s]=b.deepClone(n[s])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?b.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let n=null,s=null;const a=f=>{f&&(s?this.mergeContents(s,f):s=b.deepClone(f))};for(const f of this.overrides)y.equals(f.identifiers,[r])?n=f.contents:f.identifiers.includes(r)&&a(f.contents);return a(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.addKey(r),(0,T.addToValueTree)(this.contents,r,n,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,T.removeFromValueTree)(this.contents,r)}addKey(r){let n=this.keys.length;for(let s=0;s<n;s++)r.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,r)}removeKey(r){const n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=w;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,n){if(!E.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,n)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,n){this._raw=r;const{contents:s,keys:a,overrides:f,restricted:o,hasExcludedProperties:c}=this.doParseRaw(r,n);this._configurationModel=new w(s,a,f,c?[r]:void 0),this._restrictedConfigurations=o||[]}doParseContent(r){let n={},s=null,a=[];const f=[],o=[];function c(O){Array.isArray(a)?a.push(O):s!==null&&(a[s]=O)}const D={onObjectBegin:()=>{const O={};c(O),f.push(a),a=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const O=[];c(O),f.push(a),a=O,s=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:c,onError:(O,H,re)=>{o.push({error:O,offset:H,length:re})}};if(r)try{P.visit(r,D),n=a[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return n}doParseRaw(r,n){const s=S.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),a=this.filter(r,s,!0,n);r=a.raw;const f=(0,T.toValuesTree)(r,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),o=Object.keys(r),c=this.toOverrides(r,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:f,keys:o,overrides:c,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}filter(r,n,s,a){let f=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:f};const o={},c=[];for(const D in r)if(R.OVERRIDE_PROPERTY_REGEX.test(D)&&s){const O=this.filter(r[D],n,!1,a);o[D]=O.raw,f=f||O.hasExcludedProperties,c.push(...O.restricted)}else{const O=n[D],H=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&c.push(D),(H===void 0||a.scopes===void 0||a.scopes.includes(H))&&!(a.skipRestricted&&O?.restricted)?o[D]=r[D]:f=!0}return{raw:o,restricted:c,hasExcludedProperties:f}}toOverrides(r,n){const s=[];for(const a of Object.keys(r))if(R.OVERRIDE_PROPERTY_REGEX.test(a)){const f={};for(const o in r[a])f[o]=r[a][o];s.push({identifiers:(0,R.overrideIdentifiersFromKey)(a),keys:Object.keys(f),contents:(0,T.toValuesTree)(f,n)})}return s}}e.ConfigurationModelParser=d;class g extends I.Disposable{constructor(r,n,s,a){super(),this.userSettingsResource=r,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&s.isEqual(f.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class p{constructor(r,n,s,a,f,o,c,D,O,H,re,ce,ae){this.key=r,this.overrides=n,this.value=s,this.overrideIdentifiers=a,this.defaultConfiguration=f,this.policyConfiguration=o,this.applicationConfiguration=c,this.userConfiguration=D,this.localUserConfiguration=O,this.remoteUserConfiguration=H,this.workspaceConfiguration=re,this.folderConfigurationModel=ce,this.memoryInspectValue=ae}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class m{constructor(r,n,s,a,f=new w,o=new w,c=new k.ResourceMap,D=new w,O=new k.ResourceMap,H=!0){this._defaultConfiguration=r,this._policyConfiguration=n,this._applicationConfiguration=s,this._localUserConfiguration=a,this._remoteUserConfiguration=f,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=D,this._memoryConfigurationByResource=O,this._freeze=H,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(r,n,s){return this.getConsolidatedConfigurationModel(r,n,s).getValue(r)}updateValue(r,n,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new w,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(r):a.setValue(r,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,n,s){const a=this.getConsolidatedConfigurationModel(r,n,s),f=y.distinct(a.overrides.map(D=>D.identifiers).flat()).filter(D=>a.getOverrideValue(r,D)!==void 0),o=this.getFolderConfigurationModelForResource(n.resource,s),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration;return new p(r,n,a.getValue(r),f.length?f:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),s?this._workspaceConfiguration.freeze():void 0,o?o.freeze():void 0,c.inspect(r,n.overrideIdentifier))}keys(r){const n=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,n){this._folderConfigurations.set(r,n),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const s=[];if(!n){const{added:a,updated:f,removed:o}=l(this._defaultConfiguration,r);n=[...a,...f,...o]}for(const a of n)for(const f of(0,R.overrideIdentifiersFromKey)(a)){const o=this._defaultConfiguration.getKeysForOverrideIdentifier(f),c=r.getKeysForOverrideIdentifier(f),D=[...c.filter(O=>o.indexOf(O)===-1),...o.filter(O=>c.indexOf(O)===-1),...o.filter(O=>!b.equals(this._defaultConfiguration.override(f).getValue(O),r.override(f).getValue(O)))];s.push([f,D])}return this.updateDefaultConfiguration(r),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:s,removed:a}=l(this._policyConfiguration,r),f=[...n,...s,...a];return f.length&&this.updatePolicyConfiguration(r),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:n,updated:s,removed:a,overrides:f}=l(this.applicationConfiguration,r),o=[...n,...s,...a];return o.length&&this.updateApplicationConfiguration(r),{keys:o,overrides:f}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:s,removed:a,overrides:f}=l(this.localUserConfiguration,r),o=[...n,...s,...a];return o.length&&this.updateLocalUserConfiguration(r),{keys:o,overrides:f}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:s,removed:a,overrides:f}=l(this.remoteUserConfiguration,r),o=[...n,...s,...a];return o.length&&this.updateRemoteUserConfiguration(r),{keys:o,overrides:f}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:s,removed:a,overrides:f}=l(this.workspaceConfiguration,r),o=[...n,...s,...a];return o.length&&this.updateWorkspaceConfiguration(r),{keys:o,overrides:f}}compareAndUpdateFolderConfiguration(r,n){const s=this.folderConfigurations.get(r),{added:a,updated:f,removed:o,overrides:c}=l(s,n),D=[...a,...f,...o];return(D.length||!s)&&this.updateFolderConfiguration(r,n),{keys:D,overrides:c}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:a,removed:f,overrides:o}=l(n,void 0);return{keys:[...s,...a,...f],overrides:o}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,n,s){let a=this.getConsolidatedConfigurationModelForResource(n,s);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:r},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&r){const a=n.getFolder(r);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const f=this._memoryConfigurationByResource.get(r);f&&(s=s.merge(f))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let n=this._foldersConsolidatedConfigurations.get(r);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(r);a?(n=s.merge(a),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(r,n)):n=s}return n}getFolderConfigurationModelForResource(r,n){if(n&&r){const s=n.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,n)=>{const{contents:s,overrides:a,keys:f}=this._folderConfigurations.get(n);return r.push([n,{contents:s,overrides:a,keys:f}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a))),[...n.values()]}static parse(r){const n=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.policy),a=this.parseConfigurationModel(r.application),f=this.parseConfigurationModel(r.user),o=this.parseConfigurationModel(r.workspace),c=r.folders.reduce((D,O)=>(D.set(C.URI.revive(O[0]),this.parseConfigurationModel(O[1])),D),new k.ResourceMap);return new m(n,s,a,f,new w,o,c,new w,new k.ResourceMap,!1)}static parseConfigurationModel(r){return new w(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=m;function v(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const r=new Set,n=new Map;for(const a of i)a.keys.forEach(f=>r.add(f)),a.overrides.forEach(([f,o])=>{const c=(0,k.getOrSet)(n,f,new Set);o.forEach(D=>c.add(D))});const s=[];return n.forEach((a,f)=>s.push([f,[...a.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=v;class u{constructor(r,n,s,a){this.change=r,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const f=new Set;r.keys.forEach(c=>f.add(c)),r.overrides.forEach(([,c])=>c.forEach(D=>f.add(D))),this.affectedKeys=[...f.values()];const o=new w;this.affectedKeys.forEach(c=>o.setValue(c,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(r,n,this.currentWorkspace);return!b.equals(s,a)}return!0}return!1}doesAffectedKeysTreeContains(r,n){let s=(0,T.toValuesTree)({[n]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(r=r[a],!r)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=u;function l(i,r){const{added:n,removed:s,updated:a}=h(r?.rawConfiguration,i?.rawConfiguration),f=[],o=i?.getAllOverrideIdentifiers()||[],c=r?.getAllOverrideIdentifiers()||[];if(r){const D=c.filter(O=>!o.includes(O));for(const O of D)f.push([O,r.getKeysForOverrideIdentifier(O)])}if(i){const D=o.filter(O=>!c.includes(O));for(const O of D)f.push([O,i.getKeysForOverrideIdentifier(O)])}if(r&&i){for(const D of o)if(c.includes(D)){const O=h({contents:i.getOverrideValue(void 0,D)||{},keys:i.getKeysForOverrideIdentifier(D)},{contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)});f.push([D,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:s,updated:a,overrides:f}}function h(i,r){const n=i?r?i.keys.filter(f=>r.keys.indexOf(f)===-1):[...i.keys]:[],s=r?i?r.keys.filter(f=>i.keys.indexOf(f)===-1):[...r.keys]:[],a=[];if(i&&r){for(const f of r.keys)if(i.keys.indexOf(f)!==-1){const o=(0,T.getConfigurationValue)(r.contents,f),c=(0,T.getConfigurationValue)(i.contents,f);b.equals(o,c)||a.push(f)}}return{added:n,removed:s,updated:a}}}),define(we[216],ye([1,0,18,7,2,22,13,24,107,51,12,63,34]),function(se,e,y,t,P,I,k,b,E,C,T,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class w extends P.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:u})=>this.onDidUpdateConfiguration(v,u))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(v,u){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=w;class d extends E.ConfigurationModel{constructor(v={}){const u=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(u),h=Object.create(null),i=[];for(const r in u){const n=v[r],s=n!==void 0?n:u[r].default;(0,b.addToValueTree)(h,r,s,a=>console.error(`Conflict in default settings: ${a}`))}for(const r of Object.keys(h))C.OVERRIDE_PROPERTY_REGEX.test(r)&&i.push({identifiers:(0,C.overrideIdentifiersFromKey)(r),keys:Object.keys(h[r]),contents:(0,b.toValuesTree)(h[r],n=>console.error(`Conflict in default settings file: ${n}`))});super(h,l,i)}}e.DefaultConfigurationModel=d;class g{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let p=class extends P.Disposable{get configurationModel(){return this._configurationModel}constructor(v,u,l){super(),this.defaultConfiguration=v,this.policyService=u,this.logService=l,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.registerPolicyDefinitions(v),!0))),this._configurationModel}async registerPolicyDefinitions(v){const u={},l=[],h=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(const i of v){const r=h[i];if(!r){l.push(i);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}l.push(i),u[r.policy.name]={type:r.type}}}return(0,k.isEmptyObject)(u)||await this.policyService.registerPolicyDefinitions(u),l}onDidChangePolicies(v){const u=S.Registry.as(C.Extensions.Configuration).getPolicyConfigurations(),l=(0,y.coalesce)(v.map(h=>u.get(h)));this.update(l,!0)}update(v,u){const l=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),h=[],i=this._configurationModel.isEmpty();for(const r of v){const n=l[r]?.policy?.name;if(n){const s=this.policyService.getPolicyValue(n);(i?s!==void 0:!(0,I.equals)(this._configurationModel.getValue(r),s))&&h.push([r,s])}else this._configurationModel.getValue(r)!==void 0&&h.push([r,void 0])}if(h.length){const r=this._configurationModel;this._configurationModel=new E.ConfigurationModel;for(const n of r.keys)this._configurationModel.setValue(n,r.getValue(n));for(const[n,s]of h)s===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,s);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};p=Ae([_e(1,R.IPolicyService),_e(2,T.ILogService)],p),e.PolicyConfiguration=p}),define(we[108],ye([1,0,14,7,2,19,24,107,216,63]),function(se,e,y,t,P,I,k,b,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends P.Disposable{constructor(S,w,d,g){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new E.DefaultConfiguration),this.policyConfiguration=d instanceof C.NullPolicyService?new E.NullPolicyConfiguration:this._register(new E.PolicyConfiguration(this.defaultConfiguration,d,g)),this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,I.extUriBiasedIgnorePathCase,w)),this.configuration=new b.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:p,properties:m})=>this.onDidDefaultConfigurationChange(p,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(p=>this.onDidPolicyConfigurationChange(p))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,w,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new b.Configuration(S,w,new b.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(S,w){const d=typeof S=="string"?S:void 0,g=(0,k.isConfigurationOverrides)(S)?S:(0,k.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(d,g,void 0)}updateValue(S,w,d,g){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const w=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(d,w,2)}onDidDefaultConfigurationChange(S,w){const d=this.configuration.toData(),g=this.configuration.compareAndUpdateDefaultConfiguration(S,w);this.trigger(g,d,7)}onDidPolicyConfigurationChange(S){const w=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(d,w,7)}trigger(S,w,d){const g=new b.ConfigurationChangeEvent(S,{data:w},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(we[109],ye([1,0,10,5]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var P;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends y.ErrorNoTelemetry{static isNotAvailable(b){return b instanceof I&&b._code===P.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof I&&b._code===P.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof I&&b._code===P.NoResolverFound}static isHandled(b){return b instanceof I&&b.isHandled}constructor(b,E=P.Unknown,C){super(b),this._message=b,this._code=E,this._detail=C,this.isHandled=E===P.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}}e.RemoteAuthorityResolverError=I}),define(we[78],ye([1,0,11]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(C){return C.scheme===y.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=t;function P(C){if(!C)return;const T=C.indexOf("+");return T<0?C:C.substr(0,T)}e.getRemoteName=P;function I(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=I;function k(C){const{host:T,port:R}=E(C);if(typeof R>"u")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:R}}e.parseAuthorityWithPort=k;function b(C,T){let{host:R,port:S}=E(C);return typeof S>"u"&&(S=T),{host:R,port:S}}e.parseAuthorityWithOptionalPort=b;function E(C){const T=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const R=C.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const S=C.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:C,port:void 0}}}),define(we[35],ye([1,0,15,5,78]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=I;function k(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));var E;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,p){if(typeof g>"u"||g===null)return typeof p>"u"||p===null;if(typeof p>"u"||p===null)return!1;if(typeof g=="string"||typeof p=="string"){const m=typeof g=="string"?g:g.value,v=typeof p=="string"?p:p.value;return y.equalsIgnoreCase(m,v)}return g._lower===p._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=C;function T(d){return R(d)}e.isApplicationScopedExtension=T;function R(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function S(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function w(d,g){if(g){const p=`onResolveRemoteAuthority:${(0,P.getRemoteName)(g)}`;return d.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=w,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[32],ye([1,0,15,30,35,3,4,10,27]),function(se,e,y,t,P,I,k,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(r,n){return r.uuid&&n.uuid?r.uuid===n.uuid:r.id===n.id?!0:(0,y.compareIgnoreCase)(r.id,n.id)===0}e.areSameExtensions=C;const T=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class R{static create(n){const s=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new R(n.identifier,s,a)}static parse(n){const s=T.exec(n);return s&&s[1]&&s[2]?new R({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof R?C(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=R;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(r){const n=S.exec(r);return n&&n[1]?[g(n[1]),n[2]]:[g(r),void 0]}e.getIdAndVersion=w;function d(r,n){return`${r}.${n}`}e.getExtensionId=d;function g(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function p(r,n){return g(d(r,n))}e.getGalleryExtensionId=p;function m(r,n){const s=[],a=f=>{for(const o of s)if(o.some(c=>C(n(c),n(f))))return o;return null};for(const f of r){const o=a(f);o?o.push(f):s.push([f])}return s}e.groupByExtension=m;function v(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function u(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=u,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function l(r,n){const s=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const f=a.shift();if(f&&s.every(o=>!C(o.identifier,{id:f}))){const o=r.filter(c=>C(c.identifier,{id:f}));o.length===1&&(s.push(o[0]),a.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=l;async function h(r,n){if(!I.isLinux)return!1;let s;try{s=(await r.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){n.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(f))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=h;async function i(r,n){const s=await h(r,n),a=(0,t.getTargetPlatform)(s?"alpine":I.platform,E.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=i}),define(we[110],ye([1,0,20,10,11,19,49,4,166,30,32,35]),function(se,e,y,t,P,I,k,b,E,C,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const S=p=>(0,E.localize)(0,null,p),w=(0,E.localize)(1,null,"ms-dotnettools.csharp");function d(p,m){return m?`${p.publisher}.${p.name}@${p.version}`:`${p.publisher}.${p.name}`}let g=class{constructor(m,v){this.extensionManagementService=m,this.extensionGalleryService=v}get location(){}async listExtensions(m,v,u,l=console){let h=await this.extensionManagementService.getInstalled(1,u);const i=R.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(v&&v!==""){if(i.indexOf(v.toLowerCase())<0){l.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}h=h.filter(n=>n.manifest.categories?n.manifest.categories.map(a=>a.toLowerCase()).indexOf(v.toLowerCase())>-1:!1)}else if(v===""){l.log("Possible Categories: "),i.forEach(n=>{l.log(n)});return}this.location&&l.log((0,E.localize)(2,null,this.location)),h=h.sort((n,s)=>n.identifier.id.localeCompare(s.identifier.id));let r;for(const n of h)r!==n.identifier.id&&(r=n.identifier.id,l.log(d(n.manifest,m)))}async installExtensions(m,v,u,l,h=console){const i=[],r=[];m.length&&h.log(this.location?(0,E.localize)(3,null,this.location):(0,E.localize)(4,null));const n=await this.extensionManagementService.getInstalled(1,u.profileLocation),s=(c,D)=>{const O=n.find(H=>(0,T.areSameExtensions)(H.identifier,{id:c}));if(O){if(!l&&(!D||D==="prerelease"&&O.preRelease))return h.log((0,E.localize)(5,null,c,O.manifest.version,c)),!1;if(D&&O.manifest.version===D)return h.log((0,E.localize)(6,null,`${c}@${D}`)),!1}return!0},a=(c,D,O)=>{o.push({id:c,version:D!=="prerelease"?D:void 0,installOptions:{...u,isBuiltin:O,installPreReleaseVersion:D==="prerelease"||u.installPreReleaseVersion}})},f=[],o=[];for(const c of m)if(c instanceof b.URI)f.push(c);else{const[D,O]=(0,T.getIdAndVersion)(c);s(D,O)&&a(D,O,!1)}for(const c of v){const[D,O]=(0,T.getIdAndVersion)(c);s(D,O)&&a(D,O,!0)}if(f.length&&await Promise.all(f.map(async c=>{try{const D=await this.installVSIX(c,{...u,isBuiltin:!1},l,h);D&&r.push(D)}catch(D){h.error(D.message||D.stack||D),i.push(c.toString())}})),o.length){const c=await this.getGalleryExtensions(o);await Promise.all(o.map(async D=>{const O=c.get(D.id.toLowerCase());if(O)try{const H=await this.installFromGallery(D,O,n,l,h);H&&r.push(H)}catch(H){h.error(H.message||H.stack||H),i.push(D.id)}else h.error(`${S(D.version?`${D.id}@${D.version}`:D.id)}
${w}`),i.push(D.id)}))}if(i.length)throw new Error((0,E.localize)(7,null,i.join(", ")))}async installVSIX(m,v,u,l){const h=await this.extensionManagementService.getManifest(m);if(!h)throw new Error("Invalid vsix");if(await this.validateVSIX(h,u,v.profileLocation,l))try{return await this.extensionManagementService.install(m,v),l.log((0,E.localize)(8,null,(0,I.basename)(m))),h}catch(r){if((0,t.isCancellationError)(r))return l.log((0,E.localize)(9,null,(0,I.basename)(m))),null;throw r}return null}async getGalleryExtensions(m){const v=new Map,u=m.some(h=>h.installOptions.installPreReleaseVersion),l=await this.extensionGalleryService.getExtensions(m.map(h=>({...h,preRelease:u})),y.CancellationToken.None);for(const h of l)v.set(h.identifier.id.toLowerCase(),h);return v}async installFromGallery({id:m,version:v,installOptions:u},l,h,i,r){const n=await this.extensionGalleryService.getManifest(l,y.CancellationToken.None);if(n&&!this.validateExtensionKind(n,r))return null;const s=h.find(a=>(0,T.areSameExtensions)(a.identifier,l.identifier));if(s){if(l.version===s.manifest.version)return r.log((0,E.localize)(10,null,v?`${m}@${v}`:m)),null;r.log((0,E.localize)(11,null,m,l.version))}try{u.isBuiltin?r.log(v?(0,E.localize)(12,null,m,v):(0,E.localize)(13,null,m)):r.log(v?(0,E.localize)(14,null,m,v):(0,E.localize)(15,null,m));const a=await this.extensionManagementService.installFromGallery(l,{...u,installGivenVersion:!!v});return r.log((0,E.localize)(16,null,m,a.manifest.version)),n}catch(a){if((0,t.isCancellationError)(a))return r.log((0,E.localize)(17,null,m)),null;throw a}}validateExtensionKind(m,v){return!0}async validateVSIX(m,v,u,l){const h={id:(0,T.getGalleryExtensionId)(m.publisher,m.name)},r=(await this.extensionManagementService.getInstalled(1,u)).find(n=>(0,T.areSameExtensions)(h,n.identifier)&&(0,k.gt)(n.manifest.version,m.version));return r&&!v?(l.log((0,E.localize)(18,null,r.identifier.id,r.manifest.version,m.version)),!1):this.validateExtensionKind(m,l)}async uninstallExtensions(m,v,u,l=console){const h=async r=>{if(r instanceof b.URI){const n=await this.extensionManagementService.getManifest(r);return d(n)}return r},i=[];for(const r of m){const n=await h(r),a=(await this.extensionManagementService.getInstalled(void 0,u)).filter(f=>(0,T.areSameExtensions)(f.identifier,{id:n}));if(!a.length)throw new Error(`${this.notInstalled(n)}
${w}`);if(a.some(f=>f.type===0)){l.log((0,E.localize)(19,null,n));return}if(!v&&a.some(f=>f.isBuiltin)){l.log((0,E.localize)(20,null,n));return}l.log((0,E.localize)(21,null,n));for(const f of a)await this.extensionManagementService.uninstall(f,{profileLocation:u}),i.push(f);this.location?l.log((0,E.localize)(22,null,n,this.location)):l.log((0,E.localize)(23,null,n))}}async locateExtension(m,v=console){const u=await this.extensionManagementService.getInstalled();m.forEach(l=>{u.forEach(h=>{if(h.identifier.id===l&&h.location.scheme===P.Schemas.file){v.log(h.location.fsPath);return}})})}notInstalled(m){return this.location?(0,E.localize)(24,null,m,this.location):(0,E.localize)(25,null,m)}};g=Ae([_e(0,C.IExtensionManagementService),_e(1,C.IExtensionGalleryService)],g),e.ExtensionManagementCLI=g}),define(we[52],ye([1,0,14,16,2,31,4,32,17,5,12]),function(se,e,y,t,P,I,k,b,E,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,C.createDecorator)("IExtensionsProfileScannerService");let R=class extends P.Disposable{constructor(w,d){super(),this.fileService=w,this.logService=d,this.resourcesAccessQueueMap=new I.ResourceMap}scanProfileExtensions(w){return this.withProfileExtensions(w)}addExtensionsToProfile(w,d){return this.withProfileExtensions(d,g=>(g=g.filter(p=>w.some(([m])=>!(0,b.areSameExtensions)(p.identifier,m.identifier))),g.push(...w.map(([p,m])=>({identifier:p.identifier,version:p.manifest.version,location:p.location,metadata:m}))),g))}removeExtensionFromProfile(w,d){return this.withProfileExtensions(d,g=>g.filter(p=>!(0,b.areSameExtensions)(p.identifier,w)))}async withProfileExtensions(w,d){return this.getResourceAccessQueue(w).queue(async()=>{let g=[];try{const p=await this.fileService.readFile(w),m=JSON.parse(p.value.toString());for(const v of m){if(!v.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",v);continue}if(!v.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",v);continue}if(!v.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",v);continue}g.push({identifier:v.identifier,location:k.URI.revive(v.location),version:v.version,metadata:v.metadata})}}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}if(d){g=d(g);const p=g.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),metadata:m.metadata}));await this.fileService.writeFile(w,t.VSBuffer.fromString(JSON.stringify(p)))}return g})}getResourceAccessQueue(w){let d=this.resourcesAccessQueueMap.get(w);return d||(d=new y.Queue,this.resourcesAccessQueueMap.set(w,d)),d}};R=Ae([_e(0,E.IFileService),_e(1,T.ILogService)],R),e.ExtensionsProfileScannerService=R}),define(we[217],ye([1,0,14,10,2,11,3,19,49,23,21,24,25,30,32,75,17,12]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class Sn extends P.Disposable{constructor(l,h,i,r,n,s){super(),this.fileService=h,this.extensionGalleryService=i,this.configurationService=r,this.extensionSignatureVerificationService=n,this.logService=s,this.extensionsDownloadDir=l.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(l,h){await this.cleanUpPromise;const i=(0,b.joinPath)(this.extensionsDownloadDir,this.getName(l));try{await this.downloadFile(l,i,n=>this.extensionGalleryService.download(l,n,h))}catch(n){throw new w.ExtensionManagementError(n.message,w.ExtensionManagementErrorCode.Download)}let r=!1;if(l.isSigned&&this.configurationService.getValue("extensions.verifySignature")===!0){const n=await this.downloadSignatureArchive(l);try{r=await this.extensionSignatureVerificationService.verify(i.fsPath,n.fsPath),this.logService.info(`Verified extension: ${l.identifier.id}`,r)}catch(s){throw await this.delete(n),await this.delete(i),new w.ExtensionManagementError(s.code,w.ExtensionManagementErrorCode.Signature)}}return{location:i,verified:r}}async downloadSignatureArchive(l){await this.cleanUpPromise;const h=(0,b.joinPath)(this.extensionsDownloadDir,`${this.getName(l)}${Sn.SignatureArchiveExtension}`);return await this.downloadFile(l,h,i=>this.extensionGalleryService.downloadSignatureArchive(l,i)),h}async downloadFile(l,h,i){if(await this.fileService.exists(h))return;if(h.scheme!==I.Schemas.file){await i(h);return}const r=(0,b.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.fileService.exists(r)||await i(r);try{await this.rename(r,h,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(r)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",l.identifier.id,h.path);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(n)}. Deleted the file from downloaded location`,r.path),n}}async delete(l){await this.cleanUpPromise,await this.fileService.del(l)}async rename(l,h,i){try{await T.Promises.rename(l.fsPath,h.fsPath)}catch(r){if(k.isWindows&&r&&r.code==="EPERM"&&Date.now()<i)return this.logService.info(`Failed renaming ${l} to ${h} with 'EPERM' error. Trying again...`),this.rename(l,h,i);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const l=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(l.children){const h=[],i=[],r=[];for(const a of l.children)if(a.name.endsWith(Sn.SignatureArchiveExtension))r.push(a.resource);else{const f=d.ExtensionKey.parse(a.name);f&&i.push([f,a])}const n=(0,d.groupByExtension)(i,([a])=>a),s=[];for(const a of n)a.sort((f,o)=>E.rcompare(f[0].version,o[0].version)),h.push(...a.slice(1).map(f=>f[1].resource)),s.push(a[0][1]);s.sort((a,f)=>a.mtime-f.mtime),h.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(a=>a.resource)),h.push(...r),await y.Promises.settled(h.map(a=>(this.logService.trace("Deleting from cache",a.path),this.fileService.del(a))))}}catch(l){this.logService.error(l)}}getName(l){return this.cache?d.ExtensionKey.create(l).toString().toLowerCase():(0,C.generateUuid)()}};v.SignatureArchiveExtension=".sigzip",v=Ae([_e(0,S.INativeEnvironmentService),_e(1,p.IFileService),_e(2,w.IExtensionGalleryService),_e(3,R.IConfigurationService),_e(4,g.IExtensionSignatureVerificationService),_e(5,m.ILogService)],v),e.ExtensionsDownloader=v}),define(we[218],ye([1,0,2,6,21,35]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends y.Disposable{constructor(E,C){super(),this.environmentService=E,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(C.onDidInstallExtensions(T=>this.onDidInstallExtensions(T))),this._register(C.onDidUninstallExtension(T=>this.onDidUnInstallExtension(T)))}onDidInstallExtensions(E){E.some(C=>!!C.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(we[111],ye([1,0,112,18,14,2,11,6,21,25,30,32,12,77,3,4]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let p=class extends w.LanguagePackBaseService{constructor(l,h,i,r){super(i),this.extensionManagementService=l,this.logService=r,this.cache=this._register(new m(h,r)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getBuiltInExtensionTranslationsUri(l){const i=(await this.cache.getLanguagePacks())[d.Language.value()];if(!i){this.logService.warn(`No language pack found for ${d.Language.value()}`);return}const r=i.translations[l];return r?g.URI.file(r):void 0}async getInstalledLanguages(){const l=await this.cache.getLanguagePacks(),h=Object.keys(l).map(i=>{const r=l[i];return{...this.createQuickPickItem(i,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return h.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),h.sort((i,r)=>i.label.localeCompare(r.label)),h}async postInstallExtension(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",l.identifier.id),await this.update())}async postUninstallExtension(l){const h=await this.cache.getLanguagePacks();Object.keys(h).some(i=>h[i]&&h[i].extensions.some(r=>(0,R.areSameExtensions)(r.extensionIdentifier,l.identifier)))&&(this.logService.info("Removing language packs from the extension",l.identifier.id),await this.update())}async update(){const[l,h]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(h);return!(0,t.equals)(Object.keys(l),Object.keys(i))}};p=Ae([_e(0,T.IExtensionManagementService),_e(1,C.INativeEnvironmentService),_e(2,T.IExtensionGalleryService),_e(3,S.ILogService)],p),e.NativeLanguagePackService=p;let m=class extends I.Disposable{constructor(l,h){super(),this.logService=h,this.languagePacks={},this.languagePacksFilePath=(0,b.join)(l.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(l){return this.withLanguagePacks(h=>{Object.keys(h).forEach(i=>delete h[i]),this.createLanguagePacksFromExtensions(h,...l)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(l,...h){for(const i of h)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(l,i);Object.keys(l).forEach(i=>this.updateHash(l[i]))}createLanguagePacksFromExtension(l,h){const i=h.identifier,r=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const n of r)if(h.location.scheme===k.Schemas.file&&v(n)){let s=l[n.languageId];s||(s={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},l[n.languageId]=s);const a=s.extensions.filter(f=>(0,R.areSameExtensions)(f.extensionIdentifier,i))[0];a?a.version=h.manifest.version:s.extensions.push({extensionIdentifier:i,version:h.manifest.version});for(const f of n.translations)s.translations[f.id]=(0,b.join)(h.location.fsPath,f.path)}}updateHash(l){if(l){const h=(0,y.createHash)("md5");for(const i of l.extensions)h.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);l.hash=h.digest("hex")}}withLanguagePacks(l=()=>null){return this.languagePacksFileLimiter.queue(()=>{let h=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(h=l(i),i)).then(i=>{for(const n of Object.keys(i))i[n]||delete i[n];this.languagePacks=i,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),E.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>h,i=>this.logService.error(i))})}};m=Ae([_e(0,C.INativeEnvironmentService),_e(1,S.ILogService)],m);function v(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const l of u.translations)if(typeof l.id!="string"||typeof l.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(we[53],ye([1,0,16,178,51,5,34]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");function b(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=b;function E(g){return g.res.statusCode===204}async function C(g){return E(g)?null:(await(0,y.streamToBuffer)(g.stream)).toString()}e.asText=C;async function T(g){if(!b(g))throw new Error("Server returned "+g.res.statusCode);return C(g)}e.asTextOrError=T;async function R(g){if(!b(g))throw new Error("Server returned "+g.res.statusCode);if(E(g))return null;const m=(await(0,y.streamToBuffer)(g.stream)).toString();try{return JSON.parse(m)}catch(v){throw v.message+=`:
`+m,v}}e.asJson=R;function S(g){d(g)}e.updateProxyConfigurationsScope=S;let w;function d(g){const p=k.Registry.as(P.Extensions.Configuration),m=w;w={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},p.updateConfigurations({add:[w],remove:m?[m]:[]})}d(2)}),define(we[219],ye([1,0,20,11,17,53]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(E,C){this.requestService=E,this.fileService=C}async download(E,C,T=y.CancellationToken.None){if(E.scheme===t.Schemas.file||E.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(E,C);return}const R={type:"GET",url:E.toString(!0)},S=await this.requestService.request(R,T);if(S.res.statusCode===200)await this.fileService.writeFile(C,S.stream);else{const w=await(0,I.asTextOrError)(S);throw new Error(`Expected 200, got back ${S.res.statusCode} instead.

${w}`)}}};k=Ae([_e(0,I.IRequestService),_e(1,P.IFileService)],k),e.DownloadService=k}),define(we[220],ye([1,0,16,20]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class P{constructor(b){this.service=b}listen(b,E){throw new Error("Invalid listen")}call(b,E,C,T=t.CancellationToken.None){switch(E){case"request":return this.service.request(C[0],T).then(async({res:R,stream:S})=>{const w=await(0,y.streamToBuffer)(S);return[{statusCode:R.statusCode,headers:R.headers},w]});case"resolveProxy":return this.service.resolveProxy(C[0])}throw new Error("Invalid call")}}e.RequestChannel=P;class I{constructor(b){this.channel=b}async request(b,E){const[C,T]=await this.channel.call("request",[b],E);return{res:C,stream:(0,y.bufferToStream)(T)}}async resolveProxy(b){return this.channel.call("resolveProxy",[b])}}e.RequestChannelClient=I}),define(we[221],ye([1,0,79,13]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function P(k,b){return k.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:k.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function I(k,b,E={}){const C=(0,y.parse)(k),T=E.proxyUrl||P(C,b);if(!T)return null;const R=(0,y.parse)(T);if(!/^https?:$/.test(R.protocol||""))return null;const S={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,t.isBoolean)(E.strictSSL)?E.strictSSL:!0};return C.protocol==="http:"?new(await new Promise((w,d)=>{se(["http-proxy-agent"],w,d)}))(S):new(await new Promise((w,d)=>{se(["https-proxy-agent"],w,d)}))(S)}e.getProxyAgent=I}),define(we[80],ye([1,0,48,6,179,20,38,10,3,23,156,192,14]),function(se,e,y,t,P,I,k,b,E,C,T,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const w=1e4;let d;async function g(m,v,u){return v["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(u)&&!v["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(u)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=S.Promises.withAsyncBody(async(l,h)=>{const i=new I.CancellationTokenSource,r=setTimeout(()=>{i.dispose(!0),h(new Error((0,P.localize)(0,null)))},w);try{l(await p(m,i.token))}catch(n){!(0,b.isCancellationError)(n)&&!i.token.isCancellationRequested?h(new Error((0,P.localize)(1,null,(0,k.toErrorMessage)(n)))):l({})}finally{clearTimeout(r),i.dispose()}})),d)}e.getResolvedShellEnv=g;async function p(m,v){const u=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",u);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",l);const h=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(h+"(.*)"+h),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",r);const n=await(0,T.getSystemShell)(E.OS,r);return m.trace("getUnixShellEnvironment#shell",n),new Promise((s,a)=>{if(v.isCancellationRequested)return a((0,b.canceled)());const f=(0,t.basename)(n);let o,c;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(f)?(o=`& '${process.execPath}' ${D} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,c=["-Login","-Command"]):(o=`'${process.execPath}' ${D} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,f==="tcsh"?c=["-ic"]:c=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(c),o);const O=(0,y.spawn)(n,[...c,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});v.onCancellationRequested(()=>(O.kill(),a((0,b.canceled)()))),O.on("error",ce=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(ce)),a(ce)});const H=[];O.stdout.on("data",ce=>H.push(ce));const re=[];O.stderr.on("data",ce=>re.push(ce)),O.on("close",(ce,ae)=>{const N=Buffer.concat(H).toString("utf8");m.trace("getUnixShellEnvironment#raw",N);const J=Buffer.concat(re).toString("utf8");if(J.trim()&&m.trace("getUnixShellEnvironment#stderr",J),ce||ae)return a(new Error((0,P.localize)(2,null,ce,ae)));const B=i.exec(N),x=B?B[1]:"{}";try{const z=JSON.parse(x);u?z.ELECTRON_RUN_AS_NODE=u:delete z.ELECTRON_RUN_AS_NODE,l?z.ELECTRON_NO_ATTACH_CONSOLE=l:delete z.ELECTRON_NO_ATTACH_CONSOLE,delete z.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",z),s(z)}catch(z){m.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(z)),a(z)}})})}}),define(we[113],ye([1,0,3,27,4,23]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(C){if(y.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function b(C,T,R,S,w,d,g,p,m,v){const u=Object.create(null);u["common.machineId"]=g,u.sessionID=(0,I.generateUuid)()+Date.now(),u.commitHash=w,u.version=d,u["common.platformVersion"]=(T||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,y.PlatformToString)(y.platform),u["common.nodePlatform"]=t.platform,u["common.nodeArch"]=S,u["common.product"]=v||"desktop",p&&(u["common.msftInternal"]=p);let l=0;const h=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),y.isLinuxSnap&&(u["common.snap"]="true");const i=k(R);i&&(u["common.platformDetail"]=i);try{const r=await C.readFile(P.URI.file(m));u["common.source"]=r.value.toString().slice(0,30)}catch{}return u}e.resolveCommonProperties=b;function E(C){const T=t.env.USERDNSDOMAIN;if(!T)return!1;const R=T.toLowerCase();return C.some(S=>R===S)}e.verifyMicrosoftInternalDomain=E}),define(we[222],ye([1,0,18,10,2,22,17]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var b;(function(C){function T(R,S){return R.callstack<S.callstack?-1:R.callstack>S.callstack?1:0}C.compare=T})(b=e.ErrorEvent||(e.ErrorEvent={}));class E{constructor(T,R=E.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new P.DisposableStore,this._telemetryService=T,this._flushDelay=R;const S=t.errorHandler.addListener(w=>this._onErrorEvent(w));this._disposables.add((0,P.toDisposable)(S)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(T){if(!T||(T.detail&&T.detail.stack&&(T=T.detail),t.ErrorNoTelemetry.isErrorNoTelemetry(T)||T instanceof k.FileOperationError))return;const R=Array.isArray(T.stack)?T.stack.join(`
`):T.stack,S=T.message?T.message:(0,I.safeStringify)(T);!R||this._enqueue({msg:S,callstack:R})}_enqueue(T){const R=(0,y.binarySearch)(this._buffer,T,b.compare);R<0?(T.count=1,this._buffer.splice(~R,0,T)):(this._buffer[R].count||(this._buffer[R].count=0),this._buffer[R].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(const T of this._buffer)this._telemetryService.publicLogError2("UnhandledError",T);this._buffer.length=0}}e.default=E,E.ERROR_FLUSH_TIMEOUT=5*1e3}),define(we[223],ye([1,0,2]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends y.Disposable{constructor(I,k){super(),this.telemetryService=I,this.telemetryAppender=k}async call(I,k,b){switch(k){case"updateTelemetryLevel":{const{telemetryLevel:E}=b;return this.telemetryService.updateInjectedTelemetryLevel(E)}case"logTelemetry":{const{eventName:E,data:C}=b;return this.telemetryAppender?this.telemetryAppender.log(E,C):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${k} not found`)}listen(I,k,b){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(we[33],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,y.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,y.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(we[224],ye([1,0,29,14,67,11,6,3,4,94,21,97,199,17,26,33]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function m(i,r){const n=`${i}::${r.join(":")}`,s=p.get(n);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],f=new Map,o=new Map,c=2e4;function D(H,re,ce,ae){const N=re.substring(H.length+1);return t.Promises.withAsyncBody(async J=>{let B;try{B=await T.Promises.readdir(re,{withFileTypes:!0})}catch{J();return}if(ae.count>=c){ae.count+=B.length,ae.maxReached=!0,J();return}let x=B.length;if(x===0){J();return}let z=B;ae.count+B.length>c&&(ae.maxReached=!0,x=c-ae.count,z=B.slice(0,x)),ae.count+=B.length;for(const j of z)if(j.isDirectory()){if(ce.includes(j.name)||await D(H,(0,k.join)(re,j.name),ce,ae),--x===0){J();return}}else{const L=j.name.lastIndexOf(".");if(L>=0){const F=j.name.substring(L+1);F&&f.set(F,(f.get(F)??0)+1)}for(const F of a)F.relativePathPattern?.test(N)!==!1&&F.filePattern.test(j.name)&&o.set(F.tag,(o.get(F.tag)??0)+1);if(--x===0){J();return}}})}const O=t.Promises.withAsyncBody(async H=>{const re={count:0,maxReached:!1};await D(i,i,r,re);const ce=await l(i);H({configFiles:v(o),fileTypes:v(f),fileCount:re.count,maxFilesReached:re.maxReached,launchConfigFiles:ce})});return p.set(n,O),O}e.collectWorkspaceStats=m;function v(i){return Array.from(i.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function u(){const i={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(C.virtualMachineHint.value()*100)}%`},r=y.cpus();return r&&r.length>0&&(i.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),i}e.getMachineInfo=u;async function l(i){try{const r=new Map,n=(0,k.join)(i,".vscode","launch.json"),s=await T.Promises.readFile(n),a=[],f=(0,P.parse)(s.toString(),a);if(a.length)return console.log(`Unable to parse ${n}`),[];if((0,P.getNodeType)(f)==="object"&&f.configurations)for(const o of f.configurations){const c=o.type;c&&(r.has(c)?r.set(c,r.get(c)+1):r.set(c,1))}return v(r)}catch{return[]}}e.collectLaunchConfigs=l;let h=class{constructor(r,n){this.telemetryService=r,this.productService=n}formatMachineInfo(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}formatEnvironment(r){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const s=y.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(y.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||n.push(`Load (avg):       ${y.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(C.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,R.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async s=>{let[a,f]=s,o=this.formatProcessList(r,a);return n.forEach(c=>{if((0,S.isRemoteDiagnosticError)(c))o+=`
${c.errorMessage}`,f+=`
${c.errorMessage}`;else if(o+=`

Remote: ${c.hostName}`,c.processes&&(o+=`
${this.formatProcessList(r,c.processes)}`),c.workspaceMetadata){f+=`
|  Remote: ${c.hostName}`;for(const D of Object.keys(c.workspaceMetadata)){const O=c.workspaceMetadata[D];let H=`${O.fileCount} files`;O.maxFilesReached&&(H=`more than ${H}`),f+=`|    Folder (${D}): ${H}`,f+=this.formatWorkspaceStats(O)}}}),{processInfo:o,workspaceInfo:f}})}async getSystemInfo(r,n){const{memory:s,vmHint:a,os:f,cpus:o}=u(),c={os:f,memory:s,cpus:o,vmHint:a,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return b.isWindows||(c.load=`${y.loadavg().map(D=>Math.round(D)).join(", ")}`),b.isLinux&&(c.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(c)}async getDiagnostics(r,n){const s=[];return(0,R.listProcesses)(r.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(r)),s.push(""),s.push(this.formatProcessList(r,a)),r.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(r))),n.forEach(f=>{if((0,S.isRemoteDiagnosticError)(f))s.push(`
${f.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${f.hostName}`),s.push(this.formatMachineInfo(f.machineInfo)),f.processes&&s.push(this.formatProcessList(r,f.processes)),f.workspaceMetadata)for(const o of Object.keys(f.workspaceMetadata)){const c=f.workspaceMetadata[o];let D=`${c.fileCount} files`;c.maxFilesReached&&(D=`more than ${D}`),s.push(`Folder (${o}): ${D}`),s.push(this.formatWorkspaceStats(c))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(r){const n=[];let a=0;const f=(O,H)=>{const re=` ${O}(${H})`;a+re.length>60?(n.push(o),o="|                 ",a=o.length):a+=re.length,o+=re};let o="|      File types:";const c=10,D=r.fileTypes.length>c?c:r.fileTypes.length;for(let O=0;O<D;O++){const H=r.fileTypes[O];f(H.name,H.count)}if(n.push(o),r.configFiles.length>=0&&(o="|      Conf files:",a=0,r.configFiles.forEach(O=>{f(O.name,O.count)}),n.push(o)),r.launchConfigFiles.length>0){let O="|      Launch Configs:";r.launchConfigFiles.forEach(H=>{O+=H.count>1?` ${H.name}(${H.count})`:` ${H.name}`}),n.push(O)}return n.join(`
`)}expandGPUFeatures(r){const n=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${r[s]}`).join(`
                  `)}formatWorkspaceMetadata(r){const n=[],s=[];return r.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(f=>{const o=E.URI.revive(f);if(o.scheme===I.Schemas.file){const c=o.fsPath;s.push(m(c,["node_modules",".git"]).then(D=>{let O=`${D.fileCount} files`;D.maxFilesReached&&(O=`more than ${O}`),n.push(`|    Folder (${(0,k.basename)(c)}): ${O}`),n.push(this.formatWorkspaceStats(D))}).catch(D=>{n.push(`|      Error: Unable to collect workspace stats for folder ${c} (${D.toString()})`)}))}else n.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(r,n){const s=new Map;r.windows.forEach(f=>s.set(f.pid,f.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(r.mainPID,s,a,n,0),a.join(`
`)}formatProcessItem(r,n,s,a,f){const o=f===0;let c;o?c=a.pid===r?`${this.productService.applicationName} main`:"remote agent":(c=`${"  ".repeat(f)} ${a.name}`,a.name==="window"&&(c=`${c} (${n.get(a.pid)})`));const D=process.platform==="win32"?a.mem:y.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(D/w.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${c}`),Array.isArray(a.children)&&a.children.forEach(O=>this.formatProcessItem(r,n,s,O,f+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:s}of r.folders){const a=E.URI.revive(s);if(a.scheme!==I.Schemas.file)continue;const f=a.fsPath;try{(await m(f,["node_modules",".git"])).fileTypes.forEach(c=>n.add(c.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const s=E.URI.revive(n);if(s.scheme!==I.Schemas.file)continue;const a=s.fsPath;try{const f=await m(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),f.fileTypes.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),f.launchConfigFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),f.configFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};h=Ae([_e(0,g.ITelemetryService),_e(1,d.IProductService)],h),e.DiagnosticsService=h}),define(we[42],ye([1,0,22,91,13,24,113,33]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(s,a){return Promise.resolve(void 0)}publicLog2(s,a){return this.publicLog(s,a)}publicLogError(s,a){return Promise.resolve(void 0)}publicLogError2(s,a){return this.publicLogError(s,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class C{async publicLog(s,a,f){}async publicLogError(s,a,f){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function T(n,s){return s.onDidChangeConfiguration(a=>{a.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,I.ConfigurationTargetToString)(a.source),configurationKeys:m(a.sourceConfig)})})}e.configurationTelemetry=T;function R(n,s){return!(s.disableTelemetry||!n.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=R;function S(n){const s=n.getValue(b.TELEMETRY_SETTING_ID),a=n.getValue("telemetry.enableCrashReporter");if(n.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function w(n){const s={},a={},f={};p(n,f);for(let o in f){o=o.length>150?o.substr(o.length-149):o;const c=f[o];typeof c=="number"?a[o]=c:typeof c=="boolean"?a[o]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${c.length}`),s[o]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(s[o]=c)}return{properties:s,measurements:a}}e.validateTelemetryData=w;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function g(n){if(!n)return"none";for(const s of d)if(n.startsWith(`${s}+`))return s;return"other"}e.cleanRemoteAuthority=g;function p(n,s,a=0,f){if(!!n)for(const o of Object.getOwnPropertyNames(n)){const c=n[o],D=f?f+o:o;Array.isArray(c)?s[D]=(0,y.safeStringify)(c):c instanceof Date?s[D]=c.toISOString():(0,P.isObject)(c)?a<2?p(c,s,a+1,D+"."):s[D]=(0,y.safeStringify)(c):s[D]=c}}function m(n){if(!n)return[];const s=[];return v(s,"",n),s}function v(n,s,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(f=>v(n,s?`${s}.${f}`:f,a[f])):n.push(s)}function u(n,s){const a=n.msftInternalDomains||[],f=s.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(a)||f}e.isInternalTelemetry=u;function l(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=l;function h(n,s){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let a=n;const f=[];for(const O of s)for(;;){const H=O.exec(n);if(!H)break;f.push([H.index,O.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(a="";;){const O=c.exec(n);if(!O)break;const H=f.some(([re,ce])=>O.index<ce&&re<c.lastIndex);!o.test(O[0])&&!H&&(a+=n.substring(D,O.index)+"<REDACTED: user-file-path>",D=c.lastIndex)}return D<n.length&&(a+=n.substr(D)),a}function i(n){if(!n)return n;const s=n.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of a)if(f.regex.test(s))return`<REDACTED: ${f.label}>`;return n}function r(n,s){return(0,y.cloneAndChange)(n,a=>{if(typeof a=="string"){let f=a;f=h(f,s);for(const o of s)f=f.replace(o,"");return f=i(f),f}})}e.cleanData=r}),define(we[225],ye([1,0,196,42]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function P(I,k,b,E,C,T,R){const S={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${k.nameShort})`};if((0,t.supportsTelemetry)(k,b)&&(0,t.getTelemetryLevel)(E)===3){const w=await(0,y.getServiceMachineId)(b,C,T),{sessionId:d}=await R.getTelemetryInfo();S["X-Market-User-Id"]=w,S["VSCode-SessionId"]=d}return S}e.resolveMarketplaceHeaders=P}),define(we[226],ye([1,0,10,22,42]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function k(E,C,T){const R=await new Promise((p,m)=>{se(["@microsoft/1ds-core-js"],p,m)}),S=await new Promise((p,m)=>{se(["@microsoft/1ds-post-js"],p,m)}),w=new R.AppInsightsCore,d=new S.PostChannel,g={instrumentationKey:E,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(T){g.extensionConfig={};const p={alwaysUseXhrOverride:!0,httpXHROverride:T};g.extensionConfig[d.identifier]=p}return w.initialize(g,[]),w.addTelemetryInitializer(p=>{C&&(p.ext=p.ext??{},p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),w}class b{constructor(C,T,R,S,w){this._isInternalTelemetry=C,this._eventPrefix=T,this._defaultData=R,this._xhrOverride=w,this.endPointUrl=I,this._defaultData||(this._defaultData={}),typeof S=="function"?this._aiCoreOrKey=S():this._aiCoreOrKey=S,this._asyncAiCore=null}_withAIClient(C){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){C(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=k(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(T=>{C(T)},T=>{(0,y.onUnexpectedError)(T),console.error(T)})}}log(C,T){if(!this._aiCoreOrKey)return;T=(0,t.mixin)(T,this._defaultData),T=(0,P.validateTelemetryData)(T);const R=this._eventPrefix+"/"+C;try{this._withAIClient(S=>{S.pluginVersionString=T?.properties.version??"Unknown",S.track({name:R,baseData:{name:R,properties:T?.properties,measurements:T?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(C=>{this._withAIClient(T=>{T.unload(!0,()=>{this._aiCoreOrKey=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=b}),define(we[227],ye([1,0,2,22,91,3,15,180,24,51,50,26,34,33,42]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(v,u,l){this._configurationService=u,this._productService=l,this._experimentProperties={},this.telemetryLevel=new P.MutableObservableValue(3),this._disposables=new y.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(h),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,u){this._experimentProperties[v]=u}_updateTelemetryLevel(){let v=(0,d.getTelemetryLevel)(this._configurationService);const u=this._productService.enabledTelemetryLevels;if(u){this._sendErrorTelemetry=this.sendErrorTelemetry?u.error:!1;const l=u.usage?3:u.error?2:0;v=Math.min(v,l)}this.telemetryLevel.value=v}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const v=await this._commonProperties,u=v.sessionID,l=v["common.machineId"],h=v["common.firstSessionDate"],i=v["common.msftInternal"];return{sessionId:u,machineId:l,firstSessionDate:h,msftInternal:i}}dispose(){this._disposables.dispose()}_log(v,u,l,h){return this.telemetryLevel.value<u?Promise.resolve(void 0):this._commonProperties.then(i=>{l=(0,t.mixin)(l,this._experimentProperties),l=(0,d.cleanData)(l,this._cleanupPatterns),l=(0,t.mixin)(l,i),this._appenders.forEach(r=>r.log(v,l))},i=>{console.error(i)})}publicLog(v,u,l){return this._log(v,3,u,l)}publicLog2(v,u,l){return this.publicLog(v,u,l)}publicLogError(v,u){return this._sendErrorTelemetry?this._log(v,2,u,!0):Promise.resolve(void 0)}publicLogError2(v,u){return this.publicLogError(v,u)}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=Ae([_e(1,E.IConfigurationService),_e(2,R.IProductService)],g),e.TelemetryService=g;function p(){const m=(0,b.localize)(0,null,T.default.nameLong),v=T.default.privacyStatementUrl?(0,b.localize)(2,null,"https://aka.ms/vscode-telemetry",T.default.privacyStatementUrl):(0,b.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=I.isWeb?"":(0,b.localize)(3,null),l=(0,b.localize)(4,null),h=(0,b.localize)(5,null),i=(0,b.localize)(6,null),r=(0,b.localize)(7,null),n=`
|       | ${l} | ${h} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,b.localize)(8,null);return`
${m} ${v} ${u}

&nbsp;

${r}
${n}

&nbsp;

${s}
`}S.Registry.as(C.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,b.localize)(10,null),(0,b.localize)(11,null),(0,b.localize)(12,null),(0,b.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(C.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:T.default.privacyStatementUrl?(0,b.localize)(16,null,T.default.nameLong,T.default.privacyStatementUrl):(0,b.localize)(15,null,T.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(we[228],ye([1,0,24,5,26,33,227,42]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let E=class extends k.TelemetryService{constructor(T,R,S,w){super(T,S,w),this._injectedTelemetryLevel=R}publicLog(T,R,S){return this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(T,R,S)}publicLog2(T,R,S){return this.publicLog(T,R,S)}publicLogError(T,R){return this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(T,R)}publicLogError2(T,R){return this.publicLogError(T,R)}async updateInjectedTelemetryLevel(T){if(T===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,T):T,this._injectedTelemetryLevel===0&&this.dispose()}};E=Ae([_e(2,y.IConfigurationService),_e(3,P.IProductService)],E),e.ServerTelemetryService=E,e.ServerNullTelemetryService=new class extends b.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(I.ITelemetryService)}),define(we[229],ye([1,0,274,226]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class P extends t.AbstractOneDataSystemAppender{constructor(k,b,E,C){const T={sendPOST:(R,S)=>{const w={method:"POST",headers:{...R.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(R.data)}};try{const d=y.request(R.urlString,w,g=>{g.on("data",function(p){S(g.statusCode??200,g.headers,p.toString())}),g.on("error",function(p){S(0,{})})});d.write(R.data),d.end()}catch{S(0,{})}}};super(k,b,E,C,T)}}e.OneDataSystemAppender=P}),define(we[230],ye([1,0,10,222]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class P extends t.default{installErrorListeners(){(0,y.setUnexpectedErrorHandler)(b=>console.error(b));const k=[];process.on("unhandledRejection",(b,E)=>{k.push(E),setTimeout(()=>{const C=k.indexOf(E);C>=0&&E.catch(T=>{k.splice(C,1),(0,y.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),b&&(0,y.onUnexpectedError)(b))})},1e3)}),process.on("rejectionHandled",b=>{const E=k.indexOf(b);E>=0&&k.splice(E,1)}),process.on("uncaughtException",b=>{(0,y.onUnexpectedError)(b)})}}e.default=P}),define(we[231],ye([1,0,14,20,7,2,12]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let b=class extends I.Disposable{constructor(C,T){super(),this._logService=T,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new P.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=C===void 0?15e3:C}createRequest(C){return new Promise((T,R)=>{const S=++this._lastRequestId;this._pendingRequests.set(S,T),this._onCreateRequest.fire({requestId:S,...C});const w=new t.CancellationTokenSource;(0,y.timeout)(this._timeout,w.token).then(()=>R(`Request ${S} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(S,[(0,I.toDisposable)(()=>w.cancel())])})}acceptReply(C,T){const R=this._pendingRequests.get(C);R?(this._pendingRequests.delete(C),(0,I.dispose)(this._pendingRequestDisposables.get(C)||[]),this._pendingRequestDisposables.delete(C),R(T)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${C}`)}};b=Ae([_e(1,k.ILogService)],b),e.RequestStore=b}),define(we[114],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(u){u.Shell="terminal.integrated.shell.",u.ShellArgs="terminal.integrated.shellArgs.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var P;(function(u){u.ShellLinux="terminal.integrated.shell.linux",u.ShellMacOs="terminal.integrated.shell.osx",u.ShellWindows="terminal.integrated.shell.windows",u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationShellLinux="terminal.integrated.automationShell.linux",u.AutomationShellMacOs="terminal.integrated.automationShell.osx",u.AutomationShellWindows="terminal.integrated.automationShell.windows",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ShellArgsLinux="terminal.integrated.shellArgs.linux",u.ShellArgsMacOs="terminal.integrated.shellArgs.osx",u.ShellArgsWindows="terminal.integrated.shellArgs.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.SmoothScrolling="terminal.integrated.smoothScrolling"})(P=e.TerminalSettingId||(e.TerminalSettingId={}));var I;(function(u){u.FileName="ptyhost"})(I=e.TerminalLogConstants||(e.TerminalLogConstants={}));var k;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(k=e.PosixShellType||(e.PosixShellType={}));var b;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(b=e.WindowsShellType||(e.WindowsShellType={}));var E;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(E=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.Log="log",u.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,y.createDecorator)("ptyService");var T;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(T=e.ProcessPropertyType||(e.ProcessPropertyType={}));var R;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var S;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(S=e.TerminalLocation||(e.TerminalLocation={}));var w;(function(u){u.TerminalView="view",u.Editor="editor"})(w=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var g;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(g=e.FlowControlConstants||(e.FlowControlConstants={}));var p;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(p=e.ProfileSource||(e.ProfileSource={}));var m;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(m=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var v;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(v=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(we[232],ye([1,0,3]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function t(k){let b=k;b.indexOf("\\")!==0&&(b=b.replace(/\\/g,"\\\\"));const E=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return b=b.replace(E,""),`'${b}'`}e.escapeNonWindowsPath=t;function P(k,b,E){if(!k)return"";if(!b)return k;b.match(/[\/\\]$/)&&(b=b.slice(0,b.length-1));const C=k.replace(/\\/g,"/").toLowerCase(),T=b.replace(/\\/g,"/").toLowerCase();return C.includes(T)?`~${E}${k.slice(b.length+1)}`:k}e.collapseTildePath=P;function I(k){return k.match(/^['"].*['"]$/)&&(k=k.substring(1,k.length-1)),y.OS===1&&k&&k[1]===":"?k[0].toUpperCase()+k.substring(1):k}e.sanitizeCwd=I}),define(we[233],ye([1,0,29,11,22,6,3,27,15,13,21]),function(se,e,y,t,P,I,k,b,E,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function R(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let h=0;return l&&l.length===4&&(h=parseInt(l[3])),h}e.getWindowsBuildNumber=R;async function S(l,h,i,r=b.env,n=T.Promises.exists){if(I.isAbsolute(l))return await n(l)?l:void 0;if(h===void 0&&(h=b.cwd()),I.dirname(l)!=="."){const o=I.join(h,l);return await n(o)?o:void 0}const a=(0,P.getCaseInsensitive)(r,"PATH");if(i===void 0&&(0,C.isString)(a)&&(i=a.split(I.delimiter)),i===void 0||i.length===0){const o=I.join(h,l);return await n(o)?o:void 0}for(const o of i){let c;if(I.isAbsolute(o)?c=I.join(o,l):c=I.join(h,o,l),await n(c))return c;if(k.isWindows){let D=c+".com";if(await n(D)||(D=c+".exe",await n(D)))return D}}const f=I.join(h,l);return await n(f)?f:void 0}e.findExecutable=S;function w(l,h,i,r,n){if(!h.shellIntegration.enabled||!l.executable||l.isFeatureTerminal||l.hideFromUser||l.ignoreShellIntegration||k.isWindows&&!h.windowsEnableConpty)return;const s=l.args,a=b.platform==="win32"?I.basename(l.executable).toLowerCase():I.basename(l.executable),f=I.dirname(t.FileAccess.asFileUri("",se).fsPath);let o;const c={VSCODE_INJECTION:"1"};if(k.isWindows){if(a==="pwsh.exe")return!s||v(s)?o=e.shellIntegrationArgs.get(d.WindowsPwsh):m(s)&&(o=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),o?(o=[...o],o[o.length-1]=(0,E.format)(o[o.length-1],f,""),{newArgs:o,envMixin:c}):void 0;r.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(a){case"bash":return!s||s.length===0?o=e.shellIntegrationArgs.get(d.Bash):u(s)&&(c.VSCODE_SHELL_LOGIN="1",o=e.shellIntegrationArgs.get(d.Bash)),o?(o=[...o],o[o.length-1]=(0,E.format)(o[o.length-1],f),{newArgs:o,envMixin:c}):void 0;case"pwsh":return!s||v(s)?o=e.shellIntegrationArgs.get(d.Pwsh):m(s)&&(o=e.shellIntegrationArgs.get(d.PwshLogin)),o?(o=[...o],o[o.length-1]=(0,E.format)(o[o.length-1],f,""),{newArgs:o,envMixin:c}):void 0;case"zsh":{if(!s||s.length===0?o=e.shellIntegrationArgs.get(d.Zsh):u(s)?o=e.shellIntegrationArgs.get(d.ZshLogin):(s===e.shellIntegrationArgs.get(d.Zsh)||s===e.shellIntegrationArgs.get(d.ZshLogin))&&(o=s),!o)return;o=[...o],o[o.length-1]=(0,E.format)(o[o.length-1],f);const D=I.join(y.tmpdir(),`${y.userInfo().username}-${n.applicationName}-zsh`);c.ZDOTDIR=D;const O=i?.ZDOTDIR??y.homedir()??"~";c.USER_ZDOTDIR=O;const H=[];return H.push({source:I.join(f,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:I.join(D,".zshrc")}),H.push({source:I.join(f,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:I.join(D,".zprofile")}),H.push({source:I.join(f,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:I.join(D,".zshenv")}),H.push({source:I.join(f,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:I.join(D,".zlogin")}),{newArgs:o,envMixin:c,filesToCopy:H}}}r.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}e.getShellIntegrationInjection=w;var d;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const g=["-login","-l"],p=["-nol","-nologo"];function m(l){return typeof l=="string"?g.includes(l.toLowerCase()):l.length===1&&g.includes(l[0].toLowerCase())||l.length===2&&(g.includes(l[0].toLowerCase())||g.includes(l[1].toLowerCase()))&&(p.includes(l[0].toLowerCase())||p.includes(l[1].toLowerCase()))}function v(l){return typeof l=="string"?p.includes(l.toLowerCase()):l.length===0||l?.length===1&&p.includes(l[0].toLowerCase())}function u(l){return l==="string"&&g.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&g.includes(l[0].toLowerCase())}}),define(we[234],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var y;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST_DARK="hcDark",I.HIGH_CONTRAST_LIGHT="hcLight"})(y=e.ColorScheme||(e.ColorScheme={}));function t(I){return I===y.HIGH_CONTRAST_DARK||I===y.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function P(I){return I===y.DARK||I===y.HIGH_CONTRAST_DARK}e.isDark=P}),define(we[115],ye([1,0,40,7,2,5,34,234]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,I.createDecorator)("themeService");var E;(function(p){function m(v){return v&&typeof v=="object"&&typeof v.id=="string"}p.isThemeColor=m})(E=e.ThemeColor||(e.ThemeColor={}));function C(p){return{id:p}}e.themeColorFromId=C;var T;(function(p){function m(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||E.isThemeColor(s.color))}p.isThemeIcon=m;const v=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function u(s){const a=v.exec(s);if(!a)return;const[,f]=a;return{id:f}}p.fromString=u;function l(s){return{id:s}}p.fromId=l;function h(s,a){let f=s.id;const o=f.lastIndexOf("~");return o!==-1&&(f=f.substring(0,o)),a&&(f=`${f}~${a}`),{id:f}}p.modify=h;function i(s){const a=s.id.lastIndexOf("~");if(a!==-1)return s.id.substring(a+1)}p.getModifier=i;function r(s,a){return s.id===a.id&&s.color?.id===a.color?.id}p.isEqual=r;function n(s,a){return{id:s.id,color:a?C(a):void 0}}p.asThemeIcon=n,p.asClassNameArray=y.CSSIcon.asClassNameArray,p.asClassName=y.CSSIcon.asClassName,p.asCSSSelector=y.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=y.Codicon.file,e.FolderThemeIcon=y.Codicon.folder;function R(p){switch(p){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=R,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,P.toDisposable)(()=>{const v=this.themingParticipants.indexOf(m);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const w=new S;k.Registry.add(e.Extensions.ThemingContribution,w);function d(p){return w.onColorThemeChange(p)}e.registerThemingParticipant=d;class g extends P.Disposable{constructor(m){super(),this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,v){let u=this.theme.getColor(m);return u&&v&&(u=v(u,this.theme)),u?u.toString():null}}e.Themable=g}),define(we[235],ye([1,0,40,4,182,115]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(S,w){const d=[{name:null,description:(0,P.localize)(0,null)}];return d.push(...S.map(g=>({name:g.profileName,description:b(g)}))),w&&d.push(...w.map(g=>({name:g.title,description:E(g)}))),{values:d.map(g=>g.name),markdownDescriptions:d.map(g=>g.description)}}e.createProfileSchemaEnums=k;function b(S){let w=`$(${I.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:y.Codicon.terminal.id}) ${S.profileName}
- path: ${S.path}`;return S.args&&(typeof S.args=="string"?w+=`
- args: "${S.args}"`:w+=`
- args: [${S.args.length===0?"":`'${S.args.join("','")}'`}]`),S.overrideName!==void 0&&(w+=`
- overrideName: ${S.overrideName}`),S.color&&(w+=`
- color: ${S.color}`),S.env&&(w+=`
- env: ${JSON.stringify(S.env)}`),w}function E(S){return`$(${I.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:y.Codicon.terminal.id}) ${S.title}
- extensionIdentifier: ${S.extensionIdentifier}`}function C(S,w){if(!S&&!w)return!0;if(typeof S=="string"&&typeof w=="string")return S===w;if(Array.isArray(S)&&Array.isArray(w)){if(S.length!==w.length)return!1;for(let d=0;d<S.length;d++)if(S[d]!==w[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=C;function T(S,w){if(!S&&!w)return!0;if(!S||!w)return!1;if(I.ThemeIcon.isThemeIcon(S)&&I.ThemeIcon.isThemeIcon(w))return S.id===w.id&&S.color===w.color;if(typeof S=="object"&&"light"in S&&"dark"in S&&typeof w=="object"&&"light"in w&&"dark"in w){const d=S,g=w;if((t.URI.isUri(d.light)||R(d.light))&&(t.URI.isUri(d.dark)||R(d.dark))&&(t.URI.isUri(g.light)||R(g.light))&&(t.URI.isUri(g.dark)||R(g.dark)))return d.light.path===g.light.path&&d.dark.path===g.dark.path}if(t.URI.isUri(S)&&t.URI.isUri(w)||R(S)||R(w)){const d=S,g=w;return d.path===g.path&&d.scheme===g.scheme}return!1}e.terminalIconsEqual=T;function R(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}e.isUriComponents=R}),define(we[236],ye([1,0,40,181,51,34,235]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(y.Codicon.getAll(),l=>l.id),markdownEnumDescriptions:Array.from(y.Codicon.getAll(),l=>`$(${l.id})`)};const b={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),...e.terminalIconSchema},color:{description:(0,t.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...b}},C={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...b}},T=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),R=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),S=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),w=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),g=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),p={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:S},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...b}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...b}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...b}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...b}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){I.Registry.as(P.Extensions.Configuration).registerConfiguration(p),u()}e.registerTerminalPlatformConfiguration=m;let v;function u(l,h){const i=I.Registry.as(P.Extensions.Configuration);let r;l&&(r=(0,k.createProfileSchemaEnums)(l?.profiles,h));const n=v;v={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:l?.os===3?r?.values:void 0,markdownEnumDescriptions:l?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:l?.os===2?r?.values:void 0,markdownEnumDescriptions:l?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:l?.os===1?r?.values:void 0,markdownEnumDescriptions:l?.os===1?r?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[v],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=u}),define(we[237],ye([1,0,48,40,6,3,21,95,233,115]),function(se,e,y,t,P,I,k,b,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let T,R=!0;function S(r,n,s,a,f=process.env,o,c,D,O){return o=o||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},I.isWindows?w(s,o,f,c,a.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:a.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:a.getValue("terminal.integrated.defaultProfile.windows"),O,D):l(o,c,s,r&&typeof r=="object"?{...r}:a.getValue(I.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:a.getValue(I.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),O,D,f)}e.detectAvailableProfiles=S;async function w(r,n,s,a,f,o,c,D,O){const H=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${H?"Sysnative":"System32"}`;let ce=!1;(0,E.getWindowsBuildNumber)()>=16299&&(ce=!0),await p(D);const ae=new Map;r&&(ae.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),h(o,ae);const N=await d(ae.entries(),c,n,s,a,O);if(r||f)try{const J=await v(`${re}\\${ce?"wsl":"bash"}.exe`,c);for(const B of J)(!o||!(B.profileName in o))&&N.push(B)}catch{R&&(a?.info("WSL is not installed, so could not detect WSL profiles"),R=!1)}return N}async function d(r,n,s,a=process.env,f,o){const c=[];for(const[D,O]of r){if(O===null)continue;let H,re,ce;if("source"in O){const J=T?.get(O.source);if(!J)continue;H=J.paths,re=O.args||J.args,O.icon?ce=g(O.icon):J.icon&&(ce=J.icon)}else H=Array.isArray(O.path)?O.path:[O.path],re=I.isWindows||Array.isArray(O.args)?O.args:void 0,ce=g(O.icon);const ae=await o?.(H)||H.slice(),N=await i(D,n,ae,s,a,re,O.env,O.overrideName,O.isAutoDetected,f);N?(N.isAutoDetected=O.isAutoDetected,N.icon=ce,N.color=O.color,c.push(N)):f?.debug("Terminal profile not validated",D,H)}return f?.debug("Validated terminal profiles",c),c}function g(r){return typeof r=="string"?{id:r}:r}async function p(r){T&&!r||(T=new Map,T.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),T.set("PowerShell",{profileName:"PowerShell",paths:r||await m(),icon:C.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function m(){const r=[];for await(const n of(0,b.enumeratePowerShellInstallations)())r.push(n.exePath);return r}async function v(r,n){const s=[],a=await new Promise((c,D)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(O,H)=>{if(O)return D("Problem occurred when getting wsl distros");c(H)})});if(!a)return[];const f=new RegExp(/[\r?\n]/),o=a.split(f).filter(c=>c.trim().length>0&&c!=="");for(const c of o){if(c===""||c.startsWith("docker-desktop"))continue;const D=`${c} (WSL)`,O={profileName:D,path:r,args:["-d",`${c}`],isDefault:D===n,icon:u(c),isAutoDetected:!1};s.push(O)}return s}function u(r){return r.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):r.includes("Debian")?C.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function l(r,n,s,a,f,o,c,D){const O=new Map;if(s){const H=(await r.readFile("/etc/shells")).toString(),re=o||H.split(`
`).filter(ae=>ae.trim().indexOf("#")!==0&&ae.trim().length>0),ce=new Map;for(const ae of re){let N=(0,P.basename)(ae),J=ce.get(N)||0;J++,J>1&&(N=`${N} (${J})`),ce.set(N,J),O.set(N,{path:ae,isAutoDetected:!0})}}return h(a,O),await d(O.entries(),f,r,D,n,c)}function h(r,n){if(!!r)for(const[s,a]of Object.entries(r))a===null||!("path"in a)&&!("source"in a)?n.delete(s):(a.icon=a.icon||n.get(s)?.icon,n.set(s,a))}async function i(r,n,s,a,f,o,c,D,O,H){if(s.length===0)return Promise.resolve(void 0);const re=s.shift();if(re==="")return i(r,n,s,a,f,o,c,D,O);const ce={profileName:r,path:re,args:o,env:c,overrideName:D,isAutoDetected:O,isDefault:r===n};if((0,P.basename)(re)===re){const N=f.PATH?f.PATH.split(P.delimiter):void 0,J=await(0,E.findExecutable)(re,void 0,N,void 0,a.existsFile);return J?(ce.path=J,ce.isFromPath=!0,ce):i(r,n,s,a,f,o)}return await a.existsFile((0,P.normalize)(re))?ce:i(r,n,s,a,f,o,c,D,O)}}),define(we[238],ye([1,0,7,2,11,3,41,99,24,25,100,80,12,105,231,114,236,237]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var v;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let u=0,l=class extends t.Disposable{constructor(i,r,n,s){super(),this._reconnectConstants=i,this._configurationService=r,this._environmentService=n,this._logService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new y.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new y.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new y.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new y.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new y.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new y.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new y.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new y.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new y.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new y.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new y.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new y.Emitter),this.onProcessExit=this._onProcessExit.event,(0,p.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(I.isWindows)return process.env;try{return await(0,R.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:u,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,T.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?i.debugBrk=r.port:!r.break&&r.port&&(i.debug=r.port));const n=new b.Client(P.FileAccess.asFileUri("bootstrap-fork",se).fsPath,i);this._onPtyHostStart.fire(),k.ProxyChannel.toService(n.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(o=>{this._onPtyHostExit.fire(o.code),this._isDisposed||(this._restartCount<=v.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const a=n.getChannel(g.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(a,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(a,this._logService.getLevel())}));const f=k.ProxyChannel.toService(n.getChannel(g.TerminalIpcChannels.PtyHost));return this._register(f.onProcessData(o=>this._onProcessData.fire(o))),this._register(f.onProcessReady(o=>this._onProcessReady.fire(o))),this._register(f.onProcessExit(o=>this._onProcessExit.fire(o))),this._register(f.onDidChangeProperty(o=>this._onDidChangeProperty.fire(o))),this._register(f.onProcessReplay(o=>this._onProcessReplay.fire(o))),this._register(f.onProcessOrphanQuestion(o=>this._onProcessOrphanQuestion.fire(o))),this._register(f.onDidRequestDetach(o=>this._onDidRequestDetach.fire(o))),[n,f]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,r,n,s,a,f,o,c,D,O,H){const re=setTimeout(()=>this._handleUnresponsiveCreateProcess(),g.HeartbeatConstants.CreateProcessTimeout),ce=await this._proxy.createProcess(i,r,n,s,a,f,o,c,D,O,H);return clearTimeout(re),u=Math.max(u,ce),ce}updateTitle(i,r,n){return this._proxy.updateTitle(i,r,n)}updateIcon(i,r,n,s){return this._proxy.updateIcon(i,r,n,s)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i,r){return this._proxy.detachFromProcess(i,r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,r){return this._proxy.shutdown(i,r)}input(i,r){return this._proxy.input(i,r)}processBinary(i,r){return this._proxy.processBinary(i,r)}resize(i,r,n){return this._proxy.resize(i,r,n)}acknowledgeDataEvent(i,r){return this._proxy.acknowledgeDataEvent(i,r)}setUnicodeVersion(i,r){return this._proxy.setUnicodeVersion(i,r)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,r){return this._proxy.installAutoReply(i,r)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,r,n,s=!1){const a=await this._shellEnv;return(0,m.detectAvailableProfiles)(r,n,s,this._configurationService,a,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i){return this._proxy.getWslPath(i)}getRevivedPtyNewId(i){return this._proxy.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,r){return this._proxy.requestDetachInstance(i,r)}async acceptDetachInstanceReply(i,r){return this._proxy.acceptDetachInstanceReply(i,r)}async freePortKillProcess(i){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(i)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,r){return this._proxy.reviveTerminalProcesses(i,r)}async refreshProperty(i,r){return this._proxy.refreshProperty(i,r)}async updateProperty(i,r,n){return this._proxy.updateProperty(i,r,n)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:r})}async acceptPtyHostResolvedVariables(i,r){this._resolveVariablesRequestStore.acceptReply(i,r)}};l=Ae([_e(1,E.IConfigurationService),_e(2,C.IEnvironmentService),_e(3,S.ILogService)],l),e.PtyHostService=l}),define(we[39],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,y.createDecorator)("IUriIdentityService")}),define(we[239],ye([1,0,7,2,4,25,32,17,12,39]),function(se,e,y,t,P,I,k,b,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let T=class extends t.Disposable{constructor(S,w,d,g,p){super(),this.extensionsManagementService=S,this.logService=g,this.uriIdentityService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new y.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(v=>{this.installedExtensions=v.map(u=>u.identifier),this.startTimestamp=Date.now()}),this._register(S.onInstallExtension(v=>this.onInstallExtension(v))),this._register(S.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(S.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const m=P.URI.file(d.extensionsPath);this._register(w.watch(m)),this._register(y.Event.filter(w.onDidFilesChange,v=>v.rawChanges.some(u=>this.doesChangeAffects(u,m)))(()=>this.onDidChange()))}doesChangeAffects(S,w){return S.type!==1&&S.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(S.resource),w)?!1:this.uriIdentityService.extUri.isEqual(S.resource,this.uriIdentityService.extUri.joinPath(w,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(S.resource).startsWith(".")}onInstallExtension(S){this.addInstallingExtension(S.identifier)}onDidInstallExtensions(S){for(const w of S)this.removeInstallingExtension(w.identifier),w.local&&this.addInstalledExtension(w.identifier)}onDidUninstallExtension(S){S.error||this.removeInstalledExtension(S.identifier)}addInstallingExtension(S){this.removeInstallingExtension(S),this.installingExtensions.push(S)}removeInstallingExtension(S){this.installingExtensions=this.installingExtensions.filter(w=>!(0,k.areSameExtensions)(w,S))}addInstalledExtension(S){this.installedExtensions&&(this.removeInstalledExtension(S),this.installedExtensions.push(S))}removeInstalledExtension(S){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(w=>!(0,k.areSameExtensions)(w,S)))}async onDidChange(){if(this.installedExtensions){const S=await this.extensionsManagementService.getInstalled(),w=S.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(p=>(0,k.areSameExtensions)(p,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),d=this.installedExtensions.filter(g=>this.installingExtensions.some(p=>(0,k.areSameExtensions)(p,g))?!1:S.every(p=>!(0,k.areSameExtensions)(p.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=S.map(g=>g.identifier),(w.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:w,removed:d})}}};T=Ae([_e(1,b.IFileService),_e(2,I.INativeEnvironmentService),_e(3,E.ILogService),_e(4,C.IUriIdentityService)],T),e.ExtensionsWatcher=T}),define(we[116],ye([1,0,39,197,17,19,139,7,2]),function(se,e,y,t,P,I,k,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class C{constructor(S){this.uri=S,this.time=C._clock++}touch(){return this.time=C._clock++,this}}C._clock=0;let T=class{constructor(S){this._fileService=S,this._dispooables=new E.DisposableStore,this._limit=2**16;const w=new Map,d=g=>{let p=w.get(g.scheme);return p===void 0&&(p=S.hasProvider(g)&&!this._fileService.hasCapability(g,1024),w.set(g.scheme,p)),p};this._dispooables.add(b.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(g=>{w.delete(g.scheme)})),this.extUri=new I.ExtUri(d),this._canonicalUris=new k.SkipList((g,p)=>this.extUri.compare(g,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,I.normalizePath)(S));const w=this._canonicalUris.get(S);return w?w.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new C(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((d,g)=>d[1].touch<g[1].touch?1:d[1].touch>g[1].touch?-1:0);C._clock=0,this._canonicalUris.clear();const w=this._limit*.5;for(let d=0;d<w;d++)this._canonicalUris.set(S[d][0],S[d][1].touch())}};T=Ae([_e(0,P.IFileService)],T),e.UriIdentityService=T,(0,t.registerSingleton)(y.IUriIdentityService,T,1)}),define(we[81],ye([1,0,184,6,57,19,4,5,11]),function(se,e,y,t,P,I,k,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function C(r){const n=r;return typeof n?.id=="string"&&k.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function T(r,n){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,t.basename)(r)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const s=r;if(s.configuration)return{id:s.id,configPath:s.configuration};if(s.folders.length===1)return{id:s.id,uri:s.folders[0].uri}}e.toWorkspaceIdentifier=T;function R(r){const n=r;return typeof n?.id=="string"&&k.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=R;function S(r){const n=r;if(n?.uri)return{id:n.id,uri:k.URI.revive(n.uri)};const s=r;if(s?.configPath)return{id:s.id,configPath:k.URI.revive(s.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=S;var w;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function d(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=d;function g(r){const n=r;return!!(n&&typeof n=="object"&&k.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=g;class p{constructor(n,s,a,f,o){this._id=n,this._transient=a,this._configuration=f,this._ignorePathCasing=o,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class m{constructor(n,s){this.raw=s,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,I.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function v(r){return new m({uri:r,index:0,name:(0,I.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(r,n){return I.extUriBiasedIgnorePathCase.isEqualOrParent(r,n.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function l(r){let n;return k.URI.isUri(r)?n=r:n=r.configuration,n?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=l;function h(r,n){return!u(r,n)&&!l(r)}e.isSavedWorkspace=h;function i(r){return(typeof r=="string"?(0,t.extname)(r):(0,I.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(we[37],ye([1,0,92,7,2,19,13,4,183,25,17,5,12,81,31,39,14,23,15]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function u(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&b.URI.isUri(s.location)&&b.URI.isUri(s.globalStorageHome)&&b.URI.isUri(s.settingsResource)&&b.URI.isUri(s.keybindingsResource)&&b.URI.isUri(s.tasksResource)&&b.URI.isUri(s.snippetsHome)&&((0,k.isUndefined)(s.extensionsResource)||b.URI.isUri(s.extensionsResource)))}e.isUserDataProfile=u,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,R.createDecorator)("IUserDataProfilesService");function l(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:b.URI.revive(n.location).with({scheme:s}),globalStorageHome:b.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:b.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:b.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:b.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:b.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:b.URI.revive(n.extensionsResource)?.with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=l,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function h(n,s,a,f){return{id:n,name:s,location:a,isDefault:!1,shortName:f?.shortName,globalStorageHome:(0,I.joinPath)(a,"globalStorage"),settingsResource:(0,I.joinPath)(a,"settings.json"),keybindingsResource:(0,I.joinPath)(a,"keybindings.json"),tasksResource:(0,I.joinPath)(a,"tasks.json"),snippetsHome:(0,I.joinPath)(a,"snippets"),extensionsResource:(0,I.joinPath)(a,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:f?.useDefaultFlags,isTransient:f?.transient}}e.toUserDataProfile=h;let i=class extends P.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(s,a,f,o){super(),this.environmentService=s,this.fileService=a,this.uriIdentityService=f,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap},this.profilesHome=(0,I.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(s){this.enabled!==s&&(this._profilesObject=void 0,this.enabled=s)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const s=this.enabled?this.getStoredProfiles().map(c=>h((0,I.basename)(c.location),c.name,c.location,{shortName:c.shortName,useDefaultFlags:c.useDefaultFlags})):[];let a;const f=new d.ResourceMap,o=h((0,y.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,E.localize)(0,null),this.environmentService.userRoamingDataHome);if(s.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||s.length>0||this.transientProfilesObject.profiles.length>0?o.extensionsResource:void 0}),s.length){const c=this.getStoredProfileAssociations();if(c.workspaces)for(const[D,O]of Object.entries(c.workspaces)){const H=b.URI.parse(D),re=b.URI.parse(O),ce=s.find(ae=>this.uriIdentityService.extUri.isEqual(ae.location,re));ce&&f.set(H,ce)}if(c.emptyWindow){const D=b.URI.parse(c.emptyWindow);a=s.find(O=>this.uriIdentityService.extUri.isEqual(O.location,D))}}this._profilesObject={profiles:s,workspaces:f,emptyWindow:a}}return this._profilesObject}async createTransientProfile(s){const a="Temp",f=new RegExp(`${(0,v.escapeRegExpCharacters)(a)}\\s(\\d+)`);let o=0;for(const D of this.profiles){const O=f.exec(D.name),H=O?parseInt(O[1]):0;o=H>o?H:o}const c=`${a} ${o+1}`;return this.createProfile((0,y.hash)((0,m.generateUuid)()).toString(16),c,{transient:!0},s)}async createNamedProfile(s,a,f){return this.createProfile((0,y.hash)((0,m.generateUuid)()).toString(16),s,a,f)}async createProfile(s,a,f,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=await this.doCreateProfile(s,a,f);return o&&await this.setProfileForWorkspace(o,c),c}async doCreateProfile(s,a,f){let o=this.profileCreationPromises.get(a);return o||(o=(async()=>{try{const c=this.profiles.find(H=>H.name===a||H.id===s);if(c)return c;const D=h(s,a,(0,I.joinPath)(this.profilesHome,s),f);await this.fileService.createFolder(D.location);const O=[];return this._onWillCreateProfile.fire({profile:D,join(H){O.push(H)}}),await p.Promises.settled(O),this.updateProfiles([D],[],[]),D}finally{this.profileCreationPromises.delete(a)}})(),this.profileCreationPromises.set(a,o)),o}async updateProfile(s,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let f=this.profiles.find(o=>o.id===s.id);if(!f)throw new Error(`Profile '${s.name}' does not exist`);return f=h(f.id,a.name??f.name,f.location,{shortName:a.shortName??f.shortName,transient:a.transient??f.isTransient,useDefaultFlags:a.useDefaultFlags??f.useDefaultFlags}),this.updateProfiles([],[],[f]),f}async removeProfile(s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(s.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(o=>o.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);const f=[];this._onWillRemoveProfile.fire({profile:a,join(o){f.push(o)}});try{await Promise.allSettled(f)}catch(o){this.logService.error(o)}a.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])a.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[a],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(a.location,{recursive:!0})}catch(o){this.logService.error(o)}}getOrSetProfileForWorkspace(s,a=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let f=this.getProfileForWorkspace(s);return f||(f=a,this.profiles.length>1&&this.setProfileForWorkspaceSync(s,f)),f}async setProfileForWorkspace(s,a){this.setProfileForWorkspaceSync(s,a)}setProfileForWorkspaceSync(s,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const f=this.profiles.find(o=>o.id===a.id);if(!f)throw new Error(`Profile '${a.name}' does not exist`);this.updateWorkspaceAssociation(s,f)}unsetWorkspace(s,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(s,void 0,a)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const s=await this.fileService.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(a=>a.isDirectory&&this.profiles.every(f=>!this.uriIdentityService.extUri.isEqual(f.location,a.resource))).map(a=>this.fileService.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const s=this.transientProfilesObject.profiles.filter(a=>!this.isProfileAssociatedToWorkspace(a));await Promise.allSettled(s.map(a=>this.removeProfile(a)))}getProfileForWorkspace(s){const a=this.getWorkspace(s);return b.URI.isUri(a)?this.transientProfilesObject.workspaces.get(a)??this.profilesObject.workspaces.get(a):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(s){return(0,w.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,w.isWorkspaceIdentifier)(s)?s.configPath:"empty-window"}isProfileAssociatedToWorkspace(s){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,s.location)||[...this.transientProfilesObject.workspaces.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,s.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,s.location)||[...this.profilesObject.workspaces.values()].some(a=>this.uriIdentityService.extUri.isEqual(a.location,s.location)))}updateProfiles(s,a,f){const o=[...this.profiles,...s],c=[];this.transientProfilesObject.profiles=[];for(let D of o)D.isDefault||a.some(O=>D.id===O.id)||(D=f.find(O=>D.id===O.id)??D,D.isTransient?this.transientProfilesObject.profiles.push(D):c.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.saveStoredProfiles(c),this._profilesObject=void 0,this.triggerProfilesChanges(s,a,f)}triggerProfilesChanges(s,a,f){this._onDidChangeProfiles.fire({added:s,removed:a,updated:f,all:this.profiles})}updateWorkspaceAssociation(s,a,f){f=a?.isTransient?!0:f,f||this.updateWorkspaceAssociation(s,void 0,!0);const o=this.getWorkspace(s),c=f?this.transientProfilesObject:this.profilesObject;b.URI.isUri(o)?(c.workspaces.delete(o),a&&c.workspaces.set(o,a)):c.emptyWindow=a,f||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const s={};for(const[f,o]of this.profilesObject.workspaces.entries())s[f.toString()]=o.location.toString();const a=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:s,emptyWindow:a}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(s){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(s){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=Ae([_e(0,C.IEnvironmentService),_e(1,T.IFileService),_e(2,g.IUriIdentityService),_e(3,S.ILogService)],i),e.UserDataProfilesService=i;class r extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(s){this.storedProfiles=s}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(s){this.storedProfileAssociations=s}}e.InMemoryUserDataProfilesService=r}),define(we[240],ye([1,0,18,14,20,10,7,2,3,4,164,30,32,35,12,26,33,37]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let v=class extends b.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(n,s,a,f,o){super(),this.galleryService=n,this.telemetryService=s,this.logService=a,this.productService=f,this.userDataProfilesService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this.participants=[],this._register((0,b.toDisposable)(()=>{this.installingExtensions.forEach(({task:c})=>c.cancel()),this.uninstallingExtensions.forEach(c=>c.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const s=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,R.isTargetPlatformCompatible)(a,n.allTargetPlatforms,s))}async installFromGallery(n,s={}){try{if(!this.galleryService.isEnabled())throw new R.ExtensionManagementError(T.localize(0,null),R.ExtensionManagementErrorCode.Internal);const a=await this.checkAndGetCompatibleVersion(n,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.installExtension(a.manifest,a.extension,s)}catch(a){throw h(this.telemetryService,"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(n),error:a}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(a),l(a)}}async uninstall(n,s={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,s)}async reinstallFromGallery(n){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",n.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(1,null));const s=await this.getTargetPlatform(),[a]=await this.galleryService.getExtensions([{...n.identifier,preRelease:n.preRelease}],{targetPlatform:s,compatible:!0},P.CancellationToken.None);if(!a)throw new Error(T.localize(2,null));await this.createUninstallExtensionTask(n,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(a)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,s,a){const f=re=>`${S.ExtensionKey.create(re).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!C.URI.isUri(s)){const re=this.installingExtensions.get(f(s));if(re){this.logService.info("Extensions is already requested to install",s.identifier.id);const{local:ce}=await re.task.waitUntilTaskIsFinished();return ce}a={...a,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],c=[],D=[],O=this.createInstallExtensionTask(n,s,a);C.URI.isUri(s)||this.installingExtensions.set(f(s),{task:O,waitingTasks:[]}),this._onInstallExtension.fire({identifier:O.identifier,source:s,profileLocation:a.profileLocation}),this.logService.info("Installing extension:",O.identifier.id),o.push({task:O,manifest:n});let H=!1;try{if(a.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const ce=await this.getAllDepsAndPackExtensions(O.identifier,n,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation),ae=await this.getInstalled(void 0,a.profileLocation);for(const{gallery:N,manifest:J}of ce){H=H||!!J.extensionDependencies?.some(z=>(0,S.areSameExtensions)({id:z},O.identifier));const B=f(N),x=this.installingExtensions.get(B);if(x){if(this.canWaitForTask(O,x.task)){this.logService.info("Waiting for already requested installing extension",N.identifier.id,O.identifier.id),x.waitingTasks.push(O);const z=x.task.identifier;c.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,j=>j.some(L=>(0,S.areSameExtensions)(L.identifier,z)))).then(j=>{if(!j.find(F=>(0,S.areSameExtensions)(F.identifier,z))?.local)throw new Error(`Extension ${z.id} is not installed`)}))}}else if(!ae.some(({identifier:z})=>(0,S.areSameExtensions)(z,N.identifier))){const z=this.createInstallExtensionTask(J,N,{...a,donotIncludePackAndDependencies:!0});this.installingExtensions.set(B,{task:z,waitingTasks:[O]}),this._onInstallExtension.fire({identifier:z.identifier,source:N,profileLocation:a.profileLocation}),this.logService.info("Installing extension:",z.identifier.id,O.identifier.id),o.push({task:z,manifest:J})}}}catch(ce){if(C.URI.isUri(O.source))(0,y.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",O.identifier.id,ce.message),(0,y.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",O.identifier.id,ce.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),ce}const re=o.reduce((ce,{task:ae,manifest:N})=>(ce.set(ae.identifier.id.toLowerCase(),{task:ae,manifest:N}),ce),new Map);for(;re.size;){let ce;const ae=[...re.values()].filter(({manifest:N})=>!N.extensionDependencies?.some(J=>re.has(J.toLowerCase())));ae.length?ce=re.size===1?ae:ae.filter(({task:N})=>!(N===O&&!H)):(this.logService.info("Found extensions with circular dependencies",ae.map(({task:N})=>N.identifier.id)),ce=[...re.values()]),await this.joinAllSettled(ce.map(async({task:N})=>{const J=new Date().getTime();try{const{local:B}=await N.run();if(await this.joinAllSettled(this.participants.map(x=>x.postInstall(B,N.source,a,P.CancellationToken.None))),!C.URI.isUri(N.source)){const x=N.operation===3,z=x?void 0:(new Date().getTime()-N.source.lastUpdated)/1e3;if(h(this.telemetryService,x?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(N.source),wasVerified:N.wasVerified,duration:new Date().getTime()-J,durationSinceUpdate:z}),E.isWeb&&N.operation!==3)try{await this.galleryService.reportStatistic(B.manifest.publisher,B.manifest.name,B.manifest.version,"install")}catch{}}D.push({local:B,identifier:N.identifier,operation:N.operation,source:N.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:B.isApplicationScoped})}catch(B){throw C.URI.isUri(N.source)||h(this.telemetryService,N.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(N.source),wasVerified:N.wasVerified,duration:new Date().getTime()-J,error:B}),this.logService.error("Error while installing the extension:",N.identifier.id),B}finally{re.delete(N.identifier.id.toLowerCase())}}))}return c.length&&await this.joinAllSettled(c),D.forEach(({identifier:ce})=>this.logService.info("Extension installed successfully:",ce.id)),this._onDidInstallExtensions.fire(D),D.filter(({identifier:ce})=>(0,S.areSameExtensions)(ce,O.identifier))[0].local}catch(re){if(o.forEach(({task:ce})=>ce.cancel()),D.length)try{const ce=await Promise.allSettled(D.map(({local:ae})=>this.createUninstallExtensionTask(ae,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let ae=0;ae<ce.length;ae++){const N=ce[ae],{identifier:J}=D[ae];N.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",J.id):this.logService.warn("Rollback: Error while uninstalling extension",J.id,(0,I.getErrorMessage)(N.reason))}}catch(ce){this.logService.warn("Error while rolling back extensions",(0,I.getErrorMessage)(ce),D.map(({identifier:ae})=>ae.id))}throw this._onDidInstallExtensions.fire(o.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:a.context,profileLocation:a.profileLocation}))),re}finally{for(const[re,{task:ce,waitingTasks:ae}]of this.installingExtensions.entries()){const N=ae.indexOf(O);N!==-1&&ae.splice(N,1),ae.length===0&&(ce===O||N!==-1)&&this.installingExtensions.delete(re)}}}canWaitForTask(n,s){for(const[,{task:a,waitingTasks:f}]of this.installingExtensions.entries())if(a===n&&(f.includes(s)||f.some(o=>this.canWaitForTask(o,s)))||a===s&&f[0]&&!this.canWaitForTask(n,f[0]))return!1;return!0}async joinAllSettled(n){const s=[],a=[],f=await Promise.allSettled(n);for(const o of f)o.status==="fulfilled"?s.push(o.value):a.push(o.reason);if(a.length)throw u(a);return s}async getAllDepsAndPackExtensions(n,s,a,f,o){if(!this.galleryService.isEnabled())return[];const c=await this.getInstalled(void 0,o),D=[n],O=[],H=async(re,ce)=>{const ae=ce.extensionDependencies||[],N=[...ae];if(ce.extensionPack){const J=a?c.find(B=>(0,S.areSameExtensions)(B.identifier,re)):void 0;for(const B of ce.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(x=>(0,S.areSameExtensions)({id:x},{id:B}))||N.every(x=>!(0,S.areSameExtensions)({id:x},{id:B}))&&N.push(B)}if(N.length){const J=[...D,...O.map(x=>x.gallery.identifier)],B=N.filter(x=>J.every(z=>!(0,S.areSameExtensions)(z,{id:x})));if(B.length){const x=await this.galleryService.getExtensions(B.map(z=>({id:z,preRelease:f})),P.CancellationToken.None);for(const z of x){if(J.find(F=>(0,S.areSameExtensions)(F,z.identifier)))continue;const j=ae.some(F=>(0,S.areSameExtensions)({id:F},z.identifier));let L;try{L=await this.checkAndGetCompatibleVersion(z,!1,f)}catch(F){if(F instanceof R.ExtensionManagementError&&F.code===R.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!j){this.logService.info("Skipping the packed extension as it cannot be installed",z.identifier.id);continue}else throw F}O.push({gallery:L.extension,manifest:L.manifest}),await H(L.extension.identifier,L.manifest)}}}};return await H(n,s),O}async checkAndGetCompatibleVersion(n,s,a){if((await this.getExtensionsControlManifest()).malicious.some(D=>(0,S.areSameExtensions)(n.identifier,D)))throw new R.ExtensionManagementError(T.localize(3,null,n.identifier.id),R.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const D=await this.getTargetPlatform();throw new R.ExtensionManagementError(T.localize(4,null,n.identifier.id,this.productService.nameLong,(0,R.TargetPlatformToString)(D)),R.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(n,s,a);if(o){if(a&&!s&&n.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new R.ExtensionManagementError(T.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],P.CancellationToken.None))[0]?new R.ExtensionManagementError(T.localize(6,null,n.identifier.id),R.ExtensionManagementErrorCode.ReleaseVersionNotFound):new R.ExtensionManagementError(T.localize(7,null,n.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const c=await this.galleryService.getManifest(o,P.CancellationToken.None);if(c===null)throw new R.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,R.ExtensionManagementErrorCode.Invalid);if(c.version!==o.version)throw new R.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,R.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:c}}async getCompatibleVersion(n,s,a){const f=await this.getTargetPlatform();let o=null;return!s&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(o=(await this.galleryService.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:f,compatible:!0},P.CancellationToken.None))[0]||null),!o&&await this.galleryService.isExtensionCompatible(n,a,f)&&(o=n),o||(s?o=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:f,compatible:!0},P.CancellationToken.None))[0]||null:o=await this.galleryService.getCompatibleExtension(n,a,f)),o}async uninstallExtension(n,s){const a=H=>`${H.id.toLowerCase()}${s.versionOnly?`-${n.manifest.version}`:""}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,f=this.uninstallingExtensions.get(a(n.identifier));if(f)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),f.waitUntilTaskIsFinished();const o=(H,re)=>{const ce=this.createUninstallExtensionTask(H,re);return this.uninstallingExtensions.set(a(ce.extension.identifier),ce),s.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,s.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${H.identifier.id}@${H.manifest.version}`),this._onUninstallExtension.fire({identifier:H.identifier,profileLocation:s.profileLocation,applicationScoped:H.isApplicationScoped}),ce},c=(H,re)=>{re?s.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,s.profileLocation.toString(),re.message):this.logService.error("Failed to uninstall extension:",`${H.identifier.id}@${H.manifest.version}`,re.message):s.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${H.identifier.id}@${H.manifest.version}`,s.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${H.identifier.id}@${H.manifest.version}`),h(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,S.getLocalExtensionTelemetryData)(H),error:re}),this._onDidUninstallExtension.fire({identifier:H.identifier,version:H.manifest.version,error:re?.code,profileLocation:s.profileLocation,applicationScoped:H.isApplicationScoped})},D=[],O=[];try{D.push(o(n,s));const H=await this.getInstalled(1,s.profileLocation);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const re=this.getAllPackExtensionsToUninstall(n,H);for(const ce of re)this.uninstallingExtensions.has(a(ce.identifier))?this.logService.info("Extensions is already requested to uninstall",ce.identifier.id):D.push(o(ce,s))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(D.map(re=>re.extension),H,n),await this.joinAllSettled(D.map(async re=>{try{if(await re.run(),await this.joinAllSettled(this.participants.map(ce=>ce.postUninstall(re.extension,s,P.CancellationToken.None))),re.extension.identifier.uuid)try{await this.galleryService.reportStatistic(re.extension.manifest.publisher,re.extension.manifest.name,re.extension.manifest.version,"uninstall")}catch{}c(re.extension)}catch(ce){const ae=ce instanceof R.ExtensionManagementError?ce:new R.ExtensionManagementError((0,I.getErrorMessage)(ce),R.ExtensionManagementErrorCode.Internal);throw c(re.extension,ae),ae}finally{O.push(re)}}))}catch(H){const re=H instanceof R.ExtensionManagementError?H:new R.ExtensionManagementError((0,I.getErrorMessage)(H),R.ExtensionManagementErrorCode.Internal);for(const ce of D){try{ce.cancel()}catch{}O.includes(ce)||c(ce.extension,re)}throw re}finally{for(const H of D)this.uninstallingExtensions.delete(a(H.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",H.extension.identifier.id)}}checkForDependents(n,s,a){for(const f of n){const o=this.getDependents(f,s);if(o.length){const c=o.filter(D=>!n.some(O=>(0,S.areSameExtensions)(O.identifier,D.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(f,c,a))}}}getDependentsErrorMessage(n,s,a){return a===n?s.length===1?T.localize(8,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?T.localize(9,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):T.localize(10,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?T.localize(11,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?T.localize(12,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):T.localize(13,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(n,s,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const f=n.manifest.extensionPack?n.manifest.extensionPack:[];if(f.length){const o=s.filter(D=>!D.isBuiltin&&f.some(O=>(0,S.areSameExtensions)({id:O},D.identifier))),c=[];for(const D of o)c.push(...this.getAllPackExtensionsToUninstall(D,s,a));return[...o,...c]}return[]}getDependents(n,s){return s.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(f=>(0,S.areSameExtensions)({id:f},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(n,s,a){return a.profileLocation&&(0,w.isApplicationScopedExtension)(n)&&(a={...a,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(n,s,a)}createUninstallExtensionTask(n,s){return s.profileLocation&&n.isApplicationScoped&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(n,s)}};v=Ae([_e(0,R.IExtensionGalleryService),_e(1,p.ITelemetryService),_e(2,d.ILogService),_e(3,g.IProductService),_e(4,m.IUserDataProfilesService)],v),e.AbstractExtensionManagementService=v;function u(r){const n=Array.isArray(r)?r:[r];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=u;function l(r){if(r instanceof R.ExtensionManagementError)return r;const n=new R.ExtensionManagementError(r.message,R.ExtensionManagementErrorCode.Internal);return n.stack=r.stack,n}function h(r,n,{extensionData:s,wasVerified:a,duration:f,error:o,durationSinceUpdate:c}){let D,O;o&&(o instanceof R.ExtensionManagementError?(D=o.code,o.code===R.ExtensionManagementErrorCode.Signature&&(O=o.message)):D=R.ExtensionManagementErrorCode.Internal),r.publicLog(n,{...s,wasVerified:a,success:!o,duration:f,errorcode:D,errorcodeDetail:O,durationSinceUpdate:c})}e.reportTelemetry=h;class i{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>new Promise((s,a)=>{const f=n.onCancellationRequested(()=>{f.dispose(),a(new I.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(we[54],ye([1,0,18,14,22,16,10,67,147,2,11,6,3,19,49,69,13,4,168,25,32,35,72,17,5,12,26,7,47,52,37,39,195]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m,v,u,l,h,i,r,n,s,a,f,o,c,D,O,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var re;(function(z){function j(L,F){if(L===F)return!0;const G=Object.keys(L),oe=new Set;for(const fe of Object.keys(F))oe.add(fe);if(G.length!==oe.size)return!1;for(const fe of G){if(L[fe]!==F[fe])return!1;oe.delete(fe)}return oe.size===0}z.equals=j})(re=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let ce=class extends C.Disposable{constructor(j,L,F,G,oe,fe,ee,te,_,U,Z){super(),this.systemExtensionsLocation=j,this.userExtensionsLocation=L,this.extensionsControlLocation=F,this.cacheLocation=G,this.userDataProfilesService=oe,this.extensionsProfileScannerService=fe,this.fileService=ee,this.logService=te,this.environmentService=_,this.productService=U,this.instantiationService=Z,this._onDidChangeCache=this._register(new f.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,w.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(J,(0,w.joinPath)(this.cacheLocation,h.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(J,(0,w.joinPath)(this.cacheLocation,h.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(N,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(j,L,F){const[G,oe]=await Promise.all([this.scanSystemExtensions(j),this.scanUserExtensions(L)]),fe=F?await this.scanExtensionsUnderDevelopment(j,[...G,...oe]):[];return this.dedupExtensions(G,oe,fe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(j){const L=[];L.push(this.scanDefaultSystemExtensions(!!j.useCache,j.language)),L.push(this.scanDevSystemExtensions(j.language,!!j.checkControlFile));const[F,G]=await Promise.all(L);return this.applyScanOptions([...F,...G],0,j,!1)}async scanUserExtensions(j){this.logService.trace("Started scanning user extensions");const L=await this.createExtensionScannerInput(j.profileLocation??this.userExtensionsLocation,!!j.profileLocation,1,!j.includeUninstalled,j.language);let G=await(j.useCache&&!L.devMode&&L.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(L);return G=await this.applyScanOptions(G,1,j,!0),this.logService.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(j,L){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(G=>G.scheme===T.Schemas.file).map(async G=>{const oe=await this.createExtensionScannerInput(G,!1,1,!0,j.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(oe)).map(ee=>(ee.type=L.find(te=>(0,l.areSameExtensions)(te.identifier,ee.identifier))?.type??ee.type,this.extensionsScanner.validate(ee,oe)))}))).flat();return this.applyScanOptions(F,"development",j,!0)}return[]}async scanExistingExtension(j,L,F){const G=await this.createExtensionScannerInput(j,!1,L,!0,F.language),oe=await this.extensionsScanner.scanExtension(G);return!oe||!F.includeInvalid&&!oe.isValid?null:oe}async scanOneOrMultipleExtensions(j,L,F){const G=await this.createExtensionScannerInput(j,!1,L,!0,F.language),oe=await this.extensionsScanner.scanOneOrMultipleExtensions(G);return this.applyScanOptions(oe,L,F,!0)}async scanMetadata(j){const L=(0,w.joinPath)(j,"package.json"),F=(await this.fileService.readFile(L)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(j,L){const F=(0,w.joinPath)(j,"package.json"),G=(await this.fileService.readFile(F)).value.toString(),oe=JSON.parse(G);L.isMachineScoped=L.isMachineScoped||void 0,L.isBuiltin=L.isBuiltin||void 0,L.installedTimestamp=L.installedTimestamp||void 0,oe.__metadata={...oe.__metadata,...L},await this.fileService.writeFile((0,w.joinPath)(j,"package.json"),I.VSBuffer.fromString(JSON.stringify(oe,null,"	")))}async applyScanOptions(j,L,F,G){return F.includeAllVersions||(j=this.dedupExtensions(L===0?j:void 0,L===1?j:void 0,L==="development"?j:void 0,await this.getTargetPlatform(),G)),F.includeInvalid||(j=j.filter(oe=>oe.isValid)),j.sort((oe,fe)=>{const ee=R.basename(oe.location.fsPath),te=R.basename(fe.location.fsPath);return ee<te?-1:ee>te?1:0})}dedupExtensions(j,L,F,G,oe){const fe=(te,_,U)=>{if(te.isValid&&!_.isValid)return!1;if(te.isValid===_.isValid){if(oe&&d.gt(te.manifest.version,_.manifest.version))return this.logService.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(d.eq(te.manifest.version,_.manifest.version)){if(te.type===0)return this.logService.debug(`Skipping extension ${_.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===G)return this.logService.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return U?this.logService.warn(`Overwriting user extension ${te.location.path} with ${_.location.path}.`):this.logService.debug(`Overwriting user extension ${te.location.path} with ${_.location.path}.`),!0},ee=new Map;return j?.forEach(te=>{const _=h.ExtensionIdentifier.toKey(te.identifier.id),U=ee.get(_);(!U||fe(U,te,!1))&&ee.set(_,te)}),L?.forEach(te=>{const _=h.ExtensionIdentifier.toKey(te.identifier.id),U=ee.get(_);if(!U&&j&&te.type===0){this.logService.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!U||fe(U,te,!1))&&ee.set(_,te)}),F?.forEach(te=>{const _=h.ExtensionIdentifier.toKey(te.identifier.id),U=ee.get(_);(!U||fe(U,te,!0))&&ee.set(_,te),ee.set(_,te)}),[...ee.values()]}async scanDefaultSystemExtensions(j,L){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,L),oe=await(j&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",oe.length),oe}async scanDevSystemExtensions(j,L){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const G=L?await this.getBuiltInExtensionControl():{},oe=[],fe=m.URI.file(R.normalize(R.join(T.FileAccess.asFileUri("",se).fsPath,"..",".build","builtInExtensions")));for(const te of F){const _=G[te.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":oe.push((0,w.joinPath)(fe,te.name));break;default:oe.push(m.URI.file(_));break}}const ee=await Promise.all(oe.map(async te=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(te,!1,0,!0,j))));return this.logService.trace("Scanned dev system extensions:",ee.length),(0,y.coalesce)(ee)}async getBuiltInExtensionControl(){try{const j=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(j.value.toString())}catch{return{}}}async createExtensionScannerInput(j,L,F,G,oe,fe=!0){const ee=await this.getTranslations(oe??S.language),te=await this.getMtime(j),_=L?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,U=_?await this.getMtime(_):void 0;return new ae(j,te,_,U,L,F,G,fe,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,oe,ee)}async getMtime(j){try{const L=await this.fileService.stat(j);if(typeof L.mtime=="number")return L.mtime}catch{}}};ce=Ae([_e(4,D.IUserDataProfilesService),_e(5,c.IExtensionsProfileScannerService),_e(6,r.IFileService),_e(7,s.ILogService),_e(8,u.IEnvironmentService),_e(9,a.IProductService),_e(10,n.IInstantiationService)],ce),e.AbstractExtensionsScannerService=ce;class ae{constructor(j,L,F,G,oe,fe,ee,te,_,U,Z,ie,ue,ve){this.location=j,this.mtime=L,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=G,this.profile=oe,this.type=fe,this.excludeObsolete=ee,this.validate=te,this.productVersion=_,this.productDate=U,this.productCommit=Z,this.devMode=ie,this.language=ue,this.translations=ve}static createNlsConfiguration(j){return{language:j.language,pseudo:j.language==="pseudo",devMode:j.devMode,translations:j.translations}}static equals(j,L){return(0,w.isEqual)(j.location,L.location)&&j.mtime===L.mtime&&(0,w.isEqual)(j.applicationExtensionslocation,L.applicationExtensionslocation)&&j.applicationExtensionslocationMtime===L.applicationExtensionslocationMtime&&j.profile===L.profile&&j.type===L.type&&j.excludeObsolete===L.excludeObsolete&&j.validate===L.validate&&j.productVersion===L.productVersion&&j.productDate===L.productDate&&j.productCommit===L.productCommit&&j.devMode===L.devMode&&j.language===L.language&&re.equals(j.translations,L.translations)}}let N=class extends C.Disposable{constructor(j,L,F,G,oe){super(),this.obsoleteFile=j,this.extensionsProfileScannerService=L,this.uriIdentityService=F,this.fileService=G,this.logService=oe}async scanExtensions(j){const L=j.profile?await this.scanExtensionsFromProfile(j):await this.scanExtensionsFromLocation(j);let F={};if(j.excludeObsolete&&j.type===1)try{const G=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(G)}catch{}return(0,p.isEmptyObject)(F)?L:L.filter(G=>!F[l.ExtensionKey.create(G).toString()])}async scanExtensionsFromLocation(j){const L=await this.fileService.resolve(j.location);if(!L.children?.length)return[];const F=await Promise.all(L.children.map(async G=>{if(!G.isDirectory||j.type===1&&(0,w.basename)(G.resource).indexOf(".")===0)return null;const oe=new ae(G.resource,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(oe)}));return(0,y.coalesce)(F).sort((G,oe)=>G.location.path<oe.location.path?-1:1)}async scanExtensionsFromProfile(j){let L=await this.scanExtensionsFromProfileResource(j.location,()=>!0,j);if(j.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(j.location,j.applicationExtensionslocation)){L=L.filter(G=>!G.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(j.applicationExtensionslocation,G=>!!G.metadata?.isApplicationScoped,j);L.push(...F)}return L}async scanExtensionsFromProfileResource(j,L,F){const G=await this.extensionsProfileScannerService.scanProfileExtensions(j);if(!G.length)return[];const oe=await Promise.all(G.map(async fe=>{if(L(fe)){const ee=new ae(fe.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(ee,fe.metadata)}return null}));return(0,y.coalesce)(oe)}async scanOneOrMultipleExtensions(j){try{if(await this.fileService.exists((0,w.joinPath)(j.location,"package.json"))){const L=await this.scanExtension(j);return L?[L]:[]}else return await this.scanExtensions(j)}catch(L){return this.logService.error(`Error scanning extensions at ${j.location.path}:`,(0,k.getErrorMessage)(L)),[]}}async scanExtension(j,L){try{let F=await this.scanExtensionManifest(j.location);if(F){F.publisher||(F.publisher=h.UNDEFINED_PUBLISHER),L=L??F.__metadata,delete F.__metadata;const G=(0,l.getGalleryExtensionId)(F.publisher,F.name),oe=L?.id?{id:G,uuid:L.id}:{id:G},fe=L?.isSystem?0:j.type,ee=fe===0||!!L?.isBuiltin;F=await this.translateManifest(j.location,F,ae.createNlsConfiguration(j));const te={type:fe,identifier:oe,manifest:F,location:j.location,isBuiltin:ee,targetPlatform:L?.targetPlatform??"undefined",metadata:L,isValid:!0,validations:[]};return j.validate?this.validate(te,j):te}}catch(F){j.type!==0&&this.logService.error(F)}return null}validate(j,L){let F=!0;const G=(0,i.validateExtensionManifest)(L.productVersion,L.productDate,L.location,j.manifest,j.isBuiltin);for(const[oe,fe]of G)oe===g.default.Error&&(F=!1,this.logService.error(this.formatMessage(L.location,fe)));return j.isValid=F,j.validations=G,j}async scanExtensionManifest(j){const L=(0,w.joinPath)(j,"package.json");let F;try{F=(await this.fileService.readFile(L)).value.toString()}catch(oe){return(0,r.toFileOperationResult)(oe)!==1&&this.logService.error(this.formatMessage(j,(0,v.localize)(0,null,L.path,oe.message))),null}let G;try{G=JSON.parse(F)}catch{const fe=[];(0,b.parse)(F,fe);for(const ee of fe)this.logService.error(this.formatMessage(j,(0,v.localize)(1,null,L.path,ee.offset,ee.length,(0,E.getParseErrorMessage)(ee.error))));return null}return(0,b.getNodeType)(G)!=="object"?(this.logService.error(this.formatMessage(j,(0,v.localize)(2,null,L.path))),null):G}async translateManifest(j,L,F){const G=await this.getLocalizedMessages(j,L,F);if(G)try{const oe=[],fe=await this.resolveOriginalMessageBundle(G.default,oe);if(oe.length>0)return oe.forEach(te=>{this.logService.error(this.formatMessage(j,(0,v.localize)(3,null,G.default?.path,(0,E.getParseErrorMessage)(te.error))))}),L;if((0,b.getNodeType)(G)!=="object")return this.logService.error(this.formatMessage(j,(0,v.localize)(4,null,G.default?.path))),L;const ee=G.values||Object.create(null);return(0,H.localizeManifest)(L,ee,fe)}catch{}return L}async getLocalizedMessages(j,L,F){const G=(0,w.joinPath)(j,"package.nls.json"),oe=(_,U)=>{U.forEach(Z=>{this.logService.error(this.formatMessage(j,(0,v.localize)(5,null,_?.path,(0,E.getParseErrorMessage)(Z.error))))})},fe=_=>{this.logService.error(this.formatMessage(j,(0,v.localize)(6,null,_?.path)))},ee=`${L.publisher}.${L.name}`,te=F.translations[ee];if(te)try{const _=m.URI.file(te),U=(await this.fileService.readFile(_)).value.toString(),Z=[],ie=(0,b.parse)(U,Z);return Z.length>0?(oe(_,Z),{values:void 0,default:G}):(0,b.getNodeType)(ie)!=="object"?(fe(_),{values:void 0,default:G}):{values:ie.contents?ie.contents.package:void 0,default:G}}catch{return{values:void 0,default:G}}else{if(!await this.fileService.exists(G))return;let U;try{U=await this.findMessageBundles(j,F)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const Z=(await this.fileService.readFile(U.localized)).value.toString(),ie=[],ue=(0,b.parse)(Z,ie);return ie.length>0?(oe(U.localized,ie),{values:void 0,default:U.original}):(0,b.getNodeType)(ue)!=="object"?(fe(U.localized),{values:void 0,default:U.original}):{values:ue,default:U.original}}catch{return{values:void 0,default:U.original}}}}async resolveOriginalMessageBundle(j,L){if(j)try{const F=(await this.fileService.readFile(j)).value.toString();return(0,b.parse)(F,L)}catch{}}findMessageBundles(j,L){return new Promise((F,G)=>{const oe=fe=>{const ee=(0,w.joinPath)(j,`package.nls.${fe}.json`);this.fileService.exists(ee).then(te=>{te&&F({localized:ee,original:(0,w.joinPath)(j,"package.nls.json")});const _=fe.lastIndexOf("-");_===-1?F({localized:(0,w.joinPath)(j,"package.nls.json"),original:null}):(fe=fe.substring(0,_),oe(fe))})};if(L.devMode||L.pseudo||!L.language)return F({localized:(0,w.joinPath)(j,"package.nls.json"),original:null});oe(L.language)})}formatMessage(j,L){return`[${j.path}]: ${L}`}};N=Ae([_e(1,c.IExtensionsProfileScannerService),_e(2,O.IUriIdentityService),_e(3,r.IFileService),_e(4,s.ILogService)],N);let J=class extends N{constructor(j,L,F,G,oe,fe){super(L,F,G,oe,fe),this.cacheFile=j,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new f.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(j){const L=await this.readExtensionCache();if(this.input=j,L&&L.input&&ae.equals(L.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),L.result.map(G=>(G.location=m.URI.revive(G.location),G));const F=await super.scanExtensions(j);return await this.writeExtensionCache({input:j,result:F}),F}async readExtensionCache(){try{const j=await this.fileService.readFile(this.cacheFile),L=JSON.parse(j.value.toString());return{result:L.result,input:(0,o.revive)(L.input)}}catch(j){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(j))}return null}async writeExtensionCache(j){try{await this.fileService.writeFile(this.cacheFile,I.VSBuffer.fromString(JSON.stringify(j)))}catch(L){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(L))}}async validateCache(){if(!this.input)return;const j=await this.readExtensionCache();if(!j)return;const L=j.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!P.equals(F,L))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(G){this.logService.error(G)}}};J=Ae([_e(2,c.IExtensionsProfileScannerService),_e(3,O.IUriIdentityService),_e(4,r.IFileService),_e(5,s.ILogService)],J);function B(z,j){const L=(0,l.getExtensionId)(z.manifest.publisher,z.manifest.name);return{id:L,identifier:new h.ExtensionIdentifier(L),isBuiltin:z.type===0,isUserBuiltin:z.type===1&&z.isBuiltin,isUnderDevelopment:j,extensionLocation:z.location,uuid:z.identifier.uuid,targetPlatform:z.targetPlatform,...z.manifest}}e.toExtensionDescription=B;class x extends ce{constructor(j,L,F,G,oe,fe,ee,te,_,U,Z){super(j,L,(0,w.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,w.joinPath)(G,h.MANIFEST_CACHE_FOLDER),oe,fe,ee,te,_,U,Z),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const ie=await this.fileService.readFile(m.URI.file(S.translationsConfigFile));return JSON.parse(ie.value.toString())}catch{}return Object.create(null)})()}getTranslations(j){return this.translationsPromise}}e.NativeExtensionsScannerService=x}),define(we[241],ye([1,0,48,14,38,7,2,11,6,21,12,37]),function(se,e,y,t,P,I,k,b,E,C,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let S=class extends k.Disposable{constructor(d,g){super(),this.userDataProfilesService=d,this.logService=g,this.processesLimiter=new t.Limiter(5)}async postUninstall(d){const g=this.parseScript(d,"uninstall");return g&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),p=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${p}`)))),C.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,p=>this.logService.error("Error while removing extension storage path",p))}parseScript(d,g){const p=`vscode:${g}`;if(d.location.scheme===b.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[p]=="string"){const m=d.manifest.scripts[p].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${p} should be a node script`),null):{script:(0,E.join)(d.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(d,g,p,m,v){return new Promise((u,l)=>{const h=this.start(d,g,p,v);let i;const r=n=>{i&&(clearTimeout(i),i=null),n?l(n):u(void 0)};h.on("error",n=>{r((0,P.toErrorMessage)(n)||"Unknown")}),h.on("exit",(n,s)=>{r(n?`post-${g} process exited with code ${n}`:void 0)}),m&&(i=setTimeout(()=>{i=null,h.kill(),l("timed out")},5e3))})}start(d,g,p,m){const v={silent:!0,execArgv:void 0},u=(0,y.fork)(d,[`--type=extension-post-${g}`,...p],v);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const l=I.Event.fromNodeEventEmitter(u.stdout,"data"),h=I.Event.fromNodeEventEmitter(u.stderr,"data");l(n=>this.logService.info(m.identifier.id,m.manifest.version,`post-${g}`,n)),h(n=>this.logService.error(m.identifier.id,m.manifest.version,`post-${g}`,n));const i=I.Event.any(I.Event.map(l,n=>({data:`%c${n}`,format:[""]})),I.Event.map(h,n=>({data:`%c${n}`,format:["color: red"]})));return I.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),u}getExtensionStoragePath(d){return(0,E.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};S=Ae([_e(0,R.IUserDataProfilesService),_e(1,T.ILogService)],S),e.ExtensionsLifecycle=S}),define(we[242],ye([1,0,14,7,2,45,13,157,5,37]),function(se,e,y,t,P,I,k,b,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,E.createDecorator)("storageService");var T;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(T=e.WillSaveStateReason||(e.WillSaveStateReason={}));var R;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(R=e.StorageScope||(e.StorageScope={}));var S;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));function w(v){const u=v.get(e.TARGET_KEY);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.loadKeyTargets=w;class d extends P.Disposable{constructor(u={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super(),this.options=u,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new y.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,y.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,I.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(u,l){if(l===e.TARGET_KEY){switch(u){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:u})}else this._onDidChangeValue.fire({scope:u,key:l,target:this.getKeyTargets(u)[l]})}emitWillSaveState(u){this._onWillSaveState.fire({reason:u})}get(u,l,h){return this.getStorage(l)?.get(u,h)}getBoolean(u,l,h){return this.getStorage(l)?.getBoolean(u,h)}getNumber(u,l,h){return this.getStorage(l)?.getNumber(u,h)}store(u,l,h,i){if((0,k.isUndefinedOrNull)(l)){this.remove(u,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(u,h,i),this.getStorage(h)?.set(u,l)})}remove(u,l){this.withPausedEmitters(()=>{this.updateKeyTarget(u,l,void 0),this.getStorage(l)?.delete(u)})}withPausedEmitters(u){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{u()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(u,l){const h=[],i=this.getKeyTargets(u);for(const r of Object.keys(i))i[r]===l&&h.push(r);return h}updateKeyTarget(u,l,h){const i=this.getKeyTargets(l);typeof h=="number"?i[u]!==h&&(i[u]=h,this.getStorage(l)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[u]=="number"&&(delete i[u],this.getStorage(l)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(u){switch(u){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(u){const l=this.getStorage(u);return l?w(l):Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=T.NONE){this._onWillSaveState.fire({reason:u});const l=this.getStorage(-1),h=this.getStorage(0),i=this.getStorage(1);switch(u){case T.NONE:await y.Promises.settled([l?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await y.Promises.settled([l?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.getStorage(-1)?.items??new Map,l=this.getStorage(0)?.items??new Map,h=this.getStorage(1)?.items??new Map;return m(u,l,h,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(u,l){return this.emitWillSaveState(T.NONE),(0,C.isUserDataProfile)(u)?this.switchToProfile(u,l):this.switchToWorkspace(u,l)}canSwitchProfile(u,l){return!(u.id===l.id||g(l)&&g(u))}switchData(u,l,h,i){this.withPausedEmitters(()=>{if(i)for(const[r,n]of u)l.set(r,n);else{const r=new Set;for(const[n,s]of u)r.add(n),l.get(n)!==s&&this.emitDidChangeValue(h,n);for(const[n]of l.items)r.has(n)||this.emitDidChangeValue(h,n)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function g(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=g;class p extends d{constructor(){super(),this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(u=>this.emitDidChangeValue(1,u))),this._register(this.profileStorage.onDidChangeStorage(u=>this.emitDidChangeValue(0,u))),this._register(this.applicationStorage.onDidChangeStorage(u=>this.emitDidChangeValue(-1,u)))}getStorage(u){switch(u){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(u){return!1}}e.InMemoryStorageService=p;async function m(v,u,l,h,i,r){const n=re=>{try{return JSON.parse(re)}catch{return re}},s=new Map,a=new Map;v.forEach((re,ce)=>{s.set(ce,re),a.set(ce,n(re))});const f=new Map,o=new Map;u.forEach((re,ce)=>{f.set(ce,re),o.set(ce,n(re))});const c=new Map,D=new Map;l.forEach((re,ce)=>{c.set(ce,re),D.set(ce,n(re))}),console.group(h!==i?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const O=[];if(s.forEach((re,ce)=>{O.push({key:ce,value:re})}),console.table(O),console.groupEnd(),console.log(a),h!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const re=[];f.forEach((ce,ae)=>{re.push({key:ae,value:ce})}),console.table(re),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${r})`);const H=[];c.forEach((re,ce)=>{H.push({key:ce,value:re})}),console.table(H),console.groupEnd(),console.log(D)}e.logStorage=m}),define(we[117],ye([1,0,18,20,10,3,27,13,4,24,25,30,32,72,17,12,26,53,225,242,33]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const h=I.isWeb?"web":(0,R.getTargetPlatform)(I.platform,k.arch);var i;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished",_[_.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function r(..._){return String(_.reduce((U,Z)=>U|Z,0))}var n;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class c{constructor(U=o){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(U,Z=this.state.pageSize){return new c({...this.state,pageNumber:U,pageSize:Z})}withFilter(U,...Z){const ie=[...this.state.criteria,...Z.length?Z.map(ue=>({filterType:U,value:ue})):[{filterType:U}]];return new c({...this.state,criteria:ie})}withSortBy(U){return new c({...this.state,sortBy:U})}withSortOrder(U){return new c({...this.state,sortOrder:U})}withFlags(...U){return new c({...this.state,flags:U.reduce((Z,ie)=>Z|ie,0)})}withAssetTypes(...U){return new c({...this.state,assetTypes:U})}withSource(U){return new c({...this.state,source:U})}get raw(){const{criteria:U,pageNumber:Z,pageSize:ie,sortBy:ue,sortOrder:ve,flags:$,assetTypes:Q}=this.state;return{filters:[{criteria:U,pageNumber:Z,pageSize:ie,sortBy:ue,sortOrder:ve}],assetTypes:Q,flags:$}}get searchText(){const U=this.state.criteria.filter(Z=>Z.filterType===n.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function D(_,U){const Z=(_||[]).filter(ie=>ie.statisticName===U)[0];return Z?Z.value:0}function O(_){const U="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(ie=>ie.assetType.indexOf(U)===0).reduce((ie,ue)=>{const ve=ce(_,ue.assetType);return ve&&ie.push([ue.assetType.substring(U.length),ve]),ie},[])}function H(_){if(_.properties){const U=_.properties.filter(ue=>ue.key===s.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=U.filter(ue=>Z.test(ue.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return ce(_,s.Repository)}function re(_){return{uri:`${_.fallbackAssetUri}/${s.VSIX}?redirect=true${_.targetPlatform?`&targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${s.VSIX}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}}function ce(_,U){return _.files.filter(ie=>ie.assetType===U)[0]?{uri:`${_.assetUri}/${U}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${U}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}:null}function ae(_,U){const Z=_.properties?_.properties.filter(ue=>ue.key===U):[],ie=Z.length>0&&Z[0].value;return ie?ie.split(",").map(ue=>(0,S.adoptToGalleryExtensionId)(ue)):[]}function N(_){const U=_.properties?_.properties.filter(Z=>Z.key===a.Engine):[];return U.length>0&&U[0].value||""}function J(_){const U=_.properties?_.properties.filter(Z=>Z.key===a.PreRelease):[];return U.length>0&&U[0].value==="true"}function B(_){const U=_.properties?_.properties.filter(ie=>ie.key===a.LocalizedLanguages):[],Z=U.length>0&&U[0].value||"";return Z?Z.split(","):[]}function x(_){return _.properties?.find(U=>U.key===a.SponsorLink)?.value}function z(_){return _.indexOf("preview")!==-1}function j(_){return _.targetPlatform?(0,R.toTargetPlatform)(_.targetPlatform):"undefined"}function L(_){const U=(0,y.distinct)(_.versions.map(j)),Z=!!_.tags?.includes(R.WEB_EXTENSION_TAG),ie=U.indexOf("web");return Z?ie===-1&&U.push("web"):ie!==-1&&U.splice(ie,1),U}function F(_,U){const Z=(0,R.getFallbackTargetPlarforms)(U);for(let ie=0;ie<_.length;ie++){const ue=_[ie];if(ue.version===_[ie-1]?.version){let ve=ie;const $=j(ue);if($===U)for(;ve>0&&_[ve-1].version===ue.version;)ve--;else if(Z.includes($))for(;ve>0&&_[ve-1].version===ue.version&&j(_[ve-1])!==U;)ve--;ve!==ie&&(_.splice(ie,1),_.splice(ve,0,ue))}}return _}e.sortExtensionVersions=F;function G(_,U,Z){_.telemetryData={index:U,querySource:Z}}function oe(_,U,Z){const ie=_.versions[0],ue={manifest:ce(U,s.Manifest),readme:ce(U,s.Details),changelog:ce(U,s.Changelog),license:ce(U,s.License),repository:H(U),download:re(U),icon:ce(U,s.Icon),signature:ce(U,s.Signature),coreTranslations:O(U)};return{identifier:{id:(0,S.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:U.version,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,publisherDomain:_.publisher.domain?{link:_.publisher.domain,verified:!!_.publisher.isDomainVerified}:void 0,publisherSponsorLink:x(ie),description:_.shortDescription||"",installCount:D(_.statistics,"install"),rating:D(_.statistics,"averagerating"),ratingCount:D(_.statistics,"ratingcount"),categories:_.categories||[],tags:_.tags||[],releaseDate:Date.parse(_.releaseDate),lastUpdated:Date.parse(_.lastUpdated),allTargetPlatforms:Z,assets:ue,properties:{dependencies:ae(U,a.Dependency),extensionPack:ae(U,a.ExtensionPack),engine:N(U),localizedLanguages:B(U),targetPlatform:j(U),isPreReleaseVersion:J(U)},hasPreReleaseVersion:J(ie),hasReleaseVersion:!0,preview:z(_.flags),isSigned:!!ue.signature}}let fe=class{constructor(U,Z,ie,ue,ve,$,Q,Y){this.requestService=Z,this.logService=ie,this.environmentService=ue,this.telemetryService=ve,this.fileService=$,this.productService=Q,this.configurationService=Y;const W=Q.extensionsGallery,V=W?.servicePPEUrl&&Y.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=V?W.servicePPEUrl:W?.serviceUrl,this.extensionsGallerySearchUrl=V?void 0:W?.searchUrl,this.extensionsControlUrl=W?.controlUrl,this.commonHeadersPromise=(0,v.resolveMarketplaceHeaders)(Q.version,Q,this.environmentService,this.configurationService,this.fileService,U,this.telemetryService)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,Z,ie){const ue=t.CancellationToken.isCancellationToken(Z)?{}:Z,ve=t.CancellationToken.isCancellationToken(Z)?Z:ie,$=[],Q=[],Y=[],W=[];let V=!0;for(const le of U){le.uuid?Q.push(le.uuid):$.push(le.id);const pe=!!(le.version||le.preRelease);Y.push({id:le.id,uuid:le.uuid,includePreRelease:pe}),le.version&&W.push({id:le.id,uuid:le.uuid,version:le.version}),V=V&&!!le.hasPreRelease&&!pe}if(!Q.length&&!$.length)return[];let q=new c().withPage(1,U.length);Q.length&&(q=q.withFilter(n.ExtensionId,...Q)),$.length&&(q=q.withFilter(n.ExtensionName,...$)),(ue.queryAllVersions||V)&&(q=q.withFlags(q.flags,i.IncludeVersions)),ue.source&&(q=q.withSource(ue.source));const{extensions:X}=await this.queryGalleryExtensions(q,{targetPlatform:ue.targetPlatform??h,includePreRelease:Y,versions:W,compatible:!!ue.compatible},ve);return ue.source&&X.forEach((le,pe)=>G(le,pe,ue.source)),X}async getCompatibleExtension(U,Z,ie){if((0,R.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(U,Z,ie))return U;const ue=new c().withFlags(i.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,U.identifier.uuid),{extensions:ve}=await this.queryGalleryExtensions(ue,{targetPlatform:ie,compatible:!0,includePreRelease:Z},t.CancellationToken.None);return ve[0]||null}async isExtensionCompatible(U,Z,ie){if(!(0,R.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,ie)||!Z&&U.properties.isPreReleaseVersion)return!1;let ue=U.properties.engine;if(!ue){const ve=await this.getManifest(U,t.CancellationToken.None);if(!ve)throw new Error("Manifest was not found");ue=ve.engines.vscode}return(0,w.isEngineValid)(ue,this.productService.version,this.productService.date)}async isValidVersion(U,Z,ie,ue,ve){if(!(0,R.isTargetPlatformCompatible)(j(U),ue,ve)||Z!=="any"&&J(U)!==(Z==="prerelease"))return!1;if(ie)try{const $=await this.getEngine(U);if(!(0,w.isEngineValid)($,this.productService.version,this.productService.date))return!1}catch($){return this.logService.error(`Error while getting the engine for the version ${U.version}.`,(0,P.getErrorMessage)($)),!1}return!0}async query(U,Z){let ie=U.text||"";const ue=U.pageSize??50;let ve=new c().withPage(1,ue);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(V,q,X)=>(ve=ve.withFilter(n.Category,X||q),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(V,q,X)=>(ve=ve.withFilter(n.Tag,X||q),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(ve=ve.withFilter(n.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),ve=ve.withFilter(n.SearchText,ie)),ve=ve.withSortBy(0)):U.ids?ve=ve.withFilter(n.ExtensionId,...U.ids):U.names?ve=ve.withFilter(n.ExtensionName,...U.names):ve=ve.withSortBy(4),typeof U.sortBy=="number"&&(ve=ve.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(ve=ve.withSortOrder(U.sortOrder)),U.source&&(ve=ve.withSource(U.source));const $=async(V,q)=>{const{extensions:X,total:le}=await this.queryGalleryExtensions(V,{targetPlatform:h,compatible:!1,includePreRelease:!!U.includePreRelease},q);return X.forEach((pe,ke)=>G(pe,(V.pageNumber-1)*V.pageSize+ke,U.source)),{extensions:X,total:le}},{extensions:Q,total:Y}=await $(ve,Z),W=async(V,q)=>{if(q.isCancellationRequested)throw new P.CancellationError;const{extensions:X}=await $(ve.withPage(V+1),q);return X};return{firstPage:Q,total:Y,pageSize:ve.pageSize,getPage:W}}async queryGalleryExtensions(U,Z,ie){const ue=U.flags;!!(U.flags&i.IncludeLatestVersionOnly)&&!!(U.flags&i.IncludeVersions)&&(U=U.withFlags(U.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(U.flags&i.IncludeLatestVersionOnly)&&!(U.flags&i.IncludeVersions)&&(U=U.withFlags(U.flags,i.IncludeLatestVersionOnly)),Z.versions?.length&&(U=U.withFlags(U.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),U=U.withFlags(U.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:ve,total:$}=await this.queryRawGalleryExtensions(U,ie);if(!(U.flags&i.IncludeLatestVersionOnly)){const V=[];for(const q of ve){const X=await this.toGalleryExtensionWithCriteria(q,Z);X&&V.push(X)}return{extensions:V,total:$}}const Y=[],W=new Map;for(let V=0;V<ve.length;V++){const q=ve[V],X={id:(0,S.getGalleryExtensionId)(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},le=(0,b.isBoolean)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(ke=>(0,S.areSameExtensions)(ke,X))?.includePreRelease;if(Z.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(L(q),Z.targetPlatform))continue;const pe=await this.toGalleryExtensionWithCriteria(q,Z);!pe||pe.properties.isPreReleaseVersion&&(!le||!pe.hasReleaseVersion)||!pe.properties.isPreReleaseVersion&&pe.properties.targetPlatform!==Z.targetPlatform&&pe.hasPreReleaseVersion?W.set(q.extensionId,V):Y.push([V,pe])}if(W.size){const V=new Date().getTime(),q=new c().withFlags(ue&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,W.size).withFilter(n.ExtensionId,...W.keys()),{extensions:X}=await this.queryGalleryExtensions(q,Z,ie);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-V,count:W.size});for(const le of X){const pe=W.get(le.identifier.uuid);Y.push([pe,le])}}return{extensions:Y.sort((V,q)=>V[0]-q[0]).map(([,V])=>V),total:$}}async toGalleryExtensionWithCriteria(U,Z){const ie={id:(0,S.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},ue=Z.versions?.find(Y=>(0,S.areSameExtensions)(Y,ie))?.version,ve=(0,b.isBoolean)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(Y=>(0,S.areSameExtensions)(Y,ie))?.includePreRelease,$=L(U),Q=F(U.versions,Z.targetPlatform);if(Z.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)($,Z.targetPlatform))return null;for(let Y=0;Y<Q.length;Y++){const W=Q[Y];if(!(ue&&W.version!==ue)){if(await this.isValidVersion(W,ve?"any":"release",Z.compatible,$,Z.targetPlatform))return oe(U,W,$);if(ue&&W.version===ue)return null}}return ue||Z.compatible?null:oe(U,U.versions[0],$)}async queryRawGalleryExtensions(U,Z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,i.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,r(i.Unpublished));const ie=await this.commonHeadersPromise,ue=JSON.stringify(U.raw),ve={...ie,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},$=new Date().getTime();let Q,Y,W=0;try{if(Q=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&U.criteria.some(q=>q.filterType===n.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:ue,headers:ve},Z),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:W};const V=await(0,m.asJson)(Q);if(V){const q=V.results[0],X=q.extensions,le=q.resultMetadata&&q.resultMetadata.filter(pe=>pe.metadataType==="ResultCount")[0];return W=le&&le.metadataItems.filter(pe=>pe.name==="TotalCount")[0].count||0,{galleryExtensions:X,total:W}}return{galleryExtensions:[],total:W}}catch(V){throw Y=V,V}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-$,success:!!Q&&(0,m.isSuccess)(Q),responseBodySize:Q?.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:Y?(0,P.isCancellationError)(Y)?"canceled":(0,P.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(W)})}}async reportStatistic(U,Z,ie,ue){if(!this.isEnabled())return;const ve=I.isWeb?this.api(`/itemName/${U}.${Z}/version/${ie}/statType/${ue==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${Z}/${ie}/stats?statType=${ue}`),$=I.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Y={...await this.commonHeadersPromise,Accept:$};try{await this.requestService.request({type:"POST",url:ve,headers:Y},t.CancellationToken.None)}catch{}}async download(U,Z,ie){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const ue=(0,S.getGalleryExtensionTelemetryData)(U),ve=new Date().getTime(),$=V=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ue,duration:V}),Q=ie===2?"install":ie===3?"update":"",Y=Q?{uri:`${U.assets.download.uri}${E.URI.parse(U.assets.download.uri).query?"&":"?"}${Q}=true`,fallbackUri:`${U.assets.download.fallbackUri}${E.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${Q}=true`}:U.assets.download,W=await this.getAsset(Y);await this.fileService.writeFile(Z,W.stream),$(new Date().getTime()-ve)}async downloadSignatureArchive(U,Z){if(!U.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const ie=await this.getAsset(U.assets.signature);await this.fileService.writeFile(Z,ie.stream)}async getReadme(U,Z){if(U.assets.readme){const ie=await this.getAsset(U.assets.readme,{},Z);return await(0,m.asTextOrError)(ie)||""}return""}async getManifest(U,Z){if(U.assets.manifest){const ie=await this.getAsset(U.assets.manifest,{},Z),ue=await(0,m.asTextOrError)(ie);return ue?JSON.parse(ue):null}return null}async getManifestFromRawExtensionVersion(U,Z){const ie=ce(U,s.Manifest);if(!ie)throw new Error("Manifest was not found");const ue={"Accept-Encoding":"gzip"},ve=await this.getAsset(ie,{headers:ue});return await(0,m.asJson)(ve)}async getCoreTranslation(U,Z){const ie=U.assets.coreTranslations.filter(ue=>ue[0]===Z.toUpperCase())[0];if(ie){const ue=await this.getAsset(ie[1]),ve=await(0,m.asTextOrError)(ue);return ve?JSON.parse(ve):null}return null}async getChangelog(U,Z){if(U.assets.changelog){const ie=await this.getAsset(U.assets.changelog,{},Z);return await(0,m.asTextOrError)(ie)||""}return""}async getAllCompatibleVersions(U,Z,ie){let ue=new c().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?ue=ue.withFilter(n.ExtensionId,U.identifier.uuid):ue=ue.withFilter(n.ExtensionName,U.identifier.id);const{galleryExtensions:ve}=await this.queryRawGalleryExtensions(ue,t.CancellationToken.None);if(!ve.length)return[];const $=L(ve[0]);if((0,R.isNotWebExtensionInWebTargetPlatform)($,ie))return[];const Q=[];await Promise.all(ve[0].versions.map(async V=>{try{await this.isValidVersion(V,Z?"any":"release",!0,$,ie)&&Q.push(V)}catch{}}));const Y=[],W=new Set;for(const V of F(Q,ie))W.has(V.version)||(W.add(V.version),Y.push({version:V.version,date:V.lastUpdated,isPreReleaseVersion:J(V)}));return Y}async getAsset(U,Z={},ie=t.CancellationToken.None){const ue=await this.commonHeadersPromise,ve={type:"GET"},$={...ue,...Z.headers||{}};Z={...Z,...ve,headers:$};const Q=U.uri,Y=U.fallbackUri,W={...Z,url:Q};try{const V=await this.requestService.request(W,ie);if(V.res.statusCode===200)return V;const q=await(0,m.asTextOrError)(V);throw new Error(`Expected 200, got back ${V.res.statusCode} instead.

${q}`)}catch(V){if((0,P.isCancellationError)(V))throw V;const q=(0,P.getErrorMessage)(V);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Q,message:q});const X={...Z,url:Y};return this.requestService.request(X,ie)}}async getEngine(U){let Z=N(U);if(!Z){const ie=await this.getManifestFromRawExtensionVersion(U,t.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");Z=ie.engines.vscode}return Z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,m.asJson)(U),ie=[],ue={};if(Z){for(const ve of Z.malicious)ie.push({id:ve});if(Z.migrateToPreRelease)for(const[ve,$]of Object.entries(Z.migrateToPreRelease))(!$.engine||(0,w.isEngineValid)($.engine,this.productService.version,this.productService.date))&&(ue[ve.toLowerCase()]={disallowInstall:!0,extension:{id:$.id,displayName:$.displayName,autoMigrate:{storage:!!$.migrateStorage},preRelease:!0}});if(Z.deprecated)for(const[ve,$]of Object.entries(Z.deprecated))$&&(ue[ve.toLowerCase()]=(0,b.isBoolean)($)?{}:$)}return{malicious:ie,deprecated:ue}}};fe=Ae([_e(1,m.IRequestService),_e(2,g.ILogService),_e(3,T.IEnvironmentService),_e(4,l.ITelemetryService),_e(5,d.IFileService),_e(6,p.IProductService),_e(7,C.IConfigurationService)],fe);let ee=class extends fe{constructor(U,Z,ie,ue,ve,$,Q,Y){super(U,Z,ie,ue,ve,$,Q,Y)}};ee=Ae([_e(0,u.IStorageService),_e(1,m.IRequestService),_e(2,g.ILogService),_e(3,T.IEnvironmentService),_e(4,l.ITelemetryService),_e(5,d.IFileService),_e(6,p.IProductService),_e(7,C.IConfigurationService)],ee),e.ExtensionGalleryService=ee;let te=class extends fe{constructor(U,Z,ie,ue,ve,$,Q){super(void 0,U,Z,ie,ue,ve,$,Q)}};te=Ae([_e(0,m.IRequestService),_e(1,g.ILogService),_e(2,T.IEnvironmentService),_e(3,l.ITelemetryService),_e(4,d.IFileService),_e(5,p.IProductService),_e(6,C.IConfigurationService)],te),e.ExtensionGalleryServiceWithNoStorageService=te}),define(we[118],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,y.createDecorator)("extensionHostStatusService");class t{constructor(){this._exitInfo=new Map}setExitInfo(I,k){this._exitInfo.set(I,k)}getExitInfo(I){return this._exitInfo.get(I)||null}}e.ExtensionHostStatusService=t}),define(we[243],ye([1,0,7,14]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function P(k){let b=0,E=0,C=0;k>=1e3&&(C=Math.floor(k/1e3),k-=C*1e3),C>=60&&(E=Math.floor(C/60),C-=E*60),E>=60&&(b=Math.floor(E/60),E-=b*60);const T=b?`${b}h`:"",R=E?`${E}m`:"",S=C?`${C}s`:"",w=k?`${k}ms`:"";return`${T}${R}${S}${w}`}e.printTime=P;class I{constructor(b,E,C,T){this._logService=b,this._reconnectionToken=E,this._onClose=new y.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=C,this.protocol=T,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${P(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${P(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${P(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(b){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${b}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${P(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const b=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),b.end(),this._onClose.fire(void 0)}acceptReconnection(b,E,C){this._remoteAddress=b,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(E,C),this.protocol.endAcceptReconnection()}}e.ManagementConnection=I}),define(we[119],ye([1,0,28,11,6,140,50]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const b=P.join(t.FileAccess.asFileUri("",se).fsPath,"nls.metadata.json"),E=new Map;function C(S){return new Promise(w=>y.exists(S,w))}function T(S,w){return C(b).then(d=>{if(!d||!k.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});const g=`${S}||${w}`;let p=E.get(g);return p||(p=I.getNLSConfiguration(k.default.commit,w,b,S).then(m=>(R.is(m)&&(m._languagePackSupport=!0),m)),E.set(g,p)),p})}e.getNLSConfiguration=T;var R;(function(S){function w(d){const g=d;return g&&typeof g._languagePackId=="string"}S.is=w})(R=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(we[120],ye([1,0,19,4,25,52,54,35,17,5,12,26,37,119]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let d=class extends k.AbstractExtensionsScannerService{constructor(p,m,v,u,l,h,i){super(t.URI.file(l.builtinExtensionsPath),t.URI.file(l.extensionsPath),(0,y.joinPath)(l.userHome,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(t.URI.file(l.userDataPath),b.MANIFEST_CACHE_FOLDER),p,m,v,u,l,h,i),this.nativeEnvironmentService=l}async getTranslations(p){const m=await(0,w.getNLSConfiguration)(p,this.nativeEnvironmentService.userDataPath);if(w.InternalNLSConfiguration.is(m))try{const v=await this.fileService.readFile(t.URI.file(m._translationsConfigFile));return JSON.parse(v.value.toString())}catch{}return Object.create(null)}};d=Ae([_e(0,S.IUserDataProfilesService),_e(1,I.IExtensionsProfileScannerService),_e(2,E.IFileService),_e(3,T.ILogService),_e(4,P.INativeEnvironmentService),_e(5,R.IProductService),_e(6,C.IInstantiationService)],d),e.ExtensionsScannerService=d}),define(we[244],ye([1,0,245,28,6,23,11,21]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const E=/^[0-9A-Za-z-]+$/;var C;(function(m){m[m.None=0]="None",m[m.Optional=1]="Optional",m[m.Mandatory=2]="Mandatory"})(C=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class T{constructor(){this.type=0}validate(v){return!0}}e.NoneServerConnectionToken=T;class R{constructor(v){this.value=v,this.type=1}validate(v){return v===this.value}}e.OptionalServerConnectionToken=R;class S{constructor(v){this.value=v,this.type=2}validate(v){return v===this.value}}e.MandatoryServerConnectionToken=S;class w{constructor(v){this.message=v}}e.ServerConnectionTokenParseError=w;async function d(m,v){const u=m["without-connection-token"],l=m["connection-token"],h=m["connection-token-file"],i=m.compatibility==="1.63";if(u)return typeof l<"u"||typeof h<"u"?new w("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new T;if(typeof h<"u"){if(typeof l<"u")return new w("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let r;try{r=t.readFileSync(h).toString().replace(/\r?\n$/,"")}catch{return new w(`Unable to read the connection token file at '${h}'.`)}return E.test(r)?new S(r):new w(`The connection token defined in '${h} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof l<"u"?E.test(l)?i?new R(l):new S(l):new w(`The connection token '${l} does not adhere to the characters 0-9, a-z, A-Z or -.`):i?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new R(await v())):new S(await v())}e.parseServerConnectionToken=d;async function g(m){return d(m,async()=>{if(!m["user-data-dir"])return(0,I.generateUuid)();const u=P.join(m["user-data-dir"],"token");try{const i=(await b.Promises.readFile(u)).toString().replace(/\r?\n$/,"");if(E.test(i))return i}catch{}const l=(0,I.generateUuid)();try{await b.Promises.writeFile(u,l,{mode:384})}catch{}return l})}e.determineServerConnectionToken=g;function p(m,v,u){if(m.validate(u.query[k.connectionTokenQueryName]))return!0;const l=y.parse(v.headers.cookie||"");return m.validate(l[k.connectionTokenCookieName])}e.requestHasValidConnectionToken=p}),define(we[43],ye([1,0,185,194,59,5,25]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:y.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:y.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:y.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:y.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:y.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:y.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:y.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:y.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:y.localize(8,null)},"user-data-dir":P.OPTIONS["user-data-dir"],"enable-smoke-test-driver":P.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":P.OPTIONS["disable-telemetry"],"disable-workspace-trust":P.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:P.OPTIONS.log,logsPath:P.OPTIONS.logsPath,"force-disable-user-env":P.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:y.localize(9,null)},"default-workspace":{type:"string",description:y.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":P.OPTIONS["extensions-dir"],"extensions-download-dir":P.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":P.OPTIONS["builtin-extensions-dir"],"install-extension":P.OPTIONS["install-extension"],"install-builtin-extension":P.OPTIONS["install-builtin-extension"],"uninstall-extension":P.OPTIONS["uninstall-extension"],"list-extensions":P.OPTIONS["list-extensions"],"locate-extension":P.OPTIONS["locate-extension"],"show-versions":P.OPTIONS["show-versions"],category:P.OPTIONS.category,force:P.OPTIONS.force,"do-not-sync":P.OPTIONS["do-not-sync"],"pre-release":P.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:y.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:P.OPTIONS.help,version:P.OPTIONS.version,"locate-shell-integration-path":P.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:P.OPTIONS._},e.IServerEnvironmentService=(0,I.refineServiceDecorator)(k.IEnvironmentService);class b extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=b}),define(we[246],ye([1,0,28,88,79,245,112,36,68,3,12,43,6,11,23,26,53,20,4,16,13,78]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m,v,u,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const i={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function r(o,c,D,O){c.writeHead(D,{"Content-Type":"text/plain"}),c.end(O)}e.serveError=r;var n;(function(o){o[o.NO_CACHING=0]="NO_CACHING",o[o.ETAG=1]="ETAG",o[o.NO_EXPIRY=2]="NO_EXPIRY"})(n=e.CacheControl||(e.CacheControl={}));async function s(o,c,D,O,H,re){try{const ce=await y.promises.stat(o);if(c===1){const ae=`W/"${[ce.ino,ce.size,ce.mtime.getTime()].join("-")}"`;if(O.headers["if-none-match"]===ae)return H.writeHead(304),void H.end();re.Etag=ae}else c===2?re["Cache-Control"]="public, max-age=31536000":c===0&&(re["Cache-Control"]="no-store");re["Content-Type"]=i[(0,S.extname)(o)]||(0,E.getMediaMime)(o)||"text/plain",H.writeHead(200,re),(0,y.createReadStream)(o).pipe(H)}catch(ce){return ce.code!=="ENOENT"?(D.error(ce),console.error(ce.toString())):console.error(`File not found: ${o}`),H.writeHead(404,{"Content-Type":"text/plain"}),void H.end("Not found")}}e.serveFile=s;const a=(0,S.dirname)(w.FileAccess.asFileUri("",se).fsPath);let f=class{constructor(c,D,O,H,re){this._connectionToken=c,this._environmentService=D,this._logService=O,this._requestService=H,this._productService=re,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?v.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0;const ce=(0,h.getRemoteServerRootPath)(re);this._staticRoute=`${ce}/static`,this._callbackRoute=`${ce}/callback`,this._webExtensionRoute=`${ce}/web-extension-resource`}async handle(c,D,O){try{const H=O.pathname;return H.startsWith(this._staticRoute)&&H.charCodeAt(this._staticRoute.length)===47?this._handleStatic(c,D,O):H==="/"?this._handleRoot(c,D,O):H===this._callbackRoute?this._handleCallback(D):H.startsWith(this._webExtensionRoute)&&H.charCodeAt(this._webExtensionRoute.length)===47?this._handleWebExtensionResource(c,D,O):r(c,D,404,"Not found.")}catch(H){return this._logService.error(H),console.error(H.toString()),r(c,D,500,"Internal Server Error.")}}async _handleStatic(c,D,O){const H=Object.create(null),ce=decodeURIComponent(O.pathname).substring(this._staticRoute.length+1),ae=(0,S.join)(a,ce);return(0,b.isEqualOrParent)(ae,a,!C.isLinux)?s(ae,this._environmentService.isBuilt?2:1,this._logService,c,D,H):r(c,D,400,"Bad request.")}_getResourceURLTemplateAuthority(c){const D=c.authority.indexOf(".");return D!==-1?c.authority.substring(D+1):void 0}async _handleWebExtensionResource(c,D,O){if(!this._webExtensionResourceUrlTemplate)return r(c,D,500,"No extension gallery service configured.");const H=decodeURIComponent(O.pathname),re=(0,S.normalize)(H.substring(this._webExtensionRoute.length+1)),ce=v.URI.parse(re).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:re.substring(0,re.indexOf("/")),path:re.substring(re.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(ce))return r(c,D,403,"Request Forbidden");const ae={},N=L=>{const F=c.headers[L];F&&((0,l.isString)(F)||F[0])?ae[L]=(0,l.isString)(F)?F:F[0]:L!==L.toLowerCase()&&N(L.toLowerCase())};N("X-Client-Name"),N("X-Client-Version"),N("X-Machine-Id"),N("X-Client-Commit");const J=await this._requestService.request({type:"GET",url:ce.toString(!0),headers:ae},m.CancellationToken.None),B=J.res.statusCode||500;if(B!==200){let L=null;try{L=await(0,p.asTextOrError)(J)}catch{}return r(c,D,B,L||`Request failed with status ${B}`)}const x=Object.create(null),z=L=>{const F=J.res.headers[L];F?x[L]=F:L!==L.toLowerCase()&&z(L.toLowerCase())};z("Cache-Control"),z("Content-Type"),D.writeHead(200,x);const j=await(0,u.streamToBuffer)(J.stream);return void D.end(j.buffer)}async _handleRoot(c,D,O){const H=O.query[w.connectionTokenQueryName];if(typeof H=="string"){const fe=Object.create(null);fe["Set-Cookie"]=I.serialize(w.connectionTokenCookieName,H,{sameSite:"lax",maxAge:60*60*24*7});const ee=Object.create(null);for(const _ in O.query)_!==w.connectionTokenQueryName&&(ee[_]=O.query[_]);const te=P.format({pathname:"/",query:ee});return fe.Location=te,D.writeHead(302,fe),void D.end()}const re=fe=>{const ee=c.headers[fe];return Array.isArray(ee)?ee[0]:ee},ce=re("x-original-host")||re("x-forwarded-host")||c.headers.host;if(!ce)return r(c,D,400,"Bad request.");function ae(fe){return JSON.stringify(fe).replace(/"/g,"&quot;")}let N;this._environmentService.args["enable-smoke-test-driver"]&&(N=!1);const J=fe=>fe&&v.URI.file(t.resolve(fe)).with({scheme:w.Schemas.vscodeRemote,authority:ce}),B=w.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",se).fsPath,x=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,d.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,z={remoteAuthority:ce,_wrapWebWorkerExtHostInIframe:N,developmentOptions:{enableSmokeTestDriver:this._environmentService.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this._logService.getLevel()},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:J(this._environmentService.args["default-folder"]),workspaceUri:J(this._environmentService.args["default-workspace"]),productConfiguration:{embedderIdentifier:"server-distro",extensionsGallery:this._webExtensionResourceUrlTemplate?{...this._productService.extensionsGallery,resourceUrlTemplate:this._webExtensionResourceUrlTemplate.with({scheme:"http",authority:ce,path:`${this._webExtensionRoute}/${this._webExtensionResourceUrlTemplate.authority}${this._webExtensionResourceUrlTemplate.path}`}).toString(!0)}:void 0},callbackRoute:this._callbackRoute},j=this._productService.extensionsGallery?.nlsBaseUrl,L={WORKBENCH_WEB_CONFIGURATION:ae(z),WORKBENCH_AUTH_SESSION:x?ae(x):"",WORKBENCH_WEB_BASE_URL:this._staticRoute,WORKBENCH_NLS_BASE_URL:j?`${j}${j.endsWith("/")?"":"/"}${this._productService.commit}/${this._productService.version}/`:""};let F;try{F=(await y.promises.readFile(B)).toString().replace(/\{\{([^}]+)\}\}/g,(ee,te)=>L[te]??"undefined")}catch{return D.writeHead(404,{"Content-Type":"text/plain"}),void D.end("Not found")}const G=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(F).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${ce};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),oe={"Content-Type":"text/html","Content-Security-Policy":G};return this._connectionToken.type!==0&&(oe["Set-Cookie"]=I.serialize(w.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),D.writeHead(200,oe),void D.end(F)}_getScriptCspHashes(c){const D=/<script>([\s\S]+?)<\/script>/img,O=[];let H;for(;H=D.exec(c);){const re=k.createHash("sha256"),ce=H[1].replace(/\r\n/g,`
`),ae=re.update(Buffer.from(ce)).digest().toString("base64");O.push(`'sha256-${ae}'`)}return O}async _handleCallback(c){const D=w.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",se).fsPath,O=(await y.promises.readFile(D)).toString(),H=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(O).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return c.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":H}),void c.end(O)}};f=Ae([_e(1,R.IServerEnvironmentService),_e(2,T.ILogService),_e(3,p.IRequestService),_e(4,g.IProductService)],f),e.WebClientServer=f}),define(we[247],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,y.createDecorator)("IExtHostRpcService");class t{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=t}),define(we[64],ye([1,0,71]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(I){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:I,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function P(I){return new y.URITransformer(t(I))}e.createURITransformer=P}),define(we[248],ye([1,0,4,64,62,6,210]),function(se,e,y,t,P,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class b extends k.AbstractDiskFileSystemProviderChannel{constructor(T,R){super(new P.DiskFileSystemProvider(T),T),this.environmentService=R,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(T){let R=this.uriTransformerCache.get(T.remoteAuthority);return R||(R=(0,t.createURITransformer)(T.remoteAuthority),this.uriTransformerCache.set(T.remoteAuthority,R)),R}transformIncoming(T,R,S=!1){if(S&&R.path==="/vscode-resource"&&R.query){const w=JSON.parse(R.query).requestResourcePath;return y.URI.from({scheme:"file",path:w})}return y.URI.revive(T.transformIncoming(R))}createSessionFileWatcher(T,R){return new E(T,R,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=b;class E extends k.AbstractSessionFileWatcher{constructor(T,R,S,w){super(T,R,S,w)}getRecursiveWatcherOptions(T){const R=T.args["file-watcher-polling"];if(R){const S=R.split(I.delimiter),w=Number(S[0]);if(w>0)return{usePolling:S.length>1?S.slice(1):!0,pollingInterval:w}}}getExtraExcludes(T){if(T.extensionsPath)return[I.posix.join(T.extensionsPath,"**")]}}}),define(we[82],ye([1,0,186,13,4,2,5,34,17,11]),function(se,e,y,t,P,I,k,b,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var T;(function(L){L[L.PROGRAMMATIC=1]="PROGRAMMATIC",L[L.USER=2]="USER",L[L.EDIT=3]="EDIT",L[L.NAVIGATION=4]="NAVIGATION",L[L.JUMP=5]="JUMP"})(T=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var R;(function(L){L[L.IDENTICAL=1]="IDENTICAL",L[L.SIMILAR=2]="SIMILAR",L[L.DIFFERENT=3]="DIFFERENT"})(R=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function S(L){const F=L;return!!F&&typeof F.getSelection=="function"&&!!F.onDidChangeSelection}e.isEditorPaneWithSelection=S;function w(L,F,G){for(const oe of G.visibleEditorPanes)if(oe.group.id===F&&L.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=w;function d(L){if(a(L))return!1;const F=L;return P.URI.isUri(F?.resource)}e.isResourceEditorInput=d;function g(L){if(a(L))return!1;const F=L;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=g;function p(L){if(a(L)||g(L))return!1;const F=L;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function m(L){if(a(L))return!1;const F=L;return F?F.resource===void 0||F.resource.scheme===C.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=m;const v=/Untitled-\d+/;function u(L){return L.scheme===C.Schemas.untitled&&L.path.length>1&&!v.test(L.path)}e.isUntitledWithAssociatedResource=u;function l(L){if(a(L))return!1;const F=L;return P.URI.isUri(F?.base?.resource)&&P.URI.isUri(F?.input1?.resource)&&P.URI.isUri(F?.input2?.resource)&&P.URI.isUri(F?.result?.resource)}e.isResourceMergeEditorInput=l;var h;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(h=e.Verbosity||(e.Verbosity={}));var i;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.mapIdToSaveSource=new Map}registerSource(F,G){let oe=this.mapIdToSaveSource.get(F);return oe||(oe={source:F,label:G},this.mapIdToSaveSource.set(F,oe)),oe.source}getSourceLabel(F){return this.mapIdToSaveSource.get(F)?.label??F}}e.SaveSourceRegistry=new r;var n;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription",L[L.CanDropIntoEditor=128]="CanDropIntoEditor",L[L.MultipleEditors=256]="MultipleEditors"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends I.Disposable{}e.AbstractEditorInput=s;function a(L){return L instanceof s}e.isEditorInput=a;function f(L){const F=L;return P.URI.isUri(F?.preferredResource)}function o(L){const F=L;return a(F?.primary)&&a(F?.secondary)}e.isSideBySideEditorInput=o;function c(L){const F=L;return a(F?.modified)&&a(F?.original)}e.isDiffEditorInput=c;function D(L){return a(L?.editor)}e.isEditorInputWithOptions=D;function O(L){const F=L;return D(L)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=O;function H(L){const F=L;return typeof F?.groupId=="number"&&a(F.editor)}e.isEditorIdentifier=H;var re;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(re=e.EditorCloseContext||(e.EditorCloseContext={}));var ce;(function(L){L[L.GROUP_ACTIVE=0]="GROUP_ACTIVE",L[L.GROUP_INDEX=1]="GROUP_INDEX",L[L.GROUP_LOCKED=2]="GROUP_LOCKED",L[L.EDITOR_OPEN=3]="EDITOR_OPEN",L[L.EDITOR_CLOSE=4]="EDITOR_CLOSE",L[L.EDITOR_MOVE=5]="EDITOR_MOVE",L[L.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",L[L.EDITOR_LABEL=7]="EDITOR_LABEL",L[L.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",L[L.EDITOR_PIN=9]="EDITOR_PIN",L[L.EDITOR_STICKY=10]="EDITOR_STICKY",L[L.EDITOR_DIRTY=11]="EDITOR_DIRTY",L[L.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(ce=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var ae;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(ae=e.SideBySideEditor||(e.SideBySideEditor={}));class N{getOriginalUri(F,G){if(!F)return;if(l(F))return e.EditorResourceAccessor.getOriginalUri(F.result,G);if(G?.supportSideBySide){const{primary:fe,secondary:ee}=this.getSideEditors(F);if(fe&&ee){if(G?.supportSideBySide===ae.BOTH)return{primary:this.getOriginalUri(fe,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===ae.ANY)return this.getOriginalUri(fe,{filterByScheme:G.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:G.filterByScheme});F=G.supportSideBySide===ae.PRIMARY?fe:ee}}if(g(F)||p(F)||l(F))return;const oe=f(F)?F.preferredResource:F.resource;return!oe||!G||!G.filterByScheme?oe:this.filterUri(oe,G.filterByScheme)}getSideEditors(F){return o(F)||p(F)?{primary:F.primary,secondary:F.secondary}:c(F)||g(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,G){if(!F)return;if(l(F))return e.EditorResourceAccessor.getCanonicalUri(F.result,G);if(G?.supportSideBySide){const{primary:fe,secondary:ee}=this.getSideEditors(F);if(fe&&ee){if(G?.supportSideBySide===ae.BOTH)return{primary:this.getCanonicalUri(fe,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===ae.ANY)return this.getCanonicalUri(fe,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:G.filterByScheme});F=G.supportSideBySide===ae.PRIMARY?fe:ee}}if(g(F)||p(F)||l(F))return;const oe=F.resource;return!oe||!G||!G.filterByScheme?oe:this.filterUri(oe,G.filterByScheme)}filterUri(F,G){if(Array.isArray(G)){if(G.some(oe=>F.scheme===oe))return F}else if(G===F.scheme)return F}}e.EditorResourceAccessor=new N;var J;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(J=e.CloseDirection||(e.CloseDirection={}));class B{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const G=this.instantiationService=F.get(k.IInstantiationService);for(const[oe,fe]of this.editorSerializerConstructors)this.createEditorSerializer(oe,fe,G);this.editorSerializerConstructors.clear()}createEditorSerializer(F,G,oe){const fe=oe.createInstance(G);this.editorSerializerInstances.set(F,fe)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,G){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,G,this.instantiationService):this.editorSerializerConstructors.set(F,G),(0,I.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}b.Registry.add(e.EditorExtensions.EditorFactory,new B);async function x(L,F,G){return!L||!L.length?[]:await Promise.all(L.map(async oe=>{const fe=P.URI.revive(oe.fileUri);if(!fe){G.info("Cannot resolve the path because it is not valid.",oe);return}if(!await F.canHandleResource(fe)){G.info("Cannot resolve the path because it cannot be handled",oe);return}let te=oe.exists,_=oe.type;if(typeof te!="boolean"||typeof _!="number")try{_=(await F.stat(fe)).isDirectory?E.FileType.Directory:E.FileType.Unknown,te=!0}catch(Z){G.error(Z),te=!1}if(!te&&oe.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",oe);return}if(_===E.FileType.Directory){G.info("Cannot resolve the path because it is a directory",oe);return}const U={...oe.options,pinned:!0};return te?{resource:fe,options:U}:{resource:fe,options:U,forceUntitled:!0}}))}e.pathsToEditors=x;var z;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function j(L){const F=L;if(!F)return!1;const G=F;if(G.modified)return j(G.modified);const oe=F;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=j}),define(we[121],ye([1,0,16,70,55,68,11,6,3,101]),function(se,e,y,t,P,I,k,b,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var T;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(x){x[x.Running=1]="Running",x[x.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var w;(function(x){x[x.WithHardKernelDependency=0]="WithHardKernelDependency",x[x.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",x[x.Pure=2]="Pure",x[x.Never=3]="Never"})(w=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var d;(function(x){x.Always="always",x.Never="never",x.Optional="optional"})(d=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(x){x[x.ModelChange=1]="ModelChange",x[x.Move=2]="Move",x[x.ChangeCellLanguage=5]="ChangeCellLanguage",x[x.Initialize=6]="Initialize",x[x.ChangeCellMetadata=7]="ChangeCellMetadata",x[x.Output=8]="Output",x[x.OutputItem=9]="OutputItem",x[x.ChangeCellContent=10]="ChangeCellContent",x[x.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",x[x.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",x[x.ChangeCellMime=13]="ChangeCellMime",x[x.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var p;(function(x){x[x.Handle=0]="Handle",x[x.Index=1]="Index"})(p=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(x){x[x.Replace=1]="Replace",x[x.Output=2]="Output",x[x.Metadata=3]="Metadata",x[x.CellLanguage=4]="CellLanguage",x[x.DocumentMetadata=5]="DocumentMetadata",x[x.Move=6]="Move",x[x.OutputItems=7]="OutputItems",x[x.PartialMetadata=8]="PartialMetadata",x[x.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var v;(function(x){x.scheme=k.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${z.join("")}]+`),L=7;function F(_,U){const Z=U.toString(L),ue=`${Z.length<z.length?z[Z.length-1]:"z"}${Z}s${(0,y.encodeBase64)(y.VSBuffer.fromString(_.scheme),!0,!0)}`;return _.with({scheme:x.scheme,fragment:ue})}x.generate=F;function G(_){if(_.scheme!==x.scheme)return;const U=_.fragment.indexOf("s");if(U<0)return;const Z=parseInt(_.fragment.substring(0,U).replace(j,""),L),ie=(0,y.decodeBase64)(_.fragment.substring(U+1)).toString();if(!isNaN(Z))return{handle:Z,notebook:_.with({scheme:ie,fragment:null})}}x.parse=G;function oe(_,U){return _.with({scheme:k.Schemas.vscodeNotebookCellOutput,fragment:`op${U??""},${_.scheme!==k.Schemas.file?_.scheme:""}`})}x.generateCellOutputUri=oe;function fe(_){if(_.scheme!==k.Schemas.vscodeNotebookCellOutput)return;const U=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!U)return;const Z=U[1]&&U[1]!==""?U[1]:void 0,ie=U[2];return{outputId:Z,notebook:_.with({scheme:ie||k.Schemas.file,fragment:null})}}x.parseCellOutputUri=fe;function ee(_,U,Z){return x.generate(_,U).with({scheme:Z})}x.generateCellPropertyUri=ee;function te(_,U){if(_.scheme===U)return x.parse(_.with({scheme:x.scheme}))}x.parseCellPropertyUri=te})(v=e.CellUri||(e.CellUri={}));const u=x=>E.isWindows?x.replace(/\//g,"\\"):x;class l{constructor(z=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=j,this.order=[...new Set(z)].map(L=>({pattern:L,matches:t.parse(u(L))}))}sort(z){const j=new Map(P.Iterable.map(z,F=>[F,u(F)]));let L=[];for(const{matches:F}of this.order)for(const[G,oe]of j)if(F(oe)){L.push(G),j.delete(G);break}return j.size&&(L=L.concat([...j.keys()].sort((F,G)=>this.defaultOrder.indexOf(F)-this.defaultOrder.indexOf(G)))),L}prioritize(z,j){const L=this.findIndex(z);if(L===-1){this.order.unshift({pattern:z,matches:t.parse(u(z))});return}const F=new Set(j.map(oe=>this.findIndex(oe,L)));F.delete(-1);const G=Array.from(F).sort();this.order.splice(L+1,0,...G.map(oe=>this.order[oe]));for(let oe=G.length-1;oe>=0;oe--)this.order.splice(G[oe],1)}toArray(){return this.order.map(z=>z.pattern)}findIndex(z,j=this.order.length){const L=u(z);for(let F=0;F<j;F++)if(this.order[F].matches(L))return F;return-1}}e.MimeTypeDisplayOrder=l;function h(x,z,j,L=(F,G)=>F===G){const F=[];function G(ee,te,_){if(te===0&&_.length===0)return;const U=F[F.length-1];U&&U.start+U.deleteCount===ee?(U.deleteCount+=te,U.toInsert.push(..._)):F.push({start:ee,deleteCount:te,toInsert:_})}let oe=0,fe=0;for(;;){if(oe===x.length){G(oe,0,z.slice(fe));break}if(fe===z.length){G(oe,x.length-oe,[]);break}const ee=x[oe],te=z[fe];if(L(ee,te)){oe+=1,fe+=1;continue}j(te)?(G(oe,1,[]),oe+=1):(G(oe,0,[te]),fe+=1)}return F}e.diff=h,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(x){x.default="default",x.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(x){const z=x;return!!((typeof z.include=="string"||t.isRelativePattern(z.include))&&(typeof z.exclude=="string"||t.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=r;function n(x,z,j){if(Array.isArray(x.viewType)&&x.viewType.indexOf(z)>=0||x.viewType===z)return!0;if(x.filenamePattern){const L=r(x.filenamePattern)?x.filenamePattern.include:x.filenamePattern,F=r(x.filenamePattern)?x.filenamePattern.exclude:void 0;if(t.match(L,(0,b.basename)(j.fsPath).toLowerCase()))return!(F&&t.match(F,(0,b.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var s;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(s=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(z){return`${a._prefix}${z}`}static parse(z){if(z.startsWith(a._prefix))return z.substring(a._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a._prefix="notebook/";function f(x){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(x)}e.isTextStreamMime=f;const o=new TextDecoder;function c(x){const z=[];let j=!1;for(const L of x)(z.length===0||j)&&(z.push(L),j=!0);return re(z),B(y.VSBuffer.concat(z.map(L=>y.VSBuffer.wrap(L))))}e.compressOutputItemStreams=c;const D=`${String.fromCharCode(27)}[A`,O=D.split("").map(x=>x.charCodeAt(0)),H=10;function re(x){x.forEach((z,j)=>{if(j===0||z.length<D.length)return;const L=x[j-1],F=z.subarray(0,D.length);if(F[0]===O[0]&&F[1]===O[1]&&F[2]===O[2]){const G=L.lastIndexOf(H);if(G===-1)return;x[j-1]=L.subarray(0,G),x[j]=z.subarray(D.length)}})}function ce(x){let z=x;do x=z,z=x.replace(/[^\n]\x08/gm,"");while(z.length<x.length);return x}function ae(x){for(x=x.replace(/\r+\n/gm,`
`);x.search(/\r[^$]/g)>-1;){const z=x.match(/^(.*)\r+/m)[1];let j=x.match(/\r+(.*)$/m)[1];j=j+z.slice(j.length,z.length),x=x.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return x}const N="\b".charCodeAt(0),J="\r".charCodeAt(0);function B(x){return!x.buffer.includes(N)&&!x.buffer.includes(J)?x:y.VSBuffer.fromString(ae(ce(o.decode(x.buffer))))}}),define(we[122],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,y.createDecorator)("environmentVariableService");var t;(function(P){P[P.Replace=1]="Replace",P[P.Append=2]="Append",P[P.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(we[249],ye([1,0,3,122]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class P{constructor(E){this.collections=E,this.map=new Map,E.forEach((C,T)=>{const R=C.map.entries();let S=R.next();for(;!S.done;){const w=S.value[0];let d=this.map.get(w);if(d||(d=[],this.map.set(w,d)),d.length>0&&d[0].type===t.EnvironmentVariableMutatorType.Replace){S=R.next();continue}const g=S.value[1];d.unshift({extensionIdentifier:T,value:g.value,type:g.type}),S=R.next()}})}async applyToProcessEnvironment(E,C){let T;y.isWindows&&(T={},Object.keys(E).forEach(R=>T[R.toLowerCase()]=R));for(const[R,S]of this.map){const w=y.isWindows&&T[R.toLowerCase()]||R;for(const d of S){const g=C?await C(d.value):d.value;switch(d.type){case t.EnvironmentVariableMutatorType.Append:E[w]=(E[w]||"")+g;break;case t.EnvironmentVariableMutatorType.Prepend:E[w]=g+(E[w]||"");break;case t.EnvironmentVariableMutatorType.Replace:E[w]=g;break}}}}diff(E){const C=new Map,T=new Map,R=new Map;if(E.map.forEach((S,w)=>{const d=this.map.get(w),g=I(S,d);g&&C.set(w,g)}),this.map.forEach((S,w)=>{const d=E.map.get(w),g=I(S,d);g&&R.set(w,g)}),this.map.forEach((S,w)=>{const d=E.map.get(w),g=k(S,d);g&&T.set(w,g)}),!(C.size===0&&T.size===0&&R.size===0))return{added:C,changed:T,removed:R}}}e.MergedEnvironmentVariableCollection=P;function I(b,E){if(!E)return b;const C=new Set;E.forEach(R=>C.add(R.extensionIdentifier));const T=[];return b.forEach(R=>{C.has(R.extensionIdentifier)||T.push(R)}),T.length===0?void 0:T}function k(b,E){if(!E)return;const C=new Map;E.forEach(R=>C.set(R.extensionIdentifier,R));const T=[];return b.forEach(R=>{const S=C.get(R.extensionIdentifier);S&&(R.type!==S.type||R.value!==S.value)&&T.push(S)}),T.length===0?void 0:T}}),define(we[123],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function y(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=y;function t(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=t;function P(k){return Array.from(k.entries()).map(b=>[b[0],y(b[1].map)])}e.serializeEnvironmentVariableCollections=P;function I(k){return new Map(k.map(b=>[b[0],{map:t(b[1])}]))}e.deserializeEnvironmentVariableCollections=I}),define(we[250],ye([1,0,6,56,3,232]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function k(l,h){if(!!h)if(P.isWindows)for(const i in h){let r=i;for(const s in l)if(i.toLowerCase()===s.toLowerCase()){r=s;break}const n=h[i];n!==void 0&&b(l,r,n)}else Object.keys(h).forEach(i=>{const r=h[i];r!==void 0&&b(l,i,r)})}e.mergeEnvironments=k;function b(l,h,i){typeof i=="string"?l[h]=i:delete l[h]}function E(l,h,i,r){l.TERM_PROGRAM="vscode",h&&(l.TERM_PROGRAM_VERSION=h),R(l,r)&&(l.LANG=S(i)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=E;function C(l,h){if(!!h)for(const i of Object.keys(h)){const r=h[i];r&&(l[i]=r)}}async function T(l,h){return await Promise.all(Object.entries(h).map(async([i,r])=>{if(typeof r=="string")try{h[i]=await l(r)}catch{h[i]=r}})),h}function R(l,h){if(h==="on")return!0;if(h==="auto"){const i=l.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=R;function S(l){const h=l?l.split("-"):[],i=h.length;if(i===0)return"en_US.UTF-8";if(i===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};h[0]in r&&h.push(r[h[0]])}else h[1]=h[1].toUpperCase();return h.join("_")+".UTF-8"}e.getLangEnvVariable=S;async function w(l,h,i,r,n,s){if(l.cwd){const f=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,o=await d(f,i);return(0,I.sanitizeCwd)(o||f)}let a;return!l.ignoreConfigurationCwd&&n&&(i&&(n=await d(n,i,s)),n&&(y.isAbsolute(n)?a=n:r&&(a=y.join(r.fsPath,n)))),a||(a=r?r.fsPath:h||""),(0,I.sanitizeCwd)(a)}e.getCwd=w;async function d(l,h,i){if(h)try{return await h(l)}catch(r){i?.error("Could not resolve terminal cwd",r);return}return l}function g(l,h,i){if(!!i)return r=>i.resolveWithEnvironment(h,l,r)}e.createVariableResolver=g;async function p(l,h,i,r,n,s,a,f=P.platform){let o;a&&(o=v(l,"automationShell",f)),o||(o=v(l,"shell",f));let c=o||h;if(f===3&&!i&&r){const D=y.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();c&&c.toLowerCase().indexOf(D)===0&&(c=y.join(r,"System32",c.substr(D.length+1)))}if(c&&f===3&&(c=c.replace(/\//g,"\\")),n)try{c=await n(c)}catch(D){s.error("Could not resolve shell",D)}return c}e.getDefaultShell=p;async function m(l,h,i,r,n=P.platform){if(h&&v(l,"automationShell",n))return[];const s=n===3?"windows":n===1?"osx":"linux";let a=l(`terminal.integrated.shellArgs.${s}`);if(!a)return[];if(typeof a=="string"&&n===3)return i?await i(a):a;if(i){const f=[];for(const o of a)try{f.push(await i(o))}catch(c){r.error(`Could not resolve terminal.integrated.shellArgs.${s}`,c),f.push(o)}a=f}return a}e.getDefaultShellArgs=m;function v(l,h,i=P.platform){return l(`terminal.integrated.${h}.${i===3?"windows":i===1?"osx":"linux"}`)}async function u(l,h,i,r,n,s){const a={};if(l.strictEnv)C(a,l.env);else{C(a,s);const f={...h};i&&(f&&await T(i,f),l.env&&await T(i,l.env)),(0,t.sanitizeProcessEnvironment)(a,"VSCODE_IPC_HOOK_CLI"),k(a,f),k(a,l.env),E(a,r,P.locale,n)}return a}e.createTerminalEnvironment=u}),define(we[65],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(I){I.Delimiter="\0"})(y=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class P{static fromExtHostTestItem(k,b,E=k.parent){if(k._isRoot)return new P([b]);const C=[k.id];for(let T=E;T&&T.id!==b;T=T.parent)C.push(T.id);return C.push(b),new P(C.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const b=k.indexOf("\0");return b===-1?k:k.slice(0,b)}static fromString(k){return new P(k.split("\0"))}static join(k,b){return new P([...k.path,b])}static joinToString(k,b){return k.toString()+"\0"+b}static parentId(k){const b=k.lastIndexOf("\0");return b===-1?void 0:k.slice(0,b)}static compare(k,b){return k===b?0:b.startsWith(k+"\0")?2:k.startsWith(b+"\0")?3:1}constructor(k,b=k.length){if(this.path=k,this.viewEnd=b,k.length===0||b<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new P(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new P(this.path,k)}*idsToRoot(){for(let k=this.viewEnd;k>0;k--)yield new P(this.path,k)}compare(k){if(typeof k=="string")return P.compare(this.toString(),k);for(let b=0;b<k.viewEnd&&b<this.viewEnd;b++)if(k.path[b]!==this.path[b])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=P}),define(we[83],ye([1,0,4,46,65]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var I;(function(o){o[o.Unset=0]="Unset",o[o.Queued=1]="Queued",o[o.Running=2]="Running",o[o.Passed=3]="Passed",o[o.Failed=4]="Failed",o[o.Skipped=5]="Skipped",o[o.Errored=6]="Errored"})(I=e.TestResultState||(e.TestResultState={}));var k;(function(o){o[o.Run=2]="Run",o[o.Debug=4]="Debug",o[o.Coverage=8]="Coverage",o[o.HasNonDefaultProfile=16]="HasNonDefaultProfile",o[o.HasConfigurable=32]="HasConfigurable"})(k=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var b;(function(o){o.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),o.deserialize=c=>({range:t.Range.lift(c.range),uri:y.URI.revive(c.uri)})})(b=e.IRichLocation||(e.IRichLocation={}));var E;(function(o){o[o.Error=0]="Error",o[o.Output=1]="Output"})(E=e.TestMessageType||(e.TestMessageType={}));var C;(function(o){o.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&b.serialize(c.location)}),o.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&b.deserialize(c.location)})})(C=e.ITestErrorMessage||(e.ITestErrorMessage={}));const T=(o,c)=>`${c?"s":"e"}${o}`;e.getMarkId=T;var R;(function(o){o.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&b.serialize(c.location)}),o.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&b.deserialize(c.location)})})(R=e.ITestOutputMessage||(e.ITestOutputMessage={}));var S;(function(o){o.serialize=c=>c.type===0?C.serialize(c):R.serialize(c),o.deserialize=c=>c.type===0?C.deserialize(c):R.deserialize(c)})(S=e.ITestMessage||(e.ITestMessage={}));var w;(function(o){o.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),o.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(S.serialize)}),o.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(S.deserialize)})})(w=e.ITestTaskState||(e.ITestTaskState={}));const d="\0",g=(o,c)=>o+d+c;e.namespaceTestTag=g;const p=o=>{const c=o.indexOf(d);return{ctrlId:o.slice(0,c),tagId:o.slice(c+1)}};e.denamespaceTestTag=p;var m;(function(o){o.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),o.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?y.URI.revive(c.uri):void 0,range:c.range?t.Range.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(m=e.ITestItem||(e.ITestItem={}));var v;(function(o){o[o.NotExpandable=0]="NotExpandable",o[o.Expandable=1]="Expandable",o[o.BusyExpanding=2]="BusyExpanding",o[o.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var u;(function(o){o.serialize=c=>({expand:c.expand,item:m.serialize(c.item)}),o.deserialize=c=>({controllerId:P.TestId.root(c.item.extId),expand:c.expand,item:m.deserialize(c.item)})})(u=e.InternalTestItem||(e.InternalTestItem={}));var l;(function(o){o.serialize=c=>{let D;return c.item&&(D={},c.item.label!==void 0&&(D.label=c.item.label),c.item.tags!==void 0&&(D.tags=c.item.tags),c.item.busy!==void 0&&(D.busy=c.item.busy),c.item.uri!==void 0&&(D.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(D.range=c.item.range?.toJSON()),c.item.description!==void 0&&(D.description=c.item.description),c.item.error!==void 0&&(D.error=c.item.error),c.item.sortText!==void 0&&(D.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:D}},o.deserialize=c=>{let D;return c.item&&(D={},c.item.label!==void 0&&(D.label=c.item.label),c.item.tags!==void 0&&(D.tags=c.item.tags),c.item.busy!==void 0&&(D.busy=c.item.busy),c.item.range!==void 0&&(D.range=c.item.range?t.Range.lift(c.item.range):null),c.item.description!==void 0&&(D.description=c.item.description),c.item.error!==void 0&&(D.error=c.item.error),c.item.sortText!==void 0&&(D.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:D}}})(l=e.ITestItemUpdate||(e.ITestItemUpdate={}));const h=(o,c)=>{c.expand!==void 0&&(o.expand=c.expand),c.item!==void 0&&(o.item=o.item?Object.assign(o.item,c.item):c.item)};e.applyTestItemUpdate=h;var i;(function(o){o.serializeWithoutMessages=c=>({...u.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(w.serializeWithoutMessages),retired:c.retired}),o.serialize=c=>({...u.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(w.serialize),retired:c.retired}),o.deserialize=c=>({...u.deserialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(w.deserialize),retired:!0})})(i=e.TestResultItem||(e.TestResultItem={}));var r;(function(o){o[o.Function=0]="Function",o[o.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var n;(function(o){o[o.Add=0]="Add",o[o.Update=1]="Update",o[o.DocumentSynced=2]="DocumentSynced",o[o.Remove=3]="Remove",o[o.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",o[o.Retire=5]="Retire",o[o.AddTag=6]="AddTag",o[o.RemoveTag=7]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var s;(function(o){o.deserialize=c=>c.op===0?{op:c.op,item:u.deserialize(c.item)}:c.op===1?{op:c.op,item:l.deserialize(c.item)}:c.op===2?{op:c.op,uri:y.URI.revive(c.uri),docv:c.docv}:c,o.serialize=c=>c.op===0?{op:c.op,item:u.serialize(c.item)}:c.op===1?{op:c.op,item:l.serialize(c.item)}:c})(s=e.TestsDiffOp||(e.TestsDiffOp={}));class a{add(c){}update(c){}remove(c,D){}complete(){}}e.IncrementalChangeCollector=a;class f{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const D=this.createChangeCollector();for(const O of c)switch(O.op){case 0:{const H=u.deserialize(O.item),re=P.TestId.parentId(H.item.extId)?.toString();if(re){if(this.items.has(re)){const ce=this.items.get(re);ce.children.add(H.item.extId);const ae=this.createItem(H,ce);this.items.set(H.item.extId,ae),D.add(ae)}}else{const ce=this.createItem(H);this.roots.add(ce),this.items.set(H.item.extId,ce),D.add(ce)}H.expand===2&&this.busyControllerCount++;break}case 1:{const H=l.deserialize(O.item),re=this.items.get(H.extId);if(!re)break;H.expand!==void 0&&(re.expand===2&&this.busyControllerCount--,H.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(re,H),D.update(re);break}case 3:{const H=this.items.get(O.itemId);if(!H)break;const re=P.TestId.parentId(H.item.extId)?.toString();re?this.items.get(re).children.delete(H.item.extId):this.roots.delete(H);const ce=[[O.itemId]];for(;ce.length;)for(const ae of ce.pop()){const N=this.items.get(ae);N&&(ce.push(N.children),this.items.delete(ae),D.remove(N,N!==H),N.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(O.itemId);break;case 4:this.updatePendingRoots(O.amount);break;case 6:this._tags.set(O.tag.id,O.tag);break;case 7:this._tags.delete(O.id);break}D.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new a}}e.AbstractIncrementalTestCollection=f}),define(we[124],ye([1,0,14,7,2,85,83,65]),function(se,e,y,t,P,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const C=(m,v)=>m===v,T={range:(m,v)=>m===v?!0:!m||!v?!1:m.equalsRange(v),busy:C,label:C,description:C,error:C,tags:(m,v)=>!(m.length!==v.length||m.some(u=>!v.includes(u)))},R=(m,v)=>{let u;for(const[l,h]of Object.entries(T))h(m[l],v[l])||(u?u[l]=v[l]:u={[l]:v[l]});return u};class S extends P.Disposable{get root(){return this.options.root}constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new y.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(v){this._resolveHandler=v;for(const u of this.tree.values())this.updateExpandability(u)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){switch(v.op){case 2:{for(const u of this.diff)if(u.op===2&&u.uri===v.uri){u.docv=v.docv;return}break}case 1:{const u=this.diff[this.diff.length-1];if(u){if(u.op===1&&u.item.extId===v.item.extId){(0,k.applyTestItemUpdate)(u.item,v.item);return}if(u.op===0&&u.item.item.extId===v.item.extId){(0,k.applyTestItemUpdate)(u.item,v.item);return}}break}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,u){const l=this.tree.get(v);if(!!l){if((l.expandLevels===void 0||u>l.expandLevels)&&(l.expandLevels=u),l.expand===1){const h=this.resolveChildren(l);return h.isOpen()?this.expandChildren(l,u-1):h.wait().then(()=>this.expandChildren(l,u-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,u-1)):this.expandChildren(l,u-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,u){switch(u.op){case 3:this.removeItem(b.TestId.joinToString(v.fullId,u.id));break;case 0:this.upsertItem(u.item,v);break;case 5:for(const l of u.ops)this.onTestItemEvent(v,l);break;case 1:this.diffTagRefs(u.new,u.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:u.update}});break;case 6:this.documentSynced(v.actual.uri);break;default:(0,I.assertNever)(u)}}documentSynced(v){v&&this.pushDiff({op:2,uri:v,docv:this.options.getDocumentVersion(v)})}upsertItem(v,u){const l=b.TestId.fromExtHostTestItem(v,this.root.id,u?.actual),h=this.options.getApiFor(v);h.parent&&h.parent!==u?.actual&&this.options.getChildren(h.parent).delete(v.id);let i=this.tree.get(l.toString());if(!i){i={fullId:l,actual:v,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(i.fullId.toString(),i),this.setItemParent(v,u),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:i.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,i,u);return}if(i.actual===v){this.connectItem(v,i,u);return}const r=this.options.getChildren(i.actual),n=i.actual,s=R(this.options.toITestItem(n),this.options.toITestItem(v));this.options.getApiFor(n).listener=void 0,i.actual=v,i.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,n.tags,l.toString()),delete s.tags),this.onTestItemEvent(i,{op:4,update:s})),this.connectItemAndChildren(v,i,u);for(const[a,f]of r)this.options.getChildren(v).get(f.id)||this.removeItem(b.TestId.joinToString(l,f.id));this.documentSynced(i.actual.uri)}diffTagRefs(v,u,l){const h=new Set(u.map(i=>i.id));for(const i of v)h.delete(i.id)||this.incrementTagRefs(i);this.pushDiff({op:1,item:{extId:l,item:{tags:v.map(i=>(0,k.namespaceTestTag)(this.options.controllerId,i.id))}}}),h.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const u=this.tags.get(v.id);u?u.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,k.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const u=this.tags.get(v);u&&!--u.refCount&&(this.tags.delete(v),this.pushDiff({op:7,id:(0,k.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,u){this.options.getApiFor(v).parent=u&&u.actual!==this.root?u.actual:void 0}connectItem(v,u,l){this.setItemParent(v,l);const h=this.options.getApiFor(v);h.parent=l?.actual,h.listener=i=>this.onTestItemEvent(u,i),this.updateExpandability(u)}connectItemAndChildren(v,u,l){this.connectItem(v,u,l);for(const[h,i]of this.options.getChildren(v))this.upsertItem(i,u)}updateExpandability(v){let u;this._resolveHandler?v.resolveBarrier?u=v.resolveBarrier.isOpen()?3:2:u=v.actual.canResolveChildren?1:0:u=0,u!==v.expand&&(v.expand=u,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:u}}),u===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,u){if(u<0)return;const l=[];for(const[h,i]of this.options.getChildren(v.actual)){const r=this.expand(b.TestId.joinToString(v.fullId,i.id),u);(0,y.isThenable)(r)&&l.push(r)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const i=new y.Barrier;return i.open(),i}v.expand=2,this.pushExpandStateUpdate(v);const u=v.resolveBarrier=new y.Barrier,l=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,i)};let h;try{h=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(i){l(i)}return(0,y.isThenable)(h)?h.catch(l).then(()=>{u.open(),this.updateExpandability(v)}):(u.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const u=this.tree.get(v);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const l=[u];for(;l.length;){const h=l.pop();if(!!h){this.options.getApiFor(h.actual).listener=void 0;for(const i of h.actual.tags)this.decrementTagRefs(i.id);this.tree.delete(h.fullId.toString());for(const[i,r]of this.options.getChildren(h.actual))l.push(this.tree.get(b.TestId.joinToString(h.fullId,r.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=S;class w extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=w;class d extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class g extends Error{constructor(v,u,l){super(`TestItem with ID "${v}" is from controller "${u}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=g;const p=(m,v,u)=>{let l=new Map;return{get size(){return l.size},forEach(h,i){for(const r of l.values())h.call(i,r,this)},[Symbol.iterator](){return l.entries()},replace(h){const i=new Map,r=new Set(l.keys()),n={op:5,ops:[]};for(const s of h){if(!(s instanceof u))throw new d(s.id);const a=v(s).controllerId;if(a!==m.controllerId)throw new g(s.id,a,m.controllerId);if(i.has(s.id))throw new w(s.id);i.set(s.id,s),r.delete(s.id),n.ops.push({op:0,item:s})}for(const s of r.keys())n.ops.push({op:3,id:s});m.listener?.(n),l=i},add(h){if(!(h instanceof u))throw new d(h.id);l.set(h.id,h),m.listener?.({op:0,item:h})},delete(h){l.delete(h)&&m.listener?.({op:3,id:h})},get(h){return l.get(h)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=p}),define(we[125],ye([1,0,124]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,P=(k,b)=>{const E={controllerId:b};return t.set(k,E),E};e.createPrivateApiFor=P;const I=k=>{const b=t.get(k);if(!b)throw new y.InvalidTestItemError(k?.id||"<unknown>");return b};e.getPrivateApiFor=I}),define(we[251],ye([1,0,24,5]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(y.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(we[126],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,y.createDecorator)("configurationResolverService");var t;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class P extends Error{constructor(k,b){super(b),this.variable=k}}e.VariableError=P}),define(we[252],ye([1,0,6,27,13,22,3,154,187,126,15]),function(se,e,y,t,P,I,k,b,E,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(w,d,g,p){this._contributedVariables=new Map,this._context=w,this._labelService=d,this._userHomePromise=g,p&&(this._envVariablesPromise=p.then(m=>this.prepareEnv(m)))}prepareEnv(w){if(k.isWindows){const d=Object.create(null);return Object.keys(w).forEach(g=>{d[g.toLowerCase()]=w[g]}),d}return w}resolveWithEnvironment(w,d,g){return this.recursiveResolve({env:this.prepareEnv(w),userHome:void 0},d?d.uri:void 0,g)}async resolveAsync(w,d){const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,w?w.uri:void 0,d)}async resolveAnyBase(w,d,g,p){const m=I.deepClone(d);k.isWindows&&m.windows?Object.keys(m.windows).forEach(u=>m[u]=m.windows[u]):k.isMacintosh&&m.osx?Object.keys(m.osx).forEach(u=>m[u]=m.osx[u]):k.isLinux&&m.linux&&Object.keys(m.linux).forEach(u=>m[u]=m.linux[u]),delete m.windows,delete m.osx,delete m.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,w?w.uri:void 0,m,g,p)}async resolveAnyAsync(w,d,g){return this.resolveAnyBase(w,d,g)}async resolveAnyMap(w,d,g){const p=new Map;return{newConfig:await this.resolveAnyBase(w,d,g,p),resolvedVariables:p}}resolveWithInteractionReplace(w,d,g,p){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,d,g,p){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,d){if(this._contributedVariables.has(w))throw new Error("Variable "+w+" is contributed twice.");this._contributedVariables.set(w,d)}async recursiveResolve(w,d,g,p,m){if(P.isString(g))return this.resolveString(w,d,g,p,m);if(Array.isArray(g))return Promise.all(g.map(v=>this.recursiveResolve(w,d,v,p,m)));if(P.isObject(g)){const v=Object.create(null),u=await Promise.all(Object.keys(g).map(async l=>[await this.resolveString(w,d,l,p,m),await this.recursiveResolve(w,d,g[l],p,m)]));for(const[l,h]of u)v[l]=h;return v}return g}resolveString(w,d,g,p,m){return(0,T.replaceAsync)(g,R.VARIABLE_REGEXP,async(v,u)=>{if(u.includes(R.VARIABLE_LHS))return v;let l=await this.evaluateSingleVariable(w,v,u,d,p);return m?.set(u,l),l!==v&&P.isString(l)&&l.match(R.VARIABLE_REGEXP)&&(l=await this.resolveString(w,d,l,p,m)),l})}fsPath(w){return this._labelService?this._labelService.getUriLabel(w,{noPrefix:!0}):w.fsPath}async evaluateSingleVariable(w,d,g,p,m){let v;const u=g.split(":");u.length>1&&(g=u[0],v=u[1]);const l=r=>{const n=this._context.getFilePath();if(n)return n;throw new C.VariableError(r,(0,E.localize)(0,null,d))},h=r=>{const n=l(r);if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new C.VariableError(r,(0,E.localize)(1,null,d,y.basename(n)))},i=r=>{if(v){const n=this._context.getFolderUri(v);if(n)return n;throw new C.VariableError(r,(0,E.localize)(2,null,d,v))}if(p)return p;throw this._context.getWorkspaceFolderCount()>1?new C.VariableError(r,(0,E.localize)(3,null,d)):new C.VariableError(r,(0,E.localize)(4,null,d))};switch(g){case"env":if(v){if(w.env){const r=w.env[k.isWindows?v.toLowerCase():v];if(P.isString(r))return r}return""}throw new C.VariableError(C.VariableKind.Env,(0,E.localize)(5,null,d));case"config":if(v){const r=this._context.getConfigurationValue(p,v);if(P.isUndefinedOrNull(r))throw new C.VariableError(C.VariableKind.Config,(0,E.localize)(6,null,d,v));if(P.isObject(r))throw new C.VariableError(C.VariableKind.Config,(0,E.localize)(7,null,d,v));return r}throw new C.VariableError(C.VariableKind.Config,(0,E.localize)(8,null,d));case"command":return this.resolveFromMap(C.VariableKind.Command,d,v,m,"command");case"input":return this.resolveFromMap(C.VariableKind.Input,d,v,m,"input");case"extensionInstallFolder":if(v){const r=await this._context.getExtension(v);if(!r)throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,d,v));return this.fsPath(r.extensionLocation)}throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,d));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,b.normalizeDriveLetter)(this.fsPath(i(C.VariableKind.WorkspaceFolder)));case"cwd":return p||v?(0,b.normalizeDriveLetter)(this.fsPath(i(C.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return y.basename(this.fsPath(i(C.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(w.userHome)return w.userHome;throw new C.VariableError(C.VariableKind.UserHome,(0,E.localize)(11,null,d))}case"lineNumber":{const r=this._context.getLineNumber();if(r)return r;throw new C.VariableError(C.VariableKind.LineNumber,(0,E.localize)(12,null,d))}case"selectedText":{const r=this._context.getSelectedText();if(r)return r;throw new C.VariableError(C.VariableKind.SelectedText,(0,E.localize)(13,null,d))}case"file":return l(C.VariableKind.File);case"fileWorkspaceFolder":return h(C.VariableKind.FileWorkspaceFolder);case"relativeFile":return p||v?y.relative(this.fsPath(i(C.VariableKind.RelativeFile)),l(C.VariableKind.RelativeFile)):l(C.VariableKind.RelativeFile);case"relativeFileDirname":{const r=y.dirname(l(C.VariableKind.RelativeFileDirname));if(p||v){const n=y.relative(this.fsPath(i(C.VariableKind.RelativeFileDirname)),r);return n.length===0?".":n}return r}case"fileDirname":return y.dirname(l(C.VariableKind.FileDirname));case"fileExtname":return y.extname(l(C.VariableKind.FileExtname));case"fileBasename":return y.basename(l(C.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=y.basename(l(C.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-y.extname(r).length)}case"fileDirnameBasename":return y.basename(y.dirname(l(C.VariableKind.FileDirnameBasename)));case"execPath":{const r=this._context.getExecPath();return r||d}case"execInstallFolder":{const r=this._context.getAppRoot();return r||d}case"pathSeparator":return y.sep;default:try{const r=v?`${g}:${v}`:g;return this.resolveFromMap(C.VariableKind.Unknown,d,r,m,void 0)}catch{return d}}}}resolveFromMap(w,d,g,p,m){if(g&&p){const v=m===void 0?p[g]:p[m+":"+g];if(typeof v=="string")return v;throw new C.VariableError(w,(0,E.localize)(14,null,d))}return d}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[253],ye([1,0,5,82]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,y.createDecorator)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P=e.GroupDirection||(e.GroupDirection={}));var I;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(I=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var b;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(b=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function C(d){const g=d;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=C;var T;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var R;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function S(d){const g=d;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=S;function w(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=w}),define(we[127],ye([1,0,5,253]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,y.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function P(I){const k=I;return typeof I=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=P}),define(we[254],ye([1,0,13,251,12,109,81,123,126,82,127,11,207,122]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let d=class{get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}constructor(p,m,v,u,l,h,i,r,n,s){this._remoteAuthority=p,this._channel=m,this._configurationService=v,this._workspaceContextService=u,this._resolverService=l,this._environmentVariableService=h,this._remoteAuthorityResolverService=i,this._logService=r,this._editorService=n,this._labelService=s}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(p,m,v,u,l,h,i,r){await this._configurationService.whenRemoteConfigurationLoaded();const n=Object.create(null),s=v?(0,y.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(v)):void 0;let a;try{a=(await this._resolverService.resolveAnyMap(s,{shellLaunchConfig:p,configuration:m})).resolvedVariables}catch(ae){this._logService.error(ae)}if(a)for(const[ae,N]of a.entries())(/^config:/.test(ae)||ae==="selectedText"||ae==="lineNumber")&&(n[ae]=N);const f=[];for(const[ae,N]of this._environmentVariableService.collections.entries())f.push([ae,(0,b.serializeEnvironmentVariableCollection)(N.map)]);const o=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),c=o.options&&o.options.extensionHostEnv,D=this._workspaceContextService.getWorkspace(),O=D.folders,H=v?this._workspaceContextService.getWorkspaceFolder(v):null,re=C.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:C.SideBySideEditor.PRIMARY,filterByScheme:[R.Schemas.file,R.Schemas.vscodeUserData,R.Schemas.vscodeRemote]}),ce={configuration:m,resolvedVariables:n,envVariableCollections:f,shellLaunchConfig:p,workspaceId:D.id,workspaceName:this._labelService.getWorkspaceLabel(D),workspaceFolders:O,activeWorkspaceFolder:H,activeFileResource:re,shouldPersistTerminal:l,options:u,cols:h,rows:i,unicodeVersion:r,resolverEnv:c};return await this._channel.call("$createProcess",ce)}requestDetachInstance(p,m){return this._channel.call("$requestDetachInstance",[p,m])}acceptDetachInstanceReply(p,m){return this._channel.call("$acceptDetachInstanceReply",[p,m])}attachToProcess(p){return this._channel.call("$attachToProcess",[p])}detachFromProcess(p,m){return this._channel.call("$detachFromProcess",[p,m])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(p,m){return this._channel.call("$processBinary",[p,m])}start(p){return this._channel.call("$start",[p])}input(p,m){return this._channel.call("$input",[p,m])}acknowledgeDataEvent(p,m){return this._channel.call("$acknowledgeDataEvent",[p,m])}setUnicodeVersion(p,m){return this._channel.call("$setUnicodeVersion",[p,m])}shutdown(p,m){return this._channel.call("$shutdown",[p,m])}resize(p,m,v){return this._channel.call("$resize",[p,m,v])}getInitialCwd(p){return this._channel.call("$getInitialCwd",[p])}getCwd(p){return this._channel.call("$getCwd",[p])}orphanQuestionReply(p){return this._channel.call("$orphanQuestionReply",[p])}sendCommandResult(p,m,v){return this._channel.call("$sendCommandResult",[p,m,v])}freePortKillProcess(p){return this._channel.call("$freePortKillProcess",[p])}installAutoReply(p,m){return this._channel.call("$installAutoReply",[p,m])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(p){return this._channel.call("$getDefaultSystemShell",[p])}getProfiles(p,m,v){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,p,m,v])}acceptPtyHostResolvedVariables(p,m){return this._channel.call("$acceptPtyHostResolvedVariables",[p,m])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(p){return this._channel.call("$getWslPath",[p])}setTerminalLayoutInfo(p){const v={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:p?p.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",v)}updateTitle(p,m,v){return this._channel.call("$updateTitle",[p,m,v])}updateIcon(p,m,v,u){return this._channel.call("$updateIcon",[p,m,v,u])}refreshProperty(p,m){return this._channel.call("$refreshProperty",[p,m])}updateProperty(p,m,v){return this._channel.call("$updateProperty",[p,m,v])}getTerminalLayoutInfo(){const m={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",m)}reviveTerminalProcesses(p,m){return this._channel.call("$reviveTerminalProcesses",[p,m])}getRevivedPtyNewId(p){return this._channel.call("$getRevivedPtyNewId",[p])}serializeTerminalState(p){return this._channel.call("$serializeTerminalState",[p])}};d=Ae([_e(2,t.IWorkbenchConfigurationService),_e(3,k.IWorkspaceContextService),_e(4,E.IConfigurationResolverService),_e(5,w.IEnvironmentVariableService),_e(6,I.IRemoteAuthorityResolverService),_e(7,P.ILogService),_e(8,T.IEditorService),_e(9,S.ILabelService)],d),e.RemoteTerminalChannelClient=d}),define(we[255],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var y;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(y=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(R){this.pipeName=R,this.type=1}serialize(R){R[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class P{constructor(){this.type=2}serialize(R){R[P.ENV_KEY]="1"}}e.SocketExtHostConnection=P,P.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class I{constructor(){this.type=3}serialize(R){R[I.ENV_KEY]="1"}}e.MessagePortExtHostConnection=I,I.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function k(T){delete T[t.ENV_KEY],delete T[P.ENV_KEY],delete T[I.ENV_KEY]}function b(T,R){k(R),T.serialize(R)}e.writeExtHostConnection=b;function E(T){if(T[t.ENV_KEY])return C(T,new t(T[t.ENV_KEY]));if(T[P.ENV_KEY])return C(T,new P);if(T[I.ENV_KEY])return C(T,new I);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=E;function C(T,R){return k(T),R}}),define(we[128],ye([1,0,48,89,119,11,6,16,7,58,80,12,43,3,56,118,2,255]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function v(n={},s,a,f,o){const c=await(0,P.getNLSConfiguration)(a,f.userDataPath);let D={};if(s)try{D=await(0,T.getResolvedShellEnv)(o,f.args,process.env)}catch(N){o.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",N)}const H={...process.env,...D,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(c,void 0,0),...n},re=f.isBuilt?(0,k.join)(f.appRoot,"bin"):(0,k.join)(f.appRoot,"resources","server","bin-dev"),ce=(0,k.join)(re,"remote-cli");let ae=h(H,"PATH");return ae?ae=ce+k.delimiter+ae:ae=ce,i(H,"PATH",ae),f.args["without-browser-env-var"]||(H.BROWSER=(0,k.join)(re,"helpers",w.isWindows?"browser.cmd":"browser.sh")),r(H),H}e.buildUserEnvironment=v;class u{constructor(s,a){this.socket=s,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let s,a,f;return this.socket instanceof C.NodeSocket?(s=!0,a=!1,f=b.VSBuffer.alloc(0)):(s=!1,a=this.socket.permessageDeflate,f=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:s,permessageDeflate:a,inflateBytes:f.buffer.toString("base64")}}}let l=class{constructor(s,a,f,o,c,D,O){this._reconnectionToken=s,this._environmentService=c,this._logService=D,this._extensionHostStatusService=O,this._onClose=new E.Emitter,this.onClose=this._onClose.event,this._canSendSocket=!w.isWindows||!this._environmentService.args["socket-path"],this._disposed=!1,this._remoteAddress=a,this._extensionHostProcess=null,this._connectionData=new u(f,o),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(s){this._logService.info(`${this._logPrefix}${s}`)}_logError(s){this._logService.error(`${this._logPrefix}${s}`)}async _pipeSockets(s,a){const f=new p.DisposableStore;f.add(a.socket),f.add((0,p.toDisposable)(()=>{s.destroy()}));const o=()=>{f.dispose()};f.add(a.socket.onEnd(o)),f.add(a.socket.onClose(o)),f.add(E.Event.fromNodeEventEmitter(s,"end")(o)),f.add(E.Event.fromNodeEventEmitter(s,"close")(o)),f.add(E.Event.fromNodeEventEmitter(s,"error")(o)),f.add(a.socket.onData(c=>s.write(c.buffer))),f.add(E.Event.fromNodeEventEmitter(s,"data")(c=>{a.socket.write(b.VSBuffer.wrap(c))})),a.initialDataChunk.byteLength>0&&s.write(a.initialDataChunk.buffer)}async _sendSocketToExtensionHost(s,a){await a.socketDrain();const f=a.toIExtHostSocketMessage();let o;a.socket instanceof C.NodeSocket?o=a.socket.socket:o=a.socket.socket.socket,s.send(f,o)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const s={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(s)}acceptReconnection(s,a,f){this._remoteAddress=s,this._log("The client has reconnected.");const o=new u(a,f);if(!this._extensionHostProcess){this._connectionData=o;return}this._sendSocketToExtensionHost(this._extensionHostProcess,o)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(s){try{let a=process.execArgv?process.execArgv.filter(ae=>!/^--inspect(-brk)?=/.test(ae)):[];s.port&&!process.pkg&&(a=[`--inspect${s.break?"-brk":""}=${s.port}`]);const f=await v(s.env,!0,s.language,this._environmentService,this._logService);(0,d.removeDangerousEnvVariables)(f);let o;if(this._canSendSocket)(0,m.writeExtHostConnection)(new m.SocketExtHostConnection,f),o=null;else{const{namedPipeServer:ae,pipeName:N}=await this._listenOnPipe();(0,m.writeExtHostConnection)(new m.IPCExtHostConnection(N),f),o=ae}const c={env:f,execArgv:a,silent:!0},D=["--type=extensionHost","--transformURIs"],O=this._environmentService.args["use-host-proxy"];D.push(`--useHostProxy=${O?"true":"false"}`),this._extensionHostProcess=y.fork(I.FileAccess.asFileUri("bootstrap-fork",se).fsPath,D,c);const H=this._extensionHostProcess.pid;this._log(`<${H}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const re=E.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),ce=E.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");if(re(ae=>this._log(`<${H}> ${ae}`)),ce(ae=>this._log(`<${H}><stderr> ${ae}`)),this._extensionHostProcess.on("error",ae=>{this._logError(`<${H}> Extension Host Process had an error`),this._logService.error(ae),this._cleanResources()}),this._extensionHostProcess.on("exit",(ae,N)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:ae,signal:N}),this._log(`<${H}> Extension Host Process exited with code: ${ae}, signal: ${N}.`),this._cleanResources()}),o)o.on("connection",ae=>{o.close(),this._pipeSockets(ae,this._connectionData)});else{const ae=N=>{N.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",ae),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",ae)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}_listenOnPipe(){return new Promise((s,a)=>{const f=(0,C.createRandomIPCHandle)(),o=t.createServer();o.on("error",a),o.listen(f,()=>{o?.removeListener("error",a),s({pipeName:f,namedPipeServer:o})})})}};l=Ae([_e(4,S.IServerEnvironmentService),_e(5,R.ILogService),_e(6,g.IExtensionHostStatusService)],l),e.ExtensionHostConnection=l;function h(n,s){const a=Object.keys(n).filter(o=>o.toLowerCase()===s.toLowerCase()),f=a.length>0?a[0]:s;return n[f]}function i(n,s,a){const f=Object.keys(n).filter(c=>c.toLowerCase()===s.toLowerCase()),o=f.length>0?f[0]:s;n[o]=a}function r(n){for(const s of Object.keys(n))n[s]===null&&delete n[s]}}),define(we[256],ye([1,0,7,4,5,35,32]),function(se,e,y,t,P,I,k){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class E{constructor(f){this.affinity=f,this.kind=1}equals(f){return this.kind===f.kind&&this.affinity===f.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class C{constructor(f){this.affinity=f,this.kind=2}equals(f){return this.kind===f.kind&&this.affinity===f.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=C;class T{constructor(){this.kind=3,this.affinity=0}equals(f){return this.kind===f.kind}asString(){return"Remote"}}e.RemoteRunningLocation=T;class R{constructor(f){this.dependency=f}}e.MissingExtensionDependency=R;var S;(function(a){a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));function w(a){if(a===null)return"None";switch(a){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=w;class d{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(f,o){const c=[],D=[],O=[],H=[],re=m(this._allExtensions),ce=m(f),ae=(x,z)=>x.extensionLocation.toString()===z.extensionLocation.toString()||x.isBuiltin===z.isBuiltin||x.isUserBuiltin===z.isUserBuiltin||x.isUnderDevelopment===z.isUnderDevelopment;for(const x of this._allExtensions){const z=ce.get(I.ExtensionIdentifier.toKey(x.identifier));if(!z){c.push(x.identifier),re.delete(I.ExtensionIdentifier.toKey(x.identifier));continue}if(!ae(x,z)){c.push(x.identifier),re.delete(I.ExtensionIdentifier.toKey(x.identifier));continue}}for(const x of f){const z=re.get(I.ExtensionIdentifier.toKey(x.identifier));if(!z){D.push(x);continue}if(!ae(z,x)){c.push(z.identifier),re.delete(I.ExtensionIdentifier.toKey(z.identifier));continue}}const N=p(this._myExtensions),J=p(o);for(const x of this._myExtensions)J.has(I.ExtensionIdentifier.toKey(x))||O.push(x);for(const x of o)N.has(I.ExtensionIdentifier.toKey(x))||H.push(x);const B={toRemove:c,toAdd:D,myToRemove:O,myToAdd:H};return this.delta(B),B}delta(f){const{toRemove:o,toAdd:c,myToRemove:D,myToAdd:O}=f,H=p(o),re=p(D);for(let ce=0;ce<this._allExtensions.length;ce++)H.has(I.ExtensionIdentifier.toKey(this._allExtensions[ce].identifier))&&(this._allExtensions.splice(ce,1),ce--);for(let ce=0;ce<this._myExtensions.length;ce++)re.has(I.ExtensionIdentifier.toKey(this._myExtensions[ce]))&&(this._myExtensions.splice(ce,1),ce--);for(const ce of c)this._allExtensions.push(ce);for(const ce of O)this._myExtensions.push(ce)}containsExtension(f){for(const o of this._myExtensions)if(I.ExtensionIdentifier.equals(o,f))return!0;return!1}}e.ExtensionHostExtensions=d;class g{constructor(f){if(this[b]="ExtensionIdentifierSet",this._map=new Map,this._toKey=I.ExtensionIdentifier.toKey,f)for(const o of f)this.add(o)}get size(){return this._map.size}add(f){return this._map.set(this._toKey(f),f),this}clear(){this._map.clear()}delete(f){return this._map.delete(this._toKey(f))}has(f){return this._map.has(this._toKey(f))}forEach(f,o){this._map.forEach(c=>f.call(o,c,c,this))}*entries(){for(const[f,o]of this._map)yield[o,o]}keys(){return this._map.values()}values(){return this._map.values()}[(b=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=g;function p(a){const f=new Set;for(const o of a)f.add(I.ExtensionIdentifier.toKey(o));return f}e.extensionIdentifiersArrayToSet=p;function m(a){const f=new Map;for(const o of a)f.set(I.ExtensionIdentifier.toKey(o.identifier),o);return f}function v(a,f){return a.enabledApiProposals?a.enabledApiProposals.includes(f):!1}e.isProposedApiEnabled=v;function u(a,f){if(!v(a,f))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${f}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${f}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.checkProposedApiEnabled=u;class l{constructor(f,o,c,D){this.codeLoadingTime=f,this.activateCallTime=o,this.activateResolvedTime=c,this.activationReason=D}}e.ActivationTimes=l;class h{constructor(f,o){this.description=f,this.value=o}}e.ExtensionPointContribution=h,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var i;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function r(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function n(a,f){return{identifier:new I.ExtensionIdentifier((0,k.getExtensionId)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!f,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,browserNlsBundleUris:a.browserNlsBundleUris}}e.toExtensionDescription=n;class s{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.extensions=[]}activateByEvent(f){return Promise.resolve(void 0)}activationEventIsDone(f){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(f){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(f,o){return Promise.resolve(0)}getInspectPorts(f,o){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(f){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(f,o){return Promise.resolve()}}e.NullExtensionService=s});var Rt=this&&this.__classPrivateFieldSet||function(se,e,y,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!P:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(se,y):P?P.value=y:e.set(se,y),y},nt=this&&this.__classPrivateFieldGet||function(se,e,y,t){if(y==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!t:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?t:y==="a"?t.call(se):t?t.value:e.get(se)};define(we[129],ye([1,0,18,10,93,31,68,15,13,4,23,17,109,121,256]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d){"use strict";var g,p,m,v,u,l,h,i,r,n,s,a,f,o,c,D,O,H,re,ce,ae,N,J;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function B(M){return Object.assign(M,{apply:function(){const ne=arguments.length===1?[]:arguments[1];return Reflect.construct(M,ne,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(M,[]);{const[ne,...ge]=arguments;return Reflect.construct(M,ge,ne.constructor)}}})}let x=l=class{static from(...A){let ne=A;return new l(function(){if(ne){for(const ge of ne)ge&&typeof ge.dispose=="function"&&ge.dispose();ne=void 0}})}constructor(A){g.set(this,void 0),Rt(this,g,A,"f")}dispose(){typeof nt(this,g,"f")=="function"&&(nt(this,g,"f").call(this),Rt(this,g,void 0,"f"))}};g=new WeakMap,x=l=Ae([B],x),e.Disposable=x;let z=h=class{static Min(...A){if(A.length===0)throw new TypeError;let ne=A[0];for(let ge=1;ge<A.length;ge++){const Ue=A[ge];Ue.isBefore(ne)&&(ne=Ue)}return ne}static Max(...A){if(A.length===0)throw new TypeError;let ne=A[0];for(let ge=1;ge<A.length;ge++){const Ue=A[ge];Ue.isAfter(ne)&&(ne=Ue)}return ne}static isPosition(A){if(!A)return!1;if(A instanceof h)return!0;const{line:ne,character:ge}=A;return typeof ne=="number"&&typeof ge=="number"}static of(A){if(A instanceof h)return A;if(this.isPosition(A))return new h(A.line,A.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(A,ne){if(A<0)throw(0,t.illegalArgument)("line must be non-negative");if(ne<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=A,this._character=ne}isBefore(A){return this._line<A._line?!0:A._line<this._line?!1:this._character<A._character}isBeforeOrEqual(A){return this._line<A._line?!0:A._line<this._line?!1:this._character<=A._character}isAfter(A){return!this.isBeforeOrEqual(A)}isAfterOrEqual(A){return!this.isBefore(A)}isEqual(A){return this._line===A._line&&this._character===A._character}compareTo(A){return this._line<A._line?-1:this._line>A.line?1:this._character<A._character?-1:this._character>A._character?1:0}translate(A,ne=0){if(A===null||ne===null)throw(0,t.illegalArgument)();let ge;return typeof A>"u"?ge=0:typeof A=="number"?ge=A:(ge=typeof A.lineDelta=="number"?A.lineDelta:0,ne=typeof A.characterDelta=="number"?A.characterDelta:0),ge===0&&ne===0?this:new h(this.line+ge,this.character+ne)}with(A,ne=this.character){if(A===null||ne===null)throw(0,t.illegalArgument)();let ge;return typeof A>"u"?ge=this.line:typeof A=="number"?ge=A:(ge=typeof A.line=="number"?A.line:this.line,ne=typeof A.character=="number"?A.character:this.character),ge===this.line&&ne===this.character?this:new h(ge,ne)}toJSON(){return{line:this.line,character:this.character}}};z=h=Ae([B],z),e.Position=z;let j=i=class{static isRange(A){return A instanceof i?!0:A?z.isPosition(A.start)&&z.isPosition(A.end):!1}static of(A){if(A instanceof i)return A;if(this.isRange(A))return new i(A.start,A.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(A,ne,ge,Ue){let Ve,Ye;if(typeof A=="number"&&typeof ne=="number"&&typeof ge=="number"&&typeof Ue=="number"?(Ve=new z(A,ne),Ye=new z(ge,Ue)):z.isPosition(A)&&z.isPosition(ne)&&(Ve=z.of(A),Ye=z.of(ne)),!Ve||!Ye)throw new Error("Invalid arguments");Ve.isBefore(Ye)?(this._start=Ve,this._end=Ye):(this._start=Ye,this._end=Ve)}contains(A){return i.isRange(A)?this.contains(A.start)&&this.contains(A.end):z.isPosition(A)?!(z.of(A).isBefore(this._start)||this._end.isBefore(A)):!1}isEqual(A){return this._start.isEqual(A._start)&&this._end.isEqual(A._end)}intersection(A){const ne=z.Max(A.start,this._start),ge=z.Min(A.end,this._end);if(!ne.isAfter(ge))return new i(ne,ge)}union(A){if(this.contains(A))return this;if(A.contains(this))return A;const ne=z.Min(A.start,this._start),ge=z.Max(A.end,this.end);return new i(ne,ge)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(A,ne=this.end){if(A===null||ne===null)throw(0,t.illegalArgument)();let ge;return A?z.isPosition(A)?ge=A:(ge=A.start||this.start,ne=A.end||this.end):ge=this.start,ge.isEqual(this._start)&&ne.isEqual(this.end)?this:new i(ge,ne)}toJSON(){return[this.start,this.end]}};j=i=Ae([B],j),e.Range=j;let L=r=class extends j{static isSelection(A){return A instanceof r?!0:A?j.isRange(A)&&z.isPosition(A.anchor)&&z.isPosition(A.active)&&typeof A.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(A,ne,ge,Ue){let Ve,Ye;if(typeof A=="number"&&typeof ne=="number"&&typeof ge=="number"&&typeof Ue=="number"?(Ve=new z(A,ne),Ye=new z(ge,Ue)):z.isPosition(A)&&z.isPosition(ne)&&(Ve=z.of(A),Ye=z.of(ne)),!Ve||!Ye)throw new Error("Invalid arguments");super(Ve,Ye),this._anchor=Ve,this._active=Ye}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=r=Ae([B],L),e.Selection=L;class F{constructor(A,ne,ge){if(typeof A!="string"||A.length===0)throw(0,t.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,t.illegalArgument)("port");if(typeof ge<"u"&&(typeof ge!="string"||ge.length===0||!/^[0-9A-Za-z\-]+$/.test(ge)))throw(0,t.illegalArgument)("connectionToken");this.host=A,this.port=Math.round(ne),this.connectionToken=ge}}e.ResolvedAuthority=F;class G extends Error{static NotAvailable(A,ne){return new G(A,S.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(A){return new G(A,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(A,ne=S.RemoteAuthorityResolverErrorCode.Unknown,ge){super(A),this._message=A,this._code=ne,this._detail=ge,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,G.prototype)}}e.RemoteAuthorityResolverError=G;var oe;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(oe=e.EndOfLine||(e.EndOfLine={}));var fe;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(fe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=n=class{static isTextEdit(A){return A instanceof n?!0:A?j.isRange(A)&&typeof A.newText=="string":!1}static replace(A,ne){return new n(A,ne)}static insert(A,ne){return n.replace(new j(A,A),ne)}static delete(A){return n.replace(A,"")}static setEndOfLine(A){const ne=new n(new j(new z(0,0),new z(0,0)),"");return ne.newEol=A,ne}get range(){return this._range}set range(A){if(A&&!j.isRange(A))throw(0,t.illegalArgument)("range");this._range=A}get newText(){return this._newText||""}set newText(A){if(A&&typeof A!="string")throw(0,t.illegalArgument)("newText");this._newText=A}get newEol(){return this._newEol}set newEol(A){if(A&&typeof A!="number")throw(0,t.illegalArgument)("newEol");this._newEol=A}constructor(A,ne){this._range=A,this._newText=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=n=Ae([B],ee),e.TextEdit=ee;let te=s=class{static isNotebookCellEdit(A){return A instanceof s?!0:A?Pt.isNotebookRange(A)&&Array.isArray(A.newCells):!1}static replaceCells(A,ne){return new s(A,ne)}static insertCells(A,ne){return new s(new Pt(A,A),ne)}static deleteCells(A){return new s(A,[])}static updateCellMetadata(A,ne){const ge=new s(new Pt(A,A),[]);return ge.newCellMetadata=ne,ge}static updateNotebookMetadata(A){const ne=new s(new Pt(0,0),[]);return ne.newNotebookMetadata=A,ne}constructor(A,ne){this.range=A,this.newCells=ne}};te=s=Ae([B],te),e.NotebookEdit=te;class _{static isSnippetTextEdit(A){return A instanceof _?!0:A?j.isRange(A.range)&&ie.isSnippetString(A.snippet):!1}static replace(A,ne){return new _(A,ne)}static insert(A,ne){return _.replace(new j(A,A),ne)}constructor(A,ne){this.range=A,this.snippet=ne}}e.SnippetTextEdit=_;var U;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellReplace=5]="CellReplace",M[M.Snippet=6]="Snippet"})(U=e.FileEditType||(e.FileEditType={}));let Z=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(A,ne,ge,Ue){this._edits.push({_type:1,from:A,to:ne,options:ge,metadata:Ue})}createFile(A,ne,ge){this._edits.push({_type:1,from:void 0,to:A,options:ne,metadata:ge})}deleteFile(A,ne,ge){this._edits.push({_type:1,from:A,to:void 0,options:ne,metadata:ge})}replaceNotebookMetadata(A,ne,ge){this._edits.push({_type:3,metadata:ge,uri:A,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(A,ne,ge,Ue){const Ve=ne.start,Ye=ne.end;(Ve!==Ye||ge.length>0)&&this._edits.push({_type:5,uri:A,index:Ve,count:Ye-Ve,cells:ge,metadata:Ue})}replaceNotebookCellMetadata(A,ne,ge,Ue){this._edits.push({_type:3,metadata:Ue,uri:A,edit:{editType:8,index:ne,metadata:ge}})}replace(A,ne,ge,Ue){this._edits.push({_type:2,uri:A,edit:new ee(ne,ge),metadata:Ue})}insert(A,ne,ge,Ue){this.replace(A,new j(ne,ne),ge,Ue)}delete(A,ne,ge){this.replace(A,ne,"",ge)}has(A){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===A.toString())}set(A,ne){if(ne)for(const ge of ne){if(!ge)continue;let Ue,Ve;Array.isArray(ge)?(Ue=ge[0],Ve=ge[1]):Ue=ge,te.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.replaceNotebookCellMetadata(A,Ue.range.start,Ue.newCellMetadata,Ve):Ue.newNotebookMetadata?this.replaceNotebookMetadata(A,Ue.newNotebookMetadata,Ve):this.replaceNotebookCells(A,Ue.range,Ue.newCells,Ve):_.isSnippetTextEdit(Ue)?this._edits.push({_type:6,uri:A,range:Ue.range,edit:Ue.snippet,metadata:Ve}):this._edits.push({_type:2,uri:A,edit:Ue,metadata:Ve})}else{for(let ge=0;ge<this._edits.length;ge++){const Ue=this._edits[ge];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===A.toString()&&(this._edits[ge]=void 0);break}}(0,y.coalesceInPlace)(this._edits)}}get(A){const ne=[];for(const ge of this._edits)ge._type===2&&ge.uri.toString()===A.toString()&&ne.push(ge.edit);return ne}entries(){const A=new I.ResourceMap;for(const ne of this._edits)if(ne._type===2){let ge=A.get(ne.uri);ge||(ge=[ne.uri,[]],A.set(ne.uri,ge)),ge[1].push(ne.edit)}return[...A.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Z=Ae([B],Z),e.WorkspaceEdit=Z;let ie=a=class{static isSnippetString(A){return A instanceof a?!0:A?typeof A.value=="string":!1}static _escape(A){return A.replace(/\$|}|\\/g,"\\$&")}constructor(A){this._tabstop=1,this.value=A||""}appendText(A){return this.value+=a._escape(A),this}appendTabstop(A=this._tabstop++){return this.value+="$",this.value+=A,this}appendPlaceholder(A,ne=this._tabstop++){if(typeof A=="function"){const ge=new a;ge._tabstop=this._tabstop,A(ge),this._tabstop=ge._tabstop,A=ge.value}else A=a._escape(A);return this.value+="${",this.value+=ne,this.value+=":",this.value+=A,this.value+="}",this}appendChoice(A,ne=this._tabstop++){const ge=A.map(Ue=>Ue.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=ge,this.value+="|}",this}appendVariable(A,ne){if(typeof ne=="function"){const ge=new a;ge._tabstop=this._tabstop,ne(ge),this._tabstop=ge._tabstop,ne=ge.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=A,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};ie=a=Ae([B],ie),e.SnippetString=ie;var ue;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(ue=e.DiagnosticTag||(e.DiagnosticTag={}));var ve;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(ve=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let $=f=class{static isLocation(A){return A instanceof f?!0:A?j.isRange(A.range)&&C.URI.isUri(A.uri):!1}constructor(A,ne){if(this.uri=A,ne)if(j.isRange(ne))this.range=j.of(ne);else if(z.isPosition(ne))this.range=new j(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};$=f=Ae([B],$),e.Location=$;let Q=class{static is(A){return A?typeof A.message=="string"&&A.location&&j.isRange(A.location.range)&&C.URI.isUri(A.location.uri):!1}constructor(A,ne){this.location=A,this.message=ne}static isEqual(A,ne){return A===ne?!0:!A||!ne?!1:A.message===ne.message&&A.location.range.isEqual(ne.location.range)&&A.location.uri.toString()===ne.location.uri.toString()}};Q=Ae([B],Q),e.DiagnosticRelatedInformation=Q;let Y=class{constructor(A,ne,ge=ve.Error){if(!j.isRange(A))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=A,this.message=ne,this.severity=ge}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(A,ne){return A===ne?!0:!A||!ne?!1:A.message===ne.message&&A.severity===ne.severity&&A.code===ne.code&&A.severity===ne.severity&&A.source===ne.source&&A.range.isEqual(ne.range)&&(0,y.equals)(A.tags,ne.tags)&&(0,y.equals)(A.relatedInformation,ne.relatedInformation,Q.isEqual)}};Y=Ae([B],Y),e.Diagnostic=Y;let W=class{constructor(A,ne){if(!A)throw new Error("Illegal argument, contents must be defined");Array.isArray(A)?this.contents=A:this.contents=[A],this.range=ne}};W=Ae([B],W),e.Hover=W;var V;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(V=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let q=class{constructor(A,ne=V.Text){this.range=A,this.kind=ne}toJSON(){return{range:this.range,kind:V[this.kind]}}};q=Ae([B],q),e.DocumentHighlight=q;var X;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(X=e.SymbolKind||(e.SymbolKind={}));var le;(function(M){M[M.Deprecated=1]="Deprecated"})(le=e.SymbolTag||(e.SymbolTag={}));let pe=o=class{static validate(A){if(!A.name)throw new Error("name must not be falsy")}constructor(A,ne,ge,Ue,Ve){this.name=A,this.kind=ne,this.containerName=Ve,typeof ge=="string"&&(this.containerName=ge),Ue instanceof $?this.location=Ue:ge instanceof j&&(this.location=new $(Ue,ge)),o.validate(this)}toJSON(){return{name:this.name,kind:X[this.kind],location:this.location,containerName:this.containerName}}};pe=o=Ae([B],pe),e.SymbolInformation=pe;let ke=c=class{static validate(A){if(!A.name)throw new Error("name must not be falsy");if(!A.range.contains(A.selectionRange))throw new Error("selectionRange must be contained in fullRange");A.children?.forEach(c.validate)}constructor(A,ne,ge,Ue,Ve){this.name=A,this.detail=ne,this.kind=ge,this.range=Ue,this.selectionRange=Ve,this.children=[],c.validate(this)}};ke=c=Ae([B],ke),e.DocumentSymbol=ke;var Te;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(Te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Me=class{constructor(A,ne){this.title=A,this.kind=ne}};Me=Ae([B],Me),e.CodeAction=Me;let Oe=D=class{constructor(A){this.value=A}append(A){return new D(this.value?this.value+D.sep+A:A)}intersects(A){return this.contains(A)||A.contains(this)}contains(A){return this.value===A.value||A.value.startsWith(this.value+D.sep)}};Oe.sep=".",Oe=D=Ae([B],Oe),e.CodeActionKind=Oe,Oe.Empty=new Oe(""),Oe.QuickFix=Oe.Empty.append("quickfix"),Oe.Refactor=Oe.Empty.append("refactor"),Oe.RefactorExtract=Oe.Refactor.append("extract"),Oe.RefactorInline=Oe.Refactor.append("inline"),Oe.RefactorMove=Oe.Refactor.append("move"),Oe.RefactorRewrite=Oe.Refactor.append("rewrite"),Oe.Source=Oe.Empty.append("source"),Oe.SourceOrganizeImports=Oe.Source.append("organizeImports"),Oe.SourceFixAll=Oe.Source.append("fixAll");let me=class{constructor(A,ne){if(this.range=A,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};me=Ae([B],me),e.SelectionRange=me;class be{constructor(A,ne,ge,Ue,Ve,Ye){this.kind=A,this.name=ne,this.detail=ge,this.uri=Ue,this.range=Ve,this.selectionRange=Ye}}e.CallHierarchyItem=be;class Ee{constructor(A,ne){this.fromRanges=ne,this.from=A}}e.CallHierarchyIncomingCall=Ee;class Ne{constructor(A,ne){this.fromRanges=ne,this.to=A}}e.CallHierarchyOutgoingCall=Ne;var Be;(function(M){M[M.Information=0]="Information",M[M.Warning=1]="Warning",M[M.Error=2]="Error"})(Be=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ke=class{constructor(A,ne){this.range=A,this.command=ne}get isResolved(){return!!this.command}};Ke=Ae([B],Ke),e.CodeLens=Ke;let He=O=class{static isMarkdownString(A){return A instanceof O?!0:A&&A.appendCodeblock&&A.appendMarkdown&&A.appendText&&A.value!==void 0}constructor(A,ne=!1){p.set(this,void 0),Rt(this,p,new P.MarkdownString(A,{supportThemeIcons:ne}),"f")}get value(){return nt(this,p,"f").value}set value(A){nt(this,p,"f").value=A}get isTrusted(){return nt(this,p,"f").isTrusted}set isTrusted(A){nt(this,p,"f").isTrusted=A}get supportThemeIcons(){return nt(this,p,"f").supportThemeIcons}set supportThemeIcons(A){nt(this,p,"f").supportThemeIcons=A}get supportHtml(){return nt(this,p,"f").supportHtml}set supportHtml(A){nt(this,p,"f").supportHtml=A}get baseUri(){return nt(this,p,"f").baseUri}set baseUri(A){nt(this,p,"f").baseUri=A}appendText(A){return nt(this,p,"f").appendText(A),this}appendMarkdown(A){return nt(this,p,"f").appendMarkdown(A),this}appendCodeblock(A,ne){return nt(this,p,"f").appendCodeblock(ne??"",A),this}};p=new WeakMap,He=O=Ae([B],He),e.MarkdownString=He;let Ge=class{constructor(A,ne){this.label=A,this.documentation=ne}};Ge=Ae([B],Ge),e.ParameterInformation=Ge;let Xe=class{constructor(A,ne){this.label=A,this.documentation=ne,this.parameters=[]}};Xe=Ae([B],Xe),e.SignatureInformation=Xe;let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};et=Ae([B],et),e.SignatureHelp=et;var qe;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(qe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $e;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})($e=e.InlayHintKind||(e.InlayHintKind={}));let xe=class{constructor(A){this.value=A}};xe=Ae([B],xe),e.InlayHintLabelPart=xe;let he=class{constructor(A,ne,ge){this.position=A,this.label=ne,this.kind=ge}};he=Ae([B],he),e.InlayHint=he;var Ce;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(De=e.CompletionItemKind||(e.CompletionItemKind={}));var Re;(function(M){M[M.Deprecated=1]="Deprecated"})(Re=e.CompletionItemTag||(e.CompletionItemTag={}));let Fe=class{constructor(A,ne){this.label=A,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&De[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Fe=Ae([B],Fe),e.CompletionItem=Fe;let ze=class{constructor(A=[],ne=!1){this.items=A,this.isIncomplete=ne}};ze=Ae([B],ze),e.CompletionList=ze;let je=class{constructor(A,ne,ge){this.insertText=A,this.range=ne,this.command=ge}};je=Ae([B],je),e.InlineSuggestion=je;let rt=class{constructor(A){this.commands=void 0,this.items=A}};rt=Ae([B],rt),e.InlineSuggestionList=rt;let it=class{constructor(A,ne,ge){this.insertText=A,this.range=ne,this.command=ge}};it=Ae([B],it),e.InlineSuggestionNew=it;let Je=class{constructor(A,ne){this.items=A,this.commands=ne}};Je=Ae([B],Je),e.InlineSuggestionsNew=Je;var ot;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var lt;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ut;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative"})(ut=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ht;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(ht=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var bt;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(bt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var kt;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var At;(function(M){M[M.Undo=1]="Undo",M[M.Redo=2]="Redo"})(At=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ot;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(Ot=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(M){function A(ne){switch(ne){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=A}(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let pt=class{constructor(A,ne){if(ne&&!C.URI.isUri(ne))throw(0,t.illegalArgument)("target");if(!j.isRange(A)||A.isEmpty)throw(0,t.illegalArgument)("range");this.range=A,this.target=ne}};pt=Ae([B],pt),e.DocumentLink=pt;let Ct=class{constructor(A,ne,ge,Ue){this.red=A,this.green=ne,this.blue=ge,this.alpha=Ue}};Ct=Ae([B],Ct),e.Color=Ct;let st=class{constructor(A,ne){if(ne&&!(ne instanceof Ct))throw(0,t.illegalArgument)("color");if(!j.isRange(A)||A.isEmpty)throw(0,t.illegalArgument)("range");this.range=A,this.color=ne}};st=Ae([B],st),e.ColorInformation=st;let ft=class{constructor(A){if(!A||typeof A!="string")throw(0,t.illegalArgument)("label");this.label=A}};ft=Ae([B],ft),e.ColorPresentation=ft;var Se;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(Se=e.ColorFormat||(e.ColorFormat={}));var Ie;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(Ie=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var de;(function(M){M[M.Unknown=0]="Unknown",M[M.Shutdown=1]="Shutdown",M[M.Process=2]="Process",M[M.User=3]="User",M[M.Extension=4]="Extension"})(de=e.TerminalExitReason||(e.TerminalExitReason={}));class K{constructor(A,ne,ge){if(this.startIndex=A,this.length=ne,this.tooltip=ge,typeof A!="number"||A<0)throw(0,t.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,t.illegalArgument)("length");if(ge!==void 0&&typeof ge!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=K;var Pe;(function(M){M[M.Panel=1]="Panel",M[M.Editor=2]="Editor"})(Pe=e.TerminalLocation||(e.TerminalLocation={}));class Le{constructor(A){if(this.options=A,typeof A!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Le;var Qe;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(Qe=e.TaskRevealKind||(e.TaskRevealKind={}));var We;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(We=e.TaskPanelKind||(e.TaskPanelKind={}));let tt=H=class{static from(A){switch(A){case"clean":return H.Clean;case"build":return H.Build;case"rebuild":return H.Rebuild;case"test":return H.Test;default:return}}constructor(A,ne){if(this.label=ne,typeof A!="string"||typeof ne!="string")throw(0,t.illegalArgument)("name");this._id=A}get id(){return this._id}};tt.Clean=new H("clean","Clean"),tt.Build=new H("build","Build"),tt.Rebuild=new H("rebuild","Rebuild"),tt.Test=new H("test","Test"),tt=H=Ae([B],tt),e.TaskGroup=tt;function at(M){let A="";for(let ne=0;ne<M.length;ne++)A+=M[ne].replace(/,/g,",,")+",";return A}let Et=class{constructor(A,ne,ge){if(typeof A!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=A,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=ge):this._options=ne)}get process(){return this._process}set process(A){if(typeof A!="string")throw(0,t.illegalArgument)("process");this._process=A}get args(){return this._args}set args(A){Array.isArray(A)||(A=[]),this._args=A}get options(){return this._options}set options(A){this._options=A}computeId(){const A=[];if(A.push("process"),this._process!==void 0&&A.push(this._process),this._args&&this._args.length>0)for(const ne of this._args)A.push(ne);return at(A)}};Et=Ae([B],Et),e.ProcessExecution=Et;let dt=class{constructor(A,ne,ge){if(this._args=[],Array.isArray(ne)){if(!A)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof A!="string"&&typeof A.value!="string")throw(0,t.illegalArgument)("command");this._command=A,this._args=ne,this._options=ge}else{if(typeof A!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=A,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(A){if(typeof A!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=A}get command(){return this._command?this._command:""}set command(A){if(typeof A!="string"&&typeof A.value!="string")throw(0,t.illegalArgument)("command");this._command=A}get args(){return this._args}set args(A){this._args=A||[]}get options(){return this._options}set options(A){this._options=A}computeId(){const A=[];if(A.push("shell"),this._commandLine!==void 0&&A.push(this._commandLine),this._command!==void 0&&A.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ne of this._args)A.push(typeof ne=="string"?ne:ne.value);return at(A)}};dt=Ae([B],dt),e.ShellExecution=dt;var mt;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class bn{constructor(A){this._callback=A}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(A){this._callback=A}get callback(){return this._callback}}e.CustomExecution=bn;let Tt=re=class{constructor(A,ne,ge,Ue,Ve,Ye){this.__deprecated=!1,this._definition=this.definition=A;let Ze;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=ge,this.execution=Ue,Ze=Ve,this.__deprecated=!0):ne===vt.Global||ne===vt.Workspace?(this.target=ne,this._name=this.name=ge,this._source=this.source=Ue,this.execution=Ve,Ze=Ye):(this.target=ne,this._name=this.name=ge,this._source=this.source=Ue,this.execution=Ve,Ze=Ye),typeof Ze=="string"?(this._problemMatchers=[Ze],this._hasDefinedMatchers=!0):Array.isArray(Ze)?(this._problemMatchers=Ze,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(A){this.__id=A}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Et?this._definition={type:re.ProcessType,id:this._execution.computeId()}:this._execution instanceof dt?this._definition={type:re.ShellType,id:this._execution.computeId()}:this._execution instanceof bn?this._definition={type:re.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:re.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(A){if(A==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=A}get scope(){return this._scope}set target(A){this.clear(),this._scope=A}get name(){return this._name}set name(A){if(typeof A!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=A}get execution(){return this._execution}set execution(A){A===null&&(A=void 0),this.clear(),this._execution=A;const ne=this._definition.type;(re.EmptyType===ne||re.ProcessType===ne||re.ShellType===ne||re.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(A){if(Array.isArray(A))this.clear(),this._problemMatchers=A,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(A){A!==!0&&A!==!1&&(A=!1),this.clear(),this._isBackground=A}get source(){return this._source}set source(A){if(typeof A!="string"||A.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=A}get group(){return this._group}set group(A){A===null&&(A=void 0),this.clear(),this._group=A}get detail(){return this._detail}set detail(A){A===null&&(A=void 0),this._detail=A}get presentationOptions(){return this._presentationOptions}set presentationOptions(A){A==null&&(A=Object.create(null)),this.clear(),this._presentationOptions=A}get runOptions(){return this._runOptions}set runOptions(A){A==null&&(A=Object.create(null)),this.clear(),this._runOptions=A}};Tt.ExtensionCallbackType="customExecution",Tt.ProcessType="process",Tt.ShellType="shell",Tt.EmptyType="$empty",Tt=re=Ae([B],Tt),e.Task=Tt;var In;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(In=e.ProgressLocation||(e.ProgressLocation={}));var Dn;(function(M){function A(ne){const ge=ne;return(0,E.isNumber)(ge.value)?ge.tooltip&&!(0,E.isString)(ge.tooltip)?(console.log("INVALID view badge, invalid tooltip",ge.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ge.value),!1)}M.isViewBadge=A})(Dn=e.ViewBadge||(e.ViewBadge={}));let zt=ce=class{static isTreeItem(A,ne){if(A instanceof ce)return!0;const ge=A;if(ge.label!==void 0&&!(0,E.isString)(ge.label)&&!ge.label?.label)return console.log("INVALID tree item, invalid label",ge.label),!1;if(ge.id!==void 0&&!(0,E.isString)(ge.id))return console.log("INVALID tree item, invalid id",ge.id),!1;if(ge.iconPath!==void 0&&!(0,E.isString)(ge.iconPath)&&!C.URI.isUri(ge.iconPath)&&(!ge.iconPath||!(0,E.isString)(ge.iconPath.id))){const Ue=ge.iconPath;if(!Ue||!(0,E.isString)(Ue.light)&&!C.URI.isUri(Ue.light)&&!(0,E.isString)(Ue.dark)&&!C.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",ge.iconPath),!1}if(ge.description!==void 0&&!(0,E.isString)(ge.description)&&typeof ge.description!="boolean")return console.log("INVALID tree item, invalid description",ge.description),!1;if(ge.resourceUri!==void 0&&!C.URI.isUri(ge.resourceUri))return console.log("INVALID tree item, invalid resourceUri",ge.resourceUri),!1;if(ge.tooltip!==void 0&&!(0,E.isString)(ge.tooltip)&&!(ge.tooltip instanceof He))return console.log("INVALID tree item, invalid tooltip",ge.tooltip),!1;if(ge.command!==void 0&&!ge.command.command)return console.log("INVALID tree item, invalid command",ge.command),!1;if(ge.collapsibleState!==void 0&&ge.collapsibleState<Mt.None&&ge.collapsibleState>Mt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",ge.collapsibleState),!1;if(ge.contextValue!==void 0&&!(0,E.isString)(ge.contextValue))return console.log("INVALID tree item, invalid contextValue",ge.contextValue),!1;if(ge.accessibilityInformation!==void 0&&!ge.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",ge.accessibilityInformation),!1;if(ge.checkboxState!==void 0){(0,d.checkProposedApiEnabled)(ne,"treeItemCheckbox");const Ue=(0,E.isNumber)(ge.checkboxState)?ge.checkboxState:(0,E.isObject)(ge.checkboxState)&&(0,E.isNumber)(ge.checkboxState.state)?ge.checkboxState.state:void 0,Ve=!(0,E.isNumber)(ge.checkboxState)&&(0,E.isObject)(ge.checkboxState)?ge.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==Ht.Checked&&Ue!==Ht.Unchecked||Ve!==void 0&&!(0,E.isString)(Ve))return console.log("INVALID tree item, invalid checkboxState",ge.checkboxState),!1}return!0}constructor(A,ne=Mt.None){this.collapsibleState=ne,C.URI.isUri(A)?this.resourceUri=A:this.label=A}};zt=ce=Ae([B],zt),e.TreeItem=zt;var Mt;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(Mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Ht;(function(M){M[M.Unchecked=0]="Unchecked",M[M.Checked=1]="Checked"})(Ht=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(A,ne){this.value=A,this.id=ne??(0,T.generateUuid)()}};Vt=Ae([B],Vt),e.DataTransferItem=Vt;let jt=class{constructor(A){m.set(this,new Map);for(const[ne,ge]of A??[]){const Ue=nt(this,m,"f").get(ne);Ue?Ue.push(ge):nt(this,m,"f").set(ne,[ge])}}get(A){return nt(this,m,"f").get(A)?.[0]}set(A,ne){nt(this,m,"f").set(A,[ne])}forEach(A,ne){for(const[ge,Ue]of nt(this,m,"f"))for(const Ve of Ue)A.call(ne,Ve,ge,this)}*[(m=new WeakMap,Symbol.iterator)](){for(const[A,ne]of nt(this,m,"f"))for(const ge of ne)yield[A,ge]}};jt=Ae([B],jt),e.DataTransfer=jt;let qt=class{constructor(A){this.insertText=A}};qt=Ae([B],qt),e.DocumentDropEdit=qt;let xt=class{constructor(A){this.insertText=A}};xt=Ae([B],xt),e.DocumentPasteEdit=xt;let Dt=class{constructor(A,ne){this.id=A,this.color=ne}};Dt=Ae([B],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let Gt=class{constructor(A){this.id=A}};Gt=Ae([B],Gt),e.ThemeColor=Gt;var Pn;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(Pn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Kt=class{get base(){return this._base}set base(A){this._base=A,this._baseUri=C.URI.file(A)}get baseUri(){return this._baseUri}set baseUri(A){this._baseUri=A,this._base=A.fsPath}constructor(A,ne){if(typeof A!="string"&&(!A||!C.URI.isUri(A)&&!C.URI.isUri(A.uri)))throw(0,t.illegalArgument)("base");if(typeof ne!="string")throw(0,t.illegalArgument)("pattern");typeof A=="string"?this.baseUri=C.URI.file(A):C.URI.isUri(A)?this.baseUri=A:this.baseUri=A.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Kt=Ae([B],Kt),e.RelativePattern=Kt;let _t=class{constructor(A,ne,ge,Ue){this.enabled=typeof A=="boolean"?A:!0,typeof ne=="string"&&(this.condition=ne),typeof ge=="string"&&(this.hitCondition=ge),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};_t=Ae([B],_t),e.Breakpoint=_t;let Qt=class extends _t{constructor(A,ne,ge,Ue,Ve){if(super(ne,ge,Ue,Ve),A===null)throw(0,t.illegalArgument)("location");this.location=A}};Qt=Ae([B],Qt),e.SourceBreakpoint=Qt;let Xt=class extends _t{constructor(A,ne,ge,Ue,Ve){super(ne,ge,Ue,Ve),this.functionName=A}};Xt=Ae([B],Xt),e.FunctionBreakpoint=Xt;let Yt=class extends _t{constructor(A,ne,ge,Ue,Ve,Ye,Ze){if(super(Ue,Ve,Ye,Ze),!ne)throw(0,t.illegalArgument)("dataId");this.label=A,this.dataId=ne,this.canPersist=ge}};Yt=Ae([B],Yt),e.DataBreakpoint=Yt;let Jt=class{constructor(A,ne,ge){this.command=A,this.args=ne||[],this.options=ge}};Jt=Ae([B],Jt),e.DebugAdapterExecutable=Jt;let Zt=class{constructor(A,ne){this.port=A,this.host=ne}};Zt=Ae([B],Zt),e.DebugAdapterServer=Zt;let en=class{constructor(A){this.path=A}};en=Ae([B],en),e.DebugAdapterNamedPipeServer=en;let tn=class{constructor(A){this.implementation=A}};tn=Ae([B],tn),e.DebugAdapterInlineImplementation=tn;let nn=class{constructor(A,ne){this.range=A,this.expression=ne}};nn=Ae([B],nn),e.EvaluatableExpression=nn;var kn;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(kn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Tn;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(Tn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let rn=class{constructor(A,ne){this.range=A,this.text=ne}};rn=Ae([B],rn),e.InlineValueText=rn;let sn=class{constructor(A,ne,ge=!0){this.range=A,this.variableName=ne,this.caseSensitiveLookup=ge}};sn=Ae([B],sn),e.InlineValueVariableLookup=sn;let on=class{constructor(A,ne){this.range=A,this.expression=ne}};on=Ae([B],on),e.InlineValueEvaluatableExpression=on;let an=class{constructor(A,ne){this.frameId=A,this.stoppedLocation=ne}};an=Ae([B],an),e.InlineValueContext=an;var Rn;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(Rn=e.FileChangeType||(e.FileChangeType={}));let ln=ae=class extends Error{static FileExists(A){return new ae(A,R.FileSystemProviderErrorCode.FileExists,ae.FileExists)}static FileNotFound(A){return new ae(A,R.FileSystemProviderErrorCode.FileNotFound,ae.FileNotFound)}static FileNotADirectory(A){return new ae(A,R.FileSystemProviderErrorCode.FileNotADirectory,ae.FileNotADirectory)}static FileIsADirectory(A){return new ae(A,R.FileSystemProviderErrorCode.FileIsADirectory,ae.FileIsADirectory)}static NoPermissions(A){return new ae(A,R.FileSystemProviderErrorCode.NoPermissions,ae.NoPermissions)}static Unavailable(A){return new ae(A,R.FileSystemProviderErrorCode.Unavailable,ae.Unavailable)}constructor(A,ne=R.FileSystemProviderErrorCode.Unknown,ge){super(C.URI.isUri(A)?A.toString(!0):A),this.code=ge?.name??"Unknown",(0,R.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ae.prototype),typeof Error.captureStackTrace=="function"&&typeof ge=="function"&&Error.captureStackTrace(this,ge)}};ln=ae=Ae([B],ln),e.FileSystemError=ln;let cn=class{constructor(A,ne,ge){this.start=A,this.end=ne,this.kind=ge}};cn=Ae([B],cn),e.FoldingRange=cn;var An;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(An=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _n;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(_n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ln;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(Ln=e.CommentMode||(e.CommentMode={}));var On;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(On=e.CommentThreadState||(e.CommentThreadState={}));class Fn{constructor(A,ne=[]){this.tokenTypes=A,this.tokenModifiers=ne}}e.SemanticTokensLegend=Fn;function Nn(M){return typeof M>"u"||(0,E.isStringArray)(M)}class un{constructor(A){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,A){this._hasLegend=!0;for(let ne=0,ge=A.tokenTypes.length;ne<ge;ne++)this._tokenTypeStrToInt.set(A.tokenTypes[ne],ne);for(let ne=0,ge=A.tokenModifiers.length;ne<ge;ne++)this._tokenModifierStrToInt.set(A.tokenModifiers[ne],ne)}}push(A,ne,ge,Ue,Ve){if(typeof A=="number"&&typeof ne=="number"&&typeof ge=="number"&&typeof Ue=="number"&&(typeof Ve=="number"||typeof Ve>"u"))return typeof Ve>"u"&&(Ve=0),this._pushEncoded(A,ne,ge,Ue,Ve);if(j.isRange(A)&&typeof ne=="string"&&Nn(ge))return this._push(A,ne,ge);throw(0,t.illegalArgument)()}_push(A,ne,ge){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(A.start.line!==A.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ue=A.start.line,Ve=A.start.character,Ye=A.end.character-A.start.character,Ze=this._tokenTypeStrToInt.get(ne);let ct=0;if(ge)for(const gt of ge){if(!this._tokenModifierStrToInt.has(gt))throw new Error("`tokenModifier` is not in the provided legend");const yt=this._tokenModifierStrToInt.get(gt);ct|=1<<yt>>>0}this._pushEncoded(Ue,Ve,Ye,Ze,ct)}_pushEncoded(A,ne,ge,Ue,Ve){if(this._dataIsSortedAndDeltaEncoded&&(A<this._prevLine||A===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const ct=this._data.length/5|0;let gt=0,yt=0;for(let St=0;St<ct;St++){let It=this._data[5*St],Ft=this._data[5*St+1];It===0?(It=gt,Ft+=yt):It+=gt,this._data[5*St]=It,this._data[5*St+1]=Ft,gt=It,yt=Ft}}let Ye=A,Ze=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ye-=this._prevLine,Ye===0&&(Ze-=this._prevChar)),this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=ge,this._data[this._dataLen++]=Ue,this._data[this._dataLen++]=Ve,this._prevLine=A,this._prevChar=ne}static _sortAndDeltaEncode(A){const ne=[],ge=A.length/5|0;for(let Ze=0;Ze<ge;Ze++)ne[Ze]=Ze;ne.sort((Ze,ct)=>{const gt=A[5*Ze],yt=A[5*ct];if(gt===yt){const St=A[5*Ze+1],It=A[5*ct+1];return St-It}return gt-yt});const Ue=new Uint32Array(A.length);let Ve=0,Ye=0;for(let Ze=0;Ze<ge;Ze++){const ct=5*ne[Ze],gt=A[ct+0],yt=A[ct+1],St=A[ct+2],It=A[ct+3],Ft=A[ct+4],Cn=gt-Ve,yi=Cn===0?yt-Ye:yt,Nt=5*Ze;Ue[Nt+0]=Cn,Ue[Nt+1]=yi,Ue[Nt+2]=St,Ue[Nt+3]=It,Ue[Nt+4]=Ft,Ve=gt,Ye=yt}return Ue}build(A){return this._dataIsSortedAndDeltaEncoded?new fn(new Uint32Array(this._data),A):new fn(un._sortAndDeltaEncode(this._data),A)}}e.SemanticTokensBuilder=un;class fn{constructor(A,ne){this.resultId=ne,this.data=A}}e.SemanticTokens=fn;class Mn{constructor(A,ne,ge){this.start=A,this.deleteCount=ne,this.data=ge}}e.SemanticTokensEdit=Mn;class Un{constructor(A,ne){this.resultId=ne,this.edits=A}}e.SemanticTokensEdits=Un;var Bn;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(Bn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Ut=class{constructor(){}};Ut.Back={iconPath:new Dt("arrow-left")},Ut=Ae([B],Ut),e.QuickInputButtons=Ut;var Wn;(function(M){M[M.Separator=-1]="Separator",M[M.Default=0]="Default"})(Wn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var $n;(function(M){M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})($n=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var zn;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(zn=e.ExtensionKind||(e.ExtensionKind={}));class Hn{static validate(A){if(A.badge){let ne=(0,b.nextCharLength)(A.badge,0);if(ne<A.badge.length&&(ne+=(0,b.nextCharLength)(A.badge,ne)),A.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}if(!A.color&&!A.badge&&!A.tooltip)throw new Error("The decoration is empty");return!0}constructor(A,ne,ge){this.badge=A,this.tooltip=ne,this.color=ge}}e.FileDecoration=Hn;let hn=class{constructor(A){this.kind=A}};hn=Ae([B],hn),e.ColorTheme=hn;var Vn;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast",M[M.HighContrastLight=4]="HighContrastLight"})(Vn=e.ColorThemeKind||(e.ColorThemeKind={}));class Pt{static isNotebookRange(A){return A instanceof Pt?!0:A?typeof A.start=="number"&&typeof A.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(A,ne){if(A<0)throw(0,t.illegalArgument)("start must be positive");if(ne<0)throw(0,t.illegalArgument)("end must be positive");A<=ne?(this._start=A,this._end=ne):(this._start=ne,this._end=A)}with(A){let ne=this._start,ge=this._end;return A.start!==void 0&&(ne=A.start),A.end!==void 0&&(ge=A.end),ne===this._start&&ge===this._end?this:new Pt(ne,ge)}}e.NotebookRange=Pt;class Bt{static validate(A){if(typeof A.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof A.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof A.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(A){return Array.isArray(A)&&A.every(ne=>Bt.isNotebookCellData(ne))}static isNotebookCellData(A){return!0}constructor(A,ne,ge,Ue,Ve,Ye,Ze){this.kind=A,this.value=ne,this.languageId=ge,this.mime=Ue,this.outputs=Ve??[],this.metadata=Ye,this.executionSummary=Ze,Bt.validate(this)}}e.NotebookCellData=Bt;class jn{constructor(A){this.cells=A}}e.NotebookData=jn;class wt{static isNotebookCellOutputItem(A){return A instanceof wt?!0:A?typeof A.mime=="string"&&A.data instanceof Uint8Array:!1}static error(A){const ne={name:A.name,message:A.message,stack:A.stack};return wt.json(ne,"application/vnd.code.notebook.error")}static stdout(A){return wt.text(A,"application/vnd.code.notebook.stdout")}static stderr(A){return wt.text(A,"application/vnd.code.notebook.stderr")}static bytes(A,ne="application/octet-stream"){return new wt(A,ne)}static text(A,ne=k.Mimes.text){const ge=nt(wt,v,"f",u).encode(String(A));return new wt(ge,ne)}static json(A,ne="text/x-json"){const ge=JSON.stringify(A,void 0,"	");return wt.text(ge,ne)}constructor(A,ne){this.data=A,this.mime=ne;const ge=(0,k.normalizeMimeType)(ne,!0);if(!ge)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ge}}e.NotebookCellOutputItem=wt,v=wt,u={value:new TextEncoder};class Wt{static isNotebookCellOutput(A){return A instanceof Wt?!0:!A||typeof A!="object"?!1:typeof A.id=="string"&&Array.isArray(A.items)}static ensureUniqueMimeTypes(A,ne=!1){const ge=new Set,Ue=new Set;for(let Ve=0;Ve<A.length;Ve++){const Ye=A[Ve],Ze=(0,k.normalizeMimeType)(Ye.mime);if(!ge.has(Ze)||(0,w.isTextStreamMime)(Ze)){ge.add(Ze);continue}Ue.add(Ve),ne&&console.warn(`DUPLICATED mime type '${Ye.mime}' will be dropped`)}return Ue.size===0?A:A.filter((Ve,Ye)=>!Ue.has(Ye))}constructor(A,ne,ge){this.items=Wt.ensureUniqueMimeTypes(A,!0),typeof ne=="string"?(this.id=ne,this.metadata=ge):(this.id=(0,T.generateUuid)(),this.metadata=ne??ge)}}e.NotebookCellOutput=Wt;var qn;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(qn=e.NotebookCellKind||(e.NotebookCellKind={}));var xn;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(xn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Gn;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Kn;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(Kn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Qn{constructor(A,ne){this.text=A,this.alignment=ne}}e.NotebookCellStatusBarItem=Qn;var Xn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(Xn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Yn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred",M[M.Hidden=-1]="Hidden"})(Yn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Jn{constructor(A,ne=[]){this.uri=A,this.provides=(0,y.asArray)(ne)}}e.NotebookRendererScript=Jn;let dn=class{constructor(A,ne){this.label=A,this.timestamp=ne}};dn=Ae([B],dn),e.TimelineItem=dn;var Zn;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(Zn=e.ExtensionMode||(e.ExtensionMode={}));var ei;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(ei=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ti;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(ti=e.StandardTokenType||(e.StandardTokenType={}));class ni{constructor(A,ne){this.ranges=A,this.wordPattern=ne}}e.LinkedEditingRanges=ni;class ii{constructor(A,ne){this._port=A,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ii;var ri;(function(M){M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(ri=e.TestResultState||(e.TestResultState={}));var si;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(si=e.TestRunProfileKind||(e.TestRunProfileKind={}));let mn=class{constructor(A=void 0,ne=void 0,ge=void 0){this.include=A,this.exclude=ne,this.profile=ge}};mn=Ae([B],mn),e.TestRunRequest=mn;let gn=N=class{static diff(A,ne,ge){const Ue=new N(A);return Ue.expectedOutput=ne,Ue.actualOutput=ge,Ue}constructor(A){this.message=A}};gn=N=Ae([B],gn),e.TestMessage=gn;let pn=class{constructor(A){this.id=A}};pn=Ae([B],pn),e.TestTag=pn;let Lt=class{constructor(A,ne){this.covered=A,this.total=ne}};Lt=Ae([B],Lt),e.CoveredCount=Lt;let vn=J=class{static fromDetails(A,ne){const ge=new Lt(0,0),Ue=new Lt(0,0),Ve=new Lt(0,0);for(const Ze of ne)if("branches"in Ze){ge.total+=1,ge.covered+=Ze.executionCount>0?1:0;for(const ct of Ze.branches)Ue.total+=1,Ue.covered+=ct.executionCount>0?1:0}else Ve.total+=1,Ve.covered+=Ze.executionCount>0?1:0;const Ye=new J(A,ge,Ue.total>0?Ue:void 0,Ve.total>0?Ve:void 0);return Ye.detailedCoverage=ne,Ye}constructor(A,ne,ge,Ue){this.uri=A,this.statementCoverage=ne,this.branchCoverage=ge,this.functionCoverage=Ue}};vn=J=Ae([B],vn),e.FileCoverage=vn;let wn=class{constructor(A,ne,ge=[]){this.executionCount=A,this.location=ne,this.branches=ge}};wn=Ae([B],wn),e.StatementCoverage=wn;let yn=class{constructor(A,ne){this.executionCount=A,this.location=ne}};yn=Ae([B],yn),e.BranchCoverage=yn;let En=class{constructor(A,ne){this.executionCount=A,this.location=ne}};En=Ae([B],En),e.FunctionCoverage=En;var oi;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(oi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ai;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(ai=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var li;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore",M[M.OpenBrowserOnce=6]="OpenBrowserOnce"})(li=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ci{constructor(A,ne,ge,Ue,Ve,Ye){this.kind=A,this.name=ne,this.detail=ge,this.uri=Ue,this.range=Ve,this.selectionRange=Ye}}e.TypeHierarchyItem=ci;class ui{constructor(A){this.uri=A}}e.TextTabInput=ui;class fi{constructor(A,ne){this.original=A,this.modified=ne}}e.TextDiffTabInput=fi;class hi{constructor(A,ne,ge,Ue){this.base=A,this.input1=ne,this.input2=ge,this.result=Ue}}e.TextMergeTabInput=hi;class di{constructor(A,ne){this.uri=A,this.viewType=ne}}e.CustomEditorTabInput=di;class mi{constructor(A){this.viewType=A}}e.WebviewEditorTabInput=mi;class gi{constructor(A,ne){this.uri=A,this.notebookType=ne}}e.NotebookEditorTabInput=gi;class pi{constructor(A,ne,ge){this.original=A,this.modified=ne,this.notebookType=ge}}e.NotebookDiffEditorTabInput=pi;class vi{constructor(){}}e.TerminalEditorTabInput=vi;class wi{constructor(A,ne){this.uri=A,this.inputBoxUri=ne}}e.InteractiveWindowInput=wi}),define(we[130],ye([1,0,18,16,93,31,138,47,22,13,4,46,159,213,125,82,121,65,83,127,129,66]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m,v,u,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(Se){function Ie(K){const{selectionStartLineNumber:Pe,selectionStartColumn:Le,positionLineNumber:Qe,positionColumn:We}=K,tt=new l.Position(Pe-1,Le-1),at=new l.Position(Qe-1,We-1);return new l.Selection(tt,at)}Se.to=Ie;function de(K){const{anchor:Pe,active:Le}=K;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Se.from=de})(i=e.Selection||(e.Selection={}));var r;(function(Se){function Ie(K){if(!K)return;const{start:Pe,end:Le}=K;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Se.from=Ie;function de(K){if(!K)return;const{startLineNumber:Pe,startColumn:Le,endLineNumber:Qe,endColumn:We}=K;return new l.Range(Pe-1,Le-1,Qe-1,We-1)}Se.to=de})(r=e.Range||(e.Range={}));var n;(function(Se){function Ie(de){switch(de){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Se.to=Ie})(n=e.TokenType||(e.TokenType={}));var s;(function(Se){function Ie(K){return new l.Position(K.lineNumber-1,K.column-1)}Se.to=Ie;function de(K){return{lineNumber:K.line+1,column:K.character+1}}Se.from=de})(s=e.Position||(e.Position={}));var a;(function(Se){function Ie(Pe,Le){return(0,y.coalesce)((0,y.asArray)(Pe).map(Qe=>de(Qe,Le)))}Se.from=Ie;function de(Pe,Le){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:K(Pe.scheme,Le),pattern:$e.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function K(Pe,Le){return Le&&typeof Pe=="string"?Le.transformOutgoingScheme(Pe):Pe}})(a=e.DocumentSelector||(e.DocumentSelector={}));var f;(function(Se){function Ie(K){switch(K){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Se.from=Ie;function de(K){switch(K){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Se.to=de})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(Se){function Ie(K){let Pe;return K.code&&((0,C.isString)(K.code)||(0,C.isNumber)(K.code)?Pe=String(K.code):Pe={value:String(K.code.value),target:K.code.target}),{...r.from(K.range),message:K.message,source:K.source,code:Pe,severity:D.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(c.from),tags:Array.isArray(K.tags)?(0,y.coalesce)(K.tags.map(f.from)):void 0}}Se.from=Ie;function de(K){const Pe=new l.Diagnostic(r.to(K),K.message,D.to(K.severity));return Pe.source=K.source,Pe.code=(0,C.isString)(K.code)?K.code:K.code?.value,Pe.relatedInformation=K.relatedInformation&&K.relatedInformation.map(c.to),Pe.tags=K.tags&&(0,y.coalesce)(K.tags.map(f.to)),Pe}Se.to=de})(o=e.Diagnostic||(e.Diagnostic={}));var c;(function(Se){function Ie(K){return{...r.from(K.location.range),message:K.message,resource:K.location.uri}}Se.from=Ie;function de(K){return new l.DiagnosticRelatedInformation(new l.Location(K.resource,r.to(K)),K.message)}Se.to=de})(c=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var D;(function(Se){function Ie(K){switch(K){case l.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}Se.from=Ie;function de(K){switch(K){case w.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Se.to=de})(D=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var O;(function(Se){function Ie(K){return typeof K=="number"&&K>=l.ViewColumn.One?K-1:K===l.ViewColumn.Beside?u.SIDE_GROUP:u.ACTIVE_GROUP}Se.from=Ie;function de(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=de})(O=e.ViewColumn||(e.ViewColumn={}));function H(Se){return typeof Se.range<"u"}function re(Se){return Se.length===0?!0:!!H(Se[0])}e.isDecorationOptionsArr=re;var ce;(function(Se){function Ie(We){return We.map(Se.from)}Se.fromMany=Ie;function de(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function K(We){let tt;if(de(We)){const{language:mt,value:vt}=We;tt={value:"```"+mt+`
`+vt+"\n```\n"}}else l.MarkdownString.isMarkdownString(We)?tt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?tt={value:We}:tt={value:""};const at=Object.create(null);tt.uris=at;const Et=mt=>{try{let vt=T.URI.parse(mt,!0);vt=vt.with({query:Pe(vt.query,at)}),at[mt]=vt}catch{}return""},dt=new k.marked.Renderer;return dt.link=Et,dt.image=mt=>typeof mt=="string"?Et(P.parseHrefAndDimensions(mt).href):"",(0,k.marked)(tt.value,{renderer:dt}),tt}Se.from=K;function Pe(We,tt){if(!We)return We;let at;try{at=(0,b.parse)(We)}catch{}if(!at)return We;let Et=!1;return at=(0,E.cloneAndChange)(at,dt=>{if(T.URI.isUri(dt)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[mt]=dt,Et=!0,mt}else return}),Et?JSON.stringify(at):We}function Le(We){const tt=new l.MarkdownString(We.value,We.supportThemeIcons);return tt.isTrusted=We.isTrusted,tt.supportHtml=We.supportHtml,tt.baseUri=We.baseUri?T.URI.from(We.baseUri):void 0,tt}Se.to=Le;function Qe(We){if(!!We)return typeof We=="string"?We:Se.from(We)}Se.fromStrict=Qe})(ce=e.MarkdownString||(e.MarkdownString={}));function ae(Se){return re(Se)?Se.map(Ie=>({range:r.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?ce.fromMany(Ie.hoverMessage):Ie.hoverMessage?ce.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Se.map(Ie=>({range:r.from(Ie)}))}e.fromRangeOrRangeWithMessage=ae;function N(Se){return typeof Se>"u"?Se:typeof Se=="string"?T.URI.file(Se):Se}e.pathOrURIToURI=N;var J;(function(Se){function Ie(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?N(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Se.from=Ie})(J=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(Se){function Ie(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?N(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?J.from(de.before):void 0,after:de.after?J.from(de.after):void 0}}Se.from=Ie})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(Se){function Ie(de){if(typeof de>"u")return de;switch(de){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Ie})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(Se){function Ie(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?x.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?B.from(de.light):void 0,dark:de.dark?B.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?N(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?J.from(de.before):void 0,after:de.after?J.from(de.after):void 0}}Se.from=Ie})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var j;(function(Se){function Ie(K){return{text:K.newText,eol:K.newEol&&He.from(K.newEol),range:r.from(K.range)}}Se.from=Ie;function de(K){const Pe=new l.TextEdit(r.to(K.range),K.text);return Pe.newEol=typeof K.eol>"u"?void 0:He.to(K.eol),Pe}Se.to=de})(j=e.TextEdit||(e.TextEdit={}));var L;(function(Se){function Ie(K,Pe){const Le={edits:[]};if(K instanceof l.WorkspaceEdit){const Qe=new I.ResourceSet;for(const We of K._allEntries())We._type===1&&T.URI.isUri(We.to)&&We.from===void 0&&Qe.add(We.to);for(const We of K._allEntries())We._type===1?Le.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contentsBase64:We.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(We.options.contents))},metadata:We.metadata}):We._type===2?Le.edits.push({resource:We.uri,textEdit:j.from(We.edit),versionId:Qe.has(We.uri)?void 0:Pe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Le.edits.push({resource:We.uri,textEdit:{range:r.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Qe.has(We.uri)?void 0:Pe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Le.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Le.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(ze.from)}})}return Le}Se.from=Ie;function de(K){const Pe=new l.WorkspaceEdit;for(const Le of K.edits)Le.textEdit?Pe.replace(T.URI.revive(Le.resource),r.to(Le.textEdit.range),Le.textEdit.text):Pe.renameFile(T.URI.revive(Le.oldResource),T.URI.revive(Le.newResource),Le.options);return Pe}Se.to=de})(L=e.WorkspaceEdit||(e.WorkspaceEdit={}));var F;(function(Se){const Ie=Object.create(null);Ie[l.SymbolKind.File]=0,Ie[l.SymbolKind.Module]=1,Ie[l.SymbolKind.Namespace]=2,Ie[l.SymbolKind.Package]=3,Ie[l.SymbolKind.Class]=4,Ie[l.SymbolKind.Method]=5,Ie[l.SymbolKind.Property]=6,Ie[l.SymbolKind.Field]=7,Ie[l.SymbolKind.Constructor]=8,Ie[l.SymbolKind.Enum]=9,Ie[l.SymbolKind.Interface]=10,Ie[l.SymbolKind.Function]=11,Ie[l.SymbolKind.Variable]=12,Ie[l.SymbolKind.Constant]=13,Ie[l.SymbolKind.String]=14,Ie[l.SymbolKind.Number]=15,Ie[l.SymbolKind.Boolean]=16,Ie[l.SymbolKind.Array]=17,Ie[l.SymbolKind.Object]=18,Ie[l.SymbolKind.Key]=19,Ie[l.SymbolKind.Null]=20,Ie[l.SymbolKind.EnumMember]=21,Ie[l.SymbolKind.Struct]=22,Ie[l.SymbolKind.Event]=23,Ie[l.SymbolKind.Operator]=24,Ie[l.SymbolKind.TypeParameter]=25;function de(Pe){return typeof Ie[Pe]=="number"?Ie[Pe]:6}Se.from=de;function K(Pe){for(const Le in Ie)if(Ie[Le]===Pe)return Number(Le);return l.SymbolKind.Property}Se.to=K})(F=e.SymbolKind||(e.SymbolKind={}));var G;(function(Se){function Ie(K){switch(K){case l.SymbolTag.Deprecated:return 1}}Se.from=Ie;function de(K){switch(K){case 1:return l.SymbolTag.Deprecated}}Se.to=de})(G=e.SymbolTag||(e.SymbolTag={}));var oe;(function(Se){function Ie(K){return{name:K.name,kind:F.from(K.kind),tags:K.tags&&K.tags.map(G.from),containerName:K.containerName,location:U.from(K.location)}}Se.from=Ie;function de(K){const Pe=new l.SymbolInformation(K.name,F.to(K.kind),K.containerName,U.to(K.location));return Pe.tags=K.tags&&K.tags.map(G.to),Pe}Se.to=de})(oe=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var fe;(function(Se){function Ie(K){const Pe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:r.from(K.range),selectionRange:r.from(K.selectionRange),kind:F.from(K.kind),tags:K.tags?.map(G.from)??[]};return K.children&&(Pe.children=K.children.map(Ie)),Pe}Se.from=Ie;function de(K){const Pe=new l.DocumentSymbol(K.name,K.detail,F.to(K.kind),r.to(K.range),r.to(K.selectionRange));return(0,y.isNonEmptyArray)(K.tags)&&(Pe.tags=K.tags.map(G.to)),K.children&&(Pe.children=K.children.map(de)),Pe}Se.to=de})(fe=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(Se){function Ie(K){const Pe=new l.CallHierarchyItem(F.to(K.kind),K.name,K.detail||"",T.URI.revive(K.uri),r.to(K.range),r.to(K.selectionRange));return Pe._sessionId=K._sessionId,Pe._itemId=K._itemId,Pe}Se.to=Ie;function de(K,Pe,Le){if(Pe=Pe??K._sessionId,Le=Le??K._itemId,Pe===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Le,name:K.name,detail:K.detail,kind:F.from(K.kind),uri:K.uri,range:r.from(K.range),selectionRange:r.from(K.selectionRange),tags:K.tags?.map(G.from)}}Se.from=de})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var te;(function(Se){function Ie(de){return new l.CallHierarchyIncomingCall(ee.to(de.from),de.fromRanges.map(K=>r.to(K)))}Se.to=Ie})(te=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var _;(function(Se){function Ie(de){return new l.CallHierarchyOutgoingCall(ee.to(de.to),de.fromRanges.map(K=>r.to(K)))}Se.to=Ie})(_=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(Se){function Ie(K){return{range:K.range&&r.from(K.range),uri:K.uri}}Se.from=Ie;function de(K){return new l.Location(T.URI.revive(K.uri),r.to(K.range))}Se.to=de})(U=e.location||(e.location={}));var Z;(function(Se){function Ie(K){const Pe=K,Le=K;return{originSelectionRange:Pe.originSelectionRange?r.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Le.uri,range:r.from(Pe.targetRange?Pe.targetRange:Le.range),targetSelectionRange:Pe.targetSelectionRange?r.from(Pe.targetSelectionRange):void 0}}Se.from=Ie;function de(K){return{targetUri:T.URI.revive(K.uri),targetRange:r.to(K.range),targetSelectionRange:K.targetSelectionRange?r.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?r.to(K.originSelectionRange):void 0}}Se.to=de})(Z=e.DefinitionLink||(e.DefinitionLink={}));var ie;(function(Se){function Ie(K){return{range:r.from(K.range),contents:ce.fromMany(K.contents)}}Se.from=Ie;function de(K){return new l.Hover(K.contents.map(ce.to),r.to(K.range))}Se.to=de})(ie=e.Hover||(e.Hover={}));var ue;(function(Se){function Ie(K){return{range:r.from(K.range),expression:K.expression}}Se.from=Ie;function de(K){return new l.EvaluatableExpression(r.to(K.range),K.expression)}Se.to=de})(ue=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(Se){function Ie(K){if(K instanceof l.InlineValueText)return{type:"text",range:r.from(K.range),text:K.text};if(K instanceof l.InlineValueVariableLookup)return{type:"variable",range:r.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Ie;function de(K){switch(K.type){case"text":return{range:r.to(K.range),text:K.text};case"variable":return{range:r.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:r.to(K.range),expression:K.expression}}}Se.to=de})(ve=e.InlineValue||(e.InlineValue={}));var $;(function(Se){function Ie(K){return{frameId:K.frameId,stoppedLocation:r.from(K.stoppedLocation)}}Se.from=Ie;function de(K){return new l.InlineValueContext(K.frameId,r.to(K.stoppedLocation))}Se.to=de})($=e.InlineValueContext||(e.InlineValueContext={}));var Q;(function(Se){function Ie(K){return{range:r.from(K.range),kind:K.kind}}Se.from=Ie;function de(K){return new l.DocumentHighlight(r.to(K.range),K.kind)}Se.to=de})(Q=e.DocumentHighlight||(e.DocumentHighlight={}));var Y;(function(Se){function Ie(de){switch(de){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Se.to=Ie})(Y=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var W;(function(Se){function Ie(de){return{triggerKind:Y.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Se.to=Ie})(W=e.CompletionContext||(e.CompletionContext={}));var V;(function(Se){function Ie(K){switch(K){case l.CompletionItemTag.Deprecated:return 1}}Se.from=Ie;function de(K){switch(K){case 1:return l.CompletionItemTag.Deprecated}}Se.to=de})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(Se){const Ie=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function de(Le){return Ie.get(Le)??9}Se.from=de;const K=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Pe(Le){return K.get(Le)??l.CompletionItemKind.Property}Se.to=Pe})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var X;(function(Se){function Ie(de,K){const Pe=new l.CompletionItem(de.label);return Pe.insertText=de.insertText,Pe.kind=q.to(de.kind),Pe.tags=de.tags?.map(V.to),Pe.detail=de.detail,Pe.documentation=P.isMarkdownString(de.documentation)?ce.to(de.documentation):de.documentation,Pe.sortText=de.sortText,Pe.filterText=de.filterText,Pe.preselect=de.preselect,Pe.commitCharacters=de.commitCharacters,R.Range.isIRange(de.range)?Pe.range=r.to(de.range):typeof de.range=="object"&&(Pe.range={inserting:r.to(de.range.insert),replacing:r.to(de.range.replace)}),Pe.keepWhitespace=typeof de.insertTextRules>"u"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Pe.insertText=new l.SnippetString(de.insertText):(Pe.insertText=de.insertText,Pe.textEdit=Pe.range instanceof l.Range?new l.TextEdit(Pe.range,Pe.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Pe.additionalTextEdits=de.additionalTextEdits.map(Le=>j.to(Le))),Pe.command=K&&de.command?K.fromInternal(de.command):void 0,Pe}Se.to=Ie})(X=e.CompletionItem||(e.CompletionItem={}));var le;(function(Se){function Ie(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:ce.fromStrict(K.documentation)}}Se.from=Ie;function de(K){return{label:K.label,documentation:P.isMarkdownString(K.documentation)?ce.to(K.documentation):K.documentation}}Se.to=de})(le=e.ParameterInformation||(e.ParameterInformation={}));var pe;(function(Se){function Ie(K){return{label:K.label,documentation:ce.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(le.from):[],activeParameter:K.activeParameter}}Se.from=Ie;function de(K){return{label:K.label,documentation:P.isMarkdownString(K.documentation)?ce.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(le.to):[],activeParameter:K.activeParameter}}Se.to=de})(pe=e.SignatureInformation||(e.SignatureInformation={}));var ke;(function(Se){function Ie(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(pe.from):[]}}Se.from=Ie;function de(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(pe.to):[]}}Se.to=de})(ke=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(Se){function Ie(de,K){const Pe=new l.InlayHint(s.to(K.position),typeof K.label=="string"?K.label:K.label.map(Me.to.bind(void 0,de)),K.kind&&Oe.to(K.kind));return Pe.textEdits=K.textEdits&&K.textEdits.map(j.to),Pe.tooltip=P.isMarkdownString(K.tooltip)?ce.to(K.tooltip):K.tooltip,Pe.paddingLeft=K.paddingLeft,Pe.paddingRight=K.paddingRight,Pe}Se.to=Ie})(Te=e.InlayHint||(e.InlayHint={}));var Me;(function(Se){function Ie(de,K){const Pe=new l.InlayHintLabelPart(K.label);return Pe.tooltip=P.isMarkdownString(K.tooltip)?ce.to(K.tooltip):K.tooltip,S.Command.is(K.command)&&(Pe.command=de.fromInternal(K.command)),K.location&&(Pe.location=U.to(K.location)),Pe}Se.to=Ie})(Me=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Oe;(function(Se){function Ie(K){return K}Se.from=Ie;function de(K){return K}Se.to=de})(Oe=e.InlayHintKind||(e.InlayHintKind={}));var me;(function(Se){function Ie(K){return{range:r.from(K.range),url:K.target,tooltip:K.tooltip}}Se.from=Ie;function de(K){let Pe;if(K.url)try{Pe=typeof K.url=="string"?T.URI.parse(K.url,!0):T.URI.revive(K.url)}catch{}return new l.DocumentLink(r.to(K.range),Pe)}Se.to=de})(me=e.DocumentLink||(e.DocumentLink={}));var be;(function(Se){function Ie(K){const Pe=new l.ColorPresentation(K.label);return K.textEdit&&(Pe.textEdit=j.to(K.textEdit)),K.additionalTextEdits&&(Pe.additionalTextEdits=K.additionalTextEdits.map(Le=>j.to(Le))),Pe}Se.to=Ie;function de(K){return{label:K.label,textEdit:K.textEdit?j.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Pe=>j.from(Pe)):void 0}}Se.from=de})(be=e.ColorPresentation||(e.ColorPresentation={}));var Ee;(function(Se){function Ie(K){return new l.Color(K[0],K[1],K[2],K[3])}Se.to=Ie;function de(K){return[K.red,K.green,K.blue,K.alpha]}Se.from=de})(Ee=e.Color||(e.Color={}));var Ne;(function(Se){function Ie(K){return{range:r.from(K.range)}}Se.from=Ie;function de(K){return new l.SelectionRange(r.to(K.range))}Se.to=de})(Ne=e.SelectionRange||(e.SelectionRange={}));var Be;(function(Se){function Ie(de){switch(de){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Se.to=Ie})(Be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ke;(function(Se){function Ie(K){switch(K){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Ie;function de(K){switch(K){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Se.to=de})(Ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var He;(function(Se){function Ie(K){if(K===l.EndOfLine.CRLF)return 1;if(K===l.EndOfLine.LF)return 0}Se.from=Ie;function de(K){if(K===1)return l.EndOfLine.CRLF;if(K===0)return l.EndOfLine.LF}Se.to=de})(He=e.EndOfLine||(e.EndOfLine={}));var Ge;(function(Se){function Ie(de){if(typeof de=="object")return de.viewId;switch(de){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Ie})(Ge=e.ProgressLocation||(e.ProgressLocation={}));var Xe;(function(Se){function Ie(de){const K={start:de.start+1,end:de.end+1};return de.kind&&(K.kind=et.from(de.kind)),K}Se.from=Ie})(Xe=e.FoldingRange||(e.FoldingRange={}));var et;(function(Se){function Ie(de){if(de)switch(de){case l.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}Se.from=Ie})(et=e.FoldingRangeKind||(e.FoldingRangeKind={}));var qe;(function(Se){function Ie(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?r.from(de.selection):void 0,override:typeof de.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Ie})(qe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var $e;(function(Se){function Ie(Le){return Le instanceof l.RelativePattern?Le.toJSON():typeof Le=="string"?Le:de(Le)||K(Le)?new l.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Se.from=Ie;function de(Le){const Qe=Le;return Qe?T.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function K(Le){const Qe=Le;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Pe(Le){return typeof Le=="string"?Le:new l.RelativePattern(T.URI.revive(Le.baseUri),Le.pattern)}Se.to=Pe})($e=e.GlobPattern||(e.GlobPattern={}));var xe;(function(Se){function Ie(de){if(de){if(Array.isArray(de))return de.map(Ie);if(typeof de=="string")return de;{const K=de;return{language:K.language,scheme:K.scheme,pattern:$e.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Se.from=Ie})(xe=e.LanguageSelector||(e.LanguageSelector={}));var he;(function(Se){function Ie(K){return{start:K.start,end:K.end}}Se.from=Ie;function de(K){return new l.NotebookRange(K.start,K.end)}Se.to=de})(he=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(Se){function Ie(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Se.to=Ie;function de(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Se.from=de})(Ce=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var De;(function(Se){function Ie(de){if(de===p.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(de===p.NotebookCellExecutionState.Pending)return;if(de===p.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Se.to=Ie})(De=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Re;(function(Se){function Ie(K){switch(K){case l.NotebookCellKind.Markup:return p.CellKind.Markup;case l.NotebookCellKind.Code:default:return p.CellKind.Code}}Se.from=Ie;function de(K){switch(K){case p.CellKind.Markup:return l.NotebookCellKind.Markup;case p.CellKind.Code:default:return l.NotebookCellKind.Code}}Se.to=de})(Re=e.NotebookCellKind||(e.NotebookCellKind={}));var Fe;(function(Se){function Ie(K){const Pe={metadata:K.metadata??Object.create(null),cells:[]};for(const Le of K.cells)l.NotebookCellData.validate(Le),Pe.cells.push(ze.from(Le));return Pe}Se.from=Ie;function de(K){const Pe=new l.NotebookData(K.cells.map(ze.to));return(0,C.isEmptyObject)(K.metadata)||(Pe.metadata=K.metadata),Pe}Se.to=de})(Fe=e.NotebookData||(e.NotebookData={}));var ze;(function(Se){function Ie(K){return{cellKind:Re.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ce.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(rt.from):[]}}Se.from=Ie;function de(K){return new l.NotebookCellData(Re.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(rt.to):void 0,K.metadata,K.internalMetadata?Ce.to(K.internalMetadata):void 0)}Se.to=de})(ze=e.NotebookCellData||(e.NotebookCellData={}));var je;(function(Se){function Ie(K){return{mime:K.mime,valueBytes:t.VSBuffer.wrap(K.data)}}Se.from=Ie;function de(K){return new l.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}Se.to=de})(je=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var rt;(function(Se){function Ie(K){return{outputId:K.id,items:K.items.map(je.from),metadata:K.metadata}}Se.from=Ie;function de(K){const Pe=K.items.map(je.to);return new l.NotebookCellOutput(Pe,K.outputId,K.metadata)}Se.to=de})(rt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(Se){function Ie(Pe){return K(Pe)?{include:(0,C.withNullAsUndefined)($e.from(Pe.include)),exclude:(0,C.withNullAsUndefined)($e.from(Pe.exclude))}:(0,C.withNullAsUndefined)($e.from(Pe))}Se.from=Ie;function de(Pe){return K(Pe)?{include:$e.to(Pe.include),exclude:$e.to(Pe.exclude)}:$e.to(Pe)}Se.to=de;function K(Pe){const Le=Pe;return Le?!(0,C.isUndefinedOrNull)(Le.include)&&!(0,C.isUndefinedOrNull)(Le.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Je;(function(Se){function Ie(de,K,Pe){const Le=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,Pe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Se.from=Ie})(Je=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ot;(function(Se){function Ie(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}Se.from=Ie})(ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var lt;(function(Se){function Ie(K){return{uri:K.uri,provides:K.provides}}Se.from=Ie;function de(K){return new l.NotebookRendererScript(T.URI.revive(K.uri),K.provides)}Se.to=de})(lt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ut;(function(Se){function Ie(K){return{message:ce.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:r.from(K.location.range),uri:K.location.uri}}}Se.from=Ie;function de(K){const Pe=new l.TestMessage(typeof K.message=="string"?K.message:ce.to(K.message));return Pe.actualOutput=K.actual,Pe.expectedOutput=K.expected,Pe.location=K.location?U.to(K.location):void 0,Pe}Se.to=de})(ut=e.TestMessage||(e.TestMessage={}));var ht;(function(Se){Se.namespace=v.namespaceTestTag,Se.denamespace=v.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var bt;(function(Se){function Ie(K){const Pe=(0,d.getPrivateApiFor)(K).controllerId;return{extId:m.TestId.fromExtHostTestItem(K,Pe).toString(),label:K.label,uri:T.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Le=>ht.namespace(Pe,Le.id)),range:R.Range.lift(r.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&ce.fromStrict(K.error)||null}}Se.from=Ie;function de(K){return{parent:void 0,error:void 0,id:m.TestId.fromString(K.extId).localId,label:K.label,uri:T.URI.revive(K.uri),tags:(K.tags||[]).map(Pe=>{const{tagId:Le}=ht.denamespace(Pe);return new l.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:r.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Se.toPlain=de})(bt=e.TestItem||(e.TestItem={})),function(Se){function Ie(K){return{id:K.id}}Se.from=Ie;function de(K){return new l.TestTag(K.id)}Se.to=de}(ht=e.TestTag||(e.TestTag={}));var kt;(function(Se){const Ie=(K,Pe)=>{const Le=[];for(const[We,tt]of Pe)m.TestId.compare(tt.item.extId,We)===2&&(Pe.delete(We),Le.push(tt));const Qe={...bt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(tt=>tt.type===0).map(ut.to)})),children:Le.map(We=>Ie(We,Pe))};for(const We of Qe.children)We.parent=Qe;return Qe};function de(K){const Pe=[],Le=new Map;for(const Qe of K.items){Le.set(Qe.item.extId,Qe);const We=m.TestId.root(Qe.item.extId);K.request.targets.some(tt=>tt.controllerId===We&&tt.testIds.includes(Qe.item.extId))&&Pe.push(Qe)}return{completedAt:K.completedAt,results:Pe.map(Qe=>Ie(Qe,Le))}}Se.to=de})(kt=e.TestResults||(e.TestResults={}));var At;(function(Se){function Ie(Le){return{covered:Le.covered,total:Le.covered}}function de(Le){return"line"in Le?s.from(Le):r.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:de(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&de(Qe.location)})):void 0}:{type:0,count:Le.executionCount,location:de(Le.location)}}Se.fromDetailed=K;function Pe(Le){return{uri:Le.uri,statement:Ie(Le.statementCoverage),branch:Le.branchCoverage&&Ie(Le.branchCoverage),function:Le.functionCoverage&&Ie(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}Se.fromFile=Pe})(At=e.TestCoverage||(e.TestCoverage={}));var Ot;(function(Se){function Ie(de){switch(de){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Se.to=Ie})(Ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var pt;(function(Se){function Ie(K){const Pe=new l.TypeHierarchyItem(F.to(K.kind),K.name,K.detail||"",T.URI.revive(K.uri),r.to(K.range),r.to(K.selectionRange));return Pe._sessionId=K._sessionId,Pe._itemId=K._itemId,Pe}Se.to=Ie;function de(K,Pe,Le){if(Pe=Pe??K._sessionId,Le=Le??K._itemId,Pe===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Le,kind:F.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:r.from(K.range),selectionRange:r.from(K.selectionRange),tags:K.tags?.map(G.from)}}Se.from=de})(pt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ct;(function(Se){function Ie(de){if(!!de)return{value:de.value,tooltip:de.tooltip}}Se.from=Ie})(Ct=e.ViewBadge||(e.ViewBadge={}));var st;(function(Se){function Ie(de,K){const Pe=de.fileData;return Pe?new class extends l.DataTransferItem{asFile(){return{name:Pe.name,uri:T.URI.revive(Pe.uri),data:(0,h.once)(()=>K())}}}("",de.id):new l.DataTransferItem(de.asString)}Se.toDataTransferItem=Ie})(st=e.DataTransferItem||(e.DataTransferItem={}));var ft;(function(Se){function Ie(K,Pe){const Le=K.items.map(([Qe,We])=>[Qe,st.toDataTransferItem(We,()=>Pe(We.id))]);return new l.DataTransfer(Le)}Se.toDataTransfer=Ie;async function de(K){const Pe={items:[]},Le=[];return K.forEach((Qe,We)=>{Le.push((async()=>{const tt=await Qe.asString(),at=Qe.asFile();Pe.items.push([We,{id:Qe.id,asString:tt,fileData:at?{name:at.name,uri:at.uri}:void 0}])})())}),await Promise.all(Le),Pe}Se.toDataTransferDTO=de})(ft=e.DataTransfer||(e.DataTransfer={}))}),define(we[257],ye([1,0,46,125,65,124,83,130,4]),function(se,e,y,t,P,I,k,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const C=(u,l,h,i)=>{let r=l;return{enumerable:!0,configurable:!1,get(){return r},set(n){if(!h(r,n)){const s=r;r=n,u.listener?.(i(n,s))}}}},T=(u,l)=>u===l,R={range:(u,l)=>u===l?!0:!u||!l?!1:u.isEqual(l),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(u,l)=>!(u.length!==l.length||u.some(h=>!l.find(i=>h.id===i.id)))},S=u=>l=>({op:4,update:u(l)}),w=(u,l)=>({range:(()=>{let h;const i=S(r=>({range:y.Range.lift(b.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return h},set(r){u.listener?.({op:6}),R.range(h,r)||(h=r,u.listener?.(i(r)))}}})(),label:C(u,l,R.label,S(h=>({label:h}))),description:C(u,void 0,R.description,S(h=>({description:h}))),sortText:C(u,void 0,R.sortText,S(h=>({sortText:h}))),canResolveChildren:C(u,!1,R.canResolveChildren,h=>({op:2,state:h})),busy:C(u,!1,R.busy,S(h=>({busy:h}))),error:C(u,void 0,R.error,S(h=>({error:b.MarkdownString.fromStrict(h)||null}))),tags:C(u,[],R.tags,(h,i)=>({op:1,new:h.map(b.TestTag.from),old:i.map(b.TestTag.from)}))}),d=u=>{const l=P.TestId.fromString(u.extId),h=new p(l.controllerId,l.localId,u.label,E.URI.revive(u.uri)||void 0);return h.range=b.Range.to(u.range||void 0),h.description=u.description||void 0,h.sortText=u.sortText||void 0,h.tags=u.tags.map(i=>b.TestTag.to({id:(0,k.denamespaceTestTag)(i).tagId})),h},g=u=>{let l;for(const h of u.tests){const i=d(h.item);(0,t.getPrivateApiFor)(i).parent=l,l=i}return l};e.toItemFromContext=g;class p{constructor(l,h,i,r){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const n=(0,t.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof m?void 0:n.parent}},children:{value:(0,I.createTestItemChildren)(n,t.getPrivateApiFor,p),enumerable:!0,writable:!1},...w(n,i)})}}e.TestItemImpl=p;class m extends p{constructor(l,h){super(l,l,h,void 0),this._isRoot=!0}}e.TestItemRootImpl=m;class v extends I.TestItemCollection{constructor(l,h,i){super({controllerId:l,getDocumentVersion:r=>r&&i.getDocument(r)?.version,getApiFor:t.getPrivateApiFor,getChildren:r=>r.children,root:new m(l,h),toITestItem:b.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(we[258],ye([1,0,35,188,49]),function(se,e,y,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function I(k,b,E,C){const T=new Map;k.forEach(S=>{const w=y.ExtensionIdentifier.toKey(S.identifier),d=T.get(w);d&&C.warn((0,t.localize)(0,null,d.extensionLocation.fsPath,S.extensionLocation.fsPath)),T.set(w,S)}),b.forEach(S=>{const w=y.ExtensionIdentifier.toKey(S.identifier),d=T.get(w);if(d)if(d.isBuiltin){if(P.gte(d.version,S.version)){C.warn(`Skipping extension ${S.extensionLocation.path} in favour of the builtin extension ${d.extensionLocation.path}.`);return}S.isBuiltin=!0}else C.warn((0,t.localize)(1,null,d.extensionLocation.fsPath,S.extensionLocation.fsPath));else if(S.isBuiltin){C.warn(`Skipping obsolete builtin extension ${S.extensionLocation.path}`);return}T.set(w,S)}),E.forEach(S=>{C.info((0,t.localize)(2,null,S.extensionLocation.fsPath));const w=y.ExtensionIdentifier.toKey(S.identifier),d=T.get(w);d&&d.isBuiltin&&(S.isBuiltin=!0),T.set(w,S)});const R=[];return T.forEach(S=>R.push(S)),R}e.dedupExtensions=I}),define(we[259],ye([1,0,3,45,4,64,11,71,101,97,224,6,27,54,258]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class g{constructor(m,v,u,l,h,i,r){if(this._connectionToken=m,this._environmentService=v,this._userDataProfilesService=u,this._logService=h,this._extensionHostStatusService=i,this._extensionsScannerService=r,v.args["install-builtin-extension"]){const s={isMachineScoped:!!v.args["do-not-sync"],installPreReleaseVersion:!!v.args["pre-release"]};this.whenExtensionsReady=l.installExtensions([],v.args["install-builtin-extension"],s,!!v.args.force).then(null,a=>{h.error(a)})}else this.whenExtensionsReady=Promise.resolve();const n=v.args["install-extension"];if(n){const s=n.map(a=>/\.vsix$/i.test(a)?P.URI.file((0,R.isAbsolute)(a)?a:(0,R.join)((0,S.cwd)(),a)):a);this.whenExtensionsReady.then(()=>l.installExtensions(s,[],{isMachineScoped:!!v.args["do-not-sync"],installPreReleaseVersion:!!v.args["pre-release"]},!!v.args.force)).then(null,a=>{h.error(a)})}}async call(m,v,u){switch(v){case"getEnvironmentData":{const l=u,h=(0,I.createURITransformer)(l.remoteAuthority);let i=await this._getEnvironmentData();return i=(0,b.transformOutgoingURIs)(i,h),i}case"getExtensionHostExitInfo":{const l=u;return this._extensionHostStatusService.getExitInfo(l.reconnectionToken)}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const l=u,h=l.language;this._logService.trace(`Scanning extensions using UI language: ${h}`);const i=(0,I.createURITransformer)(l.remoteAuthority),r=l.extensionDevelopmentPath&&l.extensionDevelopmentPath.map(a=>P.URI.revive(i.transformIncoming(a))),n=r?r.filter(a=>a.scheme===k.Schemas.file).map(a=>a.fsPath):void 0;let s=await this._scanExtensions(h,n);return s=(0,b.transformOutgoingURIs)(s,i),this._logService.trace("Scanned Extensions",s),g._massageWhenConditions(s),s}case"scanSingleExtension":{await this.whenExtensionsReady;const l=u,h=l.language,i=l.isBuiltin,r=(0,I.createURITransformer)(l.remoteAuthority),n=P.URI.revive(r.transformIncoming(l.extensionLocation)),s=n.scheme===k.Schemas.file?n.fsPath:null;if(!s)return null;let a=await this._scanSingleExtension(s,i,h);return a?(a=(0,b.transformOutgoingURIs)(a,r),g._massageWhenConditions([a]),a):null}case"getDiagnosticInfo":{const l=u,h={machineInfo:(0,T.getMachineInfo)()},i=l.includeProcesses?(0,C.listProcesses)(process.pid):Promise.resolve();let r=[];const n={};if(l.folders){const s=(0,I.createURITransformer)("");r=l.folders.map(f=>P.URI.revive(s.transformIncoming(f))).filter(f=>f.scheme==="file").map(f=>(0,T.collectWorkspaceStats)(f.fsPath,["node_modules",".git"]).then(o=>{n[(0,R.basename)(f.fsPath)]=o}))}return Promise.all([i,...r]).then(([s,a])=>(h.processes=s||void 0,h.workspaceMetadata=l.folders?n:void 0,h))}}throw new Error(`IPC Command ${v} not found`)}listen(m,v,u){throw new Error("Not supported")}static _massageWhenConditions(m){const v=(n,s)=>n.replace(/file/g,"vscode-remote"),u=n=>{let s="";return s+=n.global?"g":"",s+=n.ignoreCase?"i":"",s+=n.multiline?"m":"",new RegExp(v(n.source,!0),s)},l=new class{mapDefined(n){return E.ContextKeyDefinedExpr.create(n)}mapNot(n){return E.ContextKeyNotExpr.create(n)}mapEquals(n,s){return n==="resourceScheme"&&typeof s=="string"?E.ContextKeyEqualsExpr.create(n,v(s,!1)):E.ContextKeyEqualsExpr.create(n,s)}mapNotEquals(n,s){return n==="resourceScheme"&&typeof s=="string"?E.ContextKeyNotEqualsExpr.create(n,v(s,!1)):E.ContextKeyNotEqualsExpr.create(n,s)}mapGreater(n,s){return E.ContextKeyGreaterExpr.create(n,s)}mapGreaterEquals(n,s){return E.ContextKeyGreaterEqualsExpr.create(n,s)}mapSmaller(n,s){return E.ContextKeySmallerExpr.create(n,s)}mapSmallerEquals(n,s){return E.ContextKeySmallerEqualsExpr.create(n,s)}mapRegex(n,s){return n==="resourceScheme"&&s?E.ContextKeyRegexExpr.create(n,u(s)):E.ContextKeyRegexExpr.create(n,s)}mapIn(n,s){return E.ContextKeyInExpr.create(n,s)}mapNotIn(n,s){return E.ContextKeyNotInExpr.create(n,s)}},h=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const s=E.ContextKeyExpr.deserialize(n.when);if(!s)return;const a=s.map(l);n.when=a.serialize()},i=n=>{if(Array.isArray(n))for(const s of n)h(s);else h(n)},r=n=>{for(const s in n)i(n[s])};m.forEach(n=>{n.contributes&&(n.contributes.menus&&r(n.contributes.menus),n.contributes.keybindings&&i(n.contributes.keybindings),n.contributes.views&&r(n.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:P.URI.file(this._environmentService.appRoot),settingsPath:this._environmentService.machineSettingsResource,logsPath:P.URI.file(this._environmentService.logsPath),extensionsPath:P.URI.file(this._environmentService.extensionsPath),extensionHostLogsPath:P.URI.file((0,R.join)(this._environmentService.logsPath,`exthost${g._namePool++}`)),globalStorageHome:this._userDataProfilesService.defaultProfile.globalStorageHome,workspaceStorageHome:this._environmentService.workspaceStorageHome,localHistoryHome:this._environmentService.localHistoryHome,userHome:this._environmentService.userHome,os:y.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this._environmentService.args["use-host-proxy"]}}async _scanExtensions(m,v){const[u,l,h]=await Promise.all([this._scanBuiltinExtensions(m),this._scanInstalledExtensions(m),this._scanDevelopedExtensions(m,v)]);return(0,d.dedupExtensions)(u,l,h,this._logService)}async _scanDevelopedExtensions(m,v){return v?(await Promise.all(v.map(u=>this._extensionsScannerService.scanOneOrMultipleExtensions(P.URI.file((0,R.resolve)(u)),1,{language:m})))).flat().map(u=>(0,w.toExtensionDescription)(u,!0)):[]}async _scanBuiltinExtensions(m){return(await this._extensionsScannerService.scanSystemExtensions({language:m,useCache:!0})).map(u=>(0,w.toExtensionDescription)(u,!1))}async _scanInstalledExtensions(m){return(await this._extensionsScannerService.scanUserExtensions({language:m,useCache:!0})).map(u=>(0,w.toExtensionDescription)(u,!1))}async _scanSingleExtension(m,v,u){const l=P.URI.file((0,R.resolve)(m)),h=v?0:1,i=await this._extensionsScannerService.scanExistingExtension(l,h,{language:u});return i?(0,w.toExtensionDescription)(i,!1):null}}e.RemoteAgentEnvironmentChannel=g,g._namePool=1}),define(we[131],ye([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class y{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++y.count}}e.ProxyIdentifier=y,y.count=0;const t=[];function P(b){const E=new y(b);return t[E.nid]=E,E}e.createProxyIdentifier=P;function I(b){return t[b].sid}e.getStringIdentifierForProxy=I;class k{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=k}),define(we[260],ye([1,0,131]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput"})(P=e.TabInputKind||(e.TabInputKind={}));var I;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(I=e.TabModelOperationKind||(e.TabModelOperationKind={}));var k;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var b;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(b=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var T;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(T=e.CandidatePortSource||(e.CandidatePortSource={}));class R{static mixin(p){return p._id=R._n++,p}}e.IdObject=R,R._n=0;var S;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,y.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,y.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,y.createProxyIdentifier)("ExtHostLocalization")}});var Rt=this&&this.__classPrivateFieldSet||function(se,e,y,t,P){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!P:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?P.call(se,y):P?P.value=y:e.set(se,y),y},nt=this&&this.__classPrivateFieldGet||function(se,e,y,t){if(y==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!t:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?t:y==="a"?t.call(se):t?t.value:e.get(se)};define(we[261],ye([1,0,13,129,130,22,260,18,12,47,46,90,4,2,5,247,257,16,131,38]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m,v,u){"use strict";var l,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(o,c){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,h.set(this,void 0),Rt(this,l,o.getProxy(k.MainContext.MainThreadCommands),"f"),this._logService=c,Rt(this,h,o.getProxy(k.MainContext.MainThreadTelemetry),"f"),this.converter=new r(this,D=>{const O=this._apiCommands.get(D);return O?.result===s.Void?O:void 0},c),this._argumentProcessors=[{processArgument(D){return(0,C.revive)(D)}},{processArgument(D){return(0,I.cloneAndChange)(D,function(O){if(T.Range.isIRange(O))return P.Range.to(O);if(R.Position.isIPosition(O))return P.Position.to(O);if(T.Range.isIRange(O.range)&&S.URI.isUri(O.uri))return P.location.to(O);if(O instanceof m.VSBuffer)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const c=this.registerCommand(!1,o.id,async(...D)=>{const O=o.args.map((re,ce)=>{if(!re.validate(D[ce]))throw new Error(`Invalid argument '${re.name}' when running '${o.id}', received: ${D[ce]}`);return re.convert(D[ce])}),H=await this.executeCommand(o.internalId,...O);return o.result.convert(H,D,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new t.Disposable(()=>{c.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,c,D,O,H,re){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:D,thisArg:O,description:H,extension:re}),o&&nt(this,l,"f").$registerCommand(c),new t.Disposable(()=>{this._commands.delete(c)&&o&&nt(this,l,"f").$unregisterCommand(c)})}executeCommand(o,...c){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,c,!0)}async _doExecuteCommand(o,c,D){if(this._commands.has(o))return nt(this,l,"f").$fireCommandActivationEvent(o),this._executeContributedCommand(o,c,!1);{let O=!1;const H=(0,I.cloneAndChange)(c,function(re){if(re instanceof t.Position)return P.Position.from(re);if(re instanceof t.Range)return P.Range.from(re);if(re instanceof t.Location)return P.location.from(re);if(t.NotebookRange.isNotebookRange(re))return P.NotebookRange.from(re);if(re instanceof ArrayBuffer)return O=!0,m.VSBuffer.wrap(new Uint8Array(re));if(re instanceof Uint8Array)return O=!0,m.VSBuffer.wrap(re);if(re instanceof m.VSBuffer)return O=!0,re;if(!Array.isArray(re))return re});try{const re=await nt(this,l,"f").$executeCommand(o,O?new v.SerializableObjectWithBuffers(H):H,D);return(0,C.revive)(re)}catch(re){if(re instanceof Error&&re.message==="$executeCommand:retry")return this._doExecuteCommand(o,c,!1);throw re}}}async _executeContributedCommand(o,c,D){const O=this._commands.get(o);if(!O)throw new Error("Unknown command");this._reportTelemetry(O,o);const{callback:H,thisArg:re,description:ce}=O;if(ce)for(let ae=0;ae<ce.args.length;ae++)try{(0,y.validateConstraint)(c[ae],ce.args[ae].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${ce.args[ae].name}' - ${ce.args[ae].description}`)}try{return await H.apply(re,c)}catch(ae){if(o===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...c);N&&(o=N.command)}throw this._logService.error(ae,o,O.extension?.identifier),D?new class extends Error{constructor(){super((0,u.toErrorMessage)(ae)),this.id=o,this.source=O.extension?.displayName??O.extension?.name}}:ae}}_reportTelemetry(o,c){!o.extension||o.extension.isBuiltin||nt(this,h,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:c})}$executeContributedCommand(o,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(c=c.map(D=>this._argumentProcessors.reduce((O,H)=>H.processArgument(O),D)),this._executeContributedCommand(o,c,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),nt(this,l,"f").$getCommands().then(c=>(o&&(c=c.filter(D=>D[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[c,D]of this._commands){const{description:O}=D;O&&(o[c]=O)}return Promise.resolve(o)}};l=new WeakMap,h=new WeakMap,i=Ae([_e(0,g.IExtHostRpcService),_e(1,E.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,d.createDecorator)("IExtHostCommands");class r{constructor(o,c,D){this._commands=o,this._lookupApiCommand=c,this._logService=D,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,c){if(!o)return;const D={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return D;const O=this._lookupApiCommand(o.command);if(O)D.id=O.internalId,D.arguments=O.args.map((H,re)=>H.convert(o.arguments&&o.arguments[re]));else if((0,b.isNonEmptyArray)(o.arguments)){const H=++this._cachIdPool;this._cache.set(H,o),c.add((0,w.toDisposable)(()=>{this._cache.delete(H),this._logService.trace("CommandsConverter#DISPOSE",H)})),D.$ident=H,D.id=this.delegatingCommandId,D.arguments=[H],this._logService.trace("CommandsConverter#CREATE",o.command,H)}return D}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const c=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=r;class n{constructor(o,c,D,O){this.name=o,this.description=c,this.validate=D,this.convert=O}optional(){return new n(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,c){return new n(o??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",f=>S.URI.isUri(f),f=>f),n.Position=new n("position","A position in a text document",f=>t.Position.isPosition(f),P.Position.from),n.Range=new n("range","A range in a text document",f=>t.Range.isRange(f),P.Range.from),n.Selection=new n("selection","A selection in a text document",f=>t.Selection.isSelection(f),P.Selection.from),n.Number=new n("number","",f=>typeof f=="number",f=>f),n.String=new n("string","",f=>typeof f=="string",f=>f),n.CallHierarchyItem=new n("item","A call hierarchy item",f=>f instanceof t.CallHierarchyItem,P.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",f=>f instanceof t.TypeHierarchyItem,P.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",f=>f instanceof p.TestItemImpl,P.TestItem.from);class s{constructor(o,c){this.description=o,this.convert=c}}e.ApiCommandResult=s,s.Void=new s("no result",f=>f);class a{constructor(o,c,D,O,H){this.id=o,this.internalId=c,this.description=D,this.args=O,this.result=H}}e.ApiCommand=a}),define(we[262],ye([1,0,58,275,28,261,4,12,81]),function(se,e,y,t,P,I,k,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(S,w,d){this._commands=S,this.logService=w,this._ipcHandlePath=d,this._server=t.createServer((g,p)=>this.onRequest(g,p)),this.setup().catch(g=>(w.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",S=>this.logService.error(S))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(S,w){const d=(p,m)=>{w.writeHead(p,{"content-type":"application/json"}),w.end(JSON.stringify(m||null),v=>v&&this.logService.error(v))},g=[];S.setEncoding("utf8"),S.on("data",p=>g.push(p)),S.on("end",async()=>{try{const p=JSON.parse(g.join(""));let m;switch(p.type){case"open":m=await this.open(p);break;case"openExternal":m=await this.openExternal(p);break;case"status":m=await this.getStatus(p);break;case"extensionManagement":m=await this.manageExtensions(p);break;default:d(404,`Unknown message type: ${p.type}`);break}d(200,m)}catch(p){const m=p instanceof Error?p.message:JSON.stringify(p);d(500,m),this.logService.error("Error while processing pipe request",p)}})}async open(S){const{fileURIs:w,folderURIs:d,forceNewWindow:g,diffMode:p,mergeMode:m,addMode:v,forceReuseWindow:u,gotoLineMode:l,waitMarkerFilePath:h,remoteAuthority:i}=S,r=[];if(Array.isArray(d))for(const f of d)try{r.push({folderUri:k.URI.parse(f)})}catch{}if(Array.isArray(w))for(const f of w)try{(0,E.hasWorkspaceFileExtension)(f)?r.push({workspaceUri:k.URI.parse(f)}):r.push({fileUri:k.URI.parse(f)})}catch{}const n=h?k.URI.file(h):void 0,a={forceNewWindow:g,diffMode:p,mergeMode:m,addMode:v,gotoLineMode:l,forceReuseWindow:u,preferNewWindow:!u&&!n&&!v,waitMarkerFileURI:n,remoteAuthority:i};return this._commands.executeCommand("_remoteCLI.windowOpen",r,a),""}async openExternal(S){for(const w of S.uris){const d=k.URI.parse(w),g=d.scheme==="file"?d:w;await this._commands.executeCommand("_remoteCLI.openExternal",g)}}async manageExtensions(S){const w=g=>g?.map(p=>/\.vsix$/i.test(p)?k.URI.parse(p):p),d={list:S.list,install:w(S.install),uninstall:w(S.uninstall),force:S.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",d)}async getStatus(S){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&P.existsSync(this._ipcHandlePath)&&P.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=C;let T=class extends C{constructor(S,w){super(S,w,(0,y.createRandomIPCHandle)())}};T=Ae([_e(0,I.IExtHostCommands),_e(1,b.ILogService)],T),e.CLIServer=T}),define(we[263],ye([1,0,29,7,22,2,6,3,4,58,64,262,249,123,250,252,128]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class m extends g.AbstractVariableResolverService{constructor(l,h,i,r,n){super({getFolderUri:s=>{const a=h.filter(f=>f.name===s);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(s,a)=>r[`config:${a}`],getExecPath:()=>l.VSCODE_EXEC_PATH,getAppRoot:()=>l.VSCODE_CWD,getFilePath:()=>{if(i)return k.normalize(i.fsPath)},getSelectedText:()=>r.selectedText,getLineNumber:()=>r.lineNumber,getExtension:async s=>{const f=(await n.getInstalled()).find(o=>o.identifier.id===s);return f&&{extensionLocation:f.location}}},void 0,Promise.resolve(y.homedir()),Promise.resolve(l))}}class v extends I.Disposable{constructor(l,h,i,r,n){super(),this._environmentService=l,this._logService=h,this._ptyService=i,this._productService=r,this._extensionManagementService=n,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(l,h,i){switch(h){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,i);case"$createProcess":{const r=(0,T.createURITransformer)(l.remoteAuthority);return this._createProcess(r,i)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,i);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,i);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,i);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,i);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,i);case"$start":return this._ptyService.start.apply(this._ptyService,i);case"$input":return this._ptyService.input.apply(this._ptyService,i);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,i);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,i);case"$resize":return this._ptyService.resize.apply(this._ptyService,i);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,i);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,i);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,i);case"$sendCommandResult":return this._sendCommandResult(i[0],i[1],i[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,i);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,i);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,i);case"$getProfiles":return this._getProfiles.apply(this,i);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(i[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(i);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(i);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,i);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,i);case"$getRevivedPtyNewId":return this._ptyService.getRevivedPtyNewId.apply(this._ptyService,i);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,i);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,i);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,i);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,i);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,i);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(i[0],i[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(i[0],i[1]);case"$freePortKillProcess":return this._ptyService.freePortKillProcess?.apply(this._ptyService,i)}throw new Error(`IPC Command ${h} not found`)}listen(l,h,i){switch(h){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(l,h){const i={name:h.shellLaunchConfig.name,executable:h.shellLaunchConfig.executable,args:h.shellLaunchConfig.args,cwd:typeof h.shellLaunchConfig.cwd=="string"||typeof h.shellLaunchConfig.cwd>"u"?h.shellLaunchConfig.cwd:E.URI.revive(l.transformIncoming(h.shellLaunchConfig.cwd)),env:h.shellLaunchConfig.env,useShellEnvironment:h.shellLaunchConfig.useShellEnvironment,reconnectionProperties:h.shellLaunchConfig.reconnectionProperties,type:h.shellLaunchConfig.type,isFeatureTerminal:h.shellLaunchConfig.isFeatureTerminal},r=await(0,p.buildUserEnvironment)(h.resolverEnv,!!h.shellLaunchConfig.useShellEnvironment,b.language,this._environmentService,this._logService);this._logService.trace("baseEnv",r);const n=B=>({uri:E.URI.revive(l.transformIncoming(B.uri)),name:B.name,index:B.index,toResource:()=>{throw new Error("Not implemented")}}),s=h.workspaceFolders.map(n),a=h.activeWorkspaceFolder?n(h.activeWorkspaceFolder):void 0,f=h.activeFileResource?E.URI.revive(l.transformIncoming(h.activeFileResource)):void 0,o=new m(r,s,f,h.resolvedVariables,this._extensionManagementService),c=d.createVariableResolver(a,process.env,o),D=await d.getCwd(i,y.homedir(),c,a?.uri,h.configuration["terminal.integrated.cwd"],this._logService);i.cwd=D;const O=b.isWindows?"terminal.integrated.env.windows":b.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",H=h.configuration[O],re=await d.createTerminalEnvironment(i,H,c,this._productService.version,h.configuration["terminal.integrated.detectLocale"],r);if(!i.strictEnv){const B=[];for(const[j,L]of h.envVariableCollections)B.push([j,{map:(0,w.deserializeEnvironmentVariableCollection)(L)}]);const x=new Map(B);await new S.MergedEnvironmentVariableCollection(x).applyToProcessEnvironment(re,c)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:i,initialCwd:D,cols:h.cols,rows:h.rows,env:re});const ce=(0,C.createRandomIPCHandle)();re.VSCODE_IPC_HOOK_CLI=ce;const ae=await this._ptyService.createProcess(i,D,h.cols,h.rows,h.unicodeVersion,re,r,h.options,h.shouldPersistTerminal,h.workspaceId,h.workspaceName),N={executeCommand:(B,...x)=>this._executeCommand(ae,B,x,l)},J=new R.CLIServerBase(N,this._logService,ce);return this._ptyService.onProcessExit(B=>B.id===ae&&J.dispose()),{persistentTerminalId:ae,resolvedShellLaunchConfig:i}}_executeCommand(l,h,i,r){let n,s;const a=new Promise((c,D)=>{n=c,s=D}),f=++this._lastReqId;this._pendingCommands.set(f,{resolve:n,reject:s,uriTransformer:r});const o=(0,P.cloneAndChange)(i,c=>{if(c&&c.$mid===1)return r.transformOutgoing(c);if(c&&c instanceof E.URI)return r.transformOutgoingURI(c)});return this._onExecuteCommand.fire({reqId:f,persistentProcessId:l,commandId:h,commandArgs:o}),a}_sendCommandResult(l,h,i){const r=this._pendingCommands.get(l);if(!r)return;this._pendingCommands.delete(l);const n=(0,P.cloneAndChange)(i,s=>{if(s&&s.$mid===1)return r.uriTransformer.transformIncoming(s)});h?r.reject(n):r.resolve(n)}_getDefaultSystemShell(l){return this._ptyService.getDefaultSystemShell(l)}async _getProfiles(l,h,i,r){return this._ptyService.getProfiles?.(l,h,i,r)||[]}_getEnvironment(){return{...process.env}}_getWslPath(l){return this._ptyService.getWslPath(l)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=v}),define(we[132],ye([1,0,5]),function(se,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,y.createDecorator)("remoteAgentService")}),define(we[264],ye([1,0,10,2,11,202]),function(se,e,y,t,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class k extends I.DiskFileSystemProviderClient{static register(E,C,T){const R=E.getConnection();if(!R)return t.Disposable.None;const S=new t.DisposableStore,w=(async()=>{try{const d=await E.getRawEnvironment();d?C.registerProvider(P.Schemas.vscodeRemote,S.add(new k(d,R))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(d){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,y.getErrorMessage)(d))}})();return S.add(C.onWillActivateFileSystemProvider(d=>{d.scheme===P.Schemas.vscodeRemote&&d.join(w)})),S}constructor(E,C){super(C.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:E.os===3})}}e.RemoteFileSystemProviderClient=k}),define(we[133],ye([1,0,28,14,6,13,21,160,276,277]),function(se,e,y,t,P,I,k,b,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class T extends Error{constructor(i,r){let n=r.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=r}}e.ExtractError=T;function R(h){const i=h.externalFileAttributes>>16||33188;return[448,56,7].map(r=>i&r).reduce((r,n)=>r+n,i&61440)}function S(h){if(h instanceof T)return h;let i;return/end of central directory record signature not found/.test(h.message)&&(i="CorruptZip"),new T(i,h)}function w(h,i,r,n,s,a){const f=P.dirname(i),o=P.join(n,f);if(!o.startsWith(n))return Promise.reject(new Error(b.localize(0,null,i)));const c=P.join(n,i);let D;return a.onCancellationRequested(()=>{D?.destroy()}),Promise.resolve(k.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((O,H)=>{if(!a.isCancellationRequested)try{D=(0,y.createWriteStream)(c,{mode:r}),D.once("close",()=>O()),D.once("error",H),h.once("error",H),h.pipe(D)}catch(re){H(re)}}))}function d(h,i,r,n){let s=(0,t.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{s.cancel(),h.close()}),new Promise((f,o)=>{const c=new t.Sequencer,D=O=>{O.isCancellationRequested||(a++,h.readEntry())};h.once("error",o),h.once("close",()=>s.then(()=>{n.isCancellationRequested||h.entryCount===a?f():o(new T("Incomplete",new Error(b.localize(1,null,a,h.entryCount))))},o)),h.readEntry(),h.on("entry",O=>{if(n.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){D(n);return}const H=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(H)){const ae=P.join(i,H);s=(0,t.createCancelablePromise)(N=>k.Promises.mkdir(ae,{recursive:!0}).then(()=>D(N)).then(void 0,o));return}const re=p(h,O),ce=R(O);s=(0,t.createCancelablePromise)(ae=>c.queue(()=>re.then(N=>w(N,H,ce,i,r,ae).then(()=>D(ae)))).then(null,o))})})}function g(h,i=!1){return new Promise((r,n)=>{(0,E.open)(h,i?{lazyEntries:!0}:void 0,(s,a)=>{s?n(S(s)):r((0,I.assertIsDefined)(a))})})}function p(h,i){return new Promise((r,n)=>{h.openReadStream(i,(s,a)=>{s?n(S(s)):r((0,I.assertIsDefined)(a))})})}function m(h,i){return new Promise((r,n)=>{const s=new C.ZipFile;i.forEach(f=>{f.contents?s.addBuffer(typeof f.contents=="string"?Buffer.from(f.contents,"utf8"):f.contents,f.path):f.localPath&&s.addFile(f.localPath,f.path)}),s.end();const a=(0,y.createWriteStream)(h);s.outputStream.pipe(a),s.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>r(h))})}e.zip=m;function v(h,i,r={},n){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let a=g(h,!0);return r.overwrite&&(a=a.then(f=>k.Promises.rm(i).then(()=>f))),a.then(f=>d(f,i,{sourcePathRegex:s},n))}e.extract=v;function u(h,i){return g(h).then(r=>new Promise((n,s)=>{r.on("entry",a=>{a.fileName===i&&p(r,a).then(f=>n(f),f=>s(f))}),r.once("close",()=>s(new Error(b.localize(2,null,i))))}))}function l(h,i){return u(h,i).then(r=>new Promise((n,s)=>{const a=[];r.once("error",s),r.on("data",f=>a.push(f)),r.on("end",()=>n(Buffer.concat(a)))}))}e.buffer=l}),define(we[265],ye([1,0,133,170]),function(se,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(I){return(0,y.buffer)(I,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=P}),define(we[134],ye([1,0,14,38,10,2,11,6,3,19,49,13,4,23,21,133,169,74,25,240,30,32,52,54,217,241,265,218,239,35,72,17,5,12,26,33,39,37]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m,v,u,l,h,i,r,n,s,a,f,o,c,D,O,H,re,ce,ae,N,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,H.refineServiceDecorator)(l.IExtensionManagementService);let B=class extends u.AbstractExtensionManagementService{constructor(ee,te,_,U,Z,ie,ue,ve,$,Q,Y,W){super(ee,te,_,Q,W),this.extensionsScannerService=Z,this.extensionsProfileScannerService=ie,this.downloadService=ue,this.fileService=$,this.installGalleryExtensionsTasks=new Map;const V=this._register(ve.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(ve.createInstance(x,X=>V.postUninstall(X))),this.manifestCache=this._register(new f.ExtensionsManifestCache(U,this)),this.extensionsDownloader=this._register(ve.createInstance(n.ExtensionsDownloader));const q=this._register(new o.ExtensionsWatcher(this,$,U,_,Y));this._register(q.onDidChangeExtensionsByAnotherSource(({added:X,removed:le})=>{X.length&&this._onDidInstallExtensions.fire(X.map(pe=>({identifier:pe.identifier,operation:1,local:pe}))),le.forEach(pe=>this._onDidUninstallExtension.fire({identifier:pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,h.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(ee){this.logService.trace("ExtensionManagementService#zip",ee.identifier.id);const te=await this.collectFiles(ee),_=await(0,g.zip)((0,C.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,w.generateUuid)()).fsPath,te);return S.URI.file(_)}async unzip(ee){return this.logService.trace("ExtensionManagementService#unzip",ee.toString()),(await this.install(ee)).identifier}async getManifest(ee){const{location:te,cleanup:_}=await this.downloadVsix(ee),U=b.resolve(te.fsPath);try{return await(0,a.getManifest)(U)}finally{await _()}}getInstalled(ee,te){return this.extensionsScanner.scanExtensions(ee??null,te)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(ee,te={}){this.logService.trace("ExtensionManagementService#install",ee.toString());const{location:_,cleanup:U}=await this.downloadVsix(ee);try{const Z=await(0,a.getManifest)(b.resolve(_.fsPath));if(Z.engines&&Z.engines.vscode&&!(0,D.isEngineValid)(Z.engines.vscode,this.productService.version,this.productService.date))throw new Error(p.localize(0,null,(0,h.getGalleryExtensionId)(Z.publisher,Z.name),this.productService.version));return await this.installExtension(Z,_,te)}finally{await U()}}getMetadata(ee){return this.extensionsScannerService.scanMetadata(ee.location)}async updateMetadata(ee,te){this.logService.trace("ExtensionManagementService#updateMetadata",ee.identifier.id);const _={...te};return te.isPreReleaseVersion&&(_.preRelease=!0),ee=await this.extensionsScanner.updateMetadata(ee,_),this.manifestCache.invalidate(),ee}async updateExtensionScope(ee,te){return this.logService.trace("ExtensionManagementService#updateExtensionScope",ee.identifier.id),ee=await this.extensionsScanner.updateMetadata(ee,{isMachineScoped:te}),this.manifestCache.invalidate(),ee}removeUninstalledExtensions(ee){return this.extensionsScanner.cleanUp(ee)}async download(ee,te){const{location:_}=await this.extensionsDownloader.download(ee,te);return _}async downloadVsix(ee){if(ee.scheme===k.Schemas.file)return{location:ee,async cleanup(){}};this.logService.trace("Downloading extension from",ee.toString());const te=(0,C.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,w.generateUuid)());return await this.downloadService.download(ee,te),this.logService.info("Downloaded extension to",te.toString()),{location:te,cleanup:async()=>{try{await this.fileService.del(te)}catch(U){this.logService.error(U)}}}}doCreateInstallExtensionTask(ee,te,_){let U;if(S.URI.isUri(te))U=new L(ee,te,_,this.galleryService,this.extensionsScanner,this.logService);else{const Z=h.ExtensionKey.create(te).toString();U=this.installGalleryExtensionsTasks.get(Z),U||(this.installGalleryExtensionsTasks.set(Z,U=new j(ee,te,_,this.extensionsDownloader,this.extensionsScanner,this.logService)),U.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(Z)))}return _.profileLocation?new F(U,_.profileLocation,this.extensionsProfileScannerService):U}doCreateUninstallExtensionTask(ee,te){return te.profileLocation?new oe(ee,te.profileLocation,this.extensionsProfileScannerService):new G(ee,te,this.extensionsScanner)}async collectFiles(ee){const te=async U=>{let Z=await d.Promises.readdir(U);Z=Z.map(ve=>b.join(U,ve));const ie=await Promise.all(Z.map(ve=>d.Promises.stat(ve)));let ue=Promise.resolve([]);return ie.forEach((ve,$)=>{const Q=Z[$];ve.isFile()&&(ue=ue.then(Y=>[...Y,Q])),ve.isDirectory()&&(ue=ue.then(Y=>te(Q).then(W=>[...Y,...W])))}),ue};return(await te(ee.location.fsPath)).map(U=>({path:`extension/${b.relative(ee.location.fsPath,U)}`,localPath:U}))}};B=Ae([_e(0,l.IExtensionGalleryService),_e(1,ae.ITelemetryService),_e(2,re.ILogService),_e(3,v.INativeEnvironmentService),_e(4,r.IExtensionsScannerService),_e(5,i.IExtensionsProfileScannerService),_e(6,m.IDownloadService),_e(7,H.IInstantiationService),_e(8,O.IFileService),_e(9,ce.IProductService),_e(10,N.IUriIdentityService),_e(11,J.IUserDataProfilesService)],B),e.ExtensionManagementService=B;let x=class extends I.Disposable{constructor(ee,te,_,U){super(),this.beforeRemovingExtension=ee,this.fileService=te,this.extensionsScannerService=_,this.logService=U,this.uninstalledPath=(0,C.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new y.Queue}async cleanUp(ee){await this.removeUninstalledExtensions(),ee&&await this.removeOutdatedExtensions()}async scanExtensions(ee,te){const _={includeInvalid:!0,profileLocation:te};let U=[];return ee===null||ee===0?U.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},_,!1)):ee===1&&U.push(...await this.extensionsScannerService.scanUserExtensions(_)),U=ee!==null?U.filter(Z=>Z.type===ee):U,Promise.all(U.map(Z=>this.toLocalExtension(Z)))}async scanUserExtensions(ee){const te=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!ee,includeInvalid:!0});return Promise.all(te.map(_=>this.toLocalExtension(_)))}async extractUserExtension(ee,te,_,U){const Z=ee.toString(),ie=b.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,w.generateUuid)()}`),ue=b.join(this.extensionsScannerService.userExtensionsLocation.fsPath,Z);try{await d.Promises.rm(ue)}catch{throw new l.ExtensionManagementError(p.localize(1,null,ue,ee.id),l.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(ee,te,ie,U),await this.extensionsScannerService.updateMetadata(S.URI.file(ie),_);try{await this.rename(ee,ie,ue,Date.now()+2*60*1e3),this.logService.info("Renamed to",ue)}catch(ve){try{await d.Promises.rm(ie)}catch{}if(ve.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",ee.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(ve)}. Deleted from extracted location`,ie),ve}return this.scanLocalExtension(S.URI.file(ue),1)}async updateMetadata(ee,te){return await this.extensionsScannerService.updateMetadata(ee.location,te),this.scanLocalExtension(ee.location,ee.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...ee){const te=ee.map(_=>h.ExtensionKey.create(_));await this.withUninstalledExtensions(_=>{te.forEach(U=>_[U.toString()]=!0)})}async setInstalled(ee){await this.withUninstalledExtensions(U=>delete U[ee.toString()]);const _=(await this.scanUserExtensions(!0)).find(U=>h.ExtensionKey.create(U).equals(ee))||null;return _?this.updateMetadata(_,{installedTimestamp:Date.now()}):null}async removeExtension(ee,te){this.logService.trace(`Deleting ${te} extension from disk`,ee.identifier.id,ee.location.fsPath),await d.Promises.rm(ee.location.fsPath),this.logService.info("Deleted from disk",ee.identifier.id,ee.location.fsPath)}async removeUninstalledExtension(ee){await this.removeExtension(ee,"uninstalled"),await this.withUninstalledExtensions(te=>delete te[h.ExtensionKey.create(ee).toString()])}async withUninstalledExtensions(ee){return this.uninstalledFileLimiter.queue(async()=>{let te;try{te=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let _={};if(te)try{_=JSON.parse(te)}catch{}return ee&&(ee(_),Object.keys(_).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await d.Promises.rm(this.uninstalledPath)),_})}async extractAtLocation(ee,te,_,U){this.logService.trace(`Started extracting the extension from ${te} to ${_}`);try{await d.Promises.rm(_)}catch(Z){throw new l.ExtensionManagementError(this.joinErrors(Z).message,l.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(te,_,{sourcePath:"extension",overwrite:!0},U),this.logService.info(`Extracted extension to ${_}:`,ee.id)}catch(Z){try{await d.Promises.rm(_)}catch{}let ie=l.ExtensionManagementErrorCode.Extract;throw Z instanceof g.ExtractError&&(Z.type==="CorruptZip"?ie=l.ExtensionManagementErrorCode.CorruptZip:Z.type==="Incomplete"&&(ie=l.ExtensionManagementErrorCode.IncompleteZip)),new l.ExtensionManagementError(Z.message,ie)}}async rename(ee,te,_,U){try{await d.Promises.rename(te,_)}catch(Z){if(E.isWindows&&Z&&Z.code==="EPERM"&&Date.now()<U)return this.logService.info(`Failed renaming ${te} to ${_} with 'EPERM' error. Trying again...`,ee.id),this.rename(ee,te,_,U);throw new l.ExtensionManagementError(Z.message||p.localize(2,null,te,_),Z.code||l.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(ee,te){const _=await this.extensionsScannerService.scanExistingExtension(ee,te,{includeInvalid:!0});if(_)return this.toLocalExtension(_);throw new Error(p.localize(3,null,ee.path))}async toLocalExtension(ee){const te=await this.fileService.resolve(ee.location);let _,U;return te.children&&(_=te.children.find(({name:Z})=>/^readme(\.txt|\.md|)$/i.test(Z))?.resource,U=te.children.find(({name:Z})=>/^changelog(\.txt|\.md|)$/i.test(Z))?.resource),{identifier:ee.identifier,type:ee.type,isBuiltin:ee.isBuiltin||!!ee.metadata?.isBuiltin,location:ee.location,manifest:ee.manifest,targetPlatform:ee.targetPlatform,validations:ee.validations,isValid:ee.isValid,readmeUrl:_,changelogUrl:U,publisherDisplayName:ee.metadata?.publisherDisplayName||null,publisherId:ee.metadata?.publisherId||null,isApplicationScoped:!!ee.metadata?.isApplicationScoped,isMachineScoped:!!ee.metadata?.isMachineScoped,isPreReleaseVersion:!!ee.metadata?.isPreReleaseVersion,preRelease:!!ee.metadata?.preRelease,installedTimestamp:ee.metadata?.installedTimestamp,updated:!!ee.metadata?.updated}}async removeUninstalledExtensions(){const ee=await this.getUninstalledExtensions(),te=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=new Set;for(const ie of te)ee[h.ExtensionKey.create(ie).toString()]||_.add(ie.identifier.id.toLowerCase());const U=(0,h.groupByExtension)(te,ie=>ie.identifier);await y.Promises.settled(U.map(async ie=>{const ue=ie.sort((ve,$)=>T.rcompare(ve.manifest.version,$.manifest.version))[0];_.has(ue.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(ue))}));const Z=te.filter(ie=>ee[h.ExtensionKey.create(ie).toString()]);await y.Promises.settled(Z.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const ee=await this.extensionsScannerService.scanSystemExtensions({}),te=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=[],U=await this.extensionsScannerService.getTargetPlatform(),Z=(0,h.groupByExtension)(te,ie=>ie.identifier);for(const ie of Z)if(ie.length>1&&_.push(...ie.sort((ue,ve)=>{const $=T.rcompare(ue.manifest.version,ve.manifest.version);return $!==0?$:ue.targetPlatform===U?-1:1}).slice(1)),ie[0].type===0){const ue=ee.find(ve=>(0,h.areSameExtensions)(ve.identifier,ie[0].identifier));(!ue||T.gte(ue.manifest.version,ie[0].manifest.version))&&_.push(ie[0])}await y.Promises.settled(_.map(ie=>this.removeExtension(ie,"outdated")))}joinErrors(ee){const te=Array.isArray(ee)?ee:[ee];return te.length===1?te[0]instanceof Error?te[0]:new Error(te[0]):te.reduce((_,U)=>new Error(`${_.message}${_.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};x=Ae([_e(1,O.IFileService),_e(2,r.IExtensionsScannerService),_e(3,re.ILogService)],x),e.ExtensionsScanner=x;class z extends u.AbstractExtensionTask{get operation(){return(0,R.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(ee,te,_,U,Z){super(),this.identifier=ee,this.source=te,this.options=_,this.extensionsScanner=U,this.logService=Z,this.wasVerified=!1,this._operation=2}async installExtension(ee,te){try{const _=await this.unsetUninstalledAndGetLocal(ee.key);if(_)return this.extensionsScanner.updateMetadata(_,ee.metadata)}catch{throw E.isMacintosh?new l.ExtensionManagementError(p.localize(4,null),l.ExtensionManagementErrorCode.Internal):new l.ExtensionManagementError(p.localize(5,null),l.ExtensionManagementErrorCode.Internal)}return this.extract(ee,te)}async unsetUninstalledAndGetLocal(ee){if(!await this.isUninstalled(ee))return null;this.logService.trace("Removing the extension from uninstalled list:",ee.id);const _=await this.extensionsScanner.setInstalled(ee);return this.logService.info("Removed the extension from uninstalled list:",ee.id),_}async isUninstalled(ee){return!!(await this.extensionsScanner.getUninstalledExtensions())[ee.toString()]}async extract({zipPath:ee,key:te,metadata:_},U){const Z=await this.extensionsScanner.extractUserExtension(te,ee,_,U);return this.logService.info("Extracting completed.",te.id),Z}}class j extends z{constructor(ee,te,_,U,Z,ie){super(te.identifier,te,_,Z,ie),this.manifest=ee,this.gallery=te,this.extensionsDownloader=U}async doRun(ee){const _=(await this.extensionsScanner.scanExtensions(null,void 0)).find(ue=>(0,h.areSameExtensions)(ue.identifier,this.gallery.identifier));_&&(this._operation=3);const U={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,c.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||_?.isMachineScoped,isBuiltin:this.options.isBuiltin||_?.isBuiltin,isSystem:_?.type===0?!0:void 0,updated:!!_,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,R.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:_?.preRelease)};if(_?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(_,U),metadata:U};const{location:Z,verified:ie}=await this.extensionsDownloader.download(this.gallery,this._operation);try{this.wasVerified=!!ie,this.validateManifest(Z.fsPath);const ue=await this.installExtension({zipPath:Z.fsPath,key:h.ExtensionKey.create(this.gallery),metadata:U},ee);return _&&!this.options.profileLocation&&(_.targetPlatform!==ue.targetPlatform||T.neq(_.manifest.version,ue.manifest.version))&&await this.extensionsScanner.setUninstalled(_),{local:ue,metadata:U}}catch(ue){try{await this.extensionsDownloader.delete(Z)}catch(ve){this.logService.warn("Error while deleting the downloaded file",Z.toString(),(0,P.getErrorMessage)(ve))}throw ue}}async validateManifest(ee){try{await(0,a.getManifest)(ee)}catch(te){throw new l.ExtensionManagementError((0,u.joinErrors)(te).message,l.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=j;class L extends z{constructor(ee,te,_,U,Z,ie){super({id:(0,h.getGalleryExtensionId)(ee.publisher,ee.name)},te,_,Z,ie),this.manifest=ee,this.location=te,this.galleryService=U}async doRun(ee){const te=new h.ExtensionKey(this.identifier,this.manifest.version),U=(await this.extensionsScanner.scanExtensions(1,void 0)).find(ue=>(0,h.areSameExtensions)(this.identifier,ue.identifier)),Z=await this.getMetadata(this.identifier.id,this.manifest.version,ee);if(Z.isApplicationScoped=(0,c.isApplicationScopedExtension)(this.manifest),Z.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,Z.isBuiltin=this.options.isBuiltin||U?.isBuiltin,Z.installedTimestamp=Date.now(),U)if(this._operation=3,te.equals(new h.ExtensionKey(U.identifier,U.manifest.version)))try{await this.extensionsScanner.removeExtension(U,"existing")}catch{throw new Error(p.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&T.gt(U.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(U);else{const ue=await this.unsetUninstalledAndGetLocal(te);if(ue)try{await this.extensionsScanner.removeExtension(ue,"existing")}catch{throw new Error(p.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:b.resolve(this.location.fsPath),key:te,metadata:Z},ee),metadata:Z}}async getMetadata(ee,te,_){try{let[U]=await this.galleryService.getExtensions([{id:ee,version:te}],_);if(U||([U]=await this.galleryService.getExtensions([{id:ee}],_)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F{constructor(ee,te,_){this.task=ee,this.profileLocation=te,this.extensionsProfileScannerService=_,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const ee=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[ee.local,ee.metadata]],this.profileLocation),ee}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class G extends u.AbstractExtensionTask{constructor(ee,te,_){super(),this.extension=ee,this.options=te,this.extensionsScanner=_}async doRun(ee){const te=[],_=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const U=h.ExtensionKey.create(this.extension);te.push(..._.filter(Z=>U.equals(h.ExtensionKey.create(Z))))}else te.push(..._.filter(U=>(0,h.areSameExtensions)(U.identifier,this.extension.identifier)));if(!te.length)throw new Error(p.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...te),this.options.remove)for(const U of te)try{ee.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(U)}catch(Z){throw new Error(p.localize(9,null,(0,t.toErrorMessage)(Z)))}}}class oe extends u.AbstractExtensionTask{constructor(ee,te,_){super(),this.extension=ee,this.profileLocation=te,this.extensionsProfileScannerService=_}async doRun(ee){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(we[135],ye([1,0,79,14,16,10,2,13,24,25,80,12,221,278]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends k.Disposable{constructor(p,m,v){super(),this.environmentService=m,this.logService=v,this.configure(p.getValue()),this._register(p.onDidChangeConfiguration(()=>this.configure(p.getValue()),this))}configure(p){this.proxyUrl=p.http&&p.http.proxy,this.strictSSL=!!(p.http&&p.http.proxyStrictSSL),this.authorization=p.http&&p.http.proxyAuthorization}async request(p,m){this.logService.trace("RequestService#request (node) - begin",p.url);const{proxyUrl:v,strictSSL:u}=this;let l;try{l=await(0,T.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const h={...process.env,...l},i=p.agent?p.agent:await(0,S.getProxyAgent)(p.url||"",h,{proxyUrl:v,strictSSL:u});p.agent=i,p.strictSSL=u,this.authorization&&(p.headers={...p.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(p,m);return this.logService.trace("RequestService#request (node) - success",p.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",p.url,r),r}}async getNodeRequest(p){return((0,y.parse)(p.url).protocol==="https:"?await new Promise((u,l)=>{se(["https"],u,l)}):await new Promise((u,l)=>{se(["http"],u,l)})).request}_request(p,m){return t.Promises.withAsyncBody(async(v,u)=>{const l=(0,y.parse)(p.url),h=p.getRawRequest?p.getRawRequest(p):await this.getNodeRequest(p),i={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,b.isBoolean)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(i.auth=p.user+":"+p.password);const r=h(i,n=>{const s=(0,b.isNumber)(p.followRedirects)?p.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)this._request({...p,url:n.headers.location,followRedirects:s-1},m).then(v,u);else{let a=n;n.headers["content-encoding"]==="gzip"&&(a=n.pipe((0,w.createGunzip)())),v({res:n,stream:(0,P.streamToBufferReadableStream)(a)})}});r.on("error",u),p.timeout&&r.setTimeout(p.timeout),p.data&&typeof p.data=="string"&&r.write(p.data),r.end(),m.onCancellationRequested(()=>{r.abort(),u(new I.CancellationError)})})}async resolveProxy(p){}};d=Ae([_e(0,E.IConfigurationService),_e(1,C.INativeEnvironmentService),_e(2,R.ILogService)],d),e.RequestService=d}),define(we[266],ye([1,0,76,12,60,108,24,53,135,42,33,30,117,134,75,103,50,2,104,62,11,17,26,106,132,43,110,77,111,10,4,6,27,219,74,39,116,59,3,54,120,37,52,63]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m,v,u,l,h,i,r,n,s,a,f,o,c,D,O,H,re,ce,ae,N,J,B,x,z,j,L,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class G extends m.Disposable{constructor(te,_){super(),this.args=te,this.remoteDataFolder=_,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const te=await this.initServices();await te.invokeFunction(async _=>{const U=_.get(t.ILogService);try{await this.doRun(te.createInstance(a.ExtensionManagementCLI))}catch(Z){throw U.error(Z),console.error((0,c.getErrorMessage)(Z)),Z}})}async initServices(){const te=new y.ServiceCollection,_={_serviceBrand:void 0,...p.default};te.set(i.IProductService,_);const U=new s.ServerEnvironmentService(this.args,_);te.set(s.IServerEnvironmentService,U);const Z=new t.LogService(new r.SpdLogLogger(n.RemoteExtensionLogFileName,(0,O.join)(U.logsPath,`${n.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(U)));te.set(t.ILogService,Z),Z.trace(`Remote configuration data at ${this.remoteDataFolder}`),Z.trace("process arguments:",this.args);const ie=this._register(new v.FileService(Z));te.set(h.IFileService,ie),ie.registerProvider(l.Schemas.file,this._register(new u.DiskFileSystemProvider(Z)));const ue=new N.UriIdentityService(ie);te.set(ae.IUriIdentityService,ue);const ve=this._register(new j.UserDataProfilesService(U,ie,ue,Z));te.set(j.IUserDataProfilesService,ve);const $=this._register(new I.ConfigurationService(ve.defaultProfile.settingsResource,ie,new F.NullPolicyService,Z));return await $.initialize(),te.set(k.IConfigurationService,$),te.set(b.IRequestService,new P.SyncDescriptor(E.RequestService)),te.set(ce.IDownloadService,new P.SyncDescriptor(re.DownloadService)),te.set(T.ITelemetryService,C.NullTelemetryService),te.set(R.IExtensionGalleryService,new P.SyncDescriptor(S.ExtensionGalleryServiceWithNoStorageService)),te.set(L.IExtensionsProfileScannerService,new P.SyncDescriptor(L.ExtensionsProfileScannerService)),te.set(x.IExtensionsScannerService,new P.SyncDescriptor(z.ExtensionsScannerService)),te.set(d.IExtensionSignatureVerificationService,new P.SyncDescriptor(d.ExtensionSignatureVerificationService)),te.set(w.INativeServerExtensionManagementService,new P.SyncDescriptor(w.ExtensionManagementService)),te.set(f.ILanguagePackService,new P.SyncDescriptor(o.NativeLanguagePackService)),new g.InstantiationService(te)}async doRun(te){if(this.args["list-extensions"])return te.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const _={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return te.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],_,!!this.args.force)}else{if(this.args["uninstall-extension"])return te.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return te.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(te){return te.map(_=>/\.vsix$/i.test(_)?D.URI.file((0,O.isAbsolute)(_)?_:(0,O.join)((0,H.cwd)(),_)):_)}}function oe(ee){setTimeout(()=>process.exit(ee),0)}async function fe(ee,te,_){if(ee.help){const Z=p.default.serverApplicationName+(B.isWindows?".cmd":"");console.log((0,J.buildHelpMessage)(p.default.nameLong,Z,p.default.version,_,{noInputFiles:!0,noPipe:!0}));return}if(ee.version){console.log((0,J.buildVersionMessage)(p.default.version,p.default.commit));return}const U=new G(ee,te);try{await U.run(),oe(0)}catch{oe(1)}finally{U.dispose()}}e.run=fe}),define(we[267],ye([1,0,29,7,2,11,6,94,21,41,24,108,73,214,189,74,190,200,191,25,117,30,75,110,201,134,17,104,62,60,103,76,77,111,12,105,50,26,53,220,135,113,33,42,230,114,238,39,116,259,248,223,228,263,64,43,254,132,264,118,54,120,52,37,63,229,212,4,211]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m,v,u,l,h,i,r,n,s,a,f,o,c,D,O,H,re,ce,ae,N,J,B,x,z,j,L,F,G,oe,fe,ee,te,_,U,Z,ie,ue,ve,$,Q,Y,W,V,q,X,le,pe,ke,Te,Me,Oe,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const be="monacoworkbench";async function Ee(qe,$e,xe,he){const Ce=new O.ServiceCollection,De=new Ke,Re={_serviceBrand:void 0,...N.default};Ce.set(J.IProductService,Re);const Fe=new $.ServerEnvironmentService($e,Re);Ce.set(u.IEnvironmentService,Fe),Ce.set(u.INativeEnvironmentService,Fe);const ze=new me.BufferLogService,je=new ce.MultiplexLogService([new He((0,ce.getLogLevel)(Fe)),ze]);Ce.set(ce.ILogService,je),setTimeout(()=>et(Fe.logsPath).then(null,st=>je.error(st)),1e4);const rt=new Me.LoggerService(je);ze.logger=rt.createLogger(Oe.URI.file(k.join(Fe.logsPath,`${Y.RemoteExtensionLogFileName}.log`)),{name:Y.RemoteExtensionLogFileName}),je.trace(`Remote configuration data at ${xe}`),je.trace("process arguments:",Fe.args),Array.isArray(Re.serverGreeting)&&je.info(`

${Re.serverGreeting.join(`
`)}

`),De.registerChannel(d.ExtensionHostDebugBroadcastChannel.ChannelName,new d.ExtensionHostDebugBroadcastChannel);const it=new C.StaticRouter(st=>st.clientId==="renderer");De.registerChannel("logger",new ae.LogLevelChannel(je,rt));const Je=he.add(new f.FileService(je));Ce.set(a.IFileService,Je),Je.registerProvider(I.Schemas.file,he.add(new o.DiskFileSystemProvider(je)));const ot=new te.UriIdentityService(Je);Ce.set(ee.IUriIdentityService,ot);const lt=new pe.UserDataProfilesService(Fe,Je,ot,je);Ce.set(pe.IUserDataProfilesService,lt);const ut=new R.ConfigurationService(Fe.machineSettingsResource,Je,new ke.NullPolicyService,je);Ce.set(T.IConfigurationService,ut),await ut.initialize();const ht=new V.ExtensionHostStatusService;Ce.set(V.IExtensionHostStatusService,ht),Ce.set(B.IRequestService,new c.SyncDescriptor(z.RequestService));let bt=F.NullAppender;const kt=await(0,b.getMachineId)(),At=(0,F.isInternalTelemetry)(Re,ut);if((0,F.supportsTelemetry)(Re,Fe)){Re.aiConfig&&Re.aiConfig.ariaKey&&(bt=new Te.OneDataSystemAppender(At,be,null,Re.aiConfig.ariaKey),he.add((0,P.toDisposable)(()=>bt?.flush())));const st={appenders:[bt],commonProperties:(0,j.resolveCommonProperties)(Je,(0,y.release)(),(0,y.hostname)(),process.arch,Re.commit,Re.version+"-remote",kt,At,Fe.installSourcePath,"remoteAgent"),piiPaths:(0,F.getPiiPathsFromEnvironment)(Fe)},ft=Fe.args["telemetry-level"];let Se=3;ft==="all"?Se=3:ft==="error"?Se=2:ft==="crash"?Se=1:ft!==void 0&&(Se=0),Ce.set(ie.IServerTelemetryService,new c.SyncDescriptor(ie.ServerTelemetryService,[st,Se]))}else Ce.set(ie.IServerTelemetryService,ie.ServerNullTelemetryService);Ce.set(h.IExtensionGalleryService,new c.SyncDescriptor(l.ExtensionGalleryServiceWithNoStorageService));const Ot=De.getChannel("download",it);Ce.set(g.IDownloadService,new p.DownloadServiceChannelClient(Ot,()=>Be("renderer"))),Ce.set(le.IExtensionsProfileScannerService,new c.SyncDescriptor(le.ExtensionsProfileScannerService)),Ce.set(q.IExtensionsScannerService,new c.SyncDescriptor(X.ExtensionsScannerService)),Ce.set(i.IExtensionSignatureVerificationService,new c.SyncDescriptor(i.ExtensionSignatureVerificationService)),Ce.set(s.INativeServerExtensionManagementService,new c.SyncDescriptor(s.ExtensionManagementService));const pt=new D.InstantiationService(Ce);Ce.set(H.ILanguagePackService,pt.createInstance(re.NativeLanguagePackService));const Ct=pt.createInstance(fe.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:ut.getValue("terminal.integrated.persistentSessionScrollback")??100});return Ce.set(oe.IPtyService,Ct),Ce.set(m.IEncryptionMainService,new c.SyncDescriptor(v.EncryptionMainService,[kt])),Ce.set(S.ICredentialsMainService,new c.SyncDescriptor(w.CredentialsWebMainService)),pt.invokeFunction(st=>{const ft=st.get(s.INativeServerExtensionManagementService),Se=st.get(q.IExtensionsScannerService),Ie=new _.RemoteAgentEnvironmentChannel(qe,Fe,lt,pt.createInstance(r.ExtensionManagementCLI),je,ht,Se);De.registerChannel("remoteextensionsenvironment",Ie);const de=new Z.ServerTelemetryChannel(st.get(ie.IServerTelemetryService),bt);De.registerChannel("telemetry",de),De.registerChannel(Q.REMOTE_TERMINAL_CHANNEL_NAME,new ue.RemoteTerminalChannel(Fe,je,Ct,Re,ft));const K=new U.RemoteAgentFileSystemProviderChannel(je,Fe);De.registerChannel(W.REMOTE_FILE_SYSTEM_CHANNEL_NAME,K),De.registerChannel("request",new x.RequestChannel(st.get(B.IRequestService)));const Pe=new n.ExtensionManagementChannel(ft,We=>Be(We.remoteAuthority));De.registerChannel("extensions",Pe);const Le=C.ProxyChannel.fromService(st.get(m.IEncryptionMainService));De.registerChannel("encryption",Le);const Qe=C.ProxyChannel.fromService(st.get(S.ICredentialsMainService));return De.registerChannel("credentials",Qe),ft.removeUninstalledExtensions(!0),he.add(new G.default(st.get(L.ITelemetryService))),{telemetryService:st.get(L.ITelemetryService)}}),{socketServer:De,instantiationService:pt}}e.setupServerServices=Ee;const Ne=Object.create(null);function Be(qe){return Ne[qe]||(Ne[qe]=(0,ve.createURITransformer)(qe)),Ne[qe]}class Ke extends C.IPCServer{constructor(){const $e=new t.Emitter;super($e.event),this._onDidConnectEmitter=$e}acceptConnection($e,xe){this._onDidConnectEmitter.fire({protocol:$e,onDidClientDisconnect:xe})}}e.SocketServer=Ke;class He extends ce.AbstractLogger{constructor($e=ce.DEFAULT_LOG_LEVEL){super(),this.setLevel($e),this.useColors=Boolean(process.stdout.isTTY)}trace($e,...xe){this.getLevel()<=ce.LogLevel.Trace&&(this.useColors?console.log(`\x1B[90m[${Ge()}]\x1B[0m`,$e,...xe):console.log(`[${Ge()}]`,$e,...xe))}debug($e,...xe){this.getLevel()<=ce.LogLevel.Debug&&(this.useColors?console.log(`\x1B[90m[${Ge()}]\x1B[0m`,$e,...xe):console.log(`[${Ge()}]`,$e,...xe))}info($e,...xe){this.getLevel()<=ce.LogLevel.Info&&(this.useColors?console.log(`\x1B[90m[${Ge()}]\x1B[0m`,$e,...xe):console.log(`[${Ge()}]`,$e,...xe))}warn($e,...xe){this.getLevel()<=ce.LogLevel.Warning&&(this.useColors?console.warn(`\x1B[93m[${Ge()}]\x1B[0m`,$e,...xe):console.warn(`[${Ge()}]`,$e,...xe))}error($e,...xe){this.getLevel()<=ce.LogLevel.Error&&(this.useColors?console.error(`\x1B[91m[${Ge()}]\x1B[0m`,$e,...xe):console.error(`[${Ge()}]`,$e,...xe))}critical($e,...xe){this.getLevel()<=ce.LogLevel.Critical&&(this.useColors?console.error(`\x1B[90m[${Ge()}]\x1B[0m`,$e,...xe):console.error(`[${Ge()}]`,$e,...xe))}dispose(){}flush(){}}function Ge(){const qe=new Date;return`${Xe(qe.getHours())}:${Xe(qe.getMinutes())}:${Xe(qe.getSeconds())}`}function Xe(qe){return qe<10?`0${qe}`:String(qe)}async function et(qe){const $e=k.basename(qe),xe=k.dirname(qe),De=(await E.Promises.readdir(xe)).filter(Fe=>/^\d{8}T\d{6}$/.test(Fe)).sort().filter(Fe=>Fe!==$e),Re=De.slice(0,Math.max(0,De.length-9));await Promise.all(Re.map(Fe=>E.Promises.rm(k.join(xe,Fe))))}}),define(we[268],ye([1,0,112,28,89,269,79,136,16,10,36,2,11,6,45,3,15,4,23,142,98,58,5,12,26,78,33,128,243,244,43,267,246]),function(se,e,y,t,P,I,k,b,E,C,T,R,S,w,d,g,p,m,v,u,l,h,i,r,n,s,a,f,o,c,D,O,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const re=5*60*1e3;let ce=class extends R.Disposable{constructor(B,x,z,j,L,F,G,oe){super(),this._socketServer=B,this._connectionToken=x,this._vsdaMod=z,this._environmentService=L,this._productService=F,this._logService=G,this._instantiationService=oe,this._webEndpointOriginChecker=N.create(this._productService),this._serverRootPath=(0,s.getRemoteServerRootPath)(F),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=j?this._instantiationService.createInstance(H.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(B,x){if(B.method!=="GET")return(0,H.serveError)(B,x,405,`Unsupported method ${B.method}`);if(!B.url)return(0,H.serveError)(B,x,400,"Bad request.");const z=k.parse(B.url,!0);let j=z.pathname;if(!j)return(0,H.serveError)(B,x,400,"Bad request.");if(j.startsWith(this._serverRootPath)&&j.charCodeAt(this._serverRootPath.length)===47&&(j=j.substring(this._serverRootPath.length)),j==="/version")return x.writeHead(200,{"Content-Type":"text/plain"}),void x.end(this._productService.commit||"");if(j==="/delay-shutdown")return this._delayShutdown(),x.writeHead(200),void x.end("OK");if(!(0,c.requestHasValidConnectionToken)(this._connectionToken,B,z))return(0,H.serveError)(B,x,403,"Forbidden.");if(j==="/vscode-remote-resource"){const L=z.query.path;if(typeof L!="string")return(0,H.serveError)(B,x,400,"Bad request.");let F;try{F=m.URI.from({scheme:S.Schemas.file,path:L}).fsPath}catch{return(0,H.serveError)(B,x,400,"Bad request.")}const G=Object.create(null);this._environmentService.isBuilt&&((0,T.isEqualOrParent)(F,this._environmentService.builtinExtensionsPath,!g.isLinux)||(0,T.isEqualOrParent)(F,this._environmentService.extensionsPath,!g.isLinux))&&(G["Cache-Control"]="public, max-age=31536000"),G.Vary="Origin";const oe=B.headers.origin;return oe&&this._webEndpointOriginChecker.matches(oe)&&(G["Access-Control-Allow-Origin"]=oe),(0,H.serveFile)(F,1,this._logService,B,x,G)}if(this._webClientServer){this._webClientServer.handle(B,x,z);return}return x.writeHead(404,{"Content-Type":"text/plain"}),void x.end("Not found")}handleUpgrade(B,x){let z=(0,v.generateUuid)(),j=!1,L=!1;if(B.url){const te=k.parse(B.url,!0).query;typeof te.reconnectionToken=="string"&&(z=te.reconnectionToken),te.reconnection==="true"&&(j=!0),te.skipWebSocketFrames==="true"&&(L=!0)}if(B.headers.upgrade===void 0||B.headers.upgrade.toLowerCase()!=="websocket"){x.end("HTTP/1.1 400 Bad Request");return}const F=B.headers["sec-websocket-key"],G=y.createHash("sha1");G.update(F+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const oe=G.digest("base64"),fe=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${oe}`];let ee=!1;if(!L&&!this._environmentService.args["disable-websocket-compression"]&&B.headers["sec-websocket-extensions"]){const te=Array.isArray(B.headers["sec-websocket-extensions"])?B.headers["sec-websocket-extensions"]:[B.headers["sec-websocket-extensions"]];for(const _ of te)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(_)){if(/\b(permessage-deflate)\b/.test(_)){ee=!0,fe.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(_)){ee=!0,fe.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}x.write(fe.join(`\r
`)+`\r
\r
`),x.setTimeout(0),x.setNoDelay(!0),L?this._handleWebSocketConnection(new h.NodeSocket(x,`server-connection-${z}`),j,z):this._handleWebSocketConnection(new h.WebSocketNodeSocket(new h.NodeSocket(x,`server-connection-${z}`),ee,null,!0),j,z)}handleServerError(B){this._logService.error("Error occurred in server"),this._logService.error(B)}_getRemoteAddress(B){let x;return B instanceof h.NodeSocket?x=B.socket:x=B.socket.socket,x.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(B,x,z){const j=x.getSocket();this._logService.error(`${B} ${z}.`);const L={type:"error",reason:z};x.sendControl(E.VSBuffer.fromString(JSON.stringify(L))),x.dispose(),await j.drain(),j.dispose()}_handleWebSocketConnection(B,x,z){const j=this._getRemoteAddress(B),L=`[${j}][${z.substr(0,8)}]`,F=new l.PersistentProtocol(B),G=this._vsdaMod?new this._vsdaMod.validator:null,oe=this._vsdaMod?new this._vsdaMod.signer:null;let fe;(function(U){U[U.WaitingForAuth=0]="WaitingForAuth",U[U.WaitingForConnectionType=1]="WaitingForConnectionType",U[U.Done=2]="Done",U[U.Error=3]="Error"})(fe||(fe={}));let ee=0;const te=U=>{ee=3,_.dispose(),this._rejectWebSocketConnection(L,F,U)},_=F.onControlMessage(U=>{if(ee===0){let Z;try{Z=JSON.parse(U.toString())}catch{return te("Malformed first message")}if(Z.type!=="auth")return te("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(Z.auth))return te("Unauthorized client refused: auth mismatch");let ie=(0,v.generateUuid)();if(oe)try{ie=oe.sign(Z.data)}catch{}let ue=(0,v.generateUuid)();if(G)try{ue=G.createNewMessage(ue)}catch{}const ve={type:"sign",data:ue,signedData:ie};F.sendControl(E.VSBuffer.fromString(JSON.stringify(ve))),ee=1}else if(ee===1){let Z;try{Z=JSON.parse(U.toString())}catch{return te("Malformed second message")}if(Z.type!=="connectionType")return te("Invalid second message");if(typeof Z.signedData!="string")return te("Invalid second message field type");const ie=Z.commit,ue=this._productService.commit;if(ie&&ue&&ie!==ue)return te("Client refused: version mismatch");let ve=!1;if(!G)ve=!0;else if(this._connectionToken.validate(Z.signedData))ve=!0;else try{ve=G.validate(Z.signedData)==="ok"}catch{}if(!ve){if(this._environmentService.isBuilt)return te("Unauthorized client refused");this._logService.error(`${L} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const $ in this._managementConnections)this._managementConnections[$].shortenReconnectionGraceTimeIfNecessary();for(const $ in this._extHostConnections)this._extHostConnections[$].shortenReconnectionGraceTimeIfNecessary();ee=2,_.dispose(),this._handleConnectionType(j,L,F,B,x,z,Z)}})}async _handleConnectionType(B,x,z,j,L,F,G){const oe=G.desiredConnectionType===1?`${x}[ManagementConnection]`:G.desiredConnectionType===2?`${x}[ExtensionHostConnection]`:x;if(G.desiredConnectionType===1)if(L){if(!this._managementConnections[F])return this._allReconnectionTokens.has(F)?this._rejectWebSocketConnection(oe,z,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(oe,z,"Unknown reconnection token (never seen)");z.sendControl(E.VSBuffer.fromString(JSON.stringify({type:"ok"})));const fe=z.readEntireBuffer();z.dispose(),this._managementConnections[F].acceptReconnection(B,j,fe)}else{if(this._managementConnections[F])return this._rejectWebSocketConnection(oe,z,"Duplicate reconnection token");z.sendControl(E.VSBuffer.fromString(JSON.stringify({type:"ok"})));const fe=new o.ManagementConnection(this._logService,F,B,z);this._socketServer.acceptConnection(fe.protocol,fe.onClose),this._managementConnections[F]=fe,this._allReconnectionTokens.add(F),fe.onClose(()=>{delete this._managementConnections[F]})}else if(G.desiredConnectionType===2){const fe=G.args||{language:"en"},ee=await this._updateWithFreeDebugPort(fe);if(ee.port&&this._logService.trace(`${oe} - startParams debug port ${ee.port}`),this._logService.trace(`${oe} - startParams language: ${ee.language}`),this._logService.trace(`${oe} - startParams env: ${JSON.stringify(ee.env)}`),L){if(!this._extHostConnections[F])return this._allReconnectionTokens.has(F)?this._rejectWebSocketConnection(oe,z,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(oe,z,"Unknown reconnection token (never seen)");z.sendPause(),z.sendControl(E.VSBuffer.fromString(JSON.stringify(ee.port?{debugPort:ee.port}:{})));const te=z.readEntireBuffer();z.dispose(),this._extHostConnections[F].acceptReconnection(B,j,te)}else{if(this._extHostConnections[F])return this._rejectWebSocketConnection(oe,z,"Duplicate reconnection token");z.sendPause(),z.sendControl(E.VSBuffer.fromString(JSON.stringify(ee.port?{debugPort:ee.port}:{})));const te=z.readEntireBuffer();z.dispose();const _=this._instantiationService.createInstance(f.ExtensionHostConnection,F,B,j,te);this._extHostConnections[F]=_,this._allReconnectionTokens.add(F),_.onClose(()=>{delete this._extHostConnections[F],this._onDidCloseExtHostConnection()}),_.start(ee)}}else if(G.desiredConnectionType===3){const fe=G.args;this._createTunnel(z,fe)}else return this._rejectWebSocketConnection(oe,z,"Unknown initial data received")}async _createTunnel(B,x){const z=B.getSocket().socket,j=B.readEntireBuffer();B.dispose(),z.pause();const L=await this._connectTunnelSocket(x.host,x.port);j.byteLength>0&&L.write(j.buffer),L.on("end",()=>z.end()),L.on("close",()=>z.end()),L.on("error",()=>z.destroy()),z.on("end",()=>L.end()),z.on("close",()=>L.end()),z.on("error",()=>L.destroy()),L.pipe(z),z.pipe(L)}_connectTunnelSocket(B,x){return new Promise((z,j)=>{const L=P.createConnection({host:B,port:x},()=>{L.removeListener("error",j),L.pause(),z(L)});L.once("error",j)})}_updateWithFreeDebugPort(B){return typeof B.port=="number"?(0,u.findFreePort)(B.port,10,5e3).then(x=>(B.port=x,B)):(B.debugId=void 0,B.port=void 0,B.break=void 0,Promise.resolve(B))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},re))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};ce=Ae([_e(4,D.IServerEnvironmentService),_e(5,n.IProductService),_e(6,r.ILogService),_e(7,i.IInstantiationService)],ce),e.RemoteExtensionHostAgentServer=ce;async function ae(J,B,x){const z=await(0,c.determineServerConnectionToken)(B);z instanceof c.ServerConnectionTokenParseError&&(console.warn(z.message),process.exit(1));const j=new R.DisposableStore,{socketServer:L,instantiationService:F}=await(0,O.setupServerServices)(z,B,x,j);F.invokeFunction(Z=>{const ie=Z.get(r.ILogService);(0,C.setUnexpectedErrorHandler)(ue=>{ue&&ue.code==="EPIPE"&&ue.syscall==="write"&&ue.stack&&/unexpectedErrorHandler/.test(ue.stack)||ie.error(ue)}),process.on("SIGPIPE",()=>{(0,C.onUnexpectedError)(new Error("Unexpected SIGPIPE"))})}),F.invokeFunction(Z=>{const ie=Z.get(r.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const ue=(0,w.join)(process.env.HOMEDRIVE,"node_modules"),ve=(0,w.dirname)((0,w.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),$=(0,w.join)(ve,"node_modules");if(t.existsSync(ue)||t.existsSync($)){const Q=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${ue}
* ${$}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;ie.warn(Q),console.warn(Q),process.exit(0)}}});const G=F.invokeFunction(Z=>{const ie=Z.get(r.ILogService);if(t.existsSync((0,w.join)(S.FileAccess.asFileUri("",se).fsPath,"../node_modules/vsda")))try{return se.__$__nodeRequire("vsda")}catch(ve){ie.error(ve)}return null}),oe=t.existsSync(S.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",se).fsPath);if(oe&&J&&typeof J!="string"){const Z=z.type!==0?`?${S.connectionTokenQueryName}=${z.value}`:"";console.log(`Web UI available at http://localhost${J.port===80?"":`:${J.port}`}/${Z}`)}const fe=F.createInstance(ce,L,z,G,oe);d.mark("code/server/ready");const ee=I.performance.now(),te=global.vscodeServerStartTime,_=global.vscodeServerListenTime,U=global.vscodeServerCodeLoadedTime;if(F.invokeFunction(Z=>{Z.get(a.ITelemetryService).publicLog2("serverStart",{startTime:te,startedTime:_,codeLoadedTime:U,readyTime:ee})}),B["print-startup-performance"]){const Z=b.LoaderStats.get();let ie="";ie+=`

### Load AMD-module
`,ie+=b.LoaderStats.toMarkdownTable(["Module","Duration"],Z.amdLoad),ie+=`

### Load commonjs-module
`,ie+=b.LoaderStats.toMarkdownTable(["Module","Duration"],Z.nodeRequire),ie+=`

### Invoke AMD-module factory
`,ie+=b.LoaderStats.toMarkdownTable(["Module","Duration"],Z.amdInvoke),ie+=`

### Invoke commonjs-module
`,ie+=b.LoaderStats.toMarkdownTable(["Module","Duration"],Z.nodeEval),ie+=`Start-up time: ${_-te}
`,ie+=`Code loading time: ${U-te}
`,ie+=`Initialized time: ${ee-te}
`,ie+=`
`,console.log(ie)}return fe}e.createServer=ae;class N{static create(B){const x=B.webEndpointUrlTemplate,z=B.commit,j=B.quality;if(!x||!z||!j)return new N(null);const L=(0,v.generateUuid)(),G=new URL(x.replace("{{uuid}}",L).replace("{{commit}}",z).replace("{{quality}}",j)).origin,oe=(0,p.escapeRegExpCharacters)(G).replace(L,"[a-zA-Z0-9\\-]+");try{const fe=(0,p.createRegExp)(`^${oe}$`,!0,{matchCase:!1});return new N(fe)}catch{return new N(null)}}constructor(B){this._originRegExp=B}matches(B){return this._originRegExp?this._originRegExp.test(B):!1}}}),define(we[279],ye([1,0,29,28,11,266,268,59,6,269,43,50,45]),function(se,e,y,t,P,I,k,b,E,C,T,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,S.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=C.performance.now();const w={onMultipleValues:(s,a)=>{console.error(`Option '${s}' can only be defined once. Using value ${a}.`)},onEmptyValue:s=>{console.error(`Ignoring option '${s}': Value must not be empty.`)},onUnknownOption:s=>{console.error(`Ignoring option '${s}': not supported for server.`)},onDeprecatedOption:(s,a)=>{console.warn(`Option '${s}' is deprecated: ${a}`)}},d=(0,b.parseArgs)(process.argv.slice(2),T.serverOptions,w),g=d["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,E.join)(y.homedir(),R.default.serverDataFolderName||".vscode-remote"),p=(0,E.join)(g,"data"),m=(0,E.join)(p,"User"),v=(0,E.join)(m,"globalStorage"),u=(0,E.join)(m,"History"),l=(0,E.join)(p,"Machine");d["user-data-dir"]=p;const h=(0,E.dirname)(P.FileAccess.asFileUri("",se).fsPath),i=(0,E.join)(h,"extensions");d["builtin-extensions-dir"]=i,d["extensions-dir"]=d["extensions-dir"]||(0,E.join)(g,"extensions"),[g,d["extensions-dir"],p,m,l,v,u].forEach(s=>{try{t.existsSync(s)||t.mkdirSync(s,{mode:448})}catch(a){console.error(a)}});function r(){(0,I.run)(d,g,T.serverOptions)}e.spawnCli=r;function n(s){return(0,k.createServer)(s,d,g)}e.createServer=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6261075646f055b99068d3688932416f2346dd3b/core/vs/server/node/server.main.js.map
